Package: paws.end.user.computing
Title: 'Amazon Web Services' End User Computing Services
Version: 0.10.0
Authors@R: c(
    person("David", "Kretch", , "david.kretch@gmail.com", role = "aut"),
    person("Adam", "Banker", , "adam.banker39@gmail.com", role = "aut"),
    person("Dyfan", "Jones", , "dyfan.r.jones@gmail.com", role = "cre"),
    person("Amazon.com, Inc.", role = "cph")
  )
Description: Interface to 'Amazon Web Services' end user computing
    services, including collaborative document editing, mobile intranet,
    and more <https://aws.amazon.com/>.
License: Apache License (>= 2.0)
URL: https://github.com/paws-r/paws,
        https://paws-r.r-universe.dev/paws.end.user.computing,
        https://www.paws-r-sdk.com
BugReports: https://github.com/paws-r/paws/issues
Imports: paws.common (>= 0.8.0)
Suggests: testthat
Encoding: UTF-8
Config/roxygen2/version: 8.0.0
Collate: 'appstream_service.R' 'appstream_interfaces.R'
        'appstream_operations.R' 'chatbot_service.R'
        'chatbot_interfaces.R' 'chatbot_operations.R'
        'ivschat_service.R' 'ivschat_interfaces.R'
        'ivschat_operations.R' 'reexports_paws.common.R'
        'workdocs_service.R' 'workdocs_interfaces.R'
        'workdocs_operations.R' 'workmail_service.R'
        'workmail_interfaces.R' 'workmail_operations.R'
        'workmailmessageflow_service.R'
        'workmailmessageflow_interfaces.R'
        'workmailmessageflow_operations.R' 'workspaces_service.R'
        'workspaces_interfaces.R' 'workspaces_operations.R'
        'workspacesweb_service.R' 'workspacesweb_interfaces.R'
        'workspacesweb_operations.R'
NeedsCompilation: no
Packaged: 2026-05-29 17:22:04 UTC; dyfan
Author: David Kretch [aut],
  Adam Banker [aut],
  Dyfan Jones [cre],
  Amazon.com, Inc. [cph]
Maintainer: Dyfan Jones <dyfan.r.jones@gmail.com>
Repository: CRAN
Date/Publication: 2026-05-30 05:11:09 UTC
Built: R 4.6.0; ; 2026-05-30 05:41:42 UTC; unix

# This file is generated by make.paws. Please do not edit here.
#' @importFrom paws.common new_handlers new_service set_config merge_config
NULL

#' Amazon Interactive Video Service Chat
#'
#' @description
#' **Introduction**
#' 
#' The Amazon IVS Chat control-plane API enables you to create and manage Amazon IVS Chat resources. You also need to integrate with the [Amazon IVS Chat Messaging API](https://docs.aws.amazon.com/ivs/latest/chatmsgapireference/), to enable users to interact with chat rooms in real time.
#' 
#' The API is an AWS regional service. For a list of supported regions and Amazon IVS Chat HTTPS service endpoints, see the Amazon IVS Chat information on the [Amazon IVS page](https://docs.aws.amazon.com/general/latest/gr/ivs.html) in the *AWS General Reference*.
#' 
#' This document describes HTTP operations. There is a separate *messaging* API for managing Chat resources; see the [Amazon IVS Chat Messaging API Reference](https://docs.aws.amazon.com/ivs/latest/chatmsgapireference/).
#' 
#' **Notes on terminology:**
#' 
#' -   You create service applications using the Amazon IVS Chat API. We refer to these as *applications*.
#' 
#' -   You create front-end client applications (browser and Android/iOS apps) using the Amazon IVS Chat Messaging API. We refer to these as *clients*.
#' 
#' **Resources**
#' 
#' The following resources are part of Amazon IVS Chat:
#' 
#' -   **LoggingConfiguration** — A configuration that allows customers to store and record sent messages in a chat room. See the Logging Configuration endpoints for more information.
#' 
#' -   **Room** — The central Amazon IVS Chat resource through which clients connect to and exchange chat messages. See the Room endpoints for more information.
#' 
#' **Tagging**
#' 
#' A *tag* is a metadata label that you assign to an AWS resource. A tag comprises a *key* and a *value*, both set by you. For example, you might set a tag as `topic:nature` to label a particular video category. See [Best practices and strategies](https://docs.aws.amazon.com/tag-editor/latest/userguide/best-practices-and-strats.html) in *Tagging Amazon Web Services Resources and Tag Editor* for details, including restrictions that apply to tags and "Tag naming limits and requirements"; Amazon IVS Chat has no service-specific constraints beyond what is documented there.
#' 
#' Tags can help you identify and organize your AWS resources. For example, you can use the same tag for different resources to indicate that they are related. You can also use tags to manage access (see [Access Tags](https://docs.aws.amazon.com/IAM/latest/UserGuide/access_tags.html)).
#' 
#' The Amazon IVS Chat API has these tag-related operations: [`tag_resource`][ivschat_tag_resource], [`untag_resource`][ivschat_untag_resource], and [`list_tags_for_resource`][ivschat_list_tags_for_resource]. The following resource supports tagging: Room.
#' 
#' At most 50 tags can be applied to a resource.
#' 
#' **API Access Security**
#' 
#' Your Amazon IVS Chat applications (service applications and clients) must be authenticated and authorized to access Amazon IVS Chat resources. Note the differences between these concepts:
#' 
#' -   *Authentication* is about verifying identity. Requests to the Amazon IVS Chat API must be signed to verify your identity.
#' 
#' -   *Authorization* is about granting permissions. Your IAM roles need to have permissions for Amazon IVS Chat API requests.
#' 
#' Users (viewers) connect to a room using secure access tokens that you create using the [`create_chat_token`][ivschat_create_chat_token] operation through the AWS SDK. You call CreateChatToken for every user’s chat session, passing identity and authorization information about the user.
#' 
#' **Signing API Requests**
#' 
#' HTTP API requests must be signed with an AWS SigV4 signature using your AWS security credentials. The AWS Command Line Interface (CLI) and the AWS SDKs take care of signing the underlying API calls for you. However, if your application calls the Amazon IVS Chat HTTP API directly, it’s your responsibility to sign the requests.
#' 
#' You generate a signature using valid AWS credentials for an IAM role that has permission to perform the requested action. For example, DeleteMessage requests must be made using an IAM role that has the `ivschat:DeleteMessage` permission.
#' 
#' For more information:
#' 
#' -   Authentication and generating signatures — See [Authenticating Requests (Amazon Web Services Signature Version 4)](https://docs.aws.amazon.com/AmazonS3/latest/API/sig-v4-authenticating-requests.html) in the *Amazon Web Services General Reference*.
#' 
#' -   Managing Amazon IVS permissions — See [Identity and Access Management](https://docs.aws.amazon.com/ivs/latest/LowLatencyUserGuide/security-iam.html) on the Security page of the *Amazon IVS User Guide*.
#' 
#' **Amazon Resource Names (ARNs)**
#' 
#' ARNs uniquely identify AWS resources. An ARN is required when you need to specify a resource unambiguously across all of AWS, such as in IAM policies and API calls. For more information, see [Amazon Resource Names](https://docs.aws.amazon.com/IAM/latest/UserGuide/reference-arns.html) in the *AWS General Reference*.
#'
#' @param
#' config
#' Optional configuration of credentials, endpoint, and/or region.
#' \itemize{
#' \item{\strong{credentials}: \itemize{
#' \item{\strong{creds}: \itemize{
#' \item{\strong{access_key_id}: AWS access key ID}
#' \item{\strong{secret_access_key}: AWS secret access key}
#' \item{\strong{session_token}: AWS temporary session token}
#' }}
#' \item{\strong{profile}: The name of a profile to use. If not given, then the default profile is used.}
#' \item{\strong{anonymous}: Set anonymous credentials.}
#' }}
#' \item{\strong{endpoint}: The complete URL to use for the constructed client.}
#' \item{\strong{region}: The AWS Region used in instantiating the client.}
#' \item{\strong{close_connection}: Immediately close all HTTP connections.}
#' \item{\strong{timeout}: The time in seconds till a timeout exception is thrown when attempting to make a connection. The default is 60 seconds.}
#' \item{\strong{s3_force_path_style}: Set this to `true` to force the request to use path-style addressing, i.e. `http://s3.amazonaws.com/BUCKET/KEY`.}
#' \item{\strong{sts_regional_endpoint}: Set sts regional endpoint resolver to regional or legacy \url{https://docs.aws.amazon.com/sdkref/latest/guide/feature-sts-regionalized-endpoints.html}}
#' }
#' @param
#' credentials
#' Optional credentials shorthand for the config parameter
#' \itemize{
#' \item{\strong{creds}: \itemize{
#' \item{\strong{access_key_id}: AWS access key ID}
#' \item{\strong{secret_access_key}: AWS secret access key}
#' \item{\strong{session_token}: AWS temporary session token}
#' }}
#' \item{\strong{profile}: The name of a profile to use. If not given, then the default profile is used.}
#' \item{\strong{anonymous}: Set anonymous credentials.}
#' }
#' @param
#' endpoint
#' Optional shorthand for complete URL to use for the constructed client.
#' @param
#' region
#' Optional shorthand for AWS Region used in instantiating the client.
#'
#' @section Service syntax:
#' ```
#' svc <- ivschat(
#'   config = list(
#'     credentials = list(
#'       creds = list(
#'         access_key_id = "string",
#'         secret_access_key = "string",
#'         session_token = "string"
#'       ),
#'       profile = "string",
#'       anonymous = "logical"
#'     ),
#'     endpoint = "string",
#'     region = "string",
#'     close_connection = "logical",
#'     timeout = "numeric",
#'     s3_force_path_style = "logical",
#'     sts_regional_endpoint = "string"
#'   ),
#'   credentials = list(
#'     creds = list(
#'       access_key_id = "string",
#'       secret_access_key = "string",
#'       session_token = "string"
#'     ),
#'     profile = "string",
#'     anonymous = "logical"
#'   ),
#'   endpoint = "string",
#'   region = "string"
#' )
#' ```
#'
#' @examples
#' \dontrun{
#' svc <- ivschat()
#' svc$create_chat_token(
#'   Foo = 123
#' )
#' }
#'
#' @section Operations:
#' \tabular{ll}{
#'  \link[=ivschat_create_chat_token]{create_chat_token} \tab Creates an encrypted token that is used by a chat participant to establish an individual WebSocket chat connection to a room\cr
#'  \link[=ivschat_create_logging_configuration]{create_logging_configuration} \tab Creates a logging configuration that allows clients to store and record sent messages\cr
#'  \link[=ivschat_create_room]{create_room} \tab Creates a room that allows clients to connect and pass messages\cr
#'  \link[=ivschat_delete_logging_configuration]{delete_logging_configuration} \tab Deletes the specified logging configuration\cr
#'  \link[=ivschat_delete_message]{delete_message} \tab Sends an event to a specific room which directs clients to delete a specific message; that is, unrender it from view and delete it from the client’s chat history\cr
#'  \link[=ivschat_delete_room]{delete_room} \tab Deletes the specified room\cr
#'  \link[=ivschat_disconnect_user]{disconnect_user} \tab Disconnects all connections using a specified user ID from a room\cr
#'  \link[=ivschat_get_logging_configuration]{get_logging_configuration} \tab Gets the specified logging configuration\cr
#'  \link[=ivschat_get_room]{get_room} \tab Gets the specified room\cr
#'  \link[=ivschat_list_logging_configurations]{list_logging_configurations} \tab Gets summary information about all your logging configurations in the AWS region where the API request is processed\cr
#'  \link[=ivschat_list_rooms]{list_rooms} \tab Gets summary information about all your rooms in the AWS region where the API request is processed\cr
#'  \link[=ivschat_list_tags_for_resource]{list_tags_for_resource} \tab Gets information about AWS tags for the specified ARN\cr
#'  \link[=ivschat_send_event]{send_event} \tab Sends an event to a room\cr
#'  \link[=ivschat_tag_resource]{tag_resource} \tab Adds or updates tags for the AWS resource with the specified ARN\cr
#'  \link[=ivschat_untag_resource]{untag_resource} \tab Removes tags from the resource with the specified ARN\cr
#'  \link[=ivschat_update_logging_configuration]{update_logging_configuration} \tab Updates a specified logging configuration\cr
#'  \link[=ivschat_update_room]{update_room} \tab Updates a room’s configuration
#' }
#'
#' @return
#' A client for the service. You can call the service's operations using
#' syntax like `svc$operation(...)`, where `svc` is the name you've assigned
#' to the client. The available operations are listed in the
#' Operations section.
#'
#' @rdname ivschat
#' @export
ivschat <- function(config = list(), credentials = list(), endpoint = NULL, region = NULL) {
  config <- merge_config(
    config,
    list(
      credentials = credentials,
      endpoint = endpoint,
      region = region
    )
  )
  svc <- .ivschat$operations
  svc <- set_config(svc, config)
  return(svc)
}

# Private API objects: metadata, handlers, interfaces, etc.
.ivschat <- list()

.ivschat$operations <- list()

.ivschat$metadata <- list(
  service_name = "ivschat",
  endpoints = list("^(us|eu|ap|sa|ca|me|af|il|mx)\\-\\w+\\-\\d+$" = list(endpoint = "ivschat.{region}.amazonaws.com", global = FALSE), "^cn\\-\\w+\\-\\d+$" = list(endpoint = "ivschat.{region}.amazonaws.com.cn", global = FALSE), "^us\\-gov\\-\\w+\\-\\d+$" = list(endpoint = "ivschat.{region}.amazonaws.com", global = FALSE), "^us\\-iso\\-\\w+\\-\\d+$" = list(endpoint = "ivschat.{region}.c2s.ic.gov", global = FALSE), "^us\\-isob\\-\\w+\\-\\d+$" = list(endpoint = "ivschat.{region}.sc2s.sgov.gov", global = FALSE), "^eu\\-isoe\\-\\w+\\-\\d+$" = list(endpoint = "ivschat.{region}.cloud.adc-e.uk", global = FALSE), "^us\\-isof\\-\\w+\\-\\d+$" = list(endpoint = "ivschat.{region}.csp.hci.ic.gov", global = FALSE), "^eusc\\-(de)\\-\\w+\\-\\d+$" = list(endpoint = "ivschat.{region}.amazonaws.eu", global = FALSE)),
  service_id = "ivschat",
  api_version = "2020-07-14",
  signing_name = "ivschat",
  json_version = "",
  target_prefix = ""
)

.ivschat$service <- function(config = list(), op = NULL) {
  handlers <- new_handlers("restjson", "v4")
  new_service(.ivschat$metadata, handlers, config, op)
}

# This file is generated by make.paws. Please do not edit here.
#' @importFrom paws.common populate
#' @include workmail_service.R
NULL

.workmail$associate_delegate_to_resource_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string")), ResourceId = structure(logical(0), tags = list(type = "string")), EntityId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$associate_delegate_to_resource_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$associate_member_to_group_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string")), GroupId = structure(logical(0), tags = list(type = "string")), MemberId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$associate_member_to_group_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$assume_impersonation_role_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string")), ImpersonationRoleId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$assume_impersonation_role_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Token = structure(logical(0), tags = list(type = "string")), ExpiresIn = structure(logical(0), tags = list(type = "long", box = TRUE))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$cancel_mailbox_export_job_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ClientToken = structure(logical(0), tags = list(idempotencyToken = TRUE, type = "string")), JobId = structure(logical(0), tags = list(type = "string")), OrganizationId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$cancel_mailbox_export_job_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$create_alias_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string")), EntityId = structure(logical(0), tags = list(type = "string")), Alias = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$create_alias_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$create_availability_configuration_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ClientToken = structure(logical(0), tags = list(idempotencyToken = TRUE, type = "string")), OrganizationId = structure(logical(0), tags = list(type = "string")), DomainName = structure(logical(0), tags = list(type = "string")), EwsProvider = structure(list(EwsEndpoint = structure(logical(0), tags = list(type = "string")), EwsUsername = structure(logical(0), tags = list(type = "string")), EwsPassword = structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "structure")), LambdaProvider = structure(list(LambdaArn = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$create_availability_configuration_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$create_group_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string")), Name = structure(logical(0), tags = list(type = "string")), HiddenFromGlobalAddressList = structure(logical(0), tags = list(type = "boolean"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$create_group_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(GroupId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$create_identity_center_application_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Name = structure(logical(0), tags = list(type = "string")), InstanceArn = structure(logical(0), tags = list(type = "string")), ClientToken = structure(logical(0), tags = list(idempotencyToken = TRUE, type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$create_identity_center_application_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ApplicationArn = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$create_impersonation_role_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ClientToken = structure(logical(0), tags = list(idempotencyToken = TRUE, type = "string")), OrganizationId = structure(logical(0), tags = list(type = "string")), Name = structure(logical(0), tags = list(type = "string")), Type = structure(logical(0), tags = list(type = "string")), Description = structure(logical(0), tags = list(type = "string")), Rules = structure(list(structure(list(ImpersonationRuleId = structure(logical(0), tags = list(type = "string")), Name = structure(logical(0), tags = list(type = "string")), Description = structure(logical(0), tags = list(type = "string")), Effect = structure(logical(0), tags = list(type = "string")), TargetUsers = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), NotTargetUsers = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$create_impersonation_role_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ImpersonationRoleId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$create_mobile_device_access_rule_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string")), ClientToken = structure(logical(0), tags = list(idempotencyToken = TRUE, type = "string")), Name = structure(logical(0), tags = list(type = "string")), Description = structure(logical(0), tags = list(type = "string")), Effect = structure(logical(0), tags = list(type = "string")), DeviceTypes = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), NotDeviceTypes = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), DeviceModels = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), NotDeviceModels = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), DeviceOperatingSystems = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), NotDeviceOperatingSystems = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), DeviceUserAgents = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), NotDeviceUserAgents = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$create_mobile_device_access_rule_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(MobileDeviceAccessRuleId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$create_organization_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(DirectoryId = structure(logical(0), tags = list(type = "string")), Alias = structure(logical(0), tags = list(type = "string")), ClientToken = structure(logical(0), tags = list(idempotencyToken = TRUE, type = "string")), Domains = structure(list(structure(list(DomainName = structure(logical(0), tags = list(type = "string")), HostedZoneId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), KmsKeyArn = structure(logical(0), tags = list(type = "string")), EnableInteroperability = structure(logical(0), tags = list(type = "boolean"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$create_organization_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$create_resource_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string")), Name = structure(logical(0), tags = list(type = "string")), Type = structure(logical(0), tags = list(type = "string")), Description = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), HiddenFromGlobalAddressList = structure(logical(0), tags = list(type = "boolean"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$create_resource_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ResourceId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$create_user_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string")), Name = structure(logical(0), tags = list(type = "string")), DisplayName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), Password = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), Role = structure(logical(0), tags = list(type = "string")), FirstName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), LastName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), HiddenFromGlobalAddressList = structure(logical(0), tags = list(type = "boolean")), IdentityProviderUserId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$create_user_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(UserId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$delete_access_control_rule_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string")), Name = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$delete_access_control_rule_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$delete_alias_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string")), EntityId = structure(logical(0), tags = list(type = "string")), Alias = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$delete_alias_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$delete_availability_configuration_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string")), DomainName = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$delete_availability_configuration_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$delete_email_monitoring_configuration_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$delete_email_monitoring_configuration_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$delete_group_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string")), GroupId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$delete_group_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$delete_identity_center_application_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ApplicationArn = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$delete_identity_center_application_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$delete_identity_provider_configuration_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$delete_identity_provider_configuration_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$delete_impersonation_role_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string")), ImpersonationRoleId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$delete_impersonation_role_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$delete_mailbox_permissions_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string")), EntityId = structure(logical(0), tags = list(type = "string")), GranteeId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$delete_mailbox_permissions_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$delete_mobile_device_access_override_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string")), UserId = structure(logical(0), tags = list(type = "string")), DeviceId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$delete_mobile_device_access_override_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$delete_mobile_device_access_rule_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string")), MobileDeviceAccessRuleId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$delete_mobile_device_access_rule_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$delete_organization_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ClientToken = structure(logical(0), tags = list(idempotencyToken = TRUE, type = "string")), OrganizationId = structure(logical(0), tags = list(type = "string")), DeleteDirectory = structure(logical(0), tags = list(type = "boolean")), ForceDelete = structure(logical(0), tags = list(type = "boolean")), DeleteIdentityCenterApplication = structure(logical(0), tags = list(type = "boolean"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$delete_organization_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string")), State = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$delete_personal_access_token_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string")), PersonalAccessTokenId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$delete_personal_access_token_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$delete_resource_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string")), ResourceId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$delete_resource_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$delete_retention_policy_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string")), Id = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$delete_retention_policy_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$delete_user_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string")), UserId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$delete_user_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$deregister_from_work_mail_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string")), EntityId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$deregister_from_work_mail_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$deregister_mail_domain_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string")), DomainName = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$deregister_mail_domain_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$describe_email_monitoring_configuration_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$describe_email_monitoring_configuration_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(RoleArn = structure(logical(0), tags = list(type = "string")), LogGroupArn = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$describe_entity_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string")), Email = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$describe_entity_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(EntityId = structure(logical(0), tags = list(type = "string")), Name = structure(logical(0), tags = list(type = "string")), Type = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$describe_group_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string")), GroupId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$describe_group_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(GroupId = structure(logical(0), tags = list(type = "string")), Name = structure(logical(0), tags = list(type = "string")), Email = structure(logical(0), tags = list(type = "string")), State = structure(logical(0), tags = list(type = "string")), EnabledDate = structure(logical(0), tags = list(type = "timestamp")), DisabledDate = structure(logical(0), tags = list(type = "timestamp")), HiddenFromGlobalAddressList = structure(logical(0), tags = list(type = "boolean"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$describe_identity_provider_configuration_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$describe_identity_provider_configuration_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(AuthenticationMode = structure(logical(0), tags = list(type = "string")), IdentityCenterConfiguration = structure(list(InstanceArn = structure(logical(0), tags = list(type = "string")), ApplicationArn = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), PersonalAccessTokenConfiguration = structure(list(Status = structure(logical(0), tags = list(type = "string")), LifetimeInDays = structure(logical(0), tags = list(type = "integer", box = TRUE))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$describe_inbound_dmarc_settings_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$describe_inbound_dmarc_settings_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Enforced = structure(logical(0), tags = list(type = "boolean"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$describe_mailbox_export_job_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(JobId = structure(logical(0), tags = list(type = "string")), OrganizationId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$describe_mailbox_export_job_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(EntityId = structure(logical(0), tags = list(type = "string")), Description = structure(logical(0), tags = list(type = "string")), RoleArn = structure(logical(0), tags = list(type = "string")), KmsKeyArn = structure(logical(0), tags = list(type = "string")), S3BucketName = structure(logical(0), tags = list(type = "string")), S3Prefix = structure(logical(0), tags = list(type = "string")), S3Path = structure(logical(0), tags = list(type = "string")), EstimatedProgress = structure(logical(0), tags = list(type = "integer")), State = structure(logical(0), tags = list(type = "string")), ErrorInfo = structure(logical(0), tags = list(type = "string")), StartTime = structure(logical(0), tags = list(type = "timestamp")), EndTime = structure(logical(0), tags = list(type = "timestamp"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$describe_organization_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$describe_organization_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string")), Alias = structure(logical(0), tags = list(type = "string")), State = structure(logical(0), tags = list(type = "string")), DirectoryId = structure(logical(0), tags = list(type = "string")), DirectoryType = structure(logical(0), tags = list(type = "string")), DefaultMailDomain = structure(logical(0), tags = list(type = "string")), CompletedDate = structure(logical(0), tags = list(type = "timestamp")), ErrorMessage = structure(logical(0), tags = list(type = "string")), ARN = structure(logical(0), tags = list(type = "string")), MigrationAdmin = structure(logical(0), tags = list(type = "string")), InteroperabilityEnabled = structure(logical(0), tags = list(type = "boolean"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$describe_resource_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string")), ResourceId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$describe_resource_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ResourceId = structure(logical(0), tags = list(type = "string")), Email = structure(logical(0), tags = list(type = "string")), Name = structure(logical(0), tags = list(type = "string")), Type = structure(logical(0), tags = list(type = "string")), BookingOptions = structure(list(AutoAcceptRequests = structure(logical(0), tags = list(type = "boolean")), AutoDeclineRecurringRequests = structure(logical(0), tags = list(type = "boolean")), AutoDeclineConflictingRequests = structure(logical(0), tags = list(type = "boolean"))), tags = list(type = "structure")), State = structure(logical(0), tags = list(type = "string")), EnabledDate = structure(logical(0), tags = list(type = "timestamp")), DisabledDate = structure(logical(0), tags = list(type = "timestamp")), Description = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), HiddenFromGlobalAddressList = structure(logical(0), tags = list(type = "boolean"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$describe_user_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string")), UserId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$describe_user_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(UserId = structure(logical(0), tags = list(type = "string")), Name = structure(logical(0), tags = list(type = "string")), Email = structure(logical(0), tags = list(type = "string")), DisplayName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), State = structure(logical(0), tags = list(type = "string")), UserRole = structure(logical(0), tags = list(type = "string")), EnabledDate = structure(logical(0), tags = list(type = "timestamp")), DisabledDate = structure(logical(0), tags = list(type = "timestamp")), MailboxProvisionedDate = structure(logical(0), tags = list(type = "timestamp")), MailboxDeprovisionedDate = structure(logical(0), tags = list(type = "timestamp")), FirstName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), LastName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), HiddenFromGlobalAddressList = structure(logical(0), tags = list(type = "boolean")), Initials = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), Telephone = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), Street = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), JobTitle = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), City = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), Company = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), ZipCode = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), Department = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), Country = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), Office = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), IdentityProviderUserId = structure(logical(0), tags = list(type = "string")), IdentityProviderIdentityStoreId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$disassociate_delegate_from_resource_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string")), ResourceId = structure(logical(0), tags = list(type = "string")), EntityId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$disassociate_delegate_from_resource_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$disassociate_member_from_group_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string")), GroupId = structure(logical(0), tags = list(type = "string")), MemberId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$disassociate_member_from_group_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$get_access_control_effect_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string")), IpAddress = structure(logical(0), tags = list(type = "string")), Action = structure(logical(0), tags = list(type = "string")), UserId = structure(logical(0), tags = list(type = "string")), ImpersonationRoleId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$get_access_control_effect_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Effect = structure(logical(0), tags = list(type = "string")), MatchedRules = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$get_default_retention_policy_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$get_default_retention_policy_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Id = structure(logical(0), tags = list(type = "string")), Name = structure(logical(0), tags = list(type = "string")), Description = structure(logical(0), tags = list(type = "string")), FolderConfigurations = structure(list(structure(list(Name = structure(logical(0), tags = list(type = "string")), Action = structure(logical(0), tags = list(type = "string")), Period = structure(logical(0), tags = list(type = "integer", box = TRUE))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$get_impersonation_role_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string")), ImpersonationRoleId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$get_impersonation_role_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ImpersonationRoleId = structure(logical(0), tags = list(type = "string")), Name = structure(logical(0), tags = list(type = "string")), Type = structure(logical(0), tags = list(type = "string")), Description = structure(logical(0), tags = list(type = "string")), Rules = structure(list(structure(list(ImpersonationRuleId = structure(logical(0), tags = list(type = "string")), Name = structure(logical(0), tags = list(type = "string")), Description = structure(logical(0), tags = list(type = "string")), Effect = structure(logical(0), tags = list(type = "string")), TargetUsers = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), NotTargetUsers = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure"))), tags = list(type = "list")), DateCreated = structure(logical(0), tags = list(type = "timestamp")), DateModified = structure(logical(0), tags = list(type = "timestamp"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$get_impersonation_role_effect_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string")), ImpersonationRoleId = structure(logical(0), tags = list(type = "string")), TargetUser = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$get_impersonation_role_effect_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Type = structure(logical(0), tags = list(type = "string")), Effect = structure(logical(0), tags = list(type = "string")), MatchedRules = structure(list(structure(list(ImpersonationRuleId = structure(logical(0), tags = list(type = "string")), Name = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$get_mail_domain_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string")), DomainName = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$get_mail_domain_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Records = structure(list(structure(list(Type = structure(logical(0), tags = list(type = "string")), Hostname = structure(logical(0), tags = list(type = "string")), Value = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), IsTestDomain = structure(logical(0), tags = list(type = "boolean")), IsDefault = structure(logical(0), tags = list(type = "boolean")), OwnershipVerificationStatus = structure(logical(0), tags = list(type = "string")), DkimVerificationStatus = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$get_mailbox_details_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string")), UserId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$get_mailbox_details_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(MailboxQuota = structure(logical(0), tags = list(type = "integer", box = TRUE)), MailboxSize = structure(logical(0), tags = list(type = "double"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$get_mobile_device_access_effect_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string")), DeviceType = structure(logical(0), tags = list(type = "string")), DeviceModel = structure(logical(0), tags = list(type = "string")), DeviceOperatingSystem = structure(logical(0), tags = list(type = "string")), DeviceUserAgent = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$get_mobile_device_access_effect_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Effect = structure(logical(0), tags = list(type = "string")), MatchedRules = structure(list(structure(list(MobileDeviceAccessRuleId = structure(logical(0), tags = list(type = "string")), Name = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$get_mobile_device_access_override_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string")), UserId = structure(logical(0), tags = list(type = "string")), DeviceId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$get_mobile_device_access_override_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(UserId = structure(logical(0), tags = list(type = "string")), DeviceId = structure(logical(0), tags = list(type = "string")), Effect = structure(logical(0), tags = list(type = "string")), Description = structure(logical(0), tags = list(type = "string")), DateCreated = structure(logical(0), tags = list(type = "timestamp")), DateModified = structure(logical(0), tags = list(type = "timestamp"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$get_personal_access_token_metadata_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string")), PersonalAccessTokenId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$get_personal_access_token_metadata_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(PersonalAccessTokenId = structure(logical(0), tags = list(type = "string")), UserId = structure(logical(0), tags = list(type = "string")), Name = structure(logical(0), tags = list(type = "string")), DateCreated = structure(logical(0), tags = list(type = "timestamp")), DateLastUsed = structure(logical(0), tags = list(type = "timestamp")), ExpiresTime = structure(logical(0), tags = list(type = "timestamp")), Scopes = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$list_access_control_rules_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$list_access_control_rules_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Rules = structure(list(structure(list(Name = structure(logical(0), tags = list(type = "string")), Effect = structure(logical(0), tags = list(type = "string")), Description = structure(logical(0), tags = list(type = "string")), IpRanges = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), NotIpRanges = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), Actions = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), NotActions = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), UserIds = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), NotUserIds = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), DateCreated = structure(logical(0), tags = list(type = "timestamp")), DateModified = structure(logical(0), tags = list(type = "timestamp")), ImpersonationRoleIds = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), NotImpersonationRoleIds = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$list_aliases_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string")), EntityId = structure(logical(0), tags = list(type = "string")), NextToken = structure(logical(0), tags = list(type = "string")), MaxResults = structure(logical(0), tags = list(type = "integer", box = TRUE))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$list_aliases_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Aliases = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$list_availability_configurations_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string")), MaxResults = structure(logical(0), tags = list(type = "integer", box = TRUE)), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$list_availability_configurations_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(AvailabilityConfigurations = structure(list(structure(list(DomainName = structure(logical(0), tags = list(type = "string")), ProviderType = structure(logical(0), tags = list(type = "string")), EwsProvider = structure(list(EwsEndpoint = structure(logical(0), tags = list(type = "string")), EwsUsername = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), LambdaProvider = structure(list(LambdaArn = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), DateCreated = structure(logical(0), tags = list(type = "timestamp")), DateModified = structure(logical(0), tags = list(type = "timestamp"))), tags = list(type = "structure"))), tags = list(type = "list")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$list_group_members_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string")), GroupId = structure(logical(0), tags = list(type = "string")), NextToken = structure(logical(0), tags = list(type = "string")), MaxResults = structure(logical(0), tags = list(type = "integer", box = TRUE))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$list_group_members_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Members = structure(list(structure(list(Id = structure(logical(0), tags = list(type = "string")), Name = structure(logical(0), tags = list(type = "string")), Type = structure(logical(0), tags = list(type = "string")), State = structure(logical(0), tags = list(type = "string")), EnabledDate = structure(logical(0), tags = list(type = "timestamp")), DisabledDate = structure(logical(0), tags = list(type = "timestamp"))), tags = list(type = "structure"))), tags = list(type = "list")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$list_groups_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string")), NextToken = structure(logical(0), tags = list(type = "string")), MaxResults = structure(logical(0), tags = list(type = "integer", box = TRUE)), Filters = structure(list(NamePrefix = structure(logical(0), tags = list(type = "string")), PrimaryEmailPrefix = structure(logical(0), tags = list(type = "string")), State = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$list_groups_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Groups = structure(list(structure(list(Id = structure(logical(0), tags = list(type = "string")), Email = structure(logical(0), tags = list(type = "string")), Name = structure(logical(0), tags = list(type = "string")), State = structure(logical(0), tags = list(type = "string")), EnabledDate = structure(logical(0), tags = list(type = "timestamp")), DisabledDate = structure(logical(0), tags = list(type = "timestamp"))), tags = list(type = "structure"))), tags = list(type = "list")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$list_groups_for_entity_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string")), EntityId = structure(logical(0), tags = list(type = "string")), Filters = structure(list(GroupNamePrefix = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), NextToken = structure(logical(0), tags = list(type = "string")), MaxResults = structure(logical(0), tags = list(type = "integer", box = TRUE))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$list_groups_for_entity_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Groups = structure(list(structure(list(GroupId = structure(logical(0), tags = list(type = "string")), GroupName = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$list_impersonation_roles_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string")), NextToken = structure(logical(0), tags = list(type = "string")), MaxResults = structure(logical(0), tags = list(type = "integer", box = TRUE))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$list_impersonation_roles_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Roles = structure(list(structure(list(ImpersonationRoleId = structure(logical(0), tags = list(type = "string")), Name = structure(logical(0), tags = list(type = "string")), Type = structure(logical(0), tags = list(type = "string")), DateCreated = structure(logical(0), tags = list(type = "timestamp")), DateModified = structure(logical(0), tags = list(type = "timestamp"))), tags = list(type = "structure"))), tags = list(type = "list")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$list_mail_domains_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string")), MaxResults = structure(logical(0), tags = list(type = "integer", box = TRUE)), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$list_mail_domains_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(MailDomains = structure(list(structure(list(DomainName = structure(logical(0), tags = list(type = "string")), DefaultDomain = structure(logical(0), tags = list(type = "boolean"))), tags = list(type = "structure"))), tags = list(type = "list")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$list_mailbox_export_jobs_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string")), NextToken = structure(logical(0), tags = list(type = "string")), MaxResults = structure(logical(0), tags = list(type = "integer", box = TRUE))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$list_mailbox_export_jobs_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Jobs = structure(list(structure(list(JobId = structure(logical(0), tags = list(type = "string")), EntityId = structure(logical(0), tags = list(type = "string")), Description = structure(logical(0), tags = list(type = "string")), S3BucketName = structure(logical(0), tags = list(type = "string")), S3Path = structure(logical(0), tags = list(type = "string")), EstimatedProgress = structure(logical(0), tags = list(type = "integer")), State = structure(logical(0), tags = list(type = "string")), StartTime = structure(logical(0), tags = list(type = "timestamp")), EndTime = structure(logical(0), tags = list(type = "timestamp"))), tags = list(type = "structure"))), tags = list(type = "list")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$list_mailbox_permissions_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string")), EntityId = structure(logical(0), tags = list(type = "string")), NextToken = structure(logical(0), tags = list(type = "string")), MaxResults = structure(logical(0), tags = list(type = "integer", box = TRUE))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$list_mailbox_permissions_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Permissions = structure(list(structure(list(GranteeId = structure(logical(0), tags = list(type = "string")), GranteeType = structure(logical(0), tags = list(type = "string")), PermissionValues = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure"))), tags = list(type = "list")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$list_mobile_device_access_overrides_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string")), UserId = structure(logical(0), tags = list(type = "string")), DeviceId = structure(logical(0), tags = list(type = "string")), NextToken = structure(logical(0), tags = list(type = "string")), MaxResults = structure(logical(0), tags = list(type = "integer", box = TRUE))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$list_mobile_device_access_overrides_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Overrides = structure(list(structure(list(UserId = structure(logical(0), tags = list(type = "string")), DeviceId = structure(logical(0), tags = list(type = "string")), Effect = structure(logical(0), tags = list(type = "string")), Description = structure(logical(0), tags = list(type = "string")), DateCreated = structure(logical(0), tags = list(type = "timestamp")), DateModified = structure(logical(0), tags = list(type = "timestamp"))), tags = list(type = "structure"))), tags = list(type = "list")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$list_mobile_device_access_rules_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$list_mobile_device_access_rules_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Rules = structure(list(structure(list(MobileDeviceAccessRuleId = structure(logical(0), tags = list(type = "string")), Name = structure(logical(0), tags = list(type = "string")), Description = structure(logical(0), tags = list(type = "string")), Effect = structure(logical(0), tags = list(type = "string")), DeviceTypes = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), NotDeviceTypes = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), DeviceModels = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), NotDeviceModels = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), DeviceOperatingSystems = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), NotDeviceOperatingSystems = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), DeviceUserAgents = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), NotDeviceUserAgents = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), DateCreated = structure(logical(0), tags = list(type = "timestamp")), DateModified = structure(logical(0), tags = list(type = "timestamp"))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$list_organizations_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(NextToken = structure(logical(0), tags = list(type = "string")), MaxResults = structure(logical(0), tags = list(type = "integer", box = TRUE))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$list_organizations_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationSummaries = structure(list(structure(list(OrganizationId = structure(logical(0), tags = list(type = "string")), Alias = structure(logical(0), tags = list(type = "string")), DefaultMailDomain = structure(logical(0), tags = list(type = "string")), ErrorMessage = structure(logical(0), tags = list(type = "string")), State = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$list_personal_access_tokens_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string")), UserId = structure(logical(0), tags = list(type = "string")), NextToken = structure(logical(0), tags = list(type = "string")), MaxResults = structure(logical(0), tags = list(type = "integer", box = TRUE))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$list_personal_access_tokens_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(NextToken = structure(logical(0), tags = list(type = "string")), PersonalAccessTokenSummaries = structure(list(structure(list(PersonalAccessTokenId = structure(logical(0), tags = list(type = "string")), UserId = structure(logical(0), tags = list(type = "string")), Name = structure(logical(0), tags = list(type = "string")), DateCreated = structure(logical(0), tags = list(type = "timestamp")), DateLastUsed = structure(logical(0), tags = list(type = "timestamp")), ExpiresTime = structure(logical(0), tags = list(type = "timestamp")), Scopes = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$list_resource_delegates_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string")), ResourceId = structure(logical(0), tags = list(type = "string")), NextToken = structure(logical(0), tags = list(type = "string")), MaxResults = structure(logical(0), tags = list(type = "integer", box = TRUE))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$list_resource_delegates_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Delegates = structure(list(structure(list(Id = structure(logical(0), tags = list(type = "string")), Type = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$list_resources_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string")), NextToken = structure(logical(0), tags = list(type = "string")), MaxResults = structure(logical(0), tags = list(type = "integer", box = TRUE)), Filters = structure(list(NamePrefix = structure(logical(0), tags = list(type = "string")), PrimaryEmailPrefix = structure(logical(0), tags = list(type = "string")), State = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$list_resources_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Resources = structure(list(structure(list(Id = structure(logical(0), tags = list(type = "string")), Email = structure(logical(0), tags = list(type = "string")), Name = structure(logical(0), tags = list(type = "string")), Type = structure(logical(0), tags = list(type = "string")), State = structure(logical(0), tags = list(type = "string")), EnabledDate = structure(logical(0), tags = list(type = "timestamp")), DisabledDate = structure(logical(0), tags = list(type = "timestamp")), Description = structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "structure"))), tags = list(type = "list")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$list_tags_for_resource_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ResourceARN = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$list_tags_for_resource_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Tags = structure(list(structure(list(Key = structure(logical(0), tags = list(type = "string")), Value = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$list_users_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string")), NextToken = structure(logical(0), tags = list(type = "string")), MaxResults = structure(logical(0), tags = list(type = "integer", box = TRUE)), Filters = structure(list(UsernamePrefix = structure(logical(0), tags = list(type = "string")), DisplayNamePrefix = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), PrimaryEmailPrefix = structure(logical(0), tags = list(type = "string")), State = structure(logical(0), tags = list(type = "string")), IdentityProviderUserIdPrefix = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$list_users_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Users = structure(list(structure(list(Id = structure(logical(0), tags = list(type = "string")), Email = structure(logical(0), tags = list(type = "string")), Name = structure(logical(0), tags = list(type = "string")), DisplayName = structure(logical(0), tags = list(type = "string")), State = structure(logical(0), tags = list(type = "string")), UserRole = structure(logical(0), tags = list(type = "string")), EnabledDate = structure(logical(0), tags = list(type = "timestamp")), DisabledDate = structure(logical(0), tags = list(type = "timestamp")), IdentityProviderUserId = structure(logical(0), tags = list(type = "string")), IdentityProviderIdentityStoreId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$put_access_control_rule_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Name = structure(logical(0), tags = list(type = "string")), Effect = structure(logical(0), tags = list(type = "string")), Description = structure(logical(0), tags = list(type = "string")), IpRanges = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), NotIpRanges = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), Actions = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), NotActions = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), UserIds = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), NotUserIds = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), OrganizationId = structure(logical(0), tags = list(type = "string")), ImpersonationRoleIds = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), NotImpersonationRoleIds = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$put_access_control_rule_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$put_email_monitoring_configuration_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string")), RoleArn = structure(logical(0), tags = list(type = "string")), LogGroupArn = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$put_email_monitoring_configuration_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$put_identity_provider_configuration_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string")), AuthenticationMode = structure(logical(0), tags = list(type = "string")), IdentityCenterConfiguration = structure(list(InstanceArn = structure(logical(0), tags = list(type = "string")), ApplicationArn = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), PersonalAccessTokenConfiguration = structure(list(Status = structure(logical(0), tags = list(type = "string")), LifetimeInDays = structure(logical(0), tags = list(type = "integer", box = TRUE))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$put_identity_provider_configuration_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$put_inbound_dmarc_settings_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string")), Enforced = structure(logical(0), tags = list(type = "boolean"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$put_inbound_dmarc_settings_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$put_mailbox_permissions_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string")), EntityId = structure(logical(0), tags = list(type = "string")), GranteeId = structure(logical(0), tags = list(type = "string")), PermissionValues = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$put_mailbox_permissions_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$put_mobile_device_access_override_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string")), UserId = structure(logical(0), tags = list(type = "string")), DeviceId = structure(logical(0), tags = list(type = "string")), Effect = structure(logical(0), tags = list(type = "string")), Description = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$put_mobile_device_access_override_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$put_retention_policy_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string")), Id = structure(logical(0), tags = list(type = "string")), Name = structure(logical(0), tags = list(type = "string")), Description = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), FolderConfigurations = structure(list(structure(list(Name = structure(logical(0), tags = list(type = "string")), Action = structure(logical(0), tags = list(type = "string")), Period = structure(logical(0), tags = list(type = "integer", box = TRUE))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$put_retention_policy_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$register_mail_domain_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ClientToken = structure(logical(0), tags = list(idempotencyToken = TRUE, type = "string")), OrganizationId = structure(logical(0), tags = list(type = "string")), DomainName = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$register_mail_domain_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$register_to_work_mail_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string")), EntityId = structure(logical(0), tags = list(type = "string")), Email = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$register_to_work_mail_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$reset_password_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string")), UserId = structure(logical(0), tags = list(type = "string")), Password = structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$reset_password_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$start_mailbox_export_job_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ClientToken = structure(logical(0), tags = list(idempotencyToken = TRUE, type = "string")), OrganizationId = structure(logical(0), tags = list(type = "string")), EntityId = structure(logical(0), tags = list(type = "string")), Description = structure(logical(0), tags = list(type = "string")), RoleArn = structure(logical(0), tags = list(type = "string")), KmsKeyArn = structure(logical(0), tags = list(type = "string")), S3BucketName = structure(logical(0), tags = list(type = "string")), S3Prefix = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$start_mailbox_export_job_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(JobId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$tag_resource_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ResourceARN = structure(logical(0), tags = list(type = "string")), Tags = structure(list(structure(list(Key = structure(logical(0), tags = list(type = "string")), Value = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$tag_resource_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$test_availability_configuration_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string")), DomainName = structure(logical(0), tags = list(type = "string")), EwsProvider = structure(list(EwsEndpoint = structure(logical(0), tags = list(type = "string")), EwsUsername = structure(logical(0), tags = list(type = "string")), EwsPassword = structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "structure")), LambdaProvider = structure(list(LambdaArn = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$test_availability_configuration_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(TestPassed = structure(logical(0), tags = list(type = "boolean")), FailureReason = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$untag_resource_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ResourceARN = structure(logical(0), tags = list(type = "string")), TagKeys = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$untag_resource_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$update_availability_configuration_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string")), DomainName = structure(logical(0), tags = list(type = "string")), EwsProvider = structure(list(EwsEndpoint = structure(logical(0), tags = list(type = "string")), EwsUsername = structure(logical(0), tags = list(type = "string")), EwsPassword = structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "structure")), LambdaProvider = structure(list(LambdaArn = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$update_availability_configuration_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$update_default_mail_domain_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string")), DomainName = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$update_default_mail_domain_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$update_group_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string")), GroupId = structure(logical(0), tags = list(type = "string")), HiddenFromGlobalAddressList = structure(logical(0), tags = list(type = "boolean"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$update_group_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$update_impersonation_role_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string")), ImpersonationRoleId = structure(logical(0), tags = list(type = "string")), Name = structure(logical(0), tags = list(type = "string")), Type = structure(logical(0), tags = list(type = "string")), Description = structure(logical(0), tags = list(type = "string")), Rules = structure(list(structure(list(ImpersonationRuleId = structure(logical(0), tags = list(type = "string")), Name = structure(logical(0), tags = list(type = "string")), Description = structure(logical(0), tags = list(type = "string")), Effect = structure(logical(0), tags = list(type = "string")), TargetUsers = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), NotTargetUsers = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$update_impersonation_role_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$update_mailbox_quota_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string")), UserId = structure(logical(0), tags = list(type = "string")), MailboxQuota = structure(logical(0), tags = list(type = "integer", box = TRUE))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$update_mailbox_quota_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$update_mobile_device_access_rule_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string")), MobileDeviceAccessRuleId = structure(logical(0), tags = list(type = "string")), Name = structure(logical(0), tags = list(type = "string")), Description = structure(logical(0), tags = list(type = "string")), Effect = structure(logical(0), tags = list(type = "string")), DeviceTypes = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), NotDeviceTypes = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), DeviceModels = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), NotDeviceModels = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), DeviceOperatingSystems = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), NotDeviceOperatingSystems = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), DeviceUserAgents = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), NotDeviceUserAgents = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$update_mobile_device_access_rule_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$update_primary_email_address_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string")), EntityId = structure(logical(0), tags = list(type = "string")), Email = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$update_primary_email_address_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$update_resource_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string")), ResourceId = structure(logical(0), tags = list(type = "string")), Name = structure(logical(0), tags = list(type = "string")), BookingOptions = structure(list(AutoAcceptRequests = structure(logical(0), tags = list(type = "boolean")), AutoDeclineRecurringRequests = structure(logical(0), tags = list(type = "boolean")), AutoDeclineConflictingRequests = structure(logical(0), tags = list(type = "boolean"))), tags = list(type = "structure")), Description = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), Type = structure(logical(0), tags = list(type = "string")), HiddenFromGlobalAddressList = structure(logical(0), tags = list(type = "boolean"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$update_resource_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$update_user_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string")), UserId = structure(logical(0), tags = list(type = "string")), Role = structure(logical(0), tags = list(type = "string")), DisplayName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), FirstName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), LastName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), HiddenFromGlobalAddressList = structure(logical(0), tags = list(type = "boolean")), Initials = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), Telephone = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), Street = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), JobTitle = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), City = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), Company = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), ZipCode = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), Department = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), Country = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), Office = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), IdentityProviderUserId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmail$update_user_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

# This file is generated by make.paws. Please do not edit here.
#' @importFrom paws.common populate
#' @include chatbot_service.R
NULL

.chatbot$associate_to_configuration_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Resource = structure(logical(0), tags = list(type = "string")), ChatConfiguration = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.chatbot$associate_to_configuration_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.chatbot$create_chime_webhook_configuration_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(WebhookDescription = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), WebhookUrl = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), SnsTopicArns = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), IamRoleArn = structure(logical(0), tags = list(type = "string")), ConfigurationName = structure(logical(0), tags = list(type = "string")), LoggingLevel = structure(logical(0), tags = list(type = "string")), Tags = structure(list(structure(list(TagKey = structure(logical(0), tags = list(type = "string")), TagValue = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.chatbot$create_chime_webhook_configuration_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(WebhookConfiguration = structure(list(WebhookDescription = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), ChatConfigurationArn = structure(logical(0), tags = list(type = "string")), IamRoleArn = structure(logical(0), tags = list(type = "string")), SnsTopicArns = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), ConfigurationName = structure(logical(0), tags = list(type = "string")), LoggingLevel = structure(logical(0), tags = list(type = "string")), Tags = structure(list(structure(list(TagKey = structure(logical(0), tags = list(type = "string")), TagValue = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), State = structure(logical(0), tags = list(type = "string")), StateReason = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.chatbot$create_custom_action_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Definition = structure(list(CommandText = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), AliasName = structure(logical(0), tags = list(type = "string")), Attachments = structure(list(structure(list(NotificationType = structure(logical(0), tags = list(type = "string")), ButtonText = structure(logical(0), tags = list(type = "string")), Criteria = structure(list(structure(list(Operator = structure(logical(0), tags = list(type = "string")), VariableName = structure(logical(0), tags = list(type = "string")), Value = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), Variables = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map"))), tags = list(type = "structure"))), tags = list(type = "list")), Tags = structure(list(structure(list(TagKey = structure(logical(0), tags = list(type = "string")), TagValue = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), ClientToken = structure(logical(0), tags = list(idempotencyToken = TRUE, type = "string")), ActionName = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.chatbot$create_custom_action_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(CustomActionArn = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.chatbot$create_microsoft_teams_channel_configuration_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ChannelId = structure(logical(0), tags = list(type = "string")), ChannelName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), TeamId = structure(logical(0), tags = list(type = "string")), TeamName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), TenantId = structure(logical(0), tags = list(type = "string")), SnsTopicArns = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), IamRoleArn = structure(logical(0), tags = list(type = "string")), ConfigurationName = structure(logical(0), tags = list(type = "string")), LoggingLevel = structure(logical(0), tags = list(type = "string")), GuardrailPolicyArns = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), UserAuthorizationRequired = structure(logical(0), tags = list(type = "boolean", box = TRUE)), Tags = structure(list(structure(list(TagKey = structure(logical(0), tags = list(type = "string")), TagValue = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.chatbot$create_microsoft_teams_channel_configuration_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ChannelConfiguration = structure(list(ChannelId = structure(logical(0), tags = list(type = "string")), ChannelName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), TeamId = structure(logical(0), tags = list(type = "string")), TeamName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), TenantId = structure(logical(0), tags = list(type = "string")), ChatConfigurationArn = structure(logical(0), tags = list(type = "string")), IamRoleArn = structure(logical(0), tags = list(type = "string")), SnsTopicArns = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), ConfigurationName = structure(logical(0), tags = list(type = "string")), LoggingLevel = structure(logical(0), tags = list(type = "string")), GuardrailPolicyArns = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), UserAuthorizationRequired = structure(logical(0), tags = list(type = "boolean", box = TRUE)), Tags = structure(list(structure(list(TagKey = structure(logical(0), tags = list(type = "string")), TagValue = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), State = structure(logical(0), tags = list(type = "string")), StateReason = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.chatbot$create_slack_channel_configuration_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(SlackTeamId = structure(logical(0), tags = list(type = "string")), SlackChannelId = structure(logical(0), tags = list(type = "string")), SlackChannelName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), SnsTopicArns = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), IamRoleArn = structure(logical(0), tags = list(type = "string")), ConfigurationName = structure(logical(0), tags = list(type = "string")), LoggingLevel = structure(logical(0), tags = list(type = "string")), GuardrailPolicyArns = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), UserAuthorizationRequired = structure(logical(0), tags = list(type = "boolean", box = TRUE)), Tags = structure(list(structure(list(TagKey = structure(logical(0), tags = list(type = "string")), TagValue = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.chatbot$create_slack_channel_configuration_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ChannelConfiguration = structure(list(SlackTeamName = structure(logical(0), tags = list(type = "string")), SlackTeamId = structure(logical(0), tags = list(type = "string")), SlackChannelId = structure(logical(0), tags = list(type = "string")), SlackChannelName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), ChatConfigurationArn = structure(logical(0), tags = list(type = "string")), IamRoleArn = structure(logical(0), tags = list(type = "string")), SnsTopicArns = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), ConfigurationName = structure(logical(0), tags = list(type = "string")), LoggingLevel = structure(logical(0), tags = list(type = "string")), GuardrailPolicyArns = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), UserAuthorizationRequired = structure(logical(0), tags = list(type = "boolean", box = TRUE)), Tags = structure(list(structure(list(TagKey = structure(logical(0), tags = list(type = "string")), TagValue = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), State = structure(logical(0), tags = list(type = "string")), StateReason = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.chatbot$delete_chime_webhook_configuration_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ChatConfigurationArn = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.chatbot$delete_chime_webhook_configuration_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.chatbot$delete_custom_action_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(CustomActionArn = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.chatbot$delete_custom_action_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.chatbot$delete_microsoft_teams_channel_configuration_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ChatConfigurationArn = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.chatbot$delete_microsoft_teams_channel_configuration_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.chatbot$delete_microsoft_teams_configured_team_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(TeamId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.chatbot$delete_microsoft_teams_configured_team_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.chatbot$delete_microsoft_teams_user_identity_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ChatConfigurationArn = structure(logical(0), tags = list(type = "string")), UserId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.chatbot$delete_microsoft_teams_user_identity_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.chatbot$delete_slack_channel_configuration_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ChatConfigurationArn = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.chatbot$delete_slack_channel_configuration_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.chatbot$delete_slack_user_identity_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ChatConfigurationArn = structure(logical(0), tags = list(type = "string")), SlackTeamId = structure(logical(0), tags = list(type = "string")), SlackUserId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.chatbot$delete_slack_user_identity_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.chatbot$delete_slack_workspace_authorization_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(SlackTeamId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.chatbot$delete_slack_workspace_authorization_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.chatbot$describe_chime_webhook_configurations_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(MaxResults = structure(logical(0), tags = list(type = "integer", box = TRUE)), NextToken = structure(logical(0), tags = list(type = "string")), ChatConfigurationArn = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.chatbot$describe_chime_webhook_configurations_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(NextToken = structure(logical(0), tags = list(type = "string")), WebhookConfigurations = structure(list(structure(list(WebhookDescription = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), ChatConfigurationArn = structure(logical(0), tags = list(type = "string")), IamRoleArn = structure(logical(0), tags = list(type = "string")), SnsTopicArns = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), ConfigurationName = structure(logical(0), tags = list(type = "string")), LoggingLevel = structure(logical(0), tags = list(type = "string")), Tags = structure(list(structure(list(TagKey = structure(logical(0), tags = list(type = "string")), TagValue = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), State = structure(logical(0), tags = list(type = "string")), StateReason = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.chatbot$describe_slack_channel_configurations_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(MaxResults = structure(logical(0), tags = list(type = "integer", box = TRUE)), NextToken = structure(logical(0), tags = list(type = "string")), ChatConfigurationArn = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.chatbot$describe_slack_channel_configurations_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(NextToken = structure(logical(0), tags = list(type = "string")), SlackChannelConfigurations = structure(list(structure(list(SlackTeamName = structure(logical(0), tags = list(type = "string")), SlackTeamId = structure(logical(0), tags = list(type = "string")), SlackChannelId = structure(logical(0), tags = list(type = "string")), SlackChannelName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), ChatConfigurationArn = structure(logical(0), tags = list(type = "string")), IamRoleArn = structure(logical(0), tags = list(type = "string")), SnsTopicArns = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), ConfigurationName = structure(logical(0), tags = list(type = "string")), LoggingLevel = structure(logical(0), tags = list(type = "string")), GuardrailPolicyArns = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), UserAuthorizationRequired = structure(logical(0), tags = list(type = "boolean", box = TRUE)), Tags = structure(list(structure(list(TagKey = structure(logical(0), tags = list(type = "string")), TagValue = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), State = structure(logical(0), tags = list(type = "string")), StateReason = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.chatbot$describe_slack_user_identities_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ChatConfigurationArn = structure(logical(0), tags = list(type = "string")), NextToken = structure(logical(0), tags = list(type = "string")), MaxResults = structure(logical(0), tags = list(type = "integer", box = TRUE))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.chatbot$describe_slack_user_identities_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(SlackUserIdentities = structure(list(structure(list(IamRoleArn = structure(logical(0), tags = list(type = "string")), ChatConfigurationArn = structure(logical(0), tags = list(type = "string")), SlackTeamId = structure(logical(0), tags = list(type = "string")), SlackUserId = structure(logical(0), tags = list(type = "string")), AwsUserIdentity = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.chatbot$describe_slack_workspaces_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(MaxResults = structure(logical(0), tags = list(type = "integer", box = TRUE)), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.chatbot$describe_slack_workspaces_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(SlackWorkspaces = structure(list(structure(list(SlackTeamId = structure(logical(0), tags = list(type = "string")), SlackTeamName = structure(logical(0), tags = list(type = "string")), State = structure(logical(0), tags = list(type = "string")), StateReason = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.chatbot$disassociate_from_configuration_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Resource = structure(logical(0), tags = list(type = "string")), ChatConfiguration = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.chatbot$disassociate_from_configuration_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.chatbot$get_account_preferences_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.chatbot$get_account_preferences_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(AccountPreferences = structure(list(UserAuthorizationRequired = structure(logical(0), tags = list(type = "boolean", box = TRUE)), TrainingDataCollectionEnabled = structure(logical(0), tags = list(type = "boolean", box = TRUE))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.chatbot$get_custom_action_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(CustomActionArn = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.chatbot$get_custom_action_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(CustomAction = structure(list(CustomActionArn = structure(logical(0), tags = list(type = "string")), Definition = structure(list(CommandText = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), AliasName = structure(logical(0), tags = list(type = "string")), Attachments = structure(list(structure(list(NotificationType = structure(logical(0), tags = list(type = "string")), ButtonText = structure(logical(0), tags = list(type = "string")), Criteria = structure(list(structure(list(Operator = structure(logical(0), tags = list(type = "string")), VariableName = structure(logical(0), tags = list(type = "string")), Value = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), Variables = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map"))), tags = list(type = "structure"))), tags = list(type = "list")), ActionName = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.chatbot$get_microsoft_teams_channel_configuration_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ChatConfigurationArn = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.chatbot$get_microsoft_teams_channel_configuration_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ChannelConfiguration = structure(list(ChannelId = structure(logical(0), tags = list(type = "string")), ChannelName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), TeamId = structure(logical(0), tags = list(type = "string")), TeamName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), TenantId = structure(logical(0), tags = list(type = "string")), ChatConfigurationArn = structure(logical(0), tags = list(type = "string")), IamRoleArn = structure(logical(0), tags = list(type = "string")), SnsTopicArns = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), ConfigurationName = structure(logical(0), tags = list(type = "string")), LoggingLevel = structure(logical(0), tags = list(type = "string")), GuardrailPolicyArns = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), UserAuthorizationRequired = structure(logical(0), tags = list(type = "boolean", box = TRUE)), Tags = structure(list(structure(list(TagKey = structure(logical(0), tags = list(type = "string")), TagValue = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), State = structure(logical(0), tags = list(type = "string")), StateReason = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.chatbot$list_associations_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ChatConfiguration = structure(logical(0), tags = list(type = "string")), MaxResults = structure(logical(0), tags = list(type = "integer", box = TRUE)), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.chatbot$list_associations_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Associations = structure(list(structure(list(Resource = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.chatbot$list_custom_actions_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(MaxResults = structure(logical(0), tags = list(type = "integer", box = TRUE)), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.chatbot$list_custom_actions_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(CustomActions = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.chatbot$list_microsoft_teams_channel_configurations_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(MaxResults = structure(logical(0), tags = list(type = "integer", box = TRUE)), NextToken = structure(logical(0), tags = list(type = "string")), TeamId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.chatbot$list_microsoft_teams_channel_configurations_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(NextToken = structure(logical(0), tags = list(type = "string")), TeamChannelConfigurations = structure(list(structure(list(ChannelId = structure(logical(0), tags = list(type = "string")), ChannelName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), TeamId = structure(logical(0), tags = list(type = "string")), TeamName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), TenantId = structure(logical(0), tags = list(type = "string")), ChatConfigurationArn = structure(logical(0), tags = list(type = "string")), IamRoleArn = structure(logical(0), tags = list(type = "string")), SnsTopicArns = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), ConfigurationName = structure(logical(0), tags = list(type = "string")), LoggingLevel = structure(logical(0), tags = list(type = "string")), GuardrailPolicyArns = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), UserAuthorizationRequired = structure(logical(0), tags = list(type = "boolean", box = TRUE)), Tags = structure(list(structure(list(TagKey = structure(logical(0), tags = list(type = "string")), TagValue = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), State = structure(logical(0), tags = list(type = "string")), StateReason = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.chatbot$list_microsoft_teams_configured_teams_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(MaxResults = structure(logical(0), tags = list(type = "integer", box = TRUE)), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.chatbot$list_microsoft_teams_configured_teams_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ConfiguredTeams = structure(list(structure(list(TenantId = structure(logical(0), tags = list(type = "string")), TeamId = structure(logical(0), tags = list(type = "string")), TeamName = structure(logical(0), tags = list(type = "string")), State = structure(logical(0), tags = list(type = "string")), StateReason = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.chatbot$list_microsoft_teams_user_identities_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ChatConfigurationArn = structure(logical(0), tags = list(type = "string")), NextToken = structure(logical(0), tags = list(type = "string")), MaxResults = structure(logical(0), tags = list(type = "integer", box = TRUE))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.chatbot$list_microsoft_teams_user_identities_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(TeamsUserIdentities = structure(list(structure(list(IamRoleArn = structure(logical(0), tags = list(type = "string")), ChatConfigurationArn = structure(logical(0), tags = list(type = "string")), TeamId = structure(logical(0), tags = list(type = "string")), UserId = structure(logical(0), tags = list(type = "string")), AwsUserIdentity = structure(logical(0), tags = list(type = "string")), TeamsChannelId = structure(logical(0), tags = list(type = "string")), TeamsTenantId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.chatbot$list_tags_for_resource_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ResourceARN = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.chatbot$list_tags_for_resource_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Tags = structure(list(structure(list(TagKey = structure(logical(0), tags = list(type = "string")), TagValue = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.chatbot$tag_resource_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ResourceARN = structure(logical(0), tags = list(type = "string")), Tags = structure(list(structure(list(TagKey = structure(logical(0), tags = list(type = "string")), TagValue = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.chatbot$tag_resource_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.chatbot$untag_resource_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ResourceARN = structure(logical(0), tags = list(type = "string")), TagKeys = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.chatbot$untag_resource_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.chatbot$update_account_preferences_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(UserAuthorizationRequired = structure(logical(0), tags = list(type = "boolean", box = TRUE)), TrainingDataCollectionEnabled = structure(logical(0), tags = list(type = "boolean", box = TRUE))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.chatbot$update_account_preferences_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(AccountPreferences = structure(list(UserAuthorizationRequired = structure(logical(0), tags = list(type = "boolean", box = TRUE)), TrainingDataCollectionEnabled = structure(logical(0), tags = list(type = "boolean", box = TRUE))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.chatbot$update_chime_webhook_configuration_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ChatConfigurationArn = structure(logical(0), tags = list(type = "string")), WebhookDescription = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), WebhookUrl = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), SnsTopicArns = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), IamRoleArn = structure(logical(0), tags = list(type = "string")), LoggingLevel = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.chatbot$update_chime_webhook_configuration_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(WebhookConfiguration = structure(list(WebhookDescription = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), ChatConfigurationArn = structure(logical(0), tags = list(type = "string")), IamRoleArn = structure(logical(0), tags = list(type = "string")), SnsTopicArns = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), ConfigurationName = structure(logical(0), tags = list(type = "string")), LoggingLevel = structure(logical(0), tags = list(type = "string")), Tags = structure(list(structure(list(TagKey = structure(logical(0), tags = list(type = "string")), TagValue = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), State = structure(logical(0), tags = list(type = "string")), StateReason = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.chatbot$update_custom_action_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(CustomActionArn = structure(logical(0), tags = list(type = "string")), Definition = structure(list(CommandText = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), AliasName = structure(logical(0), tags = list(type = "string")), Attachments = structure(list(structure(list(NotificationType = structure(logical(0), tags = list(type = "string")), ButtonText = structure(logical(0), tags = list(type = "string")), Criteria = structure(list(structure(list(Operator = structure(logical(0), tags = list(type = "string")), VariableName = structure(logical(0), tags = list(type = "string")), Value = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), Variables = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map"))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.chatbot$update_custom_action_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(CustomActionArn = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.chatbot$update_microsoft_teams_channel_configuration_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ChatConfigurationArn = structure(logical(0), tags = list(type = "string")), ChannelId = structure(logical(0), tags = list(type = "string")), ChannelName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), SnsTopicArns = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), IamRoleArn = structure(logical(0), tags = list(type = "string")), LoggingLevel = structure(logical(0), tags = list(type = "string")), GuardrailPolicyArns = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), UserAuthorizationRequired = structure(logical(0), tags = list(type = "boolean", box = TRUE))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.chatbot$update_microsoft_teams_channel_configuration_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ChannelConfiguration = structure(list(ChannelId = structure(logical(0), tags = list(type = "string")), ChannelName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), TeamId = structure(logical(0), tags = list(type = "string")), TeamName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), TenantId = structure(logical(0), tags = list(type = "string")), ChatConfigurationArn = structure(logical(0), tags = list(type = "string")), IamRoleArn = structure(logical(0), tags = list(type = "string")), SnsTopicArns = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), ConfigurationName = structure(logical(0), tags = list(type = "string")), LoggingLevel = structure(logical(0), tags = list(type = "string")), GuardrailPolicyArns = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), UserAuthorizationRequired = structure(logical(0), tags = list(type = "boolean", box = TRUE)), Tags = structure(list(structure(list(TagKey = structure(logical(0), tags = list(type = "string")), TagValue = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), State = structure(logical(0), tags = list(type = "string")), StateReason = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.chatbot$update_slack_channel_configuration_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ChatConfigurationArn = structure(logical(0), tags = list(type = "string")), SlackChannelId = structure(logical(0), tags = list(type = "string")), SlackChannelName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), SnsTopicArns = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), IamRoleArn = structure(logical(0), tags = list(type = "string")), LoggingLevel = structure(logical(0), tags = list(type = "string")), GuardrailPolicyArns = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), UserAuthorizationRequired = structure(logical(0), tags = list(type = "boolean", box = TRUE))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.chatbot$update_slack_channel_configuration_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ChannelConfiguration = structure(list(SlackTeamName = structure(logical(0), tags = list(type = "string")), SlackTeamId = structure(logical(0), tags = list(type = "string")), SlackChannelId = structure(logical(0), tags = list(type = "string")), SlackChannelName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), ChatConfigurationArn = structure(logical(0), tags = list(type = "string")), IamRoleArn = structure(logical(0), tags = list(type = "string")), SnsTopicArns = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), ConfigurationName = structure(logical(0), tags = list(type = "string")), LoggingLevel = structure(logical(0), tags = list(type = "string")), GuardrailPolicyArns = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), UserAuthorizationRequired = structure(logical(0), tags = list(type = "boolean", box = TRUE)), Tags = structure(list(structure(list(TagKey = structure(logical(0), tags = list(type = "string")), TagValue = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), State = structure(logical(0), tags = list(type = "string")), StateReason = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

# This file is generated by make.paws. Please do not edit here.
#' @importFrom paws.common populate
#' @include appstream_service.R
NULL

.appstream$associate_app_block_builder_app_block_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(AppBlockArn = structure(logical(0), tags = list(type = "string")), AppBlockBuilderName = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$associate_app_block_builder_app_block_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(AppBlockBuilderAppBlockAssociation = structure(list(AppBlockArn = structure(logical(0), tags = list(type = "string")), AppBlockBuilderName = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$associate_application_fleet_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(FleetName = structure(logical(0), tags = list(type = "string")), ApplicationArn = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$associate_application_fleet_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ApplicationFleetAssociation = structure(list(FleetName = structure(logical(0), tags = list(type = "string")), ApplicationArn = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$associate_application_to_entitlement_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(StackName = structure(logical(0), tags = list(type = "string")), EntitlementName = structure(logical(0), tags = list(type = "string")), ApplicationIdentifier = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$associate_application_to_entitlement_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$associate_fleet_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(FleetName = structure(logical(0), tags = list(type = "string")), StackName = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$associate_fleet_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$associate_software_to_image_builder_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ImageBuilderName = structure(logical(0), tags = list(type = "string")), SoftwareNames = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$associate_software_to_image_builder_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$batch_associate_user_stack_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(UserStackAssociations = structure(list(structure(list(StackName = structure(logical(0), tags = list(type = "string")), UserName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), AuthenticationType = structure(logical(0), tags = list(type = "string")), SendEmailNotification = structure(logical(0), tags = list(type = "boolean"))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$batch_associate_user_stack_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(errors = structure(list(structure(list(UserStackAssociation = structure(list(StackName = structure(logical(0), tags = list(type = "string")), UserName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), AuthenticationType = structure(logical(0), tags = list(type = "string")), SendEmailNotification = structure(logical(0), tags = list(type = "boolean"))), tags = list(type = "structure")), ErrorCode = structure(logical(0), tags = list(type = "string")), ErrorMessage = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$batch_disassociate_user_stack_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(UserStackAssociations = structure(list(structure(list(StackName = structure(logical(0), tags = list(type = "string")), UserName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), AuthenticationType = structure(logical(0), tags = list(type = "string")), SendEmailNotification = structure(logical(0), tags = list(type = "boolean"))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$batch_disassociate_user_stack_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(errors = structure(list(structure(list(UserStackAssociation = structure(list(StackName = structure(logical(0), tags = list(type = "string")), UserName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), AuthenticationType = structure(logical(0), tags = list(type = "string")), SendEmailNotification = structure(logical(0), tags = list(type = "boolean"))), tags = list(type = "structure")), ErrorCode = structure(logical(0), tags = list(type = "string")), ErrorMessage = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$copy_image_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(SourceImageName = structure(logical(0), tags = list(type = "string")), DestinationImageName = structure(logical(0), tags = list(type = "string")), DestinationRegion = structure(logical(0), tags = list(type = "string")), DestinationImageDescription = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$copy_image_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(DestinationImageName = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$create_app_block_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Name = structure(logical(0), tags = list(type = "string")), Description = structure(logical(0), tags = list(type = "string")), DisplayName = structure(logical(0), tags = list(type = "string")), SourceS3Location = structure(list(S3Bucket = structure(logical(0), tags = list(type = "string")), S3Key = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), SetupScriptDetails = structure(list(ScriptS3Location = structure(list(S3Bucket = structure(logical(0), tags = list(type = "string")), S3Key = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), ExecutablePath = structure(logical(0), tags = list(type = "string")), ExecutableParameters = structure(logical(0), tags = list(type = "string")), TimeoutInSeconds = structure(logical(0), tags = list(type = "integer"))), tags = list(type = "structure")), Tags = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map")), PostSetupScriptDetails = structure(list(ScriptS3Location = structure(list(S3Bucket = structure(logical(0), tags = list(type = "string")), S3Key = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), ExecutablePath = structure(logical(0), tags = list(type = "string")), ExecutableParameters = structure(logical(0), tags = list(type = "string")), TimeoutInSeconds = structure(logical(0), tags = list(type = "integer"))), tags = list(type = "structure")), PackagingType = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$create_app_block_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(AppBlock = structure(list(Name = structure(logical(0), tags = list(type = "string")), Arn = structure(logical(0), tags = list(type = "string")), Description = structure(logical(0), tags = list(type = "string")), DisplayName = structure(logical(0), tags = list(type = "string")), SourceS3Location = structure(list(S3Bucket = structure(logical(0), tags = list(type = "string")), S3Key = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), SetupScriptDetails = structure(list(ScriptS3Location = structure(list(S3Bucket = structure(logical(0), tags = list(type = "string")), S3Key = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), ExecutablePath = structure(logical(0), tags = list(type = "string")), ExecutableParameters = structure(logical(0), tags = list(type = "string")), TimeoutInSeconds = structure(logical(0), tags = list(type = "integer"))), tags = list(type = "structure")), CreatedTime = structure(logical(0), tags = list(type = "timestamp")), PostSetupScriptDetails = structure(list(ScriptS3Location = structure(list(S3Bucket = structure(logical(0), tags = list(type = "string")), S3Key = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), ExecutablePath = structure(logical(0), tags = list(type = "string")), ExecutableParameters = structure(logical(0), tags = list(type = "string")), TimeoutInSeconds = structure(logical(0), tags = list(type = "integer"))), tags = list(type = "structure")), PackagingType = structure(logical(0), tags = list(type = "string")), State = structure(logical(0), tags = list(type = "string")), AppBlockErrors = structure(list(structure(list(ErrorCode = structure(logical(0), tags = list(type = "string")), ErrorMessage = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$create_app_block_builder_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Name = structure(logical(0), tags = list(type = "string")), Description = structure(logical(0), tags = list(type = "string")), DisplayName = structure(logical(0), tags = list(type = "string")), Tags = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map")), Platform = structure(logical(0), tags = list(type = "string")), InstanceType = structure(logical(0), tags = list(type = "string")), VpcConfig = structure(list(SubnetIds = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), SecurityGroupIds = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure")), EnableDefaultInternetAccess = structure(logical(0), tags = list(type = "boolean")), IamRoleArn = structure(logical(0), tags = list(type = "string")), AccessEndpoints = structure(list(structure(list(EndpointType = structure(logical(0), tags = list(type = "string")), VpceId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), DisableIMDSV1 = structure(logical(0), tags = list(type = "boolean"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$create_app_block_builder_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(AppBlockBuilder = structure(list(Arn = structure(logical(0), tags = list(type = "string")), Name = structure(logical(0), tags = list(type = "string")), DisplayName = structure(logical(0), tags = list(type = "string")), Description = structure(logical(0), tags = list(type = "string")), Platform = structure(logical(0), tags = list(type = "string")), InstanceType = structure(logical(0), tags = list(type = "string")), EnableDefaultInternetAccess = structure(logical(0), tags = list(type = "boolean")), IamRoleArn = structure(logical(0), tags = list(type = "string")), VpcConfig = structure(list(SubnetIds = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), SecurityGroupIds = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure")), State = structure(logical(0), tags = list(type = "string")), CreatedTime = structure(logical(0), tags = list(type = "timestamp")), AppBlockBuilderErrors = structure(list(structure(list(ErrorCode = structure(logical(0), tags = list(type = "string")), ErrorMessage = structure(logical(0), tags = list(type = "string")), ErrorTimestamp = structure(logical(0), tags = list(type = "timestamp"))), tags = list(type = "structure"))), tags = list(type = "list")), StateChangeReason = structure(list(Code = structure(logical(0), tags = list(type = "string")), Message = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), AccessEndpoints = structure(list(structure(list(EndpointType = structure(logical(0), tags = list(type = "string")), VpceId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), DisableIMDSV1 = structure(logical(0), tags = list(type = "boolean"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$create_app_block_builder_streaming_url_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(AppBlockBuilderName = structure(logical(0), tags = list(type = "string")), Validity = structure(logical(0), tags = list(type = "long"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$create_app_block_builder_streaming_url_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(StreamingURL = structure(logical(0), tags = list(type = "string")), Expires = structure(logical(0), tags = list(type = "timestamp"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$create_application_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Name = structure(logical(0), tags = list(type = "string")), DisplayName = structure(logical(0), tags = list(type = "string")), Description = structure(logical(0), tags = list(type = "string")), IconS3Location = structure(list(S3Bucket = structure(logical(0), tags = list(type = "string")), S3Key = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), LaunchPath = structure(logical(0), tags = list(type = "string")), WorkingDirectory = structure(logical(0), tags = list(type = "string")), LaunchParameters = structure(logical(0), tags = list(type = "string")), Platforms = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), InstanceFamilies = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), AppBlockArn = structure(logical(0), tags = list(type = "string")), Tags = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$create_application_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Application = structure(list(Name = structure(logical(0), tags = list(type = "string")), DisplayName = structure(logical(0), tags = list(type = "string")), IconURL = structure(logical(0), tags = list(type = "string")), LaunchPath = structure(logical(0), tags = list(type = "string")), LaunchParameters = structure(logical(0), tags = list(type = "string")), Enabled = structure(logical(0), tags = list(type = "boolean")), Metadata = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map")), WorkingDirectory = structure(logical(0), tags = list(type = "string")), Description = structure(logical(0), tags = list(type = "string")), Arn = structure(logical(0), tags = list(type = "string")), AppBlockArn = structure(logical(0), tags = list(type = "string")), IconS3Location = structure(list(S3Bucket = structure(logical(0), tags = list(type = "string")), S3Key = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), Platforms = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), InstanceFamilies = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), CreatedTime = structure(logical(0), tags = list(type = "timestamp"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$create_directory_config_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(DirectoryName = structure(logical(0), tags = list(type = "string")), OrganizationalUnitDistinguishedNames = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), ServiceAccountCredentials = structure(list(AccountName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), AccountPassword = structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "structure")), CertificateBasedAuthProperties = structure(list(Status = structure(logical(0), tags = list(type = "string")), CertificateAuthorityArn = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$create_directory_config_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(DirectoryConfig = structure(list(DirectoryName = structure(logical(0), tags = list(type = "string")), OrganizationalUnitDistinguishedNames = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), ServiceAccountCredentials = structure(list(AccountName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), AccountPassword = structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "structure")), CreatedTime = structure(logical(0), tags = list(type = "timestamp")), CertificateBasedAuthProperties = structure(list(Status = structure(logical(0), tags = list(type = "string")), CertificateAuthorityArn = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$create_entitlement_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Name = structure(logical(0), tags = list(type = "string")), StackName = structure(logical(0), tags = list(type = "string")), Description = structure(logical(0), tags = list(type = "string")), AppVisibility = structure(logical(0), tags = list(type = "string")), Attributes = structure(list(structure(list(Name = structure(logical(0), tags = list(type = "string")), Value = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$create_entitlement_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Entitlement = structure(list(Name = structure(logical(0), tags = list(type = "string")), StackName = structure(logical(0), tags = list(type = "string")), Description = structure(logical(0), tags = list(type = "string")), AppVisibility = structure(logical(0), tags = list(type = "string")), Attributes = structure(list(structure(list(Name = structure(logical(0), tags = list(type = "string")), Value = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), CreatedTime = structure(logical(0), tags = list(type = "timestamp")), LastModifiedTime = structure(logical(0), tags = list(type = "timestamp"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$create_export_image_task_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ImageName = structure(logical(0), tags = list(type = "string")), AmiName = structure(logical(0), tags = list(type = "string")), IamRoleArn = structure(logical(0), tags = list(type = "string")), TagSpecifications = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map")), AmiDescription = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$create_export_image_task_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ExportImageTask = structure(list(TaskId = structure(logical(0), tags = list(type = "string")), ImageArn = structure(logical(0), tags = list(type = "string")), AmiName = structure(logical(0), tags = list(type = "string")), CreatedDate = structure(logical(0), tags = list(type = "timestamp")), AmiDescription = structure(logical(0), tags = list(type = "string")), State = structure(logical(0), tags = list(type = "string")), AmiId = structure(logical(0), tags = list(type = "string")), TagSpecifications = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map")), ErrorDetails = structure(list(structure(list(ErrorCode = structure(logical(0), tags = list(type = "string")), ErrorMessage = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$create_fleet_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Name = structure(logical(0), tags = list(type = "string")), ImageName = structure(logical(0), tags = list(type = "string")), ImageArn = structure(logical(0), tags = list(type = "string")), InstanceType = structure(logical(0), tags = list(type = "string")), FleetType = structure(logical(0), tags = list(type = "string")), ComputeCapacity = structure(list(DesiredInstances = structure(logical(0), tags = list(type = "integer")), DesiredSessions = structure(logical(0), tags = list(type = "integer"))), tags = list(type = "structure")), VpcConfig = structure(list(SubnetIds = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), SecurityGroupIds = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure")), MaxUserDurationInSeconds = structure(logical(0), tags = list(type = "integer")), DisconnectTimeoutInSeconds = structure(logical(0), tags = list(type = "integer")), Description = structure(logical(0), tags = list(type = "string")), DisplayName = structure(logical(0), tags = list(type = "string")), EnableDefaultInternetAccess = structure(logical(0), tags = list(type = "boolean")), DomainJoinInfo = structure(list(DirectoryName = structure(logical(0), tags = list(type = "string")), OrganizationalUnitDistinguishedName = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), Tags = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map")), IdleDisconnectTimeoutInSeconds = structure(logical(0), tags = list(type = "integer")), IamRoleArn = structure(logical(0), tags = list(type = "string")), StreamView = structure(logical(0), tags = list(type = "string")), Platform = structure(logical(0), tags = list(type = "string")), MaxConcurrentSessions = structure(logical(0), tags = list(type = "integer")), UsbDeviceFilterStrings = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), SessionScriptS3Location = structure(list(S3Bucket = structure(logical(0), tags = list(type = "string")), S3Key = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), MaxSessionsPerInstance = structure(logical(0), tags = list(type = "integer")), RootVolumeConfig = structure(list(VolumeSizeInGb = structure(logical(0), tags = list(type = "integer"))), tags = list(type = "structure")), DisableIMDSV1 = structure(logical(0), tags = list(type = "boolean"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$create_fleet_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Fleet = structure(list(Arn = structure(logical(0), tags = list(type = "string")), Name = structure(logical(0), tags = list(type = "string")), DisplayName = structure(logical(0), tags = list(type = "string")), Description = structure(logical(0), tags = list(type = "string")), ImageName = structure(logical(0), tags = list(type = "string")), ImageArn = structure(logical(0), tags = list(type = "string")), InstanceType = structure(logical(0), tags = list(type = "string")), FleetType = structure(logical(0), tags = list(type = "string")), ComputeCapacityStatus = structure(list(Desired = structure(logical(0), tags = list(type = "integer")), Running = structure(logical(0), tags = list(type = "integer")), InUse = structure(logical(0), tags = list(type = "integer")), Available = structure(logical(0), tags = list(type = "integer")), DesiredUserSessions = structure(logical(0), tags = list(type = "integer")), AvailableUserSessions = structure(logical(0), tags = list(type = "integer")), ActiveUserSessions = structure(logical(0), tags = list(type = "integer")), ActualUserSessions = structure(logical(0), tags = list(type = "integer")), Draining = structure(logical(0), tags = list(type = "integer")), DrainModeActiveUserSessions = structure(logical(0), tags = list(type = "integer")), DrainModeUnusedUserSessions = structure(logical(0), tags = list(type = "integer"))), tags = list(type = "structure")), MaxUserDurationInSeconds = structure(logical(0), tags = list(type = "integer")), DisconnectTimeoutInSeconds = structure(logical(0), tags = list(type = "integer")), State = structure(logical(0), tags = list(type = "string")), VpcConfig = structure(list(SubnetIds = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), SecurityGroupIds = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure")), CreatedTime = structure(logical(0), tags = list(type = "timestamp")), FleetErrors = structure(list(structure(list(ErrorCode = structure(logical(0), tags = list(type = "string")), ErrorMessage = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), EnableDefaultInternetAccess = structure(logical(0), tags = list(type = "boolean")), DomainJoinInfo = structure(list(DirectoryName = structure(logical(0), tags = list(type = "string")), OrganizationalUnitDistinguishedName = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), IdleDisconnectTimeoutInSeconds = structure(logical(0), tags = list(type = "integer")), IamRoleArn = structure(logical(0), tags = list(type = "string")), StreamView = structure(logical(0), tags = list(type = "string")), Platform = structure(logical(0), tags = list(type = "string")), MaxConcurrentSessions = structure(logical(0), tags = list(type = "integer")), UsbDeviceFilterStrings = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), SessionScriptS3Location = structure(list(S3Bucket = structure(logical(0), tags = list(type = "string")), S3Key = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), MaxSessionsPerInstance = structure(logical(0), tags = list(type = "integer")), RootVolumeConfig = structure(list(VolumeSizeInGb = structure(logical(0), tags = list(type = "integer"))), tags = list(type = "structure")), DisableIMDSV1 = structure(logical(0), tags = list(type = "boolean"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$create_image_builder_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Name = structure(logical(0), tags = list(type = "string")), ImageName = structure(logical(0), tags = list(type = "string")), ImageArn = structure(logical(0), tags = list(type = "string")), InstanceType = structure(logical(0), tags = list(type = "string")), Description = structure(logical(0), tags = list(type = "string")), DisplayName = structure(logical(0), tags = list(type = "string")), VpcConfig = structure(list(SubnetIds = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), SecurityGroupIds = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure")), IamRoleArn = structure(logical(0), tags = list(type = "string")), EnableDefaultInternetAccess = structure(logical(0), tags = list(type = "boolean")), DomainJoinInfo = structure(list(DirectoryName = structure(logical(0), tags = list(type = "string")), OrganizationalUnitDistinguishedName = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), AppstreamAgentVersion = structure(logical(0), tags = list(type = "string")), Tags = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map")), AccessEndpoints = structure(list(structure(list(EndpointType = structure(logical(0), tags = list(type = "string")), VpceId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), RootVolumeConfig = structure(list(VolumeSizeInGb = structure(logical(0), tags = list(type = "integer"))), tags = list(type = "structure")), SoftwaresToInstall = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), SoftwaresToUninstall = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), DisableIMDSV1 = structure(logical(0), tags = list(type = "boolean"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$create_image_builder_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ImageBuilder = structure(list(Name = structure(logical(0), tags = list(type = "string")), Arn = structure(logical(0), tags = list(type = "string")), ImageArn = structure(logical(0), tags = list(type = "string")), Description = structure(logical(0), tags = list(type = "string")), DisplayName = structure(logical(0), tags = list(type = "string")), VpcConfig = structure(list(SubnetIds = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), SecurityGroupIds = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure")), InstanceType = structure(logical(0), tags = list(type = "string")), Platform = structure(logical(0), tags = list(type = "string")), IamRoleArn = structure(logical(0), tags = list(type = "string")), State = structure(logical(0), tags = list(type = "string")), StateChangeReason = structure(list(Code = structure(logical(0), tags = list(type = "string")), Message = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), CreatedTime = structure(logical(0), tags = list(type = "timestamp")), EnableDefaultInternetAccess = structure(logical(0), tags = list(type = "boolean")), DomainJoinInfo = structure(list(DirectoryName = structure(logical(0), tags = list(type = "string")), OrganizationalUnitDistinguishedName = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), NetworkAccessConfiguration = structure(list(EniPrivateIpAddress = structure(logical(0), tags = list(type = "string")), EniIpv6Addresses = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), EniId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), ImageBuilderErrors = structure(list(structure(list(ErrorCode = structure(logical(0), tags = list(type = "string")), ErrorMessage = structure(logical(0), tags = list(type = "string")), ErrorTimestamp = structure(logical(0), tags = list(type = "timestamp"))), tags = list(type = "structure"))), tags = list(type = "list")), AppstreamAgentVersion = structure(logical(0), tags = list(type = "string")), AccessEndpoints = structure(list(structure(list(EndpointType = structure(logical(0), tags = list(type = "string")), VpceId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), RootVolumeConfig = structure(list(VolumeSizeInGb = structure(logical(0), tags = list(type = "integer"))), tags = list(type = "structure")), LatestAppstreamAgentVersion = structure(logical(0), tags = list(type = "string")), DisableIMDSV1 = structure(logical(0), tags = list(type = "boolean"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$create_image_builder_streaming_url_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Name = structure(logical(0), tags = list(type = "string")), Validity = structure(logical(0), tags = list(type = "long"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$create_image_builder_streaming_url_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(StreamingURL = structure(logical(0), tags = list(type = "string")), Expires = structure(logical(0), tags = list(type = "timestamp"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$create_imported_image_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Name = structure(logical(0), tags = list(type = "string")), SourceAmiId = structure(logical(0), tags = list(type = "string")), IamRoleArn = structure(logical(0), tags = list(type = "string")), Description = structure(logical(0), tags = list(type = "string")), DisplayName = structure(logical(0), tags = list(type = "string")), Tags = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map")), RuntimeValidationConfig = structure(list(IntendedInstanceType = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), AgentSoftwareVersion = structure(logical(0), tags = list(type = "string")), AppCatalogConfig = structure(list(structure(list(Name = structure(logical(0), tags = list(type = "string")), DisplayName = structure(logical(0), tags = list(type = "string")), AbsoluteAppPath = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), AbsoluteIconPath = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), AbsoluteManifestPath = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), WorkingDirectory = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), LaunchParameters = structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "structure", sensitive = TRUE))), tags = list(type = "list")), DryRun = structure(logical(0), tags = list(type = "boolean"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$create_imported_image_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Image = structure(list(Name = structure(logical(0), tags = list(type = "string")), Arn = structure(logical(0), tags = list(type = "string")), BaseImageArn = structure(logical(0), tags = list(type = "string")), DisplayName = structure(logical(0), tags = list(type = "string")), State = structure(logical(0), tags = list(type = "string")), Visibility = structure(logical(0), tags = list(type = "string")), ImageBuilderSupported = structure(logical(0), tags = list(type = "boolean")), ImageBuilderName = structure(logical(0), tags = list(type = "string")), Platform = structure(logical(0), tags = list(type = "string")), Description = structure(logical(0), tags = list(type = "string")), StateChangeReason = structure(list(Code = structure(logical(0), tags = list(type = "string")), Message = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), Applications = structure(list(structure(list(Name = structure(logical(0), tags = list(type = "string")), DisplayName = structure(logical(0), tags = list(type = "string")), IconURL = structure(logical(0), tags = list(type = "string")), LaunchPath = structure(logical(0), tags = list(type = "string")), LaunchParameters = structure(logical(0), tags = list(type = "string")), Enabled = structure(logical(0), tags = list(type = "boolean")), Metadata = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map")), WorkingDirectory = structure(logical(0), tags = list(type = "string")), Description = structure(logical(0), tags = list(type = "string")), Arn = structure(logical(0), tags = list(type = "string")), AppBlockArn = structure(logical(0), tags = list(type = "string")), IconS3Location = structure(list(S3Bucket = structure(logical(0), tags = list(type = "string")), S3Key = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), Platforms = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), InstanceFamilies = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), CreatedTime = structure(logical(0), tags = list(type = "timestamp"))), tags = list(type = "structure"))), tags = list(type = "list")), CreatedTime = structure(logical(0), tags = list(type = "timestamp")), PublicBaseImageReleasedDate = structure(logical(0), tags = list(type = "timestamp")), AppstreamAgentVersion = structure(logical(0), tags = list(type = "string")), ImagePermissions = structure(list(allowFleet = structure(logical(0), tags = list(type = "boolean")), allowImageBuilder = structure(logical(0), tags = list(type = "boolean"))), tags = list(type = "structure")), ImageErrors = structure(list(structure(list(ErrorCode = structure(logical(0), tags = list(type = "string")), ErrorMessage = structure(logical(0), tags = list(type = "string")), ErrorTimestamp = structure(logical(0), tags = list(type = "timestamp"))), tags = list(type = "structure"))), tags = list(type = "list")), LatestAppstreamAgentVersion = structure(logical(0), tags = list(type = "string")), SupportedInstanceFamilies = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), DynamicAppProvidersEnabled = structure(logical(0), tags = list(type = "string")), ImageSharedWithOthers = structure(logical(0), tags = list(type = "string")), ManagedSoftwareIncluded = structure(logical(0), tags = list(type = "boolean")), ImageType = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$create_stack_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Name = structure(logical(0), tags = list(type = "string")), Description = structure(logical(0), tags = list(type = "string")), DisplayName = structure(logical(0), tags = list(type = "string")), StorageConnectors = structure(list(structure(list(ConnectorType = structure(logical(0), tags = list(type = "string")), ResourceIdentifier = structure(logical(0), tags = list(type = "string")), Domains = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), DomainsRequireAdminConsent = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure"))), tags = list(type = "list")), RedirectURL = structure(logical(0), tags = list(type = "string")), FeedbackURL = structure(logical(0), tags = list(type = "string")), UserSettings = structure(list(structure(list(Action = structure(logical(0), tags = list(type = "string")), Permission = structure(logical(0), tags = list(type = "string")), MaximumLength = structure(logical(0), tags = list(type = "integer"))), tags = list(type = "structure"))), tags = list(type = "list")), ApplicationSettings = structure(list(Enabled = structure(logical(0), tags = list(type = "boolean")), SettingsGroup = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), Tags = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map")), AccessEndpoints = structure(list(structure(list(EndpointType = structure(logical(0), tags = list(type = "string")), VpceId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), EmbedHostDomains = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), StreamingExperienceSettings = structure(list(PreferredProtocol = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), ContentRedirection = structure(list(HostToClient = structure(list(Enabled = structure(logical(0), tags = list(type = "boolean")), AllowedUrls = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), DeniedUrls = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure"))), tags = list(type = "structure")), AgentAccessConfig = structure(list(Settings = structure(list(structure(list(AgentAction = structure(logical(0), tags = list(type = "string")), Permission = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), S3BucketArn = structure(logical(0), tags = list(type = "string")), ScreenshotsUploadEnabled = structure(logical(0), tags = list(type = "boolean")), ScreenResolution = structure(logical(0), tags = list(type = "string")), ScreenImageFormat = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$create_stack_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Stack = structure(list(Arn = structure(logical(0), tags = list(type = "string")), Name = structure(logical(0), tags = list(type = "string")), Description = structure(logical(0), tags = list(type = "string")), DisplayName = structure(logical(0), tags = list(type = "string")), CreatedTime = structure(logical(0), tags = list(type = "timestamp")), StorageConnectors = structure(list(structure(list(ConnectorType = structure(logical(0), tags = list(type = "string")), ResourceIdentifier = structure(logical(0), tags = list(type = "string")), Domains = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), DomainsRequireAdminConsent = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure"))), tags = list(type = "list")), RedirectURL = structure(logical(0), tags = list(type = "string")), FeedbackURL = structure(logical(0), tags = list(type = "string")), StackErrors = structure(list(structure(list(ErrorCode = structure(logical(0), tags = list(type = "string")), ErrorMessage = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), UserSettings = structure(list(structure(list(Action = structure(logical(0), tags = list(type = "string")), Permission = structure(logical(0), tags = list(type = "string")), MaximumLength = structure(logical(0), tags = list(type = "integer"))), tags = list(type = "structure"))), tags = list(type = "list")), ApplicationSettings = structure(list(Enabled = structure(logical(0), tags = list(type = "boolean")), SettingsGroup = structure(logical(0), tags = list(type = "string")), S3BucketName = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), AccessEndpoints = structure(list(structure(list(EndpointType = structure(logical(0), tags = list(type = "string")), VpceId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), EmbedHostDomains = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), StreamingExperienceSettings = structure(list(PreferredProtocol = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), ContentRedirection = structure(list(HostToClient = structure(list(Enabled = structure(logical(0), tags = list(type = "boolean")), AllowedUrls = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), DeniedUrls = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure"))), tags = list(type = "structure")), AgentAccessConfig = structure(list(Settings = structure(list(structure(list(AgentAction = structure(logical(0), tags = list(type = "string")), Permission = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), S3BucketArn = structure(logical(0), tags = list(type = "string")), ScreenshotsUploadEnabled = structure(logical(0), tags = list(type = "boolean")), ScreenResolution = structure(logical(0), tags = list(type = "string")), ScreenImageFormat = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$create_streaming_url_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(StackName = structure(logical(0), tags = list(type = "string")), FleetName = structure(logical(0), tags = list(type = "string")), UserId = structure(logical(0), tags = list(type = "string")), ApplicationId = structure(logical(0), tags = list(type = "string")), Validity = structure(logical(0), tags = list(type = "long")), SessionContext = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$create_streaming_url_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(StreamingURL = structure(logical(0), tags = list(type = "string")), Expires = structure(logical(0), tags = list(type = "timestamp"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$create_theme_for_stack_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(StackName = structure(logical(0), tags = list(type = "string")), FooterLinks = structure(list(structure(list(DisplayName = structure(logical(0), tags = list(type = "string")), FooterLinkURL = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), TitleText = structure(logical(0), tags = list(type = "string")), ThemeStyling = structure(logical(0), tags = list(type = "string")), OrganizationLogoS3Location = structure(list(S3Bucket = structure(logical(0), tags = list(type = "string")), S3Key = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), FaviconS3Location = structure(list(S3Bucket = structure(logical(0), tags = list(type = "string")), S3Key = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$create_theme_for_stack_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Theme = structure(list(StackName = structure(logical(0), tags = list(type = "string")), State = structure(logical(0), tags = list(type = "string")), ThemeTitleText = structure(logical(0), tags = list(type = "string")), ThemeStyling = structure(logical(0), tags = list(type = "string")), ThemeFooterLinks = structure(list(structure(list(DisplayName = structure(logical(0), tags = list(type = "string")), FooterLinkURL = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), ThemeOrganizationLogoURL = structure(logical(0), tags = list(type = "string")), ThemeFaviconURL = structure(logical(0), tags = list(type = "string")), CreatedTime = structure(logical(0), tags = list(type = "timestamp"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$create_updated_image_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(existingImageName = structure(logical(0), tags = list(type = "string")), newImageName = structure(logical(0), tags = list(type = "string")), newImageDescription = structure(logical(0), tags = list(type = "string")), newImageDisplayName = structure(logical(0), tags = list(type = "string")), newImageTags = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map")), dryRun = structure(logical(0), tags = list(type = "boolean"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$create_updated_image_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(image = structure(list(Name = structure(logical(0), tags = list(type = "string")), Arn = structure(logical(0), tags = list(type = "string")), BaseImageArn = structure(logical(0), tags = list(type = "string")), DisplayName = structure(logical(0), tags = list(type = "string")), State = structure(logical(0), tags = list(type = "string")), Visibility = structure(logical(0), tags = list(type = "string")), ImageBuilderSupported = structure(logical(0), tags = list(type = "boolean")), ImageBuilderName = structure(logical(0), tags = list(type = "string")), Platform = structure(logical(0), tags = list(type = "string")), Description = structure(logical(0), tags = list(type = "string")), StateChangeReason = structure(list(Code = structure(logical(0), tags = list(type = "string")), Message = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), Applications = structure(list(structure(list(Name = structure(logical(0), tags = list(type = "string")), DisplayName = structure(logical(0), tags = list(type = "string")), IconURL = structure(logical(0), tags = list(type = "string")), LaunchPath = structure(logical(0), tags = list(type = "string")), LaunchParameters = structure(logical(0), tags = list(type = "string")), Enabled = structure(logical(0), tags = list(type = "boolean")), Metadata = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map")), WorkingDirectory = structure(logical(0), tags = list(type = "string")), Description = structure(logical(0), tags = list(type = "string")), Arn = structure(logical(0), tags = list(type = "string")), AppBlockArn = structure(logical(0), tags = list(type = "string")), IconS3Location = structure(list(S3Bucket = structure(logical(0), tags = list(type = "string")), S3Key = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), Platforms = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), InstanceFamilies = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), CreatedTime = structure(logical(0), tags = list(type = "timestamp"))), tags = list(type = "structure"))), tags = list(type = "list")), CreatedTime = structure(logical(0), tags = list(type = "timestamp")), PublicBaseImageReleasedDate = structure(logical(0), tags = list(type = "timestamp")), AppstreamAgentVersion = structure(logical(0), tags = list(type = "string")), ImagePermissions = structure(list(allowFleet = structure(logical(0), tags = list(type = "boolean")), allowImageBuilder = structure(logical(0), tags = list(type = "boolean"))), tags = list(type = "structure")), ImageErrors = structure(list(structure(list(ErrorCode = structure(logical(0), tags = list(type = "string")), ErrorMessage = structure(logical(0), tags = list(type = "string")), ErrorTimestamp = structure(logical(0), tags = list(type = "timestamp"))), tags = list(type = "structure"))), tags = list(type = "list")), LatestAppstreamAgentVersion = structure(logical(0), tags = list(type = "string")), SupportedInstanceFamilies = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), DynamicAppProvidersEnabled = structure(logical(0), tags = list(type = "string")), ImageSharedWithOthers = structure(logical(0), tags = list(type = "string")), ManagedSoftwareIncluded = structure(logical(0), tags = list(type = "boolean")), ImageType = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), canUpdateImage = structure(logical(0), tags = list(type = "boolean"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$create_usage_report_subscription_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$create_usage_report_subscription_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(S3BucketName = structure(logical(0), tags = list(type = "string")), Schedule = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$create_user_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(UserName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), MessageAction = structure(logical(0), tags = list(type = "string")), FirstName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), LastName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), AuthenticationType = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$create_user_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$delete_app_block_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Name = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$delete_app_block_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$delete_app_block_builder_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Name = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$delete_app_block_builder_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$delete_application_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Name = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$delete_application_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$delete_directory_config_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(DirectoryName = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$delete_directory_config_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$delete_entitlement_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Name = structure(logical(0), tags = list(type = "string")), StackName = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$delete_entitlement_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$delete_fleet_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Name = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$delete_fleet_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$delete_image_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Name = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$delete_image_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Image = structure(list(Name = structure(logical(0), tags = list(type = "string")), Arn = structure(logical(0), tags = list(type = "string")), BaseImageArn = structure(logical(0), tags = list(type = "string")), DisplayName = structure(logical(0), tags = list(type = "string")), State = structure(logical(0), tags = list(type = "string")), Visibility = structure(logical(0), tags = list(type = "string")), ImageBuilderSupported = structure(logical(0), tags = list(type = "boolean")), ImageBuilderName = structure(logical(0), tags = list(type = "string")), Platform = structure(logical(0), tags = list(type = "string")), Description = structure(logical(0), tags = list(type = "string")), StateChangeReason = structure(list(Code = structure(logical(0), tags = list(type = "string")), Message = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), Applications = structure(list(structure(list(Name = structure(logical(0), tags = list(type = "string")), DisplayName = structure(logical(0), tags = list(type = "string")), IconURL = structure(logical(0), tags = list(type = "string")), LaunchPath = structure(logical(0), tags = list(type = "string")), LaunchParameters = structure(logical(0), tags = list(type = "string")), Enabled = structure(logical(0), tags = list(type = "boolean")), Metadata = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map")), WorkingDirectory = structure(logical(0), tags = list(type = "string")), Description = structure(logical(0), tags = list(type = "string")), Arn = structure(logical(0), tags = list(type = "string")), AppBlockArn = structure(logical(0), tags = list(type = "string")), IconS3Location = structure(list(S3Bucket = structure(logical(0), tags = list(type = "string")), S3Key = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), Platforms = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), InstanceFamilies = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), CreatedTime = structure(logical(0), tags = list(type = "timestamp"))), tags = list(type = "structure"))), tags = list(type = "list")), CreatedTime = structure(logical(0), tags = list(type = "timestamp")), PublicBaseImageReleasedDate = structure(logical(0), tags = list(type = "timestamp")), AppstreamAgentVersion = structure(logical(0), tags = list(type = "string")), ImagePermissions = structure(list(allowFleet = structure(logical(0), tags = list(type = "boolean")), allowImageBuilder = structure(logical(0), tags = list(type = "boolean"))), tags = list(type = "structure")), ImageErrors = structure(list(structure(list(ErrorCode = structure(logical(0), tags = list(type = "string")), ErrorMessage = structure(logical(0), tags = list(type = "string")), ErrorTimestamp = structure(logical(0), tags = list(type = "timestamp"))), tags = list(type = "structure"))), tags = list(type = "list")), LatestAppstreamAgentVersion = structure(logical(0), tags = list(type = "string")), SupportedInstanceFamilies = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), DynamicAppProvidersEnabled = structure(logical(0), tags = list(type = "string")), ImageSharedWithOthers = structure(logical(0), tags = list(type = "string")), ManagedSoftwareIncluded = structure(logical(0), tags = list(type = "boolean")), ImageType = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$delete_image_builder_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Name = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$delete_image_builder_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ImageBuilder = structure(list(Name = structure(logical(0), tags = list(type = "string")), Arn = structure(logical(0), tags = list(type = "string")), ImageArn = structure(logical(0), tags = list(type = "string")), Description = structure(logical(0), tags = list(type = "string")), DisplayName = structure(logical(0), tags = list(type = "string")), VpcConfig = structure(list(SubnetIds = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), SecurityGroupIds = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure")), InstanceType = structure(logical(0), tags = list(type = "string")), Platform = structure(logical(0), tags = list(type = "string")), IamRoleArn = structure(logical(0), tags = list(type = "string")), State = structure(logical(0), tags = list(type = "string")), StateChangeReason = structure(list(Code = structure(logical(0), tags = list(type = "string")), Message = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), CreatedTime = structure(logical(0), tags = list(type = "timestamp")), EnableDefaultInternetAccess = structure(logical(0), tags = list(type = "boolean")), DomainJoinInfo = structure(list(DirectoryName = structure(logical(0), tags = list(type = "string")), OrganizationalUnitDistinguishedName = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), NetworkAccessConfiguration = structure(list(EniPrivateIpAddress = structure(logical(0), tags = list(type = "string")), EniIpv6Addresses = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), EniId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), ImageBuilderErrors = structure(list(structure(list(ErrorCode = structure(logical(0), tags = list(type = "string")), ErrorMessage = structure(logical(0), tags = list(type = "string")), ErrorTimestamp = structure(logical(0), tags = list(type = "timestamp"))), tags = list(type = "structure"))), tags = list(type = "list")), AppstreamAgentVersion = structure(logical(0), tags = list(type = "string")), AccessEndpoints = structure(list(structure(list(EndpointType = structure(logical(0), tags = list(type = "string")), VpceId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), RootVolumeConfig = structure(list(VolumeSizeInGb = structure(logical(0), tags = list(type = "integer"))), tags = list(type = "structure")), LatestAppstreamAgentVersion = structure(logical(0), tags = list(type = "string")), DisableIMDSV1 = structure(logical(0), tags = list(type = "boolean"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$delete_image_permissions_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Name = structure(logical(0), tags = list(type = "string")), SharedAccountId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$delete_image_permissions_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$delete_stack_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Name = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$delete_stack_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$delete_theme_for_stack_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(StackName = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$delete_theme_for_stack_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$delete_usage_report_subscription_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$delete_usage_report_subscription_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$delete_user_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(UserName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), AuthenticationType = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$delete_user_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$describe_app_block_builder_app_block_associations_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(AppBlockArn = structure(logical(0), tags = list(type = "string")), AppBlockBuilderName = structure(logical(0), tags = list(type = "string")), MaxResults = structure(logical(0), tags = list(type = "integer")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$describe_app_block_builder_app_block_associations_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(AppBlockBuilderAppBlockAssociations = structure(list(structure(list(AppBlockArn = structure(logical(0), tags = list(type = "string")), AppBlockBuilderName = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$describe_app_block_builders_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Names = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), NextToken = structure(logical(0), tags = list(type = "string")), MaxResults = structure(logical(0), tags = list(type = "integer"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$describe_app_block_builders_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(AppBlockBuilders = structure(list(structure(list(Arn = structure(logical(0), tags = list(type = "string")), Name = structure(logical(0), tags = list(type = "string")), DisplayName = structure(logical(0), tags = list(type = "string")), Description = structure(logical(0), tags = list(type = "string")), Platform = structure(logical(0), tags = list(type = "string")), InstanceType = structure(logical(0), tags = list(type = "string")), EnableDefaultInternetAccess = structure(logical(0), tags = list(type = "boolean")), IamRoleArn = structure(logical(0), tags = list(type = "string")), VpcConfig = structure(list(SubnetIds = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), SecurityGroupIds = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure")), State = structure(logical(0), tags = list(type = "string")), CreatedTime = structure(logical(0), tags = list(type = "timestamp")), AppBlockBuilderErrors = structure(list(structure(list(ErrorCode = structure(logical(0), tags = list(type = "string")), ErrorMessage = structure(logical(0), tags = list(type = "string")), ErrorTimestamp = structure(logical(0), tags = list(type = "timestamp"))), tags = list(type = "structure"))), tags = list(type = "list")), StateChangeReason = structure(list(Code = structure(logical(0), tags = list(type = "string")), Message = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), AccessEndpoints = structure(list(structure(list(EndpointType = structure(logical(0), tags = list(type = "string")), VpceId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), DisableIMDSV1 = structure(logical(0), tags = list(type = "boolean"))), tags = list(type = "structure"))), tags = list(type = "list")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$describe_app_blocks_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Arns = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), NextToken = structure(logical(0), tags = list(type = "string")), MaxResults = structure(logical(0), tags = list(type = "integer"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$describe_app_blocks_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(AppBlocks = structure(list(structure(list(Name = structure(logical(0), tags = list(type = "string")), Arn = structure(logical(0), tags = list(type = "string")), Description = structure(logical(0), tags = list(type = "string")), DisplayName = structure(logical(0), tags = list(type = "string")), SourceS3Location = structure(list(S3Bucket = structure(logical(0), tags = list(type = "string")), S3Key = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), SetupScriptDetails = structure(list(ScriptS3Location = structure(list(S3Bucket = structure(logical(0), tags = list(type = "string")), S3Key = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), ExecutablePath = structure(logical(0), tags = list(type = "string")), ExecutableParameters = structure(logical(0), tags = list(type = "string")), TimeoutInSeconds = structure(logical(0), tags = list(type = "integer"))), tags = list(type = "structure")), CreatedTime = structure(logical(0), tags = list(type = "timestamp")), PostSetupScriptDetails = structure(list(ScriptS3Location = structure(list(S3Bucket = structure(logical(0), tags = list(type = "string")), S3Key = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), ExecutablePath = structure(logical(0), tags = list(type = "string")), ExecutableParameters = structure(logical(0), tags = list(type = "string")), TimeoutInSeconds = structure(logical(0), tags = list(type = "integer"))), tags = list(type = "structure")), PackagingType = structure(logical(0), tags = list(type = "string")), State = structure(logical(0), tags = list(type = "string")), AppBlockErrors = structure(list(structure(list(ErrorCode = structure(logical(0), tags = list(type = "string")), ErrorMessage = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure"))), tags = list(type = "list")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$describe_app_license_usage_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(BillingPeriod = structure(logical(0), tags = list(type = "string")), MaxResults = structure(logical(0), tags = list(type = "integer")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$describe_app_license_usage_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(AppLicenseUsages = structure(list(structure(list(UserArn = structure(logical(0), tags = list(type = "string")), BillingPeriod = structure(logical(0), tags = list(type = "string")), OwnerAWSAccountId = structure(logical(0), tags = list(type = "string")), SubscriptionFirstUsedDate = structure(logical(0), tags = list(type = "timestamp")), SubscriptionLastUsedDate = structure(logical(0), tags = list(type = "timestamp")), LicenseType = structure(logical(0), tags = list(type = "string")), UserId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$describe_application_fleet_associations_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(FleetName = structure(logical(0), tags = list(type = "string")), ApplicationArn = structure(logical(0), tags = list(type = "string")), MaxResults = structure(logical(0), tags = list(type = "integer")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$describe_application_fleet_associations_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ApplicationFleetAssociations = structure(list(structure(list(FleetName = structure(logical(0), tags = list(type = "string")), ApplicationArn = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$describe_applications_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Arns = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), NextToken = structure(logical(0), tags = list(type = "string")), MaxResults = structure(logical(0), tags = list(type = "integer"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$describe_applications_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Applications = structure(list(structure(list(Name = structure(logical(0), tags = list(type = "string")), DisplayName = structure(logical(0), tags = list(type = "string")), IconURL = structure(logical(0), tags = list(type = "string")), LaunchPath = structure(logical(0), tags = list(type = "string")), LaunchParameters = structure(logical(0), tags = list(type = "string")), Enabled = structure(logical(0), tags = list(type = "boolean")), Metadata = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map")), WorkingDirectory = structure(logical(0), tags = list(type = "string")), Description = structure(logical(0), tags = list(type = "string")), Arn = structure(logical(0), tags = list(type = "string")), AppBlockArn = structure(logical(0), tags = list(type = "string")), IconS3Location = structure(list(S3Bucket = structure(logical(0), tags = list(type = "string")), S3Key = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), Platforms = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), InstanceFamilies = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), CreatedTime = structure(logical(0), tags = list(type = "timestamp"))), tags = list(type = "structure"))), tags = list(type = "list")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$describe_directory_configs_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(DirectoryNames = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), MaxResults = structure(logical(0), tags = list(type = "integer")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$describe_directory_configs_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(DirectoryConfigs = structure(list(structure(list(DirectoryName = structure(logical(0), tags = list(type = "string")), OrganizationalUnitDistinguishedNames = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), ServiceAccountCredentials = structure(list(AccountName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), AccountPassword = structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "structure")), CreatedTime = structure(logical(0), tags = list(type = "timestamp")), CertificateBasedAuthProperties = structure(list(Status = structure(logical(0), tags = list(type = "string")), CertificateAuthorityArn = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure"))), tags = list(type = "list")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$describe_entitlements_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Name = structure(logical(0), tags = list(type = "string")), StackName = structure(logical(0), tags = list(type = "string")), NextToken = structure(logical(0), tags = list(type = "string")), MaxResults = structure(logical(0), tags = list(type = "integer"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$describe_entitlements_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Entitlements = structure(list(structure(list(Name = structure(logical(0), tags = list(type = "string")), StackName = structure(logical(0), tags = list(type = "string")), Description = structure(logical(0), tags = list(type = "string")), AppVisibility = structure(logical(0), tags = list(type = "string")), Attributes = structure(list(structure(list(Name = structure(logical(0), tags = list(type = "string")), Value = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), CreatedTime = structure(logical(0), tags = list(type = "timestamp")), LastModifiedTime = structure(logical(0), tags = list(type = "timestamp"))), tags = list(type = "structure"))), tags = list(type = "list")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$describe_fleets_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Names = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$describe_fleets_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Fleets = structure(list(structure(list(Arn = structure(logical(0), tags = list(type = "string")), Name = structure(logical(0), tags = list(type = "string")), DisplayName = structure(logical(0), tags = list(type = "string")), Description = structure(logical(0), tags = list(type = "string")), ImageName = structure(logical(0), tags = list(type = "string")), ImageArn = structure(logical(0), tags = list(type = "string")), InstanceType = structure(logical(0), tags = list(type = "string")), FleetType = structure(logical(0), tags = list(type = "string")), ComputeCapacityStatus = structure(list(Desired = structure(logical(0), tags = list(type = "integer")), Running = structure(logical(0), tags = list(type = "integer")), InUse = structure(logical(0), tags = list(type = "integer")), Available = structure(logical(0), tags = list(type = "integer")), DesiredUserSessions = structure(logical(0), tags = list(type = "integer")), AvailableUserSessions = structure(logical(0), tags = list(type = "integer")), ActiveUserSessions = structure(logical(0), tags = list(type = "integer")), ActualUserSessions = structure(logical(0), tags = list(type = "integer")), Draining = structure(logical(0), tags = list(type = "integer")), DrainModeActiveUserSessions = structure(logical(0), tags = list(type = "integer")), DrainModeUnusedUserSessions = structure(logical(0), tags = list(type = "integer"))), tags = list(type = "structure")), MaxUserDurationInSeconds = structure(logical(0), tags = list(type = "integer")), DisconnectTimeoutInSeconds = structure(logical(0), tags = list(type = "integer")), State = structure(logical(0), tags = list(type = "string")), VpcConfig = structure(list(SubnetIds = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), SecurityGroupIds = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure")), CreatedTime = structure(logical(0), tags = list(type = "timestamp")), FleetErrors = structure(list(structure(list(ErrorCode = structure(logical(0), tags = list(type = "string")), ErrorMessage = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), EnableDefaultInternetAccess = structure(logical(0), tags = list(type = "boolean")), DomainJoinInfo = structure(list(DirectoryName = structure(logical(0), tags = list(type = "string")), OrganizationalUnitDistinguishedName = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), IdleDisconnectTimeoutInSeconds = structure(logical(0), tags = list(type = "integer")), IamRoleArn = structure(logical(0), tags = list(type = "string")), StreamView = structure(logical(0), tags = list(type = "string")), Platform = structure(logical(0), tags = list(type = "string")), MaxConcurrentSessions = structure(logical(0), tags = list(type = "integer")), UsbDeviceFilterStrings = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), SessionScriptS3Location = structure(list(S3Bucket = structure(logical(0), tags = list(type = "string")), S3Key = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), MaxSessionsPerInstance = structure(logical(0), tags = list(type = "integer")), RootVolumeConfig = structure(list(VolumeSizeInGb = structure(logical(0), tags = list(type = "integer"))), tags = list(type = "structure")), DisableIMDSV1 = structure(logical(0), tags = list(type = "boolean"))), tags = list(type = "structure"))), tags = list(type = "list")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$describe_image_builders_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Names = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), MaxResults = structure(logical(0), tags = list(type = "integer")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$describe_image_builders_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ImageBuilders = structure(list(structure(list(Name = structure(logical(0), tags = list(type = "string")), Arn = structure(logical(0), tags = list(type = "string")), ImageArn = structure(logical(0), tags = list(type = "string")), Description = structure(logical(0), tags = list(type = "string")), DisplayName = structure(logical(0), tags = list(type = "string")), VpcConfig = structure(list(SubnetIds = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), SecurityGroupIds = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure")), InstanceType = structure(logical(0), tags = list(type = "string")), Platform = structure(logical(0), tags = list(type = "string")), IamRoleArn = structure(logical(0), tags = list(type = "string")), State = structure(logical(0), tags = list(type = "string")), StateChangeReason = structure(list(Code = structure(logical(0), tags = list(type = "string")), Message = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), CreatedTime = structure(logical(0), tags = list(type = "timestamp")), EnableDefaultInternetAccess = structure(logical(0), tags = list(type = "boolean")), DomainJoinInfo = structure(list(DirectoryName = structure(logical(0), tags = list(type = "string")), OrganizationalUnitDistinguishedName = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), NetworkAccessConfiguration = structure(list(EniPrivateIpAddress = structure(logical(0), tags = list(type = "string")), EniIpv6Addresses = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), EniId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), ImageBuilderErrors = structure(list(structure(list(ErrorCode = structure(logical(0), tags = list(type = "string")), ErrorMessage = structure(logical(0), tags = list(type = "string")), ErrorTimestamp = structure(logical(0), tags = list(type = "timestamp"))), tags = list(type = "structure"))), tags = list(type = "list")), AppstreamAgentVersion = structure(logical(0), tags = list(type = "string")), AccessEndpoints = structure(list(structure(list(EndpointType = structure(logical(0), tags = list(type = "string")), VpceId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), RootVolumeConfig = structure(list(VolumeSizeInGb = structure(logical(0), tags = list(type = "integer"))), tags = list(type = "structure")), LatestAppstreamAgentVersion = structure(logical(0), tags = list(type = "string")), DisableIMDSV1 = structure(logical(0), tags = list(type = "boolean"))), tags = list(type = "structure"))), tags = list(type = "list")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$describe_image_permissions_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Name = structure(logical(0), tags = list(type = "string")), MaxResults = structure(logical(0), tags = list(type = "integer", box = TRUE)), SharedAwsAccountIds = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$describe_image_permissions_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Name = structure(logical(0), tags = list(type = "string")), SharedImagePermissionsList = structure(list(structure(list(sharedAccountId = structure(logical(0), tags = list(type = "string")), imagePermissions = structure(list(allowFleet = structure(logical(0), tags = list(type = "boolean")), allowImageBuilder = structure(logical(0), tags = list(type = "boolean"))), tags = list(type = "structure"))), tags = list(type = "structure"))), tags = list(type = "list")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$describe_images_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Names = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), Arns = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), Type = structure(logical(0), tags = list(type = "string")), NextToken = structure(logical(0), tags = list(type = "string")), MaxResults = structure(logical(0), tags = list(type = "integer", box = TRUE))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$describe_images_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Images = structure(list(structure(list(Name = structure(logical(0), tags = list(type = "string")), Arn = structure(logical(0), tags = list(type = "string")), BaseImageArn = structure(logical(0), tags = list(type = "string")), DisplayName = structure(logical(0), tags = list(type = "string")), State = structure(logical(0), tags = list(type = "string")), Visibility = structure(logical(0), tags = list(type = "string")), ImageBuilderSupported = structure(logical(0), tags = list(type = "boolean")), ImageBuilderName = structure(logical(0), tags = list(type = "string")), Platform = structure(logical(0), tags = list(type = "string")), Description = structure(logical(0), tags = list(type = "string")), StateChangeReason = structure(list(Code = structure(logical(0), tags = list(type = "string")), Message = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), Applications = structure(list(structure(list(Name = structure(logical(0), tags = list(type = "string")), DisplayName = structure(logical(0), tags = list(type = "string")), IconURL = structure(logical(0), tags = list(type = "string")), LaunchPath = structure(logical(0), tags = list(type = "string")), LaunchParameters = structure(logical(0), tags = list(type = "string")), Enabled = structure(logical(0), tags = list(type = "boolean")), Metadata = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map")), WorkingDirectory = structure(logical(0), tags = list(type = "string")), Description = structure(logical(0), tags = list(type = "string")), Arn = structure(logical(0), tags = list(type = "string")), AppBlockArn = structure(logical(0), tags = list(type = "string")), IconS3Location = structure(list(S3Bucket = structure(logical(0), tags = list(type = "string")), S3Key = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), Platforms = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), InstanceFamilies = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), CreatedTime = structure(logical(0), tags = list(type = "timestamp"))), tags = list(type = "structure"))), tags = list(type = "list")), CreatedTime = structure(logical(0), tags = list(type = "timestamp")), PublicBaseImageReleasedDate = structure(logical(0), tags = list(type = "timestamp")), AppstreamAgentVersion = structure(logical(0), tags = list(type = "string")), ImagePermissions = structure(list(allowFleet = structure(logical(0), tags = list(type = "boolean")), allowImageBuilder = structure(logical(0), tags = list(type = "boolean"))), tags = list(type = "structure")), ImageErrors = structure(list(structure(list(ErrorCode = structure(logical(0), tags = list(type = "string")), ErrorMessage = structure(logical(0), tags = list(type = "string")), ErrorTimestamp = structure(logical(0), tags = list(type = "timestamp"))), tags = list(type = "structure"))), tags = list(type = "list")), LatestAppstreamAgentVersion = structure(logical(0), tags = list(type = "string")), SupportedInstanceFamilies = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), DynamicAppProvidersEnabled = structure(logical(0), tags = list(type = "string")), ImageSharedWithOthers = structure(logical(0), tags = list(type = "string")), ManagedSoftwareIncluded = structure(logical(0), tags = list(type = "boolean")), ImageType = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$describe_sessions_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(StackName = structure(logical(0), tags = list(type = "string")), FleetName = structure(logical(0), tags = list(type = "string")), UserId = structure(logical(0), tags = list(type = "string")), NextToken = structure(logical(0), tags = list(type = "string")), Limit = structure(logical(0), tags = list(type = "integer")), AuthenticationType = structure(logical(0), tags = list(type = "string")), InstanceId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$describe_sessions_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Sessions = structure(list(structure(list(Id = structure(logical(0), tags = list(type = "string")), UserId = structure(logical(0), tags = list(type = "string")), StackName = structure(logical(0), tags = list(type = "string")), FleetName = structure(logical(0), tags = list(type = "string")), State = structure(logical(0), tags = list(type = "string")), ConnectionState = structure(logical(0), tags = list(type = "string")), StartTime = structure(logical(0), tags = list(type = "timestamp")), MaxExpirationTime = structure(logical(0), tags = list(type = "timestamp")), AuthenticationType = structure(logical(0), tags = list(type = "string")), NetworkAccessConfiguration = structure(list(EniPrivateIpAddress = structure(logical(0), tags = list(type = "string")), EniIpv6Addresses = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), EniId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), InstanceId = structure(logical(0), tags = list(type = "string")), InstanceDrainStatus = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$describe_software_associations_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(AssociatedResource = structure(logical(0), tags = list(type = "string")), MaxResults = structure(logical(0), tags = list(type = "integer")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$describe_software_associations_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(AssociatedResource = structure(logical(0), tags = list(type = "string")), SoftwareAssociations = structure(list(structure(list(SoftwareName = structure(logical(0), tags = list(type = "string")), Status = structure(logical(0), tags = list(type = "string")), DeploymentError = structure(list(structure(list(ErrorCode = structure(logical(0), tags = list(type = "string")), ErrorMessage = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure"))), tags = list(type = "list")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$describe_stacks_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Names = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$describe_stacks_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Stacks = structure(list(structure(list(Arn = structure(logical(0), tags = list(type = "string")), Name = structure(logical(0), tags = list(type = "string")), Description = structure(logical(0), tags = list(type = "string")), DisplayName = structure(logical(0), tags = list(type = "string")), CreatedTime = structure(logical(0), tags = list(type = "timestamp")), StorageConnectors = structure(list(structure(list(ConnectorType = structure(logical(0), tags = list(type = "string")), ResourceIdentifier = structure(logical(0), tags = list(type = "string")), Domains = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), DomainsRequireAdminConsent = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure"))), tags = list(type = "list")), RedirectURL = structure(logical(0), tags = list(type = "string")), FeedbackURL = structure(logical(0), tags = list(type = "string")), StackErrors = structure(list(structure(list(ErrorCode = structure(logical(0), tags = list(type = "string")), ErrorMessage = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), UserSettings = structure(list(structure(list(Action = structure(logical(0), tags = list(type = "string")), Permission = structure(logical(0), tags = list(type = "string")), MaximumLength = structure(logical(0), tags = list(type = "integer"))), tags = list(type = "structure"))), tags = list(type = "list")), ApplicationSettings = structure(list(Enabled = structure(logical(0), tags = list(type = "boolean")), SettingsGroup = structure(logical(0), tags = list(type = "string")), S3BucketName = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), AccessEndpoints = structure(list(structure(list(EndpointType = structure(logical(0), tags = list(type = "string")), VpceId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), EmbedHostDomains = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), StreamingExperienceSettings = structure(list(PreferredProtocol = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), ContentRedirection = structure(list(HostToClient = structure(list(Enabled = structure(logical(0), tags = list(type = "boolean")), AllowedUrls = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), DeniedUrls = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure"))), tags = list(type = "structure")), AgentAccessConfig = structure(list(Settings = structure(list(structure(list(AgentAction = structure(logical(0), tags = list(type = "string")), Permission = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), S3BucketArn = structure(logical(0), tags = list(type = "string")), ScreenshotsUploadEnabled = structure(logical(0), tags = list(type = "boolean")), ScreenResolution = structure(logical(0), tags = list(type = "string")), ScreenImageFormat = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure"))), tags = list(type = "list")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$describe_theme_for_stack_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(StackName = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$describe_theme_for_stack_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Theme = structure(list(StackName = structure(logical(0), tags = list(type = "string")), State = structure(logical(0), tags = list(type = "string")), ThemeTitleText = structure(logical(0), tags = list(type = "string")), ThemeStyling = structure(logical(0), tags = list(type = "string")), ThemeFooterLinks = structure(list(structure(list(DisplayName = structure(logical(0), tags = list(type = "string")), FooterLinkURL = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), ThemeOrganizationLogoURL = structure(logical(0), tags = list(type = "string")), ThemeFaviconURL = structure(logical(0), tags = list(type = "string")), CreatedTime = structure(logical(0), tags = list(type = "timestamp"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$describe_usage_report_subscriptions_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(MaxResults = structure(logical(0), tags = list(type = "integer")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$describe_usage_report_subscriptions_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(UsageReportSubscriptions = structure(list(structure(list(S3BucketName = structure(logical(0), tags = list(type = "string")), Schedule = structure(logical(0), tags = list(type = "string")), LastGeneratedReportDate = structure(logical(0), tags = list(type = "timestamp")), SubscriptionErrors = structure(list(structure(list(ErrorCode = structure(logical(0), tags = list(type = "string")), ErrorMessage = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure"))), tags = list(type = "list")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$describe_user_stack_associations_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(StackName = structure(logical(0), tags = list(type = "string")), UserName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), AuthenticationType = structure(logical(0), tags = list(type = "string")), MaxResults = structure(logical(0), tags = list(type = "integer", box = TRUE)), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$describe_user_stack_associations_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(UserStackAssociations = structure(list(structure(list(StackName = structure(logical(0), tags = list(type = "string")), UserName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), AuthenticationType = structure(logical(0), tags = list(type = "string")), SendEmailNotification = structure(logical(0), tags = list(type = "boolean"))), tags = list(type = "structure"))), tags = list(type = "list")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$describe_users_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(AuthenticationType = structure(logical(0), tags = list(type = "string")), MaxResults = structure(logical(0), tags = list(type = "integer")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$describe_users_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Users = structure(list(structure(list(Arn = structure(logical(0), tags = list(type = "string")), UserName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), Enabled = structure(logical(0), tags = list(type = "boolean")), Status = structure(logical(0), tags = list(type = "string")), FirstName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), LastName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), CreatedTime = structure(logical(0), tags = list(type = "timestamp")), AuthenticationType = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$disable_user_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(UserName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), AuthenticationType = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$disable_user_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$disassociate_app_block_builder_app_block_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(AppBlockArn = structure(logical(0), tags = list(type = "string")), AppBlockBuilderName = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$disassociate_app_block_builder_app_block_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$disassociate_application_fleet_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(FleetName = structure(logical(0), tags = list(type = "string")), ApplicationArn = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$disassociate_application_fleet_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$disassociate_application_from_entitlement_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(StackName = structure(logical(0), tags = list(type = "string")), EntitlementName = structure(logical(0), tags = list(type = "string")), ApplicationIdentifier = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$disassociate_application_from_entitlement_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$disassociate_fleet_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(FleetName = structure(logical(0), tags = list(type = "string")), StackName = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$disassociate_fleet_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$disassociate_software_from_image_builder_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ImageBuilderName = structure(logical(0), tags = list(type = "string")), SoftwareNames = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$disassociate_software_from_image_builder_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$drain_session_instance_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(SessionId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$drain_session_instance_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$enable_user_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(UserName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), AuthenticationType = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$enable_user_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$expire_session_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(SessionId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$expire_session_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$get_export_image_task_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(TaskId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$get_export_image_task_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ExportImageTask = structure(list(TaskId = structure(logical(0), tags = list(type = "string")), ImageArn = structure(logical(0), tags = list(type = "string")), AmiName = structure(logical(0), tags = list(type = "string")), CreatedDate = structure(logical(0), tags = list(type = "timestamp")), AmiDescription = structure(logical(0), tags = list(type = "string")), State = structure(logical(0), tags = list(type = "string")), AmiId = structure(logical(0), tags = list(type = "string")), TagSpecifications = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map")), ErrorDetails = structure(list(structure(list(ErrorCode = structure(logical(0), tags = list(type = "string")), ErrorMessage = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$list_associated_fleets_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(StackName = structure(logical(0), tags = list(type = "string")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$list_associated_fleets_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Names = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$list_associated_stacks_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(FleetName = structure(logical(0), tags = list(type = "string")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$list_associated_stacks_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Names = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$list_entitled_applications_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(StackName = structure(logical(0), tags = list(type = "string")), EntitlementName = structure(logical(0), tags = list(type = "string")), NextToken = structure(logical(0), tags = list(type = "string")), MaxResults = structure(logical(0), tags = list(type = "integer"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$list_entitled_applications_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(EntitledApplications = structure(list(structure(list(ApplicationIdentifier = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$list_export_image_tasks_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Filters = structure(list(structure(list(Name = structure(logical(0), tags = list(type = "string")), Values = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure"))), tags = list(type = "list")), MaxResults = structure(logical(0), tags = list(type = "integer", box = TRUE)), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$list_export_image_tasks_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ExportImageTasks = structure(list(structure(list(TaskId = structure(logical(0), tags = list(type = "string")), ImageArn = structure(logical(0), tags = list(type = "string")), AmiName = structure(logical(0), tags = list(type = "string")), CreatedDate = structure(logical(0), tags = list(type = "timestamp")), AmiDescription = structure(logical(0), tags = list(type = "string")), State = structure(logical(0), tags = list(type = "string")), AmiId = structure(logical(0), tags = list(type = "string")), TagSpecifications = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map")), ErrorDetails = structure(list(structure(list(ErrorCode = structure(logical(0), tags = list(type = "string")), ErrorMessage = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure"))), tags = list(type = "list")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$list_tags_for_resource_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ResourceArn = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$list_tags_for_resource_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Tags = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$start_app_block_builder_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Name = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$start_app_block_builder_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(AppBlockBuilder = structure(list(Arn = structure(logical(0), tags = list(type = "string")), Name = structure(logical(0), tags = list(type = "string")), DisplayName = structure(logical(0), tags = list(type = "string")), Description = structure(logical(0), tags = list(type = "string")), Platform = structure(logical(0), tags = list(type = "string")), InstanceType = structure(logical(0), tags = list(type = "string")), EnableDefaultInternetAccess = structure(logical(0), tags = list(type = "boolean")), IamRoleArn = structure(logical(0), tags = list(type = "string")), VpcConfig = structure(list(SubnetIds = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), SecurityGroupIds = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure")), State = structure(logical(0), tags = list(type = "string")), CreatedTime = structure(logical(0), tags = list(type = "timestamp")), AppBlockBuilderErrors = structure(list(structure(list(ErrorCode = structure(logical(0), tags = list(type = "string")), ErrorMessage = structure(logical(0), tags = list(type = "string")), ErrorTimestamp = structure(logical(0), tags = list(type = "timestamp"))), tags = list(type = "structure"))), tags = list(type = "list")), StateChangeReason = structure(list(Code = structure(logical(0), tags = list(type = "string")), Message = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), AccessEndpoints = structure(list(structure(list(EndpointType = structure(logical(0), tags = list(type = "string")), VpceId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), DisableIMDSV1 = structure(logical(0), tags = list(type = "boolean"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$start_fleet_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Name = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$start_fleet_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$start_image_builder_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Name = structure(logical(0), tags = list(type = "string")), AppstreamAgentVersion = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$start_image_builder_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ImageBuilder = structure(list(Name = structure(logical(0), tags = list(type = "string")), Arn = structure(logical(0), tags = list(type = "string")), ImageArn = structure(logical(0), tags = list(type = "string")), Description = structure(logical(0), tags = list(type = "string")), DisplayName = structure(logical(0), tags = list(type = "string")), VpcConfig = structure(list(SubnetIds = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), SecurityGroupIds = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure")), InstanceType = structure(logical(0), tags = list(type = "string")), Platform = structure(logical(0), tags = list(type = "string")), IamRoleArn = structure(logical(0), tags = list(type = "string")), State = structure(logical(0), tags = list(type = "string")), StateChangeReason = structure(list(Code = structure(logical(0), tags = list(type = "string")), Message = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), CreatedTime = structure(logical(0), tags = list(type = "timestamp")), EnableDefaultInternetAccess = structure(logical(0), tags = list(type = "boolean")), DomainJoinInfo = structure(list(DirectoryName = structure(logical(0), tags = list(type = "string")), OrganizationalUnitDistinguishedName = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), NetworkAccessConfiguration = structure(list(EniPrivateIpAddress = structure(logical(0), tags = list(type = "string")), EniIpv6Addresses = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), EniId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), ImageBuilderErrors = structure(list(structure(list(ErrorCode = structure(logical(0), tags = list(type = "string")), ErrorMessage = structure(logical(0), tags = list(type = "string")), ErrorTimestamp = structure(logical(0), tags = list(type = "timestamp"))), tags = list(type = "structure"))), tags = list(type = "list")), AppstreamAgentVersion = structure(logical(0), tags = list(type = "string")), AccessEndpoints = structure(list(structure(list(EndpointType = structure(logical(0), tags = list(type = "string")), VpceId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), RootVolumeConfig = structure(list(VolumeSizeInGb = structure(logical(0), tags = list(type = "integer"))), tags = list(type = "structure")), LatestAppstreamAgentVersion = structure(logical(0), tags = list(type = "string")), DisableIMDSV1 = structure(logical(0), tags = list(type = "boolean"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$start_software_deployment_to_image_builder_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ImageBuilderName = structure(logical(0), tags = list(type = "string")), RetryFailedDeployments = structure(logical(0), tags = list(type = "boolean"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$start_software_deployment_to_image_builder_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$stop_app_block_builder_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Name = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$stop_app_block_builder_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(AppBlockBuilder = structure(list(Arn = structure(logical(0), tags = list(type = "string")), Name = structure(logical(0), tags = list(type = "string")), DisplayName = structure(logical(0), tags = list(type = "string")), Description = structure(logical(0), tags = list(type = "string")), Platform = structure(logical(0), tags = list(type = "string")), InstanceType = structure(logical(0), tags = list(type = "string")), EnableDefaultInternetAccess = structure(logical(0), tags = list(type = "boolean")), IamRoleArn = structure(logical(0), tags = list(type = "string")), VpcConfig = structure(list(SubnetIds = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), SecurityGroupIds = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure")), State = structure(logical(0), tags = list(type = "string")), CreatedTime = structure(logical(0), tags = list(type = "timestamp")), AppBlockBuilderErrors = structure(list(structure(list(ErrorCode = structure(logical(0), tags = list(type = "string")), ErrorMessage = structure(logical(0), tags = list(type = "string")), ErrorTimestamp = structure(logical(0), tags = list(type = "timestamp"))), tags = list(type = "structure"))), tags = list(type = "list")), StateChangeReason = structure(list(Code = structure(logical(0), tags = list(type = "string")), Message = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), AccessEndpoints = structure(list(structure(list(EndpointType = structure(logical(0), tags = list(type = "string")), VpceId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), DisableIMDSV1 = structure(logical(0), tags = list(type = "boolean"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$stop_fleet_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Name = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$stop_fleet_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$stop_image_builder_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Name = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$stop_image_builder_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ImageBuilder = structure(list(Name = structure(logical(0), tags = list(type = "string")), Arn = structure(logical(0), tags = list(type = "string")), ImageArn = structure(logical(0), tags = list(type = "string")), Description = structure(logical(0), tags = list(type = "string")), DisplayName = structure(logical(0), tags = list(type = "string")), VpcConfig = structure(list(SubnetIds = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), SecurityGroupIds = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure")), InstanceType = structure(logical(0), tags = list(type = "string")), Platform = structure(logical(0), tags = list(type = "string")), IamRoleArn = structure(logical(0), tags = list(type = "string")), State = structure(logical(0), tags = list(type = "string")), StateChangeReason = structure(list(Code = structure(logical(0), tags = list(type = "string")), Message = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), CreatedTime = structure(logical(0), tags = list(type = "timestamp")), EnableDefaultInternetAccess = structure(logical(0), tags = list(type = "boolean")), DomainJoinInfo = structure(list(DirectoryName = structure(logical(0), tags = list(type = "string")), OrganizationalUnitDistinguishedName = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), NetworkAccessConfiguration = structure(list(EniPrivateIpAddress = structure(logical(0), tags = list(type = "string")), EniIpv6Addresses = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), EniId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), ImageBuilderErrors = structure(list(structure(list(ErrorCode = structure(logical(0), tags = list(type = "string")), ErrorMessage = structure(logical(0), tags = list(type = "string")), ErrorTimestamp = structure(logical(0), tags = list(type = "timestamp"))), tags = list(type = "structure"))), tags = list(type = "list")), AppstreamAgentVersion = structure(logical(0), tags = list(type = "string")), AccessEndpoints = structure(list(structure(list(EndpointType = structure(logical(0), tags = list(type = "string")), VpceId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), RootVolumeConfig = structure(list(VolumeSizeInGb = structure(logical(0), tags = list(type = "integer"))), tags = list(type = "structure")), LatestAppstreamAgentVersion = structure(logical(0), tags = list(type = "string")), DisableIMDSV1 = structure(logical(0), tags = list(type = "boolean"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$tag_resource_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ResourceArn = structure(logical(0), tags = list(type = "string")), Tags = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$tag_resource_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$untag_resource_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ResourceArn = structure(logical(0), tags = list(type = "string")), TagKeys = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$untag_resource_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$update_app_block_builder_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Name = structure(logical(0), tags = list(type = "string")), Description = structure(logical(0), tags = list(type = "string")), DisplayName = structure(logical(0), tags = list(type = "string")), Platform = structure(logical(0), tags = list(type = "string")), InstanceType = structure(logical(0), tags = list(type = "string")), VpcConfig = structure(list(SubnetIds = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), SecurityGroupIds = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure")), EnableDefaultInternetAccess = structure(logical(0), tags = list(type = "boolean")), IamRoleArn = structure(logical(0), tags = list(type = "string")), AccessEndpoints = structure(list(structure(list(EndpointType = structure(logical(0), tags = list(type = "string")), VpceId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), AttributesToDelete = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), DisableIMDSV1 = structure(logical(0), tags = list(type = "boolean"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$update_app_block_builder_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(AppBlockBuilder = structure(list(Arn = structure(logical(0), tags = list(type = "string")), Name = structure(logical(0), tags = list(type = "string")), DisplayName = structure(logical(0), tags = list(type = "string")), Description = structure(logical(0), tags = list(type = "string")), Platform = structure(logical(0), tags = list(type = "string")), InstanceType = structure(logical(0), tags = list(type = "string")), EnableDefaultInternetAccess = structure(logical(0), tags = list(type = "boolean")), IamRoleArn = structure(logical(0), tags = list(type = "string")), VpcConfig = structure(list(SubnetIds = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), SecurityGroupIds = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure")), State = structure(logical(0), tags = list(type = "string")), CreatedTime = structure(logical(0), tags = list(type = "timestamp")), AppBlockBuilderErrors = structure(list(structure(list(ErrorCode = structure(logical(0), tags = list(type = "string")), ErrorMessage = structure(logical(0), tags = list(type = "string")), ErrorTimestamp = structure(logical(0), tags = list(type = "timestamp"))), tags = list(type = "structure"))), tags = list(type = "list")), StateChangeReason = structure(list(Code = structure(logical(0), tags = list(type = "string")), Message = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), AccessEndpoints = structure(list(structure(list(EndpointType = structure(logical(0), tags = list(type = "string")), VpceId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), DisableIMDSV1 = structure(logical(0), tags = list(type = "boolean"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$update_application_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Name = structure(logical(0), tags = list(type = "string")), DisplayName = structure(logical(0), tags = list(type = "string")), Description = structure(logical(0), tags = list(type = "string")), IconS3Location = structure(list(S3Bucket = structure(logical(0), tags = list(type = "string")), S3Key = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), LaunchPath = structure(logical(0), tags = list(type = "string")), WorkingDirectory = structure(logical(0), tags = list(type = "string")), LaunchParameters = structure(logical(0), tags = list(type = "string")), AppBlockArn = structure(logical(0), tags = list(type = "string")), AttributesToDelete = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$update_application_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Application = structure(list(Name = structure(logical(0), tags = list(type = "string")), DisplayName = structure(logical(0), tags = list(type = "string")), IconURL = structure(logical(0), tags = list(type = "string")), LaunchPath = structure(logical(0), tags = list(type = "string")), LaunchParameters = structure(logical(0), tags = list(type = "string")), Enabled = structure(logical(0), tags = list(type = "boolean")), Metadata = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map")), WorkingDirectory = structure(logical(0), tags = list(type = "string")), Description = structure(logical(0), tags = list(type = "string")), Arn = structure(logical(0), tags = list(type = "string")), AppBlockArn = structure(logical(0), tags = list(type = "string")), IconS3Location = structure(list(S3Bucket = structure(logical(0), tags = list(type = "string")), S3Key = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), Platforms = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), InstanceFamilies = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), CreatedTime = structure(logical(0), tags = list(type = "timestamp"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$update_directory_config_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(DirectoryName = structure(logical(0), tags = list(type = "string")), OrganizationalUnitDistinguishedNames = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), ServiceAccountCredentials = structure(list(AccountName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), AccountPassword = structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "structure")), CertificateBasedAuthProperties = structure(list(Status = structure(logical(0), tags = list(type = "string")), CertificateAuthorityArn = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$update_directory_config_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(DirectoryConfig = structure(list(DirectoryName = structure(logical(0), tags = list(type = "string")), OrganizationalUnitDistinguishedNames = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), ServiceAccountCredentials = structure(list(AccountName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), AccountPassword = structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "structure")), CreatedTime = structure(logical(0), tags = list(type = "timestamp")), CertificateBasedAuthProperties = structure(list(Status = structure(logical(0), tags = list(type = "string")), CertificateAuthorityArn = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$update_entitlement_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Name = structure(logical(0), tags = list(type = "string")), StackName = structure(logical(0), tags = list(type = "string")), Description = structure(logical(0), tags = list(type = "string")), AppVisibility = structure(logical(0), tags = list(type = "string")), Attributes = structure(list(structure(list(Name = structure(logical(0), tags = list(type = "string")), Value = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$update_entitlement_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Entitlement = structure(list(Name = structure(logical(0), tags = list(type = "string")), StackName = structure(logical(0), tags = list(type = "string")), Description = structure(logical(0), tags = list(type = "string")), AppVisibility = structure(logical(0), tags = list(type = "string")), Attributes = structure(list(structure(list(Name = structure(logical(0), tags = list(type = "string")), Value = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), CreatedTime = structure(logical(0), tags = list(type = "timestamp")), LastModifiedTime = structure(logical(0), tags = list(type = "timestamp"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$update_fleet_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ImageName = structure(logical(0), tags = list(type = "string")), ImageArn = structure(logical(0), tags = list(type = "string")), Name = structure(logical(0), tags = list(type = "string")), InstanceType = structure(logical(0), tags = list(type = "string")), ComputeCapacity = structure(list(DesiredInstances = structure(logical(0), tags = list(type = "integer")), DesiredSessions = structure(logical(0), tags = list(type = "integer"))), tags = list(type = "structure")), VpcConfig = structure(list(SubnetIds = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), SecurityGroupIds = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure")), MaxUserDurationInSeconds = structure(logical(0), tags = list(type = "integer")), DisconnectTimeoutInSeconds = structure(logical(0), tags = list(type = "integer")), DeleteVpcConfig = structure(logical(0), tags = list(deprecated = TRUE, type = "boolean")), Description = structure(logical(0), tags = list(type = "string")), DisplayName = structure(logical(0), tags = list(type = "string")), EnableDefaultInternetAccess = structure(logical(0), tags = list(type = "boolean")), DomainJoinInfo = structure(list(DirectoryName = structure(logical(0), tags = list(type = "string")), OrganizationalUnitDistinguishedName = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), IdleDisconnectTimeoutInSeconds = structure(logical(0), tags = list(type = "integer")), AttributesToDelete = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), IamRoleArn = structure(logical(0), tags = list(type = "string")), StreamView = structure(logical(0), tags = list(type = "string")), Platform = structure(logical(0), tags = list(type = "string")), MaxConcurrentSessions = structure(logical(0), tags = list(type = "integer")), UsbDeviceFilterStrings = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), SessionScriptS3Location = structure(list(S3Bucket = structure(logical(0), tags = list(type = "string")), S3Key = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), MaxSessionsPerInstance = structure(logical(0), tags = list(type = "integer")), RootVolumeConfig = structure(list(VolumeSizeInGb = structure(logical(0), tags = list(type = "integer"))), tags = list(type = "structure")), DisableIMDSV1 = structure(logical(0), tags = list(type = "boolean"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$update_fleet_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Fleet = structure(list(Arn = structure(logical(0), tags = list(type = "string")), Name = structure(logical(0), tags = list(type = "string")), DisplayName = structure(logical(0), tags = list(type = "string")), Description = structure(logical(0), tags = list(type = "string")), ImageName = structure(logical(0), tags = list(type = "string")), ImageArn = structure(logical(0), tags = list(type = "string")), InstanceType = structure(logical(0), tags = list(type = "string")), FleetType = structure(logical(0), tags = list(type = "string")), ComputeCapacityStatus = structure(list(Desired = structure(logical(0), tags = list(type = "integer")), Running = structure(logical(0), tags = list(type = "integer")), InUse = structure(logical(0), tags = list(type = "integer")), Available = structure(logical(0), tags = list(type = "integer")), DesiredUserSessions = structure(logical(0), tags = list(type = "integer")), AvailableUserSessions = structure(logical(0), tags = list(type = "integer")), ActiveUserSessions = structure(logical(0), tags = list(type = "integer")), ActualUserSessions = structure(logical(0), tags = list(type = "integer")), Draining = structure(logical(0), tags = list(type = "integer")), DrainModeActiveUserSessions = structure(logical(0), tags = list(type = "integer")), DrainModeUnusedUserSessions = structure(logical(0), tags = list(type = "integer"))), tags = list(type = "structure")), MaxUserDurationInSeconds = structure(logical(0), tags = list(type = "integer")), DisconnectTimeoutInSeconds = structure(logical(0), tags = list(type = "integer")), State = structure(logical(0), tags = list(type = "string")), VpcConfig = structure(list(SubnetIds = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), SecurityGroupIds = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure")), CreatedTime = structure(logical(0), tags = list(type = "timestamp")), FleetErrors = structure(list(structure(list(ErrorCode = structure(logical(0), tags = list(type = "string")), ErrorMessage = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), EnableDefaultInternetAccess = structure(logical(0), tags = list(type = "boolean")), DomainJoinInfo = structure(list(DirectoryName = structure(logical(0), tags = list(type = "string")), OrganizationalUnitDistinguishedName = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), IdleDisconnectTimeoutInSeconds = structure(logical(0), tags = list(type = "integer")), IamRoleArn = structure(logical(0), tags = list(type = "string")), StreamView = structure(logical(0), tags = list(type = "string")), Platform = structure(logical(0), tags = list(type = "string")), MaxConcurrentSessions = structure(logical(0), tags = list(type = "integer")), UsbDeviceFilterStrings = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), SessionScriptS3Location = structure(list(S3Bucket = structure(logical(0), tags = list(type = "string")), S3Key = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), MaxSessionsPerInstance = structure(logical(0), tags = list(type = "integer")), RootVolumeConfig = structure(list(VolumeSizeInGb = structure(logical(0), tags = list(type = "integer"))), tags = list(type = "structure")), DisableIMDSV1 = structure(logical(0), tags = list(type = "boolean"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$update_image_permissions_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Name = structure(logical(0), tags = list(type = "string")), SharedAccountId = structure(logical(0), tags = list(type = "string")), ImagePermissions = structure(list(allowFleet = structure(logical(0), tags = list(type = "boolean")), allowImageBuilder = structure(logical(0), tags = list(type = "boolean"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$update_image_permissions_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$update_stack_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(DisplayName = structure(logical(0), tags = list(type = "string")), Description = structure(logical(0), tags = list(type = "string")), Name = structure(logical(0), tags = list(type = "string")), StorageConnectors = structure(list(structure(list(ConnectorType = structure(logical(0), tags = list(type = "string")), ResourceIdentifier = structure(logical(0), tags = list(type = "string")), Domains = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), DomainsRequireAdminConsent = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure"))), tags = list(type = "list")), DeleteStorageConnectors = structure(logical(0), tags = list(deprecated = TRUE, type = "boolean")), RedirectURL = structure(logical(0), tags = list(type = "string")), FeedbackURL = structure(logical(0), tags = list(type = "string")), AttributesToDelete = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), UserSettings = structure(list(structure(list(Action = structure(logical(0), tags = list(type = "string")), Permission = structure(logical(0), tags = list(type = "string")), MaximumLength = structure(logical(0), tags = list(type = "integer"))), tags = list(type = "structure"))), tags = list(type = "list")), ApplicationSettings = structure(list(Enabled = structure(logical(0), tags = list(type = "boolean")), SettingsGroup = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), AccessEndpoints = structure(list(structure(list(EndpointType = structure(logical(0), tags = list(type = "string")), VpceId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), EmbedHostDomains = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), StreamingExperienceSettings = structure(list(PreferredProtocol = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), ContentRedirection = structure(list(HostToClient = structure(list(Enabled = structure(logical(0), tags = list(type = "boolean")), AllowedUrls = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), DeniedUrls = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure"))), tags = list(type = "structure")), AgentAccessConfig = structure(list(Settings = structure(list(structure(list(AgentAction = structure(logical(0), tags = list(type = "string")), Permission = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), S3BucketArn = structure(logical(0), tags = list(type = "string")), ScreenshotsUploadEnabled = structure(logical(0), tags = list(type = "boolean")), ScreenResolution = structure(logical(0), tags = list(type = "string")), ScreenImageFormat = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$update_stack_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Stack = structure(list(Arn = structure(logical(0), tags = list(type = "string")), Name = structure(logical(0), tags = list(type = "string")), Description = structure(logical(0), tags = list(type = "string")), DisplayName = structure(logical(0), tags = list(type = "string")), CreatedTime = structure(logical(0), tags = list(type = "timestamp")), StorageConnectors = structure(list(structure(list(ConnectorType = structure(logical(0), tags = list(type = "string")), ResourceIdentifier = structure(logical(0), tags = list(type = "string")), Domains = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), DomainsRequireAdminConsent = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure"))), tags = list(type = "list")), RedirectURL = structure(logical(0), tags = list(type = "string")), FeedbackURL = structure(logical(0), tags = list(type = "string")), StackErrors = structure(list(structure(list(ErrorCode = structure(logical(0), tags = list(type = "string")), ErrorMessage = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), UserSettings = structure(list(structure(list(Action = structure(logical(0), tags = list(type = "string")), Permission = structure(logical(0), tags = list(type = "string")), MaximumLength = structure(logical(0), tags = list(type = "integer"))), tags = list(type = "structure"))), tags = list(type = "list")), ApplicationSettings = structure(list(Enabled = structure(logical(0), tags = list(type = "boolean")), SettingsGroup = structure(logical(0), tags = list(type = "string")), S3BucketName = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), AccessEndpoints = structure(list(structure(list(EndpointType = structure(logical(0), tags = list(type = "string")), VpceId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), EmbedHostDomains = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), StreamingExperienceSettings = structure(list(PreferredProtocol = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), ContentRedirection = structure(list(HostToClient = structure(list(Enabled = structure(logical(0), tags = list(type = "boolean")), AllowedUrls = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), DeniedUrls = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure"))), tags = list(type = "structure")), AgentAccessConfig = structure(list(Settings = structure(list(structure(list(AgentAction = structure(logical(0), tags = list(type = "string")), Permission = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), S3BucketArn = structure(logical(0), tags = list(type = "string")), ScreenshotsUploadEnabled = structure(logical(0), tags = list(type = "boolean")), ScreenResolution = structure(logical(0), tags = list(type = "string")), ScreenImageFormat = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$update_theme_for_stack_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(StackName = structure(logical(0), tags = list(type = "string")), FooterLinks = structure(list(structure(list(DisplayName = structure(logical(0), tags = list(type = "string")), FooterLinkURL = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), TitleText = structure(logical(0), tags = list(type = "string")), ThemeStyling = structure(logical(0), tags = list(type = "string")), OrganizationLogoS3Location = structure(list(S3Bucket = structure(logical(0), tags = list(type = "string")), S3Key = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), FaviconS3Location = structure(list(S3Bucket = structure(logical(0), tags = list(type = "string")), S3Key = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), State = structure(logical(0), tags = list(type = "string")), AttributesToDelete = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.appstream$update_theme_for_stack_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Theme = structure(list(StackName = structure(logical(0), tags = list(type = "string")), State = structure(logical(0), tags = list(type = "string")), ThemeTitleText = structure(logical(0), tags = list(type = "string")), ThemeStyling = structure(logical(0), tags = list(type = "string")), ThemeFooterLinks = structure(list(structure(list(DisplayName = structure(logical(0), tags = list(type = "string")), FooterLinkURL = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), ThemeOrganizationLogoURL = structure(logical(0), tags = list(type = "string")), ThemeFaviconURL = structure(logical(0), tags = list(type = "string")), CreatedTime = structure(logical(0), tags = list(type = "timestamp"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

# This file is generated by make.paws. Please do not edit here.
#' @importFrom paws.common populate
#' @include workspacesweb_service.R
NULL

.workspacesweb$associate_browser_settings_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(portalArn = structure(logical(0), tags = list(location = "uri", locationName = "portalArn", type = "string")), browserSettingsArn = structure(logical(0), tags = list(location = "querystring", locationName = "browserSettingsArn", type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$associate_browser_settings_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(portalArn = structure(logical(0), tags = list(type = "string")), browserSettingsArn = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$associate_data_protection_settings_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(portalArn = structure(logical(0), tags = list(location = "uri", locationName = "portalArn", type = "string")), dataProtectionSettingsArn = structure(logical(0), tags = list(location = "querystring", locationName = "dataProtectionSettingsArn", type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$associate_data_protection_settings_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(portalArn = structure(logical(0), tags = list(type = "string")), dataProtectionSettingsArn = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$associate_ip_access_settings_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(portalArn = structure(logical(0), tags = list(location = "uri", locationName = "portalArn", type = "string")), ipAccessSettingsArn = structure(logical(0), tags = list(location = "querystring", locationName = "ipAccessSettingsArn", type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$associate_ip_access_settings_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(portalArn = structure(logical(0), tags = list(type = "string")), ipAccessSettingsArn = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$associate_network_settings_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(portalArn = structure(logical(0), tags = list(location = "uri", locationName = "portalArn", type = "string")), networkSettingsArn = structure(logical(0), tags = list(location = "querystring", locationName = "networkSettingsArn", type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$associate_network_settings_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(portalArn = structure(logical(0), tags = list(type = "string")), networkSettingsArn = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$associate_session_logger_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(portalArn = structure(logical(0), tags = list(location = "uri", locationName = "portalArn", type = "string")), sessionLoggerArn = structure(logical(0), tags = list(location = "querystring", locationName = "sessionLoggerArn", type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$associate_session_logger_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(portalArn = structure(logical(0), tags = list(type = "string")), sessionLoggerArn = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$associate_trust_store_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(portalArn = structure(logical(0), tags = list(location = "uri", locationName = "portalArn", type = "string")), trustStoreArn = structure(logical(0), tags = list(location = "querystring", locationName = "trustStoreArn", type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$associate_trust_store_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(portalArn = structure(logical(0), tags = list(type = "string")), trustStoreArn = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$associate_user_access_logging_settings_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(portalArn = structure(logical(0), tags = list(location = "uri", locationName = "portalArn", type = "string")), userAccessLoggingSettingsArn = structure(logical(0), tags = list(location = "querystring", locationName = "userAccessLoggingSettingsArn", type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$associate_user_access_logging_settings_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(portalArn = structure(logical(0), tags = list(type = "string")), userAccessLoggingSettingsArn = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$associate_user_settings_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(portalArn = structure(logical(0), tags = list(location = "uri", locationName = "portalArn", type = "string")), userSettingsArn = structure(logical(0), tags = list(location = "querystring", locationName = "userSettingsArn", type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$associate_user_settings_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(portalArn = structure(logical(0), tags = list(type = "string")), userSettingsArn = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$create_browser_settings_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(tags = structure(list(structure(list(Key = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), Value = structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "structure", sensitive = TRUE))), tags = list(type = "list")), customerManagedKey = structure(logical(0), tags = list(type = "string")), additionalEncryptionContext = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map")), browserPolicy = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), clientToken = structure(logical(0), tags = list(idempotencyToken = TRUE, type = "string")), webContentFilteringPolicy = structure(list(blockedCategories = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), allowedUrls = structure(list(structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "list")), blockedUrls = structure(list(structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "list"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$create_browser_settings_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(browserSettingsArn = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$create_data_protection_settings_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(displayName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), description = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), tags = structure(list(structure(list(Key = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), Value = structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "structure", sensitive = TRUE))), tags = list(type = "list")), customerManagedKey = structure(logical(0), tags = list(type = "string")), additionalEncryptionContext = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map")), inlineRedactionConfiguration = structure(list(inlineRedactionPatterns = structure(list(structure(list(builtInPatternId = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), customPattern = structure(list(patternName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), patternRegex = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), patternDescription = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), keywordRegex = structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "structure")), redactionPlaceHolder = structure(list(redactionPlaceHolderType = structure(logical(0), tags = list(type = "string")), redactionPlaceHolderText = structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "structure")), enforcedUrls = structure(list(structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "list")), exemptUrls = structure(list(structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "list")), confidenceLevel = structure(logical(0), tags = list(type = "integer", box = TRUE))), tags = list(type = "structure"))), tags = list(type = "list")), globalEnforcedUrls = structure(list(structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "list")), globalExemptUrls = structure(list(structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "list")), globalConfidenceLevel = structure(logical(0), tags = list(type = "integer", box = TRUE))), tags = list(type = "structure")), clientToken = structure(logical(0), tags = list(idempotencyToken = TRUE, type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$create_data_protection_settings_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(dataProtectionSettingsArn = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$create_identity_provider_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(portalArn = structure(logical(0), tags = list(type = "string")), identityProviderName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), identityProviderType = structure(logical(0), tags = list(type = "string")), identityProviderDetails = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map", sensitive = TRUE)), clientToken = structure(logical(0), tags = list(idempotencyToken = TRUE, type = "string")), tags = structure(list(structure(list(Key = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), Value = structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "structure", sensitive = TRUE))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$create_identity_provider_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(identityProviderArn = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$create_ip_access_settings_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(displayName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), description = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), tags = structure(list(structure(list(Key = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), Value = structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "structure", sensitive = TRUE))), tags = list(type = "list")), customerManagedKey = structure(logical(0), tags = list(type = "string")), additionalEncryptionContext = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map")), ipRules = structure(list(structure(list(ipRange = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), description = structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "structure"))), tags = list(type = "list", sensitive = TRUE)), clientToken = structure(logical(0), tags = list(idempotencyToken = TRUE, type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$create_ip_access_settings_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ipAccessSettingsArn = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$create_network_settings_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(vpcId = structure(logical(0), tags = list(type = "string")), subnetIds = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), securityGroupIds = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), tags = structure(list(structure(list(Key = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), Value = structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "structure", sensitive = TRUE))), tags = list(type = "list")), clientToken = structure(logical(0), tags = list(idempotencyToken = TRUE, type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$create_network_settings_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(networkSettingsArn = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$create_portal_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(displayName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), tags = structure(list(structure(list(Key = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), Value = structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "structure", sensitive = TRUE))), tags = list(type = "list")), customerManagedKey = structure(logical(0), tags = list(type = "string")), additionalEncryptionContext = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map")), clientToken = structure(logical(0), tags = list(idempotencyToken = TRUE, type = "string")), authenticationType = structure(logical(0), tags = list(type = "string")), instanceType = structure(logical(0), tags = list(type = "string")), maxConcurrentSessions = structure(logical(0), tags = list(type = "integer", box = TRUE)), portalCustomDomain = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$create_portal_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(portalArn = structure(logical(0), tags = list(type = "string")), portalEndpoint = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$create_session_logger_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(eventFilter = structure(list(all = structure(list(), tags = list(type = "structure")), include = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure", union = TRUE)), logConfiguration = structure(list(s3 = structure(list(bucket = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), keyPrefix = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), bucketOwner = structure(logical(0), tags = list(type = "string")), logFileFormat = structure(logical(0), tags = list(type = "string")), folderStructure = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure")), displayName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), customerManagedKey = structure(logical(0), tags = list(type = "string")), additionalEncryptionContext = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map")), tags = structure(list(structure(list(Key = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), Value = structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "structure", sensitive = TRUE))), tags = list(type = "list")), clientToken = structure(logical(0), tags = list(idempotencyToken = TRUE, type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$create_session_logger_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(sessionLoggerArn = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$create_trust_store_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(certificateList = structure(list(structure(logical(0), tags = list(type = "blob"))), tags = list(type = "list")), tags = structure(list(structure(list(Key = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), Value = structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "structure", sensitive = TRUE))), tags = list(type = "list")), clientToken = structure(logical(0), tags = list(idempotencyToken = TRUE, type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$create_trust_store_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(trustStoreArn = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$create_user_access_logging_settings_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(kinesisStreamArn = structure(logical(0), tags = list(type = "string")), tags = structure(list(structure(list(Key = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), Value = structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "structure", sensitive = TRUE))), tags = list(type = "list")), clientToken = structure(logical(0), tags = list(idempotencyToken = TRUE, type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$create_user_access_logging_settings_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(userAccessLoggingSettingsArn = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$create_user_settings_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(copyAllowed = structure(logical(0), tags = list(type = "string")), pasteAllowed = structure(logical(0), tags = list(type = "string")), downloadAllowed = structure(logical(0), tags = list(type = "string")), uploadAllowed = structure(logical(0), tags = list(type = "string")), printAllowed = structure(logical(0), tags = list(type = "string")), tags = structure(list(structure(list(Key = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), Value = structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "structure", sensitive = TRUE))), tags = list(type = "list")), disconnectTimeoutInMinutes = structure(logical(0), tags = list(type = "integer", box = TRUE)), idleDisconnectTimeoutInMinutes = structure(logical(0), tags = list(type = "integer", box = TRUE)), clientToken = structure(logical(0), tags = list(idempotencyToken = TRUE, type = "string")), cookieSynchronizationConfiguration = structure(list(allowlist = structure(list(structure(list(domain = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), name = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), path = structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "structure"))), tags = list(type = "list")), blocklist = structure(list(structure(list(domain = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), name = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), path = structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure", sensitive = TRUE)), customerManagedKey = structure(logical(0), tags = list(type = "string")), additionalEncryptionContext = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map")), deepLinkAllowed = structure(logical(0), tags = list(type = "string")), toolbarConfiguration = structure(list(toolbarType = structure(logical(0), tags = list(type = "string")), visualMode = structure(logical(0), tags = list(type = "string")), hiddenToolbarItems = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), maxDisplayResolution = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), brandingConfigurationInput = structure(list(logo = structure(list(blob = structure(logical(0), tags = list(type = "blob")), s3Uri = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure", union = TRUE)), wallpaper = structure(list(blob = structure(logical(0), tags = list(type = "blob")), s3Uri = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure", union = TRUE)), favicon = structure(list(blob = structure(logical(0), tags = list(type = "blob")), s3Uri = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure", union = TRUE)), localizedStrings = structure(list(structure(list(browserTabTitle = structure(logical(0), tags = list(type = "string")), welcomeText = structure(logical(0), tags = list(type = "string")), loginTitle = structure(logical(0), tags = list(type = "string")), loginDescription = structure(logical(0), tags = list(type = "string")), loginButtonText = structure(logical(0), tags = list(type = "string")), contactLink = structure(logical(0), tags = list(type = "string")), contactButtonText = structure(logical(0), tags = list(type = "string")), loadingText = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "map")), colorTheme = structure(logical(0), tags = list(type = "string")), termsOfService = structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "structure")), webAuthnAllowed = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$create_user_settings_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(userSettingsArn = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$delete_browser_settings_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(browserSettingsArn = structure(logical(0), tags = list(location = "uri", locationName = "browserSettingsArn", type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$delete_browser_settings_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$delete_data_protection_settings_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(dataProtectionSettingsArn = structure(logical(0), tags = list(location = "uri", locationName = "dataProtectionSettingsArn", type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$delete_data_protection_settings_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$delete_identity_provider_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(identityProviderArn = structure(logical(0), tags = list(location = "uri", locationName = "identityProviderArn", type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$delete_identity_provider_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$delete_ip_access_settings_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ipAccessSettingsArn = structure(logical(0), tags = list(location = "uri", locationName = "ipAccessSettingsArn", type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$delete_ip_access_settings_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$delete_network_settings_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(networkSettingsArn = structure(logical(0), tags = list(location = "uri", locationName = "networkSettingsArn", type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$delete_network_settings_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$delete_portal_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(portalArn = structure(logical(0), tags = list(location = "uri", locationName = "portalArn", type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$delete_portal_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$delete_session_logger_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(sessionLoggerArn = structure(logical(0), tags = list(location = "uri", locationName = "sessionLoggerArn", type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$delete_session_logger_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$delete_trust_store_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(trustStoreArn = structure(logical(0), tags = list(location = "uri", locationName = "trustStoreArn", type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$delete_trust_store_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$delete_user_access_logging_settings_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(userAccessLoggingSettingsArn = structure(logical(0), tags = list(location = "uri", locationName = "userAccessLoggingSettingsArn", type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$delete_user_access_logging_settings_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$delete_user_settings_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(userSettingsArn = structure(logical(0), tags = list(location = "uri", locationName = "userSettingsArn", type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$delete_user_settings_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$disassociate_browser_settings_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(portalArn = structure(logical(0), tags = list(location = "uri", locationName = "portalArn", type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$disassociate_browser_settings_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$disassociate_data_protection_settings_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(portalArn = structure(logical(0), tags = list(location = "uri", locationName = "portalArn", type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$disassociate_data_protection_settings_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$disassociate_ip_access_settings_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(portalArn = structure(logical(0), tags = list(location = "uri", locationName = "portalArn", type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$disassociate_ip_access_settings_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$disassociate_network_settings_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(portalArn = structure(logical(0), tags = list(location = "uri", locationName = "portalArn", type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$disassociate_network_settings_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$disassociate_session_logger_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(portalArn = structure(logical(0), tags = list(location = "uri", locationName = "portalArn", type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$disassociate_session_logger_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$disassociate_trust_store_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(portalArn = structure(logical(0), tags = list(location = "uri", locationName = "portalArn", type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$disassociate_trust_store_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$disassociate_user_access_logging_settings_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(portalArn = structure(logical(0), tags = list(location = "uri", locationName = "portalArn", type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$disassociate_user_access_logging_settings_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$disassociate_user_settings_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(portalArn = structure(logical(0), tags = list(location = "uri", locationName = "portalArn", type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$disassociate_user_settings_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$expire_session_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(portalId = structure(logical(0), tags = list(location = "uri", locationName = "portalId", type = "string")), sessionId = structure(logical(0), tags = list(location = "uri", locationName = "sessionId", type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$expire_session_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$get_browser_settings_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(browserSettingsArn = structure(logical(0), tags = list(location = "uri", locationName = "browserSettingsArn", type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$get_browser_settings_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(browserSettings = structure(list(browserSettingsArn = structure(logical(0), tags = list(type = "string")), associatedPortalArns = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), browserPolicy = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), customerManagedKey = structure(logical(0), tags = list(type = "string")), additionalEncryptionContext = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map")), webContentFilteringPolicy = structure(list(blockedCategories = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), allowedUrls = structure(list(structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "list")), blockedUrls = structure(list(structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "list"))), tags = list(type = "structure"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$get_data_protection_settings_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(dataProtectionSettingsArn = structure(logical(0), tags = list(location = "uri", locationName = "dataProtectionSettingsArn", type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$get_data_protection_settings_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(dataProtectionSettings = structure(list(dataProtectionSettingsArn = structure(logical(0), tags = list(type = "string")), inlineRedactionConfiguration = structure(list(inlineRedactionPatterns = structure(list(structure(list(builtInPatternId = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), customPattern = structure(list(patternName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), patternRegex = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), patternDescription = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), keywordRegex = structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "structure")), redactionPlaceHolder = structure(list(redactionPlaceHolderType = structure(logical(0), tags = list(type = "string")), redactionPlaceHolderText = structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "structure")), enforcedUrls = structure(list(structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "list")), exemptUrls = structure(list(structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "list")), confidenceLevel = structure(logical(0), tags = list(type = "integer", box = TRUE))), tags = list(type = "structure"))), tags = list(type = "list")), globalEnforcedUrls = structure(list(structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "list")), globalExemptUrls = structure(list(structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "list")), globalConfidenceLevel = structure(logical(0), tags = list(type = "integer", box = TRUE))), tags = list(type = "structure")), associatedPortalArns = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), displayName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), description = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), creationDate = structure(logical(0), tags = list(type = "timestamp")), customerManagedKey = structure(logical(0), tags = list(type = "string")), additionalEncryptionContext = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$get_identity_provider_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(identityProviderArn = structure(logical(0), tags = list(location = "uri", locationName = "identityProviderArn", type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$get_identity_provider_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(identityProvider = structure(list(identityProviderArn = structure(logical(0), tags = list(type = "string")), identityProviderName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), identityProviderType = structure(logical(0), tags = list(type = "string")), identityProviderDetails = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map", sensitive = TRUE))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$get_ip_access_settings_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ipAccessSettingsArn = structure(logical(0), tags = list(location = "uri", locationName = "ipAccessSettingsArn", type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$get_ip_access_settings_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ipAccessSettings = structure(list(ipAccessSettingsArn = structure(logical(0), tags = list(type = "string")), associatedPortalArns = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), ipRules = structure(list(structure(list(ipRange = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), description = structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "structure"))), tags = list(type = "list", sensitive = TRUE)), displayName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), description = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), creationDate = structure(logical(0), tags = list(type = "timestamp")), customerManagedKey = structure(logical(0), tags = list(type = "string")), additionalEncryptionContext = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$get_network_settings_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(networkSettingsArn = structure(logical(0), tags = list(location = "uri", locationName = "networkSettingsArn", type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$get_network_settings_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(networkSettings = structure(list(networkSettingsArn = structure(logical(0), tags = list(type = "string")), associatedPortalArns = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), vpcId = structure(logical(0), tags = list(type = "string")), subnetIds = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), securityGroupIds = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$get_portal_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(portalArn = structure(logical(0), tags = list(location = "uri", locationName = "portalArn", type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$get_portal_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(portal = structure(list(portalArn = structure(logical(0), tags = list(type = "string")), rendererType = structure(logical(0), tags = list(type = "string")), browserType = structure(logical(0), tags = list(type = "string")), portalStatus = structure(logical(0), tags = list(type = "string")), portalEndpoint = structure(logical(0), tags = list(type = "string")), displayName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), creationDate = structure(logical(0), tags = list(type = "timestamp")), browserSettingsArn = structure(logical(0), tags = list(type = "string")), dataProtectionSettingsArn = structure(logical(0), tags = list(type = "string")), userSettingsArn = structure(logical(0), tags = list(type = "string")), networkSettingsArn = structure(logical(0), tags = list(type = "string")), sessionLoggerArn = structure(logical(0), tags = list(type = "string")), trustStoreArn = structure(logical(0), tags = list(type = "string")), statusReason = structure(logical(0), tags = list(type = "string")), userAccessLoggingSettingsArn = structure(logical(0), tags = list(type = "string")), authenticationType = structure(logical(0), tags = list(type = "string")), ipAccessSettingsArn = structure(logical(0), tags = list(type = "string")), customerManagedKey = structure(logical(0), tags = list(type = "string")), additionalEncryptionContext = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map")), instanceType = structure(logical(0), tags = list(type = "string")), maxConcurrentSessions = structure(logical(0), tags = list(type = "integer", box = TRUE)), portalCustomDomain = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$get_portal_service_provider_metadata_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(portalArn = structure(logical(0), tags = list(location = "uri", locationName = "portalArn", type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$get_portal_service_provider_metadata_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(portalArn = structure(logical(0), tags = list(type = "string")), serviceProviderSamlMetadata = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$get_session_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(portalId = structure(logical(0), tags = list(location = "uri", locationName = "portalId", type = "string")), sessionId = structure(logical(0), tags = list(location = "uri", locationName = "sessionId", type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$get_session_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(session = structure(list(portalArn = structure(logical(0), tags = list(type = "string")), sessionId = structure(logical(0), tags = list(type = "string")), username = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), clientIpAddresses = structure(list(structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "list")), status = structure(logical(0), tags = list(type = "string")), startTime = structure(logical(0), tags = list(type = "timestamp")), endTime = structure(logical(0), tags = list(type = "timestamp"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$get_session_logger_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(sessionLoggerArn = structure(logical(0), tags = list(location = "uri", locationName = "sessionLoggerArn", type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$get_session_logger_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(sessionLogger = structure(list(sessionLoggerArn = structure(logical(0), tags = list(type = "string")), eventFilter = structure(list(all = structure(list(), tags = list(type = "structure")), include = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure", union = TRUE)), logConfiguration = structure(list(s3 = structure(list(bucket = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), keyPrefix = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), bucketOwner = structure(logical(0), tags = list(type = "string")), logFileFormat = structure(logical(0), tags = list(type = "string")), folderStructure = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure")), customerManagedKey = structure(logical(0), tags = list(type = "string")), additionalEncryptionContext = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map")), associatedPortalArns = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), displayName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), creationDate = structure(logical(0), tags = list(type = "timestamp"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$get_trust_store_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(trustStoreArn = structure(logical(0), tags = list(location = "uri", locationName = "trustStoreArn", type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$get_trust_store_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(trustStore = structure(list(associatedPortalArns = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), trustStoreArn = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$get_trust_store_certificate_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(trustStoreArn = structure(logical(0), tags = list(location = "uri", locationName = "trustStoreArn", type = "string")), thumbprint = structure(logical(0), tags = list(location = "querystring", locationName = "thumbprint", type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$get_trust_store_certificate_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(trustStoreArn = structure(logical(0), tags = list(type = "string")), certificate = structure(list(thumbprint = structure(logical(0), tags = list(type = "string")), subject = structure(logical(0), tags = list(type = "string")), issuer = structure(logical(0), tags = list(type = "string")), notValidBefore = structure(logical(0), tags = list(type = "timestamp")), notValidAfter = structure(logical(0), tags = list(type = "timestamp")), body = structure(logical(0), tags = list(type = "blob"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$get_user_access_logging_settings_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(userAccessLoggingSettingsArn = structure(logical(0), tags = list(location = "uri", locationName = "userAccessLoggingSettingsArn", type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$get_user_access_logging_settings_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(userAccessLoggingSettings = structure(list(userAccessLoggingSettingsArn = structure(logical(0), tags = list(type = "string")), associatedPortalArns = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), kinesisStreamArn = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$get_user_settings_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(userSettingsArn = structure(logical(0), tags = list(location = "uri", locationName = "userSettingsArn", type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$get_user_settings_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(userSettings = structure(list(userSettingsArn = structure(logical(0), tags = list(type = "string")), associatedPortalArns = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), copyAllowed = structure(logical(0), tags = list(type = "string")), pasteAllowed = structure(logical(0), tags = list(type = "string")), downloadAllowed = structure(logical(0), tags = list(type = "string")), uploadAllowed = structure(logical(0), tags = list(type = "string")), printAllowed = structure(logical(0), tags = list(type = "string")), disconnectTimeoutInMinutes = structure(logical(0), tags = list(type = "integer", box = TRUE)), idleDisconnectTimeoutInMinutes = structure(logical(0), tags = list(type = "integer", box = TRUE)), cookieSynchronizationConfiguration = structure(list(allowlist = structure(list(structure(list(domain = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), name = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), path = structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "structure"))), tags = list(type = "list")), blocklist = structure(list(structure(list(domain = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), name = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), path = structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure", sensitive = TRUE)), customerManagedKey = structure(logical(0), tags = list(type = "string")), additionalEncryptionContext = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map")), deepLinkAllowed = structure(logical(0), tags = list(type = "string")), toolbarConfiguration = structure(list(toolbarType = structure(logical(0), tags = list(type = "string")), visualMode = structure(logical(0), tags = list(type = "string")), hiddenToolbarItems = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), maxDisplayResolution = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), brandingConfiguration = structure(list(logo = structure(list(mimeType = structure(logical(0), tags = list(type = "string")), fileExtension = structure(logical(0), tags = list(type = "string")), lastUploadTimestamp = structure(logical(0), tags = list(type = "timestamp"))), tags = list(type = "structure")), wallpaper = structure(list(mimeType = structure(logical(0), tags = list(type = "string")), fileExtension = structure(logical(0), tags = list(type = "string")), lastUploadTimestamp = structure(logical(0), tags = list(type = "timestamp"))), tags = list(type = "structure")), favicon = structure(list(mimeType = structure(logical(0), tags = list(type = "string")), fileExtension = structure(logical(0), tags = list(type = "string")), lastUploadTimestamp = structure(logical(0), tags = list(type = "timestamp"))), tags = list(type = "structure")), localizedStrings = structure(list(structure(list(browserTabTitle = structure(logical(0), tags = list(type = "string")), welcomeText = structure(logical(0), tags = list(type = "string")), loginTitle = structure(logical(0), tags = list(type = "string")), loginDescription = structure(logical(0), tags = list(type = "string")), loginButtonText = structure(logical(0), tags = list(type = "string")), contactLink = structure(logical(0), tags = list(type = "string")), contactButtonText = structure(logical(0), tags = list(type = "string")), loadingText = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "map")), colorTheme = structure(logical(0), tags = list(type = "string")), termsOfService = structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "structure")), webAuthnAllowed = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$list_browser_settings_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(nextToken = structure(logical(0), tags = list(location = "querystring", locationName = "nextToken", type = "string")), maxResults = structure(logical(0), tags = list(location = "querystring", locationName = "maxResults", type = "integer", box = TRUE))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$list_browser_settings_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(browserSettings = structure(list(structure(list(browserSettingsArn = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), nextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$list_data_protection_settings_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(nextToken = structure(logical(0), tags = list(location = "querystring", locationName = "nextToken", type = "string")), maxResults = structure(logical(0), tags = list(location = "querystring", locationName = "maxResults", type = "integer", box = TRUE))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$list_data_protection_settings_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(dataProtectionSettings = structure(list(structure(list(dataProtectionSettingsArn = structure(logical(0), tags = list(type = "string")), displayName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), description = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), creationDate = structure(logical(0), tags = list(type = "timestamp"))), tags = list(type = "structure"))), tags = list(type = "list")), nextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$list_identity_providers_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(nextToken = structure(logical(0), tags = list(location = "querystring", locationName = "nextToken", type = "string")), maxResults = structure(logical(0), tags = list(location = "querystring", locationName = "maxResults", type = "integer", box = TRUE)), portalArn = structure(logical(0), tags = list(location = "uri", locationName = "portalArn", type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$list_identity_providers_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(nextToken = structure(logical(0), tags = list(type = "string")), identityProviders = structure(list(structure(list(identityProviderArn = structure(logical(0), tags = list(type = "string")), identityProviderName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), identityProviderType = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$list_ip_access_settings_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(nextToken = structure(logical(0), tags = list(location = "querystring", locationName = "nextToken", type = "string")), maxResults = structure(logical(0), tags = list(location = "querystring", locationName = "maxResults", type = "integer", box = TRUE))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$list_ip_access_settings_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ipAccessSettings = structure(list(structure(list(ipAccessSettingsArn = structure(logical(0), tags = list(type = "string")), displayName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), description = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), creationDate = structure(logical(0), tags = list(type = "timestamp"))), tags = list(type = "structure"))), tags = list(type = "list")), nextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$list_network_settings_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(nextToken = structure(logical(0), tags = list(location = "querystring", locationName = "nextToken", type = "string")), maxResults = structure(logical(0), tags = list(location = "querystring", locationName = "maxResults", type = "integer", box = TRUE))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$list_network_settings_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(networkSettings = structure(list(structure(list(networkSettingsArn = structure(logical(0), tags = list(type = "string")), vpcId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), nextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$list_portals_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(nextToken = structure(logical(0), tags = list(location = "querystring", locationName = "nextToken", type = "string")), maxResults = structure(logical(0), tags = list(location = "querystring", locationName = "maxResults", type = "integer", box = TRUE))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$list_portals_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(portals = structure(list(structure(list(portalArn = structure(logical(0), tags = list(type = "string")), rendererType = structure(logical(0), tags = list(type = "string")), browserType = structure(logical(0), tags = list(type = "string")), portalStatus = structure(logical(0), tags = list(type = "string")), portalEndpoint = structure(logical(0), tags = list(type = "string")), displayName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), creationDate = structure(logical(0), tags = list(type = "timestamp")), browserSettingsArn = structure(logical(0), tags = list(type = "string")), dataProtectionSettingsArn = structure(logical(0), tags = list(type = "string")), userSettingsArn = structure(logical(0), tags = list(type = "string")), networkSettingsArn = structure(logical(0), tags = list(type = "string")), sessionLoggerArn = structure(logical(0), tags = list(type = "string")), trustStoreArn = structure(logical(0), tags = list(type = "string")), userAccessLoggingSettingsArn = structure(logical(0), tags = list(type = "string")), authenticationType = structure(logical(0), tags = list(type = "string")), ipAccessSettingsArn = structure(logical(0), tags = list(type = "string")), instanceType = structure(logical(0), tags = list(type = "string")), maxConcurrentSessions = structure(logical(0), tags = list(type = "integer", box = TRUE)), portalCustomDomain = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), nextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$list_session_loggers_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(nextToken = structure(logical(0), tags = list(location = "querystring", locationName = "nextToken", type = "string")), maxResults = structure(logical(0), tags = list(location = "querystring", locationName = "maxResults", type = "integer", box = TRUE))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$list_session_loggers_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(sessionLoggers = structure(list(structure(list(sessionLoggerArn = structure(logical(0), tags = list(type = "string")), logConfiguration = structure(list(s3 = structure(list(bucket = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), keyPrefix = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), bucketOwner = structure(logical(0), tags = list(type = "string")), logFileFormat = structure(logical(0), tags = list(type = "string")), folderStructure = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure")), displayName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), creationDate = structure(logical(0), tags = list(type = "timestamp"))), tags = list(type = "structure"))), tags = list(type = "list")), nextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$list_sessions_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(portalId = structure(logical(0), tags = list(location = "uri", locationName = "portalId", type = "string")), username = structure(logical(0), tags = list(location = "querystring", locationName = "username", type = "string", sensitive = TRUE)), sessionId = structure(logical(0), tags = list(location = "querystring", locationName = "sessionId", type = "string")), sortBy = structure(logical(0), tags = list(location = "querystring", locationName = "sortBy", type = "string")), status = structure(logical(0), tags = list(location = "querystring", locationName = "status", type = "string")), maxResults = structure(logical(0), tags = list(location = "querystring", locationName = "maxResults", type = "integer", box = TRUE)), nextToken = structure(logical(0), tags = list(location = "querystring", locationName = "nextToken", type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$list_sessions_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(sessions = structure(list(structure(list(portalArn = structure(logical(0), tags = list(type = "string")), sessionId = structure(logical(0), tags = list(type = "string")), username = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), status = structure(logical(0), tags = list(type = "string")), startTime = structure(logical(0), tags = list(type = "timestamp")), endTime = structure(logical(0), tags = list(type = "timestamp"))), tags = list(type = "structure"))), tags = list(type = "list")), nextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$list_tags_for_resource_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(resourceArn = structure(logical(0), tags = list(location = "uri", locationName = "resourceArn", type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$list_tags_for_resource_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(tags = structure(list(structure(list(Key = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), Value = structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "structure", sensitive = TRUE))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$list_trust_store_certificates_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(trustStoreArn = structure(logical(0), tags = list(location = "uri", locationName = "trustStoreArn", type = "string")), nextToken = structure(logical(0), tags = list(location = "querystring", locationName = "nextToken", type = "string")), maxResults = structure(logical(0), tags = list(location = "querystring", locationName = "maxResults", type = "integer", box = TRUE))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$list_trust_store_certificates_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(certificateList = structure(list(structure(list(thumbprint = structure(logical(0), tags = list(type = "string")), subject = structure(logical(0), tags = list(type = "string")), issuer = structure(logical(0), tags = list(type = "string")), notValidBefore = structure(logical(0), tags = list(type = "timestamp")), notValidAfter = structure(logical(0), tags = list(type = "timestamp"))), tags = list(type = "structure"))), tags = list(type = "list")), trustStoreArn = structure(logical(0), tags = list(type = "string")), nextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$list_trust_stores_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(nextToken = structure(logical(0), tags = list(location = "querystring", locationName = "nextToken", type = "string")), maxResults = structure(logical(0), tags = list(location = "querystring", locationName = "maxResults", type = "integer", box = TRUE))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$list_trust_stores_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(trustStores = structure(list(structure(list(trustStoreArn = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), nextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$list_user_access_logging_settings_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(nextToken = structure(logical(0), tags = list(location = "querystring", locationName = "nextToken", type = "string")), maxResults = structure(logical(0), tags = list(location = "querystring", locationName = "maxResults", type = "integer", box = TRUE))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$list_user_access_logging_settings_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(userAccessLoggingSettings = structure(list(structure(list(userAccessLoggingSettingsArn = structure(logical(0), tags = list(type = "string")), kinesisStreamArn = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), nextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$list_user_settings_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(nextToken = structure(logical(0), tags = list(location = "querystring", locationName = "nextToken", type = "string")), maxResults = structure(logical(0), tags = list(location = "querystring", locationName = "maxResults", type = "integer", box = TRUE))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$list_user_settings_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(userSettings = structure(list(structure(list(userSettingsArn = structure(logical(0), tags = list(type = "string")), copyAllowed = structure(logical(0), tags = list(type = "string")), pasteAllowed = structure(logical(0), tags = list(type = "string")), downloadAllowed = structure(logical(0), tags = list(type = "string")), uploadAllowed = structure(logical(0), tags = list(type = "string")), printAllowed = structure(logical(0), tags = list(type = "string")), disconnectTimeoutInMinutes = structure(logical(0), tags = list(type = "integer", box = TRUE)), idleDisconnectTimeoutInMinutes = structure(logical(0), tags = list(type = "integer", box = TRUE)), cookieSynchronizationConfiguration = structure(list(allowlist = structure(list(structure(list(domain = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), name = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), path = structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "structure"))), tags = list(type = "list")), blocklist = structure(list(structure(list(domain = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), name = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), path = structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure", sensitive = TRUE)), deepLinkAllowed = structure(logical(0), tags = list(type = "string")), toolbarConfiguration = structure(list(toolbarType = structure(logical(0), tags = list(type = "string")), visualMode = structure(logical(0), tags = list(type = "string")), hiddenToolbarItems = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), maxDisplayResolution = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), brandingConfiguration = structure(list(logo = structure(list(mimeType = structure(logical(0), tags = list(type = "string")), fileExtension = structure(logical(0), tags = list(type = "string")), lastUploadTimestamp = structure(logical(0), tags = list(type = "timestamp"))), tags = list(type = "structure")), wallpaper = structure(list(mimeType = structure(logical(0), tags = list(type = "string")), fileExtension = structure(logical(0), tags = list(type = "string")), lastUploadTimestamp = structure(logical(0), tags = list(type = "timestamp"))), tags = list(type = "structure")), favicon = structure(list(mimeType = structure(logical(0), tags = list(type = "string")), fileExtension = structure(logical(0), tags = list(type = "string")), lastUploadTimestamp = structure(logical(0), tags = list(type = "timestamp"))), tags = list(type = "structure")), localizedStrings = structure(list(structure(list(browserTabTitle = structure(logical(0), tags = list(type = "string")), welcomeText = structure(logical(0), tags = list(type = "string")), loginTitle = structure(logical(0), tags = list(type = "string")), loginDescription = structure(logical(0), tags = list(type = "string")), loginButtonText = structure(logical(0), tags = list(type = "string")), contactLink = structure(logical(0), tags = list(type = "string")), contactButtonText = structure(logical(0), tags = list(type = "string")), loadingText = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "map")), colorTheme = structure(logical(0), tags = list(type = "string")), termsOfService = structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "structure")), webAuthnAllowed = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), nextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$tag_resource_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(resourceArn = structure(logical(0), tags = list(location = "uri", locationName = "resourceArn", type = "string")), tags = structure(list(structure(list(Key = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), Value = structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "structure", sensitive = TRUE))), tags = list(type = "list")), clientToken = structure(logical(0), tags = list(idempotencyToken = TRUE, type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$tag_resource_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$untag_resource_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(resourceArn = structure(logical(0), tags = list(location = "uri", locationName = "resourceArn", type = "string")), tagKeys = structure(list(structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(location = "querystring", locationName = "tagKeys", type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$untag_resource_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$update_browser_settings_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(browserSettingsArn = structure(logical(0), tags = list(location = "uri", locationName = "browserSettingsArn", type = "string")), browserPolicy = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), clientToken = structure(logical(0), tags = list(idempotencyToken = TRUE, type = "string")), webContentFilteringPolicy = structure(list(blockedCategories = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), allowedUrls = structure(list(structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "list")), blockedUrls = structure(list(structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "list"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$update_browser_settings_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(browserSettings = structure(list(browserSettingsArn = structure(logical(0), tags = list(type = "string")), associatedPortalArns = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), browserPolicy = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), customerManagedKey = structure(logical(0), tags = list(type = "string")), additionalEncryptionContext = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map")), webContentFilteringPolicy = structure(list(blockedCategories = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), allowedUrls = structure(list(structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "list")), blockedUrls = structure(list(structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "list"))), tags = list(type = "structure"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$update_data_protection_settings_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(dataProtectionSettingsArn = structure(logical(0), tags = list(location = "uri", locationName = "dataProtectionSettingsArn", type = "string")), inlineRedactionConfiguration = structure(list(inlineRedactionPatterns = structure(list(structure(list(builtInPatternId = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), customPattern = structure(list(patternName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), patternRegex = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), patternDescription = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), keywordRegex = structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "structure")), redactionPlaceHolder = structure(list(redactionPlaceHolderType = structure(logical(0), tags = list(type = "string")), redactionPlaceHolderText = structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "structure")), enforcedUrls = structure(list(structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "list")), exemptUrls = structure(list(structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "list")), confidenceLevel = structure(logical(0), tags = list(type = "integer", box = TRUE))), tags = list(type = "structure"))), tags = list(type = "list")), globalEnforcedUrls = structure(list(structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "list")), globalExemptUrls = structure(list(structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "list")), globalConfidenceLevel = structure(logical(0), tags = list(type = "integer", box = TRUE))), tags = list(type = "structure")), displayName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), description = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), clientToken = structure(logical(0), tags = list(idempotencyToken = TRUE, type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$update_data_protection_settings_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(dataProtectionSettings = structure(list(dataProtectionSettingsArn = structure(logical(0), tags = list(type = "string")), inlineRedactionConfiguration = structure(list(inlineRedactionPatterns = structure(list(structure(list(builtInPatternId = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), customPattern = structure(list(patternName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), patternRegex = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), patternDescription = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), keywordRegex = structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "structure")), redactionPlaceHolder = structure(list(redactionPlaceHolderType = structure(logical(0), tags = list(type = "string")), redactionPlaceHolderText = structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "structure")), enforcedUrls = structure(list(structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "list")), exemptUrls = structure(list(structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "list")), confidenceLevel = structure(logical(0), tags = list(type = "integer", box = TRUE))), tags = list(type = "structure"))), tags = list(type = "list")), globalEnforcedUrls = structure(list(structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "list")), globalExemptUrls = structure(list(structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "list")), globalConfidenceLevel = structure(logical(0), tags = list(type = "integer", box = TRUE))), tags = list(type = "structure")), associatedPortalArns = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), displayName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), description = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), creationDate = structure(logical(0), tags = list(type = "timestamp")), customerManagedKey = structure(logical(0), tags = list(type = "string")), additionalEncryptionContext = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$update_identity_provider_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(identityProviderArn = structure(logical(0), tags = list(location = "uri", locationName = "identityProviderArn", type = "string")), identityProviderName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), identityProviderType = structure(logical(0), tags = list(type = "string")), identityProviderDetails = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map", sensitive = TRUE)), clientToken = structure(logical(0), tags = list(idempotencyToken = TRUE, type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$update_identity_provider_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(identityProvider = structure(list(identityProviderArn = structure(logical(0), tags = list(type = "string")), identityProviderName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), identityProviderType = structure(logical(0), tags = list(type = "string")), identityProviderDetails = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map", sensitive = TRUE))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$update_ip_access_settings_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ipAccessSettingsArn = structure(logical(0), tags = list(location = "uri", locationName = "ipAccessSettingsArn", type = "string")), displayName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), description = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), ipRules = structure(list(structure(list(ipRange = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), description = structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "structure"))), tags = list(type = "list", sensitive = TRUE)), clientToken = structure(logical(0), tags = list(idempotencyToken = TRUE, type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$update_ip_access_settings_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ipAccessSettings = structure(list(ipAccessSettingsArn = structure(logical(0), tags = list(type = "string")), associatedPortalArns = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), ipRules = structure(list(structure(list(ipRange = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), description = structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "structure"))), tags = list(type = "list", sensitive = TRUE)), displayName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), description = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), creationDate = structure(logical(0), tags = list(type = "timestamp")), customerManagedKey = structure(logical(0), tags = list(type = "string")), additionalEncryptionContext = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$update_network_settings_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(networkSettingsArn = structure(logical(0), tags = list(location = "uri", locationName = "networkSettingsArn", type = "string")), vpcId = structure(logical(0), tags = list(type = "string")), subnetIds = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), securityGroupIds = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), clientToken = structure(logical(0), tags = list(idempotencyToken = TRUE, type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$update_network_settings_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(networkSettings = structure(list(networkSettingsArn = structure(logical(0), tags = list(type = "string")), associatedPortalArns = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), vpcId = structure(logical(0), tags = list(type = "string")), subnetIds = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), securityGroupIds = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$update_portal_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(portalArn = structure(logical(0), tags = list(location = "uri", locationName = "portalArn", type = "string")), displayName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), authenticationType = structure(logical(0), tags = list(type = "string")), instanceType = structure(logical(0), tags = list(type = "string")), maxConcurrentSessions = structure(logical(0), tags = list(type = "integer", box = TRUE)), portalCustomDomain = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$update_portal_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(portal = structure(list(portalArn = structure(logical(0), tags = list(type = "string")), rendererType = structure(logical(0), tags = list(type = "string")), browserType = structure(logical(0), tags = list(type = "string")), portalStatus = structure(logical(0), tags = list(type = "string")), portalEndpoint = structure(logical(0), tags = list(type = "string")), displayName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), creationDate = structure(logical(0), tags = list(type = "timestamp")), browserSettingsArn = structure(logical(0), tags = list(type = "string")), dataProtectionSettingsArn = structure(logical(0), tags = list(type = "string")), userSettingsArn = structure(logical(0), tags = list(type = "string")), networkSettingsArn = structure(logical(0), tags = list(type = "string")), sessionLoggerArn = structure(logical(0), tags = list(type = "string")), trustStoreArn = structure(logical(0), tags = list(type = "string")), statusReason = structure(logical(0), tags = list(type = "string")), userAccessLoggingSettingsArn = structure(logical(0), tags = list(type = "string")), authenticationType = structure(logical(0), tags = list(type = "string")), ipAccessSettingsArn = structure(logical(0), tags = list(type = "string")), customerManagedKey = structure(logical(0), tags = list(type = "string")), additionalEncryptionContext = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map")), instanceType = structure(logical(0), tags = list(type = "string")), maxConcurrentSessions = structure(logical(0), tags = list(type = "integer", box = TRUE)), portalCustomDomain = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$update_session_logger_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(sessionLoggerArn = structure(logical(0), tags = list(location = "uri", locationName = "sessionLoggerArn", type = "string")), eventFilter = structure(list(all = structure(list(), tags = list(type = "structure")), include = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure", union = TRUE)), logConfiguration = structure(list(s3 = structure(list(bucket = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), keyPrefix = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), bucketOwner = structure(logical(0), tags = list(type = "string")), logFileFormat = structure(logical(0), tags = list(type = "string")), folderStructure = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure")), displayName = structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$update_session_logger_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(sessionLogger = structure(list(sessionLoggerArn = structure(logical(0), tags = list(type = "string")), eventFilter = structure(list(all = structure(list(), tags = list(type = "structure")), include = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure", union = TRUE)), logConfiguration = structure(list(s3 = structure(list(bucket = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), keyPrefix = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), bucketOwner = structure(logical(0), tags = list(type = "string")), logFileFormat = structure(logical(0), tags = list(type = "string")), folderStructure = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure")), customerManagedKey = structure(logical(0), tags = list(type = "string")), additionalEncryptionContext = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map")), associatedPortalArns = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), displayName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), creationDate = structure(logical(0), tags = list(type = "timestamp"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$update_trust_store_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(trustStoreArn = structure(logical(0), tags = list(location = "uri", locationName = "trustStoreArn", type = "string")), certificatesToAdd = structure(list(structure(logical(0), tags = list(type = "blob"))), tags = list(type = "list")), certificatesToDelete = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), clientToken = structure(logical(0), tags = list(idempotencyToken = TRUE, type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$update_trust_store_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(trustStoreArn = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$update_user_access_logging_settings_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(userAccessLoggingSettingsArn = structure(logical(0), tags = list(location = "uri", locationName = "userAccessLoggingSettingsArn", type = "string")), kinesisStreamArn = structure(logical(0), tags = list(type = "string")), clientToken = structure(logical(0), tags = list(idempotencyToken = TRUE, type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$update_user_access_logging_settings_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(userAccessLoggingSettings = structure(list(userAccessLoggingSettingsArn = structure(logical(0), tags = list(type = "string")), associatedPortalArns = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), kinesisStreamArn = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$update_user_settings_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(userSettingsArn = structure(logical(0), tags = list(location = "uri", locationName = "userSettingsArn", type = "string")), copyAllowed = structure(logical(0), tags = list(type = "string")), pasteAllowed = structure(logical(0), tags = list(type = "string")), downloadAllowed = structure(logical(0), tags = list(type = "string")), uploadAllowed = structure(logical(0), tags = list(type = "string")), printAllowed = structure(logical(0), tags = list(type = "string")), disconnectTimeoutInMinutes = structure(logical(0), tags = list(type = "integer", box = TRUE)), idleDisconnectTimeoutInMinutes = structure(logical(0), tags = list(type = "integer", box = TRUE)), clientToken = structure(logical(0), tags = list(idempotencyToken = TRUE, type = "string")), cookieSynchronizationConfiguration = structure(list(allowlist = structure(list(structure(list(domain = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), name = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), path = structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "structure"))), tags = list(type = "list")), blocklist = structure(list(structure(list(domain = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), name = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), path = structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure", sensitive = TRUE)), deepLinkAllowed = structure(logical(0), tags = list(type = "string")), toolbarConfiguration = structure(list(toolbarType = structure(logical(0), tags = list(type = "string")), visualMode = structure(logical(0), tags = list(type = "string")), hiddenToolbarItems = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), maxDisplayResolution = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), brandingConfigurationInput = structure(list(logo = structure(list(blob = structure(logical(0), tags = list(type = "blob")), s3Uri = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure", union = TRUE)), wallpaper = structure(list(blob = structure(logical(0), tags = list(type = "blob")), s3Uri = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure", union = TRUE)), favicon = structure(list(blob = structure(logical(0), tags = list(type = "blob")), s3Uri = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure", union = TRUE)), localizedStrings = structure(list(structure(list(browserTabTitle = structure(logical(0), tags = list(type = "string")), welcomeText = structure(logical(0), tags = list(type = "string")), loginTitle = structure(logical(0), tags = list(type = "string")), loginDescription = structure(logical(0), tags = list(type = "string")), loginButtonText = structure(logical(0), tags = list(type = "string")), contactLink = structure(logical(0), tags = list(type = "string")), contactButtonText = structure(logical(0), tags = list(type = "string")), loadingText = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "map")), colorTheme = structure(logical(0), tags = list(type = "string")), termsOfService = structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "structure")), webAuthnAllowed = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspacesweb$update_user_settings_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(userSettings = structure(list(userSettingsArn = structure(logical(0), tags = list(type = "string")), associatedPortalArns = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), copyAllowed = structure(logical(0), tags = list(type = "string")), pasteAllowed = structure(logical(0), tags = list(type = "string")), downloadAllowed = structure(logical(0), tags = list(type = "string")), uploadAllowed = structure(logical(0), tags = list(type = "string")), printAllowed = structure(logical(0), tags = list(type = "string")), disconnectTimeoutInMinutes = structure(logical(0), tags = list(type = "integer", box = TRUE)), idleDisconnectTimeoutInMinutes = structure(logical(0), tags = list(type = "integer", box = TRUE)), cookieSynchronizationConfiguration = structure(list(allowlist = structure(list(structure(list(domain = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), name = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), path = structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "structure"))), tags = list(type = "list")), blocklist = structure(list(structure(list(domain = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), name = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), path = structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure", sensitive = TRUE)), customerManagedKey = structure(logical(0), tags = list(type = "string")), additionalEncryptionContext = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map")), deepLinkAllowed = structure(logical(0), tags = list(type = "string")), toolbarConfiguration = structure(list(toolbarType = structure(logical(0), tags = list(type = "string")), visualMode = structure(logical(0), tags = list(type = "string")), hiddenToolbarItems = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), maxDisplayResolution = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), brandingConfiguration = structure(list(logo = structure(list(mimeType = structure(logical(0), tags = list(type = "string")), fileExtension = structure(logical(0), tags = list(type = "string")), lastUploadTimestamp = structure(logical(0), tags = list(type = "timestamp"))), tags = list(type = "structure")), wallpaper = structure(list(mimeType = structure(logical(0), tags = list(type = "string")), fileExtension = structure(logical(0), tags = list(type = "string")), lastUploadTimestamp = structure(logical(0), tags = list(type = "timestamp"))), tags = list(type = "structure")), favicon = structure(list(mimeType = structure(logical(0), tags = list(type = "string")), fileExtension = structure(logical(0), tags = list(type = "string")), lastUploadTimestamp = structure(logical(0), tags = list(type = "timestamp"))), tags = list(type = "structure")), localizedStrings = structure(list(structure(list(browserTabTitle = structure(logical(0), tags = list(type = "string")), welcomeText = structure(logical(0), tags = list(type = "string")), loginTitle = structure(logical(0), tags = list(type = "string")), loginDescription = structure(logical(0), tags = list(type = "string")), loginButtonText = structure(logical(0), tags = list(type = "string")), contactLink = structure(logical(0), tags = list(type = "string")), contactButtonText = structure(logical(0), tags = list(type = "string")), loadingText = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "map")), colorTheme = structure(logical(0), tags = list(type = "string")), termsOfService = structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "structure")), webAuthnAllowed = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

# This file is generated by make.paws. Please do not edit here.
#' @importFrom paws.common get_config new_operation new_request send_request
#' @include appstream_service.R
NULL

#' Associates the specified app block builder with the specified app block
#'
#' @description
#' Associates the specified app block builder with the specified app block.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_associate_app_block_builder_app_block/](https://www.paws-r-sdk.com/docs/appstream_associate_app_block_builder_app_block/) for full documentation.
#'
#' @param AppBlockArn &#91;required&#93; The ARN of the app block.
#' @param AppBlockBuilderName &#91;required&#93; The name of the app block builder.
#'
#' @keywords internal
#'
#' @rdname appstream_associate_app_block_builder_app_block
appstream_associate_app_block_builder_app_block <- function(AppBlockArn, AppBlockBuilderName) {
  op <- new_operation(
    name = "AssociateAppBlockBuilderAppBlock",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .appstream$associate_app_block_builder_app_block_input(AppBlockArn = AppBlockArn, AppBlockBuilderName = AppBlockBuilderName)
  output <- .appstream$associate_app_block_builder_app_block_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$associate_app_block_builder_app_block <- appstream_associate_app_block_builder_app_block

#' Associates the specified application with the specified fleet
#'
#' @description
#' Associates the specified application with the specified fleet. This is only supported for Elastic fleets.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_associate_application_fleet/](https://www.paws-r-sdk.com/docs/appstream_associate_application_fleet/) for full documentation.
#'
#' @param FleetName &#91;required&#93; The name of the fleet.
#' @param ApplicationArn &#91;required&#93; The ARN of the application.
#'
#' @keywords internal
#'
#' @rdname appstream_associate_application_fleet
appstream_associate_application_fleet <- function(FleetName, ApplicationArn) {
  op <- new_operation(
    name = "AssociateApplicationFleet",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .appstream$associate_application_fleet_input(FleetName = FleetName, ApplicationArn = ApplicationArn)
  output <- .appstream$associate_application_fleet_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$associate_application_fleet <- appstream_associate_application_fleet

#' Associates an application to entitle
#'
#' @description
#' Associates an application to entitle.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_associate_application_to_entitlement/](https://www.paws-r-sdk.com/docs/appstream_associate_application_to_entitlement/) for full documentation.
#'
#' @param StackName &#91;required&#93; The name of the stack.
#' @param EntitlementName &#91;required&#93; The name of the entitlement.
#' @param ApplicationIdentifier &#91;required&#93; The identifier of the application.
#'
#' @keywords internal
#'
#' @rdname appstream_associate_application_to_entitlement
appstream_associate_application_to_entitlement <- function(StackName, EntitlementName, ApplicationIdentifier) {
  op <- new_operation(
    name = "AssociateApplicationToEntitlement",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .appstream$associate_application_to_entitlement_input(StackName = StackName, EntitlementName = EntitlementName, ApplicationIdentifier = ApplicationIdentifier)
  output <- .appstream$associate_application_to_entitlement_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$associate_application_to_entitlement <- appstream_associate_application_to_entitlement

#' Associates the specified fleet with the specified stack
#'
#' @description
#' Associates the specified fleet with the specified stack.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_associate_fleet/](https://www.paws-r-sdk.com/docs/appstream_associate_fleet/) for full documentation.
#'
#' @param FleetName &#91;required&#93; The name of the fleet.
#' @param StackName &#91;required&#93; The name of the stack.
#'
#' @keywords internal
#'
#' @rdname appstream_associate_fleet
appstream_associate_fleet <- function(FleetName, StackName) {
  op <- new_operation(
    name = "AssociateFleet",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .appstream$associate_fleet_input(FleetName = FleetName, StackName = StackName)
  output <- .appstream$associate_fleet_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$associate_fleet <- appstream_associate_fleet

#' Associates license included application(s) with an existing image
#' builder instance
#'
#' @description
#' Associates license included application(s) with an existing image builder instance.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_associate_software_to_image_builder/](https://www.paws-r-sdk.com/docs/appstream_associate_software_to_image_builder/) for full documentation.
#'
#' @param ImageBuilderName &#91;required&#93; The name of the target image builder instance.
#' @param SoftwareNames &#91;required&#93; The list of license included applications to associate with the image builder.
#' 
#' Possible values include the following:
#' 
#' -   Microsoft_Office_2021_LTSC_Professional_Plus_32Bit
#' 
#' -   Microsoft_Office_2021_LTSC_Professional_Plus_64Bit
#' 
#' -   Microsoft_Office_2024_LTSC_Professional_Plus_32Bit
#' 
#' -   Microsoft_Office_2024_LTSC_Professional_Plus_64Bit
#' 
#' -   Microsoft_Visio_2021_LTSC_Professional_32Bit
#' 
#' -   Microsoft_Visio_2021_LTSC_Professional_64Bit
#' 
#' -   Microsoft_Visio_2024_LTSC_Professional_32Bit
#' 
#' -   Microsoft_Visio_2024_LTSC_Professional_64Bit
#' 
#' -   Microsoft_Project_2021_Professional_32Bit
#' 
#' -   Microsoft_Project_2021_Professional_64Bit
#' 
#' -   Microsoft_Project_2024_Professional_32Bit
#' 
#' -   Microsoft_Project_2024_Professional_64Bit
#' 
#' -   Microsoft_Office_2021_LTSC_Standard_32Bit
#' 
#' -   Microsoft_Office_2021_LTSC_Standard_64Bit
#' 
#' -   Microsoft_Office_2024_LTSC_Standard_32Bit
#' 
#' -   Microsoft_Office_2024_LTSC_Standard_64Bit
#' 
#' -   Microsoft_Visio_2021_LTSC_Standard_32Bit
#' 
#' -   Microsoft_Visio_2021_LTSC_Standard_64Bit
#' 
#' -   Microsoft_Visio_2024_LTSC_Standard_32Bit
#' 
#' -   Microsoft_Visio_2024_LTSC_Standard_64Bit
#' 
#' -   Microsoft_Project_2021_Standard_32Bit
#' 
#' -   Microsoft_Project_2021_Standard_64Bit
#' 
#' -   Microsoft_Project_2024_Standard_32Bit
#' 
#' -   Microsoft_Project_2024_Standard_64Bit
#'
#' @keywords internal
#'
#' @rdname appstream_associate_software_to_image_builder
appstream_associate_software_to_image_builder <- function(ImageBuilderName, SoftwareNames) {
  op <- new_operation(
    name = "AssociateSoftwareToImageBuilder",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .appstream$associate_software_to_image_builder_input(ImageBuilderName = ImageBuilderName, SoftwareNames = SoftwareNames)
  output <- .appstream$associate_software_to_image_builder_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$associate_software_to_image_builder <- appstream_associate_software_to_image_builder

#' Associates the specified users with the specified stacks
#'
#' @description
#' Associates the specified users with the specified stacks. Users in a user pool cannot be assigned to stacks with fleets that are joined to an Active Directory domain.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_batch_associate_user_stack/](https://www.paws-r-sdk.com/docs/appstream_batch_associate_user_stack/) for full documentation.
#'
#' @param UserStackAssociations &#91;required&#93; The list of UserStackAssociation objects.
#'
#' @keywords internal
#'
#' @rdname appstream_batch_associate_user_stack
appstream_batch_associate_user_stack <- function(UserStackAssociations) {
  op <- new_operation(
    name = "BatchAssociateUserStack",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .appstream$batch_associate_user_stack_input(UserStackAssociations = UserStackAssociations)
  output <- .appstream$batch_associate_user_stack_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$batch_associate_user_stack <- appstream_batch_associate_user_stack

#' Disassociates the specified users from the specified stacks
#'
#' @description
#' Disassociates the specified users from the specified stacks.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_batch_disassociate_user_stack/](https://www.paws-r-sdk.com/docs/appstream_batch_disassociate_user_stack/) for full documentation.
#'
#' @param UserStackAssociations &#91;required&#93; The list of UserStackAssociation objects.
#'
#' @keywords internal
#'
#' @rdname appstream_batch_disassociate_user_stack
appstream_batch_disassociate_user_stack <- function(UserStackAssociations) {
  op <- new_operation(
    name = "BatchDisassociateUserStack",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .appstream$batch_disassociate_user_stack_input(UserStackAssociations = UserStackAssociations)
  output <- .appstream$batch_disassociate_user_stack_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$batch_disassociate_user_stack <- appstream_batch_disassociate_user_stack

#' Copies the image within the same region or to a new region within the
#' same AWS account
#'
#' @description
#' Copies the image within the same region or to a new region within the same AWS account. Note that any tags you added to the image will not be copied.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_copy_image/](https://www.paws-r-sdk.com/docs/appstream_copy_image/) for full documentation.
#'
#' @param SourceImageName &#91;required&#93; The name of the image to copy.
#' @param DestinationImageName &#91;required&#93; The name that the image will have when it is copied to the destination.
#' @param DestinationRegion &#91;required&#93; The destination region to which the image will be copied. This parameter is required, even if you are copying an image within the same region.
#' @param DestinationImageDescription The description that the image will have when it is copied to the destination.
#'
#' @keywords internal
#'
#' @rdname appstream_copy_image
appstream_copy_image <- function(SourceImageName, DestinationImageName, DestinationRegion, DestinationImageDescription = NULL) {
  op <- new_operation(
    name = "CopyImage",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .appstream$copy_image_input(SourceImageName = SourceImageName, DestinationImageName = DestinationImageName, DestinationRegion = DestinationRegion, DestinationImageDescription = DestinationImageDescription)
  output <- .appstream$copy_image_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$copy_image <- appstream_copy_image

#' Creates an app block
#'
#' @description
#' Creates an app block.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_create_app_block/](https://www.paws-r-sdk.com/docs/appstream_create_app_block/) for full documentation.
#'
#' @param Name &#91;required&#93; The name of the app block.
#' @param Description The description of the app block.
#' @param DisplayName The display name of the app block. This is not displayed to the user.
#' @param SourceS3Location &#91;required&#93; The source S3 location of the app block.
#' @param SetupScriptDetails The setup script details of the app block. This must be provided for the `CUSTOM` PackagingType.
#' @param Tags The tags assigned to the app block.
#' @param PostSetupScriptDetails The post setup script details of the app block. This can only be provided for the `APPSTREAM2` PackagingType.
#' @param PackagingType The packaging type of the app block.
#'
#' @keywords internal
#'
#' @rdname appstream_create_app_block
appstream_create_app_block <- function(Name, Description = NULL, DisplayName = NULL, SourceS3Location, SetupScriptDetails = NULL, Tags = NULL, PostSetupScriptDetails = NULL, PackagingType = NULL) {
  op <- new_operation(
    name = "CreateAppBlock",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .appstream$create_app_block_input(Name = Name, Description = Description, DisplayName = DisplayName, SourceS3Location = SourceS3Location, SetupScriptDetails = SetupScriptDetails, Tags = Tags, PostSetupScriptDetails = PostSetupScriptDetails, PackagingType = PackagingType)
  output <- .appstream$create_app_block_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$create_app_block <- appstream_create_app_block

#' Creates an app block builder
#'
#' @description
#' Creates an app block builder.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_create_app_block_builder/](https://www.paws-r-sdk.com/docs/appstream_create_app_block_builder/) for full documentation.
#'
#' @param Name &#91;required&#93; The unique name for the app block builder.
#' @param Description The description of the app block builder.
#' @param DisplayName The display name of the app block builder.
#' @param Tags The tags to associate with the app block builder. A tag is a key-value pair, and the value is optional. For example, Environment=Test. If you do not specify a value, Environment=.
#' 
#' If you do not specify a value, the value is set to an empty string.
#' 
#' Generally allowed characters are: letters, numbers, and spaces representable in UTF-8, and the following special characters:
#' 
#' _ . : / = + \\ - @@
#' 
#' For more information, see [Tagging Your Resources](https://docs.aws.amazon.com/appstream2/latest/developerguide/tagging-basic.html) in the *Amazon WorkSpaces Applications Administration Guide*.
#' @param Platform &#91;required&#93; The platform of the app block builder.
#' 
#' `WINDOWS_SERVER_2019` is the only valid value.
#' @param InstanceType &#91;required&#93; The instance type to use when launching the app block builder. The following instance types are available:
#' 
#' -   stream.standard.small
#' 
#' -   stream.standard.medium
#' 
#' -   stream.standard.large
#' 
#' -   stream.standard.xlarge
#' 
#' -   stream.standard.2xlarge
#' @param VpcConfig &#91;required&#93; The VPC configuration for the app block builder.
#' 
#' App block builders require that you specify at least two subnets in different availability zones.
#' @param EnableDefaultInternetAccess Enables or disables default internet access for the app block builder.
#' @param IamRoleArn The Amazon Resource Name (ARN) of the IAM role to apply to the app block builder. To assume a role, the app block builder calls the AWS Security Token Service (STS) `AssumeRole` API operation and passes the ARN of the role to use. The operation creates a new session with temporary credentials. WorkSpaces Applications retrieves the temporary credentials and creates the **appstream_machine_role** credential profile on the instance.
#' 
#' For more information, see [Using an IAM Role to Grant Permissions to Applications and Scripts Running on WorkSpaces Applications Streaming Instances](https://docs.aws.amazon.com/appstream2/latest/developerguide/using-iam-roles-to-grant-permissions-to-applications-scripts-streaming-instances.html) in the *Amazon WorkSpaces Applications Administration Guide*.
#' @param AccessEndpoints The list of interface VPC endpoint (interface endpoint) objects. Administrators can connect to the app block builder only through the specified endpoints.
#' @param DisableIMDSV1 Set to true to disable Instance Metadata Service Version 1 (IMDSv1) and enforce IMDSv2. Set to false to enable both IMDSv1 and IMDSv2.
#'
#' @keywords internal
#'
#' @rdname appstream_create_app_block_builder
appstream_create_app_block_builder <- function(Name, Description = NULL, DisplayName = NULL, Tags = NULL, Platform, InstanceType, VpcConfig, EnableDefaultInternetAccess = NULL, IamRoleArn = NULL, AccessEndpoints = NULL, DisableIMDSV1 = NULL) {
  op <- new_operation(
    name = "CreateAppBlockBuilder",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .appstream$create_app_block_builder_input(Name = Name, Description = Description, DisplayName = DisplayName, Tags = Tags, Platform = Platform, InstanceType = InstanceType, VpcConfig = VpcConfig, EnableDefaultInternetAccess = EnableDefaultInternetAccess, IamRoleArn = IamRoleArn, AccessEndpoints = AccessEndpoints, DisableIMDSV1 = DisableIMDSV1)
  output <- .appstream$create_app_block_builder_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$create_app_block_builder <- appstream_create_app_block_builder

#' Creates a URL to start a create app block builder streaming session
#'
#' @description
#' Creates a URL to start a create app block builder streaming session.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_create_app_block_builder_streaming_url/](https://www.paws-r-sdk.com/docs/appstream_create_app_block_builder_streaming_url/) for full documentation.
#'
#' @param AppBlockBuilderName &#91;required&#93; The name of the app block builder.
#' @param Validity The time that the streaming URL will be valid, in seconds. Specify a value between 1 and 604800 seconds. The default is 3600 seconds.
#'
#' @keywords internal
#'
#' @rdname appstream_create_app_block_builder_streaming_url
appstream_create_app_block_builder_streaming_url <- function(AppBlockBuilderName, Validity = NULL) {
  op <- new_operation(
    name = "CreateAppBlockBuilderStreamingURL",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .appstream$create_app_block_builder_streaming_url_input(AppBlockBuilderName = AppBlockBuilderName, Validity = Validity)
  output <- .appstream$create_app_block_builder_streaming_url_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$create_app_block_builder_streaming_url <- appstream_create_app_block_builder_streaming_url

#' Creates an application
#'
#' @description
#' Creates an application.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_create_application/](https://www.paws-r-sdk.com/docs/appstream_create_application/) for full documentation.
#'
#' @param Name &#91;required&#93; The name of the application. This name is visible to users when display name is not specified.
#' @param DisplayName The display name of the application. This name is visible to users in the application catalog.
#' @param Description The description of the application.
#' @param IconS3Location &#91;required&#93; The location in S3 of the application icon.
#' @param LaunchPath &#91;required&#93; The launch path of the application.
#' @param WorkingDirectory The working directory of the application.
#' @param LaunchParameters The launch parameters of the application.
#' @param Platforms &#91;required&#93; The platforms the application supports. WINDOWS_SERVER_2019, AMAZON_LINUX2 and UBUNTU_PRO_2404 are supported for Elastic fleets.
#' @param InstanceFamilies &#91;required&#93; The instance families the application supports. Valid values are GENERAL_PURPOSE and GRAPHICS_G4.
#' @param AppBlockArn &#91;required&#93; The app block ARN to which the application should be associated
#' @param Tags The tags assigned to the application.
#'
#' @keywords internal
#'
#' @rdname appstream_create_application
appstream_create_application <- function(Name, DisplayName = NULL, Description = NULL, IconS3Location, LaunchPath, WorkingDirectory = NULL, LaunchParameters = NULL, Platforms, InstanceFamilies, AppBlockArn, Tags = NULL) {
  op <- new_operation(
    name = "CreateApplication",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .appstream$create_application_input(Name = Name, DisplayName = DisplayName, Description = Description, IconS3Location = IconS3Location, LaunchPath = LaunchPath, WorkingDirectory = WorkingDirectory, LaunchParameters = LaunchParameters, Platforms = Platforms, InstanceFamilies = InstanceFamilies, AppBlockArn = AppBlockArn, Tags = Tags)
  output <- .appstream$create_application_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$create_application <- appstream_create_application

#' Creates a Directory Config object in WorkSpaces Applications
#'
#' @description
#' Creates a Directory Config object in WorkSpaces Applications. This object includes the configuration information required to join fleets and image builders to Microsoft Active Directory domains.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_create_directory_config/](https://www.paws-r-sdk.com/docs/appstream_create_directory_config/) for full documentation.
#'
#' @param DirectoryName &#91;required&#93; The fully qualified name of the directory (for example, corp.example.com).
#' @param OrganizationalUnitDistinguishedNames &#91;required&#93; The distinguished names of the organizational units for computer accounts.
#' @param ServiceAccountCredentials The credentials for the service account used by the fleet or image builder to connect to the directory.
#' @param CertificateBasedAuthProperties The certificate-based authentication properties used to authenticate SAML 2.0 Identity Provider (IdP) user identities to Active Directory domain-joined streaming instances. Fallback is turned on by default when certificate-based authentication is **Enabled** . Fallback allows users to log in using their AD domain password if certificate-based authentication is unsuccessful, or to unlock a desktop lock screen. **Enabled_no_directory_login_fallback** enables certificate-based authentication, but does not allow users to log in using their AD domain password. Users will be disconnected to re-authenticate using certificates.
#'
#' @keywords internal
#'
#' @rdname appstream_create_directory_config
appstream_create_directory_config <- function(DirectoryName, OrganizationalUnitDistinguishedNames, ServiceAccountCredentials = NULL, CertificateBasedAuthProperties = NULL) {
  op <- new_operation(
    name = "CreateDirectoryConfig",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .appstream$create_directory_config_input(DirectoryName = DirectoryName, OrganizationalUnitDistinguishedNames = OrganizationalUnitDistinguishedNames, ServiceAccountCredentials = ServiceAccountCredentials, CertificateBasedAuthProperties = CertificateBasedAuthProperties)
  output <- .appstream$create_directory_config_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$create_directory_config <- appstream_create_directory_config

#' Creates a new entitlement
#'
#' @description
#' Creates a new entitlement. Entitlements control access to specific applications within a stack, based on user attributes. Entitlements apply to SAML 2.0 federated user identities. WorkSpaces Applications user pool and streaming URL users are entitled to all applications in a stack. Entitlements don't apply to the desktop stream view application, or to applications managed by a dynamic app provider using the Dynamic Application Framework.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_create_entitlement/](https://www.paws-r-sdk.com/docs/appstream_create_entitlement/) for full documentation.
#'
#' @param Name &#91;required&#93; The name of the entitlement.
#' @param StackName &#91;required&#93; The name of the stack with which the entitlement is associated.
#' @param Description The description of the entitlement.
#' @param AppVisibility &#91;required&#93; Specifies whether all or selected apps are entitled.
#' @param Attributes &#91;required&#93; The attributes of the entitlement.
#'
#' @keywords internal
#'
#' @rdname appstream_create_entitlement
appstream_create_entitlement <- function(Name, StackName, Description = NULL, AppVisibility, Attributes) {
  op <- new_operation(
    name = "CreateEntitlement",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .appstream$create_entitlement_input(Name = Name, StackName = StackName, Description = Description, AppVisibility = AppVisibility, Attributes = Attributes)
  output <- .appstream$create_entitlement_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$create_entitlement <- appstream_create_entitlement

#' Creates a task to export a WorkSpaces Applications image to an EC2 AMI
#'
#' @description
#' Creates a task to export a WorkSpaces Applications image to an EC2 AMI. This allows you to use your customized WorkSpaces Applications images with other AWS services or for backup purposes.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_create_export_image_task/](https://www.paws-r-sdk.com/docs/appstream_create_export_image_task/) for full documentation.
#'
#' @param ImageName &#91;required&#93; The name of the WorkSpaces Applications image to export. The image must be in an available state and owned by your account.
#' @param AmiName &#91;required&#93; The name for the exported EC2 AMI. This is a required field that must be unique within your account and region.
#' @param IamRoleArn &#91;required&#93; The ARN of the IAM role that allows WorkSpaces Applications to create the AMI. The role must have permissions to copy images, describe images, and create tags, with a trust relationship allowing appstream.amazonaws.com to assume the role.
#' @param TagSpecifications The tags to apply to the exported AMI. These tags help you organize and manage your EC2 AMIs.
#' @param AmiDescription An optional description for the exported AMI. This description will be applied to the resulting EC2 AMI.
#'
#' @keywords internal
#'
#' @rdname appstream_create_export_image_task
appstream_create_export_image_task <- function(ImageName, AmiName, IamRoleArn, TagSpecifications = NULL, AmiDescription = NULL) {
  op <- new_operation(
    name = "CreateExportImageTask",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .appstream$create_export_image_task_input(ImageName = ImageName, AmiName = AmiName, IamRoleArn = IamRoleArn, TagSpecifications = TagSpecifications, AmiDescription = AmiDescription)
  output <- .appstream$create_export_image_task_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$create_export_image_task <- appstream_create_export_image_task

#' Creates a fleet
#'
#' @description
#' Creates a fleet. A fleet consists of streaming instances that your users access for their applications and desktops.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_create_fleet/](https://www.paws-r-sdk.com/docs/appstream_create_fleet/) for full documentation.
#'
#' @param Name &#91;required&#93; A unique name for the fleet.
#' @param ImageName The name of the image used to create the fleet.
#' @param ImageArn The ARN of the public, private, or shared image to use.
#' @param InstanceType &#91;required&#93; The instance type to use when launching fleet instances. The following instance types are available:
#' 
#' -   stream.standard.small
#' 
#' -   stream.standard.medium
#' 
#' -   stream.standard.large
#' 
#' -   stream.standard.xlarge
#' 
#' -   stream.standard.2xlarge
#' 
#' -   stream.compute.large
#' 
#' -   stream.compute.xlarge
#' 
#' -   stream.compute.2xlarge
#' 
#' -   stream.compute.4xlarge
#' 
#' -   stream.compute.8xlarge
#' 
#' -   stream.memory.large
#' 
#' -   stream.memory.xlarge
#' 
#' -   stream.memory.2xlarge
#' 
#' -   stream.memory.4xlarge
#' 
#' -   stream.memory.8xlarge
#' 
#' -   stream.memory.z1d.large
#' 
#' -   stream.memory.z1d.xlarge
#' 
#' -   stream.memory.z1d.2xlarge
#' 
#' -   stream.memory.z1d.3xlarge
#' 
#' -   stream.memory.z1d.6xlarge
#' 
#' -   stream.memory.z1d.12xlarge
#' 
#' -   stream.graphics.g4dn.xlarge
#' 
#' -   stream.graphics.g4dn.2xlarge
#' 
#' -   stream.graphics.g4dn.4xlarge
#' 
#' -   stream.graphics.g4dn.8xlarge
#' 
#' -   stream.graphics.g4dn.12xlarge
#' 
#' -   stream.graphics.g4dn.16xlarge
#' 
#' -   stream.graphics.g5.xlarge
#' 
#' -   stream.graphics.g5.2xlarge
#' 
#' -   stream.graphics.g5.4xlarge
#' 
#' -   stream.graphics.g5.8xlarge
#' 
#' -   stream.graphics.g5.12xlarge
#' 
#' -   stream.graphics.g5.16xlarge
#' 
#' -   stream.graphics.g5.24xlarge
#' 
#' -   stream.graphics.g6.xlarge
#' 
#' -   stream.graphics.g6.2xlarge
#' 
#' -   stream.graphics.g6.4xlarge
#' 
#' -   stream.graphics.g6.8xlarge
#' 
#' -   stream.graphics.g6.16xlarge
#' 
#' -   stream.graphics.g6.12xlarge
#' 
#' -   stream.graphics.g6.24xlarge
#' 
#' -   stream.graphics.gr6.4xlarge
#' 
#' -   stream.graphics.gr6.8xlarge
#' 
#' -   stream.graphics.g6f.large
#' 
#' -   stream.graphics.g6f.xlarge
#' 
#' -   stream.graphics.g6f.2xlarge
#' 
#' -   stream.graphics.g6f.4xlarge
#' 
#' -   stream.graphics.gr6f.4xlarge
#' 
#' The following instance types are available for Elastic fleets:
#' 
#' -   stream.standard.small
#' 
#' -   stream.standard.medium
#' 
#' -   stream.standard.large
#' 
#' -   stream.standard.xlarge
#' 
#' -   stream.standard.2xlarge
#' @param FleetType The fleet type.
#' 
#' **ALWAYS_ON**
#' 
#' Provides users with instant-on access to their apps. You are charged for all running instances in your fleet, even if no users are streaming apps.
#' 
#' **ON_DEMAND**
#' 
#' Provide users with access to applications after they connect, which takes one to two minutes. You are charged for instance streaming when users are connected and a small hourly fee for instances that are not streaming apps.
#' @param ComputeCapacity The desired capacity for the fleet. This is not allowed for Elastic fleets. For Elastic fleets, specify MaxConcurrentSessions instead.
#' @param VpcConfig The VPC configuration for the fleet. This is required for Elastic fleets, but not required for other fleet types. Elastic fleets require that you specify at least two subnets in different availability zones.
#' @param MaxUserDurationInSeconds The maximum amount of time that a streaming session can remain active, in seconds. If users are still connected to a streaming instance five minutes before this limit is reached, they are prompted to save any open documents before being disconnected. After this time elapses, the instance is terminated and replaced by a new instance.
#' 
#' Specify a value between 600 and 432000.
#' @param DisconnectTimeoutInSeconds The amount of time that a streaming session remains active after users disconnect. If users try to reconnect to the streaming session after a disconnection or network interruption within this time interval, they are connected to their previous session. Otherwise, they are connected to a new session with a new streaming instance.
#' 
#' Specify a value between 60 and 36000.
#' @param Description The description to display.
#' @param DisplayName The fleet name to display.
#' @param EnableDefaultInternetAccess Enables or disables default internet access for the fleet.
#' @param DomainJoinInfo The name of the directory and organizational unit (OU) to use to join the fleet to a Microsoft Active Directory domain. This is not allowed for Elastic fleets.
#' @param Tags The tags to associate with the fleet. A tag is a key-value pair, and the value is optional. For example, Environment=Test. If you do not specify a value, Environment=.
#' 
#' If you do not specify a value, the value is set to an empty string.
#' 
#' Generally allowed characters are: letters, numbers, and spaces representable in UTF-8, and the following special characters:
#' 
#' _ . : / = + \\ - @@
#' 
#' For more information, see [Tagging Your Resources](https://docs.aws.amazon.com/appstream2/latest/developerguide/tagging-basic.html) in the *Amazon WorkSpaces Applications Administration Guide*.
#' @param IdleDisconnectTimeoutInSeconds The amount of time that users can be idle (inactive) before they are disconnected from their streaming session and the `DisconnectTimeoutInSeconds` time interval begins. Users are notified before they are disconnected due to inactivity. If they try to reconnect to the streaming session before the time interval specified in `DisconnectTimeoutInSeconds` elapses, they are connected to their previous session. Users are considered idle when they stop providing keyboard or mouse input during their streaming session. File uploads and downloads, audio in, audio out, and pixels changing do not qualify as user activity. If users continue to be idle after the time interval in `IdleDisconnectTimeoutInSeconds` elapses, they are disconnected.
#' 
#' To prevent users from being disconnected due to inactivity, specify a value of 0. Otherwise, specify a value between 60 and 36000. The default value is 0.
#' 
#' If you enable this feature, we recommend that you specify a value that corresponds exactly to a whole number of minutes (for example, 60, 120, and 180). If you don't do this, the value is rounded to the nearest minute. For example, if you specify a value of 70, users are disconnected after 1 minute of inactivity. If you specify a value that is at the midpoint between two different minutes, the value is rounded up. For example, if you specify a value of 90, users are disconnected after 2 minutes of inactivity.
#' @param IamRoleArn The Amazon Resource Name (ARN) of the IAM role to apply to the fleet. To assume a role, a fleet instance calls the AWS Security Token Service (STS) `AssumeRole` API operation and passes the ARN of the role to use. The operation creates a new session with temporary credentials. WorkSpaces Applications retrieves the temporary credentials and creates the **appstream_machine_role** credential profile on the instance.
#' 
#' For more information, see [Using an IAM Role to Grant Permissions to Applications and Scripts Running on WorkSpaces Applications Streaming Instances](https://docs.aws.amazon.com/appstream2/latest/developerguide/using-iam-roles-to-grant-permissions-to-applications-scripts-streaming-instances.html) in the *Amazon WorkSpaces Applications Administration Guide*.
#' @param StreamView The WorkSpaces Applications view that is displayed to your users when they stream from the fleet. When `APP` is specified, only the windows of applications opened by users display. When `DESKTOP` is specified, the standard desktop that is provided by the operating system displays.
#' 
#' The default value is `APP`.
#' @param Platform The fleet platform. WINDOWS_SERVER_2019, AMAZON_LINUX2 and UBUNTU_PRO_2404 are supported for Elastic fleets.
#' @param MaxConcurrentSessions The maximum concurrent sessions of the Elastic fleet. This is required for Elastic fleets, and not allowed for other fleet types.
#' @param UsbDeviceFilterStrings The USB device filter strings that specify which USB devices a user can redirect to the fleet streaming session, when using the Windows native client. This is allowed but not required for Elastic fleets.
#' @param SessionScriptS3Location The S3 location of the session scripts configuration zip file. This only applies to Elastic fleets.
#' @param MaxSessionsPerInstance The maximum number of user sessions on an instance. This only applies to multi-session fleets.
#' @param RootVolumeConfig The configuration for the root volume of fleet instances. Use this to customize storage capacity from 200 GB up to 500 GB based on your application requirements.
#' @param DisableIMDSV1 Set to true to disable Instance Metadata Service Version 1 (IMDSv1) and enforce IMDSv2. Set to false to enable both IMDSv1 and IMDSv2.
#' 
#' Before disabling IMDSv1, ensure your WorkSpaces Applications images are running the agent version or managed image update released on or after January 16, 2024 to support IMDSv2 enforcement.
#'
#' @keywords internal
#'
#' @rdname appstream_create_fleet
appstream_create_fleet <- function(Name, ImageName = NULL, ImageArn = NULL, InstanceType, FleetType = NULL, ComputeCapacity = NULL, VpcConfig = NULL, MaxUserDurationInSeconds = NULL, DisconnectTimeoutInSeconds = NULL, Description = NULL, DisplayName = NULL, EnableDefaultInternetAccess = NULL, DomainJoinInfo = NULL, Tags = NULL, IdleDisconnectTimeoutInSeconds = NULL, IamRoleArn = NULL, StreamView = NULL, Platform = NULL, MaxConcurrentSessions = NULL, UsbDeviceFilterStrings = NULL, SessionScriptS3Location = NULL, MaxSessionsPerInstance = NULL, RootVolumeConfig = NULL, DisableIMDSV1 = NULL) {
  op <- new_operation(
    name = "CreateFleet",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .appstream$create_fleet_input(Name = Name, ImageName = ImageName, ImageArn = ImageArn, InstanceType = InstanceType, FleetType = FleetType, ComputeCapacity = ComputeCapacity, VpcConfig = VpcConfig, MaxUserDurationInSeconds = MaxUserDurationInSeconds, DisconnectTimeoutInSeconds = DisconnectTimeoutInSeconds, Description = Description, DisplayName = DisplayName, EnableDefaultInternetAccess = EnableDefaultInternetAccess, DomainJoinInfo = DomainJoinInfo, Tags = Tags, IdleDisconnectTimeoutInSeconds = IdleDisconnectTimeoutInSeconds, IamRoleArn = IamRoleArn, StreamView = StreamView, Platform = Platform, MaxConcurrentSessions = MaxConcurrentSessions, UsbDeviceFilterStrings = UsbDeviceFilterStrings, SessionScriptS3Location = SessionScriptS3Location, MaxSessionsPerInstance = MaxSessionsPerInstance, RootVolumeConfig = RootVolumeConfig, DisableIMDSV1 = DisableIMDSV1)
  output <- .appstream$create_fleet_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$create_fleet <- appstream_create_fleet

#' Creates an image builder
#'
#' @description
#' Creates an image builder. An image builder is a virtual machine that is used to create an image.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_create_image_builder/](https://www.paws-r-sdk.com/docs/appstream_create_image_builder/) for full documentation.
#'
#' @param Name &#91;required&#93; A unique name for the image builder.
#' @param ImageName The name of the image used to create the image builder.
#' @param ImageArn The ARN of the public, private, or shared image to use.
#' @param InstanceType &#91;required&#93; The instance type to use when launching the image builder. The following instance types are available:
#' 
#' -   stream.standard.small
#' 
#' -   stream.standard.medium
#' 
#' -   stream.standard.large
#' 
#' -   stream.compute.large
#' 
#' -   stream.compute.xlarge
#' 
#' -   stream.compute.2xlarge
#' 
#' -   stream.compute.4xlarge
#' 
#' -   stream.compute.8xlarge
#' 
#' -   stream.memory.large
#' 
#' -   stream.memory.xlarge
#' 
#' -   stream.memory.2xlarge
#' 
#' -   stream.memory.4xlarge
#' 
#' -   stream.memory.8xlarge
#' 
#' -   stream.memory.z1d.large
#' 
#' -   stream.memory.z1d.xlarge
#' 
#' -   stream.memory.z1d.2xlarge
#' 
#' -   stream.memory.z1d.3xlarge
#' 
#' -   stream.memory.z1d.6xlarge
#' 
#' -   stream.memory.z1d.12xlarge
#' 
#' -   stream.graphics.g4dn.xlarge
#' 
#' -   stream.graphics.g4dn.2xlarge
#' 
#' -   stream.graphics.g4dn.4xlarge
#' 
#' -   stream.graphics.g4dn.8xlarge
#' 
#' -   stream.graphics.g4dn.12xlarge
#' 
#' -   stream.graphics.g4dn.16xlarge
#' 
#' -   stream.graphics.g5.xlarge
#' 
#' -   stream.graphics.g5.2xlarge
#' 
#' -   stream.graphics.g5.4xlarge
#' 
#' -   stream.graphics.g5.8xlarge
#' 
#' -   stream.graphics.g5.16xlarge
#' 
#' -   stream.graphics.g5.12xlarge
#' 
#' -   stream.graphics.g5.24xlarge
#' 
#' -   stream.graphics.g6.xlarge
#' 
#' -   stream.graphics.g6.2xlarge
#' 
#' -   stream.graphics.g6.4xlarge
#' 
#' -   stream.graphics.g6.8xlarge
#' 
#' -   stream.graphics.g6.16xlarge
#' 
#' -   stream.graphics.g6.12xlarge
#' 
#' -   stream.graphics.g6.24xlarge
#' 
#' -   stream.graphics.gr6.4xlarge
#' 
#' -   stream.graphics.gr6.8xlarge
#' 
#' -   stream.graphics.g6f.large
#' 
#' -   stream.graphics.g6f.xlarge
#' 
#' -   stream.graphics.g6f.2xlarge
#' 
#' -   stream.graphics.g6f.4xlarge
#' 
#' -   stream.graphics.gr6f.4xlarge
#' @param Description The description to display.
#' @param DisplayName The image builder name to display.
#' @param VpcConfig The VPC configuration for the image builder. You can specify only one subnet.
#' @param IamRoleArn The Amazon Resource Name (ARN) of the IAM role to apply to the image builder. To assume a role, the image builder calls the AWS Security Token Service (STS) `AssumeRole` API operation and passes the ARN of the role to use. The operation creates a new session with temporary credentials. WorkSpaces Applications retrieves the temporary credentials and creates the **appstream_machine_role** credential profile on the instance.
#' 
#' For more information, see [Using an IAM Role to Grant Permissions to Applications and Scripts Running on WorkSpaces Applications Streaming Instances](https://docs.aws.amazon.com/appstream2/latest/developerguide/using-iam-roles-to-grant-permissions-to-applications-scripts-streaming-instances.html) in the *Amazon WorkSpaces Applications Administration Guide*.
#' @param EnableDefaultInternetAccess Enables or disables default internet access for the image builder.
#' @param DomainJoinInfo The name of the directory and organizational unit (OU) to use to join the image builder to a Microsoft Active Directory domain.
#' @param AppstreamAgentVersion The version of the WorkSpaces Applications agent to use for this image builder. To use the latest version of the WorkSpaces Applications agent, specify \[LATEST\].
#' @param Tags The tags to associate with the image builder. A tag is a key-value pair, and the value is optional. For example, Environment=Test. If you do not specify a value, Environment=.
#' 
#' Generally allowed characters are: letters, numbers, and spaces representable in UTF-8, and the following special characters:
#' 
#' _ . : / = + \\ - @@
#' 
#' If you do not specify a value, the value is set to an empty string.
#' 
#' For more information about tags, see [Tagging Your Resources](https://docs.aws.amazon.com/appstream2/latest/developerguide/tagging-basic.html) in the *Amazon WorkSpaces Applications Administration Guide*.
#' @param AccessEndpoints The list of interface VPC endpoint (interface endpoint) objects. Administrators can connect to the image builder only through the specified endpoints.
#' @param RootVolumeConfig The configuration for the root volume of the image builder. Use this to customize storage capacity from 200 GB up to 500 GB based on your application installation requirements.
#' @param SoftwaresToInstall The list of license included applications to install on the image builder during creation.
#' 
#' Possible values include the following:
#' 
#' -   Microsoft_Office_2021_LTSC_Professional_Plus_32Bit
#' 
#' -   Microsoft_Office_2021_LTSC_Professional_Plus_64Bit
#' 
#' -   Microsoft_Office_2024_LTSC_Professional_Plus_32Bit
#' 
#' -   Microsoft_Office_2024_LTSC_Professional_Plus_64Bit
#' 
#' -   Microsoft_Visio_2021_LTSC_Professional_32Bit
#' 
#' -   Microsoft_Visio_2021_LTSC_Professional_64Bit
#' 
#' -   Microsoft_Visio_2024_LTSC_Professional_32Bit
#' 
#' -   Microsoft_Visio_2024_LTSC_Professional_64Bit
#' 
#' -   Microsoft_Project_2021_Professional_32Bit
#' 
#' -   Microsoft_Project_2021_Professional_64Bit
#' 
#' -   Microsoft_Project_2024_Professional_32Bit
#' 
#' -   Microsoft_Project_2024_Professional_64Bit
#' 
#' -   Microsoft_Office_2021_LTSC_Standard_32Bit
#' 
#' -   Microsoft_Office_2021_LTSC_Standard_64Bit
#' 
#' -   Microsoft_Office_2024_LTSC_Standard_32Bit
#' 
#' -   Microsoft_Office_2024_LTSC_Standard_64Bit
#' 
#' -   Microsoft_Visio_2021_LTSC_Standard_32Bit
#' 
#' -   Microsoft_Visio_2021_LTSC_Standard_64Bit
#' 
#' -   Microsoft_Visio_2024_LTSC_Standard_32Bit
#' 
#' -   Microsoft_Visio_2024_LTSC_Standard_64Bit
#' 
#' -   Microsoft_Project_2021_Standard_32Bit
#' 
#' -   Microsoft_Project_2021_Standard_64Bit
#' 
#' -   Microsoft_Project_2024_Standard_32Bit
#' 
#' -   Microsoft_Project_2024_Standard_64Bit
#' @param SoftwaresToUninstall The list of license included applications to uninstall from the image builder during creation.
#' 
#' Possible values include the following:
#' 
#' -   Microsoft_Office_2021_LTSC_Professional_Plus_32Bit
#' 
#' -   Microsoft_Office_2021_LTSC_Professional_Plus_64Bit
#' 
#' -   Microsoft_Office_2024_LTSC_Professional_Plus_32Bit
#' 
#' -   Microsoft_Office_2024_LTSC_Professional_Plus_64Bit
#' 
#' -   Microsoft_Visio_2021_LTSC_Professional_32Bit
#' 
#' -   Microsoft_Visio_2021_LTSC_Professional_64Bit
#' 
#' -   Microsoft_Visio_2024_LTSC_Professional_32Bit
#' 
#' -   Microsoft_Visio_2024_LTSC_Professional_64Bit
#' 
#' -   Microsoft_Project_2021_Professional_32Bit
#' 
#' -   Microsoft_Project_2021_Professional_64Bit
#' 
#' -   Microsoft_Project_2024_Professional_32Bit
#' 
#' -   Microsoft_Project_2024_Professional_64Bit
#' 
#' -   Microsoft_Office_2021_LTSC_Standard_32Bit
#' 
#' -   Microsoft_Office_2021_LTSC_Standard_64Bit
#' 
#' -   Microsoft_Office_2024_LTSC_Standard_32Bit
#' 
#' -   Microsoft_Office_2024_LTSC_Standard_64Bit
#' 
#' -   Microsoft_Visio_2021_LTSC_Standard_32Bit
#' 
#' -   Microsoft_Visio_2021_LTSC_Standard_64Bit
#' 
#' -   Microsoft_Visio_2024_LTSC_Standard_32Bit
#' 
#' -   Microsoft_Visio_2024_LTSC_Standard_64Bit
#' 
#' -   Microsoft_Project_2021_Standard_32Bit
#' 
#' -   Microsoft_Project_2021_Standard_64Bit
#' 
#' -   Microsoft_Project_2024_Standard_32Bit
#' 
#' -   Microsoft_Project_2024_Standard_64Bit
#' @param DisableIMDSV1 Set to true to disable Instance Metadata Service Version 1 (IMDSv1) and enforce IMDSv2. Set to false to enable both IMDSv1 and IMDSv2.
#' 
#' Before disabling IMDSv1, ensure your WorkSpaces Applications images are running the agent version or managed image update released on or after January 16, 2024 to support IMDSv2 enforcement.
#'
#' @keywords internal
#'
#' @rdname appstream_create_image_builder
appstream_create_image_builder <- function(Name, ImageName = NULL, ImageArn = NULL, InstanceType, Description = NULL, DisplayName = NULL, VpcConfig = NULL, IamRoleArn = NULL, EnableDefaultInternetAccess = NULL, DomainJoinInfo = NULL, AppstreamAgentVersion = NULL, Tags = NULL, AccessEndpoints = NULL, RootVolumeConfig = NULL, SoftwaresToInstall = NULL, SoftwaresToUninstall = NULL, DisableIMDSV1 = NULL) {
  op <- new_operation(
    name = "CreateImageBuilder",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .appstream$create_image_builder_input(Name = Name, ImageName = ImageName, ImageArn = ImageArn, InstanceType = InstanceType, Description = Description, DisplayName = DisplayName, VpcConfig = VpcConfig, IamRoleArn = IamRoleArn, EnableDefaultInternetAccess = EnableDefaultInternetAccess, DomainJoinInfo = DomainJoinInfo, AppstreamAgentVersion = AppstreamAgentVersion, Tags = Tags, AccessEndpoints = AccessEndpoints, RootVolumeConfig = RootVolumeConfig, SoftwaresToInstall = SoftwaresToInstall, SoftwaresToUninstall = SoftwaresToUninstall, DisableIMDSV1 = DisableIMDSV1)
  output <- .appstream$create_image_builder_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$create_image_builder <- appstream_create_image_builder

#' Creates a URL to start an image builder streaming session
#'
#' @description
#' Creates a URL to start an image builder streaming session.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_create_image_builder_streaming_url/](https://www.paws-r-sdk.com/docs/appstream_create_image_builder_streaming_url/) for full documentation.
#'
#' @param Name &#91;required&#93; The name of the image builder.
#' @param Validity The time that the streaming URL will be valid, in seconds. Specify a value between 1 and 604800 seconds. The default is 3600 seconds.
#'
#' @keywords internal
#'
#' @rdname appstream_create_image_builder_streaming_url
appstream_create_image_builder_streaming_url <- function(Name, Validity = NULL) {
  op <- new_operation(
    name = "CreateImageBuilderStreamingURL",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .appstream$create_image_builder_streaming_url_input(Name = Name, Validity = Validity)
  output <- .appstream$create_image_builder_streaming_url_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$create_image_builder_streaming_url <- appstream_create_image_builder_streaming_url

#' Creates a custom WorkSpaces Applications image by importing an EC2 AMI
#'
#' @description
#' Creates a custom WorkSpaces Applications image by importing an EC2 AMI. This allows you to use your own customized AMI to create WorkSpaces Applications images that support additional instance types beyond the standard stream.* instances.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_create_imported_image/](https://www.paws-r-sdk.com/docs/appstream_create_imported_image/) for full documentation.
#'
#' @param Name &#91;required&#93; A unique name for the imported image. The name must be between 1 and 100 characters and can contain letters, numbers, underscores, periods, and hyphens.
#' @param SourceAmiId &#91;required&#93; The ID of the EC2 AMI to import. The AMI must meet specific requirements including Windows Server 2022 Full Base, UEFI boot mode, TPM 2.0 support, and proper drivers.
#' @param IamRoleArn &#91;required&#93; The ARN of the IAM role that allows WorkSpaces Applications to access your AMI. The role must have permissions to modify image attributes and describe images, with a trust relationship allowing appstream.amazonaws.com to assume the role.
#' @param Description An optional description for the imported image. The description must match approved regex patterns and can be up to 256 characters.
#' @param DisplayName An optional display name for the imported image. The display name must match approved regex patterns and can be up to 100 characters.
#' @param Tags The tags to apply to the imported image. Tags help you organize and manage your WorkSpaces Applications resources.
#' @param RuntimeValidationConfig Configuration for runtime validation of the imported image. When specified, WorkSpaces Applications provisions an instance to test streaming functionality, which helps ensure the image is suitable for use.
#' @param AgentSoftwareVersion The version of the WorkSpaces Applications agent to use for the imported image. Choose CURRENT_LATEST to use the agent version available at the time of import, or ALWAYS_LATEST to automatically update to the latest agent version when new versions are released.
#' @param AppCatalogConfig Configuration for the application catalog of the imported image. This allows you to specify applications available for streaming, including their paths, icons, and launch parameters. This field contains sensitive data.
#' @param DryRun When set to true, performs validation checks without actually creating the imported image. Use this to verify your configuration before executing the actual import operation.
#'
#' @keywords internal
#'
#' @rdname appstream_create_imported_image
appstream_create_imported_image <- function(Name, SourceAmiId, IamRoleArn, Description = NULL, DisplayName = NULL, Tags = NULL, RuntimeValidationConfig = NULL, AgentSoftwareVersion = NULL, AppCatalogConfig = NULL, DryRun = NULL) {
  op <- new_operation(
    name = "CreateImportedImage",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .appstream$create_imported_image_input(Name = Name, SourceAmiId = SourceAmiId, IamRoleArn = IamRoleArn, Description = Description, DisplayName = DisplayName, Tags = Tags, RuntimeValidationConfig = RuntimeValidationConfig, AgentSoftwareVersion = AgentSoftwareVersion, AppCatalogConfig = AppCatalogConfig, DryRun = DryRun)
  output <- .appstream$create_imported_image_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$create_imported_image <- appstream_create_imported_image

#' Creates a stack to start streaming applications to users
#'
#' @description
#' Creates a stack to start streaming applications to users. A stack consists of an associated fleet, user access policies, and storage configurations.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_create_stack/](https://www.paws-r-sdk.com/docs/appstream_create_stack/) for full documentation.
#'
#' @param Name &#91;required&#93; The name of the stack.
#' @param Description The description to display.
#' @param DisplayName The stack name to display.
#' @param StorageConnectors The storage connectors to enable.
#' @param RedirectURL The URL that users are redirected to after their streaming session ends.
#' @param FeedbackURL The URL that users are redirected to after they click the Send Feedback link. If no URL is specified, no Send Feedback link is displayed.
#' @param UserSettings The actions that are enabled or disabled for users during their streaming sessions. By default, these actions are enabled.
#' @param ApplicationSettings The persistent application settings for users of a stack. When these settings are enabled, changes that users make to applications and Windows settings are automatically saved after each session and applied to the next session.
#' @param Tags The tags to associate with the stack. A tag is a key-value pair, and the value is optional. For example, Environment=Test. If you do not specify a value, Environment=.
#' 
#' If you do not specify a value, the value is set to an empty string.
#' 
#' Generally allowed characters are: letters, numbers, and spaces representable in UTF-8, and the following special characters:
#' 
#' _ . : / = + \\ - @@
#' 
#' For more information about tags, see [Tagging Your Resources](https://docs.aws.amazon.com/appstream2/latest/developerguide/tagging-basic.html) in the *Amazon WorkSpaces Applications Administration Guide*.
#' @param AccessEndpoints The list of interface VPC endpoint (interface endpoint) objects. Users of the stack can connect to WorkSpaces Applications only through the specified endpoints.
#' @param EmbedHostDomains The domains where WorkSpaces Applications streaming sessions can be embedded in an iframe. You must approve the domains that you want to host embedded WorkSpaces Applications streaming sessions.
#' @param StreamingExperienceSettings The streaming protocol you want your stack to prefer. This can be UDP or TCP. Currently, UDP is only supported in the Windows native client.
#' @param ContentRedirection Configuration for bidirectional URL redirection between the streaming session and the local client. Use HostToClient to redirect URLs from the remote desktop to the local browser.
#' @param AgentAccessConfig The configuration for agent access on the stack. If specified, agent access is enabled for the stack.
#'
#' @keywords internal
#'
#' @rdname appstream_create_stack
appstream_create_stack <- function(Name, Description = NULL, DisplayName = NULL, StorageConnectors = NULL, RedirectURL = NULL, FeedbackURL = NULL, UserSettings = NULL, ApplicationSettings = NULL, Tags = NULL, AccessEndpoints = NULL, EmbedHostDomains = NULL, StreamingExperienceSettings = NULL, ContentRedirection = NULL, AgentAccessConfig = NULL) {
  op <- new_operation(
    name = "CreateStack",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .appstream$create_stack_input(Name = Name, Description = Description, DisplayName = DisplayName, StorageConnectors = StorageConnectors, RedirectURL = RedirectURL, FeedbackURL = FeedbackURL, UserSettings = UserSettings, ApplicationSettings = ApplicationSettings, Tags = Tags, AccessEndpoints = AccessEndpoints, EmbedHostDomains = EmbedHostDomains, StreamingExperienceSettings = StreamingExperienceSettings, ContentRedirection = ContentRedirection, AgentAccessConfig = AgentAccessConfig)
  output <- .appstream$create_stack_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$create_stack <- appstream_create_stack

#' Creates a temporary URL to start an WorkSpaces Applications streaming
#' session for the specified user
#'
#' @description
#' Creates a temporary URL to start an WorkSpaces Applications streaming session for the specified user. A streaming URL enables application streaming to be tested without user setup.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_create_streaming_url/](https://www.paws-r-sdk.com/docs/appstream_create_streaming_url/) for full documentation.
#'
#' @param StackName &#91;required&#93; The name of the stack.
#' @param FleetName &#91;required&#93; The name of the fleet.
#' @param UserId &#91;required&#93; The identifier of the user.
#' @param ApplicationId The name of the application to launch after the session starts. This is the name that you specified as **Name** in the Image Assistant. If your fleet is enabled for the **Desktop** stream view, you can also choose to launch directly to the operating system desktop. To do so, specify **Desktop**.
#' @param Validity The time that the streaming URL will be valid, in seconds. Specify a value between 1 and 604800 seconds. The default is 60 seconds.
#' @param SessionContext The session context. For more information, see [Session Context](https://docs.aws.amazon.com/appstream2/latest/developerguide/managing-stacks-fleets.html#managing-stacks-fleets-parameters) in the *Amazon WorkSpaces Applications Administration Guide*.
#'
#' @keywords internal
#'
#' @rdname appstream_create_streaming_url
appstream_create_streaming_url <- function(StackName, FleetName, UserId, ApplicationId = NULL, Validity = NULL, SessionContext = NULL) {
  op <- new_operation(
    name = "CreateStreamingURL",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .appstream$create_streaming_url_input(StackName = StackName, FleetName = FleetName, UserId = UserId, ApplicationId = ApplicationId, Validity = Validity, SessionContext = SessionContext)
  output <- .appstream$create_streaming_url_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$create_streaming_url <- appstream_create_streaming_url

#' Creates custom branding that customizes the appearance of the streaming
#' application catalog page
#'
#' @description
#' Creates custom branding that customizes the appearance of the streaming application catalog page.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_create_theme_for_stack/](https://www.paws-r-sdk.com/docs/appstream_create_theme_for_stack/) for full documentation.
#'
#' @param StackName &#91;required&#93; The name of the stack for the theme.
#' @param FooterLinks The links that are displayed in the footer of the streaming application catalog page. These links are helpful resources for users, such as the organization's IT support and product marketing sites.
#' @param TitleText &#91;required&#93; The title that is displayed at the top of the browser tab during users' application streaming sessions.
#' @param ThemeStyling &#91;required&#93; The color theme that is applied to website links, text, and buttons. These colors are also applied as accents in the background for the streaming application catalog page.
#' @param OrganizationLogoS3Location &#91;required&#93; The organization logo that appears on the streaming application catalog page.
#' @param FaviconS3Location &#91;required&#93; The S3 location of the favicon. The favicon enables users to recognize their application streaming site in a browser full of tabs or bookmarks. It is displayed at the top of the browser tab for the application streaming site during users' streaming sessions.
#'
#' @keywords internal
#'
#' @rdname appstream_create_theme_for_stack
appstream_create_theme_for_stack <- function(StackName, FooterLinks = NULL, TitleText, ThemeStyling, OrganizationLogoS3Location, FaviconS3Location) {
  op <- new_operation(
    name = "CreateThemeForStack",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .appstream$create_theme_for_stack_input(StackName = StackName, FooterLinks = FooterLinks, TitleText = TitleText, ThemeStyling = ThemeStyling, OrganizationLogoS3Location = OrganizationLogoS3Location, FaviconS3Location = FaviconS3Location)
  output <- .appstream$create_theme_for_stack_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$create_theme_for_stack <- appstream_create_theme_for_stack

#' Creates a new image with the latest Windows operating system updates,
#' driver updates, and WorkSpaces Applications agent software
#'
#' @description
#' Creates a new image with the latest Windows operating system updates, driver updates, and WorkSpaces Applications agent software.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_create_updated_image/](https://www.paws-r-sdk.com/docs/appstream_create_updated_image/) for full documentation.
#'
#' @param existingImageName &#91;required&#93; The name of the image to update.
#' @param newImageName &#91;required&#93; The name of the new image. The name must be unique within the AWS account and Region.
#' @param newImageDescription The description to display for the new image.
#' @param newImageDisplayName The name to display for the new image.
#' @param newImageTags The tags to associate with the new image. A tag is a key-value pair, and the value is optional. For example, Environment=Test. If you do not specify a value, Environment=.
#' 
#' Generally allowed characters are: letters, numbers, and spaces representable in UTF-8, and the following special characters:
#' 
#' _ . : / = + \\ - @@
#' 
#' If you do not specify a value, the value is set to an empty string.
#' 
#' For more information about tags, see [Tagging Your Resources](https://docs.aws.amazon.com/appstream2/latest/developerguide/tagging-basic.html) in the *Amazon WorkSpaces Applications Administration Guide*.
#' @param dryRun Indicates whether to display the status of image update availability before WorkSpaces Applications initiates the process of creating a new updated image. If this value is set to `true`, WorkSpaces Applications displays whether image updates are available. If this value is set to `false`, WorkSpaces Applications initiates the process of creating a new updated image without displaying whether image updates are available.
#'
#' @keywords internal
#'
#' @rdname appstream_create_updated_image
appstream_create_updated_image <- function(existingImageName, newImageName, newImageDescription = NULL, newImageDisplayName = NULL, newImageTags = NULL, dryRun = NULL) {
  op <- new_operation(
    name = "CreateUpdatedImage",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .appstream$create_updated_image_input(existingImageName = existingImageName, newImageName = newImageName, newImageDescription = newImageDescription, newImageDisplayName = newImageDisplayName, newImageTags = newImageTags, dryRun = dryRun)
  output <- .appstream$create_updated_image_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$create_updated_image <- appstream_create_updated_image

#' Creates a usage report subscription
#'
#' @description
#' Creates a usage report subscription. Usage reports are generated daily.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_create_usage_report_subscription/](https://www.paws-r-sdk.com/docs/appstream_create_usage_report_subscription/) for full documentation.
#'

#'
#' @keywords internal
#'
#' @rdname appstream_create_usage_report_subscription
appstream_create_usage_report_subscription <- function() {
  op <- new_operation(
    name = "CreateUsageReportSubscription",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .appstream$create_usage_report_subscription_input()
  output <- .appstream$create_usage_report_subscription_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$create_usage_report_subscription <- appstream_create_usage_report_subscription

#' Creates a new user in the user pool
#'
#' @description
#' Creates a new user in the user pool.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_create_user/](https://www.paws-r-sdk.com/docs/appstream_create_user/) for full documentation.
#'
#' @param UserName &#91;required&#93; The email address of the user.
#' 
#' Users' email addresses are case-sensitive. During login, if they specify an email address that doesn't use the same capitalization as the email address specified when their user pool account was created, a "user does not exist" error message displays.
#' @param MessageAction The action to take for the welcome email that is sent to a user after the user is created in the user pool. If you specify SUPPRESS, no email is sent. If you specify RESEND, do not specify the first name or last name of the user. If the value is null, the email is sent.
#' 
#' The temporary password in the welcome email is valid for only 7 days. If users don’t set their passwords within 7 days, you must send them a new welcome email.
#' @param FirstName The first name, or given name, of the user.
#' @param LastName The last name, or surname, of the user.
#' @param AuthenticationType &#91;required&#93; The authentication type for the user. You must specify USERPOOL.
#'
#' @keywords internal
#'
#' @rdname appstream_create_user
appstream_create_user <- function(UserName, MessageAction = NULL, FirstName = NULL, LastName = NULL, AuthenticationType) {
  op <- new_operation(
    name = "CreateUser",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .appstream$create_user_input(UserName = UserName, MessageAction = MessageAction, FirstName = FirstName, LastName = LastName, AuthenticationType = AuthenticationType)
  output <- .appstream$create_user_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$create_user <- appstream_create_user

#' Deletes an app block
#'
#' @description
#' Deletes an app block.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_delete_app_block/](https://www.paws-r-sdk.com/docs/appstream_delete_app_block/) for full documentation.
#'
#' @param Name &#91;required&#93; The name of the app block.
#'
#' @keywords internal
#'
#' @rdname appstream_delete_app_block
appstream_delete_app_block <- function(Name) {
  op <- new_operation(
    name = "DeleteAppBlock",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .appstream$delete_app_block_input(Name = Name)
  output <- .appstream$delete_app_block_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$delete_app_block <- appstream_delete_app_block

#' Deletes an app block builder
#'
#' @description
#' Deletes an app block builder.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_delete_app_block_builder/](https://www.paws-r-sdk.com/docs/appstream_delete_app_block_builder/) for full documentation.
#'
#' @param Name &#91;required&#93; The name of the app block builder.
#'
#' @keywords internal
#'
#' @rdname appstream_delete_app_block_builder
appstream_delete_app_block_builder <- function(Name) {
  op <- new_operation(
    name = "DeleteAppBlockBuilder",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .appstream$delete_app_block_builder_input(Name = Name)
  output <- .appstream$delete_app_block_builder_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$delete_app_block_builder <- appstream_delete_app_block_builder

#' Deletes an application
#'
#' @description
#' Deletes an application.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_delete_application/](https://www.paws-r-sdk.com/docs/appstream_delete_application/) for full documentation.
#'
#' @param Name &#91;required&#93; The name of the application.
#'
#' @keywords internal
#'
#' @rdname appstream_delete_application
appstream_delete_application <- function(Name) {
  op <- new_operation(
    name = "DeleteApplication",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .appstream$delete_application_input(Name = Name)
  output <- .appstream$delete_application_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$delete_application <- appstream_delete_application

#' Deletes the specified Directory Config object from WorkSpaces
#' Applications
#'
#' @description
#' Deletes the specified Directory Config object from WorkSpaces Applications. This object includes the information required to join streaming instances to an Active Directory domain.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_delete_directory_config/](https://www.paws-r-sdk.com/docs/appstream_delete_directory_config/) for full documentation.
#'
#' @param DirectoryName &#91;required&#93; The name of the directory configuration.
#'
#' @keywords internal
#'
#' @rdname appstream_delete_directory_config
appstream_delete_directory_config <- function(DirectoryName) {
  op <- new_operation(
    name = "DeleteDirectoryConfig",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .appstream$delete_directory_config_input(DirectoryName = DirectoryName)
  output <- .appstream$delete_directory_config_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$delete_directory_config <- appstream_delete_directory_config

#' Deletes the specified entitlement
#'
#' @description
#' Deletes the specified entitlement.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_delete_entitlement/](https://www.paws-r-sdk.com/docs/appstream_delete_entitlement/) for full documentation.
#'
#' @param Name &#91;required&#93; The name of the entitlement.
#' @param StackName &#91;required&#93; The name of the stack with which the entitlement is associated.
#'
#' @keywords internal
#'
#' @rdname appstream_delete_entitlement
appstream_delete_entitlement <- function(Name, StackName) {
  op <- new_operation(
    name = "DeleteEntitlement",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .appstream$delete_entitlement_input(Name = Name, StackName = StackName)
  output <- .appstream$delete_entitlement_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$delete_entitlement <- appstream_delete_entitlement

#' Deletes the specified fleet
#'
#' @description
#' Deletes the specified fleet.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_delete_fleet/](https://www.paws-r-sdk.com/docs/appstream_delete_fleet/) for full documentation.
#'
#' @param Name &#91;required&#93; The name of the fleet.
#'
#' @keywords internal
#'
#' @rdname appstream_delete_fleet
appstream_delete_fleet <- function(Name) {
  op <- new_operation(
    name = "DeleteFleet",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .appstream$delete_fleet_input(Name = Name)
  output <- .appstream$delete_fleet_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$delete_fleet <- appstream_delete_fleet

#' Deletes the specified image
#'
#' @description
#' Deletes the specified image. You cannot delete an image when it is in use. After you delete an image, you cannot provision new capacity using the image.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_delete_image/](https://www.paws-r-sdk.com/docs/appstream_delete_image/) for full documentation.
#'
#' @param Name &#91;required&#93; The name of the image.
#'
#' @keywords internal
#'
#' @rdname appstream_delete_image
appstream_delete_image <- function(Name) {
  op <- new_operation(
    name = "DeleteImage",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .appstream$delete_image_input(Name = Name)
  output <- .appstream$delete_image_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$delete_image <- appstream_delete_image

#' Deletes the specified image builder and releases the capacity
#'
#' @description
#' Deletes the specified image builder and releases the capacity.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_delete_image_builder/](https://www.paws-r-sdk.com/docs/appstream_delete_image_builder/) for full documentation.
#'
#' @param Name &#91;required&#93; The name of the image builder.
#'
#' @keywords internal
#'
#' @rdname appstream_delete_image_builder
appstream_delete_image_builder <- function(Name) {
  op <- new_operation(
    name = "DeleteImageBuilder",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .appstream$delete_image_builder_input(Name = Name)
  output <- .appstream$delete_image_builder_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$delete_image_builder <- appstream_delete_image_builder

#' Deletes permissions for the specified private image
#'
#' @description
#' Deletes permissions for the specified private image. After you delete permissions for an image, AWS accounts to which you previously granted these permissions can no longer use the image.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_delete_image_permissions/](https://www.paws-r-sdk.com/docs/appstream_delete_image_permissions/) for full documentation.
#'
#' @param Name &#91;required&#93; The name of the private image.
#' @param SharedAccountId &#91;required&#93; The 12-digit identifier of the AWS account for which to delete image permissions.
#'
#' @keywords internal
#'
#' @rdname appstream_delete_image_permissions
appstream_delete_image_permissions <- function(Name, SharedAccountId) {
  op <- new_operation(
    name = "DeleteImagePermissions",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .appstream$delete_image_permissions_input(Name = Name, SharedAccountId = SharedAccountId)
  output <- .appstream$delete_image_permissions_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$delete_image_permissions <- appstream_delete_image_permissions

#' Deletes the specified stack
#'
#' @description
#' Deletes the specified stack. After the stack is deleted, the application streaming environment provided by the stack is no longer available to users. Also, any reservations made for application streaming sessions for the stack are released.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_delete_stack/](https://www.paws-r-sdk.com/docs/appstream_delete_stack/) for full documentation.
#'
#' @param Name &#91;required&#93; The name of the stack.
#'
#' @keywords internal
#'
#' @rdname appstream_delete_stack
appstream_delete_stack <- function(Name) {
  op <- new_operation(
    name = "DeleteStack",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .appstream$delete_stack_input(Name = Name)
  output <- .appstream$delete_stack_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$delete_stack <- appstream_delete_stack

#' Deletes custom branding that customizes the appearance of the streaming
#' application catalog page
#'
#' @description
#' Deletes custom branding that customizes the appearance of the streaming application catalog page.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_delete_theme_for_stack/](https://www.paws-r-sdk.com/docs/appstream_delete_theme_for_stack/) for full documentation.
#'
#' @param StackName &#91;required&#93; The name of the stack for the theme.
#'
#' @keywords internal
#'
#' @rdname appstream_delete_theme_for_stack
appstream_delete_theme_for_stack <- function(StackName) {
  op <- new_operation(
    name = "DeleteThemeForStack",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .appstream$delete_theme_for_stack_input(StackName = StackName)
  output <- .appstream$delete_theme_for_stack_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$delete_theme_for_stack <- appstream_delete_theme_for_stack

#' Disables usage report generation
#'
#' @description
#' Disables usage report generation.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_delete_usage_report_subscription/](https://www.paws-r-sdk.com/docs/appstream_delete_usage_report_subscription/) for full documentation.
#'

#'
#' @keywords internal
#'
#' @rdname appstream_delete_usage_report_subscription
appstream_delete_usage_report_subscription <- function() {
  op <- new_operation(
    name = "DeleteUsageReportSubscription",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .appstream$delete_usage_report_subscription_input()
  output <- .appstream$delete_usage_report_subscription_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$delete_usage_report_subscription <- appstream_delete_usage_report_subscription

#' Deletes a user from the user pool
#'
#' @description
#' Deletes a user from the user pool.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_delete_user/](https://www.paws-r-sdk.com/docs/appstream_delete_user/) for full documentation.
#'
#' @param UserName &#91;required&#93; The email address of the user.
#' 
#' Users' email addresses are case-sensitive.
#' @param AuthenticationType &#91;required&#93; The authentication type for the user. You must specify USERPOOL.
#'
#' @keywords internal
#'
#' @rdname appstream_delete_user
appstream_delete_user <- function(UserName, AuthenticationType) {
  op <- new_operation(
    name = "DeleteUser",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .appstream$delete_user_input(UserName = UserName, AuthenticationType = AuthenticationType)
  output <- .appstream$delete_user_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$delete_user <- appstream_delete_user

#' Retrieves a list that describes one or more app block builder
#' associations
#'
#' @description
#' Retrieves a list that describes one or more app block builder associations.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_describe_app_block_builder_app_block_associations/](https://www.paws-r-sdk.com/docs/appstream_describe_app_block_builder_app_block_associations/) for full documentation.
#'
#' @param AppBlockArn The ARN of the app block.
#' @param AppBlockBuilderName The name of the app block builder.
#' @param MaxResults The maximum size of each page of results.
#' @param NextToken The pagination token used to retrieve the next page of results for this operation.
#'
#' @keywords internal
#'
#' @rdname appstream_describe_app_block_builder_app_block_associations
appstream_describe_app_block_builder_app_block_associations <- function(AppBlockArn = NULL, AppBlockBuilderName = NULL, MaxResults = NULL, NextToken = NULL) {
  op <- new_operation(
    name = "DescribeAppBlockBuilderAppBlockAssociations",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(input_token = "NextToken", output_token = "NextToken", limit_key = "MaxResults"),
    stream_api = FALSE
  )
  input <- .appstream$describe_app_block_builder_app_block_associations_input(AppBlockArn = AppBlockArn, AppBlockBuilderName = AppBlockBuilderName, MaxResults = MaxResults, NextToken = NextToken)
  output <- .appstream$describe_app_block_builder_app_block_associations_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$describe_app_block_builder_app_block_associations <- appstream_describe_app_block_builder_app_block_associations

#' Retrieves a list that describes one or more app block builders
#'
#' @description
#' Retrieves a list that describes one or more app block builders.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_describe_app_block_builders/](https://www.paws-r-sdk.com/docs/appstream_describe_app_block_builders/) for full documentation.
#'
#' @param Names The names of the app block builders.
#' @param NextToken The pagination token used to retrieve the next page of results for this operation.
#' @param MaxResults The maximum size of each page of results. The maximum value is 25.
#'
#' @keywords internal
#'
#' @rdname appstream_describe_app_block_builders
appstream_describe_app_block_builders <- function(Names = NULL, NextToken = NULL, MaxResults = NULL) {
  op <- new_operation(
    name = "DescribeAppBlockBuilders",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(input_token = "NextToken", output_token = "NextToken", limit_key = "MaxResults"),
    stream_api = FALSE
  )
  input <- .appstream$describe_app_block_builders_input(Names = Names, NextToken = NextToken, MaxResults = MaxResults)
  output <- .appstream$describe_app_block_builders_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$describe_app_block_builders <- appstream_describe_app_block_builders

#' Retrieves a list that describes one or more app blocks
#'
#' @description
#' Retrieves a list that describes one or more app blocks.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_describe_app_blocks/](https://www.paws-r-sdk.com/docs/appstream_describe_app_blocks/) for full documentation.
#'
#' @param Arns The ARNs of the app blocks.
#' @param NextToken The pagination token used to retrieve the next page of results for this operation.
#' @param MaxResults The maximum size of each page of results.
#'
#' @keywords internal
#'
#' @rdname appstream_describe_app_blocks
appstream_describe_app_blocks <- function(Arns = NULL, NextToken = NULL, MaxResults = NULL) {
  op <- new_operation(
    name = "DescribeAppBlocks",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .appstream$describe_app_blocks_input(Arns = Arns, NextToken = NextToken, MaxResults = MaxResults)
  output <- .appstream$describe_app_blocks_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$describe_app_blocks <- appstream_describe_app_blocks

#' Retrieves license included application usage information
#'
#' @description
#' Retrieves license included application usage information.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_describe_app_license_usage/](https://www.paws-r-sdk.com/docs/appstream_describe_app_license_usage/) for full documentation.
#'
#' @param BillingPeriod &#91;required&#93; Billing period for the usage record.
#' 
#' Specify the value in *yyyy-mm* format. For example, for August 2025, use *2025-08*.
#' @param MaxResults The maximum number of results to return.
#' @param NextToken Token for pagination of results.
#'
#' @keywords internal
#'
#' @rdname appstream_describe_app_license_usage
appstream_describe_app_license_usage <- function(BillingPeriod, MaxResults = NULL, NextToken = NULL) {
  op <- new_operation(
    name = "DescribeAppLicenseUsage",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .appstream$describe_app_license_usage_input(BillingPeriod = BillingPeriod, MaxResults = MaxResults, NextToken = NextToken)
  output <- .appstream$describe_app_license_usage_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$describe_app_license_usage <- appstream_describe_app_license_usage

#' Retrieves a list that describes one or more application fleet
#' associations
#'
#' @description
#' Retrieves a list that describes one or more application fleet associations. Either ApplicationArn or FleetName must be specified.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_describe_application_fleet_associations/](https://www.paws-r-sdk.com/docs/appstream_describe_application_fleet_associations/) for full documentation.
#'
#' @param FleetName The name of the fleet.
#' @param ApplicationArn The ARN of the application.
#' @param MaxResults The maximum size of each page of results.
#' @param NextToken The pagination token used to retrieve the next page of results for this operation.
#'
#' @keywords internal
#'
#' @rdname appstream_describe_application_fleet_associations
appstream_describe_application_fleet_associations <- function(FleetName = NULL, ApplicationArn = NULL, MaxResults = NULL, NextToken = NULL) {
  op <- new_operation(
    name = "DescribeApplicationFleetAssociations",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .appstream$describe_application_fleet_associations_input(FleetName = FleetName, ApplicationArn = ApplicationArn, MaxResults = MaxResults, NextToken = NextToken)
  output <- .appstream$describe_application_fleet_associations_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$describe_application_fleet_associations <- appstream_describe_application_fleet_associations

#' Retrieves a list that describes one or more applications
#'
#' @description
#' Retrieves a list that describes one or more applications.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_describe_applications/](https://www.paws-r-sdk.com/docs/appstream_describe_applications/) for full documentation.
#'
#' @param Arns The ARNs for the applications.
#' @param NextToken The pagination token used to retrieve the next page of results for this operation.
#' @param MaxResults The maximum size of each page of results.
#'
#' @keywords internal
#'
#' @rdname appstream_describe_applications
appstream_describe_applications <- function(Arns = NULL, NextToken = NULL, MaxResults = NULL) {
  op <- new_operation(
    name = "DescribeApplications",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .appstream$describe_applications_input(Arns = Arns, NextToken = NextToken, MaxResults = MaxResults)
  output <- .appstream$describe_applications_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$describe_applications <- appstream_describe_applications

#' Retrieves a list that describes one or more specified Directory Config
#' objects for WorkSpaces Applications, if the names for these objects are
#' provided
#'
#' @description
#' Retrieves a list that describes one or more specified Directory Config objects for WorkSpaces Applications, if the names for these objects are provided. Otherwise, all Directory Config objects in the account are described. These objects include the configuration information required to join fleets and image builders to Microsoft Active Directory domains.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_describe_directory_configs/](https://www.paws-r-sdk.com/docs/appstream_describe_directory_configs/) for full documentation.
#'
#' @param DirectoryNames The directory names.
#' @param MaxResults The maximum size of each page of results.
#' @param NextToken The pagination token to use to retrieve the next page of results for this operation. If this value is null, it retrieves the first page.
#'
#' @keywords internal
#'
#' @rdname appstream_describe_directory_configs
appstream_describe_directory_configs <- function(DirectoryNames = NULL, MaxResults = NULL, NextToken = NULL) {
  op <- new_operation(
    name = "DescribeDirectoryConfigs",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(input_token = "NextToken", output_token = "NextToken", limit_key = "MaxResults", result_key = "DirectoryConfigs"),
    stream_api = FALSE
  )
  input <- .appstream$describe_directory_configs_input(DirectoryNames = DirectoryNames, MaxResults = MaxResults, NextToken = NextToken)
  output <- .appstream$describe_directory_configs_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$describe_directory_configs <- appstream_describe_directory_configs

#' Retrieves a list that describes one of more entitlements
#'
#' @description
#' Retrieves a list that describes one of more entitlements.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_describe_entitlements/](https://www.paws-r-sdk.com/docs/appstream_describe_entitlements/) for full documentation.
#'
#' @param Name The name of the entitlement.
#' @param StackName &#91;required&#93; The name of the stack with which the entitlement is associated.
#' @param NextToken The pagination token used to retrieve the next page of results for this operation.
#' @param MaxResults The maximum size of each page of results.
#'
#' @keywords internal
#'
#' @rdname appstream_describe_entitlements
appstream_describe_entitlements <- function(Name = NULL, StackName, NextToken = NULL, MaxResults = NULL) {
  op <- new_operation(
    name = "DescribeEntitlements",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .appstream$describe_entitlements_input(Name = Name, StackName = StackName, NextToken = NextToken, MaxResults = MaxResults)
  output <- .appstream$describe_entitlements_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$describe_entitlements <- appstream_describe_entitlements

#' Retrieves a list that describes one or more specified fleets, if the
#' fleet names are provided
#'
#' @description
#' Retrieves a list that describes one or more specified fleets, if the fleet names are provided. Otherwise, all fleets in the account are described.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_describe_fleets/](https://www.paws-r-sdk.com/docs/appstream_describe_fleets/) for full documentation.
#'
#' @param Names The names of the fleets to describe.
#' @param NextToken The pagination token to use to retrieve the next page of results for this operation. If this value is null, it retrieves the first page.
#'
#' @keywords internal
#'
#' @rdname appstream_describe_fleets
appstream_describe_fleets <- function(Names = NULL, NextToken = NULL) {
  op <- new_operation(
    name = "DescribeFleets",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(input_token = "NextToken", output_token = "NextToken", result_key = "Fleets"),
    stream_api = FALSE
  )
  input <- .appstream$describe_fleets_input(Names = Names, NextToken = NextToken)
  output <- .appstream$describe_fleets_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$describe_fleets <- appstream_describe_fleets

#' Retrieves a list that describes one or more specified image builders, if
#' the image builder names are provided
#'
#' @description
#' Retrieves a list that describes one or more specified image builders, if the image builder names are provided. Otherwise, all image builders in the account are described.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_describe_image_builders/](https://www.paws-r-sdk.com/docs/appstream_describe_image_builders/) for full documentation.
#'
#' @param Names The names of the image builders to describe.
#' @param MaxResults The maximum size of each page of results.
#' @param NextToken The pagination token to use to retrieve the next page of results for this operation. If this value is null, it retrieves the first page.
#'
#' @keywords internal
#'
#' @rdname appstream_describe_image_builders
appstream_describe_image_builders <- function(Names = NULL, MaxResults = NULL, NextToken = NULL) {
  op <- new_operation(
    name = "DescribeImageBuilders",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(input_token = "NextToken", output_token = "NextToken", limit_key = "MaxResults", result_key = "ImageBuilders"),
    stream_api = FALSE
  )
  input <- .appstream$describe_image_builders_input(Names = Names, MaxResults = MaxResults, NextToken = NextToken)
  output <- .appstream$describe_image_builders_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$describe_image_builders <- appstream_describe_image_builders

#' Retrieves a list that describes the permissions for shared AWS account
#' IDs on a private image that you own
#'
#' @description
#' Retrieves a list that describes the permissions for shared AWS account IDs on a private image that you own.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_describe_image_permissions/](https://www.paws-r-sdk.com/docs/appstream_describe_image_permissions/) for full documentation.
#'
#' @param Name &#91;required&#93; The name of the private image for which to describe permissions. The image must be one that you own.
#' @param MaxResults The maximum size of each page of results.
#' @param SharedAwsAccountIds The 12-digit identifier of one or more AWS accounts with which the image is shared.
#' @param NextToken The pagination token to use to retrieve the next page of results for this operation. If this value is null, it retrieves the first page.
#'
#' @keywords internal
#'
#' @rdname appstream_describe_image_permissions
appstream_describe_image_permissions <- function(Name, MaxResults = NULL, SharedAwsAccountIds = NULL, NextToken = NULL) {
  op <- new_operation(
    name = "DescribeImagePermissions",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(input_token = "NextToken", output_token = "NextToken", limit_key = "MaxResults"),
    stream_api = FALSE
  )
  input <- .appstream$describe_image_permissions_input(Name = Name, MaxResults = MaxResults, SharedAwsAccountIds = SharedAwsAccountIds, NextToken = NextToken)
  output <- .appstream$describe_image_permissions_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$describe_image_permissions <- appstream_describe_image_permissions

#' Retrieves a list that describes one or more specified images, if the
#' image names or image ARNs are provided
#'
#' @description
#' Retrieves a list that describes one or more specified images, if the image names or image ARNs are provided. Otherwise, all images in the account are described.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_describe_images/](https://www.paws-r-sdk.com/docs/appstream_describe_images/) for full documentation.
#'
#' @param Names The names of the public or private images to describe.
#' @param Arns The ARNs of the public, private, and shared images to describe.
#' @param Type The type of image (public, private, or shared) to describe.
#' @param NextToken The pagination token to use to retrieve the next page of results for this operation. If this value is null, it retrieves the first page.
#' @param MaxResults The maximum size of each page of results.
#'
#' @keywords internal
#'
#' @rdname appstream_describe_images
appstream_describe_images <- function(Names = NULL, Arns = NULL, Type = NULL, NextToken = NULL, MaxResults = NULL) {
  op <- new_operation(
    name = "DescribeImages",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(input_token = "NextToken", output_token = "NextToken", limit_key = "MaxResults", result_key = "Images"),
    stream_api = FALSE
  )
  input <- .appstream$describe_images_input(Names = Names, Arns = Arns, Type = Type, NextToken = NextToken, MaxResults = MaxResults)
  output <- .appstream$describe_images_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$describe_images <- appstream_describe_images

#' Retrieves a list that describes the streaming sessions for a specified
#' stack and fleet
#'
#' @description
#' Retrieves a list that describes the streaming sessions for a specified stack and fleet. If a UserId is provided for the stack and fleet, only streaming sessions for that user are described. If an authentication type is not provided, the default is to authenticate users using a streaming URL.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_describe_sessions/](https://www.paws-r-sdk.com/docs/appstream_describe_sessions/) for full documentation.
#'
#' @param StackName &#91;required&#93; The name of the stack. This value is case-sensitive.
#' @param FleetName &#91;required&#93; The name of the fleet. This value is case-sensitive.
#' @param UserId The user identifier (ID). If you specify a user ID, you must also specify the authentication type.
#' @param NextToken The pagination token to use to retrieve the next page of results for this operation. If this value is null, it retrieves the first page.
#' @param Limit The size of each page of results. The default value is 20 and the maximum value is 50.
#' @param AuthenticationType The authentication method. Specify `API` for a user authenticated using a streaming URL or `SAML` for a SAML federated user. The default is to authenticate users using a streaming URL.
#' @param InstanceId The identifier for the instance hosting the session.
#'
#' @keywords internal
#'
#' @rdname appstream_describe_sessions
appstream_describe_sessions <- function(StackName, FleetName, UserId = NULL, NextToken = NULL, Limit = NULL, AuthenticationType = NULL, InstanceId = NULL) {
  op <- new_operation(
    name = "DescribeSessions",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(input_token = "NextToken", output_token = "NextToken", limit_key = "Limit", result_key = "Sessions"),
    stream_api = FALSE
  )
  input <- .appstream$describe_sessions_input(StackName = StackName, FleetName = FleetName, UserId = UserId, NextToken = NextToken, Limit = Limit, AuthenticationType = AuthenticationType, InstanceId = InstanceId)
  output <- .appstream$describe_sessions_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$describe_sessions <- appstream_describe_sessions

#' Retrieves license included application associations for a specified
#' resource
#'
#' @description
#' Retrieves license included application associations for a specified resource.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_describe_software_associations/](https://www.paws-r-sdk.com/docs/appstream_describe_software_associations/) for full documentation.
#'
#' @param AssociatedResource &#91;required&#93; The ARN of the resource to describe software associations. Possible resources are Image and ImageBuilder.
#' @param MaxResults The maximum number of results to return.
#' @param NextToken The pagination token to use to retrieve the next page of results for this operation.
#'
#' @keywords internal
#'
#' @rdname appstream_describe_software_associations
appstream_describe_software_associations <- function(AssociatedResource, MaxResults = NULL, NextToken = NULL) {
  op <- new_operation(
    name = "DescribeSoftwareAssociations",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .appstream$describe_software_associations_input(AssociatedResource = AssociatedResource, MaxResults = MaxResults, NextToken = NextToken)
  output <- .appstream$describe_software_associations_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$describe_software_associations <- appstream_describe_software_associations

#' Retrieves a list that describes one or more specified stacks, if the
#' stack names are provided
#'
#' @description
#' Retrieves a list that describes one or more specified stacks, if the stack names are provided. Otherwise, all stacks in the account are described.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_describe_stacks/](https://www.paws-r-sdk.com/docs/appstream_describe_stacks/) for full documentation.
#'
#' @param Names The names of the stacks to describe.
#' @param NextToken The pagination token to use to retrieve the next page of results for this operation. If this value is null, it retrieves the first page.
#'
#' @keywords internal
#'
#' @rdname appstream_describe_stacks
appstream_describe_stacks <- function(Names = NULL, NextToken = NULL) {
  op <- new_operation(
    name = "DescribeStacks",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(input_token = "NextToken", output_token = "NextToken", result_key = "Stacks"),
    stream_api = FALSE
  )
  input <- .appstream$describe_stacks_input(Names = Names, NextToken = NextToken)
  output <- .appstream$describe_stacks_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$describe_stacks <- appstream_describe_stacks

#' Retrieves a list that describes the theme for a specified stack
#'
#' @description
#' Retrieves a list that describes the theme for a specified stack. A theme is custom branding that customizes the appearance of the streaming application catalog page.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_describe_theme_for_stack/](https://www.paws-r-sdk.com/docs/appstream_describe_theme_for_stack/) for full documentation.
#'
#' @param StackName &#91;required&#93; The name of the stack for the theme.
#'
#' @keywords internal
#'
#' @rdname appstream_describe_theme_for_stack
appstream_describe_theme_for_stack <- function(StackName) {
  op <- new_operation(
    name = "DescribeThemeForStack",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .appstream$describe_theme_for_stack_input(StackName = StackName)
  output <- .appstream$describe_theme_for_stack_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$describe_theme_for_stack <- appstream_describe_theme_for_stack

#' Retrieves a list that describes one or more usage report subscriptions
#'
#' @description
#' Retrieves a list that describes one or more usage report subscriptions.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_describe_usage_report_subscriptions/](https://www.paws-r-sdk.com/docs/appstream_describe_usage_report_subscriptions/) for full documentation.
#'
#' @param MaxResults The maximum size of each page of results.
#' @param NextToken The pagination token to use to retrieve the next page of results for this operation. If this value is null, it retrieves the first page.
#'
#' @keywords internal
#'
#' @rdname appstream_describe_usage_report_subscriptions
appstream_describe_usage_report_subscriptions <- function(MaxResults = NULL, NextToken = NULL) {
  op <- new_operation(
    name = "DescribeUsageReportSubscriptions",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .appstream$describe_usage_report_subscriptions_input(MaxResults = MaxResults, NextToken = NextToken)
  output <- .appstream$describe_usage_report_subscriptions_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$describe_usage_report_subscriptions <- appstream_describe_usage_report_subscriptions

#' Retrieves a list that describes the UserStackAssociation objects
#'
#' @description
#' Retrieves a list that describes the UserStackAssociation objects. You must specify either or both of the following:
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_describe_user_stack_associations/](https://www.paws-r-sdk.com/docs/appstream_describe_user_stack_associations/) for full documentation.
#'
#' @param StackName The name of the stack that is associated with the user.
#' @param UserName The email address of the user who is associated with the stack.
#' 
#' Users' email addresses are case-sensitive.
#' @param AuthenticationType The authentication type for the user who is associated with the stack. You must specify USERPOOL.
#' @param MaxResults The maximum size of each page of results.
#' @param NextToken The pagination token to use to retrieve the next page of results for this operation. If this value is null, it retrieves the first page.
#'
#' @keywords internal
#'
#' @rdname appstream_describe_user_stack_associations
appstream_describe_user_stack_associations <- function(StackName = NULL, UserName = NULL, AuthenticationType = NULL, MaxResults = NULL, NextToken = NULL) {
  op <- new_operation(
    name = "DescribeUserStackAssociations",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(input_token = "NextToken", output_token = "NextToken", limit_key = "MaxResults", result_key = "UserStackAssociations"),
    stream_api = FALSE
  )
  input <- .appstream$describe_user_stack_associations_input(StackName = StackName, UserName = UserName, AuthenticationType = AuthenticationType, MaxResults = MaxResults, NextToken = NextToken)
  output <- .appstream$describe_user_stack_associations_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$describe_user_stack_associations <- appstream_describe_user_stack_associations

#' Retrieves a list that describes one or more specified users in the user
#' pool
#'
#' @description
#' Retrieves a list that describes one or more specified users in the user pool.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_describe_users/](https://www.paws-r-sdk.com/docs/appstream_describe_users/) for full documentation.
#'
#' @param AuthenticationType &#91;required&#93; The authentication type for the users in the user pool to describe. You must specify USERPOOL.
#' @param MaxResults The maximum size of each page of results.
#' @param NextToken The pagination token to use to retrieve the next page of results for this operation. If this value is null, it retrieves the first page.
#'
#' @keywords internal
#'
#' @rdname appstream_describe_users
appstream_describe_users <- function(AuthenticationType, MaxResults = NULL, NextToken = NULL) {
  op <- new_operation(
    name = "DescribeUsers",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(input_token = "NextToken", output_token = "NextToken", limit_key = "MaxResults", result_key = "Users"),
    stream_api = FALSE
  )
  input <- .appstream$describe_users_input(AuthenticationType = AuthenticationType, MaxResults = MaxResults, NextToken = NextToken)
  output <- .appstream$describe_users_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$describe_users <- appstream_describe_users

#' Disables the specified user in the user pool
#'
#' @description
#' Disables the specified user in the user pool. Users can't sign in to WorkSpaces Applications until they are re-enabled. This action does not delete the user.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_disable_user/](https://www.paws-r-sdk.com/docs/appstream_disable_user/) for full documentation.
#'
#' @param UserName &#91;required&#93; The email address of the user.
#' 
#' Users' email addresses are case-sensitive.
#' @param AuthenticationType &#91;required&#93; The authentication type for the user. You must specify USERPOOL.
#'
#' @keywords internal
#'
#' @rdname appstream_disable_user
appstream_disable_user <- function(UserName, AuthenticationType) {
  op <- new_operation(
    name = "DisableUser",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .appstream$disable_user_input(UserName = UserName, AuthenticationType = AuthenticationType)
  output <- .appstream$disable_user_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$disable_user <- appstream_disable_user

#' Disassociates a specified app block builder from a specified app block
#'
#' @description
#' Disassociates a specified app block builder from a specified app block.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_disassociate_app_block_builder_app_block/](https://www.paws-r-sdk.com/docs/appstream_disassociate_app_block_builder_app_block/) for full documentation.
#'
#' @param AppBlockArn &#91;required&#93; The ARN of the app block.
#' @param AppBlockBuilderName &#91;required&#93; The name of the app block builder.
#'
#' @keywords internal
#'
#' @rdname appstream_disassociate_app_block_builder_app_block
appstream_disassociate_app_block_builder_app_block <- function(AppBlockArn, AppBlockBuilderName) {
  op <- new_operation(
    name = "DisassociateAppBlockBuilderAppBlock",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .appstream$disassociate_app_block_builder_app_block_input(AppBlockArn = AppBlockArn, AppBlockBuilderName = AppBlockBuilderName)
  output <- .appstream$disassociate_app_block_builder_app_block_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$disassociate_app_block_builder_app_block <- appstream_disassociate_app_block_builder_app_block

#' Disassociates the specified application from the fleet
#'
#' @description
#' Disassociates the specified application from the fleet.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_disassociate_application_fleet/](https://www.paws-r-sdk.com/docs/appstream_disassociate_application_fleet/) for full documentation.
#'
#' @param FleetName &#91;required&#93; The name of the fleet.
#' @param ApplicationArn &#91;required&#93; The ARN of the application.
#'
#' @keywords internal
#'
#' @rdname appstream_disassociate_application_fleet
appstream_disassociate_application_fleet <- function(FleetName, ApplicationArn) {
  op <- new_operation(
    name = "DisassociateApplicationFleet",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .appstream$disassociate_application_fleet_input(FleetName = FleetName, ApplicationArn = ApplicationArn)
  output <- .appstream$disassociate_application_fleet_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$disassociate_application_fleet <- appstream_disassociate_application_fleet

#' Deletes the specified application from the specified entitlement
#'
#' @description
#' Deletes the specified application from the specified entitlement.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_disassociate_application_from_entitlement/](https://www.paws-r-sdk.com/docs/appstream_disassociate_application_from_entitlement/) for full documentation.
#'
#' @param StackName &#91;required&#93; The name of the stack with which the entitlement is associated.
#' @param EntitlementName &#91;required&#93; The name of the entitlement.
#' @param ApplicationIdentifier &#91;required&#93; The identifier of the application to remove from the entitlement.
#'
#' @keywords internal
#'
#' @rdname appstream_disassociate_application_from_entitlement
appstream_disassociate_application_from_entitlement <- function(StackName, EntitlementName, ApplicationIdentifier) {
  op <- new_operation(
    name = "DisassociateApplicationFromEntitlement",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .appstream$disassociate_application_from_entitlement_input(StackName = StackName, EntitlementName = EntitlementName, ApplicationIdentifier = ApplicationIdentifier)
  output <- .appstream$disassociate_application_from_entitlement_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$disassociate_application_from_entitlement <- appstream_disassociate_application_from_entitlement

#' Disassociates the specified fleet from the specified stack
#'
#' @description
#' Disassociates the specified fleet from the specified stack.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_disassociate_fleet/](https://www.paws-r-sdk.com/docs/appstream_disassociate_fleet/) for full documentation.
#'
#' @param FleetName &#91;required&#93; The name of the fleet.
#' @param StackName &#91;required&#93; The name of the stack.
#'
#' @keywords internal
#'
#' @rdname appstream_disassociate_fleet
appstream_disassociate_fleet <- function(FleetName, StackName) {
  op <- new_operation(
    name = "DisassociateFleet",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .appstream$disassociate_fleet_input(FleetName = FleetName, StackName = StackName)
  output <- .appstream$disassociate_fleet_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$disassociate_fleet <- appstream_disassociate_fleet

#' Removes license included application(s) association(s) from an image
#' builder instance
#'
#' @description
#' Removes license included application(s) association(s) from an image builder instance.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_disassociate_software_from_image_builder/](https://www.paws-r-sdk.com/docs/appstream_disassociate_software_from_image_builder/) for full documentation.
#'
#' @param ImageBuilderName &#91;required&#93; The name of the target image builder instance.
#' @param SoftwareNames &#91;required&#93; The list of license included applications to disassociate from the image builder.
#' 
#' Possible values include the following:
#' 
#' -   Microsoft_Office_2021_LTSC_Professional_Plus_32Bit
#' 
#' -   Microsoft_Office_2021_LTSC_Professional_Plus_64Bit
#' 
#' -   Microsoft_Office_2024_LTSC_Professional_Plus_32Bit
#' 
#' -   Microsoft_Office_2024_LTSC_Professional_Plus_64Bit
#' 
#' -   Microsoft_Visio_2021_LTSC_Professional_32Bit
#' 
#' -   Microsoft_Visio_2021_LTSC_Professional_64Bit
#' 
#' -   Microsoft_Visio_2024_LTSC_Professional_32Bit
#' 
#' -   Microsoft_Visio_2024_LTSC_Professional_64Bit
#' 
#' -   Microsoft_Project_2021_Professional_32Bit
#' 
#' -   Microsoft_Project_2021_Professional_64Bit
#' 
#' -   Microsoft_Project_2024_Professional_32Bit
#' 
#' -   Microsoft_Project_2024_Professional_64Bit
#' 
#' -   Microsoft_Office_2021_LTSC_Standard_32Bit
#' 
#' -   Microsoft_Office_2021_LTSC_Standard_64Bit
#' 
#' -   Microsoft_Office_2024_LTSC_Standard_32Bit
#' 
#' -   Microsoft_Office_2024_LTSC_Standard_64Bit
#' 
#' -   Microsoft_Visio_2021_LTSC_Standard_32Bit
#' 
#' -   Microsoft_Visio_2021_LTSC_Standard_64Bit
#' 
#' -   Microsoft_Visio_2024_LTSC_Standard_32Bit
#' 
#' -   Microsoft_Visio_2024_LTSC_Standard_64Bit
#' 
#' -   Microsoft_Project_2021_Standard_32Bit
#' 
#' -   Microsoft_Project_2021_Standard_64Bit
#' 
#' -   Microsoft_Project_2024_Standard_32Bit
#' 
#' -   Microsoft_Project_2024_Standard_64Bit
#'
#' @keywords internal
#'
#' @rdname appstream_disassociate_software_from_image_builder
appstream_disassociate_software_from_image_builder <- function(ImageBuilderName, SoftwareNames) {
  op <- new_operation(
    name = "DisassociateSoftwareFromImageBuilder",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .appstream$disassociate_software_from_image_builder_input(ImageBuilderName = ImageBuilderName, SoftwareNames = SoftwareNames)
  output <- .appstream$disassociate_software_from_image_builder_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$disassociate_software_from_image_builder <- appstream_disassociate_software_from_image_builder

#' Drains the instance hosting the specified streaming session
#'
#' @description
#' Drains the instance hosting the specified streaming session. The instance stops accepting new sessions while existing sessions continue uninterrupted. Once all sessions end, the instance is reclaimed and replaced. This only applies to multi-session fleets.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_drain_session_instance/](https://www.paws-r-sdk.com/docs/appstream_drain_session_instance/) for full documentation.
#'
#' @param SessionId &#91;required&#93; The identifier of the streaming session.
#'
#' @keywords internal
#'
#' @rdname appstream_drain_session_instance
appstream_drain_session_instance <- function(SessionId) {
  op <- new_operation(
    name = "DrainSessionInstance",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .appstream$drain_session_instance_input(SessionId = SessionId)
  output <- .appstream$drain_session_instance_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$drain_session_instance <- appstream_drain_session_instance

#' Enables a user in the user pool
#'
#' @description
#' Enables a user in the user pool. After being enabled, users can sign in to WorkSpaces Applications and open applications from the stacks to which they are assigned.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_enable_user/](https://www.paws-r-sdk.com/docs/appstream_enable_user/) for full documentation.
#'
#' @param UserName &#91;required&#93; The email address of the user.
#' 
#' Users' email addresses are case-sensitive. During login, if they specify an email address that doesn't use the same capitalization as the email address specified when their user pool account was created, a "user does not exist" error message displays.
#' @param AuthenticationType &#91;required&#93; The authentication type for the user. You must specify USERPOOL.
#'
#' @keywords internal
#'
#' @rdname appstream_enable_user
appstream_enable_user <- function(UserName, AuthenticationType) {
  op <- new_operation(
    name = "EnableUser",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .appstream$enable_user_input(UserName = UserName, AuthenticationType = AuthenticationType)
  output <- .appstream$enable_user_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$enable_user <- appstream_enable_user

#' Immediately stops the specified streaming session
#'
#' @description
#' Immediately stops the specified streaming session.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_expire_session/](https://www.paws-r-sdk.com/docs/appstream_expire_session/) for full documentation.
#'
#' @param SessionId &#91;required&#93; The identifier of the streaming session.
#'
#' @keywords internal
#'
#' @rdname appstream_expire_session
appstream_expire_session <- function(SessionId) {
  op <- new_operation(
    name = "ExpireSession",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .appstream$expire_session_input(SessionId = SessionId)
  output <- .appstream$expire_session_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$expire_session <- appstream_expire_session

#' Retrieves information about an export image task, including its current
#' state, progress, and any error details
#'
#' @description
#' Retrieves information about an export image task, including its current state, progress, and any error details.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_get_export_image_task/](https://www.paws-r-sdk.com/docs/appstream_get_export_image_task/) for full documentation.
#'
#' @param TaskId The unique identifier of the export image task to retrieve information about.
#'
#' @keywords internal
#'
#' @rdname appstream_get_export_image_task
appstream_get_export_image_task <- function(TaskId = NULL) {
  op <- new_operation(
    name = "GetExportImageTask",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .appstream$get_export_image_task_input(TaskId = TaskId)
  output <- .appstream$get_export_image_task_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$get_export_image_task <- appstream_get_export_image_task

#' Retrieves the name of the fleet that is associated with the specified
#' stack
#'
#' @description
#' Retrieves the name of the fleet that is associated with the specified stack.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_list_associated_fleets/](https://www.paws-r-sdk.com/docs/appstream_list_associated_fleets/) for full documentation.
#'
#' @param StackName &#91;required&#93; The name of the stack.
#' @param NextToken The pagination token to use to retrieve the next page of results for this operation. If this value is null, it retrieves the first page.
#'
#' @keywords internal
#'
#' @rdname appstream_list_associated_fleets
appstream_list_associated_fleets <- function(StackName, NextToken = NULL) {
  op <- new_operation(
    name = "ListAssociatedFleets",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(input_token = "NextToken", output_token = "NextToken", result_key = "Names"),
    stream_api = FALSE
  )
  input <- .appstream$list_associated_fleets_input(StackName = StackName, NextToken = NextToken)
  output <- .appstream$list_associated_fleets_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$list_associated_fleets <- appstream_list_associated_fleets

#' Retrieves the name of the stack with which the specified fleet is
#' associated
#'
#' @description
#' Retrieves the name of the stack with which the specified fleet is associated.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_list_associated_stacks/](https://www.paws-r-sdk.com/docs/appstream_list_associated_stacks/) for full documentation.
#'
#' @param FleetName &#91;required&#93; The name of the fleet.
#' @param NextToken The pagination token to use to retrieve the next page of results for this operation. If this value is null, it retrieves the first page.
#'
#' @keywords internal
#'
#' @rdname appstream_list_associated_stacks
appstream_list_associated_stacks <- function(FleetName, NextToken = NULL) {
  op <- new_operation(
    name = "ListAssociatedStacks",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(input_token = "NextToken", output_token = "NextToken", result_key = "Names"),
    stream_api = FALSE
  )
  input <- .appstream$list_associated_stacks_input(FleetName = FleetName, NextToken = NextToken)
  output <- .appstream$list_associated_stacks_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$list_associated_stacks <- appstream_list_associated_stacks

#' Retrieves a list of entitled applications
#'
#' @description
#' Retrieves a list of entitled applications.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_list_entitled_applications/](https://www.paws-r-sdk.com/docs/appstream_list_entitled_applications/) for full documentation.
#'
#' @param StackName &#91;required&#93; The name of the stack with which the entitlement is associated.
#' @param EntitlementName &#91;required&#93; The name of the entitlement.
#' @param NextToken The pagination token used to retrieve the next page of results for this operation.
#' @param MaxResults The maximum size of each page of results.
#'
#' @keywords internal
#'
#' @rdname appstream_list_entitled_applications
appstream_list_entitled_applications <- function(StackName, EntitlementName, NextToken = NULL, MaxResults = NULL) {
  op <- new_operation(
    name = "ListEntitledApplications",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .appstream$list_entitled_applications_input(StackName = StackName, EntitlementName = EntitlementName, NextToken = NextToken, MaxResults = MaxResults)
  output <- .appstream$list_entitled_applications_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$list_entitled_applications <- appstream_list_entitled_applications

#' Lists export image tasks, with optional filtering and pagination
#'
#' @description
#' Lists export image tasks, with optional filtering and pagination. Use this operation to monitor the status of multiple export operations.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_list_export_image_tasks/](https://www.paws-r-sdk.com/docs/appstream_list_export_image_tasks/) for full documentation.
#'
#' @param Filters Optional filters to apply when listing export image tasks. Filters help you narrow down the results based on specific criteria.
#' @param MaxResults The maximum number of export image tasks to return in a single request. The valid range is 1-500, with a default of 50.
#' @param NextToken The pagination token from a previous request. Use this to retrieve the next page of results when there are more tasks than the MaxResults limit.
#'
#' @keywords internal
#'
#' @rdname appstream_list_export_image_tasks
appstream_list_export_image_tasks <- function(Filters = NULL, MaxResults = NULL, NextToken = NULL) {
  op <- new_operation(
    name = "ListExportImageTasks",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .appstream$list_export_image_tasks_input(Filters = Filters, MaxResults = MaxResults, NextToken = NextToken)
  output <- .appstream$list_export_image_tasks_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$list_export_image_tasks <- appstream_list_export_image_tasks

#' Retrieves a list of all tags for the specified WorkSpaces Applications
#' resource
#'
#' @description
#' Retrieves a list of all tags for the specified WorkSpaces Applications resource. You can tag WorkSpaces Applications image builders, images, fleets, and stacks.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_list_tags_for_resource/](https://www.paws-r-sdk.com/docs/appstream_list_tags_for_resource/) for full documentation.
#'
#' @param ResourceArn &#91;required&#93; The Amazon Resource Name (ARN) of the resource.
#'
#' @keywords internal
#'
#' @rdname appstream_list_tags_for_resource
appstream_list_tags_for_resource <- function(ResourceArn) {
  op <- new_operation(
    name = "ListTagsForResource",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .appstream$list_tags_for_resource_input(ResourceArn = ResourceArn)
  output <- .appstream$list_tags_for_resource_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$list_tags_for_resource <- appstream_list_tags_for_resource

#' Starts an app block builder
#'
#' @description
#' Starts an app block builder.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_start_app_block_builder/](https://www.paws-r-sdk.com/docs/appstream_start_app_block_builder/) for full documentation.
#'
#' @param Name &#91;required&#93; The name of the app block builder.
#'
#' @keywords internal
#'
#' @rdname appstream_start_app_block_builder
appstream_start_app_block_builder <- function(Name) {
  op <- new_operation(
    name = "StartAppBlockBuilder",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .appstream$start_app_block_builder_input(Name = Name)
  output <- .appstream$start_app_block_builder_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$start_app_block_builder <- appstream_start_app_block_builder

#' Starts the specified fleet
#'
#' @description
#' Starts the specified fleet.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_start_fleet/](https://www.paws-r-sdk.com/docs/appstream_start_fleet/) for full documentation.
#'
#' @param Name &#91;required&#93; The name of the fleet.
#'
#' @keywords internal
#'
#' @rdname appstream_start_fleet
appstream_start_fleet <- function(Name) {
  op <- new_operation(
    name = "StartFleet",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .appstream$start_fleet_input(Name = Name)
  output <- .appstream$start_fleet_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$start_fleet <- appstream_start_fleet

#' Starts the specified image builder
#'
#' @description
#' Starts the specified image builder.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_start_image_builder/](https://www.paws-r-sdk.com/docs/appstream_start_image_builder/) for full documentation.
#'
#' @param Name &#91;required&#93; The name of the image builder.
#' @param AppstreamAgentVersion The version of the WorkSpaces Applications agent to use for this image builder. To use the latest version of the WorkSpaces Applications agent, specify \[LATEST\].
#'
#' @keywords internal
#'
#' @rdname appstream_start_image_builder
appstream_start_image_builder <- function(Name, AppstreamAgentVersion = NULL) {
  op <- new_operation(
    name = "StartImageBuilder",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .appstream$start_image_builder_input(Name = Name, AppstreamAgentVersion = AppstreamAgentVersion)
  output <- .appstream$start_image_builder_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$start_image_builder <- appstream_start_image_builder

#' Initiates license included applications deployment to an image builder
#' instance
#'
#' @description
#' Initiates license included applications deployment to an image builder instance.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_start_software_deployment_to_image_builder/](https://www.paws-r-sdk.com/docs/appstream_start_software_deployment_to_image_builder/) for full documentation.
#'
#' @param ImageBuilderName &#91;required&#93; The name of the target image builder instance.
#' @param RetryFailedDeployments Whether to retry previously failed license included application deployments.
#'
#' @keywords internal
#'
#' @rdname appstream_start_software_deployment_to_image_builder
appstream_start_software_deployment_to_image_builder <- function(ImageBuilderName, RetryFailedDeployments = NULL) {
  op <- new_operation(
    name = "StartSoftwareDeploymentToImageBuilder",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .appstream$start_software_deployment_to_image_builder_input(ImageBuilderName = ImageBuilderName, RetryFailedDeployments = RetryFailedDeployments)
  output <- .appstream$start_software_deployment_to_image_builder_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$start_software_deployment_to_image_builder <- appstream_start_software_deployment_to_image_builder

#' Stops an app block builder
#'
#' @description
#' Stops an app block builder.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_stop_app_block_builder/](https://www.paws-r-sdk.com/docs/appstream_stop_app_block_builder/) for full documentation.
#'
#' @param Name &#91;required&#93; The name of the app block builder.
#'
#' @keywords internal
#'
#' @rdname appstream_stop_app_block_builder
appstream_stop_app_block_builder <- function(Name) {
  op <- new_operation(
    name = "StopAppBlockBuilder",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .appstream$stop_app_block_builder_input(Name = Name)
  output <- .appstream$stop_app_block_builder_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$stop_app_block_builder <- appstream_stop_app_block_builder

#' Stops the specified fleet
#'
#' @description
#' Stops the specified fleet.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_stop_fleet/](https://www.paws-r-sdk.com/docs/appstream_stop_fleet/) for full documentation.
#'
#' @param Name &#91;required&#93; The name of the fleet.
#'
#' @keywords internal
#'
#' @rdname appstream_stop_fleet
appstream_stop_fleet <- function(Name) {
  op <- new_operation(
    name = "StopFleet",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .appstream$stop_fleet_input(Name = Name)
  output <- .appstream$stop_fleet_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$stop_fleet <- appstream_stop_fleet

#' Stops the specified image builder
#'
#' @description
#' Stops the specified image builder.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_stop_image_builder/](https://www.paws-r-sdk.com/docs/appstream_stop_image_builder/) for full documentation.
#'
#' @param Name &#91;required&#93; The name of the image builder.
#'
#' @keywords internal
#'
#' @rdname appstream_stop_image_builder
appstream_stop_image_builder <- function(Name) {
  op <- new_operation(
    name = "StopImageBuilder",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .appstream$stop_image_builder_input(Name = Name)
  output <- .appstream$stop_image_builder_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$stop_image_builder <- appstream_stop_image_builder

#' Adds or overwrites one or more tags for the specified WorkSpaces
#' Applications resource
#'
#' @description
#' Adds or overwrites one or more tags for the specified WorkSpaces Applications resource. You can tag WorkSpaces Applications image builders, images, fleets, and stacks.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_tag_resource/](https://www.paws-r-sdk.com/docs/appstream_tag_resource/) for full documentation.
#'
#' @param ResourceArn &#91;required&#93; The Amazon Resource Name (ARN) of the resource.
#' @param Tags &#91;required&#93; The tags to associate. A tag is a key-value pair, and the value is optional. For example, Environment=Test. If you do not specify a value, Environment=.
#' 
#' If you do not specify a value, the value is set to an empty string.
#' 
#' Generally allowed characters are: letters, numbers, and spaces representable in UTF-8, and the following special characters:
#' 
#' _ . : / = + \\ - @@
#'
#' @keywords internal
#'
#' @rdname appstream_tag_resource
appstream_tag_resource <- function(ResourceArn, Tags) {
  op <- new_operation(
    name = "TagResource",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .appstream$tag_resource_input(ResourceArn = ResourceArn, Tags = Tags)
  output <- .appstream$tag_resource_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$tag_resource <- appstream_tag_resource

#' Disassociates one or more specified tags from the specified WorkSpaces
#' Applications resource
#'
#' @description
#' Disassociates one or more specified tags from the specified WorkSpaces Applications resource.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_untag_resource/](https://www.paws-r-sdk.com/docs/appstream_untag_resource/) for full documentation.
#'
#' @param ResourceArn &#91;required&#93; The Amazon Resource Name (ARN) of the resource.
#' @param TagKeys &#91;required&#93; The tag keys for the tags to disassociate.
#'
#' @keywords internal
#'
#' @rdname appstream_untag_resource
appstream_untag_resource <- function(ResourceArn, TagKeys) {
  op <- new_operation(
    name = "UntagResource",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .appstream$untag_resource_input(ResourceArn = ResourceArn, TagKeys = TagKeys)
  output <- .appstream$untag_resource_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$untag_resource <- appstream_untag_resource

#' Updates an app block builder
#'
#' @description
#' Updates an app block builder.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_update_app_block_builder/](https://www.paws-r-sdk.com/docs/appstream_update_app_block_builder/) for full documentation.
#'
#' @param Name &#91;required&#93; The unique name for the app block builder.
#' @param Description The description of the app block builder.
#' @param DisplayName The display name of the app block builder.
#' @param Platform The platform of the app block builder.
#' 
#' `WINDOWS_SERVER_2019` is the only valid value.
#' @param InstanceType The instance type to use when launching the app block builder. The following instance types are available:
#' 
#' -   stream.standard.small
#' 
#' -   stream.standard.medium
#' 
#' -   stream.standard.large
#' 
#' -   stream.standard.xlarge
#' 
#' -   stream.standard.2xlarge
#' @param VpcConfig The VPC configuration for the app block builder.
#' 
#' App block builders require that you specify at least two subnets in different availability zones.
#' @param EnableDefaultInternetAccess Enables or disables default internet access for the app block builder.
#' @param IamRoleArn The Amazon Resource Name (ARN) of the IAM role to apply to the app block builder. To assume a role, the app block builder calls the AWS Security Token Service (STS) `AssumeRole` API operation and passes the ARN of the role to use. The operation creates a new session with temporary credentials. WorkSpaces Applications retrieves the temporary credentials and creates the **appstream_machine_role** credential profile on the instance.
#' 
#' For more information, see [Using an IAM Role to Grant Permissions to Applications and Scripts Running on WorkSpaces Applications Streaming Instances](https://docs.aws.amazon.com/appstream2/latest/developerguide/using-iam-roles-to-grant-permissions-to-applications-scripts-streaming-instances.html) in the *Amazon WorkSpaces Applications Administration Guide*.
#' @param AccessEndpoints The list of interface VPC endpoint (interface endpoint) objects. Administrators can connect to the app block builder only through the specified endpoints.
#' @param AttributesToDelete The attributes to delete from the app block builder.
#' @param DisableIMDSV1 Set to true to disable Instance Metadata Service Version 1 (IMDSv1) and enforce IMDSv2. Set to false to enable both IMDSv1 and IMDSv2.
#'
#' @keywords internal
#'
#' @rdname appstream_update_app_block_builder
appstream_update_app_block_builder <- function(Name, Description = NULL, DisplayName = NULL, Platform = NULL, InstanceType = NULL, VpcConfig = NULL, EnableDefaultInternetAccess = NULL, IamRoleArn = NULL, AccessEndpoints = NULL, AttributesToDelete = NULL, DisableIMDSV1 = NULL) {
  op <- new_operation(
    name = "UpdateAppBlockBuilder",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .appstream$update_app_block_builder_input(Name = Name, Description = Description, DisplayName = DisplayName, Platform = Platform, InstanceType = InstanceType, VpcConfig = VpcConfig, EnableDefaultInternetAccess = EnableDefaultInternetAccess, IamRoleArn = IamRoleArn, AccessEndpoints = AccessEndpoints, AttributesToDelete = AttributesToDelete, DisableIMDSV1 = DisableIMDSV1)
  output <- .appstream$update_app_block_builder_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$update_app_block_builder <- appstream_update_app_block_builder

#' Updates the specified application
#'
#' @description
#' Updates the specified application.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_update_application/](https://www.paws-r-sdk.com/docs/appstream_update_application/) for full documentation.
#'
#' @param Name &#91;required&#93; The name of the application. This name is visible to users when display name is not specified.
#' @param DisplayName The display name of the application. This name is visible to users in the application catalog.
#' @param Description The description of the application.
#' @param IconS3Location The icon S3 location of the application.
#' @param LaunchPath The launch path of the application.
#' @param WorkingDirectory The working directory of the application.
#' @param LaunchParameters The launch parameters of the application.
#' @param AppBlockArn The ARN of the app block.
#' @param AttributesToDelete The attributes to delete for an application.
#'
#' @keywords internal
#'
#' @rdname appstream_update_application
appstream_update_application <- function(Name, DisplayName = NULL, Description = NULL, IconS3Location = NULL, LaunchPath = NULL, WorkingDirectory = NULL, LaunchParameters = NULL, AppBlockArn = NULL, AttributesToDelete = NULL) {
  op <- new_operation(
    name = "UpdateApplication",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .appstream$update_application_input(Name = Name, DisplayName = DisplayName, Description = Description, IconS3Location = IconS3Location, LaunchPath = LaunchPath, WorkingDirectory = WorkingDirectory, LaunchParameters = LaunchParameters, AppBlockArn = AppBlockArn, AttributesToDelete = AttributesToDelete)
  output <- .appstream$update_application_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$update_application <- appstream_update_application

#' Updates the specified Directory Config object in WorkSpaces Applications
#'
#' @description
#' Updates the specified Directory Config object in WorkSpaces Applications. This object includes the configuration information required to join fleets and image builders to Microsoft Active Directory domains.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_update_directory_config/](https://www.paws-r-sdk.com/docs/appstream_update_directory_config/) for full documentation.
#'
#' @param DirectoryName &#91;required&#93; The name of the Directory Config object.
#' @param OrganizationalUnitDistinguishedNames The distinguished names of the organizational units for computer accounts.
#' @param ServiceAccountCredentials The credentials for the service account used by the fleet or image builder to connect to the directory.
#' @param CertificateBasedAuthProperties The certificate-based authentication properties used to authenticate SAML 2.0 Identity Provider (IdP) user identities to Active Directory domain-joined streaming instances. Fallback is turned on by default when certificate-based authentication is **Enabled** . Fallback allows users to log in using their AD domain password if certificate-based authentication is unsuccessful, or to unlock a desktop lock screen. **Enabled_no_directory_login_fallback** enables certificate-based authentication, but does not allow users to log in using their AD domain password. Users will be disconnected to re-authenticate using certificates.
#'
#' @keywords internal
#'
#' @rdname appstream_update_directory_config
appstream_update_directory_config <- function(DirectoryName, OrganizationalUnitDistinguishedNames = NULL, ServiceAccountCredentials = NULL, CertificateBasedAuthProperties = NULL) {
  op <- new_operation(
    name = "UpdateDirectoryConfig",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .appstream$update_directory_config_input(DirectoryName = DirectoryName, OrganizationalUnitDistinguishedNames = OrganizationalUnitDistinguishedNames, ServiceAccountCredentials = ServiceAccountCredentials, CertificateBasedAuthProperties = CertificateBasedAuthProperties)
  output <- .appstream$update_directory_config_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$update_directory_config <- appstream_update_directory_config

#' Updates the specified entitlement
#'
#' @description
#' Updates the specified entitlement.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_update_entitlement/](https://www.paws-r-sdk.com/docs/appstream_update_entitlement/) for full documentation.
#'
#' @param Name &#91;required&#93; The name of the entitlement.
#' @param StackName &#91;required&#93; The name of the stack with which the entitlement is associated.
#' @param Description The description of the entitlement.
#' @param AppVisibility Specifies whether all or only selected apps are entitled.
#' @param Attributes The attributes of the entitlement.
#'
#' @keywords internal
#'
#' @rdname appstream_update_entitlement
appstream_update_entitlement <- function(Name, StackName, Description = NULL, AppVisibility = NULL, Attributes = NULL) {
  op <- new_operation(
    name = "UpdateEntitlement",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .appstream$update_entitlement_input(Name = Name, StackName = StackName, Description = Description, AppVisibility = AppVisibility, Attributes = Attributes)
  output <- .appstream$update_entitlement_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$update_entitlement <- appstream_update_entitlement

#' Updates the specified fleet
#'
#' @description
#' Updates the specified fleet.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_update_fleet/](https://www.paws-r-sdk.com/docs/appstream_update_fleet/) for full documentation.
#'
#' @param ImageName The name of the image used to create the fleet.
#' @param ImageArn The ARN of the public, private, or shared image to use.
#' @param Name A unique name for the fleet.
#' @param InstanceType The instance type to use when launching fleet instances. The following instance types are available:
#' 
#' -   stream.standard.small
#' 
#' -   stream.standard.medium
#' 
#' -   stream.standard.large
#' 
#' -   stream.standard.xlarge
#' 
#' -   stream.standard.2xlarge
#' 
#' -   stream.compute.large
#' 
#' -   stream.compute.xlarge
#' 
#' -   stream.compute.2xlarge
#' 
#' -   stream.compute.4xlarge
#' 
#' -   stream.compute.8xlarge
#' 
#' -   stream.memory.large
#' 
#' -   stream.memory.xlarge
#' 
#' -   stream.memory.2xlarge
#' 
#' -   stream.memory.4xlarge
#' 
#' -   stream.memory.8xlarge
#' 
#' -   stream.memory.z1d.large
#' 
#' -   stream.memory.z1d.xlarge
#' 
#' -   stream.memory.z1d.2xlarge
#' 
#' -   stream.memory.z1d.3xlarge
#' 
#' -   stream.memory.z1d.6xlarge
#' 
#' -   stream.memory.z1d.12xlarge
#' 
#' -   stream.graphics.g4dn.xlarge
#' 
#' -   stream.graphics.g4dn.2xlarge
#' 
#' -   stream.graphics.g4dn.4xlarge
#' 
#' -   stream.graphics.g4dn.8xlarge
#' 
#' -   stream.graphics.g4dn.12xlarge
#' 
#' -   stream.graphics.g4dn.16xlarge
#' 
#' -   stream.graphics.g5.xlarge
#' 
#' -   stream.graphics.g5.2xlarge
#' 
#' -   stream.graphics.g5.4xlarge
#' 
#' -   stream.graphics.g5.8xlarge
#' 
#' -   stream.graphics.g5.16xlarge
#' 
#' -   stream.graphics.g5.12xlarge
#' 
#' -   stream.graphics.g5.24xlarge
#' 
#' -   stream.graphics.g6.xlarge
#' 
#' -   stream.graphics.g6.2xlarge
#' 
#' -   stream.graphics.g6.4xlarge
#' 
#' -   stream.graphics.g6.8xlarge
#' 
#' -   stream.graphics.g6.16xlarge
#' 
#' -   stream.graphics.g6.12xlarge
#' 
#' -   stream.graphics.g6.24xlarge
#' 
#' -   stream.graphics.gr6.4xlarge
#' 
#' -   stream.graphics.gr6.8xlarge
#' 
#' -   stream.graphics.g6f.large
#' 
#' -   stream.graphics.g6f.xlarge
#' 
#' -   stream.graphics.g6f.2xlarge
#' 
#' -   stream.graphics.g6f.4xlarge
#' 
#' -   stream.graphics.gr6f.4xlarge
#' 
#' The following instance types are available for Elastic fleets:
#' 
#' -   stream.standard.small
#' 
#' -   stream.standard.medium
#' 
#' -   stream.standard.large
#' 
#' -   stream.standard.xlarge
#' 
#' -   stream.standard.2xlarge
#' @param ComputeCapacity The desired capacity for the fleet. This is not allowed for Elastic fleets.
#' @param VpcConfig The VPC configuration for the fleet. This is required for Elastic fleets, but not required for other fleet types. Elastic fleets require that you specify at least two subnets in different availability zones.
#' @param MaxUserDurationInSeconds The maximum amount of time that a streaming session can remain active, in seconds. If users are still connected to a streaming instance five minutes before this limit is reached, they are prompted to save any open documents before being disconnected. After this time elapses, the instance is terminated and replaced by a new instance.
#' 
#' Specify a value between 600 and 432000.
#' @param DisconnectTimeoutInSeconds The amount of time that a streaming session remains active after users disconnect. If users try to reconnect to the streaming session after a disconnection or network interruption within this time interval, they are connected to their previous session. Otherwise, they are connected to a new session with a new streaming instance.
#' 
#' Specify a value between 60 and 36000.
#' @param DeleteVpcConfig Deletes the VPC association for the specified fleet.
#' @param Description The description to display.
#' @param DisplayName The fleet name to display.
#' @param EnableDefaultInternetAccess Enables or disables default internet access for the fleet.
#' @param DomainJoinInfo The name of the directory and organizational unit (OU) to use to join the fleet to a Microsoft Active Directory domain.
#' @param IdleDisconnectTimeoutInSeconds The amount of time that users can be idle (inactive) before they are disconnected from their streaming session and the `DisconnectTimeoutInSeconds` time interval begins. Users are notified before they are disconnected due to inactivity. If users try to reconnect to the streaming session before the time interval specified in `DisconnectTimeoutInSeconds` elapses, they are connected to their previous session. Users are considered idle when they stop providing keyboard or mouse input during their streaming session. File uploads and downloads, audio in, audio out, and pixels changing do not qualify as user activity. If users continue to be idle after the time interval in `IdleDisconnectTimeoutInSeconds` elapses, they are disconnected.
#' 
#' To prevent users from being disconnected due to inactivity, specify a value of 0. Otherwise, specify a value between 60 and 36000. The default value is 0.
#' 
#' If you enable this feature, we recommend that you specify a value that corresponds exactly to a whole number of minutes (for example, 60, 120, and 180). If you don't do this, the value is rounded to the nearest minute. For example, if you specify a value of 70, users are disconnected after 1 minute of inactivity. If you specify a value that is at the midpoint between two different minutes, the value is rounded up. For example, if you specify a value of 90, users are disconnected after 2 minutes of inactivity.
#' @param AttributesToDelete The fleet attributes to delete.
#' @param IamRoleArn The Amazon Resource Name (ARN) of the IAM role to apply to the fleet. To assume a role, a fleet instance calls the AWS Security Token Service (STS) `AssumeRole` API operation and passes the ARN of the role to use. The operation creates a new session with temporary credentials. WorkSpaces Applications retrieves the temporary credentials and creates the **appstream_machine_role** credential profile on the instance.
#' 
#' For more information, see [Using an IAM Role to Grant Permissions to Applications and Scripts Running on WorkSpaces Applications Streaming Instances](https://docs.aws.amazon.com/appstream2/latest/developerguide/using-iam-roles-to-grant-permissions-to-applications-scripts-streaming-instances.html) in the *Amazon WorkSpaces Applications Administration Guide*.
#' @param StreamView The WorkSpaces Applications view that is displayed to your users when they stream from the fleet. When `APP` is specified, only the windows of applications opened by users display. When `DESKTOP` is specified, the standard desktop that is provided by the operating system displays.
#' 
#' The default value is `APP`.
#' @param Platform The platform of the fleet. WINDOWS_SERVER_2019, AMAZON_LINUX2 and UBUNTU_PRO_2404 are supported for Elastic fleets.
#' @param MaxConcurrentSessions The maximum number of concurrent sessions for a fleet.
#' @param UsbDeviceFilterStrings The USB device filter strings that specify which USB devices a user can redirect to the fleet streaming session, when using the Windows native client. This is allowed but not required for Elastic fleets.
#' @param SessionScriptS3Location The S3 location of the session scripts configuration zip file. This only applies to Elastic fleets.
#' @param MaxSessionsPerInstance The maximum number of user sessions on an instance. This only applies to multi-session fleets.
#' @param RootVolumeConfig The updated configuration for the root volume of fleet instances. Note that volume size cannot be decreased below the image volume size.
#' @param DisableIMDSV1 Set to true to disable Instance Metadata Service Version 1 (IMDSv1) and enforce IMDSv2. Set to false to enable both IMDSv1 and IMDSv2.
#' 
#' Before disabling IMDSv1, ensure your WorkSpaces Applications images are running the agent version or managed image update released on or after January 16, 2024 to support IMDSv2 enforcement.
#'
#' @keywords internal
#'
#' @rdname appstream_update_fleet
appstream_update_fleet <- function(ImageName = NULL, ImageArn = NULL, Name = NULL, InstanceType = NULL, ComputeCapacity = NULL, VpcConfig = NULL, MaxUserDurationInSeconds = NULL, DisconnectTimeoutInSeconds = NULL, DeleteVpcConfig = NULL, Description = NULL, DisplayName = NULL, EnableDefaultInternetAccess = NULL, DomainJoinInfo = NULL, IdleDisconnectTimeoutInSeconds = NULL, AttributesToDelete = NULL, IamRoleArn = NULL, StreamView = NULL, Platform = NULL, MaxConcurrentSessions = NULL, UsbDeviceFilterStrings = NULL, SessionScriptS3Location = NULL, MaxSessionsPerInstance = NULL, RootVolumeConfig = NULL, DisableIMDSV1 = NULL) {
  op <- new_operation(
    name = "UpdateFleet",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .appstream$update_fleet_input(ImageName = ImageName, ImageArn = ImageArn, Name = Name, InstanceType = InstanceType, ComputeCapacity = ComputeCapacity, VpcConfig = VpcConfig, MaxUserDurationInSeconds = MaxUserDurationInSeconds, DisconnectTimeoutInSeconds = DisconnectTimeoutInSeconds, DeleteVpcConfig = DeleteVpcConfig, Description = Description, DisplayName = DisplayName, EnableDefaultInternetAccess = EnableDefaultInternetAccess, DomainJoinInfo = DomainJoinInfo, IdleDisconnectTimeoutInSeconds = IdleDisconnectTimeoutInSeconds, AttributesToDelete = AttributesToDelete, IamRoleArn = IamRoleArn, StreamView = StreamView, Platform = Platform, MaxConcurrentSessions = MaxConcurrentSessions, UsbDeviceFilterStrings = UsbDeviceFilterStrings, SessionScriptS3Location = SessionScriptS3Location, MaxSessionsPerInstance = MaxSessionsPerInstance, RootVolumeConfig = RootVolumeConfig, DisableIMDSV1 = DisableIMDSV1)
  output <- .appstream$update_fleet_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$update_fleet <- appstream_update_fleet

#' Adds or updates permissions for the specified private image
#'
#' @description
#' Adds or updates permissions for the specified private image.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_update_image_permissions/](https://www.paws-r-sdk.com/docs/appstream_update_image_permissions/) for full documentation.
#'
#' @param Name &#91;required&#93; The name of the private image.
#' @param SharedAccountId &#91;required&#93; The 12-digit identifier of the AWS account for which you want add or update image permissions.
#' @param ImagePermissions &#91;required&#93; The permissions for the image.
#'
#' @keywords internal
#'
#' @rdname appstream_update_image_permissions
appstream_update_image_permissions <- function(Name, SharedAccountId, ImagePermissions) {
  op <- new_operation(
    name = "UpdateImagePermissions",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .appstream$update_image_permissions_input(Name = Name, SharedAccountId = SharedAccountId, ImagePermissions = ImagePermissions)
  output <- .appstream$update_image_permissions_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$update_image_permissions <- appstream_update_image_permissions

#' Updates the specified fields for the specified stack
#'
#' @description
#' Updates the specified fields for the specified stack.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_update_stack/](https://www.paws-r-sdk.com/docs/appstream_update_stack/) for full documentation.
#'
#' @param DisplayName The stack name to display.
#' @param Description The description to display.
#' @param Name &#91;required&#93; The name of the stack.
#' @param StorageConnectors The storage connectors to enable.
#' @param DeleteStorageConnectors Deletes the storage connectors currently enabled for the stack.
#' @param RedirectURL The URL that users are redirected to after their streaming session ends.
#' @param FeedbackURL The URL that users are redirected to after they choose the Send Feedback link. If no URL is specified, no Send Feedback link is displayed.
#' @param AttributesToDelete The stack attributes to delete.
#' @param UserSettings The actions that are enabled or disabled for users during their streaming sessions. By default, these actions are enabled.
#' @param ApplicationSettings The persistent application settings for users of a stack. When these settings are enabled, changes that users make to applications and Windows settings are automatically saved after each session and applied to the next session.
#' @param AccessEndpoints The list of interface VPC endpoint (interface endpoint) objects. Users of the stack can connect to WorkSpaces Applications only through the specified endpoints.
#' @param EmbedHostDomains The domains where WorkSpaces Applications streaming sessions can be embedded in an iframe. You must approve the domains that you want to host embedded WorkSpaces Applications streaming sessions.
#' @param StreamingExperienceSettings The streaming protocol you want your stack to prefer. This can be UDP or TCP. Currently, UDP is only supported in the Windows native client.
#' @param ContentRedirection Configuration for bidirectional URL redirection between the streaming session and the local client. Use HostToClient to redirect URLs from the remote desktop to the local browser.
#' @param AgentAccessConfig The configuration for agent access on the stack. Specify this to update agent access settings. To remove agent access, use AttributesToDelete with the AGENT_ACCESS_CONFIG value.
#'
#' @keywords internal
#'
#' @rdname appstream_update_stack
appstream_update_stack <- function(DisplayName = NULL, Description = NULL, Name, StorageConnectors = NULL, DeleteStorageConnectors = NULL, RedirectURL = NULL, FeedbackURL = NULL, AttributesToDelete = NULL, UserSettings = NULL, ApplicationSettings = NULL, AccessEndpoints = NULL, EmbedHostDomains = NULL, StreamingExperienceSettings = NULL, ContentRedirection = NULL, AgentAccessConfig = NULL) {
  op <- new_operation(
    name = "UpdateStack",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .appstream$update_stack_input(DisplayName = DisplayName, Description = Description, Name = Name, StorageConnectors = StorageConnectors, DeleteStorageConnectors = DeleteStorageConnectors, RedirectURL = RedirectURL, FeedbackURL = FeedbackURL, AttributesToDelete = AttributesToDelete, UserSettings = UserSettings, ApplicationSettings = ApplicationSettings, AccessEndpoints = AccessEndpoints, EmbedHostDomains = EmbedHostDomains, StreamingExperienceSettings = StreamingExperienceSettings, ContentRedirection = ContentRedirection, AgentAccessConfig = AgentAccessConfig)
  output <- .appstream$update_stack_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$update_stack <- appstream_update_stack

#' Updates custom branding that customizes the appearance of the streaming
#' application catalog page
#'
#' @description
#' Updates custom branding that customizes the appearance of the streaming application catalog page.
#'
#' See [https://www.paws-r-sdk.com/docs/appstream_update_theme_for_stack/](https://www.paws-r-sdk.com/docs/appstream_update_theme_for_stack/) for full documentation.
#'
#' @param StackName &#91;required&#93; The name of the stack for the theme.
#' @param FooterLinks The links that are displayed in the footer of the streaming application catalog page. These links are helpful resources for users, such as the organization's IT support and product marketing sites.
#' @param TitleText The title that is displayed at the top of the browser tab during users' application streaming sessions.
#' @param ThemeStyling The color theme that is applied to website links, text, and buttons. These colors are also applied as accents in the background for the streaming application catalog page.
#' @param OrganizationLogoS3Location The organization logo that appears on the streaming application catalog page.
#' @param FaviconS3Location The S3 location of the favicon. The favicon enables users to recognize their application streaming site in a browser full of tabs or bookmarks. It is displayed at the top of the browser tab for the application streaming site during users' streaming sessions.
#' @param State Specifies whether custom branding should be applied to catalog page or not.
#' @param AttributesToDelete The attributes to delete.
#'
#' @keywords internal
#'
#' @rdname appstream_update_theme_for_stack
appstream_update_theme_for_stack <- function(StackName, FooterLinks = NULL, TitleText = NULL, ThemeStyling = NULL, OrganizationLogoS3Location = NULL, FaviconS3Location = NULL, State = NULL, AttributesToDelete = NULL) {
  op <- new_operation(
    name = "UpdateThemeForStack",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .appstream$update_theme_for_stack_input(StackName = StackName, FooterLinks = FooterLinks, TitleText = TitleText, ThemeStyling = ThemeStyling, OrganizationLogoS3Location = OrganizationLogoS3Location, FaviconS3Location = FaviconS3Location, State = State, AttributesToDelete = AttributesToDelete)
  output <- .appstream$update_theme_for_stack_output()
  config <- get_config()
  svc <- .appstream$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.appstream$operations$update_theme_for_stack <- appstream_update_theme_for_stack

# This file is generated by make.paws. Please do not edit here.
#' @importFrom paws.common populate
#' @include workspaces_service.R
NULL

.workspaces$accept_account_link_invitation_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(LinkId = structure(logical(0), tags = list(type = "string")), ClientToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$accept_account_link_invitation_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(AccountLink = structure(list(AccountLinkId = structure(logical(0), tags = list(type = "string")), AccountLinkStatus = structure(logical(0), tags = list(type = "string")), SourceAccountId = structure(logical(0), tags = list(type = "string")), TargetAccountId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$associate_connection_alias_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(AliasId = structure(logical(0), tags = list(type = "string")), ResourceId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$associate_connection_alias_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ConnectionIdentifier = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$associate_ip_groups_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(DirectoryId = structure(logical(0), tags = list(type = "string")), GroupIds = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$associate_ip_groups_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$associate_workspace_application_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(WorkspaceId = structure(logical(0), tags = list(type = "string")), ApplicationId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$associate_workspace_application_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Association = structure(list(AssociatedResourceId = structure(logical(0), tags = list(type = "string")), AssociatedResourceType = structure(logical(0), tags = list(type = "string")), Created = structure(logical(0), tags = list(type = "timestamp")), LastUpdatedTime = structure(logical(0), tags = list(type = "timestamp")), State = structure(logical(0), tags = list(type = "string")), StateReason = structure(list(ErrorCode = structure(logical(0), tags = list(type = "string")), ErrorMessage = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), WorkspaceId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$authorize_ip_rules_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(GroupId = structure(logical(0), tags = list(type = "string")), UserRules = structure(list(structure(list(ipRule = structure(logical(0), tags = list(type = "string")), ruleDesc = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$authorize_ip_rules_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$copy_workspace_image_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Name = structure(logical(0), tags = list(type = "string")), Description = structure(logical(0), tags = list(type = "string")), SourceImageId = structure(logical(0), tags = list(type = "string")), SourceRegion = structure(logical(0), tags = list(type = "string")), Tags = structure(list(structure(list(Key = structure(logical(0), tags = list(type = "string")), Value = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$copy_workspace_image_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ImageId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$create_account_link_invitation_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(TargetAccountId = structure(logical(0), tags = list(type = "string")), ClientToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$create_account_link_invitation_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(AccountLink = structure(list(AccountLinkId = structure(logical(0), tags = list(type = "string")), AccountLinkStatus = structure(logical(0), tags = list(type = "string")), SourceAccountId = structure(logical(0), tags = list(type = "string")), TargetAccountId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$create_connect_client_add_in_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ResourceId = structure(logical(0), tags = list(type = "string")), Name = structure(logical(0), tags = list(type = "string")), URL = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$create_connect_client_add_in_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(AddInId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$create_connection_alias_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ConnectionString = structure(logical(0), tags = list(type = "string")), Tags = structure(list(structure(list(Key = structure(logical(0), tags = list(type = "string")), Value = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$create_connection_alias_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(AliasId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$create_ip_group_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(GroupName = structure(logical(0), tags = list(type = "string")), GroupDesc = structure(logical(0), tags = list(type = "string")), UserRules = structure(list(structure(list(ipRule = structure(logical(0), tags = list(type = "string")), ruleDesc = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), Tags = structure(list(structure(list(Key = structure(logical(0), tags = list(type = "string")), Value = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$create_ip_group_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(GroupId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$create_standby_workspaces_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(PrimaryRegion = structure(logical(0), tags = list(type = "string")), StandbyWorkspaces = structure(list(structure(list(PrimaryWorkspaceId = structure(logical(0), tags = list(type = "string")), VolumeEncryptionKey = structure(logical(0), tags = list(type = "string")), DirectoryId = structure(logical(0), tags = list(type = "string")), Tags = structure(list(structure(list(Key = structure(logical(0), tags = list(type = "string")), Value = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), DataReplication = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$create_standby_workspaces_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(FailedStandbyRequests = structure(list(structure(list(StandbyWorkspaceRequest = structure(list(PrimaryWorkspaceId = structure(logical(0), tags = list(type = "string")), VolumeEncryptionKey = structure(logical(0), tags = list(type = "string")), DirectoryId = structure(logical(0), tags = list(type = "string")), Tags = structure(list(structure(list(Key = structure(logical(0), tags = list(type = "string")), Value = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), DataReplication = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), ErrorCode = structure(logical(0), tags = list(type = "string")), ErrorMessage = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), PendingStandbyRequests = structure(list(structure(list(UserName = structure(logical(0), tags = list(type = "string")), DirectoryId = structure(logical(0), tags = list(type = "string")), State = structure(logical(0), tags = list(type = "string")), WorkspaceId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$create_tags_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ResourceId = structure(logical(0), tags = list(type = "string")), Tags = structure(list(structure(list(Key = structure(logical(0), tags = list(type = "string")), Value = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$create_tags_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$create_updated_workspace_image_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Name = structure(logical(0), tags = list(type = "string")), Description = structure(logical(0), tags = list(type = "string")), SourceImageId = structure(logical(0), tags = list(type = "string")), Tags = structure(list(structure(list(Key = structure(logical(0), tags = list(type = "string")), Value = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$create_updated_workspace_image_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ImageId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$create_workspace_bundle_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(BundleName = structure(logical(0), tags = list(type = "string")), BundleDescription = structure(logical(0), tags = list(type = "string")), ImageId = structure(logical(0), tags = list(type = "string")), ComputeType = structure(list(Name = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), UserStorage = structure(list(Capacity = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), RootStorage = structure(list(Capacity = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), Tags = structure(list(structure(list(Key = structure(logical(0), tags = list(type = "string")), Value = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$create_workspace_bundle_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(WorkspaceBundle = structure(list(BundleId = structure(logical(0), tags = list(type = "string")), Name = structure(logical(0), tags = list(type = "string")), Owner = structure(logical(0), tags = list(type = "string")), Description = structure(logical(0), tags = list(type = "string")), ImageId = structure(logical(0), tags = list(type = "string")), RootStorage = structure(list(Capacity = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), UserStorage = structure(list(Capacity = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), ComputeType = structure(list(Name = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), LastUpdatedTime = structure(logical(0), tags = list(type = "timestamp")), CreationTime = structure(logical(0), tags = list(type = "timestamp")), State = structure(logical(0), tags = list(type = "string")), BundleType = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$create_workspace_image_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Name = structure(logical(0), tags = list(type = "string")), Description = structure(logical(0), tags = list(type = "string")), WorkspaceId = structure(logical(0), tags = list(type = "string")), Tags = structure(list(structure(list(Key = structure(logical(0), tags = list(type = "string")), Value = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$create_workspace_image_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ImageId = structure(logical(0), tags = list(type = "string")), Name = structure(logical(0), tags = list(type = "string")), Description = structure(logical(0), tags = list(type = "string")), OperatingSystem = structure(list(Type = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), State = structure(logical(0), tags = list(type = "string")), RequiredTenancy = structure(logical(0), tags = list(type = "string")), Created = structure(logical(0), tags = list(type = "timestamp")), OwnerAccountId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$create_workspaces_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Workspaces = structure(list(structure(list(DirectoryId = structure(logical(0), tags = list(type = "string")), UserName = structure(logical(0), tags = list(type = "string")), BundleId = structure(logical(0), tags = list(type = "string")), VolumeEncryptionKey = structure(logical(0), tags = list(type = "string")), UserVolumeEncryptionEnabled = structure(logical(0), tags = list(type = "boolean")), RootVolumeEncryptionEnabled = structure(logical(0), tags = list(type = "boolean")), WorkspaceProperties = structure(list(RunningMode = structure(logical(0), tags = list(type = "string")), RunningModeAutoStopTimeoutInMinutes = structure(logical(0), tags = list(type = "integer")), RootVolumeSizeGib = structure(logical(0), tags = list(type = "integer")), UserVolumeSizeGib = structure(logical(0), tags = list(type = "integer")), ComputeTypeName = structure(logical(0), tags = list(type = "string")), Protocols = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), OperatingSystemName = structure(logical(0), tags = list(type = "string")), GlobalAccelerator = structure(list(Mode = structure(logical(0), tags = list(type = "string")), PreferredProtocol = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure")), Tags = structure(list(structure(list(Key = structure(logical(0), tags = list(type = "string")), Value = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), WorkspaceName = structure(logical(0), tags = list(type = "string")), Ipv6Address = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$create_workspaces_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(FailedRequests = structure(list(structure(list(WorkspaceRequest = structure(list(DirectoryId = structure(logical(0), tags = list(type = "string")), UserName = structure(logical(0), tags = list(type = "string")), BundleId = structure(logical(0), tags = list(type = "string")), VolumeEncryptionKey = structure(logical(0), tags = list(type = "string")), UserVolumeEncryptionEnabled = structure(logical(0), tags = list(type = "boolean")), RootVolumeEncryptionEnabled = structure(logical(0), tags = list(type = "boolean")), WorkspaceProperties = structure(list(RunningMode = structure(logical(0), tags = list(type = "string")), RunningModeAutoStopTimeoutInMinutes = structure(logical(0), tags = list(type = "integer")), RootVolumeSizeGib = structure(logical(0), tags = list(type = "integer")), UserVolumeSizeGib = structure(logical(0), tags = list(type = "integer")), ComputeTypeName = structure(logical(0), tags = list(type = "string")), Protocols = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), OperatingSystemName = structure(logical(0), tags = list(type = "string")), GlobalAccelerator = structure(list(Mode = structure(logical(0), tags = list(type = "string")), PreferredProtocol = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure")), Tags = structure(list(structure(list(Key = structure(logical(0), tags = list(type = "string")), Value = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), WorkspaceName = structure(logical(0), tags = list(type = "string")), Ipv6Address = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), ErrorCode = structure(logical(0), tags = list(type = "string")), ErrorMessage = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), PendingRequests = structure(list(structure(list(WorkspaceId = structure(logical(0), tags = list(type = "string")), DirectoryId = structure(logical(0), tags = list(type = "string")), UserName = structure(logical(0), tags = list(type = "string")), IpAddress = structure(logical(0), tags = list(type = "string")), Ipv6Address = structure(logical(0), tags = list(type = "string")), State = structure(logical(0), tags = list(type = "string")), BundleId = structure(logical(0), tags = list(type = "string")), SubnetId = structure(logical(0), tags = list(type = "string")), ErrorMessage = structure(logical(0), tags = list(type = "string")), ErrorCode = structure(logical(0), tags = list(type = "string")), ComputerName = structure(logical(0), tags = list(type = "string")), VolumeEncryptionKey = structure(logical(0), tags = list(type = "string")), UserVolumeEncryptionEnabled = structure(logical(0), tags = list(type = "boolean")), RootVolumeEncryptionEnabled = structure(logical(0), tags = list(type = "boolean")), WorkspaceName = structure(logical(0), tags = list(type = "string")), WorkspaceProperties = structure(list(RunningMode = structure(logical(0), tags = list(type = "string")), RunningModeAutoStopTimeoutInMinutes = structure(logical(0), tags = list(type = "integer")), RootVolumeSizeGib = structure(logical(0), tags = list(type = "integer")), UserVolumeSizeGib = structure(logical(0), tags = list(type = "integer")), ComputeTypeName = structure(logical(0), tags = list(type = "string")), Protocols = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), OperatingSystemName = structure(logical(0), tags = list(type = "string")), GlobalAccelerator = structure(list(Mode = structure(logical(0), tags = list(type = "string")), PreferredProtocol = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure")), ModificationStates = structure(list(structure(list(Resource = structure(logical(0), tags = list(type = "string")), State = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), RelatedWorkspaces = structure(list(structure(list(WorkspaceId = structure(logical(0), tags = list(type = "string")), Region = structure(logical(0), tags = list(type = "string")), State = structure(logical(0), tags = list(type = "string")), Type = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), DataReplicationSettings = structure(list(DataReplication = structure(logical(0), tags = list(type = "string")), RecoverySnapshotTime = structure(logical(0), tags = list(type = "timestamp"))), tags = list(type = "structure")), StandbyWorkspacesProperties = structure(list(structure(list(StandbyWorkspaceId = structure(logical(0), tags = list(type = "string")), DataReplication = structure(logical(0), tags = list(type = "string")), RecoverySnapshotTime = structure(logical(0), tags = list(type = "timestamp"))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$create_workspaces_pool_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(PoolName = structure(logical(0), tags = list(type = "string")), Description = structure(logical(0), tags = list(type = "string")), BundleId = structure(logical(0), tags = list(type = "string")), DirectoryId = structure(logical(0), tags = list(type = "string")), Capacity = structure(list(DesiredUserSessions = structure(logical(0), tags = list(type = "integer"))), tags = list(type = "structure")), Tags = structure(list(structure(list(Key = structure(logical(0), tags = list(type = "string")), Value = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), ApplicationSettings = structure(list(Status = structure(logical(0), tags = list(type = "string")), SettingsGroup = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), TimeoutSettings = structure(list(DisconnectTimeoutInSeconds = structure(logical(0), tags = list(type = "integer")), IdleDisconnectTimeoutInSeconds = structure(logical(0), tags = list(type = "integer")), MaxUserDurationInSeconds = structure(logical(0), tags = list(type = "integer"))), tags = list(type = "structure")), RunningMode = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$create_workspaces_pool_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(WorkspacesPool = structure(list(PoolId = structure(logical(0), tags = list(type = "string")), PoolArn = structure(logical(0), tags = list(type = "string")), CapacityStatus = structure(list(AvailableUserSessions = structure(logical(0), tags = list(type = "integer")), DesiredUserSessions = structure(logical(0), tags = list(type = "integer")), ActualUserSessions = structure(logical(0), tags = list(type = "integer")), ActiveUserSessions = structure(logical(0), tags = list(type = "integer"))), tags = list(type = "structure")), PoolName = structure(logical(0), tags = list(type = "string")), Description = structure(logical(0), tags = list(type = "string")), State = structure(logical(0), tags = list(type = "string")), CreatedAt = structure(logical(0), tags = list(type = "timestamp")), BundleId = structure(logical(0), tags = list(type = "string")), DirectoryId = structure(logical(0), tags = list(type = "string")), Errors = structure(list(structure(list(ErrorCode = structure(logical(0), tags = list(type = "string")), ErrorMessage = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), ApplicationSettings = structure(list(Status = structure(logical(0), tags = list(type = "string")), SettingsGroup = structure(logical(0), tags = list(type = "string")), S3BucketName = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), TimeoutSettings = structure(list(DisconnectTimeoutInSeconds = structure(logical(0), tags = list(type = "integer")), IdleDisconnectTimeoutInSeconds = structure(logical(0), tags = list(type = "integer")), MaxUserDurationInSeconds = structure(logical(0), tags = list(type = "integer"))), tags = list(type = "structure")), RunningMode = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$delete_account_link_invitation_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(LinkId = structure(logical(0), tags = list(type = "string")), ClientToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$delete_account_link_invitation_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(AccountLink = structure(list(AccountLinkId = structure(logical(0), tags = list(type = "string")), AccountLinkStatus = structure(logical(0), tags = list(type = "string")), SourceAccountId = structure(logical(0), tags = list(type = "string")), TargetAccountId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$delete_client_branding_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ResourceId = structure(logical(0), tags = list(type = "string")), Platforms = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$delete_client_branding_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$delete_connect_client_add_in_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(AddInId = structure(logical(0), tags = list(type = "string")), ResourceId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$delete_connect_client_add_in_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$delete_connection_alias_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(AliasId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$delete_connection_alias_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$delete_ip_group_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(GroupId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$delete_ip_group_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$delete_tags_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ResourceId = structure(logical(0), tags = list(type = "string")), TagKeys = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$delete_tags_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$delete_workspace_bundle_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(BundleId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$delete_workspace_bundle_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$delete_workspace_image_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ImageId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$delete_workspace_image_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$deploy_workspace_applications_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(WorkspaceId = structure(logical(0), tags = list(type = "string")), Force = structure(logical(0), tags = list(type = "boolean"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$deploy_workspace_applications_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Deployment = structure(list(Associations = structure(list(structure(list(AssociatedResourceId = structure(logical(0), tags = list(type = "string")), AssociatedResourceType = structure(logical(0), tags = list(type = "string")), Created = structure(logical(0), tags = list(type = "timestamp")), LastUpdatedTime = structure(logical(0), tags = list(type = "timestamp")), State = structure(logical(0), tags = list(type = "string")), StateReason = structure(list(ErrorCode = structure(logical(0), tags = list(type = "string")), ErrorMessage = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), WorkspaceId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$deregister_workspace_directory_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(DirectoryId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$deregister_workspace_directory_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$describe_account_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$describe_account_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(DedicatedTenancySupport = structure(logical(0), tags = list(type = "string")), DedicatedTenancyManagementCidrRange = structure(logical(0), tags = list(type = "string")), DedicatedTenancyAccountType = structure(logical(0), tags = list(type = "string")), Message = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$describe_account_modifications_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$describe_account_modifications_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(AccountModifications = structure(list(structure(list(ModificationState = structure(logical(0), tags = list(type = "string")), DedicatedTenancySupport = structure(logical(0), tags = list(type = "string")), DedicatedTenancyManagementCidrRange = structure(logical(0), tags = list(type = "string")), StartTime = structure(logical(0), tags = list(type = "timestamp")), ErrorCode = structure(logical(0), tags = list(type = "string")), ErrorMessage = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$describe_application_associations_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(MaxResults = structure(logical(0), tags = list(type = "integer")), NextToken = structure(logical(0), tags = list(type = "string")), ApplicationId = structure(logical(0), tags = list(type = "string")), AssociatedResourceTypes = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$describe_application_associations_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Associations = structure(list(structure(list(ApplicationId = structure(logical(0), tags = list(type = "string")), AssociatedResourceId = structure(logical(0), tags = list(type = "string")), AssociatedResourceType = structure(logical(0), tags = list(type = "string")), Created = structure(logical(0), tags = list(type = "timestamp")), LastUpdatedTime = structure(logical(0), tags = list(type = "timestamp")), State = structure(logical(0), tags = list(type = "string")), StateReason = structure(list(ErrorCode = structure(logical(0), tags = list(type = "string")), ErrorMessage = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure"))), tags = list(type = "list")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$describe_applications_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ApplicationIds = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), ComputeTypeNames = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), LicenseType = structure(logical(0), tags = list(type = "string")), OperatingSystemNames = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), Owner = structure(logical(0), tags = list(type = "string")), MaxResults = structure(logical(0), tags = list(type = "integer")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$describe_applications_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Applications = structure(list(structure(list(ApplicationId = structure(logical(0), tags = list(type = "string")), Created = structure(logical(0), tags = list(type = "timestamp")), Description = structure(logical(0), tags = list(type = "string")), LicenseType = structure(logical(0), tags = list(type = "string")), Name = structure(logical(0), tags = list(type = "string")), Owner = structure(logical(0), tags = list(type = "string")), State = structure(logical(0), tags = list(type = "string")), SupportedComputeTypeNames = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), SupportedOperatingSystemNames = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure"))), tags = list(type = "list")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$describe_bundle_associations_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(BundleId = structure(logical(0), tags = list(type = "string")), AssociatedResourceTypes = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$describe_bundle_associations_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Associations = structure(list(structure(list(AssociatedResourceId = structure(logical(0), tags = list(type = "string")), AssociatedResourceType = structure(logical(0), tags = list(type = "string")), BundleId = structure(logical(0), tags = list(type = "string")), Created = structure(logical(0), tags = list(type = "timestamp")), LastUpdatedTime = structure(logical(0), tags = list(type = "timestamp")), State = structure(logical(0), tags = list(type = "string")), StateReason = structure(list(ErrorCode = structure(logical(0), tags = list(type = "string")), ErrorMessage = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$describe_client_branding_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ResourceId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$describe_client_branding_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(DeviceTypeWindows = structure(list(LogoUrl = structure(logical(0), tags = list(type = "string")), SupportEmail = structure(logical(0), tags = list(type = "string")), SupportLink = structure(logical(0), tags = list(type = "string")), ForgotPasswordLink = structure(logical(0), tags = list(type = "string")), LoginMessage = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map"))), tags = list(type = "structure")), DeviceTypeOsx = structure(list(LogoUrl = structure(logical(0), tags = list(type = "string")), SupportEmail = structure(logical(0), tags = list(type = "string")), SupportLink = structure(logical(0), tags = list(type = "string")), ForgotPasswordLink = structure(logical(0), tags = list(type = "string")), LoginMessage = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map"))), tags = list(type = "structure")), DeviceTypeAndroid = structure(list(LogoUrl = structure(logical(0), tags = list(type = "string")), SupportEmail = structure(logical(0), tags = list(type = "string")), SupportLink = structure(logical(0), tags = list(type = "string")), ForgotPasswordLink = structure(logical(0), tags = list(type = "string")), LoginMessage = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map"))), tags = list(type = "structure")), DeviceTypeIos = structure(list(LogoUrl = structure(logical(0), tags = list(type = "string")), Logo2xUrl = structure(logical(0), tags = list(type = "string")), Logo3xUrl = structure(logical(0), tags = list(type = "string")), SupportEmail = structure(logical(0), tags = list(type = "string")), SupportLink = structure(logical(0), tags = list(type = "string")), ForgotPasswordLink = structure(logical(0), tags = list(type = "string")), LoginMessage = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map"))), tags = list(type = "structure")), DeviceTypeLinux = structure(list(LogoUrl = structure(logical(0), tags = list(type = "string")), SupportEmail = structure(logical(0), tags = list(type = "string")), SupportLink = structure(logical(0), tags = list(type = "string")), ForgotPasswordLink = structure(logical(0), tags = list(type = "string")), LoginMessage = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map"))), tags = list(type = "structure")), DeviceTypeWeb = structure(list(LogoUrl = structure(logical(0), tags = list(type = "string")), SupportEmail = structure(logical(0), tags = list(type = "string")), SupportLink = structure(logical(0), tags = list(type = "string")), ForgotPasswordLink = structure(logical(0), tags = list(type = "string")), LoginMessage = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$describe_client_properties_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ResourceIds = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$describe_client_properties_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ClientPropertiesList = structure(list(structure(list(ResourceId = structure(logical(0), tags = list(type = "string")), ClientProperties = structure(list(ReconnectEnabled = structure(logical(0), tags = list(type = "string")), LogUploadEnabled = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$describe_connect_client_add_ins_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ResourceId = structure(logical(0), tags = list(type = "string")), NextToken = structure(logical(0), tags = list(type = "string")), MaxResults = structure(logical(0), tags = list(type = "integer"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$describe_connect_client_add_ins_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(AddIns = structure(list(structure(list(AddInId = structure(logical(0), tags = list(type = "string")), ResourceId = structure(logical(0), tags = list(type = "string")), Name = structure(logical(0), tags = list(type = "string")), URL = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$describe_connection_alias_permissions_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(AliasId = structure(logical(0), tags = list(type = "string")), NextToken = structure(logical(0), tags = list(type = "string")), MaxResults = structure(logical(0), tags = list(type = "integer"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$describe_connection_alias_permissions_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(AliasId = structure(logical(0), tags = list(type = "string")), ConnectionAliasPermissions = structure(list(structure(list(SharedAccountId = structure(logical(0), tags = list(type = "string")), AllowAssociation = structure(logical(0), tags = list(type = "boolean"))), tags = list(type = "structure"))), tags = list(type = "list")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$describe_connection_aliases_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(AliasIds = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), ResourceId = structure(logical(0), tags = list(type = "string")), Limit = structure(logical(0), tags = list(type = "integer")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$describe_connection_aliases_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ConnectionAliases = structure(list(structure(list(ConnectionString = structure(logical(0), tags = list(type = "string")), AliasId = structure(logical(0), tags = list(type = "string")), State = structure(logical(0), tags = list(type = "string")), OwnerAccountId = structure(logical(0), tags = list(type = "string")), Associations = structure(list(structure(list(AssociationStatus = structure(logical(0), tags = list(type = "string")), AssociatedAccountId = structure(logical(0), tags = list(type = "string")), ResourceId = structure(logical(0), tags = list(type = "string")), ConnectionIdentifier = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure"))), tags = list(type = "list")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$describe_custom_workspace_image_import_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ImageId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$describe_custom_workspace_image_import_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ImageId = structure(logical(0), tags = list(type = "string")), InfrastructureConfigurationArn = structure(logical(0), tags = list(type = "string")), State = structure(logical(0), tags = list(type = "string")), StateMessage = structure(logical(0), tags = list(type = "string")), ProgressPercentage = structure(logical(0), tags = list(type = "integer")), Created = structure(logical(0), tags = list(type = "timestamp")), LastUpdatedTime = structure(logical(0), tags = list(type = "timestamp")), ImageSource = structure(list(Ec2ImportTaskId = structure(logical(0), tags = list(type = "string")), ImageBuildVersionArn = structure(logical(0), tags = list(type = "string")), Ec2ImageId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure", union = TRUE)), ImageBuilderInstanceId = structure(logical(0), tags = list(type = "string")), ErrorDetails = structure(list(structure(list(ErrorCode = structure(logical(0), tags = list(type = "string")), ErrorMessage = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$describe_image_associations_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ImageId = structure(logical(0), tags = list(type = "string")), AssociatedResourceTypes = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$describe_image_associations_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Associations = structure(list(structure(list(AssociatedResourceId = structure(logical(0), tags = list(type = "string")), AssociatedResourceType = structure(logical(0), tags = list(type = "string")), Created = structure(logical(0), tags = list(type = "timestamp")), LastUpdatedTime = structure(logical(0), tags = list(type = "timestamp")), ImageId = structure(logical(0), tags = list(type = "string")), State = structure(logical(0), tags = list(type = "string")), StateReason = structure(list(ErrorCode = structure(logical(0), tags = list(type = "string")), ErrorMessage = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$describe_ip_groups_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(GroupIds = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), NextToken = structure(logical(0), tags = list(type = "string")), MaxResults = structure(logical(0), tags = list(type = "integer"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$describe_ip_groups_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Result = structure(list(structure(list(groupId = structure(logical(0), tags = list(type = "string")), groupName = structure(logical(0), tags = list(type = "string")), groupDesc = structure(logical(0), tags = list(type = "string")), userRules = structure(list(structure(list(ipRule = structure(logical(0), tags = list(type = "string")), ruleDesc = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure"))), tags = list(type = "list")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$describe_tags_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ResourceId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$describe_tags_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(TagList = structure(list(structure(list(Key = structure(logical(0), tags = list(type = "string")), Value = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$describe_workspace_associations_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(WorkspaceId = structure(logical(0), tags = list(type = "string")), AssociatedResourceTypes = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$describe_workspace_associations_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Associations = structure(list(structure(list(AssociatedResourceId = structure(logical(0), tags = list(type = "string")), AssociatedResourceType = structure(logical(0), tags = list(type = "string")), Created = structure(logical(0), tags = list(type = "timestamp")), LastUpdatedTime = structure(logical(0), tags = list(type = "timestamp")), State = structure(logical(0), tags = list(type = "string")), StateReason = structure(list(ErrorCode = structure(logical(0), tags = list(type = "string")), ErrorMessage = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), WorkspaceId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$describe_workspace_bundles_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(BundleIds = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), Owner = structure(logical(0), tags = list(type = "string")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$describe_workspace_bundles_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Bundles = structure(list(structure(list(BundleId = structure(logical(0), tags = list(type = "string")), Name = structure(logical(0), tags = list(type = "string")), Owner = structure(logical(0), tags = list(type = "string")), Description = structure(logical(0), tags = list(type = "string")), ImageId = structure(logical(0), tags = list(type = "string")), RootStorage = structure(list(Capacity = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), UserStorage = structure(list(Capacity = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), ComputeType = structure(list(Name = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), LastUpdatedTime = structure(logical(0), tags = list(type = "timestamp")), CreationTime = structure(logical(0), tags = list(type = "timestamp")), State = structure(logical(0), tags = list(type = "string")), BundleType = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$describe_workspace_directories_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(DirectoryIds = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), WorkspaceDirectoryNames = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), Limit = structure(logical(0), tags = list(type = "integer")), NextToken = structure(logical(0), tags = list(type = "string")), Filters = structure(list(structure(list(Name = structure(logical(0), tags = list(type = "string")), Values = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$describe_workspace_directories_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Directories = structure(list(structure(list(DirectoryId = structure(logical(0), tags = list(type = "string")), Alias = structure(logical(0), tags = list(type = "string")), DirectoryName = structure(logical(0), tags = list(type = "string")), RegistrationCode = structure(logical(0), tags = list(type = "string")), SubnetIds = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), DnsIpAddresses = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), DnsIpv6Addresses = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), CustomerUserName = structure(logical(0), tags = list(type = "string")), IamRoleId = structure(logical(0), tags = list(type = "string")), DirectoryType = structure(logical(0), tags = list(type = "string")), WorkspaceSecurityGroupId = structure(logical(0), tags = list(type = "string")), State = structure(logical(0), tags = list(type = "string")), WorkspaceCreationProperties = structure(list(EnableInternetAccess = structure(logical(0), tags = list(type = "boolean")), DefaultOu = structure(logical(0), tags = list(type = "string")), CustomSecurityGroupId = structure(logical(0), tags = list(type = "string")), UserEnabledAsLocalAdministrator = structure(logical(0), tags = list(type = "boolean")), EnableMaintenanceMode = structure(logical(0), tags = list(type = "boolean")), InstanceIamRoleArn = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), ipGroupIds = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), WorkspaceAccessProperties = structure(list(DeviceTypeWindows = structure(logical(0), tags = list(type = "string")), DeviceTypeOsx = structure(logical(0), tags = list(type = "string")), DeviceTypeWeb = structure(logical(0), tags = list(type = "string")), DeviceTypeIos = structure(logical(0), tags = list(type = "string")), DeviceTypeAndroid = structure(logical(0), tags = list(type = "string")), DeviceTypeChromeOs = structure(logical(0), tags = list(type = "string")), DeviceTypeZeroClient = structure(logical(0), tags = list(type = "string")), DeviceTypeLinux = structure(logical(0), tags = list(type = "string")), DeviceTypeWorkSpacesThinClient = structure(logical(0), tags = list(type = "string")), AccessEndpointConfig = structure(list(AccessEndpoints = structure(list(structure(list(AccessEndpointType = structure(logical(0), tags = list(type = "string")), VpcEndpointId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), InternetFallbackProtocols = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure"))), tags = list(type = "structure")), Tenancy = structure(logical(0), tags = list(type = "string")), SelfservicePermissions = structure(list(RestartWorkspace = structure(logical(0), tags = list(type = "string")), IncreaseVolumeSize = structure(logical(0), tags = list(type = "string")), ChangeComputeType = structure(logical(0), tags = list(type = "string")), SwitchRunningMode = structure(logical(0), tags = list(type = "string")), RebuildWorkspace = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), SamlProperties = structure(list(Status = structure(logical(0), tags = list(type = "string")), UserAccessUrl = structure(logical(0), tags = list(type = "string")), RelayStateParameterName = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), CertificateBasedAuthProperties = structure(list(Status = structure(logical(0), tags = list(type = "string")), CertificateAuthorityArn = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), EndpointEncryptionMode = structure(logical(0), tags = list(type = "string")), MicrosoftEntraConfig = structure(list(TenantId = structure(logical(0), tags = list(type = "string")), ApplicationConfigSecretArn = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), WorkspaceDirectoryName = structure(logical(0), tags = list(type = "string")), WorkspaceDirectoryDescription = structure(logical(0), tags = list(type = "string")), UserIdentityType = structure(logical(0), tags = list(type = "string")), WorkspaceType = structure(logical(0), tags = list(type = "string")), IDCConfig = structure(list(InstanceArn = structure(logical(0), tags = list(type = "string")), ApplicationArn = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), ActiveDirectoryConfig = structure(list(DomainName = structure(logical(0), tags = list(type = "string")), ServiceAccountSecretArn = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), StreamingProperties = structure(list(StreamingExperiencePreferredProtocol = structure(logical(0), tags = list(type = "string")), UserSettings = structure(list(structure(list(Action = structure(logical(0), tags = list(type = "string")), Permission = structure(logical(0), tags = list(type = "string")), MaximumLength = structure(logical(0), tags = list(type = "integer"))), tags = list(type = "structure"))), tags = list(type = "list")), StorageConnectors = structure(list(structure(list(ConnectorType = structure(logical(0), tags = list(type = "string")), Status = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), GlobalAccelerator = structure(list(Mode = structure(logical(0), tags = list(type = "string")), PreferredProtocol = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure")), ErrorMessage = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$describe_workspace_image_permissions_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ImageId = structure(logical(0), tags = list(type = "string")), NextToken = structure(logical(0), tags = list(type = "string")), MaxResults = structure(logical(0), tags = list(type = "integer"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$describe_workspace_image_permissions_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ImageId = structure(logical(0), tags = list(type = "string")), ImagePermissions = structure(list(structure(list(SharedAccountId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$describe_workspace_images_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ImageIds = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), ImageType = structure(logical(0), tags = list(type = "string")), NextToken = structure(logical(0), tags = list(type = "string")), MaxResults = structure(logical(0), tags = list(type = "integer"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$describe_workspace_images_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Images = structure(list(structure(list(ImageId = structure(logical(0), tags = list(type = "string")), Name = structure(logical(0), tags = list(type = "string")), Description = structure(logical(0), tags = list(type = "string")), OperatingSystem = structure(list(Type = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), State = structure(logical(0), tags = list(type = "string")), RequiredTenancy = structure(logical(0), tags = list(type = "string")), ErrorCode = structure(logical(0), tags = list(type = "string")), ErrorMessage = structure(logical(0), tags = list(type = "string")), Created = structure(logical(0), tags = list(type = "timestamp")), OwnerAccountId = structure(logical(0), tags = list(type = "string")), Updates = structure(list(UpdateAvailable = structure(logical(0), tags = list(type = "boolean")), Description = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), ErrorDetails = structure(list(structure(list(ErrorCode = structure(logical(0), tags = list(type = "string")), ErrorMessage = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure"))), tags = list(type = "list")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$describe_workspace_snapshots_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(WorkspaceId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$describe_workspace_snapshots_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(RebuildSnapshots = structure(list(structure(list(SnapshotTime = structure(logical(0), tags = list(type = "timestamp"))), tags = list(type = "structure"))), tags = list(type = "list")), RestoreSnapshots = structure(list(structure(list(SnapshotTime = structure(logical(0), tags = list(type = "timestamp"))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$describe_workspaces_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(WorkspaceIds = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), DirectoryId = structure(logical(0), tags = list(type = "string")), UserName = structure(logical(0), tags = list(type = "string")), BundleId = structure(logical(0), tags = list(type = "string")), Limit = structure(logical(0), tags = list(type = "integer")), NextToken = structure(logical(0), tags = list(type = "string")), WorkspaceName = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$describe_workspaces_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Workspaces = structure(list(structure(list(WorkspaceId = structure(logical(0), tags = list(type = "string")), DirectoryId = structure(logical(0), tags = list(type = "string")), UserName = structure(logical(0), tags = list(type = "string")), IpAddress = structure(logical(0), tags = list(type = "string")), Ipv6Address = structure(logical(0), tags = list(type = "string")), State = structure(logical(0), tags = list(type = "string")), BundleId = structure(logical(0), tags = list(type = "string")), SubnetId = structure(logical(0), tags = list(type = "string")), ErrorMessage = structure(logical(0), tags = list(type = "string")), ErrorCode = structure(logical(0), tags = list(type = "string")), ComputerName = structure(logical(0), tags = list(type = "string")), VolumeEncryptionKey = structure(logical(0), tags = list(type = "string")), UserVolumeEncryptionEnabled = structure(logical(0), tags = list(type = "boolean")), RootVolumeEncryptionEnabled = structure(logical(0), tags = list(type = "boolean")), WorkspaceName = structure(logical(0), tags = list(type = "string")), WorkspaceProperties = structure(list(RunningMode = structure(logical(0), tags = list(type = "string")), RunningModeAutoStopTimeoutInMinutes = structure(logical(0), tags = list(type = "integer")), RootVolumeSizeGib = structure(logical(0), tags = list(type = "integer")), UserVolumeSizeGib = structure(logical(0), tags = list(type = "integer")), ComputeTypeName = structure(logical(0), tags = list(type = "string")), Protocols = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), OperatingSystemName = structure(logical(0), tags = list(type = "string")), GlobalAccelerator = structure(list(Mode = structure(logical(0), tags = list(type = "string")), PreferredProtocol = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure")), ModificationStates = structure(list(structure(list(Resource = structure(logical(0), tags = list(type = "string")), State = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), RelatedWorkspaces = structure(list(structure(list(WorkspaceId = structure(logical(0), tags = list(type = "string")), Region = structure(logical(0), tags = list(type = "string")), State = structure(logical(0), tags = list(type = "string")), Type = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), DataReplicationSettings = structure(list(DataReplication = structure(logical(0), tags = list(type = "string")), RecoverySnapshotTime = structure(logical(0), tags = list(type = "timestamp"))), tags = list(type = "structure")), StandbyWorkspacesProperties = structure(list(structure(list(StandbyWorkspaceId = structure(logical(0), tags = list(type = "string")), DataReplication = structure(logical(0), tags = list(type = "string")), RecoverySnapshotTime = structure(logical(0), tags = list(type = "timestamp"))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure"))), tags = list(type = "list")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$describe_workspaces_connection_status_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(WorkspaceIds = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$describe_workspaces_connection_status_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(WorkspacesConnectionStatus = structure(list(structure(list(WorkspaceId = structure(logical(0), tags = list(type = "string")), ConnectionState = structure(logical(0), tags = list(type = "string")), ConnectionStateCheckTimestamp = structure(logical(0), tags = list(type = "timestamp")), LastKnownUserConnectionTimestamp = structure(logical(0), tags = list(type = "timestamp"))), tags = list(type = "structure"))), tags = list(type = "list")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$describe_workspaces_pool_sessions_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(PoolId = structure(logical(0), tags = list(type = "string")), UserId = structure(logical(0), tags = list(type = "string")), Limit = structure(logical(0), tags = list(type = "integer")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$describe_workspaces_pool_sessions_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Sessions = structure(list(structure(list(AuthenticationType = structure(logical(0), tags = list(type = "string")), ConnectionState = structure(logical(0), tags = list(type = "string")), SessionId = structure(logical(0), tags = list(type = "string")), InstanceId = structure(logical(0), tags = list(type = "string")), PoolId = structure(logical(0), tags = list(type = "string")), ExpirationTime = structure(logical(0), tags = list(type = "timestamp")), NetworkAccessConfiguration = structure(list(EniPrivateIpAddress = structure(logical(0), tags = list(type = "string")), EniId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), StartTime = structure(logical(0), tags = list(type = "timestamp")), UserId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$describe_workspaces_pools_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(PoolIds = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), Filters = structure(list(structure(list(Name = structure(logical(0), tags = list(type = "string")), Values = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), Operator = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), Limit = structure(logical(0), tags = list(type = "integer")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$describe_workspaces_pools_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(WorkspacesPools = structure(list(structure(list(PoolId = structure(logical(0), tags = list(type = "string")), PoolArn = structure(logical(0), tags = list(type = "string")), CapacityStatus = structure(list(AvailableUserSessions = structure(logical(0), tags = list(type = "integer")), DesiredUserSessions = structure(logical(0), tags = list(type = "integer")), ActualUserSessions = structure(logical(0), tags = list(type = "integer")), ActiveUserSessions = structure(logical(0), tags = list(type = "integer"))), tags = list(type = "structure")), PoolName = structure(logical(0), tags = list(type = "string")), Description = structure(logical(0), tags = list(type = "string")), State = structure(logical(0), tags = list(type = "string")), CreatedAt = structure(logical(0), tags = list(type = "timestamp")), BundleId = structure(logical(0), tags = list(type = "string")), DirectoryId = structure(logical(0), tags = list(type = "string")), Errors = structure(list(structure(list(ErrorCode = structure(logical(0), tags = list(type = "string")), ErrorMessage = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), ApplicationSettings = structure(list(Status = structure(logical(0), tags = list(type = "string")), SettingsGroup = structure(logical(0), tags = list(type = "string")), S3BucketName = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), TimeoutSettings = structure(list(DisconnectTimeoutInSeconds = structure(logical(0), tags = list(type = "integer")), IdleDisconnectTimeoutInSeconds = structure(logical(0), tags = list(type = "integer")), MaxUserDurationInSeconds = structure(logical(0), tags = list(type = "integer"))), tags = list(type = "structure")), RunningMode = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$disassociate_connection_alias_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(AliasId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$disassociate_connection_alias_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$disassociate_ip_groups_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(DirectoryId = structure(logical(0), tags = list(type = "string")), GroupIds = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$disassociate_ip_groups_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$disassociate_workspace_application_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(WorkspaceId = structure(logical(0), tags = list(type = "string")), ApplicationId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$disassociate_workspace_application_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Association = structure(list(AssociatedResourceId = structure(logical(0), tags = list(type = "string")), AssociatedResourceType = structure(logical(0), tags = list(type = "string")), Created = structure(logical(0), tags = list(type = "timestamp")), LastUpdatedTime = structure(logical(0), tags = list(type = "timestamp")), State = structure(logical(0), tags = list(type = "string")), StateReason = structure(list(ErrorCode = structure(logical(0), tags = list(type = "string")), ErrorMessage = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), WorkspaceId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$get_account_link_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(LinkId = structure(logical(0), tags = list(type = "string")), LinkedAccountId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$get_account_link_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(AccountLink = structure(list(AccountLinkId = structure(logical(0), tags = list(type = "string")), AccountLinkStatus = structure(logical(0), tags = list(type = "string")), SourceAccountId = structure(logical(0), tags = list(type = "string")), TargetAccountId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$import_client_branding_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ResourceId = structure(logical(0), tags = list(type = "string")), DeviceTypeWindows = structure(list(Logo = structure(logical(0), tags = list(type = "blob")), SupportEmail = structure(logical(0), tags = list(type = "string")), SupportLink = structure(logical(0), tags = list(type = "string")), ForgotPasswordLink = structure(logical(0), tags = list(type = "string")), LoginMessage = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map"))), tags = list(type = "structure")), DeviceTypeOsx = structure(list(Logo = structure(logical(0), tags = list(type = "blob")), SupportEmail = structure(logical(0), tags = list(type = "string")), SupportLink = structure(logical(0), tags = list(type = "string")), ForgotPasswordLink = structure(logical(0), tags = list(type = "string")), LoginMessage = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map"))), tags = list(type = "structure")), DeviceTypeAndroid = structure(list(Logo = structure(logical(0), tags = list(type = "blob")), SupportEmail = structure(logical(0), tags = list(type = "string")), SupportLink = structure(logical(0), tags = list(type = "string")), ForgotPasswordLink = structure(logical(0), tags = list(type = "string")), LoginMessage = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map"))), tags = list(type = "structure")), DeviceTypeIos = structure(list(Logo = structure(logical(0), tags = list(type = "blob")), Logo2x = structure(logical(0), tags = list(type = "blob")), Logo3x = structure(logical(0), tags = list(type = "blob")), SupportEmail = structure(logical(0), tags = list(type = "string")), SupportLink = structure(logical(0), tags = list(type = "string")), ForgotPasswordLink = structure(logical(0), tags = list(type = "string")), LoginMessage = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map"))), tags = list(type = "structure")), DeviceTypeLinux = structure(list(Logo = structure(logical(0), tags = list(type = "blob")), SupportEmail = structure(logical(0), tags = list(type = "string")), SupportLink = structure(logical(0), tags = list(type = "string")), ForgotPasswordLink = structure(logical(0), tags = list(type = "string")), LoginMessage = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map"))), tags = list(type = "structure")), DeviceTypeWeb = structure(list(Logo = structure(logical(0), tags = list(type = "blob")), SupportEmail = structure(logical(0), tags = list(type = "string")), SupportLink = structure(logical(0), tags = list(type = "string")), ForgotPasswordLink = structure(logical(0), tags = list(type = "string")), LoginMessage = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$import_client_branding_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(DeviceTypeWindows = structure(list(LogoUrl = structure(logical(0), tags = list(type = "string")), SupportEmail = structure(logical(0), tags = list(type = "string")), SupportLink = structure(logical(0), tags = list(type = "string")), ForgotPasswordLink = structure(logical(0), tags = list(type = "string")), LoginMessage = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map"))), tags = list(type = "structure")), DeviceTypeOsx = structure(list(LogoUrl = structure(logical(0), tags = list(type = "string")), SupportEmail = structure(logical(0), tags = list(type = "string")), SupportLink = structure(logical(0), tags = list(type = "string")), ForgotPasswordLink = structure(logical(0), tags = list(type = "string")), LoginMessage = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map"))), tags = list(type = "structure")), DeviceTypeAndroid = structure(list(LogoUrl = structure(logical(0), tags = list(type = "string")), SupportEmail = structure(logical(0), tags = list(type = "string")), SupportLink = structure(logical(0), tags = list(type = "string")), ForgotPasswordLink = structure(logical(0), tags = list(type = "string")), LoginMessage = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map"))), tags = list(type = "structure")), DeviceTypeIos = structure(list(LogoUrl = structure(logical(0), tags = list(type = "string")), Logo2xUrl = structure(logical(0), tags = list(type = "string")), Logo3xUrl = structure(logical(0), tags = list(type = "string")), SupportEmail = structure(logical(0), tags = list(type = "string")), SupportLink = structure(logical(0), tags = list(type = "string")), ForgotPasswordLink = structure(logical(0), tags = list(type = "string")), LoginMessage = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map"))), tags = list(type = "structure")), DeviceTypeLinux = structure(list(LogoUrl = structure(logical(0), tags = list(type = "string")), SupportEmail = structure(logical(0), tags = list(type = "string")), SupportLink = structure(logical(0), tags = list(type = "string")), ForgotPasswordLink = structure(logical(0), tags = list(type = "string")), LoginMessage = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map"))), tags = list(type = "structure")), DeviceTypeWeb = structure(list(LogoUrl = structure(logical(0), tags = list(type = "string")), SupportEmail = structure(logical(0), tags = list(type = "string")), SupportLink = structure(logical(0), tags = list(type = "string")), ForgotPasswordLink = structure(logical(0), tags = list(type = "string")), LoginMessage = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$import_custom_workspace_image_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ImageName = structure(logical(0), tags = list(type = "string")), ImageDescription = structure(logical(0), tags = list(type = "string")), ComputeType = structure(logical(0), tags = list(type = "string")), Protocol = structure(logical(0), tags = list(type = "string")), ImageSource = structure(list(Ec2ImportTaskId = structure(logical(0), tags = list(type = "string")), ImageBuildVersionArn = structure(logical(0), tags = list(type = "string")), Ec2ImageId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure", union = TRUE)), InfrastructureConfigurationArn = structure(logical(0), tags = list(type = "string")), Platform = structure(logical(0), tags = list(type = "string")), OsVersion = structure(logical(0), tags = list(type = "string")), Tags = structure(list(structure(list(Key = structure(logical(0), tags = list(type = "string")), Value = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$import_custom_workspace_image_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ImageId = structure(logical(0), tags = list(type = "string")), State = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$import_workspace_image_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Ec2ImageId = structure(logical(0), tags = list(type = "string")), IngestionProcess = structure(logical(0), tags = list(type = "string")), ImageName = structure(logical(0), tags = list(type = "string")), ImageDescription = structure(logical(0), tags = list(type = "string")), Tags = structure(list(structure(list(Key = structure(logical(0), tags = list(type = "string")), Value = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), Applications = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$import_workspace_image_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ImageId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$list_account_links_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(LinkStatusFilter = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), NextToken = structure(logical(0), tags = list(type = "string")), MaxResults = structure(logical(0), tags = list(type = "integer"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$list_account_links_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(AccountLinks = structure(list(structure(list(AccountLinkId = structure(logical(0), tags = list(type = "string")), AccountLinkStatus = structure(logical(0), tags = list(type = "string")), SourceAccountId = structure(logical(0), tags = list(type = "string")), TargetAccountId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$list_available_management_cidr_ranges_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ManagementCidrRangeConstraint = structure(logical(0), tags = list(type = "string")), MaxResults = structure(logical(0), tags = list(type = "integer")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$list_available_management_cidr_ranges_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ManagementCidrRanges = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), NextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$migrate_workspace_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(SourceWorkspaceId = structure(logical(0), tags = list(type = "string")), BundleId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$migrate_workspace_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(SourceWorkspaceId = structure(logical(0), tags = list(type = "string")), TargetWorkspaceId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$modify_account_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(DedicatedTenancySupport = structure(logical(0), tags = list(type = "string")), DedicatedTenancyManagementCidrRange = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$modify_account_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Message = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$modify_certificate_based_auth_properties_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ResourceId = structure(logical(0), tags = list(type = "string")), CertificateBasedAuthProperties = structure(list(Status = structure(logical(0), tags = list(type = "string")), CertificateAuthorityArn = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), PropertiesToDelete = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$modify_certificate_based_auth_properties_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$modify_client_properties_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ResourceId = structure(logical(0), tags = list(type = "string")), ClientProperties = structure(list(ReconnectEnabled = structure(logical(0), tags = list(type = "string")), LogUploadEnabled = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$modify_client_properties_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$modify_endpoint_encryption_mode_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(DirectoryId = structure(logical(0), tags = list(type = "string")), EndpointEncryptionMode = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$modify_endpoint_encryption_mode_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$modify_saml_properties_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ResourceId = structure(logical(0), tags = list(type = "string")), SamlProperties = structure(list(Status = structure(logical(0), tags = list(type = "string")), UserAccessUrl = structure(logical(0), tags = list(type = "string")), RelayStateParameterName = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), PropertiesToDelete = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$modify_saml_properties_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$modify_selfservice_permissions_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ResourceId = structure(logical(0), tags = list(type = "string")), SelfservicePermissions = structure(list(RestartWorkspace = structure(logical(0), tags = list(type = "string")), IncreaseVolumeSize = structure(logical(0), tags = list(type = "string")), ChangeComputeType = structure(logical(0), tags = list(type = "string")), SwitchRunningMode = structure(logical(0), tags = list(type = "string")), RebuildWorkspace = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$modify_selfservice_permissions_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$modify_streaming_properties_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ResourceId = structure(logical(0), tags = list(type = "string")), StreamingProperties = structure(list(StreamingExperiencePreferredProtocol = structure(logical(0), tags = list(type = "string")), UserSettings = structure(list(structure(list(Action = structure(logical(0), tags = list(type = "string")), Permission = structure(logical(0), tags = list(type = "string")), MaximumLength = structure(logical(0), tags = list(type = "integer"))), tags = list(type = "structure"))), tags = list(type = "list")), StorageConnectors = structure(list(structure(list(ConnectorType = structure(logical(0), tags = list(type = "string")), Status = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), GlobalAccelerator = structure(list(Mode = structure(logical(0), tags = list(type = "string")), PreferredProtocol = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$modify_streaming_properties_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$modify_workspace_access_properties_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ResourceId = structure(logical(0), tags = list(type = "string")), WorkspaceAccessProperties = structure(list(DeviceTypeWindows = structure(logical(0), tags = list(type = "string")), DeviceTypeOsx = structure(logical(0), tags = list(type = "string")), DeviceTypeWeb = structure(logical(0), tags = list(type = "string")), DeviceTypeIos = structure(logical(0), tags = list(type = "string")), DeviceTypeAndroid = structure(logical(0), tags = list(type = "string")), DeviceTypeChromeOs = structure(logical(0), tags = list(type = "string")), DeviceTypeZeroClient = structure(logical(0), tags = list(type = "string")), DeviceTypeLinux = structure(logical(0), tags = list(type = "string")), DeviceTypeWorkSpacesThinClient = structure(logical(0), tags = list(type = "string")), AccessEndpointConfig = structure(list(AccessEndpoints = structure(list(structure(list(AccessEndpointType = structure(logical(0), tags = list(type = "string")), VpcEndpointId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), InternetFallbackProtocols = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$modify_workspace_access_properties_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$modify_workspace_creation_properties_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ResourceId = structure(logical(0), tags = list(type = "string")), WorkspaceCreationProperties = structure(list(EnableInternetAccess = structure(logical(0), tags = list(type = "boolean")), DefaultOu = structure(logical(0), tags = list(type = "string")), CustomSecurityGroupId = structure(logical(0), tags = list(type = "string")), UserEnabledAsLocalAdministrator = structure(logical(0), tags = list(type = "boolean")), EnableMaintenanceMode = structure(logical(0), tags = list(type = "boolean")), InstanceIamRoleArn = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$modify_workspace_creation_properties_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$modify_workspace_properties_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(WorkspaceId = structure(logical(0), tags = list(type = "string")), WorkspaceProperties = structure(list(RunningMode = structure(logical(0), tags = list(type = "string")), RunningModeAutoStopTimeoutInMinutes = structure(logical(0), tags = list(type = "integer")), RootVolumeSizeGib = structure(logical(0), tags = list(type = "integer")), UserVolumeSizeGib = structure(logical(0), tags = list(type = "integer")), ComputeTypeName = structure(logical(0), tags = list(type = "string")), Protocols = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), OperatingSystemName = structure(logical(0), tags = list(type = "string")), GlobalAccelerator = structure(list(Mode = structure(logical(0), tags = list(type = "string")), PreferredProtocol = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure")), DataReplication = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$modify_workspace_properties_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$modify_workspace_state_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(WorkspaceId = structure(logical(0), tags = list(type = "string")), WorkspaceState = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$modify_workspace_state_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$reboot_workspaces_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(RebootWorkspaceRequests = structure(list(structure(list(WorkspaceId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$reboot_workspaces_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(FailedRequests = structure(list(structure(list(WorkspaceId = structure(logical(0), tags = list(type = "string")), ErrorCode = structure(logical(0), tags = list(type = "string")), ErrorMessage = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$rebuild_workspaces_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(RebuildWorkspaceRequests = structure(list(structure(list(WorkspaceId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$rebuild_workspaces_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(FailedRequests = structure(list(structure(list(WorkspaceId = structure(logical(0), tags = list(type = "string")), ErrorCode = structure(logical(0), tags = list(type = "string")), ErrorMessage = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$register_workspace_directory_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(DirectoryId = structure(logical(0), tags = list(type = "string")), SubnetIds = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), EnableSelfService = structure(logical(0), tags = list(type = "boolean")), Tenancy = structure(logical(0), tags = list(type = "string")), Tags = structure(list(structure(list(Key = structure(logical(0), tags = list(type = "string")), Value = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), WorkspaceDirectoryName = structure(logical(0), tags = list(type = "string")), WorkspaceDirectoryDescription = structure(logical(0), tags = list(type = "string")), UserIdentityType = structure(logical(0), tags = list(type = "string")), IdcInstanceArn = structure(logical(0), tags = list(type = "string")), MicrosoftEntraConfig = structure(list(TenantId = structure(logical(0), tags = list(type = "string")), ApplicationConfigSecretArn = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), WorkspaceType = structure(logical(0), tags = list(type = "string")), ActiveDirectoryConfig = structure(list(DomainName = structure(logical(0), tags = list(type = "string")), ServiceAccountSecretArn = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$register_workspace_directory_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(DirectoryId = structure(logical(0), tags = list(type = "string")), State = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$reject_account_link_invitation_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(LinkId = structure(logical(0), tags = list(type = "string")), ClientToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$reject_account_link_invitation_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(AccountLink = structure(list(AccountLinkId = structure(logical(0), tags = list(type = "string")), AccountLinkStatus = structure(logical(0), tags = list(type = "string")), SourceAccountId = structure(logical(0), tags = list(type = "string")), TargetAccountId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$restore_workspace_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(WorkspaceId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$restore_workspace_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$revoke_ip_rules_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(GroupId = structure(logical(0), tags = list(type = "string")), UserRules = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$revoke_ip_rules_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$start_workspaces_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(StartWorkspaceRequests = structure(list(structure(list(WorkspaceId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$start_workspaces_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(FailedRequests = structure(list(structure(list(WorkspaceId = structure(logical(0), tags = list(type = "string")), ErrorCode = structure(logical(0), tags = list(type = "string")), ErrorMessage = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$start_workspaces_pool_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(PoolId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$start_workspaces_pool_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$stop_workspaces_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(StopWorkspaceRequests = structure(list(structure(list(WorkspaceId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$stop_workspaces_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(FailedRequests = structure(list(structure(list(WorkspaceId = structure(logical(0), tags = list(type = "string")), ErrorCode = structure(logical(0), tags = list(type = "string")), ErrorMessage = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$stop_workspaces_pool_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(PoolId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$stop_workspaces_pool_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$terminate_workspaces_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(TerminateWorkspaceRequests = structure(list(structure(list(WorkspaceId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$terminate_workspaces_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(FailedRequests = structure(list(structure(list(WorkspaceId = structure(logical(0), tags = list(type = "string")), ErrorCode = structure(logical(0), tags = list(type = "string")), ErrorMessage = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$terminate_workspaces_pool_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(PoolId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$terminate_workspaces_pool_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$terminate_workspaces_pool_session_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(SessionId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$terminate_workspaces_pool_session_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$update_connect_client_add_in_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(AddInId = structure(logical(0), tags = list(type = "string")), ResourceId = structure(logical(0), tags = list(type = "string")), Name = structure(logical(0), tags = list(type = "string")), URL = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$update_connect_client_add_in_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$update_connection_alias_permission_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(AliasId = structure(logical(0), tags = list(type = "string")), ConnectionAliasPermission = structure(list(SharedAccountId = structure(logical(0), tags = list(type = "string")), AllowAssociation = structure(logical(0), tags = list(type = "boolean"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$update_connection_alias_permission_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$update_rules_of_ip_group_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(GroupId = structure(logical(0), tags = list(type = "string")), UserRules = structure(list(structure(list(ipRule = structure(logical(0), tags = list(type = "string")), ruleDesc = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$update_rules_of_ip_group_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$update_workspace_bundle_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(BundleId = structure(logical(0), tags = list(type = "string")), ImageId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$update_workspace_bundle_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$update_workspace_image_permission_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ImageId = structure(logical(0), tags = list(type = "string")), AllowCopyImage = structure(logical(0), tags = list(type = "boolean")), SharedAccountId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$update_workspace_image_permission_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$update_workspaces_pool_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(PoolId = structure(logical(0), tags = list(type = "string")), Description = structure(logical(0), tags = list(type = "string")), BundleId = structure(logical(0), tags = list(type = "string")), DirectoryId = structure(logical(0), tags = list(type = "string")), Capacity = structure(list(DesiredUserSessions = structure(logical(0), tags = list(type = "integer"))), tags = list(type = "structure")), ApplicationSettings = structure(list(Status = structure(logical(0), tags = list(type = "string")), SettingsGroup = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), TimeoutSettings = structure(list(DisconnectTimeoutInSeconds = structure(logical(0), tags = list(type = "integer")), IdleDisconnectTimeoutInSeconds = structure(logical(0), tags = list(type = "integer")), MaxUserDurationInSeconds = structure(logical(0), tags = list(type = "integer"))), tags = list(type = "structure")), RunningMode = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workspaces$update_workspaces_pool_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(WorkspacesPool = structure(list(PoolId = structure(logical(0), tags = list(type = "string")), PoolArn = structure(logical(0), tags = list(type = "string")), CapacityStatus = structure(list(AvailableUserSessions = structure(logical(0), tags = list(type = "integer")), DesiredUserSessions = structure(logical(0), tags = list(type = "integer")), ActualUserSessions = structure(logical(0), tags = list(type = "integer")), ActiveUserSessions = structure(logical(0), tags = list(type = "integer"))), tags = list(type = "structure")), PoolName = structure(logical(0), tags = list(type = "string")), Description = structure(logical(0), tags = list(type = "string")), State = structure(logical(0), tags = list(type = "string")), CreatedAt = structure(logical(0), tags = list(type = "timestamp")), BundleId = structure(logical(0), tags = list(type = "string")), DirectoryId = structure(logical(0), tags = list(type = "string")), Errors = structure(list(structure(list(ErrorCode = structure(logical(0), tags = list(type = "string")), ErrorMessage = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), ApplicationSettings = structure(list(Status = structure(logical(0), tags = list(type = "string")), SettingsGroup = structure(logical(0), tags = list(type = "string")), S3BucketName = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), TimeoutSettings = structure(list(DisconnectTimeoutInSeconds = structure(logical(0), tags = list(type = "integer")), IdleDisconnectTimeoutInSeconds = structure(logical(0), tags = list(type = "integer")), MaxUserDurationInSeconds = structure(logical(0), tags = list(type = "integer"))), tags = list(type = "structure")), RunningMode = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

# This file is generated by make.paws. Please do not edit here.
#' @importFrom paws.common populate
#' @include workdocs_service.R
NULL

.workdocs$abort_document_version_upload_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(AuthenticationToken = structure(logical(0), tags = list(location = "header", locationName = "Authentication", type = "string", sensitive = TRUE)), DocumentId = structure(logical(0), tags = list(location = "uri", locationName = "DocumentId", type = "string")), VersionId = structure(logical(0), tags = list(location = "uri", locationName = "VersionId", type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workdocs$abort_document_version_upload_output <- function(...) {
  list()
}

.workdocs$activate_user_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(UserId = structure(logical(0), tags = list(location = "uri", locationName = "UserId", type = "string")), AuthenticationToken = structure(logical(0), tags = list(location = "header", locationName = "Authentication", type = "string", sensitive = TRUE))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workdocs$activate_user_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(User = structure(list(Id = structure(logical(0), tags = list(type = "string")), Username = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), EmailAddress = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), GivenName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), Surname = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), OrganizationId = structure(logical(0), tags = list(type = "string")), RootFolderId = structure(logical(0), tags = list(type = "string")), RecycleBinFolderId = structure(logical(0), tags = list(type = "string")), Status = structure(logical(0), tags = list(type = "string")), Type = structure(logical(0), tags = list(type = "string")), CreatedTimestamp = structure(logical(0), tags = list(type = "timestamp")), ModifiedTimestamp = structure(logical(0), tags = list(type = "timestamp")), TimeZoneId = structure(logical(0), tags = list(type = "string")), Locale = structure(logical(0), tags = list(type = "string")), Storage = structure(list(StorageUtilizedInBytes = structure(logical(0), tags = list(type = "long")), StorageRule = structure(list(StorageAllocatedInBytes = structure(logical(0), tags = list(type = "long")), StorageType = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workdocs$add_resource_permissions_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(AuthenticationToken = structure(logical(0), tags = list(location = "header", locationName = "Authentication", type = "string", sensitive = TRUE)), ResourceId = structure(logical(0), tags = list(location = "uri", locationName = "ResourceId", type = "string")), Principals = structure(list(structure(list(Id = structure(logical(0), tags = list(type = "string")), Type = structure(logical(0), tags = list(type = "string")), Role = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), NotificationOptions = structure(list(SendEmail = structure(logical(0), tags = list(type = "boolean")), EmailMessage = structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workdocs$add_resource_permissions_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ShareResults = structure(list(structure(list(PrincipalId = structure(logical(0), tags = list(type = "string")), InviteePrincipalId = structure(logical(0), tags = list(type = "string")), Role = structure(logical(0), tags = list(type = "string")), Status = structure(logical(0), tags = list(type = "string")), ShareId = structure(logical(0), tags = list(type = "string")), StatusMessage = structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workdocs$create_comment_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(AuthenticationToken = structure(logical(0), tags = list(location = "header", locationName = "Authentication", type = "string", sensitive = TRUE)), DocumentId = structure(logical(0), tags = list(location = "uri", locationName = "DocumentId", type = "string")), VersionId = structure(logical(0), tags = list(location = "uri", locationName = "VersionId", type = "string")), ParentId = structure(logical(0), tags = list(type = "string")), ThreadId = structure(logical(0), tags = list(type = "string")), Text = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), Visibility = structure(logical(0), tags = list(type = "string")), NotifyCollaborators = structure(logical(0), tags = list(type = "boolean"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workdocs$create_comment_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Comment = structure(list(CommentId = structure(logical(0), tags = list(type = "string")), ParentId = structure(logical(0), tags = list(type = "string")), ThreadId = structure(logical(0), tags = list(type = "string")), Text = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), Contributor = structure(list(Id = structure(logical(0), tags = list(type = "string")), Username = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), EmailAddress = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), GivenName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), Surname = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), OrganizationId = structure(logical(0), tags = list(type = "string")), RootFolderId = structure(logical(0), tags = list(type = "string")), RecycleBinFolderId = structure(logical(0), tags = list(type = "string")), Status = structure(logical(0), tags = list(type = "string")), Type = structure(logical(0), tags = list(type = "string")), CreatedTimestamp = structure(logical(0), tags = list(type = "timestamp")), ModifiedTimestamp = structure(logical(0), tags = list(type = "timestamp")), TimeZoneId = structure(logical(0), tags = list(type = "string")), Locale = structure(logical(0), tags = list(type = "string")), Storage = structure(list(StorageUtilizedInBytes = structure(logical(0), tags = list(type = "long")), StorageRule = structure(list(StorageAllocatedInBytes = structure(logical(0), tags = list(type = "long")), StorageType = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure"))), tags = list(type = "structure")), CreatedTimestamp = structure(logical(0), tags = list(type = "timestamp")), Status = structure(logical(0), tags = list(type = "string")), Visibility = structure(logical(0), tags = list(type = "string")), RecipientId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workdocs$create_custom_metadata_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(AuthenticationToken = structure(logical(0), tags = list(location = "header", locationName = "Authentication", type = "string", sensitive = TRUE)), ResourceId = structure(logical(0), tags = list(location = "uri", locationName = "ResourceId", type = "string")), VersionId = structure(logical(0), tags = list(location = "querystring", locationName = "versionid", type = "string")), CustomMetadata = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workdocs$create_custom_metadata_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workdocs$create_folder_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(AuthenticationToken = structure(logical(0), tags = list(location = "header", locationName = "Authentication", type = "string", sensitive = TRUE)), Name = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), ParentFolderId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workdocs$create_folder_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Metadata = structure(list(Id = structure(logical(0), tags = list(type = "string")), Name = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), CreatorId = structure(logical(0), tags = list(type = "string")), ParentFolderId = structure(logical(0), tags = list(type = "string")), CreatedTimestamp = structure(logical(0), tags = list(type = "timestamp")), ModifiedTimestamp = structure(logical(0), tags = list(type = "timestamp")), ResourceState = structure(logical(0), tags = list(type = "string")), Signature = structure(logical(0), tags = list(type = "string")), Labels = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), Size = structure(logical(0), tags = list(type = "long")), LatestVersionSize = structure(logical(0), tags = list(type = "long"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workdocs$create_labels_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ResourceId = structure(logical(0), tags = list(location = "uri", locationName = "ResourceId", type = "string")), Labels = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), AuthenticationToken = structure(logical(0), tags = list(location = "header", locationName = "Authentication", type = "string", sensitive = TRUE))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workdocs$create_labels_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workdocs$create_notification_subscription_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(location = "uri", locationName = "OrganizationId", type = "string")), Endpoint = structure(logical(0), tags = list(type = "string")), Protocol = structure(logical(0), tags = list(type = "string")), SubscriptionType = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workdocs$create_notification_subscription_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Subscription = structure(list(SubscriptionId = structure(logical(0), tags = list(type = "string")), EndPoint = structure(logical(0), tags = list(type = "string")), Protocol = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workdocs$create_user_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(type = "string")), Username = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), EmailAddress = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), GivenName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), Surname = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), Password = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), TimeZoneId = structure(logical(0), tags = list(type = "string")), StorageRule = structure(list(StorageAllocatedInBytes = structure(logical(0), tags = list(type = "long")), StorageType = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), AuthenticationToken = structure(logical(0), tags = list(location = "header", locationName = "Authentication", type = "string", sensitive = TRUE))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workdocs$create_user_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(User = structure(list(Id = structure(logical(0), tags = list(type = "string")), Username = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), EmailAddress = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), GivenName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), Surname = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), OrganizationId = structure(logical(0), tags = list(type = "string")), RootFolderId = structure(logical(0), tags = list(type = "string")), RecycleBinFolderId = structure(logical(0), tags = list(type = "string")), Status = structure(logical(0), tags = list(type = "string")), Type = structure(logical(0), tags = list(type = "string")), CreatedTimestamp = structure(logical(0), tags = list(type = "timestamp")), ModifiedTimestamp = structure(logical(0), tags = list(type = "timestamp")), TimeZoneId = structure(logical(0), tags = list(type = "string")), Locale = structure(logical(0), tags = list(type = "string")), Storage = structure(list(StorageUtilizedInBytes = structure(logical(0), tags = list(type = "long")), StorageRule = structure(list(StorageAllocatedInBytes = structure(logical(0), tags = list(type = "long")), StorageType = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workdocs$deactivate_user_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(UserId = structure(logical(0), tags = list(location = "uri", locationName = "UserId", type = "string")), AuthenticationToken = structure(logical(0), tags = list(location = "header", locationName = "Authentication", type = "string", sensitive = TRUE))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workdocs$deactivate_user_output <- function(...) {
  list()
}

.workdocs$delete_comment_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(AuthenticationToken = structure(logical(0), tags = list(location = "header", locationName = "Authentication", type = "string", sensitive = TRUE)), DocumentId = structure(logical(0), tags = list(location = "uri", locationName = "DocumentId", type = "string")), VersionId = structure(logical(0), tags = list(location = "uri", locationName = "VersionId", type = "string")), CommentId = structure(logical(0), tags = list(location = "uri", locationName = "CommentId", type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workdocs$delete_comment_output <- function(...) {
  list()
}

.workdocs$delete_custom_metadata_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(AuthenticationToken = structure(logical(0), tags = list(location = "header", locationName = "Authentication", type = "string", sensitive = TRUE)), ResourceId = structure(logical(0), tags = list(location = "uri", locationName = "ResourceId", type = "string")), VersionId = structure(logical(0), tags = list(location = "querystring", locationName = "versionId", type = "string")), Keys = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(location = "querystring", locationName = "keys", type = "list")), DeleteAll = structure(logical(0), tags = list(location = "querystring", locationName = "deleteAll", type = "boolean"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workdocs$delete_custom_metadata_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workdocs$delete_document_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(AuthenticationToken = structure(logical(0), tags = list(location = "header", locationName = "Authentication", type = "string", sensitive = TRUE)), DocumentId = structure(logical(0), tags = list(location = "uri", locationName = "DocumentId", type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workdocs$delete_document_output <- function(...) {
  list()
}

.workdocs$delete_document_version_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(AuthenticationToken = structure(logical(0), tags = list(location = "header", locationName = "Authentication", type = "string", sensitive = TRUE)), DocumentId = structure(logical(0), tags = list(location = "uri", locationName = "DocumentId", type = "string")), VersionId = structure(logical(0), tags = list(location = "uri", locationName = "VersionId", type = "string")), DeletePriorVersions = structure(logical(0), tags = list(location = "querystring", locationName = "deletePriorVersions", type = "boolean"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workdocs$delete_document_version_output <- function(...) {
  list()
}

.workdocs$delete_folder_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(AuthenticationToken = structure(logical(0), tags = list(location = "header", locationName = "Authentication", type = "string", sensitive = TRUE)), FolderId = structure(logical(0), tags = list(location = "uri", locationName = "FolderId", type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workdocs$delete_folder_output <- function(...) {
  list()
}

.workdocs$delete_folder_contents_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(AuthenticationToken = structure(logical(0), tags = list(location = "header", locationName = "Authentication", type = "string", sensitive = TRUE)), FolderId = structure(logical(0), tags = list(location = "uri", locationName = "FolderId", type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workdocs$delete_folder_contents_output <- function(...) {
  list()
}

.workdocs$delete_labels_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(ResourceId = structure(logical(0), tags = list(location = "uri", locationName = "ResourceId", type = "string")), AuthenticationToken = structure(logical(0), tags = list(location = "header", locationName = "Authentication", type = "string", sensitive = TRUE)), Labels = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(location = "querystring", locationName = "labels", type = "list")), DeleteAll = structure(logical(0), tags = list(location = "querystring", locationName = "deleteAll", type = "boolean"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workdocs$delete_labels_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workdocs$delete_notification_subscription_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(SubscriptionId = structure(logical(0), tags = list(location = "uri", locationName = "SubscriptionId", type = "string")), OrganizationId = structure(logical(0), tags = list(location = "uri", locationName = "OrganizationId", type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workdocs$delete_notification_subscription_output <- function(...) {
  list()
}

.workdocs$delete_user_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(AuthenticationToken = structure(logical(0), tags = list(location = "header", locationName = "Authentication", type = "string", sensitive = TRUE)), UserId = structure(logical(0), tags = list(location = "uri", locationName = "UserId", type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workdocs$delete_user_output <- function(...) {
  list()
}

.workdocs$describe_activities_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(AuthenticationToken = structure(logical(0), tags = list(location = "header", locationName = "Authentication", type = "string", sensitive = TRUE)), StartTime = structure(logical(0), tags = list(location = "querystring", locationName = "startTime", type = "timestamp")), EndTime = structure(logical(0), tags = list(location = "querystring", locationName = "endTime", type = "timestamp")), OrganizationId = structure(logical(0), tags = list(location = "querystring", locationName = "organizationId", type = "string")), ActivityTypes = structure(logical(0), tags = list(location = "querystring", locationName = "activityTypes", type = "string")), ResourceId = structure(logical(0), tags = list(location = "querystring", locationName = "resourceId", type = "string")), UserId = structure(logical(0), tags = list(location = "querystring", locationName = "userId", type = "string")), IncludeIndirectActivities = structure(logical(0), tags = list(location = "querystring", locationName = "includeIndirectActivities", type = "boolean")), Limit = structure(logical(0), tags = list(location = "querystring", locationName = "limit", type = "integer")), Marker = structure(logical(0), tags = list(location = "querystring", locationName = "marker", type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workdocs$describe_activities_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(UserActivities = structure(list(structure(list(Type = structure(logical(0), tags = list(type = "string")), TimeStamp = structure(logical(0), tags = list(type = "timestamp")), IsIndirectActivity = structure(logical(0), tags = list(type = "boolean")), OrganizationId = structure(logical(0), tags = list(type = "string")), Initiator = structure(list(Id = structure(logical(0), tags = list(type = "string")), Username = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), GivenName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), Surname = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), EmailAddress = structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "structure")), Participants = structure(list(Users = structure(list(structure(list(Id = structure(logical(0), tags = list(type = "string")), Username = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), GivenName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), Surname = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), EmailAddress = structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "structure"))), tags = list(type = "list")), Groups = structure(list(structure(list(Id = structure(logical(0), tags = list(type = "string")), Name = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure")), ResourceMetadata = structure(list(Type = structure(logical(0), tags = list(type = "string")), Name = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), OriginalName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), Id = structure(logical(0), tags = list(type = "string")), VersionId = structure(logical(0), tags = list(type = "string")), Owner = structure(list(Id = structure(logical(0), tags = list(type = "string")), Username = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), GivenName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), Surname = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), EmailAddress = structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "structure")), ParentId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), OriginalParent = structure(list(Type = structure(logical(0), tags = list(type = "string")), Name = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), OriginalName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), Id = structure(logical(0), tags = list(type = "string")), VersionId = structure(logical(0), tags = list(type = "string")), Owner = structure(list(Id = structure(logical(0), tags = list(type = "string")), Username = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), GivenName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), Surname = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), EmailAddress = structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "structure")), ParentId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), CommentMetadata = structure(list(CommentId = structure(logical(0), tags = list(type = "string")), Contributor = structure(list(Id = structure(logical(0), tags = list(type = "string")), Username = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), EmailAddress = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), GivenName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), Surname = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), OrganizationId = structure(logical(0), tags = list(type = "string")), RootFolderId = structure(logical(0), tags = list(type = "string")), RecycleBinFolderId = structure(logical(0), tags = list(type = "string")), Status = structure(logical(0), tags = list(type = "string")), Type = structure(logical(0), tags = list(type = "string")), CreatedTimestamp = structure(logical(0), tags = list(type = "timestamp")), ModifiedTimestamp = structure(logical(0), tags = list(type = "timestamp")), TimeZoneId = structure(logical(0), tags = list(type = "string")), Locale = structure(logical(0), tags = list(type = "string")), Storage = structure(list(StorageUtilizedInBytes = structure(logical(0), tags = list(type = "long")), StorageRule = structure(list(StorageAllocatedInBytes = structure(logical(0), tags = list(type = "long")), StorageType = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure"))), tags = list(type = "structure")), CreatedTimestamp = structure(logical(0), tags = list(type = "timestamp")), CommentStatus = structure(logical(0), tags = list(type = "string")), RecipientId = structure(logical(0), tags = list(type = "string")), ContributorId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure"))), tags = list(type = "list")), Marker = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workdocs$describe_comments_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(AuthenticationToken = structure(logical(0), tags = list(location = "header", locationName = "Authentication", type = "string", sensitive = TRUE)), DocumentId = structure(logical(0), tags = list(location = "uri", locationName = "DocumentId", type = "string")), VersionId = structure(logical(0), tags = list(location = "uri", locationName = "VersionId", type = "string")), Limit = structure(logical(0), tags = list(location = "querystring", locationName = "limit", type = "integer")), Marker = structure(logical(0), tags = list(location = "querystring", locationName = "marker", type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workdocs$describe_comments_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Comments = structure(list(structure(list(CommentId = structure(logical(0), tags = list(type = "string")), ParentId = structure(logical(0), tags = list(type = "string")), ThreadId = structure(logical(0), tags = list(type = "string")), Text = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), Contributor = structure(list(Id = structure(logical(0), tags = list(type = "string")), Username = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), EmailAddress = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), GivenName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), Surname = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), OrganizationId = structure(logical(0), tags = list(type = "string")), RootFolderId = structure(logical(0), tags = list(type = "string")), RecycleBinFolderId = structure(logical(0), tags = list(type = "string")), Status = structure(logical(0), tags = list(type = "string")), Type = structure(logical(0), tags = list(type = "string")), CreatedTimestamp = structure(logical(0), tags = list(type = "timestamp")), ModifiedTimestamp = structure(logical(0), tags = list(type = "timestamp")), TimeZoneId = structure(logical(0), tags = list(type = "string")), Locale = structure(logical(0), tags = list(type = "string")), Storage = structure(list(StorageUtilizedInBytes = structure(logical(0), tags = list(type = "long")), StorageRule = structure(list(StorageAllocatedInBytes = structure(logical(0), tags = list(type = "long")), StorageType = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure"))), tags = list(type = "structure")), CreatedTimestamp = structure(logical(0), tags = list(type = "timestamp")), Status = structure(logical(0), tags = list(type = "string")), Visibility = structure(logical(0), tags = list(type = "string")), RecipientId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), Marker = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workdocs$describe_document_versions_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(AuthenticationToken = structure(logical(0), tags = list(location = "header", locationName = "Authentication", type = "string", sensitive = TRUE)), DocumentId = structure(logical(0), tags = list(location = "uri", locationName = "DocumentId", type = "string")), Marker = structure(logical(0), tags = list(location = "querystring", locationName = "marker", type = "string")), Limit = structure(logical(0), tags = list(location = "querystring", locationName = "limit", type = "integer")), Include = structure(logical(0), tags = list(location = "querystring", locationName = "include", type = "string")), Fields = structure(logical(0), tags = list(location = "querystring", locationName = "fields", type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workdocs$describe_document_versions_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(DocumentVersions = structure(list(structure(list(Id = structure(logical(0), tags = list(type = "string")), Name = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), ContentType = structure(logical(0), tags = list(type = "string")), Size = structure(logical(0), tags = list(type = "long")), Signature = structure(logical(0), tags = list(type = "string")), Status = structure(logical(0), tags = list(type = "string")), CreatedTimestamp = structure(logical(0), tags = list(type = "timestamp")), ModifiedTimestamp = structure(logical(0), tags = list(type = "timestamp")), ContentCreatedTimestamp = structure(logical(0), tags = list(type = "timestamp")), ContentModifiedTimestamp = structure(logical(0), tags = list(type = "timestamp")), CreatorId = structure(logical(0), tags = list(type = "string")), Thumbnail = structure(list(structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "map")), Source = structure(list(structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "map"))), tags = list(type = "structure"))), tags = list(type = "list")), Marker = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workdocs$describe_folder_contents_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(AuthenticationToken = structure(logical(0), tags = list(location = "header", locationName = "Authentication", type = "string", sensitive = TRUE)), FolderId = structure(logical(0), tags = list(location = "uri", locationName = "FolderId", type = "string")), Sort = structure(logical(0), tags = list(location = "querystring", locationName = "sort", type = "string")), Order = structure(logical(0), tags = list(location = "querystring", locationName = "order", type = "string")), Limit = structure(logical(0), tags = list(location = "querystring", locationName = "limit", type = "integer")), Marker = structure(logical(0), tags = list(location = "querystring", locationName = "marker", type = "string")), Type = structure(logical(0), tags = list(location = "querystring", locationName = "type", type = "string")), Include = structure(logical(0), tags = list(location = "querystring", locationName = "include", type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workdocs$describe_folder_contents_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Folders = structure(list(structure(list(Id = structure(logical(0), tags = list(type = "string")), Name = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), CreatorId = structure(logical(0), tags = list(type = "string")), ParentFolderId = structure(logical(0), tags = list(type = "string")), CreatedTimestamp = structure(logical(0), tags = list(type = "timestamp")), ModifiedTimestamp = structure(logical(0), tags = list(type = "timestamp")), ResourceState = structure(logical(0), tags = list(type = "string")), Signature = structure(logical(0), tags = list(type = "string")), Labels = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), Size = structure(logical(0), tags = list(type = "long")), LatestVersionSize = structure(logical(0), tags = list(type = "long"))), tags = list(type = "structure"))), tags = list(type = "list")), Documents = structure(list(structure(list(Id = structure(logical(0), tags = list(type = "string")), CreatorId = structure(logical(0), tags = list(type = "string")), ParentFolderId = structure(logical(0), tags = list(type = "string")), CreatedTimestamp = structure(logical(0), tags = list(type = "timestamp")), ModifiedTimestamp = structure(logical(0), tags = list(type = "timestamp")), LatestVersionMetadata = structure(list(Id = structure(logical(0), tags = list(type = "string")), Name = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), ContentType = structure(logical(0), tags = list(type = "string")), Size = structure(logical(0), tags = list(type = "long")), Signature = structure(logical(0), tags = list(type = "string")), Status = structure(logical(0), tags = list(type = "string")), CreatedTimestamp = structure(logical(0), tags = list(type = "timestamp")), ModifiedTimestamp = structure(logical(0), tags = list(type = "timestamp")), ContentCreatedTimestamp = structure(logical(0), tags = list(type = "timestamp")), ContentModifiedTimestamp = structure(logical(0), tags = list(type = "timestamp")), CreatorId = structure(logical(0), tags = list(type = "string")), Thumbnail = structure(list(structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "map")), Source = structure(list(structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "map"))), tags = list(type = "structure")), ResourceState = structure(logical(0), tags = list(type = "string")), Labels = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure"))), tags = list(type = "list")), Marker = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workdocs$describe_groups_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(AuthenticationToken = structure(logical(0), tags = list(location = "header", locationName = "Authentication", type = "string", sensitive = TRUE)), SearchQuery = structure(logical(0), tags = list(location = "querystring", locationName = "searchQuery", type = "string", sensitive = TRUE)), OrganizationId = structure(logical(0), tags = list(location = "querystring", locationName = "organizationId", type = "string")), Marker = structure(logical(0), tags = list(location = "querystring", locationName = "marker", type = "string")), Limit = structure(logical(0), tags = list(location = "querystring", locationName = "limit", type = "integer"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workdocs$describe_groups_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Groups = structure(list(structure(list(Id = structure(logical(0), tags = list(type = "string")), Name = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), Marker = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workdocs$describe_notification_subscriptions_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(OrganizationId = structure(logical(0), tags = list(location = "uri", locationName = "OrganizationId", type = "string")), Marker = structure(logical(0), tags = list(location = "querystring", locationName = "marker", type = "string")), Limit = structure(logical(0), tags = list(location = "querystring", locationName = "limit", type = "integer"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workdocs$describe_notification_subscriptions_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Subscriptions = structure(list(structure(list(SubscriptionId = structure(logical(0), tags = list(type = "string")), EndPoint = structure(logical(0), tags = list(type = "string")), Protocol = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), Marker = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workdocs$describe_resource_permissions_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(AuthenticationToken = structure(logical(0), tags = list(location = "header", locationName = "Authentication", type = "string", sensitive = TRUE)), ResourceId = structure(logical(0), tags = list(location = "uri", locationName = "ResourceId", type = "string")), PrincipalId = structure(logical(0), tags = list(location = "querystring", locationName = "principalId", type = "string")), Limit = structure(logical(0), tags = list(location = "querystring", locationName = "limit", type = "integer")), Marker = structure(logical(0), tags = list(location = "querystring", locationName = "marker", type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workdocs$describe_resource_permissions_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Principals = structure(list(structure(list(Id = structure(logical(0), tags = list(type = "string")), Type = structure(logical(0), tags = list(type = "string")), Roles = structure(list(structure(list(Role = structure(logical(0), tags = list(type = "string")), Type = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure"))), tags = list(type = "list")), Marker = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workdocs$describe_root_folders_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(AuthenticationToken = structure(logical(0), tags = list(location = "header", locationName = "Authentication", type = "string", sensitive = TRUE)), Limit = structure(logical(0), tags = list(location = "querystring", locationName = "limit", type = "integer")), Marker = structure(logical(0), tags = list(location = "querystring", locationName = "marker", type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workdocs$describe_root_folders_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Folders = structure(list(structure(list(Id = structure(logical(0), tags = list(type = "string")), Name = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), CreatorId = structure(logical(0), tags = list(type = "string")), ParentFolderId = structure(logical(0), tags = list(type = "string")), CreatedTimestamp = structure(logical(0), tags = list(type = "timestamp")), ModifiedTimestamp = structure(logical(0), tags = list(type = "timestamp")), ResourceState = structure(logical(0), tags = list(type = "string")), Signature = structure(logical(0), tags = list(type = "string")), Labels = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), Size = structure(logical(0), tags = list(type = "long")), LatestVersionSize = structure(logical(0), tags = list(type = "long"))), tags = list(type = "structure"))), tags = list(type = "list")), Marker = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workdocs$describe_users_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(AuthenticationToken = structure(logical(0), tags = list(location = "header", locationName = "Authentication", type = "string", sensitive = TRUE)), OrganizationId = structure(logical(0), tags = list(location = "querystring", locationName = "organizationId", type = "string")), UserIds = structure(logical(0), tags = list(location = "querystring", locationName = "userIds", type = "string")), Query = structure(logical(0), tags = list(location = "querystring", locationName = "query", type = "string", sensitive = TRUE)), Include = structure(logical(0), tags = list(location = "querystring", locationName = "include", type = "string")), Order = structure(logical(0), tags = list(location = "querystring", locationName = "order", type = "string")), Sort = structure(logical(0), tags = list(location = "querystring", locationName = "sort", type = "string")), Marker = structure(logical(0), tags = list(location = "querystring", locationName = "marker", type = "string")), Limit = structure(logical(0), tags = list(location = "querystring", locationName = "limit", type = "integer")), Fields = structure(logical(0), tags = list(location = "querystring", locationName = "fields", type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workdocs$describe_users_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Users = structure(list(structure(list(Id = structure(logical(0), tags = list(type = "string")), Username = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), EmailAddress = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), GivenName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), Surname = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), OrganizationId = structure(logical(0), tags = list(type = "string")), RootFolderId = structure(logical(0), tags = list(type = "string")), RecycleBinFolderId = structure(logical(0), tags = list(type = "string")), Status = structure(logical(0), tags = list(type = "string")), Type = structure(logical(0), tags = list(type = "string")), CreatedTimestamp = structure(logical(0), tags = list(type = "timestamp")), ModifiedTimestamp = structure(logical(0), tags = list(type = "timestamp")), TimeZoneId = structure(logical(0), tags = list(type = "string")), Locale = structure(logical(0), tags = list(type = "string")), Storage = structure(list(StorageUtilizedInBytes = structure(logical(0), tags = list(type = "long")), StorageRule = structure(list(StorageAllocatedInBytes = structure(logical(0), tags = list(type = "long")), StorageType = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure"))), tags = list(type = "structure"))), tags = list(type = "list")), TotalNumberOfUsers = structure(logical(0), tags = list(deprecated = TRUE, type = "long")), Marker = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workdocs$get_current_user_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(AuthenticationToken = structure(logical(0), tags = list(location = "header", locationName = "Authentication", type = "string", sensitive = TRUE))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workdocs$get_current_user_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(User = structure(list(Id = structure(logical(0), tags = list(type = "string")), Username = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), EmailAddress = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), GivenName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), Surname = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), OrganizationId = structure(logical(0), tags = list(type = "string")), RootFolderId = structure(logical(0), tags = list(type = "string")), RecycleBinFolderId = structure(logical(0), tags = list(type = "string")), Status = structure(logical(0), tags = list(type = "string")), Type = structure(logical(0), tags = list(type = "string")), CreatedTimestamp = structure(logical(0), tags = list(type = "timestamp")), ModifiedTimestamp = structure(logical(0), tags = list(type = "timestamp")), TimeZoneId = structure(logical(0), tags = list(type = "string")), Locale = structure(logical(0), tags = list(type = "string")), Storage = structure(list(StorageUtilizedInBytes = structure(logical(0), tags = list(type = "long")), StorageRule = structure(list(StorageAllocatedInBytes = structure(logical(0), tags = list(type = "long")), StorageType = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workdocs$get_document_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(AuthenticationToken = structure(logical(0), tags = list(location = "header", locationName = "Authentication", type = "string", sensitive = TRUE)), DocumentId = structure(logical(0), tags = list(location = "uri", locationName = "DocumentId", type = "string")), IncludeCustomMetadata = structure(logical(0), tags = list(location = "querystring", locationName = "includeCustomMetadata", type = "boolean"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workdocs$get_document_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Metadata = structure(list(Id = structure(logical(0), tags = list(type = "string")), CreatorId = structure(logical(0), tags = list(type = "string")), ParentFolderId = structure(logical(0), tags = list(type = "string")), CreatedTimestamp = structure(logical(0), tags = list(type = "timestamp")), ModifiedTimestamp = structure(logical(0), tags = list(type = "timestamp")), LatestVersionMetadata = structure(list(Id = structure(logical(0), tags = list(type = "string")), Name = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), ContentType = structure(logical(0), tags = list(type = "string")), Size = structure(logical(0), tags = list(type = "long")), Signature = structure(logical(0), tags = list(type = "string")), Status = structure(logical(0), tags = list(type = "string")), CreatedTimestamp = structure(logical(0), tags = list(type = "timestamp")), ModifiedTimestamp = structure(logical(0), tags = list(type = "timestamp")), ContentCreatedTimestamp = structure(logical(0), tags = list(type = "timestamp")), ContentModifiedTimestamp = structure(logical(0), tags = list(type = "timestamp")), CreatorId = structure(logical(0), tags = list(type = "string")), Thumbnail = structure(list(structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "map")), Source = structure(list(structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "map"))), tags = list(type = "structure")), ResourceState = structure(logical(0), tags = list(type = "string")), Labels = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure")), CustomMetadata = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workdocs$get_document_path_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(AuthenticationToken = structure(logical(0), tags = list(location = "header", locationName = "Authentication", type = "string", sensitive = TRUE)), DocumentId = structure(logical(0), tags = list(location = "uri", locationName = "DocumentId", type = "string")), Limit = structure(logical(0), tags = list(location = "querystring", locationName = "limit", type = "integer")), Fields = structure(logical(0), tags = list(location = "querystring", locationName = "fields", type = "string")), Marker = structure(logical(0), tags = list(location = "querystring", locationName = "marker", type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workdocs$get_document_path_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Path = structure(list(Components = structure(list(structure(list(Id = structure(logical(0), tags = list(type = "string")), Name = structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workdocs$get_document_version_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(AuthenticationToken = structure(logical(0), tags = list(location = "header", locationName = "Authentication", type = "string", sensitive = TRUE)), DocumentId = structure(logical(0), tags = list(location = "uri", locationName = "DocumentId", type = "string")), VersionId = structure(logical(0), tags = list(location = "uri", locationName = "VersionId", type = "string")), Fields = structure(logical(0), tags = list(location = "querystring", locationName = "fields", type = "string")), IncludeCustomMetadata = structure(logical(0), tags = list(location = "querystring", locationName = "includeCustomMetadata", type = "boolean"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workdocs$get_document_version_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Metadata = structure(list(Id = structure(logical(0), tags = list(type = "string")), Name = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), ContentType = structure(logical(0), tags = list(type = "string")), Size = structure(logical(0), tags = list(type = "long")), Signature = structure(logical(0), tags = list(type = "string")), Status = structure(logical(0), tags = list(type = "string")), CreatedTimestamp = structure(logical(0), tags = list(type = "timestamp")), ModifiedTimestamp = structure(logical(0), tags = list(type = "timestamp")), ContentCreatedTimestamp = structure(logical(0), tags = list(type = "timestamp")), ContentModifiedTimestamp = structure(logical(0), tags = list(type = "timestamp")), CreatorId = structure(logical(0), tags = list(type = "string")), Thumbnail = structure(list(structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "map")), Source = structure(list(structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "map"))), tags = list(type = "structure")), CustomMetadata = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workdocs$get_folder_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(AuthenticationToken = structure(logical(0), tags = list(location = "header", locationName = "Authentication", type = "string", sensitive = TRUE)), FolderId = structure(logical(0), tags = list(location = "uri", locationName = "FolderId", type = "string")), IncludeCustomMetadata = structure(logical(0), tags = list(location = "querystring", locationName = "includeCustomMetadata", type = "boolean"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workdocs$get_folder_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Metadata = structure(list(Id = structure(logical(0), tags = list(type = "string")), Name = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), CreatorId = structure(logical(0), tags = list(type = "string")), ParentFolderId = structure(logical(0), tags = list(type = "string")), CreatedTimestamp = structure(logical(0), tags = list(type = "timestamp")), ModifiedTimestamp = structure(logical(0), tags = list(type = "timestamp")), ResourceState = structure(logical(0), tags = list(type = "string")), Signature = structure(logical(0), tags = list(type = "string")), Labels = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), Size = structure(logical(0), tags = list(type = "long")), LatestVersionSize = structure(logical(0), tags = list(type = "long"))), tags = list(type = "structure")), CustomMetadata = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workdocs$get_folder_path_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(AuthenticationToken = structure(logical(0), tags = list(location = "header", locationName = "Authentication", type = "string", sensitive = TRUE)), FolderId = structure(logical(0), tags = list(location = "uri", locationName = "FolderId", type = "string")), Limit = structure(logical(0), tags = list(location = "querystring", locationName = "limit", type = "integer")), Fields = structure(logical(0), tags = list(location = "querystring", locationName = "fields", type = "string")), Marker = structure(logical(0), tags = list(location = "querystring", locationName = "marker", type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workdocs$get_folder_path_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Path = structure(list(Components = structure(list(structure(list(Id = structure(logical(0), tags = list(type = "string")), Name = structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "structure"))), tags = list(type = "list"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workdocs$get_resources_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(AuthenticationToken = structure(logical(0), tags = list(location = "header", locationName = "Authentication", type = "string", sensitive = TRUE)), UserId = structure(logical(0), tags = list(location = "querystring", locationName = "userId", type = "string")), CollectionType = structure(logical(0), tags = list(location = "querystring", locationName = "collectionType", type = "string")), Limit = structure(logical(0), tags = list(location = "querystring", locationName = "limit", type = "integer")), Marker = structure(logical(0), tags = list(location = "querystring", locationName = "marker", type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workdocs$get_resources_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Folders = structure(list(structure(list(Id = structure(logical(0), tags = list(type = "string")), Name = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), CreatorId = structure(logical(0), tags = list(type = "string")), ParentFolderId = structure(logical(0), tags = list(type = "string")), CreatedTimestamp = structure(logical(0), tags = list(type = "timestamp")), ModifiedTimestamp = structure(logical(0), tags = list(type = "timestamp")), ResourceState = structure(logical(0), tags = list(type = "string")), Signature = structure(logical(0), tags = list(type = "string")), Labels = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), Size = structure(logical(0), tags = list(type = "long")), LatestVersionSize = structure(logical(0), tags = list(type = "long"))), tags = list(type = "structure"))), tags = list(type = "list")), Documents = structure(list(structure(list(Id = structure(logical(0), tags = list(type = "string")), CreatorId = structure(logical(0), tags = list(type = "string")), ParentFolderId = structure(logical(0), tags = list(type = "string")), CreatedTimestamp = structure(logical(0), tags = list(type = "timestamp")), ModifiedTimestamp = structure(logical(0), tags = list(type = "timestamp")), LatestVersionMetadata = structure(list(Id = structure(logical(0), tags = list(type = "string")), Name = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), ContentType = structure(logical(0), tags = list(type = "string")), Size = structure(logical(0), tags = list(type = "long")), Signature = structure(logical(0), tags = list(type = "string")), Status = structure(logical(0), tags = list(type = "string")), CreatedTimestamp = structure(logical(0), tags = list(type = "timestamp")), ModifiedTimestamp = structure(logical(0), tags = list(type = "timestamp")), ContentCreatedTimestamp = structure(logical(0), tags = list(type = "timestamp")), ContentModifiedTimestamp = structure(logical(0), tags = list(type = "timestamp")), CreatorId = structure(logical(0), tags = list(type = "string")), Thumbnail = structure(list(structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "map")), Source = structure(list(structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "map"))), tags = list(type = "structure")), ResourceState = structure(logical(0), tags = list(type = "string")), Labels = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure"))), tags = list(type = "list")), Marker = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workdocs$initiate_document_version_upload_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(AuthenticationToken = structure(logical(0), tags = list(location = "header", locationName = "Authentication", type = "string", sensitive = TRUE)), Id = structure(logical(0), tags = list(type = "string")), Name = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), ContentCreatedTimestamp = structure(logical(0), tags = list(type = "timestamp")), ContentModifiedTimestamp = structure(logical(0), tags = list(type = "timestamp")), ContentType = structure(logical(0), tags = list(type = "string")), DocumentSizeInBytes = structure(logical(0), tags = list(type = "long")), ParentFolderId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workdocs$initiate_document_version_upload_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Metadata = structure(list(Id = structure(logical(0), tags = list(type = "string")), CreatorId = structure(logical(0), tags = list(type = "string")), ParentFolderId = structure(logical(0), tags = list(type = "string")), CreatedTimestamp = structure(logical(0), tags = list(type = "timestamp")), ModifiedTimestamp = structure(logical(0), tags = list(type = "timestamp")), LatestVersionMetadata = structure(list(Id = structure(logical(0), tags = list(type = "string")), Name = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), ContentType = structure(logical(0), tags = list(type = "string")), Size = structure(logical(0), tags = list(type = "long")), Signature = structure(logical(0), tags = list(type = "string")), Status = structure(logical(0), tags = list(type = "string")), CreatedTimestamp = structure(logical(0), tags = list(type = "timestamp")), ModifiedTimestamp = structure(logical(0), tags = list(type = "timestamp")), ContentCreatedTimestamp = structure(logical(0), tags = list(type = "timestamp")), ContentModifiedTimestamp = structure(logical(0), tags = list(type = "timestamp")), CreatorId = structure(logical(0), tags = list(type = "string")), Thumbnail = structure(list(structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "map")), Source = structure(list(structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "map"))), tags = list(type = "structure")), ResourceState = structure(logical(0), tags = list(type = "string")), Labels = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure")), UploadMetadata = structure(list(UploadUrl = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), SignedHeaders = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workdocs$remove_all_resource_permissions_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(AuthenticationToken = structure(logical(0), tags = list(location = "header", locationName = "Authentication", type = "string", sensitive = TRUE)), ResourceId = structure(logical(0), tags = list(location = "uri", locationName = "ResourceId", type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workdocs$remove_all_resource_permissions_output <- function(...) {
  list()
}

.workdocs$remove_resource_permission_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(AuthenticationToken = structure(logical(0), tags = list(location = "header", locationName = "Authentication", type = "string", sensitive = TRUE)), ResourceId = structure(logical(0), tags = list(location = "uri", locationName = "ResourceId", type = "string")), PrincipalId = structure(logical(0), tags = list(location = "uri", locationName = "PrincipalId", type = "string")), PrincipalType = structure(logical(0), tags = list(location = "querystring", locationName = "type", type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workdocs$remove_resource_permission_output <- function(...) {
  list()
}

.workdocs$restore_document_versions_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(AuthenticationToken = structure(logical(0), tags = list(location = "header", locationName = "Authentication", type = "string", sensitive = TRUE)), DocumentId = structure(logical(0), tags = list(location = "uri", locationName = "DocumentId", type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workdocs$restore_document_versions_output <- function(...) {
  list()
}

.workdocs$search_resources_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(AuthenticationToken = structure(logical(0), tags = list(location = "header", locationName = "Authentication", type = "string", sensitive = TRUE)), QueryText = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), QueryScopes = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), OrganizationId = structure(logical(0), tags = list(type = "string")), AdditionalResponseFields = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), Filters = structure(list(TextLocales = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), ContentCategories = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), ResourceTypes = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), Labels = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), Principals = structure(list(structure(list(Id = structure(logical(0), tags = list(type = "string")), Roles = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure"))), tags = list(type = "list")), AncestorIds = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), SearchCollectionTypes = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), SizeRange = structure(list(StartValue = structure(logical(0), tags = list(type = "long")), EndValue = structure(logical(0), tags = list(type = "long"))), tags = list(type = "structure")), CreatedRange = structure(list(StartValue = structure(logical(0), tags = list(type = "timestamp")), EndValue = structure(logical(0), tags = list(type = "timestamp"))), tags = list(type = "structure")), ModifiedRange = structure(list(StartValue = structure(logical(0), tags = list(type = "timestamp")), EndValue = structure(logical(0), tags = list(type = "timestamp"))), tags = list(type = "structure"))), tags = list(type = "structure")), OrderBy = structure(list(structure(list(Field = structure(logical(0), tags = list(type = "string")), Order = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "list")), Limit = structure(logical(0), tags = list(type = "integer")), Marker = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workdocs$search_resources_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(Items = structure(list(structure(list(ResourceType = structure(logical(0), tags = list(type = "string")), WebUrl = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), DocumentMetadata = structure(list(Id = structure(logical(0), tags = list(type = "string")), CreatorId = structure(logical(0), tags = list(type = "string")), ParentFolderId = structure(logical(0), tags = list(type = "string")), CreatedTimestamp = structure(logical(0), tags = list(type = "timestamp")), ModifiedTimestamp = structure(logical(0), tags = list(type = "timestamp")), LatestVersionMetadata = structure(list(Id = structure(logical(0), tags = list(type = "string")), Name = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), ContentType = structure(logical(0), tags = list(type = "string")), Size = structure(logical(0), tags = list(type = "long")), Signature = structure(logical(0), tags = list(type = "string")), Status = structure(logical(0), tags = list(type = "string")), CreatedTimestamp = structure(logical(0), tags = list(type = "timestamp")), ModifiedTimestamp = structure(logical(0), tags = list(type = "timestamp")), ContentCreatedTimestamp = structure(logical(0), tags = list(type = "timestamp")), ContentModifiedTimestamp = structure(logical(0), tags = list(type = "timestamp")), CreatorId = structure(logical(0), tags = list(type = "string")), Thumbnail = structure(list(structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "map")), Source = structure(list(structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "map"))), tags = list(type = "structure")), ResourceState = structure(logical(0), tags = list(type = "string")), Labels = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure")), FolderMetadata = structure(list(Id = structure(logical(0), tags = list(type = "string")), Name = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), CreatorId = structure(logical(0), tags = list(type = "string")), ParentFolderId = structure(logical(0), tags = list(type = "string")), CreatedTimestamp = structure(logical(0), tags = list(type = "timestamp")), ModifiedTimestamp = structure(logical(0), tags = list(type = "timestamp")), ResourceState = structure(logical(0), tags = list(type = "string")), Signature = structure(logical(0), tags = list(type = "string")), Labels = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), Size = structure(logical(0), tags = list(type = "long")), LatestVersionSize = structure(logical(0), tags = list(type = "long"))), tags = list(type = "structure")), CommentMetadata = structure(list(CommentId = structure(logical(0), tags = list(type = "string")), Contributor = structure(list(Id = structure(logical(0), tags = list(type = "string")), Username = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), EmailAddress = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), GivenName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), Surname = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), OrganizationId = structure(logical(0), tags = list(type = "string")), RootFolderId = structure(logical(0), tags = list(type = "string")), RecycleBinFolderId = structure(logical(0), tags = list(type = "string")), Status = structure(logical(0), tags = list(type = "string")), Type = structure(logical(0), tags = list(type = "string")), CreatedTimestamp = structure(logical(0), tags = list(type = "timestamp")), ModifiedTimestamp = structure(logical(0), tags = list(type = "timestamp")), TimeZoneId = structure(logical(0), tags = list(type = "string")), Locale = structure(logical(0), tags = list(type = "string")), Storage = structure(list(StorageUtilizedInBytes = structure(logical(0), tags = list(type = "long")), StorageRule = structure(list(StorageAllocatedInBytes = structure(logical(0), tags = list(type = "long")), StorageType = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure"))), tags = list(type = "structure")), CreatedTimestamp = structure(logical(0), tags = list(type = "timestamp")), CommentStatus = structure(logical(0), tags = list(type = "string")), RecipientId = structure(logical(0), tags = list(type = "string")), ContributorId = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), DocumentVersionMetadata = structure(list(Id = structure(logical(0), tags = list(type = "string")), Name = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), ContentType = structure(logical(0), tags = list(type = "string")), Size = structure(logical(0), tags = list(type = "long")), Signature = structure(logical(0), tags = list(type = "string")), Status = structure(logical(0), tags = list(type = "string")), CreatedTimestamp = structure(logical(0), tags = list(type = "timestamp")), ModifiedTimestamp = structure(logical(0), tags = list(type = "timestamp")), ContentCreatedTimestamp = structure(logical(0), tags = list(type = "timestamp")), ContentModifiedTimestamp = structure(logical(0), tags = list(type = "timestamp")), CreatorId = structure(logical(0), tags = list(type = "string")), Thumbnail = structure(list(structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "map")), Source = structure(list(structure(logical(0), tags = list(type = "string", sensitive = TRUE))), tags = list(type = "map"))), tags = list(type = "structure"))), tags = list(type = "structure"))), tags = list(type = "list")), Marker = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workdocs$update_document_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(AuthenticationToken = structure(logical(0), tags = list(location = "header", locationName = "Authentication", type = "string", sensitive = TRUE)), DocumentId = structure(logical(0), tags = list(location = "uri", locationName = "DocumentId", type = "string")), Name = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), ParentFolderId = structure(logical(0), tags = list(type = "string")), ResourceState = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workdocs$update_document_output <- function(...) {
  list()
}

.workdocs$update_document_version_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(AuthenticationToken = structure(logical(0), tags = list(location = "header", locationName = "Authentication", type = "string", sensitive = TRUE)), DocumentId = structure(logical(0), tags = list(location = "uri", locationName = "DocumentId", type = "string")), VersionId = structure(logical(0), tags = list(location = "uri", locationName = "VersionId", type = "string")), VersionStatus = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workdocs$update_document_version_output <- function(...) {
  list()
}

.workdocs$update_folder_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(AuthenticationToken = structure(logical(0), tags = list(location = "header", locationName = "Authentication", type = "string", sensitive = TRUE)), FolderId = structure(logical(0), tags = list(location = "uri", locationName = "FolderId", type = "string")), Name = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), ParentFolderId = structure(logical(0), tags = list(type = "string")), ResourceState = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workdocs$update_folder_output <- function(...) {
  list()
}

.workdocs$update_user_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(AuthenticationToken = structure(logical(0), tags = list(location = "header", locationName = "Authentication", type = "string", sensitive = TRUE)), UserId = structure(logical(0), tags = list(location = "uri", locationName = "UserId", type = "string")), GivenName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), Surname = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), Type = structure(logical(0), tags = list(type = "string")), StorageRule = structure(list(StorageAllocatedInBytes = structure(logical(0), tags = list(type = "long")), StorageType = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), TimeZoneId = structure(logical(0), tags = list(type = "string")), Locale = structure(logical(0), tags = list(type = "string")), GrantPoweruserPrivileges = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workdocs$update_user_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(User = structure(list(Id = structure(logical(0), tags = list(type = "string")), Username = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), EmailAddress = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), GivenName = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), Surname = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), OrganizationId = structure(logical(0), tags = list(type = "string")), RootFolderId = structure(logical(0), tags = list(type = "string")), RecycleBinFolderId = structure(logical(0), tags = list(type = "string")), Status = structure(logical(0), tags = list(type = "string")), Type = structure(logical(0), tags = list(type = "string")), CreatedTimestamp = structure(logical(0), tags = list(type = "timestamp")), ModifiedTimestamp = structure(logical(0), tags = list(type = "timestamp")), TimeZoneId = structure(logical(0), tags = list(type = "string")), Locale = structure(logical(0), tags = list(type = "string")), Storage = structure(list(StorageUtilizedInBytes = structure(logical(0), tags = list(type = "long")), StorageRule = structure(list(StorageAllocatedInBytes = structure(logical(0), tags = list(type = "long")), StorageType = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

# This file is generated by make.paws. Please do not edit here.
#' @importFrom paws.common new_handlers new_service set_config merge_config
NULL

#' Amazon WorkSpaces
#'
#' @description
#' Amazon WorkSpaces Service
#' 
#' Amazon WorkSpaces enables you to provision virtual, cloud-based Microsoft Windows or Amazon Linux desktops for your users, known as *WorkSpaces*. WorkSpaces eliminates the need to procure and deploy hardware or install complex software. You can quickly add or remove users as your needs change. Users can access their virtual desktops from multiple devices or web browsers.
#' 
#' This API Reference provides detailed information about the actions, data types, parameters, and errors of the WorkSpaces service. For more information about the supported Amazon Web Services Regions, endpoints, and service quotas of the Amazon WorkSpaces service, see [WorkSpaces endpoints and quotas](https://docs.aws.amazon.com/general/latest/gr/wsp.html) in the *Amazon Web Services General Reference*.
#' 
#' You can also manage your WorkSpaces resources using the WorkSpaces console, Command Line Interface (CLI), and SDKs. For more information about administering WorkSpaces, see the [Amazon WorkSpaces Administration Guide](https://docs.aws.amazon.com/workspaces/latest/adminguide/). For more information about using the Amazon WorkSpaces client application or web browser to access provisioned WorkSpaces, see the [Amazon WorkSpaces User Guide](https://docs.aws.amazon.com/workspaces/latest/userguide/). For more information about using the CLI to manage your WorkSpaces resources, see the [WorkSpaces section of the CLI Reference](https://docs.aws.amazon.com/cli/latest/reference/workspaces/).
#'
#' @param
#' config
#' Optional configuration of credentials, endpoint, and/or region.
#' \itemize{
#' \item{\strong{credentials}: \itemize{
#' \item{\strong{creds}: \itemize{
#' \item{\strong{access_key_id}: AWS access key ID}
#' \item{\strong{secret_access_key}: AWS secret access key}
#' \item{\strong{session_token}: AWS temporary session token}
#' }}
#' \item{\strong{profile}: The name of a profile to use. If not given, then the default profile is used.}
#' \item{\strong{anonymous}: Set anonymous credentials.}
#' }}
#' \item{\strong{endpoint}: The complete URL to use for the constructed client.}
#' \item{\strong{region}: The AWS Region used in instantiating the client.}
#' \item{\strong{close_connection}: Immediately close all HTTP connections.}
#' \item{\strong{timeout}: The time in seconds till a timeout exception is thrown when attempting to make a connection. The default is 60 seconds.}
#' \item{\strong{s3_force_path_style}: Set this to `true` to force the request to use path-style addressing, i.e. `http://s3.amazonaws.com/BUCKET/KEY`.}
#' \item{\strong{sts_regional_endpoint}: Set sts regional endpoint resolver to regional or legacy \url{https://docs.aws.amazon.com/sdkref/latest/guide/feature-sts-regionalized-endpoints.html}}
#' }
#' @param
#' credentials
#' Optional credentials shorthand for the config parameter
#' \itemize{
#' \item{\strong{creds}: \itemize{
#' \item{\strong{access_key_id}: AWS access key ID}
#' \item{\strong{secret_access_key}: AWS secret access key}
#' \item{\strong{session_token}: AWS temporary session token}
#' }}
#' \item{\strong{profile}: The name of a profile to use. If not given, then the default profile is used.}
#' \item{\strong{anonymous}: Set anonymous credentials.}
#' }
#' @param
#' endpoint
#' Optional shorthand for complete URL to use for the constructed client.
#' @param
#' region
#' Optional shorthand for AWS Region used in instantiating the client.
#'
#' @section Service syntax:
#' ```
#' svc <- workspaces(
#'   config = list(
#'     credentials = list(
#'       creds = list(
#'         access_key_id = "string",
#'         secret_access_key = "string",
#'         session_token = "string"
#'       ),
#'       profile = "string",
#'       anonymous = "logical"
#'     ),
#'     endpoint = "string",
#'     region = "string",
#'     close_connection = "logical",
#'     timeout = "numeric",
#'     s3_force_path_style = "logical",
#'     sts_regional_endpoint = "string"
#'   ),
#'   credentials = list(
#'     creds = list(
#'       access_key_id = "string",
#'       secret_access_key = "string",
#'       session_token = "string"
#'     ),
#'     profile = "string",
#'     anonymous = "logical"
#'   ),
#'   endpoint = "string",
#'   region = "string"
#' )
#' ```
#'
#' @examples
#' \dontrun{
#' svc <- workspaces()
#' svc$accept_account_link_invitation(
#'   Foo = 123
#' )
#' }
#'
#' @section Operations:
#' \tabular{ll}{
#'  \link[=workspaces_accept_account_link_invitation]{accept_account_link_invitation} \tab Accepts the account link invitation\cr
#'  \link[=workspaces_associate_connection_alias]{associate_connection_alias} \tab Associates the specified connection alias with the specified directory to enable cross-Region redirection\cr
#'  \link[=workspaces_associate_ip_groups]{associate_ip_groups} \tab Associates the specified IP access control group with the specified directory\cr
#'  \link[=workspaces_associate_workspace_application]{associate_workspace_application} \tab Associates the specified application to the specified WorkSpace\cr
#'  \link[=workspaces_authorize_ip_rules]{authorize_ip_rules} \tab Adds one or more rules to the specified IP access control group\cr
#'  \link[=workspaces_copy_workspace_image]{copy_workspace_image} \tab Copies the specified image from the specified Region to the current Region\cr
#'  \link[=workspaces_create_account_link_invitation]{create_account_link_invitation} \tab Creates the account link invitation\cr
#'  \link[=workspaces_create_connect_client_add_in]{create_connect_client_add_in} \tab Creates a client-add-in for Amazon Connect within a directory\cr
#'  \link[=workspaces_create_connection_alias]{create_connection_alias} \tab Creates the specified connection alias for use with cross-Region redirection\cr
#'  \link[=workspaces_create_ip_group]{create_ip_group} \tab Creates an IP access control group\cr
#'  \link[=workspaces_create_standby_workspaces]{create_standby_workspaces} \tab Creates a standby WorkSpace in a secondary Region\cr
#'  \link[=workspaces_create_tags]{create_tags} \tab Creates the specified tags for the specified WorkSpaces resource\cr
#'  \link[=workspaces_create_updated_workspace_image]{create_updated_workspace_image} \tab Creates a new updated WorkSpace image based on the specified source image\cr
#'  \link[=workspaces_create_workspace_bundle]{create_workspace_bundle} \tab Creates the specified WorkSpace bundle\cr
#'  \link[=workspaces_create_workspace_image]{create_workspace_image} \tab Creates a new WorkSpace image from an existing WorkSpace\cr
#'  \link[=workspaces_create_workspaces]{create_workspaces} \tab Creates one or more WorkSpaces\cr
#'  \link[=workspaces_create_workspaces_pool]{create_workspaces_pool} \tab Creates a pool of WorkSpaces\cr
#'  \link[=workspaces_delete_account_link_invitation]{delete_account_link_invitation} \tab Deletes the account link invitation\cr
#'  \link[=workspaces_delete_client_branding]{delete_client_branding} \tab Deletes customized client branding\cr
#'  \link[=workspaces_delete_connect_client_add_in]{delete_connect_client_add_in} \tab Deletes a client-add-in for Amazon Connect that is configured within a directory\cr
#'  \link[=workspaces_delete_connection_alias]{delete_connection_alias} \tab Deletes the specified connection alias\cr
#'  \link[=workspaces_delete_ip_group]{delete_ip_group} \tab Deletes the specified IP access control group\cr
#'  \link[=workspaces_delete_tags]{delete_tags} \tab Deletes the specified tags from the specified WorkSpaces resource\cr
#'  \link[=workspaces_delete_workspace_bundle]{delete_workspace_bundle} \tab Deletes the specified WorkSpace bundle\cr
#'  \link[=workspaces_delete_workspace_image]{delete_workspace_image} \tab Deletes the specified image from your account\cr
#'  \link[=workspaces_deploy_workspace_applications]{deploy_workspace_applications} \tab Deploys associated applications to the specified WorkSpace\cr
#'  \link[=workspaces_deregister_workspace_directory]{deregister_workspace_directory} \tab Deregisters the specified directory\cr
#'  \link[=workspaces_describe_account]{describe_account} \tab Retrieves a list that describes the configuration of Bring Your Own License (BYOL) for the specified account\cr
#'  \link[=workspaces_describe_account_modifications]{describe_account_modifications} \tab Retrieves a list that describes modifications to the configuration of Bring Your Own License (BYOL) for the specified account\cr
#'  \link[=workspaces_describe_application_associations]{describe_application_associations} \tab Describes the associations between the application and the specified associated resources\cr
#'  \link[=workspaces_describe_applications]{describe_applications} \tab Describes the specified applications by filtering based on their compute types, license availability, operating systems, and owners\cr
#'  \link[=workspaces_describe_bundle_associations]{describe_bundle_associations} \tab Describes the associations between the applications and the specified bundle\cr
#'  \link[=workspaces_describe_client_branding]{describe_client_branding} \tab Describes the specified client branding\cr
#'  \link[=workspaces_describe_client_properties]{describe_client_properties} \tab Retrieves a list that describes one or more specified Amazon WorkSpaces clients\cr
#'  \link[=workspaces_describe_connect_client_add_ins]{describe_connect_client_add_ins} \tab Retrieves a list of Amazon Connect client add-ins that have been created\cr
#'  \link[=workspaces_describe_connection_aliases]{describe_connection_aliases} \tab Retrieves a list that describes the connection aliases used for cross-Region redirection\cr
#'  \link[=workspaces_describe_connection_alias_permissions]{describe_connection_alias_permissions} \tab Describes the permissions that the owner of a connection alias has granted to another Amazon Web Services account for the specified connection alias\cr
#'  \link[=workspaces_describe_custom_workspace_image_import]{describe_custom_workspace_image_import} \tab Retrieves information about a WorkSpace BYOL image being imported via ImportCustomWorkspaceImage\cr
#'  \link[=workspaces_describe_image_associations]{describe_image_associations} \tab Describes the associations between the applications and the specified image\cr
#'  \link[=workspaces_describe_ip_groups]{describe_ip_groups} \tab Describes one or more of your IP access control groups\cr
#'  \link[=workspaces_describe_tags]{describe_tags} \tab Describes the specified tags for the specified WorkSpaces resource\cr
#'  \link[=workspaces_describe_workspace_associations]{describe_workspace_associations} \tab Describes the associations betweens applications and the specified WorkSpace\cr
#'  \link[=workspaces_describe_workspace_bundles]{describe_workspace_bundles} \tab Retrieves a list that describes the available WorkSpace bundles\cr
#'  \link[=workspaces_describe_workspace_directories]{describe_workspace_directories} \tab Describes the available directories that are registered with Amazon WorkSpaces\cr
#'  \link[=workspaces_describe_workspace_image_permissions]{describe_workspace_image_permissions} \tab Describes the permissions that the owner of an image has granted to other Amazon Web Services accounts for an image\cr
#'  \link[=workspaces_describe_workspace_images]{describe_workspace_images} \tab Retrieves a list that describes one or more specified images, if the image identifiers are provided\cr
#'  \link[=workspaces_describe_workspaces]{describe_workspaces} \tab Describes the specified WorkSpaces\cr
#'  \link[=workspaces_describe_workspaces_connection_status]{describe_workspaces_connection_status} \tab Describes the connection status of the specified WorkSpaces\cr
#'  \link[=workspaces_describe_workspace_snapshots]{describe_workspace_snapshots} \tab Describes the snapshots for the specified WorkSpace\cr
#'  \link[=workspaces_describe_workspaces_pools]{describe_workspaces_pools} \tab Describes the specified WorkSpaces Pools\cr
#'  \link[=workspaces_describe_workspaces_pool_sessions]{describe_workspaces_pool_sessions} \tab Retrieves a list that describes the streaming sessions for a specified pool\cr
#'  \link[=workspaces_disassociate_connection_alias]{disassociate_connection_alias} \tab Disassociates a connection alias from a directory\cr
#'  \link[=workspaces_disassociate_ip_groups]{disassociate_ip_groups} \tab Disassociates the specified IP access control group from the specified directory\cr
#'  \link[=workspaces_disassociate_workspace_application]{disassociate_workspace_application} \tab Disassociates the specified application from a WorkSpace\cr
#'  \link[=workspaces_get_account_link]{get_account_link} \tab Retrieves account link information\cr
#'  \link[=workspaces_import_client_branding]{import_client_branding} \tab Imports client branding\cr
#'  \link[=workspaces_import_custom_workspace_image]{import_custom_workspace_image} \tab Imports the specified Windows 10 or 11 Bring Your Own License (BYOL) image into Amazon WorkSpaces using EC2 Image Builder\cr
#'  \link[=workspaces_import_workspace_image]{import_workspace_image} \tab Imports the specified Windows 10 or 11 Bring Your Own License (BYOL) image into Amazon WorkSpaces\cr
#'  \link[=workspaces_list_account_links]{list_account_links} \tab Lists all account links\cr
#'  \link[=workspaces_list_available_management_cidr_ranges]{list_available_management_cidr_ranges} \tab Retrieves a list of IP address ranges, specified as IPv4 CIDR blocks, that you can use for the network management interface when you enable Bring Your Own License (BYOL)\cr
#'  \link[=workspaces_migrate_workspace]{migrate_workspace} \tab Migrates a WorkSpace from one operating system or bundle type to another, while retaining the data on the user volume\cr
#'  \link[=workspaces_modify_account]{modify_account} \tab Modifies the configuration of Bring Your Own License (BYOL) for the specified account\cr
#'  \link[=workspaces_modify_certificate_based_auth_properties]{modify_certificate_based_auth_properties} \tab Modifies the properties of the certificate-based authentication you want to use with your WorkSpaces\cr
#'  \link[=workspaces_modify_client_properties]{modify_client_properties} \tab Modifies the properties of the specified Amazon WorkSpaces clients\cr
#'  \link[=workspaces_modify_endpoint_encryption_mode]{modify_endpoint_encryption_mode} \tab Modifies the endpoint encryption mode that allows you to configure the specified directory between Standard TLS and FIPS 140-2 validated mode\cr
#'  \link[=workspaces_modify_saml_properties]{modify_saml_properties} \tab Modifies multiple properties related to SAML 2\cr
#'  \link[=workspaces_modify_selfservice_permissions]{modify_selfservice_permissions} \tab Modifies the self-service WorkSpace management capabilities for your users\cr
#'  \link[=workspaces_modify_streaming_properties]{modify_streaming_properties} \tab Modifies the specified streaming properties\cr
#'  \link[=workspaces_modify_workspace_access_properties]{modify_workspace_access_properties} \tab Specifies which devices and operating systems users can use to access their WorkSpaces\cr
#'  \link[=workspaces_modify_workspace_creation_properties]{modify_workspace_creation_properties} \tab Modify the default properties used to create WorkSpaces\cr
#'  \link[=workspaces_modify_workspace_properties]{modify_workspace_properties} \tab Modifies the specified WorkSpace properties\cr
#'  \link[=workspaces_modify_workspace_state]{modify_workspace_state} \tab Sets the state of the specified WorkSpace\cr
#'  \link[=workspaces_reboot_workspaces]{reboot_workspaces} \tab Reboots the specified WorkSpaces\cr
#'  \link[=workspaces_rebuild_workspaces]{rebuild_workspaces} \tab Rebuilds the specified WorkSpace\cr
#'  \link[=workspaces_register_workspace_directory]{register_workspace_directory} \tab Registers the specified directory\cr
#'  \link[=workspaces_reject_account_link_invitation]{reject_account_link_invitation} \tab Rejects the account link invitation\cr
#'  \link[=workspaces_restore_workspace]{restore_workspace} \tab Restores the specified WorkSpace to its last known healthy state\cr
#'  \link[=workspaces_revoke_ip_rules]{revoke_ip_rules} \tab Removes one or more rules from the specified IP access control group\cr
#'  \link[=workspaces_start_workspaces]{start_workspaces} \tab Starts the specified WorkSpaces\cr
#'  \link[=workspaces_start_workspaces_pool]{start_workspaces_pool} \tab Starts the specified pool\cr
#'  \link[=workspaces_stop_workspaces]{stop_workspaces} \tab Stops the specified WorkSpaces\cr
#'  \link[=workspaces_stop_workspaces_pool]{stop_workspaces_pool} \tab Stops the specified pool\cr
#'  \link[=workspaces_terminate_workspaces]{terminate_workspaces} \tab Terminates the specified WorkSpaces\cr
#'  \link[=workspaces_terminate_workspaces_pool]{terminate_workspaces_pool} \tab Terminates the specified pool\cr
#'  \link[=workspaces_terminate_workspaces_pool_session]{terminate_workspaces_pool_session} \tab Terminates the pool session\cr
#'  \link[=workspaces_update_connect_client_add_in]{update_connect_client_add_in} \tab Updates a Amazon Connect client add-in\cr
#'  \link[=workspaces_update_connection_alias_permission]{update_connection_alias_permission} \tab Shares or unshares a connection alias with one account by specifying whether that account has permission to associate the connection alias with a directory\cr
#'  \link[=workspaces_update_rules_of_ip_group]{update_rules_of_ip_group} \tab Replaces the current rules of the specified IP access control group with the specified rules\cr
#'  \link[=workspaces_update_workspace_bundle]{update_workspace_bundle} \tab Updates a WorkSpace bundle with a new image\cr
#'  \link[=workspaces_update_workspace_image_permission]{update_workspace_image_permission} \tab Shares or unshares an image with one account in the same Amazon Web Services Region by specifying whether that account has permission to copy the image\cr
#'  \link[=workspaces_update_workspaces_pool]{update_workspaces_pool} \tab Updates the specified pool
#' }
#'
#' @return
#' A client for the service. You can call the service's operations using
#' syntax like `svc$operation(...)`, where `svc` is the name you've assigned
#' to the client. The available operations are listed in the
#' Operations section.
#'
#' @rdname workspaces
#' @export
workspaces <- function(config = list(), credentials = list(), endpoint = NULL, region = NULL) {
  config <- merge_config(
    config,
    list(
      credentials = credentials,
      endpoint = endpoint,
      region = region
    )
  )
  svc <- .workspaces$operations
  svc <- set_config(svc, config)
  return(svc)
}

# Private API objects: metadata, handlers, interfaces, etc.
.workspaces <- list()

.workspaces$operations <- list()

.workspaces$metadata <- list(
  service_name = "workspaces",
  endpoints = list("^(us|eu|ap|sa|ca|me|af|il|mx)\\-\\w+\\-\\d+$" = list(endpoint = "workspaces.{region}.amazonaws.com", global = FALSE), "^cn\\-\\w+\\-\\d+$" = list(endpoint = "workspaces.{region}.amazonaws.com.cn", global = FALSE), "^us\\-gov\\-\\w+\\-\\d+$" = list(endpoint = "workspaces.{region}.amazonaws.com", global = FALSE), "^us\\-iso\\-\\w+\\-\\d+$" = list(endpoint = "workspaces.{region}.c2s.ic.gov", global = FALSE), "^us\\-isob\\-\\w+\\-\\d+$" = list(endpoint = "workspaces.{region}.sc2s.sgov.gov", global = FALSE), "^eu\\-isoe\\-\\w+\\-\\d+$" = list(endpoint = "workspaces.{region}.cloud.adc-e.uk", global = FALSE), "^us\\-isof\\-\\w+\\-\\d+$" = list(endpoint = "workspaces.{region}.csp.hci.ic.gov", global = FALSE), "^eusc\\-(de)\\-\\w+\\-\\d+$" = list(endpoint = "workspaces.{region}.amazonaws.eu", global = FALSE)),
  service_id = "WorkSpaces",
  api_version = "2015-04-08",
  signing_name = "workspaces",
  json_version = "1.1",
  target_prefix = "WorkspacesService"
)

.workspaces$service <- function(config = list(), op = NULL) {
  handlers <- new_handlers("jsonrpc", "v4")
  new_service(.workspaces$metadata, handlers, config, op)
}

# This file is generated by make.paws. Please do not edit here.
#' @importFrom paws.common new_handlers new_service set_config merge_config
NULL

#' Amazon AppStream
#'
#' @description
#' Amazon WorkSpaces Applications
#' 
#' This is the *Amazon WorkSpaces Applications API Reference*. This documentation provides descriptions and syntax for each of the actions and data types in WorkSpaces Applications. WorkSpaces Applications is a fully managed, secure application streaming service that lets you stream desktop applications to users without rewriting applications. WorkSpaces Applications manages the AWS resources that are required to host and run your applications, scales automatically, and provides access to your users on demand.
#' 
#' You can call the WorkSpaces Applications API operations by using an interface VPC endpoint (interface endpoint). For more information, see [Access WorkSpaces Applications API Operations and CLI Commands Through an Interface VPC Endpoint](https://docs.aws.amazon.com/appstream2/latest/developerguide/access-api-cli-through-interface-vpc-endpoint.html) in the *Amazon WorkSpaces Applications Administration Guide*.
#' 
#' To learn more about WorkSpaces Applications, see the following resources:
#' 
#' -   [Amazon WorkSpaces Applications product page](https://aws.amazon.com/workspaces/applications/)
#' 
#' -   [Amazon WorkSpaces Applications documentation](https://docs.aws.amazon.com/appstream2/)
#'
#' @param
#' config
#' Optional configuration of credentials, endpoint, and/or region.
#' \itemize{
#' \item{\strong{credentials}: \itemize{
#' \item{\strong{creds}: \itemize{
#' \item{\strong{access_key_id}: AWS access key ID}
#' \item{\strong{secret_access_key}: AWS secret access key}
#' \item{\strong{session_token}: AWS temporary session token}
#' }}
#' \item{\strong{profile}: The name of a profile to use. If not given, then the default profile is used.}
#' \item{\strong{anonymous}: Set anonymous credentials.}
#' }}
#' \item{\strong{endpoint}: The complete URL to use for the constructed client.}
#' \item{\strong{region}: The AWS Region used in instantiating the client.}
#' \item{\strong{close_connection}: Immediately close all HTTP connections.}
#' \item{\strong{timeout}: The time in seconds till a timeout exception is thrown when attempting to make a connection. The default is 60 seconds.}
#' \item{\strong{s3_force_path_style}: Set this to `true` to force the request to use path-style addressing, i.e. `http://s3.amazonaws.com/BUCKET/KEY`.}
#' \item{\strong{sts_regional_endpoint}: Set sts regional endpoint resolver to regional or legacy \url{https://docs.aws.amazon.com/sdkref/latest/guide/feature-sts-regionalized-endpoints.html}}
#' }
#' @param
#' credentials
#' Optional credentials shorthand for the config parameter
#' \itemize{
#' \item{\strong{creds}: \itemize{
#' \item{\strong{access_key_id}: AWS access key ID}
#' \item{\strong{secret_access_key}: AWS secret access key}
#' \item{\strong{session_token}: AWS temporary session token}
#' }}
#' \item{\strong{profile}: The name of a profile to use. If not given, then the default profile is used.}
#' \item{\strong{anonymous}: Set anonymous credentials.}
#' }
#' @param
#' endpoint
#' Optional shorthand for complete URL to use for the constructed client.
#' @param
#' region
#' Optional shorthand for AWS Region used in instantiating the client.
#'
#' @section Service syntax:
#' ```
#' svc <- appstream(
#'   config = list(
#'     credentials = list(
#'       creds = list(
#'         access_key_id = "string",
#'         secret_access_key = "string",
#'         session_token = "string"
#'       ),
#'       profile = "string",
#'       anonymous = "logical"
#'     ),
#'     endpoint = "string",
#'     region = "string",
#'     close_connection = "logical",
#'     timeout = "numeric",
#'     s3_force_path_style = "logical",
#'     sts_regional_endpoint = "string"
#'   ),
#'   credentials = list(
#'     creds = list(
#'       access_key_id = "string",
#'       secret_access_key = "string",
#'       session_token = "string"
#'     ),
#'     profile = "string",
#'     anonymous = "logical"
#'   ),
#'   endpoint = "string",
#'   region = "string"
#' )
#' ```
#'
#' @examples
#' \dontrun{
#' svc <- appstream()
#' svc$associate_app_block_builder_app_block(
#'   Foo = 123
#' )
#' }
#'
#' @section Operations:
#' \tabular{ll}{
#'  \link[=appstream_associate_app_block_builder_app_block]{associate_app_block_builder_app_block} \tab Associates the specified app block builder with the specified app block\cr
#'  \link[=appstream_associate_application_fleet]{associate_application_fleet} \tab Associates the specified application with the specified fleet\cr
#'  \link[=appstream_associate_application_to_entitlement]{associate_application_to_entitlement} \tab Associates an application to entitle\cr
#'  \link[=appstream_associate_fleet]{associate_fleet} \tab Associates the specified fleet with the specified stack\cr
#'  \link[=appstream_associate_software_to_image_builder]{associate_software_to_image_builder} \tab Associates license included application(s) with an existing image builder instance\cr
#'  \link[=appstream_batch_associate_user_stack]{batch_associate_user_stack} \tab Associates the specified users with the specified stacks\cr
#'  \link[=appstream_batch_disassociate_user_stack]{batch_disassociate_user_stack} \tab Disassociates the specified users from the specified stacks\cr
#'  \link[=appstream_copy_image]{copy_image} \tab Copies the image within the same region or to a new region within the same AWS account\cr
#'  \link[=appstream_create_app_block]{create_app_block} \tab Creates an app block\cr
#'  \link[=appstream_create_app_block_builder]{create_app_block_builder} \tab Creates an app block builder\cr
#'  \link[=appstream_create_app_block_builder_streaming_url]{create_app_block_builder_streaming_url} \tab Creates a URL to start a create app block builder streaming session\cr
#'  \link[=appstream_create_application]{create_application} \tab Creates an application\cr
#'  \link[=appstream_create_directory_config]{create_directory_config} \tab Creates a Directory Config object in WorkSpaces Applications\cr
#'  \link[=appstream_create_entitlement]{create_entitlement} \tab Creates a new entitlement\cr
#'  \link[=appstream_create_export_image_task]{create_export_image_task} \tab Creates a task to export a WorkSpaces Applications image to an EC2 AMI\cr
#'  \link[=appstream_create_fleet]{create_fleet} \tab Creates a fleet\cr
#'  \link[=appstream_create_image_builder]{create_image_builder} \tab Creates an image builder\cr
#'  \link[=appstream_create_image_builder_streaming_url]{create_image_builder_streaming_url} \tab Creates a URL to start an image builder streaming session\cr
#'  \link[=appstream_create_imported_image]{create_imported_image} \tab Creates a custom WorkSpaces Applications image by importing an EC2 AMI\cr
#'  \link[=appstream_create_stack]{create_stack} \tab Creates a stack to start streaming applications to users\cr
#'  \link[=appstream_create_streaming_url]{create_streaming_url} \tab Creates a temporary URL to start an WorkSpaces Applications streaming session for the specified user\cr
#'  \link[=appstream_create_theme_for_stack]{create_theme_for_stack} \tab Creates custom branding that customizes the appearance of the streaming application catalog page\cr
#'  \link[=appstream_create_updated_image]{create_updated_image} \tab Creates a new image with the latest Windows operating system updates, driver updates, and WorkSpaces Applications agent software\cr
#'  \link[=appstream_create_usage_report_subscription]{create_usage_report_subscription} \tab Creates a usage report subscription\cr
#'  \link[=appstream_create_user]{create_user} \tab Creates a new user in the user pool\cr
#'  \link[=appstream_delete_app_block]{delete_app_block} \tab Deletes an app block\cr
#'  \link[=appstream_delete_app_block_builder]{delete_app_block_builder} \tab Deletes an app block builder\cr
#'  \link[=appstream_delete_application]{delete_application} \tab Deletes an application\cr
#'  \link[=appstream_delete_directory_config]{delete_directory_config} \tab Deletes the specified Directory Config object from WorkSpaces Applications\cr
#'  \link[=appstream_delete_entitlement]{delete_entitlement} \tab Deletes the specified entitlement\cr
#'  \link[=appstream_delete_fleet]{delete_fleet} \tab Deletes the specified fleet\cr
#'  \link[=appstream_delete_image]{delete_image} \tab Deletes the specified image\cr
#'  \link[=appstream_delete_image_builder]{delete_image_builder} \tab Deletes the specified image builder and releases the capacity\cr
#'  \link[=appstream_delete_image_permissions]{delete_image_permissions} \tab Deletes permissions for the specified private image\cr
#'  \link[=appstream_delete_stack]{delete_stack} \tab Deletes the specified stack\cr
#'  \link[=appstream_delete_theme_for_stack]{delete_theme_for_stack} \tab Deletes custom branding that customizes the appearance of the streaming application catalog page\cr
#'  \link[=appstream_delete_usage_report_subscription]{delete_usage_report_subscription} \tab Disables usage report generation\cr
#'  \link[=appstream_delete_user]{delete_user} \tab Deletes a user from the user pool\cr
#'  \link[=appstream_describe_app_block_builder_app_block_associations]{describe_app_block_builder_app_block_associations} \tab Retrieves a list that describes one or more app block builder associations\cr
#'  \link[=appstream_describe_app_block_builders]{describe_app_block_builders} \tab Retrieves a list that describes one or more app block builders\cr
#'  \link[=appstream_describe_app_blocks]{describe_app_blocks} \tab Retrieves a list that describes one or more app blocks\cr
#'  \link[=appstream_describe_application_fleet_associations]{describe_application_fleet_associations} \tab Retrieves a list that describes one or more application fleet associations\cr
#'  \link[=appstream_describe_applications]{describe_applications} \tab Retrieves a list that describes one or more applications\cr
#'  \link[=appstream_describe_app_license_usage]{describe_app_license_usage} \tab Retrieves license included application usage information\cr
#'  \link[=appstream_describe_directory_configs]{describe_directory_configs} \tab Retrieves a list that describes one or more specified Directory Config objects for WorkSpaces Applications, if the names for these objects are provided\cr
#'  \link[=appstream_describe_entitlements]{describe_entitlements} \tab Retrieves a list that describes one of more entitlements\cr
#'  \link[=appstream_describe_fleets]{describe_fleets} \tab Retrieves a list that describes one or more specified fleets, if the fleet names are provided\cr
#'  \link[=appstream_describe_image_builders]{describe_image_builders} \tab Retrieves a list that describes one or more specified image builders, if the image builder names are provided\cr
#'  \link[=appstream_describe_image_permissions]{describe_image_permissions} \tab Retrieves a list that describes the permissions for shared AWS account IDs on a private image that you own\cr
#'  \link[=appstream_describe_images]{describe_images} \tab Retrieves a list that describes one or more specified images, if the image names or image ARNs are provided\cr
#'  \link[=appstream_describe_sessions]{describe_sessions} \tab Retrieves a list that describes the streaming sessions for a specified stack and fleet\cr
#'  \link[=appstream_describe_software_associations]{describe_software_associations} \tab Retrieves license included application associations for a specified resource\cr
#'  \link[=appstream_describe_stacks]{describe_stacks} \tab Retrieves a list that describes one or more specified stacks, if the stack names are provided\cr
#'  \link[=appstream_describe_theme_for_stack]{describe_theme_for_stack} \tab Retrieves a list that describes the theme for a specified stack\cr
#'  \link[=appstream_describe_usage_report_subscriptions]{describe_usage_report_subscriptions} \tab Retrieves a list that describes one or more usage report subscriptions\cr
#'  \link[=appstream_describe_users]{describe_users} \tab Retrieves a list that describes one or more specified users in the user pool\cr
#'  \link[=appstream_describe_user_stack_associations]{describe_user_stack_associations} \tab Retrieves a list that describes the UserStackAssociation objects\cr
#'  \link[=appstream_disable_user]{disable_user} \tab Disables the specified user in the user pool\cr
#'  \link[=appstream_disassociate_app_block_builder_app_block]{disassociate_app_block_builder_app_block} \tab Disassociates a specified app block builder from a specified app block\cr
#'  \link[=appstream_disassociate_application_fleet]{disassociate_application_fleet} \tab Disassociates the specified application from the fleet\cr
#'  \link[=appstream_disassociate_application_from_entitlement]{disassociate_application_from_entitlement} \tab Deletes the specified application from the specified entitlement\cr
#'  \link[=appstream_disassociate_fleet]{disassociate_fleet} \tab Disassociates the specified fleet from the specified stack\cr
#'  \link[=appstream_disassociate_software_from_image_builder]{disassociate_software_from_image_builder} \tab Removes license included application(s) association(s) from an image builder instance\cr
#'  \link[=appstream_drain_session_instance]{drain_session_instance} \tab Drains the instance hosting the specified streaming session\cr
#'  \link[=appstream_enable_user]{enable_user} \tab Enables a user in the user pool\cr
#'  \link[=appstream_expire_session]{expire_session} \tab Immediately stops the specified streaming session\cr
#'  \link[=appstream_get_export_image_task]{get_export_image_task} \tab Retrieves information about an export image task, including its current state, progress, and any error details\cr
#'  \link[=appstream_list_associated_fleets]{list_associated_fleets} \tab Retrieves the name of the fleet that is associated with the specified stack\cr
#'  \link[=appstream_list_associated_stacks]{list_associated_stacks} \tab Retrieves the name of the stack with which the specified fleet is associated\cr
#'  \link[=appstream_list_entitled_applications]{list_entitled_applications} \tab Retrieves a list of entitled applications\cr
#'  \link[=appstream_list_export_image_tasks]{list_export_image_tasks} \tab Lists export image tasks, with optional filtering and pagination\cr
#'  \link[=appstream_list_tags_for_resource]{list_tags_for_resource} \tab Retrieves a list of all tags for the specified WorkSpaces Applications resource\cr
#'  \link[=appstream_start_app_block_builder]{start_app_block_builder} \tab Starts an app block builder\cr
#'  \link[=appstream_start_fleet]{start_fleet} \tab Starts the specified fleet\cr
#'  \link[=appstream_start_image_builder]{start_image_builder} \tab Starts the specified image builder\cr
#'  \link[=appstream_start_software_deployment_to_image_builder]{start_software_deployment_to_image_builder} \tab Initiates license included applications deployment to an image builder instance\cr
#'  \link[=appstream_stop_app_block_builder]{stop_app_block_builder} \tab Stops an app block builder\cr
#'  \link[=appstream_stop_fleet]{stop_fleet} \tab Stops the specified fleet\cr
#'  \link[=appstream_stop_image_builder]{stop_image_builder} \tab Stops the specified image builder\cr
#'  \link[=appstream_tag_resource]{tag_resource} \tab Adds or overwrites one or more tags for the specified WorkSpaces Applications resource\cr
#'  \link[=appstream_untag_resource]{untag_resource} \tab Disassociates one or more specified tags from the specified WorkSpaces Applications resource\cr
#'  \link[=appstream_update_app_block_builder]{update_app_block_builder} \tab Updates an app block builder\cr
#'  \link[=appstream_update_application]{update_application} \tab Updates the specified application\cr
#'  \link[=appstream_update_directory_config]{update_directory_config} \tab Updates the specified Directory Config object in WorkSpaces Applications\cr
#'  \link[=appstream_update_entitlement]{update_entitlement} \tab Updates the specified entitlement\cr
#'  \link[=appstream_update_fleet]{update_fleet} \tab Updates the specified fleet\cr
#'  \link[=appstream_update_image_permissions]{update_image_permissions} \tab Adds or updates permissions for the specified private image\cr
#'  \link[=appstream_update_stack]{update_stack} \tab Updates the specified fields for the specified stack\cr
#'  \link[=appstream_update_theme_for_stack]{update_theme_for_stack} \tab Updates custom branding that customizes the appearance of the streaming application catalog page
#' }
#'
#' @return
#' A client for the service. You can call the service's operations using
#' syntax like `svc$operation(...)`, where `svc` is the name you've assigned
#' to the client. The available operations are listed in the
#' Operations section.
#'
#' @rdname appstream
#' @export
appstream <- function(config = list(), credentials = list(), endpoint = NULL, region = NULL) {
  config <- merge_config(
    config,
    list(
      credentials = credentials,
      endpoint = endpoint,
      region = region
    )
  )
  svc <- .appstream$operations
  svc <- set_config(svc, config)
  return(svc)
}

# Private API objects: metadata, handlers, interfaces, etc.
.appstream <- list()

.appstream$operations <- list()

.appstream$metadata <- list(
  service_name = "appstream2",
  endpoints = list("^(us|eu|ap|sa|ca|me|af|il|mx)\\-\\w+\\-\\d+$" = list(endpoint = "appstream2.{region}.amazonaws.com", global = FALSE), "^cn\\-\\w+\\-\\d+$" = list(endpoint = "appstream2.{region}.amazonaws.com.cn", global = FALSE), "^us\\-gov\\-\\w+\\-\\d+$" = list(endpoint = "appstream2.{region}.amazonaws.com", global = FALSE), "^us\\-iso\\-\\w+\\-\\d+$" = list(endpoint = "appstream2.{region}.c2s.ic.gov", global = FALSE), "^us\\-isob\\-\\w+\\-\\d+$" = list(endpoint = "appstream2.{region}.sc2s.sgov.gov", global = FALSE), "^eu\\-isoe\\-\\w+\\-\\d+$" = list(endpoint = "appstream2.{region}.cloud.adc-e.uk", global = FALSE), "^us\\-isof\\-\\w+\\-\\d+$" = list(endpoint = "appstream2.{region}.csp.hci.ic.gov", global = FALSE), "^eusc\\-(de)\\-\\w+\\-\\d+$" = list(endpoint = "appstream2.{region}.amazonaws.eu", global = FALSE)),
  service_id = "AppStream",
  api_version = "2016-12-01",
  signing_name = "appstream",
  json_version = "1.1",
  target_prefix = "PhotonAdminProxyService"
)

.appstream$service <- function(config = list(), op = NULL) {
  handlers <- new_handlers("jsonrpc", "v4")
  new_service(.appstream$metadata, handlers, config, op)
}

svc <- paws::appstream()

test_that("describe_app_block_builder_app_block_associations", {
  expect_error(svc$describe_app_block_builder_app_block_associations(), NA)
})

test_that("describe_app_block_builder_app_block_associations", {
  expect_error(svc$describe_app_block_builder_app_block_associations(MaxResults = 20), NA)
})

test_that("describe_app_block_builders", {
  expect_error(svc$describe_app_block_builders(), NA)
})

test_that("describe_app_block_builders", {
  expect_error(svc$describe_app_block_builders(MaxResults = 20), NA)
})

test_that("describe_app_blocks", {
  expect_error(svc$describe_app_blocks(), NA)
})

test_that("describe_app_blocks", {
  expect_error(svc$describe_app_blocks(MaxResults = 20), NA)
})

test_that("describe_application_fleet_associations", {
  expect_error(svc$describe_application_fleet_associations(), NA)
})

test_that("describe_application_fleet_associations", {
  expect_error(svc$describe_application_fleet_associations(MaxResults = 20), NA)
})

test_that("describe_applications", {
  expect_error(svc$describe_applications(), NA)
})

test_that("describe_applications", {
  expect_error(svc$describe_applications(MaxResults = 20), NA)
})

test_that("describe_directory_configs", {
  expect_error(svc$describe_directory_configs(), NA)
})

test_that("describe_directory_configs", {
  expect_error(svc$describe_directory_configs(MaxResults = 20), NA)
})

test_that("describe_fleets", {
  expect_error(svc$describe_fleets(), NA)
})

test_that("describe_image_builders", {
  expect_error(svc$describe_image_builders(), NA)
})

test_that("describe_image_builders", {
  expect_error(svc$describe_image_builders(MaxResults = 20), NA)
})

test_that("describe_images", {
  expect_error(svc$describe_images(), NA)
})

test_that("describe_images", {
  expect_error(svc$describe_images(MaxResults = 20), NA)
})

test_that("describe_stacks", {
  expect_error(svc$describe_stacks(), NA)
})

test_that("describe_usage_report_subscriptions", {
  expect_error(svc$describe_usage_report_subscriptions(), NA)
})

test_that("describe_usage_report_subscriptions", {
  expect_error(svc$describe_usage_report_subscriptions(MaxResults = 20), NA)
})

test_that("list_export_image_tasks", {
  expect_error(svc$list_export_image_tasks(), NA)
})

test_that("list_export_image_tasks", {
  expect_error(svc$list_export_image_tasks(MaxResults = 20), NA)
})

# This file is generated by make.paws. Please do not edit here.
#' @importFrom paws.common populate
#' @include ivschat_service.R
NULL

.ivschat$create_chat_token_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(roomIdentifier = structure(logical(0), tags = list(type = "string")), userId = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), capabilities = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list")), sessionDurationInMinutes = structure(logical(0), tags = list(type = "integer", box = TRUE)), attributes = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map", sensitive = TRUE))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.ivschat$create_chat_token_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(token = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), tokenExpirationTime = structure(logical(0), tags = list(type = "timestamp", timestampFormat = "iso8601")), sessionExpirationTime = structure(logical(0), tags = list(type = "timestamp", timestampFormat = "iso8601"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.ivschat$create_logging_configuration_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(name = structure(logical(0), tags = list(type = "string")), destinationConfiguration = structure(list(s3 = structure(list(bucketName = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), cloudWatchLogs = structure(list(logGroupName = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), firehose = structure(list(deliveryStreamName = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure", union = TRUE)), tags = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.ivschat$create_logging_configuration_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(arn = structure(logical(0), tags = list(type = "string")), id = structure(logical(0), tags = list(type = "string")), createTime = structure(logical(0), tags = list(type = "timestamp", timestampFormat = "iso8601")), updateTime = structure(logical(0), tags = list(type = "timestamp", timestampFormat = "iso8601")), name = structure(logical(0), tags = list(type = "string")), destinationConfiguration = structure(list(s3 = structure(list(bucketName = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), cloudWatchLogs = structure(list(logGroupName = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), firehose = structure(list(deliveryStreamName = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure", union = TRUE)), state = structure(logical(0), tags = list(type = "string")), tags = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.ivschat$create_room_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(name = structure(logical(0), tags = list(type = "string")), maximumMessageRatePerSecond = structure(logical(0), tags = list(type = "integer", box = TRUE)), maximumMessageLength = structure(logical(0), tags = list(type = "integer", box = TRUE)), messageReviewHandler = structure(list(uri = structure(logical(0), tags = list(type = "string")), fallbackResult = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), tags = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map")), loggingConfigurationIdentifiers = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.ivschat$create_room_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(arn = structure(logical(0), tags = list(type = "string")), id = structure(logical(0), tags = list(type = "string")), name = structure(logical(0), tags = list(type = "string")), createTime = structure(logical(0), tags = list(type = "timestamp", timestampFormat = "iso8601")), updateTime = structure(logical(0), tags = list(type = "timestamp", timestampFormat = "iso8601")), maximumMessageRatePerSecond = structure(logical(0), tags = list(type = "integer", box = TRUE)), maximumMessageLength = structure(logical(0), tags = list(type = "integer", box = TRUE)), messageReviewHandler = structure(list(uri = structure(logical(0), tags = list(type = "string")), fallbackResult = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), tags = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map")), loggingConfigurationIdentifiers = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.ivschat$delete_logging_configuration_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(identifier = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.ivschat$delete_logging_configuration_output <- function(...) {
  list()
}

.ivschat$delete_message_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(roomIdentifier = structure(logical(0), tags = list(type = "string")), id = structure(logical(0), tags = list(type = "string")), reason = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.ivschat$delete_message_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(id = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.ivschat$delete_room_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(identifier = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.ivschat$delete_room_output <- function(...) {
  list()
}

.ivschat$disconnect_user_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(roomIdentifier = structure(logical(0), tags = list(type = "string")), userId = structure(logical(0), tags = list(type = "string", sensitive = TRUE)), reason = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.ivschat$disconnect_user_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.ivschat$get_logging_configuration_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(identifier = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.ivschat$get_logging_configuration_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(arn = structure(logical(0), tags = list(type = "string")), id = structure(logical(0), tags = list(type = "string")), createTime = structure(logical(0), tags = list(type = "timestamp", timestampFormat = "iso8601")), updateTime = structure(logical(0), tags = list(type = "timestamp", timestampFormat = "iso8601")), name = structure(logical(0), tags = list(type = "string")), destinationConfiguration = structure(list(s3 = structure(list(bucketName = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), cloudWatchLogs = structure(list(logGroupName = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), firehose = structure(list(deliveryStreamName = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure", union = TRUE)), state = structure(logical(0), tags = list(type = "string")), tags = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.ivschat$get_room_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(identifier = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.ivschat$get_room_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(arn = structure(logical(0), tags = list(type = "string")), id = structure(logical(0), tags = list(type = "string")), name = structure(logical(0), tags = list(type = "string")), createTime = structure(logical(0), tags = list(type = "timestamp", timestampFormat = "iso8601")), updateTime = structure(logical(0), tags = list(type = "timestamp", timestampFormat = "iso8601")), maximumMessageRatePerSecond = structure(logical(0), tags = list(type = "integer", box = TRUE)), maximumMessageLength = structure(logical(0), tags = list(type = "integer", box = TRUE)), messageReviewHandler = structure(list(uri = structure(logical(0), tags = list(type = "string")), fallbackResult = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), tags = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map")), loggingConfigurationIdentifiers = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.ivschat$list_logging_configurations_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(nextToken = structure(logical(0), tags = list(type = "string")), maxResults = structure(logical(0), tags = list(type = "integer", box = TRUE))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.ivschat$list_logging_configurations_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(loggingConfigurations = structure(list(structure(list(arn = structure(logical(0), tags = list(type = "string")), id = structure(logical(0), tags = list(type = "string")), createTime = structure(logical(0), tags = list(type = "timestamp", timestampFormat = "iso8601")), updateTime = structure(logical(0), tags = list(type = "timestamp", timestampFormat = "iso8601")), name = structure(logical(0), tags = list(type = "string")), destinationConfiguration = structure(list(s3 = structure(list(bucketName = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), cloudWatchLogs = structure(list(logGroupName = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), firehose = structure(list(deliveryStreamName = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure", union = TRUE)), state = structure(logical(0), tags = list(type = "string")), tags = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map"))), tags = list(type = "structure"))), tags = list(type = "list")), nextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.ivschat$list_rooms_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(name = structure(logical(0), tags = list(type = "string")), nextToken = structure(logical(0), tags = list(type = "string")), maxResults = structure(logical(0), tags = list(type = "integer", box = TRUE)), messageReviewHandlerUri = structure(logical(0), tags = list(type = "string")), loggingConfigurationIdentifier = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.ivschat$list_rooms_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(rooms = structure(list(structure(list(arn = structure(logical(0), tags = list(type = "string")), id = structure(logical(0), tags = list(type = "string")), name = structure(logical(0), tags = list(type = "string")), messageReviewHandler = structure(list(uri = structure(logical(0), tags = list(type = "string")), fallbackResult = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), createTime = structure(logical(0), tags = list(type = "timestamp", timestampFormat = "iso8601")), updateTime = structure(logical(0), tags = list(type = "timestamp", timestampFormat = "iso8601")), tags = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map")), loggingConfigurationIdentifiers = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure"))), tags = list(type = "list")), nextToken = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.ivschat$list_tags_for_resource_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(resourceArn = structure(logical(0), tags = list(location = "uri", locationName = "resourceArn", type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.ivschat$list_tags_for_resource_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(tags = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.ivschat$send_event_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(roomIdentifier = structure(logical(0), tags = list(type = "string")), eventName = structure(logical(0), tags = list(type = "string")), attributes = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.ivschat$send_event_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(id = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.ivschat$tag_resource_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(resourceArn = structure(logical(0), tags = list(location = "uri", locationName = "resourceArn", type = "string")), tags = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.ivschat$tag_resource_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.ivschat$untag_resource_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(resourceArn = structure(logical(0), tags = list(location = "uri", locationName = "resourceArn", type = "string")), tagKeys = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(location = "querystring", locationName = "tagKeys", type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.ivschat$untag_resource_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

.ivschat$update_logging_configuration_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(identifier = structure(logical(0), tags = list(type = "string")), name = structure(logical(0), tags = list(type = "string")), destinationConfiguration = structure(list(s3 = structure(list(bucketName = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), cloudWatchLogs = structure(list(logGroupName = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), firehose = structure(list(deliveryStreamName = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure", union = TRUE))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.ivschat$update_logging_configuration_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(arn = structure(logical(0), tags = list(type = "string")), id = structure(logical(0), tags = list(type = "string")), createTime = structure(logical(0), tags = list(type = "timestamp", timestampFormat = "iso8601")), updateTime = structure(logical(0), tags = list(type = "timestamp", timestampFormat = "iso8601")), name = structure(logical(0), tags = list(type = "string")), destinationConfiguration = structure(list(s3 = structure(list(bucketName = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), cloudWatchLogs = structure(list(logGroupName = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), firehose = structure(list(deliveryStreamName = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure", union = TRUE)), state = structure(logical(0), tags = list(type = "string")), tags = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.ivschat$update_room_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(identifier = structure(logical(0), tags = list(type = "string")), name = structure(logical(0), tags = list(type = "string")), maximumMessageRatePerSecond = structure(logical(0), tags = list(type = "integer", box = TRUE)), maximumMessageLength = structure(logical(0), tags = list(type = "integer", box = TRUE)), messageReviewHandler = structure(list(uri = structure(logical(0), tags = list(type = "string")), fallbackResult = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), loggingConfigurationIdentifiers = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.ivschat$update_room_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(arn = structure(logical(0), tags = list(type = "string")), id = structure(logical(0), tags = list(type = "string")), name = structure(logical(0), tags = list(type = "string")), createTime = structure(logical(0), tags = list(type = "timestamp", timestampFormat = "iso8601")), updateTime = structure(logical(0), tags = list(type = "timestamp", timestampFormat = "iso8601")), maximumMessageRatePerSecond = structure(logical(0), tags = list(type = "integer", box = TRUE)), maximumMessageLength = structure(logical(0), tags = list(type = "integer", box = TRUE)), messageReviewHandler = structure(list(uri = structure(logical(0), tags = list(type = "string")), fallbackResult = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure")), tags = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "map")), loggingConfigurationIdentifiers = structure(list(structure(logical(0), tags = list(type = "string"))), tags = list(type = "list"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

# This file is generated by make.paws. Please do not edit here.
#' @importFrom paws.common get_config new_operation new_request send_request
#' @include workspaces_service.R
NULL

#' Accepts the account link invitation
#'
#' @description
#' Accepts the account link invitation.
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_accept_account_link_invitation/](https://www.paws-r-sdk.com/docs/workspaces_accept_account_link_invitation/) for full documentation.
#'
#' @param LinkId &#91;required&#93; The identifier of the account link.
#' @param ClientToken A string of up to 64 ASCII characters that Amazon WorkSpaces uses to ensure idempotent creation.
#'
#' @keywords internal
#'
#' @rdname workspaces_accept_account_link_invitation
workspaces_accept_account_link_invitation <- function(LinkId, ClientToken = NULL) {
  op <- new_operation(
    name = "AcceptAccountLinkInvitation",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$accept_account_link_invitation_input(LinkId = LinkId, ClientToken = ClientToken)
  output <- .workspaces$accept_account_link_invitation_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$accept_account_link_invitation <- workspaces_accept_account_link_invitation

#' Associates the specified connection alias with the specified directory
#' to enable cross-Region redirection
#'
#' @description
#' Associates the specified connection alias with the specified directory to enable cross-Region redirection. For more information, see [Cross-Region Redirection for Amazon WorkSpaces](https://docs.aws.amazon.com/workspaces/latest/adminguide/cross-region-redirection.html).
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_associate_connection_alias/](https://www.paws-r-sdk.com/docs/workspaces_associate_connection_alias/) for full documentation.
#'
#' @param AliasId &#91;required&#93; The identifier of the connection alias.
#' @param ResourceId &#91;required&#93; The identifier of the directory to associate the connection alias with.
#'
#' @keywords internal
#'
#' @rdname workspaces_associate_connection_alias
workspaces_associate_connection_alias <- function(AliasId, ResourceId) {
  op <- new_operation(
    name = "AssociateConnectionAlias",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$associate_connection_alias_input(AliasId = AliasId, ResourceId = ResourceId)
  output <- .workspaces$associate_connection_alias_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$associate_connection_alias <- workspaces_associate_connection_alias

#' Associates the specified IP access control group with the specified
#' directory
#'
#' @description
#' Associates the specified IP access control group with the specified directory.
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_associate_ip_groups/](https://www.paws-r-sdk.com/docs/workspaces_associate_ip_groups/) for full documentation.
#'
#' @param DirectoryId &#91;required&#93; The identifier of the directory.
#' @param GroupIds &#91;required&#93; The identifiers of one or more IP access control groups.
#'
#' @keywords internal
#'
#' @rdname workspaces_associate_ip_groups
workspaces_associate_ip_groups <- function(DirectoryId, GroupIds) {
  op <- new_operation(
    name = "AssociateIpGroups",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$associate_ip_groups_input(DirectoryId = DirectoryId, GroupIds = GroupIds)
  output <- .workspaces$associate_ip_groups_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$associate_ip_groups <- workspaces_associate_ip_groups

#' Associates the specified application to the specified WorkSpace
#'
#' @description
#' Associates the specified application to the specified WorkSpace.
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_associate_workspace_application/](https://www.paws-r-sdk.com/docs/workspaces_associate_workspace_application/) for full documentation.
#'
#' @param WorkspaceId &#91;required&#93; The identifier of the WorkSpace.
#' @param ApplicationId &#91;required&#93; The identifier of the application.
#'
#' @keywords internal
#'
#' @rdname workspaces_associate_workspace_application
workspaces_associate_workspace_application <- function(WorkspaceId, ApplicationId) {
  op <- new_operation(
    name = "AssociateWorkspaceApplication",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$associate_workspace_application_input(WorkspaceId = WorkspaceId, ApplicationId = ApplicationId)
  output <- .workspaces$associate_workspace_application_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$associate_workspace_application <- workspaces_associate_workspace_application

#' Adds one or more rules to the specified IP access control group
#'
#' @description
#' Adds one or more rules to the specified IP access control group.
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_authorize_ip_rules/](https://www.paws-r-sdk.com/docs/workspaces_authorize_ip_rules/) for full documentation.
#'
#' @param GroupId &#91;required&#93; The identifier of the group.
#' @param UserRules &#91;required&#93; The rules to add to the group.
#'
#' @keywords internal
#'
#' @rdname workspaces_authorize_ip_rules
workspaces_authorize_ip_rules <- function(GroupId, UserRules) {
  op <- new_operation(
    name = "AuthorizeIpRules",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$authorize_ip_rules_input(GroupId = GroupId, UserRules = UserRules)
  output <- .workspaces$authorize_ip_rules_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$authorize_ip_rules <- workspaces_authorize_ip_rules

#' Copies the specified image from the specified Region to the current
#' Region
#'
#' @description
#' Copies the specified image from the specified Region to the current Region. For more information about copying images, see [Copy a Custom WorkSpaces Image](https://docs.aws.amazon.com/workspaces/latest/adminguide/copy-custom-image.html).
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_copy_workspace_image/](https://www.paws-r-sdk.com/docs/workspaces_copy_workspace_image/) for full documentation.
#'
#' @param Name &#91;required&#93; The name of the image.
#' @param Description A description of the image.
#' @param SourceImageId &#91;required&#93; The identifier of the source image.
#' @param SourceRegion &#91;required&#93; The identifier of the source Region.
#' @param Tags The tags for the image.
#'
#' @keywords internal
#'
#' @rdname workspaces_copy_workspace_image
workspaces_copy_workspace_image <- function(Name, Description = NULL, SourceImageId, SourceRegion, Tags = NULL) {
  op <- new_operation(
    name = "CopyWorkspaceImage",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$copy_workspace_image_input(Name = Name, Description = Description, SourceImageId = SourceImageId, SourceRegion = SourceRegion, Tags = Tags)
  output <- .workspaces$copy_workspace_image_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$copy_workspace_image <- workspaces_copy_workspace_image

#' Creates the account link invitation
#'
#' @description
#' Creates the account link invitation.
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_create_account_link_invitation/](https://www.paws-r-sdk.com/docs/workspaces_create_account_link_invitation/) for full documentation.
#'
#' @param TargetAccountId &#91;required&#93; The identifier of the target account.
#' @param ClientToken A string of up to 64 ASCII characters that Amazon WorkSpaces uses to ensure idempotent creation.
#'
#' @keywords internal
#'
#' @rdname workspaces_create_account_link_invitation
workspaces_create_account_link_invitation <- function(TargetAccountId, ClientToken = NULL) {
  op <- new_operation(
    name = "CreateAccountLinkInvitation",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$create_account_link_invitation_input(TargetAccountId = TargetAccountId, ClientToken = ClientToken)
  output <- .workspaces$create_account_link_invitation_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$create_account_link_invitation <- workspaces_create_account_link_invitation

#' Creates a client-add-in for Amazon Connect within a directory
#'
#' @description
#' Creates a client-add-in for Amazon Connect within a directory. You can create only one Amazon Connect client add-in within a directory.
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_create_connect_client_add_in/](https://www.paws-r-sdk.com/docs/workspaces_create_connect_client_add_in/) for full documentation.
#'
#' @param ResourceId &#91;required&#93; The directory identifier for which to configure the client add-in.
#' @param Name &#91;required&#93; The name of the client add-in.
#' @param URL &#91;required&#93; The endpoint URL of the Amazon Connect client add-in.
#'
#' @keywords internal
#'
#' @rdname workspaces_create_connect_client_add_in
workspaces_create_connect_client_add_in <- function(ResourceId, Name, URL) {
  op <- new_operation(
    name = "CreateConnectClientAddIn",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$create_connect_client_add_in_input(ResourceId = ResourceId, Name = Name, URL = URL)
  output <- .workspaces$create_connect_client_add_in_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$create_connect_client_add_in <- workspaces_create_connect_client_add_in

#' Creates the specified connection alias for use with cross-Region
#' redirection
#'
#' @description
#' Creates the specified connection alias for use with cross-Region redirection. For more information, see [Cross-Region Redirection for Amazon WorkSpaces](https://docs.aws.amazon.com/workspaces/latest/adminguide/cross-region-redirection.html).
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_create_connection_alias/](https://www.paws-r-sdk.com/docs/workspaces_create_connection_alias/) for full documentation.
#'
#' @param ConnectionString &#91;required&#93; A connection string in the form of a fully qualified domain name (FQDN), such as `www.example.com`.
#' 
#' After you create a connection string, it is always associated to your Amazon Web Services account. You cannot recreate the same connection string with a different account, even if you delete all instances of it from the original account. The connection string is globally reserved for your account.
#' @param Tags The tags to associate with the connection alias.
#'
#' @keywords internal
#'
#' @rdname workspaces_create_connection_alias
workspaces_create_connection_alias <- function(ConnectionString, Tags = NULL) {
  op <- new_operation(
    name = "CreateConnectionAlias",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$create_connection_alias_input(ConnectionString = ConnectionString, Tags = Tags)
  output <- .workspaces$create_connection_alias_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$create_connection_alias <- workspaces_create_connection_alias

#' Creates an IP access control group
#'
#' @description
#' Creates an IP access control group.
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_create_ip_group/](https://www.paws-r-sdk.com/docs/workspaces_create_ip_group/) for full documentation.
#'
#' @param GroupName &#91;required&#93; The name of the group.
#' @param GroupDesc The description of the group.
#' @param UserRules The rules to add to the group.
#' @param Tags The tags. Each WorkSpaces resource can have a maximum of 50 tags.
#'
#' @keywords internal
#'
#' @rdname workspaces_create_ip_group
workspaces_create_ip_group <- function(GroupName, GroupDesc = NULL, UserRules = NULL, Tags = NULL) {
  op <- new_operation(
    name = "CreateIpGroup",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$create_ip_group_input(GroupName = GroupName, GroupDesc = GroupDesc, UserRules = UserRules, Tags = Tags)
  output <- .workspaces$create_ip_group_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$create_ip_group <- workspaces_create_ip_group

#' Creates a standby WorkSpace in a secondary Region
#'
#' @description
#' Creates a standby WorkSpace in a secondary Region.
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_create_standby_workspaces/](https://www.paws-r-sdk.com/docs/workspaces_create_standby_workspaces/) for full documentation.
#'
#' @param PrimaryRegion &#91;required&#93; The Region of the primary WorkSpace.
#' @param StandbyWorkspaces &#91;required&#93; Information about the standby WorkSpace to be created.
#'
#' @keywords internal
#'
#' @rdname workspaces_create_standby_workspaces
workspaces_create_standby_workspaces <- function(PrimaryRegion, StandbyWorkspaces) {
  op <- new_operation(
    name = "CreateStandbyWorkspaces",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$create_standby_workspaces_input(PrimaryRegion = PrimaryRegion, StandbyWorkspaces = StandbyWorkspaces)
  output <- .workspaces$create_standby_workspaces_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$create_standby_workspaces <- workspaces_create_standby_workspaces

#' Creates the specified tags for the specified WorkSpaces resource
#'
#' @description
#' Creates the specified tags for the specified WorkSpaces resource.
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_create_tags/](https://www.paws-r-sdk.com/docs/workspaces_create_tags/) for full documentation.
#'
#' @param ResourceId &#91;required&#93; The identifier of the WorkSpaces resource. The supported resource types are WorkSpaces, registered directories, images, custom bundles, IP access control groups, and connection aliases.
#' @param Tags &#91;required&#93; The tags. Each WorkSpaces resource can have a maximum of 50 tags.
#'
#' @keywords internal
#'
#' @rdname workspaces_create_tags
workspaces_create_tags <- function(ResourceId, Tags) {
  op <- new_operation(
    name = "CreateTags",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$create_tags_input(ResourceId = ResourceId, Tags = Tags)
  output <- .workspaces$create_tags_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$create_tags <- workspaces_create_tags

#' Creates a new updated WorkSpace image based on the specified source
#' image
#'
#' @description
#' Creates a new updated WorkSpace image based on the specified source image. The new updated WorkSpace image has the latest drivers and other updates required by the Amazon WorkSpaces components.
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_create_updated_workspace_image/](https://www.paws-r-sdk.com/docs/workspaces_create_updated_workspace_image/) for full documentation.
#'
#' @param Name &#91;required&#93; The name of the new updated WorkSpace image.
#' @param Description &#91;required&#93; A description of whether updates for the WorkSpace image are available.
#' @param SourceImageId &#91;required&#93; The identifier of the source WorkSpace image.
#' @param Tags The tags that you want to add to the new updated WorkSpace image.
#' 
#' To add tags at the same time when you're creating the updated image, you must create an IAM policy that grants your IAM user permissions to use `workspaces:CreateTags`.
#'
#' @keywords internal
#'
#' @rdname workspaces_create_updated_workspace_image
workspaces_create_updated_workspace_image <- function(Name, Description, SourceImageId, Tags = NULL) {
  op <- new_operation(
    name = "CreateUpdatedWorkspaceImage",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$create_updated_workspace_image_input(Name = Name, Description = Description, SourceImageId = SourceImageId, Tags = Tags)
  output <- .workspaces$create_updated_workspace_image_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$create_updated_workspace_image <- workspaces_create_updated_workspace_image

#' Creates the specified WorkSpace bundle
#'
#' @description
#' Creates the specified WorkSpace bundle. For more information about creating WorkSpace bundles, see [Create a Custom WorkSpaces Image and Bundle](https://docs.aws.amazon.com/workspaces/latest/adminguide/create-custom-bundle.html).
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_create_workspace_bundle/](https://www.paws-r-sdk.com/docs/workspaces_create_workspace_bundle/) for full documentation.
#'
#' @param BundleName &#91;required&#93; The name of the bundle.
#' @param BundleDescription &#91;required&#93; The description of the bundle.
#' @param ImageId &#91;required&#93; The identifier of the image that is used to create the bundle.
#' @param ComputeType &#91;required&#93; Describes the compute type of the bundle.
#' @param UserStorage &#91;required&#93; Describes the user volume for a WorkSpace bundle.
#' @param RootStorage Describes the root volume for a WorkSpace bundle.
#' @param Tags The tags associated with the bundle.
#' 
#' To add tags at the same time when you're creating the bundle, you must create an IAM policy that grants your IAM user permissions to use `workspaces:CreateTags`.
#'
#' @keywords internal
#'
#' @rdname workspaces_create_workspace_bundle
workspaces_create_workspace_bundle <- function(BundleName, BundleDescription, ImageId, ComputeType, UserStorage, RootStorage = NULL, Tags = NULL) {
  op <- new_operation(
    name = "CreateWorkspaceBundle",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$create_workspace_bundle_input(BundleName = BundleName, BundleDescription = BundleDescription, ImageId = ImageId, ComputeType = ComputeType, UserStorage = UserStorage, RootStorage = RootStorage, Tags = Tags)
  output <- .workspaces$create_workspace_bundle_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$create_workspace_bundle <- workspaces_create_workspace_bundle

#' Creates a new WorkSpace image from an existing WorkSpace
#'
#' @description
#' Creates a new WorkSpace image from an existing WorkSpace.
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_create_workspace_image/](https://www.paws-r-sdk.com/docs/workspaces_create_workspace_image/) for full documentation.
#'
#' @param Name &#91;required&#93; The name of the new WorkSpace image.
#' @param Description &#91;required&#93; The description of the new WorkSpace image.
#' @param WorkspaceId &#91;required&#93; The identifier of the source WorkSpace
#' @param Tags The tags that you want to add to the new WorkSpace image. To add tags when you're creating the image, you must create an IAM policy that grants your IAM user permission to use `workspaces:CreateTags`.
#'
#' @keywords internal
#'
#' @rdname workspaces_create_workspace_image
workspaces_create_workspace_image <- function(Name, Description, WorkspaceId, Tags = NULL) {
  op <- new_operation(
    name = "CreateWorkspaceImage",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$create_workspace_image_input(Name = Name, Description = Description, WorkspaceId = WorkspaceId, Tags = Tags)
  output <- .workspaces$create_workspace_image_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$create_workspace_image <- workspaces_create_workspace_image

#' Creates one or more WorkSpaces
#'
#' @description
#' Creates one or more WorkSpaces.
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_create_workspaces/](https://www.paws-r-sdk.com/docs/workspaces_create_workspaces/) for full documentation.
#'
#' @param Workspaces &#91;required&#93; The WorkSpaces to create. You can specify up to 25 WorkSpaces.
#'
#' @keywords internal
#'
#' @rdname workspaces_create_workspaces
workspaces_create_workspaces <- function(Workspaces) {
  op <- new_operation(
    name = "CreateWorkspaces",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$create_workspaces_input(Workspaces = Workspaces)
  output <- .workspaces$create_workspaces_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$create_workspaces <- workspaces_create_workspaces

#' Creates a pool of WorkSpaces
#'
#' @description
#' Creates a pool of WorkSpaces.
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_create_workspaces_pool/](https://www.paws-r-sdk.com/docs/workspaces_create_workspaces_pool/) for full documentation.
#'
#' @param PoolName &#91;required&#93; The name of the pool.
#' @param Description &#91;required&#93; The pool description.
#' @param BundleId &#91;required&#93; The identifier of the bundle for the pool.
#' @param DirectoryId &#91;required&#93; The identifier of the directory for the pool.
#' @param Capacity &#91;required&#93; The user capacity of the pool.
#' @param Tags The tags for the pool.
#' @param ApplicationSettings Indicates the application settings of the pool.
#' @param TimeoutSettings Indicates the timeout settings of the pool.
#' @param RunningMode The running mode for the pool.
#'
#' @keywords internal
#'
#' @rdname workspaces_create_workspaces_pool
workspaces_create_workspaces_pool <- function(PoolName, Description, BundleId, DirectoryId, Capacity, Tags = NULL, ApplicationSettings = NULL, TimeoutSettings = NULL, RunningMode = NULL) {
  op <- new_operation(
    name = "CreateWorkspacesPool",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$create_workspaces_pool_input(PoolName = PoolName, Description = Description, BundleId = BundleId, DirectoryId = DirectoryId, Capacity = Capacity, Tags = Tags, ApplicationSettings = ApplicationSettings, TimeoutSettings = TimeoutSettings, RunningMode = RunningMode)
  output <- .workspaces$create_workspaces_pool_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$create_workspaces_pool <- workspaces_create_workspaces_pool

#' Deletes the account link invitation
#'
#' @description
#' Deletes the account link invitation.
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_delete_account_link_invitation/](https://www.paws-r-sdk.com/docs/workspaces_delete_account_link_invitation/) for full documentation.
#'
#' @param LinkId &#91;required&#93; The identifier of the account link.
#' @param ClientToken A string of up to 64 ASCII characters that Amazon WorkSpaces uses to ensure idempotent creation.
#'
#' @keywords internal
#'
#' @rdname workspaces_delete_account_link_invitation
workspaces_delete_account_link_invitation <- function(LinkId, ClientToken = NULL) {
  op <- new_operation(
    name = "DeleteAccountLinkInvitation",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$delete_account_link_invitation_input(LinkId = LinkId, ClientToken = ClientToken)
  output <- .workspaces$delete_account_link_invitation_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$delete_account_link_invitation <- workspaces_delete_account_link_invitation

#' Deletes customized client branding
#'
#' @description
#' Deletes customized client branding. Client branding allows you to customize your WorkSpace's client login portal. You can tailor your login portal company logo, the support email address, support link, link to reset password, and a custom message for users trying to sign in.
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_delete_client_branding/](https://www.paws-r-sdk.com/docs/workspaces_delete_client_branding/) for full documentation.
#'
#' @param ResourceId &#91;required&#93; The directory identifier of the WorkSpace for which you want to delete client branding.
#' @param Platforms &#91;required&#93; The device type for which you want to delete client branding.
#'
#' @keywords internal
#'
#' @rdname workspaces_delete_client_branding
workspaces_delete_client_branding <- function(ResourceId, Platforms) {
  op <- new_operation(
    name = "DeleteClientBranding",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$delete_client_branding_input(ResourceId = ResourceId, Platforms = Platforms)
  output <- .workspaces$delete_client_branding_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$delete_client_branding <- workspaces_delete_client_branding

#' Deletes a client-add-in for Amazon Connect that is configured within a
#' directory
#'
#' @description
#' Deletes a client-add-in for Amazon Connect that is configured within a directory.
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_delete_connect_client_add_in/](https://www.paws-r-sdk.com/docs/workspaces_delete_connect_client_add_in/) for full documentation.
#'
#' @param AddInId &#91;required&#93; The identifier of the client add-in to delete.
#' @param ResourceId &#91;required&#93; The directory identifier for which the client add-in is configured.
#'
#' @keywords internal
#'
#' @rdname workspaces_delete_connect_client_add_in
workspaces_delete_connect_client_add_in <- function(AddInId, ResourceId) {
  op <- new_operation(
    name = "DeleteConnectClientAddIn",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$delete_connect_client_add_in_input(AddInId = AddInId, ResourceId = ResourceId)
  output <- .workspaces$delete_connect_client_add_in_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$delete_connect_client_add_in <- workspaces_delete_connect_client_add_in

#' Deletes the specified connection alias
#'
#' @description
#' Deletes the specified connection alias. For more information, see [Cross-Region Redirection for Amazon WorkSpaces](https://docs.aws.amazon.com/workspaces/latest/adminguide/cross-region-redirection.html).
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_delete_connection_alias/](https://www.paws-r-sdk.com/docs/workspaces_delete_connection_alias/) for full documentation.
#'
#' @param AliasId &#91;required&#93; The identifier of the connection alias to delete.
#'
#' @keywords internal
#'
#' @rdname workspaces_delete_connection_alias
workspaces_delete_connection_alias <- function(AliasId) {
  op <- new_operation(
    name = "DeleteConnectionAlias",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$delete_connection_alias_input(AliasId = AliasId)
  output <- .workspaces$delete_connection_alias_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$delete_connection_alias <- workspaces_delete_connection_alias

#' Deletes the specified IP access control group
#'
#' @description
#' Deletes the specified IP access control group.
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_delete_ip_group/](https://www.paws-r-sdk.com/docs/workspaces_delete_ip_group/) for full documentation.
#'
#' @param GroupId &#91;required&#93; The identifier of the IP access control group.
#'
#' @keywords internal
#'
#' @rdname workspaces_delete_ip_group
workspaces_delete_ip_group <- function(GroupId) {
  op <- new_operation(
    name = "DeleteIpGroup",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$delete_ip_group_input(GroupId = GroupId)
  output <- .workspaces$delete_ip_group_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$delete_ip_group <- workspaces_delete_ip_group

#' Deletes the specified tags from the specified WorkSpaces resource
#'
#' @description
#' Deletes the specified tags from the specified WorkSpaces resource.
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_delete_tags/](https://www.paws-r-sdk.com/docs/workspaces_delete_tags/) for full documentation.
#'
#' @param ResourceId &#91;required&#93; The identifier of the WorkSpaces resource. The supported resource types are WorkSpaces, registered directories, images, custom bundles, IP access control groups, and connection aliases.
#' @param TagKeys &#91;required&#93; The tag keys.
#'
#' @keywords internal
#'
#' @rdname workspaces_delete_tags
workspaces_delete_tags <- function(ResourceId, TagKeys) {
  op <- new_operation(
    name = "DeleteTags",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$delete_tags_input(ResourceId = ResourceId, TagKeys = TagKeys)
  output <- .workspaces$delete_tags_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$delete_tags <- workspaces_delete_tags

#' Deletes the specified WorkSpace bundle
#'
#' @description
#' Deletes the specified WorkSpace bundle. For more information about deleting WorkSpace bundles, see [Delete a Custom WorkSpaces Bundle or Image](https://docs.aws.amazon.com/workspaces/latest/adminguide/delete_bundle.html).
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_delete_workspace_bundle/](https://www.paws-r-sdk.com/docs/workspaces_delete_workspace_bundle/) for full documentation.
#'
#' @param BundleId The identifier of the bundle.
#'
#' @keywords internal
#'
#' @rdname workspaces_delete_workspace_bundle
workspaces_delete_workspace_bundle <- function(BundleId = NULL) {
  op <- new_operation(
    name = "DeleteWorkspaceBundle",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$delete_workspace_bundle_input(BundleId = BundleId)
  output <- .workspaces$delete_workspace_bundle_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$delete_workspace_bundle <- workspaces_delete_workspace_bundle

#' Deletes the specified image from your account
#'
#' @description
#' Deletes the specified image from your account. To delete an image, you must first delete any bundles that are associated with the image and unshare the image if it is shared with other accounts.
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_delete_workspace_image/](https://www.paws-r-sdk.com/docs/workspaces_delete_workspace_image/) for full documentation.
#'
#' @param ImageId &#91;required&#93; The identifier of the image.
#'
#' @keywords internal
#'
#' @rdname workspaces_delete_workspace_image
workspaces_delete_workspace_image <- function(ImageId) {
  op <- new_operation(
    name = "DeleteWorkspaceImage",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$delete_workspace_image_input(ImageId = ImageId)
  output <- .workspaces$delete_workspace_image_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$delete_workspace_image <- workspaces_delete_workspace_image

#' Deploys associated applications to the specified WorkSpace
#'
#' @description
#' Deploys associated applications to the specified WorkSpace
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_deploy_workspace_applications/](https://www.paws-r-sdk.com/docs/workspaces_deploy_workspace_applications/) for full documentation.
#'
#' @param WorkspaceId &#91;required&#93; The identifier of the WorkSpace.
#' @param Force Indicates whether the force flag is applied for the specified WorkSpace. When the force flag is enabled, it allows previously failed deployments to be retried.
#'
#' @keywords internal
#'
#' @rdname workspaces_deploy_workspace_applications
workspaces_deploy_workspace_applications <- function(WorkspaceId, Force = NULL) {
  op <- new_operation(
    name = "DeployWorkspaceApplications",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$deploy_workspace_applications_input(WorkspaceId = WorkspaceId, Force = Force)
  output <- .workspaces$deploy_workspace_applications_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$deploy_workspace_applications <- workspaces_deploy_workspace_applications

#' Deregisters the specified directory
#'
#' @description
#' Deregisters the specified directory. This operation is asynchronous and returns before the WorkSpace directory is deregistered. If any WorkSpaces are registered to this directory, you must remove them before you can deregister the directory.
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_deregister_workspace_directory/](https://www.paws-r-sdk.com/docs/workspaces_deregister_workspace_directory/) for full documentation.
#'
#' @param DirectoryId &#91;required&#93; The identifier of the directory. If any WorkSpaces are registered to this directory, you must remove them before you deregister the directory, or you will receive an OperationNotSupportedException error.
#'
#' @keywords internal
#'
#' @rdname workspaces_deregister_workspace_directory
workspaces_deregister_workspace_directory <- function(DirectoryId) {
  op <- new_operation(
    name = "DeregisterWorkspaceDirectory",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$deregister_workspace_directory_input(DirectoryId = DirectoryId)
  output <- .workspaces$deregister_workspace_directory_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$deregister_workspace_directory <- workspaces_deregister_workspace_directory

#' Retrieves a list that describes the configuration of Bring Your Own
#' License (BYOL) for the specified account
#'
#' @description
#' Retrieves a list that describes the configuration of Bring Your Own License (BYOL) for the specified account.
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_describe_account/](https://www.paws-r-sdk.com/docs/workspaces_describe_account/) for full documentation.
#'

#'
#' @keywords internal
#'
#' @rdname workspaces_describe_account
workspaces_describe_account <- function() {
  op <- new_operation(
    name = "DescribeAccount",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$describe_account_input()
  output <- .workspaces$describe_account_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$describe_account <- workspaces_describe_account

#' Retrieves a list that describes modifications to the configuration of
#' Bring Your Own License (BYOL) for the specified account
#'
#' @description
#' Retrieves a list that describes modifications to the configuration of Bring Your Own License (BYOL) for the specified account.
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_describe_account_modifications/](https://www.paws-r-sdk.com/docs/workspaces_describe_account_modifications/) for full documentation.
#'
#' @param NextToken If you received a `NextToken` from a previous call that was paginated, provide this token to receive the next set of results.
#'
#' @keywords internal
#'
#' @rdname workspaces_describe_account_modifications
workspaces_describe_account_modifications <- function(NextToken = NULL) {
  op <- new_operation(
    name = "DescribeAccountModifications",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(input_token = "NextToken", output_token = "NextToken", result_key = "AccountModifications"),
    stream_api = FALSE
  )
  input <- .workspaces$describe_account_modifications_input(NextToken = NextToken)
  output <- .workspaces$describe_account_modifications_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$describe_account_modifications <- workspaces_describe_account_modifications

#' Describes the associations between the application and the specified
#' associated resources
#'
#' @description
#' Describes the associations between the application and the specified associated resources.
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_describe_application_associations/](https://www.paws-r-sdk.com/docs/workspaces_describe_application_associations/) for full documentation.
#'
#' @param MaxResults The maximum number of associations to return.
#' @param NextToken If you received a `NextToken` from a previous call that was paginated, provide this token to receive the next set of results.
#' @param ApplicationId &#91;required&#93; The identifier of the specified application.
#' @param AssociatedResourceTypes &#91;required&#93; The resource type of the associated resources.
#'
#' @keywords internal
#'
#' @rdname workspaces_describe_application_associations
workspaces_describe_application_associations <- function(MaxResults = NULL, NextToken = NULL, ApplicationId, AssociatedResourceTypes) {
  op <- new_operation(
    name = "DescribeApplicationAssociations",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(input_token = "NextToken", limit_key = "MaxResults", output_token = "NextToken"),
    stream_api = FALSE
  )
  input <- .workspaces$describe_application_associations_input(MaxResults = MaxResults, NextToken = NextToken, ApplicationId = ApplicationId, AssociatedResourceTypes = AssociatedResourceTypes)
  output <- .workspaces$describe_application_associations_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$describe_application_associations <- workspaces_describe_application_associations

#' Describes the specified applications by filtering based on their compute
#' types, license availability, operating systems, and owners
#'
#' @description
#' Describes the specified applications by filtering based on their compute types, license availability, operating systems, and owners.
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_describe_applications/](https://www.paws-r-sdk.com/docs/workspaces_describe_applications/) for full documentation.
#'
#' @param ApplicationIds The identifiers of one or more applications.
#' @param ComputeTypeNames The compute types supported by the applications.
#' @param LicenseType The license availability for the applications.
#' @param OperatingSystemNames The operating systems supported by the applications.
#' @param Owner The owner of the applications.
#' @param MaxResults The maximum number of applications to return.
#' @param NextToken If you received a `NextToken` from a previous call that was paginated, provide this token to receive the next set of results.
#'
#' @keywords internal
#'
#' @rdname workspaces_describe_applications
workspaces_describe_applications <- function(ApplicationIds = NULL, ComputeTypeNames = NULL, LicenseType = NULL, OperatingSystemNames = NULL, Owner = NULL, MaxResults = NULL, NextToken = NULL) {
  op <- new_operation(
    name = "DescribeApplications",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(input_token = "NextToken", limit_key = "MaxResults", output_token = "NextToken"),
    stream_api = FALSE
  )
  input <- .workspaces$describe_applications_input(ApplicationIds = ApplicationIds, ComputeTypeNames = ComputeTypeNames, LicenseType = LicenseType, OperatingSystemNames = OperatingSystemNames, Owner = Owner, MaxResults = MaxResults, NextToken = NextToken)
  output <- .workspaces$describe_applications_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$describe_applications <- workspaces_describe_applications

#' Describes the associations between the applications and the specified
#' bundle
#'
#' @description
#' Describes the associations between the applications and the specified bundle.
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_describe_bundle_associations/](https://www.paws-r-sdk.com/docs/workspaces_describe_bundle_associations/) for full documentation.
#'
#' @param BundleId &#91;required&#93; The identifier of the bundle.
#' @param AssociatedResourceTypes &#91;required&#93; The resource types of the associated resource.
#'
#' @keywords internal
#'
#' @rdname workspaces_describe_bundle_associations
workspaces_describe_bundle_associations <- function(BundleId, AssociatedResourceTypes) {
  op <- new_operation(
    name = "DescribeBundleAssociations",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$describe_bundle_associations_input(BundleId = BundleId, AssociatedResourceTypes = AssociatedResourceTypes)
  output <- .workspaces$describe_bundle_associations_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$describe_bundle_associations <- workspaces_describe_bundle_associations

#' Describes the specified client branding
#'
#' @description
#' Describes the specified client branding. Client branding allows you to customize the log in page of various device types for your users. You can add your company logo, the support email address, support link, link to reset password, and a custom message for users trying to sign in.
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_describe_client_branding/](https://www.paws-r-sdk.com/docs/workspaces_describe_client_branding/) for full documentation.
#'
#' @param ResourceId &#91;required&#93; The directory identifier of the WorkSpace for which you want to view client branding information.
#'
#' @keywords internal
#'
#' @rdname workspaces_describe_client_branding
workspaces_describe_client_branding <- function(ResourceId) {
  op <- new_operation(
    name = "DescribeClientBranding",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$describe_client_branding_input(ResourceId = ResourceId)
  output <- .workspaces$describe_client_branding_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$describe_client_branding <- workspaces_describe_client_branding

#' Retrieves a list that describes one or more specified Amazon WorkSpaces
#' clients
#'
#' @description
#' Retrieves a list that describes one or more specified Amazon WorkSpaces clients.
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_describe_client_properties/](https://www.paws-r-sdk.com/docs/workspaces_describe_client_properties/) for full documentation.
#'
#' @param ResourceIds &#91;required&#93; The resource identifier, in the form of directory IDs.
#'
#' @keywords internal
#'
#' @rdname workspaces_describe_client_properties
workspaces_describe_client_properties <- function(ResourceIds) {
  op <- new_operation(
    name = "DescribeClientProperties",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$describe_client_properties_input(ResourceIds = ResourceIds)
  output <- .workspaces$describe_client_properties_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$describe_client_properties <- workspaces_describe_client_properties

#' Retrieves a list of Amazon Connect client add-ins that have been created
#'
#' @description
#' Retrieves a list of Amazon Connect client add-ins that have been created.
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_describe_connect_client_add_ins/](https://www.paws-r-sdk.com/docs/workspaces_describe_connect_client_add_ins/) for full documentation.
#'
#' @param ResourceId &#91;required&#93; The directory identifier for which the client add-in is configured.
#' @param NextToken If you received a `NextToken` from a previous call that was paginated, provide this token to receive the next set of results.
#' @param MaxResults The maximum number of items to return.
#'
#' @keywords internal
#'
#' @rdname workspaces_describe_connect_client_add_ins
workspaces_describe_connect_client_add_ins <- function(ResourceId, NextToken = NULL, MaxResults = NULL) {
  op <- new_operation(
    name = "DescribeConnectClientAddIns",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$describe_connect_client_add_ins_input(ResourceId = ResourceId, NextToken = NextToken, MaxResults = MaxResults)
  output <- .workspaces$describe_connect_client_add_ins_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$describe_connect_client_add_ins <- workspaces_describe_connect_client_add_ins

#' Describes the permissions that the owner of a connection alias has
#' granted to another Amazon Web Services account for the specified
#' connection alias
#'
#' @description
#' Describes the permissions that the owner of a connection alias has granted to another Amazon Web Services account for the specified connection alias. For more information, see [Cross-Region Redirection for Amazon WorkSpaces](https://docs.aws.amazon.com/workspaces/latest/adminguide/cross-region-redirection.html).
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_describe_connection_alias_permissions/](https://www.paws-r-sdk.com/docs/workspaces_describe_connection_alias_permissions/) for full documentation.
#'
#' @param AliasId &#91;required&#93; The identifier of the connection alias.
#' @param NextToken If you received a `NextToken` from a previous call that was paginated, provide this token to receive the next set of results.
#' @param MaxResults The maximum number of results to return.
#'
#' @keywords internal
#'
#' @rdname workspaces_describe_connection_alias_permissions
workspaces_describe_connection_alias_permissions <- function(AliasId, NextToken = NULL, MaxResults = NULL) {
  op <- new_operation(
    name = "DescribeConnectionAliasPermissions",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$describe_connection_alias_permissions_input(AliasId = AliasId, NextToken = NextToken, MaxResults = MaxResults)
  output <- .workspaces$describe_connection_alias_permissions_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$describe_connection_alias_permissions <- workspaces_describe_connection_alias_permissions

#' Retrieves a list that describes the connection aliases used for
#' cross-Region redirection
#'
#' @description
#' Retrieves a list that describes the connection aliases used for cross-Region redirection. For more information, see [Cross-Region Redirection for Amazon WorkSpaces](https://docs.aws.amazon.com/workspaces/latest/adminguide/cross-region-redirection.html).
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_describe_connection_aliases/](https://www.paws-r-sdk.com/docs/workspaces_describe_connection_aliases/) for full documentation.
#'
#' @param AliasIds The identifiers of the connection aliases to describe.
#' @param ResourceId The identifier of the directory associated with the connection alias.
#' @param Limit The maximum number of connection aliases to return.
#' @param NextToken If you received a `NextToken` from a previous call that was paginated, provide this token to receive the next set of results.
#'
#' @keywords internal
#'
#' @rdname workspaces_describe_connection_aliases
workspaces_describe_connection_aliases <- function(AliasIds = NULL, ResourceId = NULL, Limit = NULL, NextToken = NULL) {
  op <- new_operation(
    name = "DescribeConnectionAliases",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$describe_connection_aliases_input(AliasIds = AliasIds, ResourceId = ResourceId, Limit = Limit, NextToken = NextToken)
  output <- .workspaces$describe_connection_aliases_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$describe_connection_aliases <- workspaces_describe_connection_aliases

#' Retrieves information about a WorkSpace BYOL image being imported via
#' ImportCustomWorkspaceImage
#'
#' @description
#' Retrieves information about a WorkSpace BYOL image being imported via ImportCustomWorkspaceImage.
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_describe_custom_workspace_image_import/](https://www.paws-r-sdk.com/docs/workspaces_describe_custom_workspace_image_import/) for full documentation.
#'
#' @param ImageId &#91;required&#93; The identifier of the WorkSpace image.
#'
#' @keywords internal
#'
#' @rdname workspaces_describe_custom_workspace_image_import
workspaces_describe_custom_workspace_image_import <- function(ImageId) {
  op <- new_operation(
    name = "DescribeCustomWorkspaceImageImport",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$describe_custom_workspace_image_import_input(ImageId = ImageId)
  output <- .workspaces$describe_custom_workspace_image_import_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$describe_custom_workspace_image_import <- workspaces_describe_custom_workspace_image_import

#' Describes the associations between the applications and the specified
#' image
#'
#' @description
#' Describes the associations between the applications and the specified image.
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_describe_image_associations/](https://www.paws-r-sdk.com/docs/workspaces_describe_image_associations/) for full documentation.
#'
#' @param ImageId &#91;required&#93; The identifier of the image.
#' @param AssociatedResourceTypes &#91;required&#93; The resource types of the associated resource.
#'
#' @keywords internal
#'
#' @rdname workspaces_describe_image_associations
workspaces_describe_image_associations <- function(ImageId, AssociatedResourceTypes) {
  op <- new_operation(
    name = "DescribeImageAssociations",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$describe_image_associations_input(ImageId = ImageId, AssociatedResourceTypes = AssociatedResourceTypes)
  output <- .workspaces$describe_image_associations_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$describe_image_associations <- workspaces_describe_image_associations

#' Describes one or more of your IP access control groups
#'
#' @description
#' Describes one or more of your IP access control groups.
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_describe_ip_groups/](https://www.paws-r-sdk.com/docs/workspaces_describe_ip_groups/) for full documentation.
#'
#' @param GroupIds The identifiers of one or more IP access control groups.
#' @param NextToken If you received a `NextToken` from a previous call that was paginated, provide this token to receive the next set of results.
#' @param MaxResults The maximum number of items to return.
#'
#' @keywords internal
#'
#' @rdname workspaces_describe_ip_groups
workspaces_describe_ip_groups <- function(GroupIds = NULL, NextToken = NULL, MaxResults = NULL) {
  op <- new_operation(
    name = "DescribeIpGroups",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(input_token = "NextToken", limit_key = "MaxResults", output_token = "NextToken", result_key = "Result"),
    stream_api = FALSE
  )
  input <- .workspaces$describe_ip_groups_input(GroupIds = GroupIds, NextToken = NextToken, MaxResults = MaxResults)
  output <- .workspaces$describe_ip_groups_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$describe_ip_groups <- workspaces_describe_ip_groups

#' Describes the specified tags for the specified WorkSpaces resource
#'
#' @description
#' Describes the specified tags for the specified WorkSpaces resource.
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_describe_tags/](https://www.paws-r-sdk.com/docs/workspaces_describe_tags/) for full documentation.
#'
#' @param ResourceId &#91;required&#93; The identifier of the WorkSpaces resource. The supported resource types are WorkSpaces, registered directories, images, custom bundles, IP access control groups, and connection aliases.
#'
#' @keywords internal
#'
#' @rdname workspaces_describe_tags
workspaces_describe_tags <- function(ResourceId) {
  op <- new_operation(
    name = "DescribeTags",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$describe_tags_input(ResourceId = ResourceId)
  output <- .workspaces$describe_tags_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$describe_tags <- workspaces_describe_tags

#' Describes the associations betweens applications and the specified
#' WorkSpace
#'
#' @description
#' Describes the associations betweens applications and the specified WorkSpace.
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_describe_workspace_associations/](https://www.paws-r-sdk.com/docs/workspaces_describe_workspace_associations/) for full documentation.
#'
#' @param WorkspaceId &#91;required&#93; The identifier of the WorkSpace.
#' @param AssociatedResourceTypes &#91;required&#93; The resource types of the associated resources.
#'
#' @keywords internal
#'
#' @rdname workspaces_describe_workspace_associations
workspaces_describe_workspace_associations <- function(WorkspaceId, AssociatedResourceTypes) {
  op <- new_operation(
    name = "DescribeWorkspaceAssociations",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$describe_workspace_associations_input(WorkspaceId = WorkspaceId, AssociatedResourceTypes = AssociatedResourceTypes)
  output <- .workspaces$describe_workspace_associations_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$describe_workspace_associations <- workspaces_describe_workspace_associations

#' Retrieves a list that describes the available WorkSpace bundles
#'
#' @description
#' Retrieves a list that describes the available WorkSpace bundles.
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_describe_workspace_bundles/](https://www.paws-r-sdk.com/docs/workspaces_describe_workspace_bundles/) for full documentation.
#'
#' @param BundleIds The identifiers of the bundles. You cannot combine this parameter with any other filter.
#' @param Owner The owner of the bundles. You cannot combine this parameter with any other filter.
#' 
#' To describe the bundles provided by Amazon Web Services, specify `AMAZON`. To describe the bundles that belong to your account, don't specify a value.
#' @param NextToken The token for the next set of results. (You received this token from a previous call.)
#'
#' @keywords internal
#'
#' @rdname workspaces_describe_workspace_bundles
workspaces_describe_workspace_bundles <- function(BundleIds = NULL, Owner = NULL, NextToken = NULL) {
  op <- new_operation(
    name = "DescribeWorkspaceBundles",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(input_token = "NextToken", output_token = "NextToken", result_key = "Bundles"),
    stream_api = FALSE
  )
  input <- .workspaces$describe_workspace_bundles_input(BundleIds = BundleIds, Owner = Owner, NextToken = NextToken)
  output <- .workspaces$describe_workspace_bundles_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$describe_workspace_bundles <- workspaces_describe_workspace_bundles

#' Describes the available directories that are registered with Amazon
#' WorkSpaces
#'
#' @description
#' Describes the available directories that are registered with Amazon WorkSpaces.
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_describe_workspace_directories/](https://www.paws-r-sdk.com/docs/workspaces_describe_workspace_directories/) for full documentation.
#'
#' @param DirectoryIds The identifiers of the directories. If the value is null, all directories are retrieved.
#' @param WorkspaceDirectoryNames The names of the WorkSpace directories.
#' @param Limit The maximum number of directories to return.
#' @param NextToken If you received a `NextToken` from a previous call that was paginated, provide this token to receive the next set of results.
#' @param Filters The filter condition for the WorkSpaces.
#'
#' @keywords internal
#'
#' @rdname workspaces_describe_workspace_directories
workspaces_describe_workspace_directories <- function(DirectoryIds = NULL, WorkspaceDirectoryNames = NULL, Limit = NULL, NextToken = NULL, Filters = NULL) {
  op <- new_operation(
    name = "DescribeWorkspaceDirectories",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(input_token = "NextToken", output_token = "NextToken", result_key = "Directories"),
    stream_api = FALSE
  )
  input <- .workspaces$describe_workspace_directories_input(DirectoryIds = DirectoryIds, WorkspaceDirectoryNames = WorkspaceDirectoryNames, Limit = Limit, NextToken = NextToken, Filters = Filters)
  output <- .workspaces$describe_workspace_directories_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$describe_workspace_directories <- workspaces_describe_workspace_directories

#' Describes the permissions that the owner of an image has granted to
#' other Amazon Web Services accounts for an image
#'
#' @description
#' Describes the permissions that the owner of an image has granted to other Amazon Web Services accounts for an image.
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_describe_workspace_image_permissions/](https://www.paws-r-sdk.com/docs/workspaces_describe_workspace_image_permissions/) for full documentation.
#'
#' @param ImageId &#91;required&#93; The identifier of the image.
#' @param NextToken If you received a `NextToken` from a previous call that was paginated, provide this token to receive the next set of results.
#' @param MaxResults The maximum number of items to return.
#'
#' @keywords internal
#'
#' @rdname workspaces_describe_workspace_image_permissions
workspaces_describe_workspace_image_permissions <- function(ImageId, NextToken = NULL, MaxResults = NULL) {
  op <- new_operation(
    name = "DescribeWorkspaceImagePermissions",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$describe_workspace_image_permissions_input(ImageId = ImageId, NextToken = NextToken, MaxResults = MaxResults)
  output <- .workspaces$describe_workspace_image_permissions_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$describe_workspace_image_permissions <- workspaces_describe_workspace_image_permissions

#' Retrieves a list that describes one or more specified images, if the
#' image identifiers are provided
#'
#' @description
#' Retrieves a list that describes one or more specified images, if the image identifiers are provided. Otherwise, all images in the account are described.
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_describe_workspace_images/](https://www.paws-r-sdk.com/docs/workspaces_describe_workspace_images/) for full documentation.
#'
#' @param ImageIds The identifier of the image.
#' @param ImageType The type (owned or shared) of the image.
#' @param NextToken If you received a `NextToken` from a previous call that was paginated, provide this token to receive the next set of results.
#' @param MaxResults The maximum number of items to return.
#'
#' @keywords internal
#'
#' @rdname workspaces_describe_workspace_images
workspaces_describe_workspace_images <- function(ImageIds = NULL, ImageType = NULL, NextToken = NULL, MaxResults = NULL) {
  op <- new_operation(
    name = "DescribeWorkspaceImages",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(input_token = "NextToken", limit_key = "MaxResults", output_token = "NextToken", result_key = "Images"),
    stream_api = FALSE
  )
  input <- .workspaces$describe_workspace_images_input(ImageIds = ImageIds, ImageType = ImageType, NextToken = NextToken, MaxResults = MaxResults)
  output <- .workspaces$describe_workspace_images_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$describe_workspace_images <- workspaces_describe_workspace_images

#' Describes the snapshots for the specified WorkSpace
#'
#' @description
#' Describes the snapshots for the specified WorkSpace.
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_describe_workspace_snapshots/](https://www.paws-r-sdk.com/docs/workspaces_describe_workspace_snapshots/) for full documentation.
#'
#' @param WorkspaceId &#91;required&#93; The identifier of the WorkSpace.
#'
#' @keywords internal
#'
#' @rdname workspaces_describe_workspace_snapshots
workspaces_describe_workspace_snapshots <- function(WorkspaceId) {
  op <- new_operation(
    name = "DescribeWorkspaceSnapshots",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$describe_workspace_snapshots_input(WorkspaceId = WorkspaceId)
  output <- .workspaces$describe_workspace_snapshots_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$describe_workspace_snapshots <- workspaces_describe_workspace_snapshots

#' Describes the specified WorkSpaces
#'
#' @description
#' Describes the specified WorkSpaces.
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_describe_workspaces/](https://www.paws-r-sdk.com/docs/workspaces_describe_workspaces/) for full documentation.
#'
#' @param WorkspaceIds The identifiers of the WorkSpaces. You cannot combine this parameter with any other filter.
#' 
#' Because the [`create_workspaces`][workspaces_create_workspaces] operation is asynchronous, the identifier it returns is not immediately available. If you immediately call [`describe_workspaces`][workspaces_describe_workspaces] with this identifier, no information is returned.
#' @param DirectoryId The identifier of the directory. In addition, you can optionally specify a specific directory user (see `UserName`). You cannot combine this parameter with any other filter.
#' @param UserName The name of the directory user. You must specify this parameter with `DirectoryId`.
#' @param BundleId The identifier of the bundle. All WorkSpaces that are created from this bundle are retrieved. You cannot combine this parameter with any other filter.
#' @param Limit The maximum number of items to return.
#' @param NextToken If you received a `NextToken` from a previous call that was paginated, provide this token to receive the next set of results.
#' @param WorkspaceName The name of the user-decoupled WorkSpace.
#'
#' @keywords internal
#'
#' @rdname workspaces_describe_workspaces
workspaces_describe_workspaces <- function(WorkspaceIds = NULL, DirectoryId = NULL, UserName = NULL, BundleId = NULL, Limit = NULL, NextToken = NULL, WorkspaceName = NULL) {
  op <- new_operation(
    name = "DescribeWorkspaces",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(limit_key = "Limit", input_token = "NextToken", output_token = "NextToken", result_key = "Workspaces"),
    stream_api = FALSE
  )
  input <- .workspaces$describe_workspaces_input(WorkspaceIds = WorkspaceIds, DirectoryId = DirectoryId, UserName = UserName, BundleId = BundleId, Limit = Limit, NextToken = NextToken, WorkspaceName = WorkspaceName)
  output <- .workspaces$describe_workspaces_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$describe_workspaces <- workspaces_describe_workspaces

#' Describes the connection status of the specified WorkSpaces
#'
#' @description
#' Describes the connection status of the specified WorkSpaces.
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_describe_workspaces_connection_status/](https://www.paws-r-sdk.com/docs/workspaces_describe_workspaces_connection_status/) for full documentation.
#'
#' @param WorkspaceIds The identifiers of the WorkSpaces. You can specify up to 25 WorkSpaces.
#' @param NextToken If you received a `NextToken` from a previous call that was paginated, provide this token to receive the next set of results.
#'
#' @keywords internal
#'
#' @rdname workspaces_describe_workspaces_connection_status
workspaces_describe_workspaces_connection_status <- function(WorkspaceIds = NULL, NextToken = NULL) {
  op <- new_operation(
    name = "DescribeWorkspacesConnectionStatus",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(input_token = "NextToken", output_token = "NextToken", result_key = "WorkspacesConnectionStatus"),
    stream_api = FALSE
  )
  input <- .workspaces$describe_workspaces_connection_status_input(WorkspaceIds = WorkspaceIds, NextToken = NextToken)
  output <- .workspaces$describe_workspaces_connection_status_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$describe_workspaces_connection_status <- workspaces_describe_workspaces_connection_status

#' Retrieves a list that describes the streaming sessions for a specified
#' pool
#'
#' @description
#' Retrieves a list that describes the streaming sessions for a specified pool.
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_describe_workspaces_pool_sessions/](https://www.paws-r-sdk.com/docs/workspaces_describe_workspaces_pool_sessions/) for full documentation.
#'
#' @param PoolId &#91;required&#93; The identifier of the pool.
#' @param UserId The identifier of the user.
#' @param Limit The maximum size of each page of results. The default value is 20 and the maximum value is 50.
#' @param NextToken If you received a `NextToken` from a previous call that was paginated, provide this token to receive the next set of results.
#'
#' @keywords internal
#'
#' @rdname workspaces_describe_workspaces_pool_sessions
workspaces_describe_workspaces_pool_sessions <- function(PoolId, UserId = NULL, Limit = NULL, NextToken = NULL) {
  op <- new_operation(
    name = "DescribeWorkspacesPoolSessions",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$describe_workspaces_pool_sessions_input(PoolId = PoolId, UserId = UserId, Limit = Limit, NextToken = NextToken)
  output <- .workspaces$describe_workspaces_pool_sessions_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$describe_workspaces_pool_sessions <- workspaces_describe_workspaces_pool_sessions

#' Describes the specified WorkSpaces Pools
#'
#' @description
#' Describes the specified WorkSpaces Pools.
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_describe_workspaces_pools/](https://www.paws-r-sdk.com/docs/workspaces_describe_workspaces_pools/) for full documentation.
#'
#' @param PoolIds The identifier of the WorkSpaces Pools.
#' @param Filters The filter conditions for the WorkSpaces Pool to return.
#' @param Limit The maximum number of items to return.
#' @param NextToken If you received a `NextToken` from a previous call that was paginated, provide this token to receive the next set of results.
#'
#' @keywords internal
#'
#' @rdname workspaces_describe_workspaces_pools
workspaces_describe_workspaces_pools <- function(PoolIds = NULL, Filters = NULL, Limit = NULL, NextToken = NULL) {
  op <- new_operation(
    name = "DescribeWorkspacesPools",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$describe_workspaces_pools_input(PoolIds = PoolIds, Filters = Filters, Limit = Limit, NextToken = NextToken)
  output <- .workspaces$describe_workspaces_pools_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$describe_workspaces_pools <- workspaces_describe_workspaces_pools

#' Disassociates a connection alias from a directory
#'
#' @description
#' Disassociates a connection alias from a directory. Disassociating a connection alias disables cross-Region redirection between two directories in different Regions. For more information, see [Cross-Region Redirection for Amazon WorkSpaces](https://docs.aws.amazon.com/workspaces/latest/adminguide/cross-region-redirection.html).
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_disassociate_connection_alias/](https://www.paws-r-sdk.com/docs/workspaces_disassociate_connection_alias/) for full documentation.
#'
#' @param AliasId &#91;required&#93; The identifier of the connection alias to disassociate.
#'
#' @keywords internal
#'
#' @rdname workspaces_disassociate_connection_alias
workspaces_disassociate_connection_alias <- function(AliasId) {
  op <- new_operation(
    name = "DisassociateConnectionAlias",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$disassociate_connection_alias_input(AliasId = AliasId)
  output <- .workspaces$disassociate_connection_alias_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$disassociate_connection_alias <- workspaces_disassociate_connection_alias

#' Disassociates the specified IP access control group from the specified
#' directory
#'
#' @description
#' Disassociates the specified IP access control group from the specified directory.
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_disassociate_ip_groups/](https://www.paws-r-sdk.com/docs/workspaces_disassociate_ip_groups/) for full documentation.
#'
#' @param DirectoryId &#91;required&#93; The identifier of the directory.
#' @param GroupIds &#91;required&#93; The identifiers of one or more IP access control groups.
#'
#' @keywords internal
#'
#' @rdname workspaces_disassociate_ip_groups
workspaces_disassociate_ip_groups <- function(DirectoryId, GroupIds) {
  op <- new_operation(
    name = "DisassociateIpGroups",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$disassociate_ip_groups_input(DirectoryId = DirectoryId, GroupIds = GroupIds)
  output <- .workspaces$disassociate_ip_groups_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$disassociate_ip_groups <- workspaces_disassociate_ip_groups

#' Disassociates the specified application from a WorkSpace
#'
#' @description
#' Disassociates the specified application from a WorkSpace.
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_disassociate_workspace_application/](https://www.paws-r-sdk.com/docs/workspaces_disassociate_workspace_application/) for full documentation.
#'
#' @param WorkspaceId &#91;required&#93; The identifier of the WorkSpace.
#' @param ApplicationId &#91;required&#93; The identifier of the application.
#'
#' @keywords internal
#'
#' @rdname workspaces_disassociate_workspace_application
workspaces_disassociate_workspace_application <- function(WorkspaceId, ApplicationId) {
  op <- new_operation(
    name = "DisassociateWorkspaceApplication",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$disassociate_workspace_application_input(WorkspaceId = WorkspaceId, ApplicationId = ApplicationId)
  output <- .workspaces$disassociate_workspace_application_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$disassociate_workspace_application <- workspaces_disassociate_workspace_application

#' Retrieves account link information
#'
#' @description
#' Retrieves account link information.
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_get_account_link/](https://www.paws-r-sdk.com/docs/workspaces_get_account_link/) for full documentation.
#'
#' @param LinkId The identifier of the account to link.
#' @param LinkedAccountId The identifier of the account link
#'
#' @keywords internal
#'
#' @rdname workspaces_get_account_link
workspaces_get_account_link <- function(LinkId = NULL, LinkedAccountId = NULL) {
  op <- new_operation(
    name = "GetAccountLink",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$get_account_link_input(LinkId = LinkId, LinkedAccountId = LinkedAccountId)
  output <- .workspaces$get_account_link_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$get_account_link <- workspaces_get_account_link

#' Imports client branding
#'
#' @description
#' Imports client branding. Client branding allows you to customize your WorkSpace's client login portal. You can tailor your login portal company logo, the support email address, support link, link to reset password, and a custom message for users trying to sign in.
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_import_client_branding/](https://www.paws-r-sdk.com/docs/workspaces_import_client_branding/) for full documentation.
#'
#' @param ResourceId &#91;required&#93; The directory identifier of the WorkSpace for which you want to import client branding.
#' @param DeviceTypeWindows The branding information to import for Windows devices.
#' @param DeviceTypeOsx The branding information to import for macOS devices.
#' @param DeviceTypeAndroid The branding information to import for Android devices.
#' @param DeviceTypeIos The branding information to import for iOS devices.
#' @param DeviceTypeLinux The branding information to import for Linux devices.
#' @param DeviceTypeWeb The branding information to import for web access.
#'
#' @keywords internal
#'
#' @rdname workspaces_import_client_branding
workspaces_import_client_branding <- function(ResourceId, DeviceTypeWindows = NULL, DeviceTypeOsx = NULL, DeviceTypeAndroid = NULL, DeviceTypeIos = NULL, DeviceTypeLinux = NULL, DeviceTypeWeb = NULL) {
  op <- new_operation(
    name = "ImportClientBranding",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$import_client_branding_input(ResourceId = ResourceId, DeviceTypeWindows = DeviceTypeWindows, DeviceTypeOsx = DeviceTypeOsx, DeviceTypeAndroid = DeviceTypeAndroid, DeviceTypeIos = DeviceTypeIos, DeviceTypeLinux = DeviceTypeLinux, DeviceTypeWeb = DeviceTypeWeb)
  output <- .workspaces$import_client_branding_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$import_client_branding <- workspaces_import_client_branding

#' Imports the specified Windows 10 or 11 Bring Your Own License (BYOL)
#' image into Amazon WorkSpaces using EC2 Image Builder
#'
#' @description
#' Imports the specified Windows 10 or 11 Bring Your Own License (BYOL) image into Amazon WorkSpaces using EC2 Image Builder. The image must be an already licensed image that is in your Amazon Web Services account, and you must own the image. For more information about creating BYOL images, see [Bring Your Own Windows Desktop Licenses](https://docs.aws.amazon.com/workspaces/latest/adminguide/byol-windows-images.html).
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_import_custom_workspace_image/](https://www.paws-r-sdk.com/docs/workspaces_import_custom_workspace_image/) for full documentation.
#'
#' @param ImageName &#91;required&#93; The name of the WorkSpace image.
#' @param ImageDescription &#91;required&#93; The description of the WorkSpace image.
#' @param ComputeType &#91;required&#93; The supported compute type for the WorkSpace image.
#' @param Protocol &#91;required&#93; The supported protocol for the WorkSpace image. Windows 11 does not support PCOIP protocol.
#' @param ImageSource &#91;required&#93; The options for image import source.
#' @param InfrastructureConfigurationArn &#91;required&#93; The infrastructure configuration ARN that specifies how the WorkSpace image is built.
#' @param Platform &#91;required&#93; The platform for the WorkSpace image source.
#' @param OsVersion &#91;required&#93; The OS version for the WorkSpace image source.
#' @param Tags The resource tags. Each WorkSpaces resource can have a maximum of 50 tags.
#'
#' @keywords internal
#'
#' @rdname workspaces_import_custom_workspace_image
workspaces_import_custom_workspace_image <- function(ImageName, ImageDescription, ComputeType, Protocol, ImageSource, InfrastructureConfigurationArn, Platform, OsVersion, Tags = NULL) {
  op <- new_operation(
    name = "ImportCustomWorkspaceImage",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$import_custom_workspace_image_input(ImageName = ImageName, ImageDescription = ImageDescription, ComputeType = ComputeType, Protocol = Protocol, ImageSource = ImageSource, InfrastructureConfigurationArn = InfrastructureConfigurationArn, Platform = Platform, OsVersion = OsVersion, Tags = Tags)
  output <- .workspaces$import_custom_workspace_image_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$import_custom_workspace_image <- workspaces_import_custom_workspace_image

#' Imports the specified Windows 10 or 11 Bring Your Own License (BYOL)
#' image into Amazon WorkSpaces
#'
#' @description
#' Imports the specified Windows 10 or 11 Bring Your Own License (BYOL) image into Amazon WorkSpaces. The image must be an already licensed Amazon EC2 image that is in your Amazon Web Services account, and you must own the image. For more information about creating BYOL images, see [Bring Your Own Windows Desktop Licenses](https://docs.aws.amazon.com/workspaces/latest/adminguide/byol-windows-images.html).
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_import_workspace_image/](https://www.paws-r-sdk.com/docs/workspaces_import_workspace_image/) for full documentation.
#'
#' @param Ec2ImageId &#91;required&#93; The identifier of the EC2 image.
#' @param IngestionProcess &#91;required&#93; The ingestion process to be used when importing the image, depending on which protocol you want to use for your BYOL Workspace image, either PCoIP, WSP, or bring your own protocol (BYOP). To use DCV, specify a value that ends in `_WSP`. To use PCoIP, specify a value that does not end in `_WSP`. To use BYOP, specify a value that ends in `_BYOP`.
#' 
#' For non-GPU-enabled bundles (bundles other than Graphics or GraphicsPro), specify `BYOL_REGULAR`, `BYOL_REGULAR_WSP`, or `BYOL_REGULAR_BYOP`, depending on the protocol.
#' 
#' The `BYOL_REGULAR_BYOP` and `BYOL_GRAPHICS_G4DN_BYOP` values are only supported by Amazon WorkSpaces Core. Contact your account team to be allow-listed to use these values. For more information, see [Amazon WorkSpaces Core](https://aws.amazon.com/workspaces/vdi-partners/).
#' @param ImageName &#91;required&#93; The name of the WorkSpace image.
#' @param ImageDescription &#91;required&#93; The description of the WorkSpace image.
#' @param Tags The tags. Each WorkSpaces resource can have a maximum of 50 tags.
#' @param Applications If specified, the version of Microsoft Office to subscribe to. Valid only for Windows 10 and 11 BYOL images. For more information about subscribing to Office for BYOL images, see [Bring Your Own Windows Desktop Licenses](https://docs.aws.amazon.com/workspaces/latest/adminguide/byol-windows-images.html).
#' 
#' -   Although this parameter is an array, only one item is allowed at this time.
#' 
#' -   During the image import process, non-GPU DCV (formerly WSP) WorkSpaces with Windows 11 support only `Microsoft_Office_2019`. GPU DCV (formerly WSP) WorkSpaces with Windows 11 do not support Office installation.
#'
#' @keywords internal
#'
#' @rdname workspaces_import_workspace_image
workspaces_import_workspace_image <- function(Ec2ImageId, IngestionProcess, ImageName, ImageDescription, Tags = NULL, Applications = NULL) {
  op <- new_operation(
    name = "ImportWorkspaceImage",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$import_workspace_image_input(Ec2ImageId = Ec2ImageId, IngestionProcess = IngestionProcess, ImageName = ImageName, ImageDescription = ImageDescription, Tags = Tags, Applications = Applications)
  output <- .workspaces$import_workspace_image_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$import_workspace_image <- workspaces_import_workspace_image

#' Lists all account links
#'
#' @description
#' Lists all account links.
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_list_account_links/](https://www.paws-r-sdk.com/docs/workspaces_list_account_links/) for full documentation.
#'
#' @param LinkStatusFilter Filters the account based on their link status.
#' @param NextToken The token to use to retrieve the next page of results. This value is null when there are no more results to return.
#' @param MaxResults The maximum number of accounts to return.
#'
#' @keywords internal
#'
#' @rdname workspaces_list_account_links
workspaces_list_account_links <- function(LinkStatusFilter = NULL, NextToken = NULL, MaxResults = NULL) {
  op <- new_operation(
    name = "ListAccountLinks",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(input_token = "NextToken", limit_key = "MaxResults", output_token = "NextToken", result_key = "AccountLinks"),
    stream_api = FALSE
  )
  input <- .workspaces$list_account_links_input(LinkStatusFilter = LinkStatusFilter, NextToken = NextToken, MaxResults = MaxResults)
  output <- .workspaces$list_account_links_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$list_account_links <- workspaces_list_account_links

#' Retrieves a list of IP address ranges, specified as IPv4 CIDR blocks,
#' that you can use for the network management interface when you enable
#' Bring Your Own License (BYOL)
#'
#' @description
#' Retrieves a list of IP address ranges, specified as IPv4 CIDR blocks, that you can use for the network management interface when you enable Bring Your Own License (BYOL).
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_list_available_management_cidr_ranges/](https://www.paws-r-sdk.com/docs/workspaces_list_available_management_cidr_ranges/) for full documentation.
#'
#' @param ManagementCidrRangeConstraint &#91;required&#93; The IP address range to search. Specify an IP address range that is compatible with your network and in CIDR notation (that is, specify the range as an IPv4 CIDR block).
#' @param MaxResults The maximum number of items to return.
#' @param NextToken If you received a `NextToken` from a previous call that was paginated, provide this token to receive the next set of results.
#'
#' @keywords internal
#'
#' @rdname workspaces_list_available_management_cidr_ranges
workspaces_list_available_management_cidr_ranges <- function(ManagementCidrRangeConstraint, MaxResults = NULL, NextToken = NULL) {
  op <- new_operation(
    name = "ListAvailableManagementCidrRanges",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(input_token = "NextToken", limit_key = "MaxResults", output_token = "NextToken", result_key = "ManagementCidrRanges"),
    stream_api = FALSE
  )
  input <- .workspaces$list_available_management_cidr_ranges_input(ManagementCidrRangeConstraint = ManagementCidrRangeConstraint, MaxResults = MaxResults, NextToken = NextToken)
  output <- .workspaces$list_available_management_cidr_ranges_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$list_available_management_cidr_ranges <- workspaces_list_available_management_cidr_ranges

#' Migrates a WorkSpace from one operating system or bundle type to
#' another, while retaining the data on the user volume
#'
#' @description
#' Migrates a WorkSpace from one operating system or bundle type to another, while retaining the data on the user volume.
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_migrate_workspace/](https://www.paws-r-sdk.com/docs/workspaces_migrate_workspace/) for full documentation.
#'
#' @param SourceWorkspaceId &#91;required&#93; The identifier of the WorkSpace to migrate from.
#' @param BundleId &#91;required&#93; The identifier of the target bundle type to migrate the WorkSpace to.
#'
#' @keywords internal
#'
#' @rdname workspaces_migrate_workspace
workspaces_migrate_workspace <- function(SourceWorkspaceId, BundleId) {
  op <- new_operation(
    name = "MigrateWorkspace",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$migrate_workspace_input(SourceWorkspaceId = SourceWorkspaceId, BundleId = BundleId)
  output <- .workspaces$migrate_workspace_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$migrate_workspace <- workspaces_migrate_workspace

#' Modifies the configuration of Bring Your Own License (BYOL) for the
#' specified account
#'
#' @description
#' Modifies the configuration of Bring Your Own License (BYOL) for the specified account.
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_modify_account/](https://www.paws-r-sdk.com/docs/workspaces_modify_account/) for full documentation.
#'
#' @param DedicatedTenancySupport The status of BYOL.
#' @param DedicatedTenancyManagementCidrRange The IP address range, specified as an IPv4 CIDR block, for the management network interface. Specify an IP address range that is compatible with your network and in CIDR notation (that is, specify the range as an IPv4 CIDR block). The CIDR block size must be /16 (for example, 203.0.113.25/16). It must also be specified as available by the [`list_available_management_cidr_ranges`][workspaces_list_available_management_cidr_ranges] operation.
#'
#' @keywords internal
#'
#' @rdname workspaces_modify_account
workspaces_modify_account <- function(DedicatedTenancySupport = NULL, DedicatedTenancyManagementCidrRange = NULL) {
  op <- new_operation(
    name = "ModifyAccount",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$modify_account_input(DedicatedTenancySupport = DedicatedTenancySupport, DedicatedTenancyManagementCidrRange = DedicatedTenancyManagementCidrRange)
  output <- .workspaces$modify_account_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$modify_account <- workspaces_modify_account

#' Modifies the properties of the certificate-based authentication you want
#' to use with your WorkSpaces
#'
#' @description
#' Modifies the properties of the certificate-based authentication you want to use with your WorkSpaces.
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_modify_certificate_based_auth_properties/](https://www.paws-r-sdk.com/docs/workspaces_modify_certificate_based_auth_properties/) for full documentation.
#'
#' @param ResourceId &#91;required&#93; The resource identifiers, in the form of directory IDs.
#' @param CertificateBasedAuthProperties The properties of the certificate-based authentication.
#' @param PropertiesToDelete The properties of the certificate-based authentication you want to delete.
#'
#' @keywords internal
#'
#' @rdname workspaces_modify_certificate_based_auth_properties
workspaces_modify_certificate_based_auth_properties <- function(ResourceId, CertificateBasedAuthProperties = NULL, PropertiesToDelete = NULL) {
  op <- new_operation(
    name = "ModifyCertificateBasedAuthProperties",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$modify_certificate_based_auth_properties_input(ResourceId = ResourceId, CertificateBasedAuthProperties = CertificateBasedAuthProperties, PropertiesToDelete = PropertiesToDelete)
  output <- .workspaces$modify_certificate_based_auth_properties_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$modify_certificate_based_auth_properties <- workspaces_modify_certificate_based_auth_properties

#' Modifies the properties of the specified Amazon WorkSpaces clients
#'
#' @description
#' Modifies the properties of the specified Amazon WorkSpaces clients.
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_modify_client_properties/](https://www.paws-r-sdk.com/docs/workspaces_modify_client_properties/) for full documentation.
#'
#' @param ResourceId &#91;required&#93; The resource identifiers, in the form of directory IDs.
#' @param ClientProperties &#91;required&#93; Information about the Amazon WorkSpaces client.
#'
#' @keywords internal
#'
#' @rdname workspaces_modify_client_properties
workspaces_modify_client_properties <- function(ResourceId, ClientProperties) {
  op <- new_operation(
    name = "ModifyClientProperties",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$modify_client_properties_input(ResourceId = ResourceId, ClientProperties = ClientProperties)
  output <- .workspaces$modify_client_properties_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$modify_client_properties <- workspaces_modify_client_properties

#' Modifies the endpoint encryption mode that allows you to configure the
#' specified directory between Standard TLS and FIPS 140-2 validated mode
#'
#' @description
#' Modifies the endpoint encryption mode that allows you to configure the specified directory between Standard TLS and FIPS 140-2 validated mode.
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_modify_endpoint_encryption_mode/](https://www.paws-r-sdk.com/docs/workspaces_modify_endpoint_encryption_mode/) for full documentation.
#'
#' @param DirectoryId &#91;required&#93; The identifier of the directory.
#' @param EndpointEncryptionMode &#91;required&#93; The encryption mode used for endpoint connections when streaming to WorkSpaces Personal or WorkSpace Pools.
#'
#' @keywords internal
#'
#' @rdname workspaces_modify_endpoint_encryption_mode
workspaces_modify_endpoint_encryption_mode <- function(DirectoryId, EndpointEncryptionMode) {
  op <- new_operation(
    name = "ModifyEndpointEncryptionMode",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$modify_endpoint_encryption_mode_input(DirectoryId = DirectoryId, EndpointEncryptionMode = EndpointEncryptionMode)
  output <- .workspaces$modify_endpoint_encryption_mode_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$modify_endpoint_encryption_mode <- workspaces_modify_endpoint_encryption_mode

#' Modifies multiple properties related to SAML 2
#'
#' @description
#' Modifies multiple properties related to SAML 2.0 authentication, including the enablement status, user access URL, and relay state parameter name that are used for configuring federation with an SAML 2.0 identity provider.
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_modify_saml_properties/](https://www.paws-r-sdk.com/docs/workspaces_modify_saml_properties/) for full documentation.
#'
#' @param ResourceId &#91;required&#93; The directory identifier for which you want to configure SAML properties.
#' @param SamlProperties The properties for configuring SAML 2.0 authentication.
#' @param PropertiesToDelete The SAML properties to delete as part of your request.
#' 
#' Specify one of the following options:
#' 
#' -   `SAML_PROPERTIES_USER_ACCESS_URL` to delete the user access URL.
#' 
#' -   `SAML_PROPERTIES_RELAY_STATE_PARAMETER_NAME` to delete the relay state parameter name.
#'
#' @keywords internal
#'
#' @rdname workspaces_modify_saml_properties
workspaces_modify_saml_properties <- function(ResourceId, SamlProperties = NULL, PropertiesToDelete = NULL) {
  op <- new_operation(
    name = "ModifySamlProperties",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$modify_saml_properties_input(ResourceId = ResourceId, SamlProperties = SamlProperties, PropertiesToDelete = PropertiesToDelete)
  output <- .workspaces$modify_saml_properties_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$modify_saml_properties <- workspaces_modify_saml_properties

#' Modifies the self-service WorkSpace management capabilities for your
#' users
#'
#' @description
#' Modifies the self-service WorkSpace management capabilities for your users. For more information, see [Enable Self-Service WorkSpace Management Capabilities for Your Users](https://docs.aws.amazon.com/workspaces/latest/adminguide/enable-user-self-service-workspace-management.html).
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_modify_selfservice_permissions/](https://www.paws-r-sdk.com/docs/workspaces_modify_selfservice_permissions/) for full documentation.
#'
#' @param ResourceId &#91;required&#93; The identifier of the directory.
#' @param SelfservicePermissions &#91;required&#93; The permissions to enable or disable self-service capabilities.
#'
#' @keywords internal
#'
#' @rdname workspaces_modify_selfservice_permissions
workspaces_modify_selfservice_permissions <- function(ResourceId, SelfservicePermissions) {
  op <- new_operation(
    name = "ModifySelfservicePermissions",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$modify_selfservice_permissions_input(ResourceId = ResourceId, SelfservicePermissions = SelfservicePermissions)
  output <- .workspaces$modify_selfservice_permissions_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$modify_selfservice_permissions <- workspaces_modify_selfservice_permissions

#' Modifies the specified streaming properties
#'
#' @description
#' Modifies the specified streaming properties.
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_modify_streaming_properties/](https://www.paws-r-sdk.com/docs/workspaces_modify_streaming_properties/) for full documentation.
#'
#' @param ResourceId &#91;required&#93; The identifier of the resource.
#' @param StreamingProperties The streaming properties to configure.
#'
#' @keywords internal
#'
#' @rdname workspaces_modify_streaming_properties
workspaces_modify_streaming_properties <- function(ResourceId, StreamingProperties = NULL) {
  op <- new_operation(
    name = "ModifyStreamingProperties",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$modify_streaming_properties_input(ResourceId = ResourceId, StreamingProperties = StreamingProperties)
  output <- .workspaces$modify_streaming_properties_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$modify_streaming_properties <- workspaces_modify_streaming_properties

#' Specifies which devices and operating systems users can use to access
#' their WorkSpaces
#'
#' @description
#' Specifies which devices and operating systems users can use to access their WorkSpaces. For more information, see [Control Device Access](https://docs.aws.amazon.com/workspaces/latest/adminguide/#control-device-access).
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_modify_workspace_access_properties/](https://www.paws-r-sdk.com/docs/workspaces_modify_workspace_access_properties/) for full documentation.
#'
#' @param ResourceId &#91;required&#93; The identifier of the directory.
#' @param WorkspaceAccessProperties &#91;required&#93; The device types and operating systems to enable or disable for access.
#'
#' @keywords internal
#'
#' @rdname workspaces_modify_workspace_access_properties
workspaces_modify_workspace_access_properties <- function(ResourceId, WorkspaceAccessProperties) {
  op <- new_operation(
    name = "ModifyWorkspaceAccessProperties",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$modify_workspace_access_properties_input(ResourceId = ResourceId, WorkspaceAccessProperties = WorkspaceAccessProperties)
  output <- .workspaces$modify_workspace_access_properties_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$modify_workspace_access_properties <- workspaces_modify_workspace_access_properties

#' Modify the default properties used to create WorkSpaces
#'
#' @description
#' Modify the default properties used to create WorkSpaces.
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_modify_workspace_creation_properties/](https://www.paws-r-sdk.com/docs/workspaces_modify_workspace_creation_properties/) for full documentation.
#'
#' @param ResourceId &#91;required&#93; The identifier of the directory.
#' @param WorkspaceCreationProperties &#91;required&#93; The default properties for creating WorkSpaces.
#'
#' @keywords internal
#'
#' @rdname workspaces_modify_workspace_creation_properties
workspaces_modify_workspace_creation_properties <- function(ResourceId, WorkspaceCreationProperties) {
  op <- new_operation(
    name = "ModifyWorkspaceCreationProperties",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$modify_workspace_creation_properties_input(ResourceId = ResourceId, WorkspaceCreationProperties = WorkspaceCreationProperties)
  output <- .workspaces$modify_workspace_creation_properties_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$modify_workspace_creation_properties <- workspaces_modify_workspace_creation_properties

#' Modifies the specified WorkSpace properties
#'
#' @description
#' Modifies the specified WorkSpace properties. For important information about how to modify the size of the root and user volumes, see [Modify a WorkSpace](https://docs.aws.amazon.com/workspaces/latest/adminguide/modify-workspaces.html).
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_modify_workspace_properties/](https://www.paws-r-sdk.com/docs/workspaces_modify_workspace_properties/) for full documentation.
#'
#' @param WorkspaceId &#91;required&#93; The identifier of the WorkSpace.
#' @param WorkspaceProperties The properties of the WorkSpace.
#' @param DataReplication Indicates the data replication status.
#'
#' @keywords internal
#'
#' @rdname workspaces_modify_workspace_properties
workspaces_modify_workspace_properties <- function(WorkspaceId, WorkspaceProperties = NULL, DataReplication = NULL) {
  op <- new_operation(
    name = "ModifyWorkspaceProperties",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$modify_workspace_properties_input(WorkspaceId = WorkspaceId, WorkspaceProperties = WorkspaceProperties, DataReplication = DataReplication)
  output <- .workspaces$modify_workspace_properties_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$modify_workspace_properties <- workspaces_modify_workspace_properties

#' Sets the state of the specified WorkSpace
#'
#' @description
#' Sets the state of the specified WorkSpace.
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_modify_workspace_state/](https://www.paws-r-sdk.com/docs/workspaces_modify_workspace_state/) for full documentation.
#'
#' @param WorkspaceId &#91;required&#93; The identifier of the WorkSpace.
#' @param WorkspaceState &#91;required&#93; The WorkSpace state.
#'
#' @keywords internal
#'
#' @rdname workspaces_modify_workspace_state
workspaces_modify_workspace_state <- function(WorkspaceId, WorkspaceState) {
  op <- new_operation(
    name = "ModifyWorkspaceState",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$modify_workspace_state_input(WorkspaceId = WorkspaceId, WorkspaceState = WorkspaceState)
  output <- .workspaces$modify_workspace_state_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$modify_workspace_state <- workspaces_modify_workspace_state

#' Reboots the specified WorkSpaces
#'
#' @description
#' Reboots the specified WorkSpaces.
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_reboot_workspaces/](https://www.paws-r-sdk.com/docs/workspaces_reboot_workspaces/) for full documentation.
#'
#' @param RebootWorkspaceRequests &#91;required&#93; The WorkSpaces to reboot. You can specify up to 25 WorkSpaces.
#'
#' @keywords internal
#'
#' @rdname workspaces_reboot_workspaces
workspaces_reboot_workspaces <- function(RebootWorkspaceRequests) {
  op <- new_operation(
    name = "RebootWorkspaces",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$reboot_workspaces_input(RebootWorkspaceRequests = RebootWorkspaceRequests)
  output <- .workspaces$reboot_workspaces_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$reboot_workspaces <- workspaces_reboot_workspaces

#' Rebuilds the specified WorkSpace
#'
#' @description
#' Rebuilds the specified WorkSpace.
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_rebuild_workspaces/](https://www.paws-r-sdk.com/docs/workspaces_rebuild_workspaces/) for full documentation.
#'
#' @param RebuildWorkspaceRequests &#91;required&#93; The WorkSpace to rebuild. You can specify a single WorkSpace.
#'
#' @keywords internal
#'
#' @rdname workspaces_rebuild_workspaces
workspaces_rebuild_workspaces <- function(RebuildWorkspaceRequests) {
  op <- new_operation(
    name = "RebuildWorkspaces",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$rebuild_workspaces_input(RebuildWorkspaceRequests = RebuildWorkspaceRequests)
  output <- .workspaces$rebuild_workspaces_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$rebuild_workspaces <- workspaces_rebuild_workspaces

#' Registers the specified directory
#'
#' @description
#' Registers the specified directory. This operation is asynchronous and returns before the WorkSpace directory is registered. If this is the first time you are registering a directory, you will need to create the workspaces_DefaultRole role before you can register a directory. For more information, see [Creating the workspaces_DefaultRole Role](https://docs.aws.amazon.com/workspaces/latest/adminguide/workspaces-access-control.html#create-default-role).
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_register_workspace_directory/](https://www.paws-r-sdk.com/docs/workspaces_register_workspace_directory/) for full documentation.
#'
#' @param DirectoryId The identifier of the directory. You cannot register a directory if it does not have a status of Active. If the directory does not have a status of Active, you will receive an InvalidResourceStateException error. If you have already registered the maximum number of directories that you can register with Amazon WorkSpaces, you will receive a ResourceLimitExceededException error. Deregister directories that you are not using for WorkSpaces, and try again.
#' @param SubnetIds The identifiers of the subnets for your virtual private cloud (VPC). Make sure that the subnets are in supported Availability Zones. The subnets must also be in separate Availability Zones. If these conditions are not met, you will receive an OperationNotSupportedException error.
#' @param EnableSelfService Indicates whether self-service capabilities are enabled or disabled.
#' @param Tenancy Indicates whether your WorkSpace directory is dedicated or shared. To use Bring Your Own License (BYOL) images, this value must be set to `DEDICATED` and your Amazon Web Services account must be enabled for BYOL. If your account has not been enabled for BYOL, you will receive an InvalidParameterValuesException error. For more information about BYOL images, see [Bring Your Own Windows Desktop Images](https://docs.aws.amazon.com/workspaces/latest/adminguide/byol-windows-images.html).
#' @param Tags The tags associated with the directory.
#' @param WorkspaceDirectoryName The name of the directory to register.
#' @param WorkspaceDirectoryDescription Description of the directory to register.
#' @param UserIdentityType The type of identity management the user is using.
#' @param IdcInstanceArn The Amazon Resource Name (ARN) of the identity center instance.
#' @param MicrosoftEntraConfig The details about Microsoft Entra config.
#' @param WorkspaceType Indicates whether the directory's WorkSpace type is personal or pools.
#' @param ActiveDirectoryConfig The active directory config of the directory.
#'
#' @keywords internal
#'
#' @rdname workspaces_register_workspace_directory
workspaces_register_workspace_directory <- function(DirectoryId = NULL, SubnetIds = NULL, EnableSelfService = NULL, Tenancy = NULL, Tags = NULL, WorkspaceDirectoryName = NULL, WorkspaceDirectoryDescription = NULL, UserIdentityType = NULL, IdcInstanceArn = NULL, MicrosoftEntraConfig = NULL, WorkspaceType = NULL, ActiveDirectoryConfig = NULL) {
  op <- new_operation(
    name = "RegisterWorkspaceDirectory",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$register_workspace_directory_input(DirectoryId = DirectoryId, SubnetIds = SubnetIds, EnableSelfService = EnableSelfService, Tenancy = Tenancy, Tags = Tags, WorkspaceDirectoryName = WorkspaceDirectoryName, WorkspaceDirectoryDescription = WorkspaceDirectoryDescription, UserIdentityType = UserIdentityType, IdcInstanceArn = IdcInstanceArn, MicrosoftEntraConfig = MicrosoftEntraConfig, WorkspaceType = WorkspaceType, ActiveDirectoryConfig = ActiveDirectoryConfig)
  output <- .workspaces$register_workspace_directory_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$register_workspace_directory <- workspaces_register_workspace_directory

#' Rejects the account link invitation
#'
#' @description
#' Rejects the account link invitation.
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_reject_account_link_invitation/](https://www.paws-r-sdk.com/docs/workspaces_reject_account_link_invitation/) for full documentation.
#'
#' @param LinkId &#91;required&#93; The identifier of the account link
#' @param ClientToken The client token of the account link invitation to reject.
#'
#' @keywords internal
#'
#' @rdname workspaces_reject_account_link_invitation
workspaces_reject_account_link_invitation <- function(LinkId, ClientToken = NULL) {
  op <- new_operation(
    name = "RejectAccountLinkInvitation",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$reject_account_link_invitation_input(LinkId = LinkId, ClientToken = ClientToken)
  output <- .workspaces$reject_account_link_invitation_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$reject_account_link_invitation <- workspaces_reject_account_link_invitation

#' Restores the specified WorkSpace to its last known healthy state
#'
#' @description
#' Restores the specified WorkSpace to its last known healthy state.
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_restore_workspace/](https://www.paws-r-sdk.com/docs/workspaces_restore_workspace/) for full documentation.
#'
#' @param WorkspaceId &#91;required&#93; The identifier of the WorkSpace.
#'
#' @keywords internal
#'
#' @rdname workspaces_restore_workspace
workspaces_restore_workspace <- function(WorkspaceId) {
  op <- new_operation(
    name = "RestoreWorkspace",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$restore_workspace_input(WorkspaceId = WorkspaceId)
  output <- .workspaces$restore_workspace_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$restore_workspace <- workspaces_restore_workspace

#' Removes one or more rules from the specified IP access control group
#'
#' @description
#' Removes one or more rules from the specified IP access control group.
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_revoke_ip_rules/](https://www.paws-r-sdk.com/docs/workspaces_revoke_ip_rules/) for full documentation.
#'
#' @param GroupId &#91;required&#93; The identifier of the group.
#' @param UserRules &#91;required&#93; The rules to remove from the group.
#'
#' @keywords internal
#'
#' @rdname workspaces_revoke_ip_rules
workspaces_revoke_ip_rules <- function(GroupId, UserRules) {
  op <- new_operation(
    name = "RevokeIpRules",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$revoke_ip_rules_input(GroupId = GroupId, UserRules = UserRules)
  output <- .workspaces$revoke_ip_rules_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$revoke_ip_rules <- workspaces_revoke_ip_rules

#' Starts the specified WorkSpaces
#'
#' @description
#' Starts the specified WorkSpaces.
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_start_workspaces/](https://www.paws-r-sdk.com/docs/workspaces_start_workspaces/) for full documentation.
#'
#' @param StartWorkspaceRequests &#91;required&#93; The WorkSpaces to start. You can specify up to 25 WorkSpaces.
#'
#' @keywords internal
#'
#' @rdname workspaces_start_workspaces
workspaces_start_workspaces <- function(StartWorkspaceRequests) {
  op <- new_operation(
    name = "StartWorkspaces",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$start_workspaces_input(StartWorkspaceRequests = StartWorkspaceRequests)
  output <- .workspaces$start_workspaces_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$start_workspaces <- workspaces_start_workspaces

#' Starts the specified pool
#'
#' @description
#' Starts the specified pool.
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_start_workspaces_pool/](https://www.paws-r-sdk.com/docs/workspaces_start_workspaces_pool/) for full documentation.
#'
#' @param PoolId &#91;required&#93; The identifier of the pool.
#'
#' @keywords internal
#'
#' @rdname workspaces_start_workspaces_pool
workspaces_start_workspaces_pool <- function(PoolId) {
  op <- new_operation(
    name = "StartWorkspacesPool",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$start_workspaces_pool_input(PoolId = PoolId)
  output <- .workspaces$start_workspaces_pool_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$start_workspaces_pool <- workspaces_start_workspaces_pool

#' Stops the specified WorkSpaces
#'
#' @description
#' Stops the specified WorkSpaces.
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_stop_workspaces/](https://www.paws-r-sdk.com/docs/workspaces_stop_workspaces/) for full documentation.
#'
#' @param StopWorkspaceRequests &#91;required&#93; The WorkSpaces to stop. You can specify up to 25 WorkSpaces.
#'
#' @keywords internal
#'
#' @rdname workspaces_stop_workspaces
workspaces_stop_workspaces <- function(StopWorkspaceRequests) {
  op <- new_operation(
    name = "StopWorkspaces",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$stop_workspaces_input(StopWorkspaceRequests = StopWorkspaceRequests)
  output <- .workspaces$stop_workspaces_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$stop_workspaces <- workspaces_stop_workspaces

#' Stops the specified pool
#'
#' @description
#' Stops the specified pool.
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_stop_workspaces_pool/](https://www.paws-r-sdk.com/docs/workspaces_stop_workspaces_pool/) for full documentation.
#'
#' @param PoolId &#91;required&#93; The identifier of the pool.
#'
#' @keywords internal
#'
#' @rdname workspaces_stop_workspaces_pool
workspaces_stop_workspaces_pool <- function(PoolId) {
  op <- new_operation(
    name = "StopWorkspacesPool",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$stop_workspaces_pool_input(PoolId = PoolId)
  output <- .workspaces$stop_workspaces_pool_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$stop_workspaces_pool <- workspaces_stop_workspaces_pool

#' Terminates the specified WorkSpaces
#'
#' @description
#' Terminates the specified WorkSpaces.
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_terminate_workspaces/](https://www.paws-r-sdk.com/docs/workspaces_terminate_workspaces/) for full documentation.
#'
#' @param TerminateWorkspaceRequests &#91;required&#93; The WorkSpaces to terminate. You can specify up to 25 WorkSpaces.
#'
#' @keywords internal
#'
#' @rdname workspaces_terminate_workspaces
workspaces_terminate_workspaces <- function(TerminateWorkspaceRequests) {
  op <- new_operation(
    name = "TerminateWorkspaces",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$terminate_workspaces_input(TerminateWorkspaceRequests = TerminateWorkspaceRequests)
  output <- .workspaces$terminate_workspaces_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$terminate_workspaces <- workspaces_terminate_workspaces

#' Terminates the specified pool
#'
#' @description
#' Terminates the specified pool.
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_terminate_workspaces_pool/](https://www.paws-r-sdk.com/docs/workspaces_terminate_workspaces_pool/) for full documentation.
#'
#' @param PoolId &#91;required&#93; The identifier of the pool.
#'
#' @keywords internal
#'
#' @rdname workspaces_terminate_workspaces_pool
workspaces_terminate_workspaces_pool <- function(PoolId) {
  op <- new_operation(
    name = "TerminateWorkspacesPool",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$terminate_workspaces_pool_input(PoolId = PoolId)
  output <- .workspaces$terminate_workspaces_pool_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$terminate_workspaces_pool <- workspaces_terminate_workspaces_pool

#' Terminates the pool session
#'
#' @description
#' Terminates the pool session.
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_terminate_workspaces_pool_session/](https://www.paws-r-sdk.com/docs/workspaces_terminate_workspaces_pool_session/) for full documentation.
#'
#' @param SessionId &#91;required&#93; The identifier of the pool session.
#'
#' @keywords internal
#'
#' @rdname workspaces_terminate_workspaces_pool_session
workspaces_terminate_workspaces_pool_session <- function(SessionId) {
  op <- new_operation(
    name = "TerminateWorkspacesPoolSession",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$terminate_workspaces_pool_session_input(SessionId = SessionId)
  output <- .workspaces$terminate_workspaces_pool_session_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$terminate_workspaces_pool_session <- workspaces_terminate_workspaces_pool_session

#' Updates a Amazon Connect client add-in
#'
#' @description
#' Updates a Amazon Connect client add-in. Use this action to update the name and endpoint URL of a Amazon Connect client add-in.
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_update_connect_client_add_in/](https://www.paws-r-sdk.com/docs/workspaces_update_connect_client_add_in/) for full documentation.
#'
#' @param AddInId &#91;required&#93; The identifier of the client add-in to update.
#' @param ResourceId &#91;required&#93; The directory identifier for which the client add-in is configured.
#' @param Name The name of the client add-in.
#' @param URL The endpoint URL of the Amazon Connect client add-in.
#'
#' @keywords internal
#'
#' @rdname workspaces_update_connect_client_add_in
workspaces_update_connect_client_add_in <- function(AddInId, ResourceId, Name = NULL, URL = NULL) {
  op <- new_operation(
    name = "UpdateConnectClientAddIn",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$update_connect_client_add_in_input(AddInId = AddInId, ResourceId = ResourceId, Name = Name, URL = URL)
  output <- .workspaces$update_connect_client_add_in_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$update_connect_client_add_in <- workspaces_update_connect_client_add_in

#' Shares or unshares a connection alias with one account by specifying
#' whether that account has permission to associate the connection alias
#' with a directory
#'
#' @description
#' Shares or unshares a connection alias with one account by specifying whether that account has permission to associate the connection alias with a directory. If the association permission is granted, the connection alias is shared with that account. If the association permission is revoked, the connection alias is unshared with the account. For more information, see [Cross-Region Redirection for Amazon WorkSpaces](https://docs.aws.amazon.com/workspaces/latest/adminguide/cross-region-redirection.html).
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_update_connection_alias_permission/](https://www.paws-r-sdk.com/docs/workspaces_update_connection_alias_permission/) for full documentation.
#'
#' @param AliasId &#91;required&#93; The identifier of the connection alias that you want to update permissions for.
#' @param ConnectionAliasPermission &#91;required&#93; Indicates whether to share or unshare the connection alias with the specified Amazon Web Services account.
#'
#' @keywords internal
#'
#' @rdname workspaces_update_connection_alias_permission
workspaces_update_connection_alias_permission <- function(AliasId, ConnectionAliasPermission) {
  op <- new_operation(
    name = "UpdateConnectionAliasPermission",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$update_connection_alias_permission_input(AliasId = AliasId, ConnectionAliasPermission = ConnectionAliasPermission)
  output <- .workspaces$update_connection_alias_permission_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$update_connection_alias_permission <- workspaces_update_connection_alias_permission

#' Replaces the current rules of the specified IP access control group with
#' the specified rules
#'
#' @description
#' Replaces the current rules of the specified IP access control group with the specified rules.
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_update_rules_of_ip_group/](https://www.paws-r-sdk.com/docs/workspaces_update_rules_of_ip_group/) for full documentation.
#'
#' @param GroupId &#91;required&#93; The identifier of the group.
#' @param UserRules &#91;required&#93; One or more rules.
#'
#' @keywords internal
#'
#' @rdname workspaces_update_rules_of_ip_group
workspaces_update_rules_of_ip_group <- function(GroupId, UserRules) {
  op <- new_operation(
    name = "UpdateRulesOfIpGroup",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$update_rules_of_ip_group_input(GroupId = GroupId, UserRules = UserRules)
  output <- .workspaces$update_rules_of_ip_group_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$update_rules_of_ip_group <- workspaces_update_rules_of_ip_group

#' Updates a WorkSpace bundle with a new image
#'
#' @description
#' Updates a WorkSpace bundle with a new image. For more information about updating WorkSpace bundles, see [Update a Custom WorkSpaces Bundle](https://docs.aws.amazon.com/workspaces/latest/adminguide/update-custom-bundle.html).
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_update_workspace_bundle/](https://www.paws-r-sdk.com/docs/workspaces_update_workspace_bundle/) for full documentation.
#'
#' @param BundleId The identifier of the bundle.
#' @param ImageId The identifier of the image.
#'
#' @keywords internal
#'
#' @rdname workspaces_update_workspace_bundle
workspaces_update_workspace_bundle <- function(BundleId = NULL, ImageId = NULL) {
  op <- new_operation(
    name = "UpdateWorkspaceBundle",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$update_workspace_bundle_input(BundleId = BundleId, ImageId = ImageId)
  output <- .workspaces$update_workspace_bundle_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$update_workspace_bundle <- workspaces_update_workspace_bundle

#' Shares or unshares an image with one account in the same Amazon Web
#' Services Region by specifying whether that account has permission to
#' copy the image
#'
#' @description
#' Shares or unshares an image with one account in the same Amazon Web Services Region by specifying whether that account has permission to copy the image. If the copy image permission is granted, the image is shared with that account. If the copy image permission is revoked, the image is unshared with the account.
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_update_workspace_image_permission/](https://www.paws-r-sdk.com/docs/workspaces_update_workspace_image_permission/) for full documentation.
#'
#' @param ImageId &#91;required&#93; The identifier of the image.
#' @param AllowCopyImage &#91;required&#93; The permission to copy the image. This permission can be revoked only after an image has been shared.
#' @param SharedAccountId &#91;required&#93; The identifier of the Amazon Web Services account to share or unshare the image with.
#' 
#' Before sharing the image, confirm that you are sharing to the correct Amazon Web Services account ID.
#'
#' @keywords internal
#'
#' @rdname workspaces_update_workspace_image_permission
workspaces_update_workspace_image_permission <- function(ImageId, AllowCopyImage, SharedAccountId) {
  op <- new_operation(
    name = "UpdateWorkspaceImagePermission",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$update_workspace_image_permission_input(ImageId = ImageId, AllowCopyImage = AllowCopyImage, SharedAccountId = SharedAccountId)
  output <- .workspaces$update_workspace_image_permission_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$update_workspace_image_permission <- workspaces_update_workspace_image_permission

#' Updates the specified pool
#'
#' @description
#' Updates the specified pool.
#'
#' See [https://www.paws-r-sdk.com/docs/workspaces_update_workspaces_pool/](https://www.paws-r-sdk.com/docs/workspaces_update_workspaces_pool/) for full documentation.
#'
#' @param PoolId &#91;required&#93; The identifier of the specified pool to update.
#' @param Description Describes the specified pool to update.
#' @param BundleId The identifier of the bundle.
#' @param DirectoryId The identifier of the directory.
#' @param Capacity The desired capacity for the pool.
#' @param ApplicationSettings The persistent application settings for users in the pool.
#' @param TimeoutSettings Indicates the timeout settings of the specified pool.
#' @param RunningMode The desired running mode for the pool. The running mode can only be updated when the pool is in a stopped state.
#'
#' @keywords internal
#'
#' @rdname workspaces_update_workspaces_pool
workspaces_update_workspaces_pool <- function(PoolId, Description = NULL, BundleId = NULL, DirectoryId = NULL, Capacity = NULL, ApplicationSettings = NULL, TimeoutSettings = NULL, RunningMode = NULL) {
  op <- new_operation(
    name = "UpdateWorkspacesPool",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspaces$update_workspaces_pool_input(PoolId = PoolId, Description = Description, BundleId = BundleId, DirectoryId = DirectoryId, Capacity = Capacity, ApplicationSettings = ApplicationSettings, TimeoutSettings = TimeoutSettings, RunningMode = RunningMode)
  output <- .workspaces$update_workspaces_pool_output()
  config <- get_config()
  svc <- .workspaces$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspaces$operations$update_workspaces_pool <- workspaces_update_workspaces_pool

# This file is generated by make.paws. Please do not edit here.
#' @importFrom paws.common populate
#' @include workmailmessageflow_service.R
NULL

.workmailmessageflow$get_raw_message_content_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(messageId = structure(logical(0), tags = list(location = "uri", locationName = "messageId", type = "string"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmailmessageflow$get_raw_message_content_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(messageContent = structure(logical(0), tags = list(type = "blob", streaming = TRUE))), tags = list(type = "structure", payload = "messageContent"))
  return(populate(args, shape))
}

.workmailmessageflow$put_raw_message_content_input <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(messageId = structure(logical(0), tags = list(location = "uri", locationName = "messageId", type = "string")), content = structure(list(s3Reference = structure(list(bucket = structure(logical(0), tags = list(type = "string")), key = structure(logical(0), tags = list(type = "string")), objectVersion = structure(logical(0), tags = list(type = "string"))), tags = list(type = "structure"))), tags = list(type = "structure"))), tags = list(type = "structure"))
  return(populate(args, shape))
}

.workmailmessageflow$put_raw_message_content_output <- function(...) {
  args <- c(as.list(environment()), list(...))
  shape <- structure(list(), tags = list(type = "structure"))
  return(populate(args, shape))
}

# This file is generated by make.paws. Please do not edit here.
#' @importFrom paws.common get_config new_operation new_request send_request
#' @include workspacesweb_service.R
NULL

#' Associates a browser settings resource with a web portal
#'
#' @description
#' Associates a browser settings resource with a web portal.
#'
#' See [https://www.paws-r-sdk.com/docs/workspacesweb_associate_browser_settings/](https://www.paws-r-sdk.com/docs/workspacesweb_associate_browser_settings/) for full documentation.
#'
#' @param portalArn &#91;required&#93; The ARN of the web portal.
#' @param browserSettingsArn &#91;required&#93; The ARN of the browser settings.
#'
#' @keywords internal
#'
#' @rdname workspacesweb_associate_browser_settings
workspacesweb_associate_browser_settings <- function(portalArn, browserSettingsArn) {
  op <- new_operation(
    name = "AssociateBrowserSettings",
    http_method = "PUT",
    http_path = "/portals/{portalArn+}/browserSettings",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspacesweb$associate_browser_settings_input(portalArn = portalArn, browserSettingsArn = browserSettingsArn)
  output <- .workspacesweb$associate_browser_settings_output()
  config <- get_config()
  svc <- .workspacesweb$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspacesweb$operations$associate_browser_settings <- workspacesweb_associate_browser_settings

#' Associates a data protection settings resource with a web portal
#'
#' @description
#' Associates a data protection settings resource with a web portal.
#'
#' See [https://www.paws-r-sdk.com/docs/workspacesweb_associate_data_protection_settings/](https://www.paws-r-sdk.com/docs/workspacesweb_associate_data_protection_settings/) for full documentation.
#'
#' @param portalArn &#91;required&#93; The ARN of the web portal.
#' @param dataProtectionSettingsArn &#91;required&#93; The ARN of the data protection settings.
#'
#' @keywords internal
#'
#' @rdname workspacesweb_associate_data_protection_settings
workspacesweb_associate_data_protection_settings <- function(portalArn, dataProtectionSettingsArn) {
  op <- new_operation(
    name = "AssociateDataProtectionSettings",
    http_method = "PUT",
    http_path = "/portals/{portalArn+}/dataProtectionSettings",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspacesweb$associate_data_protection_settings_input(portalArn = portalArn, dataProtectionSettingsArn = dataProtectionSettingsArn)
  output <- .workspacesweb$associate_data_protection_settings_output()
  config <- get_config()
  svc <- .workspacesweb$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspacesweb$operations$associate_data_protection_settings <- workspacesweb_associate_data_protection_settings

#' Associates an IP access settings resource with a web portal
#'
#' @description
#' Associates an IP access settings resource with a web portal.
#'
#' See [https://www.paws-r-sdk.com/docs/workspacesweb_associate_ip_access_settings/](https://www.paws-r-sdk.com/docs/workspacesweb_associate_ip_access_settings/) for full documentation.
#'
#' @param portalArn &#91;required&#93; The ARN of the web portal.
#' @param ipAccessSettingsArn &#91;required&#93; The ARN of the IP access settings.
#'
#' @keywords internal
#'
#' @rdname workspacesweb_associate_ip_access_settings
workspacesweb_associate_ip_access_settings <- function(portalArn, ipAccessSettingsArn) {
  op <- new_operation(
    name = "AssociateIpAccessSettings",
    http_method = "PUT",
    http_path = "/portals/{portalArn+}/ipAccessSettings",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspacesweb$associate_ip_access_settings_input(portalArn = portalArn, ipAccessSettingsArn = ipAccessSettingsArn)
  output <- .workspacesweb$associate_ip_access_settings_output()
  config <- get_config()
  svc <- .workspacesweb$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspacesweb$operations$associate_ip_access_settings <- workspacesweb_associate_ip_access_settings

#' Associates a network settings resource with a web portal
#'
#' @description
#' Associates a network settings resource with a web portal.
#'
#' See [https://www.paws-r-sdk.com/docs/workspacesweb_associate_network_settings/](https://www.paws-r-sdk.com/docs/workspacesweb_associate_network_settings/) for full documentation.
#'
#' @param portalArn &#91;required&#93; The ARN of the web portal.
#' @param networkSettingsArn &#91;required&#93; The ARN of the network settings.
#'
#' @keywords internal
#'
#' @rdname workspacesweb_associate_network_settings
workspacesweb_associate_network_settings <- function(portalArn, networkSettingsArn) {
  op <- new_operation(
    name = "AssociateNetworkSettings",
    http_method = "PUT",
    http_path = "/portals/{portalArn+}/networkSettings",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspacesweb$associate_network_settings_input(portalArn = portalArn, networkSettingsArn = networkSettingsArn)
  output <- .workspacesweb$associate_network_settings_output()
  config <- get_config()
  svc <- .workspacesweb$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspacesweb$operations$associate_network_settings <- workspacesweb_associate_network_settings

#' Associates a session logger with a portal
#'
#' @description
#' Associates a session logger with a portal.
#'
#' See [https://www.paws-r-sdk.com/docs/workspacesweb_associate_session_logger/](https://www.paws-r-sdk.com/docs/workspacesweb_associate_session_logger/) for full documentation.
#'
#' @param portalArn &#91;required&#93; The ARN of the portal to associate to the session logger ARN.
#' @param sessionLoggerArn &#91;required&#93; The ARN of the session logger to associate to the portal ARN.
#'
#' @keywords internal
#'
#' @rdname workspacesweb_associate_session_logger
workspacesweb_associate_session_logger <- function(portalArn, sessionLoggerArn) {
  op <- new_operation(
    name = "AssociateSessionLogger",
    http_method = "PUT",
    http_path = "/portals/{portalArn+}/sessionLogger",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspacesweb$associate_session_logger_input(portalArn = portalArn, sessionLoggerArn = sessionLoggerArn)
  output <- .workspacesweb$associate_session_logger_output()
  config <- get_config()
  svc <- .workspacesweb$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspacesweb$operations$associate_session_logger <- workspacesweb_associate_session_logger

#' Associates a trust store with a web portal
#'
#' @description
#' Associates a trust store with a web portal.
#'
#' See [https://www.paws-r-sdk.com/docs/workspacesweb_associate_trust_store/](https://www.paws-r-sdk.com/docs/workspacesweb_associate_trust_store/) for full documentation.
#'
#' @param portalArn &#91;required&#93; The ARN of the web portal.
#' @param trustStoreArn &#91;required&#93; The ARN of the trust store.
#'
#' @keywords internal
#'
#' @rdname workspacesweb_associate_trust_store
workspacesweb_associate_trust_store <- function(portalArn, trustStoreArn) {
  op <- new_operation(
    name = "AssociateTrustStore",
    http_method = "PUT",
    http_path = "/portals/{portalArn+}/trustStores",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspacesweb$associate_trust_store_input(portalArn = portalArn, trustStoreArn = trustStoreArn)
  output <- .workspacesweb$associate_trust_store_output()
  config <- get_config()
  svc <- .workspacesweb$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspacesweb$operations$associate_trust_store <- workspacesweb_associate_trust_store

#' Associates a user access logging settings resource with a web portal
#'
#' @description
#' Associates a user access logging settings resource with a web portal.
#'
#' See [https://www.paws-r-sdk.com/docs/workspacesweb_associate_user_access_logging_settings/](https://www.paws-r-sdk.com/docs/workspacesweb_associate_user_access_logging_settings/) for full documentation.
#'
#' @param portalArn &#91;required&#93; The ARN of the web portal.
#' @param userAccessLoggingSettingsArn &#91;required&#93; The ARN of the user access logging settings.
#'
#' @keywords internal
#'
#' @rdname workspacesweb_associate_user_access_logging_settings
workspacesweb_associate_user_access_logging_settings <- function(portalArn, userAccessLoggingSettingsArn) {
  op <- new_operation(
    name = "AssociateUserAccessLoggingSettings",
    http_method = "PUT",
    http_path = "/portals/{portalArn+}/userAccessLoggingSettings",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspacesweb$associate_user_access_logging_settings_input(portalArn = portalArn, userAccessLoggingSettingsArn = userAccessLoggingSettingsArn)
  output <- .workspacesweb$associate_user_access_logging_settings_output()
  config <- get_config()
  svc <- .workspacesweb$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspacesweb$operations$associate_user_access_logging_settings <- workspacesweb_associate_user_access_logging_settings

#' Associates a user settings resource with a web portal
#'
#' @description
#' Associates a user settings resource with a web portal.
#'
#' See [https://www.paws-r-sdk.com/docs/workspacesweb_associate_user_settings/](https://www.paws-r-sdk.com/docs/workspacesweb_associate_user_settings/) for full documentation.
#'
#' @param portalArn &#91;required&#93; The ARN of the web portal.
#' @param userSettingsArn &#91;required&#93; The ARN of the user settings.
#'
#' @keywords internal
#'
#' @rdname workspacesweb_associate_user_settings
workspacesweb_associate_user_settings <- function(portalArn, userSettingsArn) {
  op <- new_operation(
    name = "AssociateUserSettings",
    http_method = "PUT",
    http_path = "/portals/{portalArn+}/userSettings",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspacesweb$associate_user_settings_input(portalArn = portalArn, userSettingsArn = userSettingsArn)
  output <- .workspacesweb$associate_user_settings_output()
  config <- get_config()
  svc <- .workspacesweb$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspacesweb$operations$associate_user_settings <- workspacesweb_associate_user_settings

#' Creates a browser settings resource that can be associated with a web
#' portal
#'
#' @description
#' Creates a browser settings resource that can be associated with a web portal. Once associated with a web portal, browser settings control how the browser will behave once a user starts a streaming session for the web portal.
#'
#' See [https://www.paws-r-sdk.com/docs/workspacesweb_create_browser_settings/](https://www.paws-r-sdk.com/docs/workspacesweb_create_browser_settings/) for full documentation.
#'
#' @param tags The tags to add to the browser settings resource. A tag is a key-value pair.
#' @param customerManagedKey The custom managed key of the browser settings.
#' @param additionalEncryptionContext Additional encryption context of the browser settings.
#' @param browserPolicy A JSON string containing Chrome Enterprise policies that will be applied to all streaming sessions.
#' @param clientToken A unique, case-sensitive identifier that you provide to ensure the idempotency of the request. Idempotency ensures that an API request completes only once. With an idempotent request, if the original request completes successfully, subsequent retries with the same client token returns the result from the original successful request.
#' 
#' If you do not specify a client token, one is automatically generated by the Amazon Web Services SDK.
#' @param webContentFilteringPolicy The policy that specifies which URLs end users are allowed to access or which URLs or domain categories they are restricted from accessing for enhanced security.
#'
#' @keywords internal
#'
#' @rdname workspacesweb_create_browser_settings
workspacesweb_create_browser_settings <- function(tags = NULL, customerManagedKey = NULL, additionalEncryptionContext = NULL, browserPolicy = NULL, clientToken = NULL, webContentFilteringPolicy = NULL) {
  op <- new_operation(
    name = "CreateBrowserSettings",
    http_method = "POST",
    http_path = "/browserSettings",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspacesweb$create_browser_settings_input(tags = tags, customerManagedKey = customerManagedKey, additionalEncryptionContext = additionalEncryptionContext, browserPolicy = browserPolicy, clientToken = clientToken, webContentFilteringPolicy = webContentFilteringPolicy)
  output <- .workspacesweb$create_browser_settings_output()
  config <- get_config()
  svc <- .workspacesweb$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspacesweb$operations$create_browser_settings <- workspacesweb_create_browser_settings

#' Creates a data protection settings resource that can be associated with
#' a web portal
#'
#' @description
#' Creates a data protection settings resource that can be associated with a web portal.
#'
#' See [https://www.paws-r-sdk.com/docs/workspacesweb_create_data_protection_settings/](https://www.paws-r-sdk.com/docs/workspacesweb_create_data_protection_settings/) for full documentation.
#'
#' @param displayName The display name of the data protection settings.
#' @param description The description of the data protection settings.
#' @param tags The tags to add to the data protection settings resource. A tag is a key-value pair.
#' @param customerManagedKey The custom managed key of the data protection settings.
#' @param additionalEncryptionContext Additional encryption context of the data protection settings.
#' @param inlineRedactionConfiguration The inline redaction configuration of the data protection settings that will be applied to all sessions.
#' @param clientToken A unique, case-sensitive identifier that you provide to ensure the idempotency of the request. Idempotency ensures that an API request completes only once. With an idempotent request, if the original request completes successfully, subsequent retries with the same client token returns the result from the original successful request.
#' 
#' If you do not specify a client token, one is automatically generated by the Amazon Web Services SDK.
#'
#' @keywords internal
#'
#' @rdname workspacesweb_create_data_protection_settings
workspacesweb_create_data_protection_settings <- function(displayName = NULL, description = NULL, tags = NULL, customerManagedKey = NULL, additionalEncryptionContext = NULL, inlineRedactionConfiguration = NULL, clientToken = NULL) {
  op <- new_operation(
    name = "CreateDataProtectionSettings",
    http_method = "POST",
    http_path = "/dataProtectionSettings",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspacesweb$create_data_protection_settings_input(displayName = displayName, description = description, tags = tags, customerManagedKey = customerManagedKey, additionalEncryptionContext = additionalEncryptionContext, inlineRedactionConfiguration = inlineRedactionConfiguration, clientToken = clientToken)
  output <- .workspacesweb$create_data_protection_settings_output()
  config <- get_config()
  svc <- .workspacesweb$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspacesweb$operations$create_data_protection_settings <- workspacesweb_create_data_protection_settings

#' Creates an identity provider resource that is then associated with a web
#' portal
#'
#' @description
#' Creates an identity provider resource that is then associated with a web portal.
#'
#' See [https://www.paws-r-sdk.com/docs/workspacesweb_create_identity_provider/](https://www.paws-r-sdk.com/docs/workspacesweb_create_identity_provider/) for full documentation.
#'
#' @param portalArn &#91;required&#93; The ARN of the web portal.
#' @param identityProviderName &#91;required&#93; The identity provider name.
#' @param identityProviderType &#91;required&#93; The identity provider type.
#' @param identityProviderDetails &#91;required&#93; The identity provider details. The following list describes the provider detail keys for each identity provider type.
#' 
#' -   For Google and Login with Amazon:
#' 
#'     -   `client_id`
#' 
#'     -   `client_secret`
#' 
#'     -   `authorize_scopes`
#' 
#' -   For Facebook:
#' 
#'     -   `client_id`
#' 
#'     -   `client_secret`
#' 
#'     -   `authorize_scopes`
#' 
#'     -   `api_version`
#' 
#' -   For Sign in with Apple:
#' 
#'     -   `client_id`
#' 
#'     -   `team_id`
#' 
#'     -   `key_id`
#' 
#'     -   `private_key`
#' 
#'     -   `authorize_scopes`
#' 
#' -   For OIDC providers:
#' 
#'     -   `client_id`
#' 
#'     -   `client_secret`
#' 
#'     -   `attributes_request_method`
#' 
#'     -   `oidc_issuer`
#' 
#'     -   `authorize_scopes`
#' 
#'     -   `authorize_url` *if not available from discovery URL specified by oidc_issuer key*
#' 
#'     -   `token_url` *if not available from discovery URL specified by oidc_issuer key*
#' 
#'     -   `attributes_url` *if not available from discovery URL specified by oidc_issuer key*
#' 
#'     -   `jwks_uri` *if not available from discovery URL specified by oidc_issuer key*
#' 
#' -   For SAML providers:
#' 
#'     -   `MetadataFile` OR `MetadataURL`
#' 
#'     -   `IDPSignout` (boolean) *optional*
#' 
#'     -   `IDPInit` (boolean) *optional*
#' 
#'     -   `RequestSigningAlgorithm` (string) *optional* - Only accepts `rsa-sha256`
#' 
#'     -   `EncryptedResponses` (boolean) *optional*
#' @param clientToken A unique, case-sensitive identifier that you provide to ensure the idempotency of the request. Idempotency ensures that an API request completes only once. With an idempotent request, if the original request completes successfully, subsequent retries with the same client token returns the result from the original successful request.
#' 
#' If you do not specify a client token, one is automatically generated by the Amazon Web Services SDK.
#' @param tags The tags to add to the identity provider resource. A tag is a key-value pair.
#'
#' @keywords internal
#'
#' @rdname workspacesweb_create_identity_provider
workspacesweb_create_identity_provider <- function(portalArn, identityProviderName, identityProviderType, identityProviderDetails, clientToken = NULL, tags = NULL) {
  op <- new_operation(
    name = "CreateIdentityProvider",
    http_method = "POST",
    http_path = "/identityProviders",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspacesweb$create_identity_provider_input(portalArn = portalArn, identityProviderName = identityProviderName, identityProviderType = identityProviderType, identityProviderDetails = identityProviderDetails, clientToken = clientToken, tags = tags)
  output <- .workspacesweb$create_identity_provider_output()
  config <- get_config()
  svc <- .workspacesweb$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspacesweb$operations$create_identity_provider <- workspacesweb_create_identity_provider

#' Creates an IP access settings resource that can be associated with a web
#' portal
#'
#' @description
#' Creates an IP access settings resource that can be associated with a web portal.
#'
#' See [https://www.paws-r-sdk.com/docs/workspacesweb_create_ip_access_settings/](https://www.paws-r-sdk.com/docs/workspacesweb_create_ip_access_settings/) for full documentation.
#'
#' @param displayName The display name of the IP access settings.
#' @param description The description of the IP access settings.
#' @param tags The tags to add to the IP access settings resource. A tag is a key-value pair.
#' @param customerManagedKey The custom managed key of the IP access settings.
#' @param additionalEncryptionContext Additional encryption context of the IP access settings.
#' @param ipRules &#91;required&#93; The IP rules of the IP access settings.
#' @param clientToken A unique, case-sensitive identifier that you provide to ensure the idempotency of the request. Idempotency ensures that an API request completes only once. With an idempotent request, if the original request completes successfully, subsequent retries with the same client token returns the result from the original successful request.
#' 
#' If you do not specify a client token, one is automatically generated by the Amazon Web Services SDK.
#'
#' @keywords internal
#'
#' @rdname workspacesweb_create_ip_access_settings
workspacesweb_create_ip_access_settings <- function(displayName = NULL, description = NULL, tags = NULL, customerManagedKey = NULL, additionalEncryptionContext = NULL, ipRules, clientToken = NULL) {
  op <- new_operation(
    name = "CreateIpAccessSettings",
    http_method = "POST",
    http_path = "/ipAccessSettings",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspacesweb$create_ip_access_settings_input(displayName = displayName, description = description, tags = tags, customerManagedKey = customerManagedKey, additionalEncryptionContext = additionalEncryptionContext, ipRules = ipRules, clientToken = clientToken)
  output <- .workspacesweb$create_ip_access_settings_output()
  config <- get_config()
  svc <- .workspacesweb$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspacesweb$operations$create_ip_access_settings <- workspacesweb_create_ip_access_settings

#' Creates a network settings resource that can be associated with a web
#' portal
#'
#' @description
#' Creates a network settings resource that can be associated with a web portal. Once associated with a web portal, network settings define how streaming instances will connect with your specified VPC.
#'
#' See [https://www.paws-r-sdk.com/docs/workspacesweb_create_network_settings/](https://www.paws-r-sdk.com/docs/workspacesweb_create_network_settings/) for full documentation.
#'
#' @param vpcId &#91;required&#93; The VPC that streaming instances will connect to.
#' @param subnetIds &#91;required&#93; The subnets in which network interfaces are created to connect streaming instances to your VPC. At least two of these subnets must be in different availability zones.
#' @param securityGroupIds &#91;required&#93; One or more security groups used to control access from streaming instances to your VPC.
#' @param tags The tags to add to the network settings resource. A tag is a key-value pair.
#' @param clientToken A unique, case-sensitive identifier that you provide to ensure the idempotency of the request. Idempotency ensures that an API request completes only once. With an idempotent request, if the original request completes successfully, subsequent retries with the same client token returns the result from the original successful request.
#' 
#' If you do not specify a client token, one is automatically generated by the Amazon Web Services SDK.
#'
#' @keywords internal
#'
#' @rdname workspacesweb_create_network_settings
workspacesweb_create_network_settings <- function(vpcId, subnetIds, securityGroupIds, tags = NULL, clientToken = NULL) {
  op <- new_operation(
    name = "CreateNetworkSettings",
    http_method = "POST",
    http_path = "/networkSettings",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspacesweb$create_network_settings_input(vpcId = vpcId, subnetIds = subnetIds, securityGroupIds = securityGroupIds, tags = tags, clientToken = clientToken)
  output <- .workspacesweb$create_network_settings_output()
  config <- get_config()
  svc <- .workspacesweb$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspacesweb$operations$create_network_settings <- workspacesweb_create_network_settings

#' Creates a web portal
#'
#' @description
#' Creates a web portal.
#'
#' See [https://www.paws-r-sdk.com/docs/workspacesweb_create_portal/](https://www.paws-r-sdk.com/docs/workspacesweb_create_portal/) for full documentation.
#'
#' @param displayName The name of the web portal. This is not visible to users who log into the web portal.
#' @param tags The tags to add to the web portal. A tag is a key-value pair.
#' @param customerManagedKey The customer managed key of the web portal.
#' @param additionalEncryptionContext The additional encryption context of the portal.
#' @param clientToken A unique, case-sensitive identifier that you provide to ensure the idempotency of the request. Idempotency ensures that an API request completes only once. With an idempotent request, if the original request completes successfully, subsequent retries with the same client token returns the result from the original successful request.
#' 
#' If you do not specify a client token, one is automatically generated by the Amazon Web Services SDK.
#' @param authenticationType The type of authentication integration points used when signing into the web portal. Defaults to `Standard`.
#' 
#' `Standard` web portals are authenticated directly through your identity provider. You need to call [`create_identity_provider`][workspacesweb_create_identity_provider] to integrate your identity provider with your web portal. User and group access to your web portal is controlled through your identity provider.
#' 
#' `IAM Identity Center` web portals are authenticated through IAM Identity Center. Identity sources (including external identity provider integration), plus user and group access to your web portal, can be configured in the IAM Identity Center.
#' @param instanceType The type and resources of the underlying instance.
#' @param maxConcurrentSessions The maximum number of concurrent sessions for the portal.
#' @param portalCustomDomain The custom domain of the web portal that users access in order to start streaming sessions.
#'
#' @keywords internal
#'
#' @rdname workspacesweb_create_portal
workspacesweb_create_portal <- function(displayName = NULL, tags = NULL, customerManagedKey = NULL, additionalEncryptionContext = NULL, clientToken = NULL, authenticationType = NULL, instanceType = NULL, maxConcurrentSessions = NULL, portalCustomDomain = NULL) {
  op <- new_operation(
    name = "CreatePortal",
    http_method = "POST",
    http_path = "/portals",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspacesweb$create_portal_input(displayName = displayName, tags = tags, customerManagedKey = customerManagedKey, additionalEncryptionContext = additionalEncryptionContext, clientToken = clientToken, authenticationType = authenticationType, instanceType = instanceType, maxConcurrentSessions = maxConcurrentSessions, portalCustomDomain = portalCustomDomain)
  output <- .workspacesweb$create_portal_output()
  config <- get_config()
  svc <- .workspacesweb$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspacesweb$operations$create_portal <- workspacesweb_create_portal

#' Creates a session logger
#'
#' @description
#' Creates a session logger.
#'
#' See [https://www.paws-r-sdk.com/docs/workspacesweb_create_session_logger/](https://www.paws-r-sdk.com/docs/workspacesweb_create_session_logger/) for full documentation.
#'
#' @param eventFilter &#91;required&#93; The filter that specifies the events to monitor.
#' @param logConfiguration &#91;required&#93; The configuration that specifies where logs are delivered.
#' @param displayName The human-readable display name for the session logger resource.
#' @param customerManagedKey The custom managed key of the session logger.
#' @param additionalEncryptionContext The additional encryption context of the session logger.
#' @param tags The tags to add to the session logger.
#' @param clientToken A unique, case-sensitive identifier that you provide to ensure the idempotency of the request. Idempotency ensures that an API request completes only once. With an idempotent request, if the original request completes successfully, subsequent retries with the same client token returns the result from the original successful request. If you do not specify a client token, one is automatically generated by the AWS SDK.
#'
#' @keywords internal
#'
#' @rdname workspacesweb_create_session_logger
workspacesweb_create_session_logger <- function(eventFilter, logConfiguration, displayName = NULL, customerManagedKey = NULL, additionalEncryptionContext = NULL, tags = NULL, clientToken = NULL) {
  op <- new_operation(
    name = "CreateSessionLogger",
    http_method = "POST",
    http_path = "/sessionLoggers",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspacesweb$create_session_logger_input(eventFilter = eventFilter, logConfiguration = logConfiguration, displayName = displayName, customerManagedKey = customerManagedKey, additionalEncryptionContext = additionalEncryptionContext, tags = tags, clientToken = clientToken)
  output <- .workspacesweb$create_session_logger_output()
  config <- get_config()
  svc <- .workspacesweb$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspacesweb$operations$create_session_logger <- workspacesweb_create_session_logger

#' Creates a trust store that can be associated with a web portal
#'
#' @description
#' Creates a trust store that can be associated with a web portal. A trust store contains certificate authority (CA) certificates. Once associated with a web portal, the browser in a streaming session will recognize certificates that have been issued using any of the CAs in the trust store. If your organization has internal websites that use certificates issued by private CAs, you should add the private CA certificate to the trust store.
#'
#' See [https://www.paws-r-sdk.com/docs/workspacesweb_create_trust_store/](https://www.paws-r-sdk.com/docs/workspacesweb_create_trust_store/) for full documentation.
#'
#' @param certificateList &#91;required&#93; A list of CA certificates to be added to the trust store.
#' @param tags The tags to add to the trust store. A tag is a key-value pair.
#' @param clientToken A unique, case-sensitive identifier that you provide to ensure the idempotency of the request. Idempotency ensures that an API request completes only once. With an idempotent request, if the original request completes successfully, subsequent retries with the same client token returns the result from the original successful request.
#' 
#' If you do not specify a client token, one is automatically generated by the Amazon Web Services SDK.
#'
#' @keywords internal
#'
#' @rdname workspacesweb_create_trust_store
workspacesweb_create_trust_store <- function(certificateList, tags = NULL, clientToken = NULL) {
  op <- new_operation(
    name = "CreateTrustStore",
    http_method = "POST",
    http_path = "/trustStores",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspacesweb$create_trust_store_input(certificateList = certificateList, tags = tags, clientToken = clientToken)
  output <- .workspacesweb$create_trust_store_output()
  config <- get_config()
  svc <- .workspacesweb$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspacesweb$operations$create_trust_store <- workspacesweb_create_trust_store

#' Creates a user access logging settings resource that can be associated
#' with a web portal
#'
#' @description
#' Creates a user access logging settings resource that can be associated with a web portal.
#'
#' See [https://www.paws-r-sdk.com/docs/workspacesweb_create_user_access_logging_settings/](https://www.paws-r-sdk.com/docs/workspacesweb_create_user_access_logging_settings/) for full documentation.
#'
#' @param kinesisStreamArn &#91;required&#93; The ARN of the Kinesis stream.
#' @param tags The tags to add to the user settings resource. A tag is a key-value pair.
#' @param clientToken A unique, case-sensitive identifier that you provide to ensure the idempotency of the request. Idempotency ensures that an API request completes only once. With an idempotent request, if the original request completes successfully, subsequent retries with the same client token returns the result from the original successful request.
#' 
#' If you do not specify a client token, one is automatically generated by the Amazon Web Services SDK.
#'
#' @keywords internal
#'
#' @rdname workspacesweb_create_user_access_logging_settings
workspacesweb_create_user_access_logging_settings <- function(kinesisStreamArn, tags = NULL, clientToken = NULL) {
  op <- new_operation(
    name = "CreateUserAccessLoggingSettings",
    http_method = "POST",
    http_path = "/userAccessLoggingSettings",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspacesweb$create_user_access_logging_settings_input(kinesisStreamArn = kinesisStreamArn, tags = tags, clientToken = clientToken)
  output <- .workspacesweb$create_user_access_logging_settings_output()
  config <- get_config()
  svc <- .workspacesweb$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspacesweb$operations$create_user_access_logging_settings <- workspacesweb_create_user_access_logging_settings

#' Creates a user settings resource that can be associated with a web
#' portal
#'
#' @description
#' Creates a user settings resource that can be associated with a web portal. Once associated with a web portal, user settings control how users can transfer data between a streaming session and the their local devices.
#'
#' See [https://www.paws-r-sdk.com/docs/workspacesweb_create_user_settings/](https://www.paws-r-sdk.com/docs/workspacesweb_create_user_settings/) for full documentation.
#'
#' @param copyAllowed &#91;required&#93; Specifies whether the user can copy text from the streaming session to the local device.
#' @param pasteAllowed &#91;required&#93; Specifies whether the user can paste text from the local device to the streaming session.
#' @param downloadAllowed &#91;required&#93; Specifies whether the user can download files from the streaming session to the local device.
#' @param uploadAllowed &#91;required&#93; Specifies whether the user can upload files from the local device to the streaming session.
#' @param printAllowed &#91;required&#93; Specifies whether the user can print to the local device.
#' @param tags The tags to add to the user settings resource. A tag is a key-value pair.
#' @param disconnectTimeoutInMinutes The amount of time that a streaming session remains active after users disconnect.
#' @param idleDisconnectTimeoutInMinutes The amount of time that users can be idle (inactive) before they are disconnected from their streaming session and the disconnect timeout interval begins.
#' @param clientToken A unique, case-sensitive identifier that you provide to ensure the idempotency of the request. Idempotency ensures that an API request completes only once. With an idempotent request, if the original request completes successfully, subsequent retries with the same client token returns the result from the original successful request.
#' 
#' If you do not specify a client token, one is automatically generated by the Amazon Web Services SDK.
#' @param cookieSynchronizationConfiguration The configuration that specifies which cookies should be synchronized from the end user's local browser to the remote browser.
#' @param customerManagedKey The customer managed key used to encrypt sensitive information in the user settings.
#' @param additionalEncryptionContext The additional encryption context of the user settings.
#' @param deepLinkAllowed Specifies whether the user can use deep links that open automatically when connecting to a session.
#' @param toolbarConfiguration The configuration of the toolbar. This allows administrators to select the toolbar type and visual mode, set maximum display resolution for sessions, and choose which items are visible to end users during their sessions. If administrators do not modify these settings, end users retain control over their toolbar preferences.
#' @param brandingConfigurationInput The branding configuration input that customizes the appearance of the web portal for end users. This includes a custom logo, favicon, localized strings, color theme, and optionally a wallpaper and terms of service.
#' @param webAuthnAllowed Specifies whether the user can use WebAuthn redirection for passwordless login to websites within the streaming session.
#'
#' @keywords internal
#'
#' @rdname workspacesweb_create_user_settings
workspacesweb_create_user_settings <- function(copyAllowed, pasteAllowed, downloadAllowed, uploadAllowed, printAllowed, tags = NULL, disconnectTimeoutInMinutes = NULL, idleDisconnectTimeoutInMinutes = NULL, clientToken = NULL, cookieSynchronizationConfiguration = NULL, customerManagedKey = NULL, additionalEncryptionContext = NULL, deepLinkAllowed = NULL, toolbarConfiguration = NULL, brandingConfigurationInput = NULL, webAuthnAllowed = NULL) {
  op <- new_operation(
    name = "CreateUserSettings",
    http_method = "POST",
    http_path = "/userSettings",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspacesweb$create_user_settings_input(copyAllowed = copyAllowed, pasteAllowed = pasteAllowed, downloadAllowed = downloadAllowed, uploadAllowed = uploadAllowed, printAllowed = printAllowed, tags = tags, disconnectTimeoutInMinutes = disconnectTimeoutInMinutes, idleDisconnectTimeoutInMinutes = idleDisconnectTimeoutInMinutes, clientToken = clientToken, cookieSynchronizationConfiguration = cookieSynchronizationConfiguration, customerManagedKey = customerManagedKey, additionalEncryptionContext = additionalEncryptionContext, deepLinkAllowed = deepLinkAllowed, toolbarConfiguration = toolbarConfiguration, brandingConfigurationInput = brandingConfigurationInput, webAuthnAllowed = webAuthnAllowed)
  output <- .workspacesweb$create_user_settings_output()
  config <- get_config()
  svc <- .workspacesweb$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspacesweb$operations$create_user_settings <- workspacesweb_create_user_settings

#' Deletes browser settings
#'
#' @description
#' Deletes browser settings.
#'
#' See [https://www.paws-r-sdk.com/docs/workspacesweb_delete_browser_settings/](https://www.paws-r-sdk.com/docs/workspacesweb_delete_browser_settings/) for full documentation.
#'
#' @param browserSettingsArn &#91;required&#93; The ARN of the browser settings.
#'
#' @keywords internal
#'
#' @rdname workspacesweb_delete_browser_settings
workspacesweb_delete_browser_settings <- function(browserSettingsArn) {
  op <- new_operation(
    name = "DeleteBrowserSettings",
    http_method = "DELETE",
    http_path = "/browserSettings/{browserSettingsArn+}",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspacesweb$delete_browser_settings_input(browserSettingsArn = browserSettingsArn)
  output <- .workspacesweb$delete_browser_settings_output()
  config <- get_config()
  svc <- .workspacesweb$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspacesweb$operations$delete_browser_settings <- workspacesweb_delete_browser_settings

#' Deletes data protection settings
#'
#' @description
#' Deletes data protection settings.
#'
#' See [https://www.paws-r-sdk.com/docs/workspacesweb_delete_data_protection_settings/](https://www.paws-r-sdk.com/docs/workspacesweb_delete_data_protection_settings/) for full documentation.
#'
#' @param dataProtectionSettingsArn &#91;required&#93; The ARN of the data protection settings.
#'
#' @keywords internal
#'
#' @rdname workspacesweb_delete_data_protection_settings
workspacesweb_delete_data_protection_settings <- function(dataProtectionSettingsArn) {
  op <- new_operation(
    name = "DeleteDataProtectionSettings",
    http_method = "DELETE",
    http_path = "/dataProtectionSettings/{dataProtectionSettingsArn+}",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspacesweb$delete_data_protection_settings_input(dataProtectionSettingsArn = dataProtectionSettingsArn)
  output <- .workspacesweb$delete_data_protection_settings_output()
  config <- get_config()
  svc <- .workspacesweb$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspacesweb$operations$delete_data_protection_settings <- workspacesweb_delete_data_protection_settings

#' Deletes the identity provider
#'
#' @description
#' Deletes the identity provider.
#'
#' See [https://www.paws-r-sdk.com/docs/workspacesweb_delete_identity_provider/](https://www.paws-r-sdk.com/docs/workspacesweb_delete_identity_provider/) for full documentation.
#'
#' @param identityProviderArn &#91;required&#93; The ARN of the identity provider.
#'
#' @keywords internal
#'
#' @rdname workspacesweb_delete_identity_provider
workspacesweb_delete_identity_provider <- function(identityProviderArn) {
  op <- new_operation(
    name = "DeleteIdentityProvider",
    http_method = "DELETE",
    http_path = "/identityProviders/{identityProviderArn+}",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspacesweb$delete_identity_provider_input(identityProviderArn = identityProviderArn)
  output <- .workspacesweb$delete_identity_provider_output()
  config <- get_config()
  svc <- .workspacesweb$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspacesweb$operations$delete_identity_provider <- workspacesweb_delete_identity_provider

#' Deletes IP access settings
#'
#' @description
#' Deletes IP access settings.
#'
#' See [https://www.paws-r-sdk.com/docs/workspacesweb_delete_ip_access_settings/](https://www.paws-r-sdk.com/docs/workspacesweb_delete_ip_access_settings/) for full documentation.
#'
#' @param ipAccessSettingsArn &#91;required&#93; The ARN of the IP access settings.
#'
#' @keywords internal
#'
#' @rdname workspacesweb_delete_ip_access_settings
workspacesweb_delete_ip_access_settings <- function(ipAccessSettingsArn) {
  op <- new_operation(
    name = "DeleteIpAccessSettings",
    http_method = "DELETE",
    http_path = "/ipAccessSettings/{ipAccessSettingsArn+}",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspacesweb$delete_ip_access_settings_input(ipAccessSettingsArn = ipAccessSettingsArn)
  output <- .workspacesweb$delete_ip_access_settings_output()
  config <- get_config()
  svc <- .workspacesweb$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspacesweb$operations$delete_ip_access_settings <- workspacesweb_delete_ip_access_settings

#' Deletes network settings
#'
#' @description
#' Deletes network settings.
#'
#' See [https://www.paws-r-sdk.com/docs/workspacesweb_delete_network_settings/](https://www.paws-r-sdk.com/docs/workspacesweb_delete_network_settings/) for full documentation.
#'
#' @param networkSettingsArn &#91;required&#93; The ARN of the network settings.
#'
#' @keywords internal
#'
#' @rdname workspacesweb_delete_network_settings
workspacesweb_delete_network_settings <- function(networkSettingsArn) {
  op <- new_operation(
    name = "DeleteNetworkSettings",
    http_method = "DELETE",
    http_path = "/networkSettings/{networkSettingsArn+}",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspacesweb$delete_network_settings_input(networkSettingsArn = networkSettingsArn)
  output <- .workspacesweb$delete_network_settings_output()
  config <- get_config()
  svc <- .workspacesweb$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspacesweb$operations$delete_network_settings <- workspacesweb_delete_network_settings

#' Deletes a web portal
#'
#' @description
#' Deletes a web portal.
#'
#' See [https://www.paws-r-sdk.com/docs/workspacesweb_delete_portal/](https://www.paws-r-sdk.com/docs/workspacesweb_delete_portal/) for full documentation.
#'
#' @param portalArn &#91;required&#93; The ARN of the web portal.
#'
#' @keywords internal
#'
#' @rdname workspacesweb_delete_portal
workspacesweb_delete_portal <- function(portalArn) {
  op <- new_operation(
    name = "DeletePortal",
    http_method = "DELETE",
    http_path = "/portals/{portalArn+}",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspacesweb$delete_portal_input(portalArn = portalArn)
  output <- .workspacesweb$delete_portal_output()
  config <- get_config()
  svc <- .workspacesweb$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspacesweb$operations$delete_portal <- workspacesweb_delete_portal

#' Deletes a session logger resource
#'
#' @description
#' Deletes a session logger resource.
#'
#' See [https://www.paws-r-sdk.com/docs/workspacesweb_delete_session_logger/](https://www.paws-r-sdk.com/docs/workspacesweb_delete_session_logger/) for full documentation.
#'
#' @param sessionLoggerArn &#91;required&#93; The ARN of the session logger.
#'
#' @keywords internal
#'
#' @rdname workspacesweb_delete_session_logger
workspacesweb_delete_session_logger <- function(sessionLoggerArn) {
  op <- new_operation(
    name = "DeleteSessionLogger",
    http_method = "DELETE",
    http_path = "/sessionLoggers/{sessionLoggerArn+}",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspacesweb$delete_session_logger_input(sessionLoggerArn = sessionLoggerArn)
  output <- .workspacesweb$delete_session_logger_output()
  config <- get_config()
  svc <- .workspacesweb$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspacesweb$operations$delete_session_logger <- workspacesweb_delete_session_logger

#' Deletes the trust store
#'
#' @description
#' Deletes the trust store.
#'
#' See [https://www.paws-r-sdk.com/docs/workspacesweb_delete_trust_store/](https://www.paws-r-sdk.com/docs/workspacesweb_delete_trust_store/) for full documentation.
#'
#' @param trustStoreArn &#91;required&#93; The ARN of the trust store.
#'
#' @keywords internal
#'
#' @rdname workspacesweb_delete_trust_store
workspacesweb_delete_trust_store <- function(trustStoreArn) {
  op <- new_operation(
    name = "DeleteTrustStore",
    http_method = "DELETE",
    http_path = "/trustStores/{trustStoreArn+}",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspacesweb$delete_trust_store_input(trustStoreArn = trustStoreArn)
  output <- .workspacesweb$delete_trust_store_output()
  config <- get_config()
  svc <- .workspacesweb$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspacesweb$operations$delete_trust_store <- workspacesweb_delete_trust_store

#' Deletes user access logging settings
#'
#' @description
#' Deletes user access logging settings.
#'
#' See [https://www.paws-r-sdk.com/docs/workspacesweb_delete_user_access_logging_settings/](https://www.paws-r-sdk.com/docs/workspacesweb_delete_user_access_logging_settings/) for full documentation.
#'
#' @param userAccessLoggingSettingsArn &#91;required&#93; The ARN of the user access logging settings.
#'
#' @keywords internal
#'
#' @rdname workspacesweb_delete_user_access_logging_settings
workspacesweb_delete_user_access_logging_settings <- function(userAccessLoggingSettingsArn) {
  op <- new_operation(
    name = "DeleteUserAccessLoggingSettings",
    http_method = "DELETE",
    http_path = "/userAccessLoggingSettings/{userAccessLoggingSettingsArn+}",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspacesweb$delete_user_access_logging_settings_input(userAccessLoggingSettingsArn = userAccessLoggingSettingsArn)
  output <- .workspacesweb$delete_user_access_logging_settings_output()
  config <- get_config()
  svc <- .workspacesweb$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspacesweb$operations$delete_user_access_logging_settings <- workspacesweb_delete_user_access_logging_settings

#' Deletes user settings
#'
#' @description
#' Deletes user settings.
#'
#' See [https://www.paws-r-sdk.com/docs/workspacesweb_delete_user_settings/](https://www.paws-r-sdk.com/docs/workspacesweb_delete_user_settings/) for full documentation.
#'
#' @param userSettingsArn &#91;required&#93; The ARN of the user settings.
#'
#' @keywords internal
#'
#' @rdname workspacesweb_delete_user_settings
workspacesweb_delete_user_settings <- function(userSettingsArn) {
  op <- new_operation(
    name = "DeleteUserSettings",
    http_method = "DELETE",
    http_path = "/userSettings/{userSettingsArn+}",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspacesweb$delete_user_settings_input(userSettingsArn = userSettingsArn)
  output <- .workspacesweb$delete_user_settings_output()
  config <- get_config()
  svc <- .workspacesweb$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspacesweb$operations$delete_user_settings <- workspacesweb_delete_user_settings

#' Disassociates browser settings from a web portal
#'
#' @description
#' Disassociates browser settings from a web portal.
#'
#' See [https://www.paws-r-sdk.com/docs/workspacesweb_disassociate_browser_settings/](https://www.paws-r-sdk.com/docs/workspacesweb_disassociate_browser_settings/) for full documentation.
#'
#' @param portalArn &#91;required&#93; The ARN of the web portal.
#'
#' @keywords internal
#'
#' @rdname workspacesweb_disassociate_browser_settings
workspacesweb_disassociate_browser_settings <- function(portalArn) {
  op <- new_operation(
    name = "DisassociateBrowserSettings",
    http_method = "DELETE",
    http_path = "/portals/{portalArn+}/browserSettings",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspacesweb$disassociate_browser_settings_input(portalArn = portalArn)
  output <- .workspacesweb$disassociate_browser_settings_output()
  config <- get_config()
  svc <- .workspacesweb$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspacesweb$operations$disassociate_browser_settings <- workspacesweb_disassociate_browser_settings

#' Disassociates data protection settings from a web portal
#'
#' @description
#' Disassociates data protection settings from a web portal.
#'
#' See [https://www.paws-r-sdk.com/docs/workspacesweb_disassociate_data_protection_settings/](https://www.paws-r-sdk.com/docs/workspacesweb_disassociate_data_protection_settings/) for full documentation.
#'
#' @param portalArn &#91;required&#93; The ARN of the web portal.
#'
#' @keywords internal
#'
#' @rdname workspacesweb_disassociate_data_protection_settings
workspacesweb_disassociate_data_protection_settings <- function(portalArn) {
  op <- new_operation(
    name = "DisassociateDataProtectionSettings",
    http_method = "DELETE",
    http_path = "/portals/{portalArn+}/dataProtectionSettings",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspacesweb$disassociate_data_protection_settings_input(portalArn = portalArn)
  output <- .workspacesweb$disassociate_data_protection_settings_output()
  config <- get_config()
  svc <- .workspacesweb$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspacesweb$operations$disassociate_data_protection_settings <- workspacesweb_disassociate_data_protection_settings

#' Disassociates IP access settings from a web portal
#'
#' @description
#' Disassociates IP access settings from a web portal.
#'
#' See [https://www.paws-r-sdk.com/docs/workspacesweb_disassociate_ip_access_settings/](https://www.paws-r-sdk.com/docs/workspacesweb_disassociate_ip_access_settings/) for full documentation.
#'
#' @param portalArn &#91;required&#93; The ARN of the web portal.
#'
#' @keywords internal
#'
#' @rdname workspacesweb_disassociate_ip_access_settings
workspacesweb_disassociate_ip_access_settings <- function(portalArn) {
  op <- new_operation(
    name = "DisassociateIpAccessSettings",
    http_method = "DELETE",
    http_path = "/portals/{portalArn+}/ipAccessSettings",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspacesweb$disassociate_ip_access_settings_input(portalArn = portalArn)
  output <- .workspacesweb$disassociate_ip_access_settings_output()
  config <- get_config()
  svc <- .workspacesweb$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspacesweb$operations$disassociate_ip_access_settings <- workspacesweb_disassociate_ip_access_settings

#' Disassociates network settings from a web portal
#'
#' @description
#' Disassociates network settings from a web portal.
#'
#' See [https://www.paws-r-sdk.com/docs/workspacesweb_disassociate_network_settings/](https://www.paws-r-sdk.com/docs/workspacesweb_disassociate_network_settings/) for full documentation.
#'
#' @param portalArn &#91;required&#93; The ARN of the web portal.
#'
#' @keywords internal
#'
#' @rdname workspacesweb_disassociate_network_settings
workspacesweb_disassociate_network_settings <- function(portalArn) {
  op <- new_operation(
    name = "DisassociateNetworkSettings",
    http_method = "DELETE",
    http_path = "/portals/{portalArn+}/networkSettings",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspacesweb$disassociate_network_settings_input(portalArn = portalArn)
  output <- .workspacesweb$disassociate_network_settings_output()
  config <- get_config()
  svc <- .workspacesweb$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspacesweb$operations$disassociate_network_settings <- workspacesweb_disassociate_network_settings

#' Disassociates a session logger from a portal
#'
#' @description
#' Disassociates a session logger from a portal.
#'
#' See [https://www.paws-r-sdk.com/docs/workspacesweb_disassociate_session_logger/](https://www.paws-r-sdk.com/docs/workspacesweb_disassociate_session_logger/) for full documentation.
#'
#' @param portalArn &#91;required&#93; The ARN of the portal to disassociate from the a session logger.
#'
#' @keywords internal
#'
#' @rdname workspacesweb_disassociate_session_logger
workspacesweb_disassociate_session_logger <- function(portalArn) {
  op <- new_operation(
    name = "DisassociateSessionLogger",
    http_method = "DELETE",
    http_path = "/portals/{portalArn+}/sessionLogger",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspacesweb$disassociate_session_logger_input(portalArn = portalArn)
  output <- .workspacesweb$disassociate_session_logger_output()
  config <- get_config()
  svc <- .workspacesweb$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspacesweb$operations$disassociate_session_logger <- workspacesweb_disassociate_session_logger

#' Disassociates a trust store from a web portal
#'
#' @description
#' Disassociates a trust store from a web portal.
#'
#' See [https://www.paws-r-sdk.com/docs/workspacesweb_disassociate_trust_store/](https://www.paws-r-sdk.com/docs/workspacesweb_disassociate_trust_store/) for full documentation.
#'
#' @param portalArn &#91;required&#93; The ARN of the web portal.
#'
#' @keywords internal
#'
#' @rdname workspacesweb_disassociate_trust_store
workspacesweb_disassociate_trust_store <- function(portalArn) {
  op <- new_operation(
    name = "DisassociateTrustStore",
    http_method = "DELETE",
    http_path = "/portals/{portalArn+}/trustStores",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspacesweb$disassociate_trust_store_input(portalArn = portalArn)
  output <- .workspacesweb$disassociate_trust_store_output()
  config <- get_config()
  svc <- .workspacesweb$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspacesweb$operations$disassociate_trust_store <- workspacesweb_disassociate_trust_store

#' Disassociates user access logging settings from a web portal
#'
#' @description
#' Disassociates user access logging settings from a web portal.
#'
#' See [https://www.paws-r-sdk.com/docs/workspacesweb_disassociate_user_access_logging_settings/](https://www.paws-r-sdk.com/docs/workspacesweb_disassociate_user_access_logging_settings/) for full documentation.
#'
#' @param portalArn &#91;required&#93; The ARN of the web portal.
#'
#' @keywords internal
#'
#' @rdname workspacesweb_disassociate_user_access_logging_settings
workspacesweb_disassociate_user_access_logging_settings <- function(portalArn) {
  op <- new_operation(
    name = "DisassociateUserAccessLoggingSettings",
    http_method = "DELETE",
    http_path = "/portals/{portalArn+}/userAccessLoggingSettings",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspacesweb$disassociate_user_access_logging_settings_input(portalArn = portalArn)
  output <- .workspacesweb$disassociate_user_access_logging_settings_output()
  config <- get_config()
  svc <- .workspacesweb$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspacesweb$operations$disassociate_user_access_logging_settings <- workspacesweb_disassociate_user_access_logging_settings

#' Disassociates user settings from a web portal
#'
#' @description
#' Disassociates user settings from a web portal.
#'
#' See [https://www.paws-r-sdk.com/docs/workspacesweb_disassociate_user_settings/](https://www.paws-r-sdk.com/docs/workspacesweb_disassociate_user_settings/) for full documentation.
#'
#' @param portalArn &#91;required&#93; The ARN of the web portal.
#'
#' @keywords internal
#'
#' @rdname workspacesweb_disassociate_user_settings
workspacesweb_disassociate_user_settings <- function(portalArn) {
  op <- new_operation(
    name = "DisassociateUserSettings",
    http_method = "DELETE",
    http_path = "/portals/{portalArn+}/userSettings",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspacesweb$disassociate_user_settings_input(portalArn = portalArn)
  output <- .workspacesweb$disassociate_user_settings_output()
  config <- get_config()
  svc <- .workspacesweb$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspacesweb$operations$disassociate_user_settings <- workspacesweb_disassociate_user_settings

#' Expires an active secure browser session
#'
#' @description
#' Expires an active secure browser session.
#'
#' See [https://www.paws-r-sdk.com/docs/workspacesweb_expire_session/](https://www.paws-r-sdk.com/docs/workspacesweb_expire_session/) for full documentation.
#'
#' @param portalId &#91;required&#93; The ID of the web portal for the session.
#' @param sessionId &#91;required&#93; The ID of the session to expire.
#'
#' @keywords internal
#'
#' @rdname workspacesweb_expire_session
workspacesweb_expire_session <- function(portalId, sessionId) {
  op <- new_operation(
    name = "ExpireSession",
    http_method = "DELETE",
    http_path = "/portals/{portalId}/sessions/{sessionId}",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspacesweb$expire_session_input(portalId = portalId, sessionId = sessionId)
  output <- .workspacesweb$expire_session_output()
  config <- get_config()
  svc <- .workspacesweb$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspacesweb$operations$expire_session <- workspacesweb_expire_session

#' Gets browser settings
#'
#' @description
#' Gets browser settings.
#'
#' See [https://www.paws-r-sdk.com/docs/workspacesweb_get_browser_settings/](https://www.paws-r-sdk.com/docs/workspacesweb_get_browser_settings/) for full documentation.
#'
#' @param browserSettingsArn &#91;required&#93; The ARN of the browser settings.
#'
#' @keywords internal
#'
#' @rdname workspacesweb_get_browser_settings
workspacesweb_get_browser_settings <- function(browserSettingsArn) {
  op <- new_operation(
    name = "GetBrowserSettings",
    http_method = "GET",
    http_path = "/browserSettings/{browserSettingsArn+}",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspacesweb$get_browser_settings_input(browserSettingsArn = browserSettingsArn)
  output <- .workspacesweb$get_browser_settings_output()
  config <- get_config()
  svc <- .workspacesweb$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspacesweb$operations$get_browser_settings <- workspacesweb_get_browser_settings

#' Gets the data protection settings
#'
#' @description
#' Gets the data protection settings.
#'
#' See [https://www.paws-r-sdk.com/docs/workspacesweb_get_data_protection_settings/](https://www.paws-r-sdk.com/docs/workspacesweb_get_data_protection_settings/) for full documentation.
#'
#' @param dataProtectionSettingsArn &#91;required&#93; The ARN of the data protection settings.
#'
#' @keywords internal
#'
#' @rdname workspacesweb_get_data_protection_settings
workspacesweb_get_data_protection_settings <- function(dataProtectionSettingsArn) {
  op <- new_operation(
    name = "GetDataProtectionSettings",
    http_method = "GET",
    http_path = "/dataProtectionSettings/{dataProtectionSettingsArn+}",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspacesweb$get_data_protection_settings_input(dataProtectionSettingsArn = dataProtectionSettingsArn)
  output <- .workspacesweb$get_data_protection_settings_output()
  config <- get_config()
  svc <- .workspacesweb$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspacesweb$operations$get_data_protection_settings <- workspacesweb_get_data_protection_settings

#' Gets the identity provider
#'
#' @description
#' Gets the identity provider.
#'
#' See [https://www.paws-r-sdk.com/docs/workspacesweb_get_identity_provider/](https://www.paws-r-sdk.com/docs/workspacesweb_get_identity_provider/) for full documentation.
#'
#' @param identityProviderArn &#91;required&#93; The ARN of the identity provider.
#'
#' @keywords internal
#'
#' @rdname workspacesweb_get_identity_provider
workspacesweb_get_identity_provider <- function(identityProviderArn) {
  op <- new_operation(
    name = "GetIdentityProvider",
    http_method = "GET",
    http_path = "/identityProviders/{identityProviderArn+}",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspacesweb$get_identity_provider_input(identityProviderArn = identityProviderArn)
  output <- .workspacesweb$get_identity_provider_output()
  config <- get_config()
  svc <- .workspacesweb$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspacesweb$operations$get_identity_provider <- workspacesweb_get_identity_provider

#' Gets the IP access settings
#'
#' @description
#' Gets the IP access settings.
#'
#' See [https://www.paws-r-sdk.com/docs/workspacesweb_get_ip_access_settings/](https://www.paws-r-sdk.com/docs/workspacesweb_get_ip_access_settings/) for full documentation.
#'
#' @param ipAccessSettingsArn &#91;required&#93; The ARN of the IP access settings.
#'
#' @keywords internal
#'
#' @rdname workspacesweb_get_ip_access_settings
workspacesweb_get_ip_access_settings <- function(ipAccessSettingsArn) {
  op <- new_operation(
    name = "GetIpAccessSettings",
    http_method = "GET",
    http_path = "/ipAccessSettings/{ipAccessSettingsArn+}",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspacesweb$get_ip_access_settings_input(ipAccessSettingsArn = ipAccessSettingsArn)
  output <- .workspacesweb$get_ip_access_settings_output()
  config <- get_config()
  svc <- .workspacesweb$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspacesweb$operations$get_ip_access_settings <- workspacesweb_get_ip_access_settings

#' Gets the network settings
#'
#' @description
#' Gets the network settings.
#'
#' See [https://www.paws-r-sdk.com/docs/workspacesweb_get_network_settings/](https://www.paws-r-sdk.com/docs/workspacesweb_get_network_settings/) for full documentation.
#'
#' @param networkSettingsArn &#91;required&#93; The ARN of the network settings.
#'
#' @keywords internal
#'
#' @rdname workspacesweb_get_network_settings
workspacesweb_get_network_settings <- function(networkSettingsArn) {
  op <- new_operation(
    name = "GetNetworkSettings",
    http_method = "GET",
    http_path = "/networkSettings/{networkSettingsArn+}",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspacesweb$get_network_settings_input(networkSettingsArn = networkSettingsArn)
  output <- .workspacesweb$get_network_settings_output()
  config <- get_config()
  svc <- .workspacesweb$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspacesweb$operations$get_network_settings <- workspacesweb_get_network_settings

#' Gets the web portal
#'
#' @description
#' Gets the web portal.
#'
#' See [https://www.paws-r-sdk.com/docs/workspacesweb_get_portal/](https://www.paws-r-sdk.com/docs/workspacesweb_get_portal/) for full documentation.
#'
#' @param portalArn &#91;required&#93; The ARN of the web portal.
#'
#' @keywords internal
#'
#' @rdname workspacesweb_get_portal
workspacesweb_get_portal <- function(portalArn) {
  op <- new_operation(
    name = "GetPortal",
    http_method = "GET",
    http_path = "/portals/{portalArn+}",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspacesweb$get_portal_input(portalArn = portalArn)
  output <- .workspacesweb$get_portal_output()
  config <- get_config()
  svc <- .workspacesweb$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspacesweb$operations$get_portal <- workspacesweb_get_portal

#' Gets the service provider metadata
#'
#' @description
#' Gets the service provider metadata.
#'
#' See [https://www.paws-r-sdk.com/docs/workspacesweb_get_portal_service_provider_metadata/](https://www.paws-r-sdk.com/docs/workspacesweb_get_portal_service_provider_metadata/) for full documentation.
#'
#' @param portalArn &#91;required&#93; The ARN of the web portal.
#'
#' @keywords internal
#'
#' @rdname workspacesweb_get_portal_service_provider_metadata
workspacesweb_get_portal_service_provider_metadata <- function(portalArn) {
  op <- new_operation(
    name = "GetPortalServiceProviderMetadata",
    http_method = "GET",
    http_path = "/portalIdp/{portalArn+}",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspacesweb$get_portal_service_provider_metadata_input(portalArn = portalArn)
  output <- .workspacesweb$get_portal_service_provider_metadata_output()
  config <- get_config()
  svc <- .workspacesweb$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspacesweb$operations$get_portal_service_provider_metadata <- workspacesweb_get_portal_service_provider_metadata

#' Gets information for a secure browser session
#'
#' @description
#' Gets information for a secure browser session.
#'
#' See [https://www.paws-r-sdk.com/docs/workspacesweb_get_session/](https://www.paws-r-sdk.com/docs/workspacesweb_get_session/) for full documentation.
#'
#' @param portalId &#91;required&#93; The ID of the web portal for the session.
#' @param sessionId &#91;required&#93; The ID of the session.
#'
#' @keywords internal
#'
#' @rdname workspacesweb_get_session
workspacesweb_get_session <- function(portalId, sessionId) {
  op <- new_operation(
    name = "GetSession",
    http_method = "GET",
    http_path = "/portals/{portalId}/sessions/{sessionId}",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspacesweb$get_session_input(portalId = portalId, sessionId = sessionId)
  output <- .workspacesweb$get_session_output()
  config <- get_config()
  svc <- .workspacesweb$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspacesweb$operations$get_session <- workspacesweb_get_session

#' Gets details about a specific session logger resource
#'
#' @description
#' Gets details about a specific session logger resource.
#'
#' See [https://www.paws-r-sdk.com/docs/workspacesweb_get_session_logger/](https://www.paws-r-sdk.com/docs/workspacesweb_get_session_logger/) for full documentation.
#'
#' @param sessionLoggerArn &#91;required&#93; The ARN of the session logger.
#'
#' @keywords internal
#'
#' @rdname workspacesweb_get_session_logger
workspacesweb_get_session_logger <- function(sessionLoggerArn) {
  op <- new_operation(
    name = "GetSessionLogger",
    http_method = "GET",
    http_path = "/sessionLoggers/{sessionLoggerArn+}",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspacesweb$get_session_logger_input(sessionLoggerArn = sessionLoggerArn)
  output <- .workspacesweb$get_session_logger_output()
  config <- get_config()
  svc <- .workspacesweb$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspacesweb$operations$get_session_logger <- workspacesweb_get_session_logger

#' Gets the trust store
#'
#' @description
#' Gets the trust store.
#'
#' See [https://www.paws-r-sdk.com/docs/workspacesweb_get_trust_store/](https://www.paws-r-sdk.com/docs/workspacesweb_get_trust_store/) for full documentation.
#'
#' @param trustStoreArn &#91;required&#93; The ARN of the trust store.
#'
#' @keywords internal
#'
#' @rdname workspacesweb_get_trust_store
workspacesweb_get_trust_store <- function(trustStoreArn) {
  op <- new_operation(
    name = "GetTrustStore",
    http_method = "GET",
    http_path = "/trustStores/{trustStoreArn+}",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspacesweb$get_trust_store_input(trustStoreArn = trustStoreArn)
  output <- .workspacesweb$get_trust_store_output()
  config <- get_config()
  svc <- .workspacesweb$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspacesweb$operations$get_trust_store <- workspacesweb_get_trust_store

#' Gets the trust store certificate
#'
#' @description
#' Gets the trust store certificate.
#'
#' See [https://www.paws-r-sdk.com/docs/workspacesweb_get_trust_store_certificate/](https://www.paws-r-sdk.com/docs/workspacesweb_get_trust_store_certificate/) for full documentation.
#'
#' @param trustStoreArn &#91;required&#93; The ARN of the trust store certificate.
#' @param thumbprint &#91;required&#93; The thumbprint of the trust store certificate.
#'
#' @keywords internal
#'
#' @rdname workspacesweb_get_trust_store_certificate
workspacesweb_get_trust_store_certificate <- function(trustStoreArn, thumbprint) {
  op <- new_operation(
    name = "GetTrustStoreCertificate",
    http_method = "GET",
    http_path = "/trustStores/{trustStoreArn+}/certificate",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspacesweb$get_trust_store_certificate_input(trustStoreArn = trustStoreArn, thumbprint = thumbprint)
  output <- .workspacesweb$get_trust_store_certificate_output()
  config <- get_config()
  svc <- .workspacesweb$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspacesweb$operations$get_trust_store_certificate <- workspacesweb_get_trust_store_certificate

#' Gets user access logging settings
#'
#' @description
#' Gets user access logging settings.
#'
#' See [https://www.paws-r-sdk.com/docs/workspacesweb_get_user_access_logging_settings/](https://www.paws-r-sdk.com/docs/workspacesweb_get_user_access_logging_settings/) for full documentation.
#'
#' @param userAccessLoggingSettingsArn &#91;required&#93; The ARN of the user access logging settings.
#'
#' @keywords internal
#'
#' @rdname workspacesweb_get_user_access_logging_settings
workspacesweb_get_user_access_logging_settings <- function(userAccessLoggingSettingsArn) {
  op <- new_operation(
    name = "GetUserAccessLoggingSettings",
    http_method = "GET",
    http_path = "/userAccessLoggingSettings/{userAccessLoggingSettingsArn+}",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspacesweb$get_user_access_logging_settings_input(userAccessLoggingSettingsArn = userAccessLoggingSettingsArn)
  output <- .workspacesweb$get_user_access_logging_settings_output()
  config <- get_config()
  svc <- .workspacesweb$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspacesweb$operations$get_user_access_logging_settings <- workspacesweb_get_user_access_logging_settings

#' Gets user settings
#'
#' @description
#' Gets user settings.
#'
#' See [https://www.paws-r-sdk.com/docs/workspacesweb_get_user_settings/](https://www.paws-r-sdk.com/docs/workspacesweb_get_user_settings/) for full documentation.
#'
#' @param userSettingsArn &#91;required&#93; The ARN of the user settings.
#'
#' @keywords internal
#'
#' @rdname workspacesweb_get_user_settings
workspacesweb_get_user_settings <- function(userSettingsArn) {
  op <- new_operation(
    name = "GetUserSettings",
    http_method = "GET",
    http_path = "/userSettings/{userSettingsArn+}",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspacesweb$get_user_settings_input(userSettingsArn = userSettingsArn)
  output <- .workspacesweb$get_user_settings_output()
  config <- get_config()
  svc <- .workspacesweb$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspacesweb$operations$get_user_settings <- workspacesweb_get_user_settings

#' Retrieves a list of browser settings
#'
#' @description
#' Retrieves a list of browser settings.
#'
#' See [https://www.paws-r-sdk.com/docs/workspacesweb_list_browser_settings/](https://www.paws-r-sdk.com/docs/workspacesweb_list_browser_settings/) for full documentation.
#'
#' @param nextToken The pagination token used to retrieve the next page of results for this operation.
#' @param maxResults The maximum number of results to be included in the next page.
#'
#' @keywords internal
#'
#' @rdname workspacesweb_list_browser_settings
workspacesweb_list_browser_settings <- function(nextToken = NULL, maxResults = NULL) {
  op <- new_operation(
    name = "ListBrowserSettings",
    http_method = "GET",
    http_path = "/browserSettings",
    host_prefix = "",
    paginator = list(input_token = "nextToken", output_token = "nextToken", limit_key = "maxResults"),
    stream_api = FALSE
  )
  input <- .workspacesweb$list_browser_settings_input(nextToken = nextToken, maxResults = maxResults)
  output <- .workspacesweb$list_browser_settings_output()
  config <- get_config()
  svc <- .workspacesweb$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspacesweb$operations$list_browser_settings <- workspacesweb_list_browser_settings

#' Retrieves a list of data protection settings
#'
#' @description
#' Retrieves a list of data protection settings.
#'
#' See [https://www.paws-r-sdk.com/docs/workspacesweb_list_data_protection_settings/](https://www.paws-r-sdk.com/docs/workspacesweb_list_data_protection_settings/) for full documentation.
#'
#' @param nextToken The pagination token used to retrieve the next page of results for this operation.
#' @param maxResults The maximum number of results to be included in the next page.
#'
#' @keywords internal
#'
#' @rdname workspacesweb_list_data_protection_settings
workspacesweb_list_data_protection_settings <- function(nextToken = NULL, maxResults = NULL) {
  op <- new_operation(
    name = "ListDataProtectionSettings",
    http_method = "GET",
    http_path = "/dataProtectionSettings",
    host_prefix = "",
    paginator = list(input_token = "nextToken", output_token = "nextToken", limit_key = "maxResults", result_key = "dataProtectionSettings"),
    stream_api = FALSE
  )
  input <- .workspacesweb$list_data_protection_settings_input(nextToken = nextToken, maxResults = maxResults)
  output <- .workspacesweb$list_data_protection_settings_output()
  config <- get_config()
  svc <- .workspacesweb$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspacesweb$operations$list_data_protection_settings <- workspacesweb_list_data_protection_settings

#' Retrieves a list of identity providers for a specific web portal
#'
#' @description
#' Retrieves a list of identity providers for a specific web portal.
#'
#' See [https://www.paws-r-sdk.com/docs/workspacesweb_list_identity_providers/](https://www.paws-r-sdk.com/docs/workspacesweb_list_identity_providers/) for full documentation.
#'
#' @param nextToken The pagination token used to retrieve the next page of results for this operation.
#' @param maxResults The maximum number of results to be included in the next page.
#' @param portalArn &#91;required&#93; The ARN of the web portal.
#'
#' @keywords internal
#'
#' @rdname workspacesweb_list_identity_providers
workspacesweb_list_identity_providers <- function(nextToken = NULL, maxResults = NULL, portalArn) {
  op <- new_operation(
    name = "ListIdentityProviders",
    http_method = "GET",
    http_path = "/portals/{portalArn+}/identityProviders",
    host_prefix = "",
    paginator = list(input_token = "nextToken", output_token = "nextToken", limit_key = "maxResults"),
    stream_api = FALSE
  )
  input <- .workspacesweb$list_identity_providers_input(nextToken = nextToken, maxResults = maxResults, portalArn = portalArn)
  output <- .workspacesweb$list_identity_providers_output()
  config <- get_config()
  svc <- .workspacesweb$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspacesweb$operations$list_identity_providers <- workspacesweb_list_identity_providers

#' Retrieves a list of IP access settings
#'
#' @description
#' Retrieves a list of IP access settings.
#'
#' See [https://www.paws-r-sdk.com/docs/workspacesweb_list_ip_access_settings/](https://www.paws-r-sdk.com/docs/workspacesweb_list_ip_access_settings/) for full documentation.
#'
#' @param nextToken The pagination token used to retrieve the next page of results for this operation.
#' @param maxResults The maximum number of results to be included in the next page.
#'
#' @keywords internal
#'
#' @rdname workspacesweb_list_ip_access_settings
workspacesweb_list_ip_access_settings <- function(nextToken = NULL, maxResults = NULL) {
  op <- new_operation(
    name = "ListIpAccessSettings",
    http_method = "GET",
    http_path = "/ipAccessSettings",
    host_prefix = "",
    paginator = list(input_token = "nextToken", output_token = "nextToken", limit_key = "maxResults"),
    stream_api = FALSE
  )
  input <- .workspacesweb$list_ip_access_settings_input(nextToken = nextToken, maxResults = maxResults)
  output <- .workspacesweb$list_ip_access_settings_output()
  config <- get_config()
  svc <- .workspacesweb$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspacesweb$operations$list_ip_access_settings <- workspacesweb_list_ip_access_settings

#' Retrieves a list of network settings
#'
#' @description
#' Retrieves a list of network settings.
#'
#' See [https://www.paws-r-sdk.com/docs/workspacesweb_list_network_settings/](https://www.paws-r-sdk.com/docs/workspacesweb_list_network_settings/) for full documentation.
#'
#' @param nextToken The pagination token used to retrieve the next page of results for this operation.
#' @param maxResults The maximum number of results to be included in the next page.
#'
#' @keywords internal
#'
#' @rdname workspacesweb_list_network_settings
workspacesweb_list_network_settings <- function(nextToken = NULL, maxResults = NULL) {
  op <- new_operation(
    name = "ListNetworkSettings",
    http_method = "GET",
    http_path = "/networkSettings",
    host_prefix = "",
    paginator = list(input_token = "nextToken", output_token = "nextToken", limit_key = "maxResults"),
    stream_api = FALSE
  )
  input <- .workspacesweb$list_network_settings_input(nextToken = nextToken, maxResults = maxResults)
  output <- .workspacesweb$list_network_settings_output()
  config <- get_config()
  svc <- .workspacesweb$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspacesweb$operations$list_network_settings <- workspacesweb_list_network_settings

#' Retrieves a list or web portals
#'
#' @description
#' Retrieves a list or web portals.
#'
#' See [https://www.paws-r-sdk.com/docs/workspacesweb_list_portals/](https://www.paws-r-sdk.com/docs/workspacesweb_list_portals/) for full documentation.
#'
#' @param nextToken The pagination token used to retrieve the next page of results for this operation.
#' @param maxResults The maximum number of results to be included in the next page.
#'
#' @keywords internal
#'
#' @rdname workspacesweb_list_portals
workspacesweb_list_portals <- function(nextToken = NULL, maxResults = NULL) {
  op <- new_operation(
    name = "ListPortals",
    http_method = "GET",
    http_path = "/portals",
    host_prefix = "",
    paginator = list(input_token = "nextToken", output_token = "nextToken", limit_key = "maxResults"),
    stream_api = FALSE
  )
  input <- .workspacesweb$list_portals_input(nextToken = nextToken, maxResults = maxResults)
  output <- .workspacesweb$list_portals_output()
  config <- get_config()
  svc <- .workspacesweb$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspacesweb$operations$list_portals <- workspacesweb_list_portals

#' Lists all available session logger resources
#'
#' @description
#' Lists all available session logger resources.
#'
#' See [https://www.paws-r-sdk.com/docs/workspacesweb_list_session_loggers/](https://www.paws-r-sdk.com/docs/workspacesweb_list_session_loggers/) for full documentation.
#'
#' @param nextToken The pagination token used to retrieve the next page of results for this operation.
#' @param maxResults The maximum number of results to be included in the next page.
#'
#' @keywords internal
#'
#' @rdname workspacesweb_list_session_loggers
workspacesweb_list_session_loggers <- function(nextToken = NULL, maxResults = NULL) {
  op <- new_operation(
    name = "ListSessionLoggers",
    http_method = "GET",
    http_path = "/sessionLoggers",
    host_prefix = "",
    paginator = list(input_token = "nextToken", output_token = "nextToken", limit_key = "maxResults", result_key = "sessionLoggers"),
    stream_api = FALSE
  )
  input <- .workspacesweb$list_session_loggers_input(nextToken = nextToken, maxResults = maxResults)
  output <- .workspacesweb$list_session_loggers_output()
  config <- get_config()
  svc <- .workspacesweb$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspacesweb$operations$list_session_loggers <- workspacesweb_list_session_loggers

#' Lists information for multiple secure browser sessions from a specific
#' portal
#'
#' @description
#' Lists information for multiple secure browser sessions from a specific portal.
#'
#' See [https://www.paws-r-sdk.com/docs/workspacesweb_list_sessions/](https://www.paws-r-sdk.com/docs/workspacesweb_list_sessions/) for full documentation.
#'
#' @param portalId &#91;required&#93; The ID of the web portal for the sessions.
#' @param username The username of the session.
#' @param sessionId The ID of the session.
#' @param sortBy The method in which the returned sessions should be sorted.
#' @param status The status of the session.
#' @param maxResults The maximum number of results to be included in the next page.
#' @param nextToken The pagination token used to retrieve the next page of results for this operation.
#'
#' @keywords internal
#'
#' @rdname workspacesweb_list_sessions
workspacesweb_list_sessions <- function(portalId, username = NULL, sessionId = NULL, sortBy = NULL, status = NULL, maxResults = NULL, nextToken = NULL) {
  op <- new_operation(
    name = "ListSessions",
    http_method = "GET",
    http_path = "/portals/{portalId}/sessions",
    host_prefix = "",
    paginator = list(input_token = "nextToken", output_token = "nextToken", limit_key = "maxResults", result_key = "sessions"),
    stream_api = FALSE
  )
  input <- .workspacesweb$list_sessions_input(portalId = portalId, username = username, sessionId = sessionId, sortBy = sortBy, status = status, maxResults = maxResults, nextToken = nextToken)
  output <- .workspacesweb$list_sessions_output()
  config <- get_config()
  svc <- .workspacesweb$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspacesweb$operations$list_sessions <- workspacesweb_list_sessions

#' Retrieves a list of tags for a resource
#'
#' @description
#' Retrieves a list of tags for a resource.
#'
#' See [https://www.paws-r-sdk.com/docs/workspacesweb_list_tags_for_resource/](https://www.paws-r-sdk.com/docs/workspacesweb_list_tags_for_resource/) for full documentation.
#'
#' @param resourceArn &#91;required&#93; The ARN of the resource.
#'
#' @keywords internal
#'
#' @rdname workspacesweb_list_tags_for_resource
workspacesweb_list_tags_for_resource <- function(resourceArn) {
  op <- new_operation(
    name = "ListTagsForResource",
    http_method = "GET",
    http_path = "/tags/{resourceArn+}",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspacesweb$list_tags_for_resource_input(resourceArn = resourceArn)
  output <- .workspacesweb$list_tags_for_resource_output()
  config <- get_config()
  svc <- .workspacesweb$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspacesweb$operations$list_tags_for_resource <- workspacesweb_list_tags_for_resource

#' Retrieves a list of trust store certificates
#'
#' @description
#' Retrieves a list of trust store certificates.
#'
#' See [https://www.paws-r-sdk.com/docs/workspacesweb_list_trust_store_certificates/](https://www.paws-r-sdk.com/docs/workspacesweb_list_trust_store_certificates/) for full documentation.
#'
#' @param trustStoreArn &#91;required&#93; The ARN of the trust store
#' @param nextToken The pagination token used to retrieve the next page of results for this operation.
#' @param maxResults The maximum number of results to be included in the next page.
#'
#' @keywords internal
#'
#' @rdname workspacesweb_list_trust_store_certificates
workspacesweb_list_trust_store_certificates <- function(trustStoreArn, nextToken = NULL, maxResults = NULL) {
  op <- new_operation(
    name = "ListTrustStoreCertificates",
    http_method = "GET",
    http_path = "/trustStores/{trustStoreArn+}/certificates",
    host_prefix = "",
    paginator = list(input_token = "nextToken", output_token = "nextToken", limit_key = "maxResults"),
    stream_api = FALSE
  )
  input <- .workspacesweb$list_trust_store_certificates_input(trustStoreArn = trustStoreArn, nextToken = nextToken, maxResults = maxResults)
  output <- .workspacesweb$list_trust_store_certificates_output()
  config <- get_config()
  svc <- .workspacesweb$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspacesweb$operations$list_trust_store_certificates <- workspacesweb_list_trust_store_certificates

#' Retrieves a list of trust stores
#'
#' @description
#' Retrieves a list of trust stores.
#'
#' See [https://www.paws-r-sdk.com/docs/workspacesweb_list_trust_stores/](https://www.paws-r-sdk.com/docs/workspacesweb_list_trust_stores/) for full documentation.
#'
#' @param nextToken The pagination token used to retrieve the next page of results for this operation.
#' @param maxResults The maximum number of results to be included in the next page.
#'
#' @keywords internal
#'
#' @rdname workspacesweb_list_trust_stores
workspacesweb_list_trust_stores <- function(nextToken = NULL, maxResults = NULL) {
  op <- new_operation(
    name = "ListTrustStores",
    http_method = "GET",
    http_path = "/trustStores",
    host_prefix = "",
    paginator = list(input_token = "nextToken", output_token = "nextToken", limit_key = "maxResults"),
    stream_api = FALSE
  )
  input <- .workspacesweb$list_trust_stores_input(nextToken = nextToken, maxResults = maxResults)
  output <- .workspacesweb$list_trust_stores_output()
  config <- get_config()
  svc <- .workspacesweb$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspacesweb$operations$list_trust_stores <- workspacesweb_list_trust_stores

#' Retrieves a list of user access logging settings
#'
#' @description
#' Retrieves a list of user access logging settings.
#'
#' See [https://www.paws-r-sdk.com/docs/workspacesweb_list_user_access_logging_settings/](https://www.paws-r-sdk.com/docs/workspacesweb_list_user_access_logging_settings/) for full documentation.
#'
#' @param nextToken The pagination token used to retrieve the next page of results for this operation.
#' @param maxResults The maximum number of results to be included in the next page.
#'
#' @keywords internal
#'
#' @rdname workspacesweb_list_user_access_logging_settings
workspacesweb_list_user_access_logging_settings <- function(nextToken = NULL, maxResults = NULL) {
  op <- new_operation(
    name = "ListUserAccessLoggingSettings",
    http_method = "GET",
    http_path = "/userAccessLoggingSettings",
    host_prefix = "",
    paginator = list(input_token = "nextToken", output_token = "nextToken", limit_key = "maxResults"),
    stream_api = FALSE
  )
  input <- .workspacesweb$list_user_access_logging_settings_input(nextToken = nextToken, maxResults = maxResults)
  output <- .workspacesweb$list_user_access_logging_settings_output()
  config <- get_config()
  svc <- .workspacesweb$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspacesweb$operations$list_user_access_logging_settings <- workspacesweb_list_user_access_logging_settings

#' Retrieves a list of user settings
#'
#' @description
#' Retrieves a list of user settings.
#'
#' See [https://www.paws-r-sdk.com/docs/workspacesweb_list_user_settings/](https://www.paws-r-sdk.com/docs/workspacesweb_list_user_settings/) for full documentation.
#'
#' @param nextToken The pagination token used to retrieve the next page of results for this operation.
#' @param maxResults The maximum number of results to be included in the next page.
#'
#' @keywords internal
#'
#' @rdname workspacesweb_list_user_settings
workspacesweb_list_user_settings <- function(nextToken = NULL, maxResults = NULL) {
  op <- new_operation(
    name = "ListUserSettings",
    http_method = "GET",
    http_path = "/userSettings",
    host_prefix = "",
    paginator = list(input_token = "nextToken", output_token = "nextToken", limit_key = "maxResults"),
    stream_api = FALSE
  )
  input <- .workspacesweb$list_user_settings_input(nextToken = nextToken, maxResults = maxResults)
  output <- .workspacesweb$list_user_settings_output()
  config <- get_config()
  svc <- .workspacesweb$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspacesweb$operations$list_user_settings <- workspacesweb_list_user_settings

#' Adds or overwrites one or more tags for the specified resource
#'
#' @description
#' Adds or overwrites one or more tags for the specified resource.
#'
#' See [https://www.paws-r-sdk.com/docs/workspacesweb_tag_resource/](https://www.paws-r-sdk.com/docs/workspacesweb_tag_resource/) for full documentation.
#'
#' @param resourceArn &#91;required&#93; The ARN of the resource.
#' @param tags &#91;required&#93; The tags of the resource.
#' @param clientToken A unique, case-sensitive identifier that you provide to ensure the idempotency of the request. Idempotency ensures that an API request completes only once. With an idempotent request, if the original request completes successfully, subsequent retries with the same client token returns the result from the original successful request.
#' 
#' If you do not specify a client token, one is automatically generated by the Amazon Web Services SDK.
#'
#' @keywords internal
#'
#' @rdname workspacesweb_tag_resource
workspacesweb_tag_resource <- function(resourceArn, tags, clientToken = NULL) {
  op <- new_operation(
    name = "TagResource",
    http_method = "POST",
    http_path = "/tags/{resourceArn+}",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspacesweb$tag_resource_input(resourceArn = resourceArn, tags = tags, clientToken = clientToken)
  output <- .workspacesweb$tag_resource_output()
  config <- get_config()
  svc <- .workspacesweb$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspacesweb$operations$tag_resource <- workspacesweb_tag_resource

#' Removes one or more tags from the specified resource
#'
#' @description
#' Removes one or more tags from the specified resource.
#'
#' See [https://www.paws-r-sdk.com/docs/workspacesweb_untag_resource/](https://www.paws-r-sdk.com/docs/workspacesweb_untag_resource/) for full documentation.
#'
#' @param resourceArn &#91;required&#93; The ARN of the resource.
#' @param tagKeys &#91;required&#93; The list of tag keys to remove from the resource.
#'
#' @keywords internal
#'
#' @rdname workspacesweb_untag_resource
workspacesweb_untag_resource <- function(resourceArn, tagKeys) {
  op <- new_operation(
    name = "UntagResource",
    http_method = "DELETE",
    http_path = "/tags/{resourceArn+}",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspacesweb$untag_resource_input(resourceArn = resourceArn, tagKeys = tagKeys)
  output <- .workspacesweb$untag_resource_output()
  config <- get_config()
  svc <- .workspacesweb$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspacesweb$operations$untag_resource <- workspacesweb_untag_resource

#' Updates browser settings
#'
#' @description
#' Updates browser settings.
#'
#' See [https://www.paws-r-sdk.com/docs/workspacesweb_update_browser_settings/](https://www.paws-r-sdk.com/docs/workspacesweb_update_browser_settings/) for full documentation.
#'
#' @param browserSettingsArn &#91;required&#93; The ARN of the browser settings.
#' @param browserPolicy A JSON string containing Chrome Enterprise policies that will be applied to all streaming sessions.
#' @param clientToken A unique, case-sensitive identifier that you provide to ensure the idempotency of the request. Idempotency ensures that an API request completes only once. With an idempotent request, if the original request completes successfully, subsequent retries with the same client token return the result from the original successful request.
#' 
#' If you do not specify a client token, one is automatically generated by the Amazon Web Services SDK.
#' @param webContentFilteringPolicy The policy that specifies which URLs end users are allowed to access or which URLs or domain categories they are restricted from accessing for enhanced security.
#'
#' @keywords internal
#'
#' @rdname workspacesweb_update_browser_settings
workspacesweb_update_browser_settings <- function(browserSettingsArn, browserPolicy = NULL, clientToken = NULL, webContentFilteringPolicy = NULL) {
  op <- new_operation(
    name = "UpdateBrowserSettings",
    http_method = "PATCH",
    http_path = "/browserSettings/{browserSettingsArn+}",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspacesweb$update_browser_settings_input(browserSettingsArn = browserSettingsArn, browserPolicy = browserPolicy, clientToken = clientToken, webContentFilteringPolicy = webContentFilteringPolicy)
  output <- .workspacesweb$update_browser_settings_output()
  config <- get_config()
  svc <- .workspacesweb$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspacesweb$operations$update_browser_settings <- workspacesweb_update_browser_settings

#' Updates data protection settings
#'
#' @description
#' Updates data protection settings.
#'
#' See [https://www.paws-r-sdk.com/docs/workspacesweb_update_data_protection_settings/](https://www.paws-r-sdk.com/docs/workspacesweb_update_data_protection_settings/) for full documentation.
#'
#' @param dataProtectionSettingsArn &#91;required&#93; The ARN of the data protection settings.
#' @param inlineRedactionConfiguration The inline redaction configuration of the data protection settings that will be applied to all sessions.
#' @param displayName The display name of the data protection settings.
#' @param description The description of the data protection settings.
#' @param clientToken A unique, case-sensitive identifier that you provide to ensure the idempotency of the request. Idempotency ensures that an API request completes only once. With an idempotent request, if the original request completes successfully, subsequent retries with the same client token return the result from the original successful request.
#' 
#' If you do not specify a client token, one is automatically generated by the Amazon Web Services SDK.
#'
#' @keywords internal
#'
#' @rdname workspacesweb_update_data_protection_settings
workspacesweb_update_data_protection_settings <- function(dataProtectionSettingsArn, inlineRedactionConfiguration = NULL, displayName = NULL, description = NULL, clientToken = NULL) {
  op <- new_operation(
    name = "UpdateDataProtectionSettings",
    http_method = "PATCH",
    http_path = "/dataProtectionSettings/{dataProtectionSettingsArn+}",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspacesweb$update_data_protection_settings_input(dataProtectionSettingsArn = dataProtectionSettingsArn, inlineRedactionConfiguration = inlineRedactionConfiguration, displayName = displayName, description = description, clientToken = clientToken)
  output <- .workspacesweb$update_data_protection_settings_output()
  config <- get_config()
  svc <- .workspacesweb$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspacesweb$operations$update_data_protection_settings <- workspacesweb_update_data_protection_settings

#' Updates the identity provider
#'
#' @description
#' Updates the identity provider.
#'
#' See [https://www.paws-r-sdk.com/docs/workspacesweb_update_identity_provider/](https://www.paws-r-sdk.com/docs/workspacesweb_update_identity_provider/) for full documentation.
#'
#' @param identityProviderArn &#91;required&#93; The ARN of the identity provider.
#' @param identityProviderName The name of the identity provider.
#' @param identityProviderType The type of the identity provider.
#' @param identityProviderDetails The details of the identity provider. The following list describes the provider detail keys for each identity provider type.
#' 
#' -   For Google and Login with Amazon:
#' 
#'     -   `client_id`
#' 
#'     -   `client_secret`
#' 
#'     -   `authorize_scopes`
#' 
#' -   For Facebook:
#' 
#'     -   `client_id`
#' 
#'     -   `client_secret`
#' 
#'     -   `authorize_scopes`
#' 
#'     -   `api_version`
#' 
#' -   For Sign in with Apple:
#' 
#'     -   `client_id`
#' 
#'     -   `team_id`
#' 
#'     -   `key_id`
#' 
#'     -   `private_key`
#' 
#'     -   `authorize_scopes`
#' 
#' -   For OIDC providers:
#' 
#'     -   `client_id`
#' 
#'     -   `client_secret`
#' 
#'     -   `attributes_request_method`
#' 
#'     -   `oidc_issuer`
#' 
#'     -   `authorize_scopes`
#' 
#'     -   `authorize_url` *if not available from discovery URL specified by oidc_issuer key*
#' 
#'     -   `token_url` *if not available from discovery URL specified by oidc_issuer key*
#' 
#'     -   `attributes_url` *if not available from discovery URL specified by oidc_issuer key*
#' 
#'     -   `jwks_uri` *if not available from discovery URL specified by oidc_issuer key*
#' 
#' -   For SAML providers:
#' 
#'     -   `MetadataFile` OR `MetadataURL`
#' 
#'     -   `IDPSignout` (boolean) *optional*
#' 
#'     -   `IDPInit` (boolean) *optional*
#' 
#'     -   `RequestSigningAlgorithm` (string) *optional* - Only accepts `rsa-sha256`
#' 
#'     -   `EncryptedResponses` (boolean) *optional*
#' @param clientToken A unique, case-sensitive identifier that you provide to ensure the idempotency of the request. Idempotency ensures that an API request completes only once. With an idempotent request, if the original request completes successfully, subsequent retries with the same client token return the result from the original successful request.
#' 
#' If you do not specify a client token, one is automatically generated by the Amazon Web Services SDK.
#'
#' @keywords internal
#'
#' @rdname workspacesweb_update_identity_provider
workspacesweb_update_identity_provider <- function(identityProviderArn, identityProviderName = NULL, identityProviderType = NULL, identityProviderDetails = NULL, clientToken = NULL) {
  op <- new_operation(
    name = "UpdateIdentityProvider",
    http_method = "PATCH",
    http_path = "/identityProviders/{identityProviderArn+}",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspacesweb$update_identity_provider_input(identityProviderArn = identityProviderArn, identityProviderName = identityProviderName, identityProviderType = identityProviderType, identityProviderDetails = identityProviderDetails, clientToken = clientToken)
  output <- .workspacesweb$update_identity_provider_output()
  config <- get_config()
  svc <- .workspacesweb$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspacesweb$operations$update_identity_provider <- workspacesweb_update_identity_provider

#' Updates IP access settings
#'
#' @description
#' Updates IP access settings.
#'
#' See [https://www.paws-r-sdk.com/docs/workspacesweb_update_ip_access_settings/](https://www.paws-r-sdk.com/docs/workspacesweb_update_ip_access_settings/) for full documentation.
#'
#' @param ipAccessSettingsArn &#91;required&#93; The ARN of the IP access settings.
#' @param displayName The display name of the IP access settings.
#' @param description The description of the IP access settings.
#' @param ipRules The updated IP rules of the IP access settings.
#' @param clientToken A unique, case-sensitive identifier that you provide to ensure the idempotency of the request. Idempotency ensures that an API request completes only once. With an idempotent request, if the original request completes successfully, subsequent retries with the same client token return the result from the original successful request.
#' 
#' If you do not specify a client token, one is automatically generated by the Amazon Web Services SDK.
#'
#' @keywords internal
#'
#' @rdname workspacesweb_update_ip_access_settings
workspacesweb_update_ip_access_settings <- function(ipAccessSettingsArn, displayName = NULL, description = NULL, ipRules = NULL, clientToken = NULL) {
  op <- new_operation(
    name = "UpdateIpAccessSettings",
    http_method = "PATCH",
    http_path = "/ipAccessSettings/{ipAccessSettingsArn+}",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspacesweb$update_ip_access_settings_input(ipAccessSettingsArn = ipAccessSettingsArn, displayName = displayName, description = description, ipRules = ipRules, clientToken = clientToken)
  output <- .workspacesweb$update_ip_access_settings_output()
  config <- get_config()
  svc <- .workspacesweb$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspacesweb$operations$update_ip_access_settings <- workspacesweb_update_ip_access_settings

#' Updates network settings
#'
#' @description
#' Updates network settings.
#'
#' See [https://www.paws-r-sdk.com/docs/workspacesweb_update_network_settings/](https://www.paws-r-sdk.com/docs/workspacesweb_update_network_settings/) for full documentation.
#'
#' @param networkSettingsArn &#91;required&#93; The ARN of the network settings.
#' @param vpcId The VPC that streaming instances will connect to.
#' @param subnetIds The subnets in which network interfaces are created to connect streaming instances to your VPC. At least two of these subnets must be in different availability zones.
#' @param securityGroupIds One or more security groups used to control access from streaming instances to your VPC.
#' @param clientToken A unique, case-sensitive identifier that you provide to ensure the idempotency of the request. Idempotency ensures that an API request completes only once. With an idempotent request, if the original request completes successfully, subsequent retries with the same client token return the result from the original successful request.
#' 
#' If you do not specify a client token, one is automatically generated by the Amazon Web Services SDK.
#'
#' @keywords internal
#'
#' @rdname workspacesweb_update_network_settings
workspacesweb_update_network_settings <- function(networkSettingsArn, vpcId = NULL, subnetIds = NULL, securityGroupIds = NULL, clientToken = NULL) {
  op <- new_operation(
    name = "UpdateNetworkSettings",
    http_method = "PATCH",
    http_path = "/networkSettings/{networkSettingsArn+}",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspacesweb$update_network_settings_input(networkSettingsArn = networkSettingsArn, vpcId = vpcId, subnetIds = subnetIds, securityGroupIds = securityGroupIds, clientToken = clientToken)
  output <- .workspacesweb$update_network_settings_output()
  config <- get_config()
  svc <- .workspacesweb$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspacesweb$operations$update_network_settings <- workspacesweb_update_network_settings

#' Updates a web portal
#'
#' @description
#' Updates a web portal.
#'
#' See [https://www.paws-r-sdk.com/docs/workspacesweb_update_portal/](https://www.paws-r-sdk.com/docs/workspacesweb_update_portal/) for full documentation.
#'
#' @param portalArn &#91;required&#93; The ARN of the web portal.
#' @param displayName The name of the web portal. This is not visible to users who log into the web portal.
#' @param authenticationType The type of authentication integration points used when signing into the web portal. Defaults to `Standard`.
#' 
#' `Standard` web portals are authenticated directly through your identity provider. You need to call [`create_identity_provider`][workspacesweb_create_identity_provider] to integrate your identity provider with your web portal. User and group access to your web portal is controlled through your identity provider.
#' 
#' `IAM Identity Center` web portals are authenticated through IAM Identity Center. Identity sources (including external identity provider integration), plus user and group access to your web portal, can be configured in the IAM Identity Center.
#' @param instanceType The type and resources of the underlying instance.
#' @param maxConcurrentSessions The maximum number of concurrent sessions for the portal.
#' @param portalCustomDomain The custom domain of the web portal that users access in order to start streaming sessions.
#'
#' @keywords internal
#'
#' @rdname workspacesweb_update_portal
workspacesweb_update_portal <- function(portalArn, displayName = NULL, authenticationType = NULL, instanceType = NULL, maxConcurrentSessions = NULL, portalCustomDomain = NULL) {
  op <- new_operation(
    name = "UpdatePortal",
    http_method = "PUT",
    http_path = "/portals/{portalArn+}",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspacesweb$update_portal_input(portalArn = portalArn, displayName = displayName, authenticationType = authenticationType, instanceType = instanceType, maxConcurrentSessions = maxConcurrentSessions, portalCustomDomain = portalCustomDomain)
  output <- .workspacesweb$update_portal_output()
  config <- get_config()
  svc <- .workspacesweb$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspacesweb$operations$update_portal <- workspacesweb_update_portal

#' Updates the details of a session logger
#'
#' @description
#' Updates the details of a session logger.
#'
#' See [https://www.paws-r-sdk.com/docs/workspacesweb_update_session_logger/](https://www.paws-r-sdk.com/docs/workspacesweb_update_session_logger/) for full documentation.
#'
#' @param sessionLoggerArn &#91;required&#93; The ARN of the session logger to update.
#' @param eventFilter The updated eventFilter.
#' @param logConfiguration The updated logConfiguration.
#' @param displayName The updated display name.
#'
#' @keywords internal
#'
#' @rdname workspacesweb_update_session_logger
workspacesweb_update_session_logger <- function(sessionLoggerArn, eventFilter = NULL, logConfiguration = NULL, displayName = NULL) {
  op <- new_operation(
    name = "UpdateSessionLogger",
    http_method = "POST",
    http_path = "/sessionLoggers/{sessionLoggerArn+}",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspacesweb$update_session_logger_input(sessionLoggerArn = sessionLoggerArn, eventFilter = eventFilter, logConfiguration = logConfiguration, displayName = displayName)
  output <- .workspacesweb$update_session_logger_output()
  config <- get_config()
  svc <- .workspacesweb$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspacesweb$operations$update_session_logger <- workspacesweb_update_session_logger

#' Updates the trust store
#'
#' @description
#' Updates the trust store.
#'
#' See [https://www.paws-r-sdk.com/docs/workspacesweb_update_trust_store/](https://www.paws-r-sdk.com/docs/workspacesweb_update_trust_store/) for full documentation.
#'
#' @param trustStoreArn &#91;required&#93; The ARN of the trust store.
#' @param certificatesToAdd A list of CA certificates to add to the trust store.
#' @param certificatesToDelete A list of CA certificates to delete from a trust store.
#' @param clientToken A unique, case-sensitive identifier that you provide to ensure the idempotency of the request. Idempotency ensures that an API request completes only once. With an idempotent request, if the original request completes successfully, subsequent retries with the same client token return the result from the original successful request.
#' 
#' If you do not specify a client token, one is automatically generated by the Amazon Web Services SDK.
#'
#' @keywords internal
#'
#' @rdname workspacesweb_update_trust_store
workspacesweb_update_trust_store <- function(trustStoreArn, certificatesToAdd = NULL, certificatesToDelete = NULL, clientToken = NULL) {
  op <- new_operation(
    name = "UpdateTrustStore",
    http_method = "PATCH",
    http_path = "/trustStores/{trustStoreArn+}",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspacesweb$update_trust_store_input(trustStoreArn = trustStoreArn, certificatesToAdd = certificatesToAdd, certificatesToDelete = certificatesToDelete, clientToken = clientToken)
  output <- .workspacesweb$update_trust_store_output()
  config <- get_config()
  svc <- .workspacesweb$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspacesweb$operations$update_trust_store <- workspacesweb_update_trust_store

#' Updates the user access logging settings
#'
#' @description
#' Updates the user access logging settings.
#'
#' See [https://www.paws-r-sdk.com/docs/workspacesweb_update_user_access_logging_settings/](https://www.paws-r-sdk.com/docs/workspacesweb_update_user_access_logging_settings/) for full documentation.
#'
#' @param userAccessLoggingSettingsArn &#91;required&#93; The ARN of the user access logging settings.
#' @param kinesisStreamArn The ARN of the Kinesis stream.
#' @param clientToken A unique, case-sensitive identifier that you provide to ensure the idempotency of the request. Idempotency ensures that an API request completes only once. With an idempotent request, if the original request completes successfully, subsequent retries with the same client token return the result from the original successful request.
#' 
#' If you do not specify a client token, one is automatically generated by the Amazon Web Services SDK.
#'
#' @keywords internal
#'
#' @rdname workspacesweb_update_user_access_logging_settings
workspacesweb_update_user_access_logging_settings <- function(userAccessLoggingSettingsArn, kinesisStreamArn = NULL, clientToken = NULL) {
  op <- new_operation(
    name = "UpdateUserAccessLoggingSettings",
    http_method = "PATCH",
    http_path = "/userAccessLoggingSettings/{userAccessLoggingSettingsArn+}",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspacesweb$update_user_access_logging_settings_input(userAccessLoggingSettingsArn = userAccessLoggingSettingsArn, kinesisStreamArn = kinesisStreamArn, clientToken = clientToken)
  output <- .workspacesweb$update_user_access_logging_settings_output()
  config <- get_config()
  svc <- .workspacesweb$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspacesweb$operations$update_user_access_logging_settings <- workspacesweb_update_user_access_logging_settings

#' Updates the user settings
#'
#' @description
#' Updates the user settings.
#'
#' See [https://www.paws-r-sdk.com/docs/workspacesweb_update_user_settings/](https://www.paws-r-sdk.com/docs/workspacesweb_update_user_settings/) for full documentation.
#'
#' @param userSettingsArn &#91;required&#93; The ARN of the user settings.
#' @param copyAllowed Specifies whether the user can copy text from the streaming session to the local device.
#' @param pasteAllowed Specifies whether the user can paste text from the local device to the streaming session.
#' @param downloadAllowed Specifies whether the user can download files from the streaming session to the local device.
#' @param uploadAllowed Specifies whether the user can upload files from the local device to the streaming session.
#' @param printAllowed Specifies whether the user can print to the local device.
#' @param disconnectTimeoutInMinutes The amount of time that a streaming session remains active after users disconnect.
#' @param idleDisconnectTimeoutInMinutes The amount of time that users can be idle (inactive) before they are disconnected from their streaming session and the disconnect timeout interval begins.
#' @param clientToken A unique, case-sensitive identifier that you provide to ensure the idempotency of the request. Idempotency ensures that an API request completes only once. With an idempotent request, if the original request completes successfully, subsequent retries with the same client token return the result from the original successful request.
#' 
#' If you do not specify a client token, one is automatically generated by the Amazon Web Services SDK.
#' @param cookieSynchronizationConfiguration The configuration that specifies which cookies should be synchronized from the end user's local browser to the remote browser.
#' 
#' If the allowlist and blocklist are empty, the configuration becomes null.
#' @param deepLinkAllowed Specifies whether the user can use deep links that open automatically when connecting to a session.
#' @param toolbarConfiguration The configuration of the toolbar. This allows administrators to select the toolbar type and visual mode, set maximum display resolution for sessions, and choose which items are visible to end users during their sessions. If administrators do not modify these settings, end users retain control over their toolbar preferences.
#' @param brandingConfigurationInput The branding configuration that customizes the appearance of the web portal for end users. When updating user settings without an existing branding configuration, all fields (logo, favicon, localized strings, and color theme) are required except for wallpaper and terms of service. When updating user settings with an existing branding configuration, all fields are optional.
#' @param webAuthnAllowed Specifies whether the user can use WebAuthn redirection for passwordless login to websites within the streaming session.
#'
#' @keywords internal
#'
#' @rdname workspacesweb_update_user_settings
workspacesweb_update_user_settings <- function(userSettingsArn, copyAllowed = NULL, pasteAllowed = NULL, downloadAllowed = NULL, uploadAllowed = NULL, printAllowed = NULL, disconnectTimeoutInMinutes = NULL, idleDisconnectTimeoutInMinutes = NULL, clientToken = NULL, cookieSynchronizationConfiguration = NULL, deepLinkAllowed = NULL, toolbarConfiguration = NULL, brandingConfigurationInput = NULL, webAuthnAllowed = NULL) {
  op <- new_operation(
    name = "UpdateUserSettings",
    http_method = "PATCH",
    http_path = "/userSettings/{userSettingsArn+}",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workspacesweb$update_user_settings_input(userSettingsArn = userSettingsArn, copyAllowed = copyAllowed, pasteAllowed = pasteAllowed, downloadAllowed = downloadAllowed, uploadAllowed = uploadAllowed, printAllowed = printAllowed, disconnectTimeoutInMinutes = disconnectTimeoutInMinutes, idleDisconnectTimeoutInMinutes = idleDisconnectTimeoutInMinutes, clientToken = clientToken, cookieSynchronizationConfiguration = cookieSynchronizationConfiguration, deepLinkAllowed = deepLinkAllowed, toolbarConfiguration = toolbarConfiguration, brandingConfigurationInput = brandingConfigurationInput, webAuthnAllowed = webAuthnAllowed)
  output <- .workspacesweb$update_user_settings_output()
  config <- get_config()
  svc <- .workspacesweb$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workspacesweb$operations$update_user_settings <- workspacesweb_update_user_settings

# This file is generated by make.paws. Please do not edit here.
#' @importFrom paws.common get_config new_operation new_request send_request
#' @include ivschat_service.R
NULL

#' Creates an encrypted token that is used by a chat participant to
#' establish an individual WebSocket chat connection to a room
#'
#' @description
#' Creates an encrypted token that is used by a chat participant to establish an individual WebSocket chat connection to a room. When the token is used to connect to chat, the connection is valid for the session duration specified in the request. The token becomes invalid at the token-expiration timestamp included in the response.
#'
#' See [https://www.paws-r-sdk.com/docs/ivschat_create_chat_token/](https://www.paws-r-sdk.com/docs/ivschat_create_chat_token/) for full documentation.
#'
#' @param roomIdentifier &#91;required&#93; Identifier of the room that the client is trying to access. Currently this must be an ARN.
#' @param userId &#91;required&#93; Application-provided ID that uniquely identifies the user associated with this token. This can be any UTF-8 encoded text.
#' @param capabilities Set of capabilities that the user is allowed to perform in the room. Default: None (the capability to view messages is implicitly included in all requests).
#' @param sessionDurationInMinutes Session duration (in minutes), after which the session expires. Default: 60 (1 hour).
#' @param attributes Application-provided attributes to encode into the token and attach to a chat session. Map keys and values can contain UTF-8 encoded text. The maximum length of this field is 1 KB total.
#'
#' @keywords internal
#'
#' @rdname ivschat_create_chat_token
ivschat_create_chat_token <- function(roomIdentifier, userId, capabilities = NULL, sessionDurationInMinutes = NULL, attributes = NULL) {
  op <- new_operation(
    name = "CreateChatToken",
    http_method = "POST",
    http_path = "/CreateChatToken",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .ivschat$create_chat_token_input(roomIdentifier = roomIdentifier, userId = userId, capabilities = capabilities, sessionDurationInMinutes = sessionDurationInMinutes, attributes = attributes)
  output <- .ivschat$create_chat_token_output()
  config <- get_config()
  svc <- .ivschat$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.ivschat$operations$create_chat_token <- ivschat_create_chat_token

#' Creates a logging configuration that allows clients to store and record
#' sent messages
#'
#' @description
#' Creates a logging configuration that allows clients to store and record sent messages.
#'
#' See [https://www.paws-r-sdk.com/docs/ivschat_create_logging_configuration/](https://www.paws-r-sdk.com/docs/ivschat_create_logging_configuration/) for full documentation.
#'
#' @param name Logging-configuration name. The value does not need to be unique.
#' @param destinationConfiguration &#91;required&#93; A complex type that contains a destination configuration for where chat content will be logged. There can be only one type of destination (`cloudWatchLogs`, `firehose`, or `s3`) in a `destinationConfiguration`.
#' @param tags Tags to attach to the resource. Array of maps, each of the form `string:string (key:value)`. See [Best practices and strategies](https://docs.aws.amazon.com/tag-editor/latest/userguide/best-practices-and-strats.html) in *Tagging Amazon Web Services Resources and Tag Editor* for details, including restrictions that apply to tags and "Tag naming limits and requirements"; Amazon IVS Chat has no constraints on tags beyond what is documented there.
#'
#' @keywords internal
#'
#' @rdname ivschat_create_logging_configuration
ivschat_create_logging_configuration <- function(name = NULL, destinationConfiguration, tags = NULL) {
  op <- new_operation(
    name = "CreateLoggingConfiguration",
    http_method = "POST",
    http_path = "/CreateLoggingConfiguration",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .ivschat$create_logging_configuration_input(name = name, destinationConfiguration = destinationConfiguration, tags = tags)
  output <- .ivschat$create_logging_configuration_output()
  config <- get_config()
  svc <- .ivschat$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.ivschat$operations$create_logging_configuration <- ivschat_create_logging_configuration

#' Creates a room that allows clients to connect and pass messages
#'
#' @description
#' Creates a room that allows clients to connect and pass messages.
#'
#' See [https://www.paws-r-sdk.com/docs/ivschat_create_room/](https://www.paws-r-sdk.com/docs/ivschat_create_room/) for full documentation.
#'
#' @param name Room name. The value does not need to be unique.
#' @param maximumMessageRatePerSecond Maximum number of messages per second that can be sent to the room (by all clients). Default: 10.
#' @param maximumMessageLength Maximum number of characters in a single message. Messages are expected to be UTF-8 encoded and this limit applies specifically to rune/code-point count, not number of bytes. Default: 500.
#' @param messageReviewHandler Configuration information for optional review of messages.
#' @param tags Tags to attach to the resource. Array of maps, each of the form `string:string (key:value)`. See [Best practices and strategies](https://docs.aws.amazon.com/tag-editor/latest/userguide/best-practices-and-strats.html) in *Tagging Amazon Web Services Resources and Tag Editor* for details, including restrictions that apply to tags and "Tag naming limits and requirements"; Amazon IVS Chat has no constraints beyond what is documented there.
#' @param loggingConfigurationIdentifiers Array of logging-configuration identifiers attached to the room.
#'
#' @keywords internal
#'
#' @rdname ivschat_create_room
ivschat_create_room <- function(name = NULL, maximumMessageRatePerSecond = NULL, maximumMessageLength = NULL, messageReviewHandler = NULL, tags = NULL, loggingConfigurationIdentifiers = NULL) {
  op <- new_operation(
    name = "CreateRoom",
    http_method = "POST",
    http_path = "/CreateRoom",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .ivschat$create_room_input(name = name, maximumMessageRatePerSecond = maximumMessageRatePerSecond, maximumMessageLength = maximumMessageLength, messageReviewHandler = messageReviewHandler, tags = tags, loggingConfigurationIdentifiers = loggingConfigurationIdentifiers)
  output <- .ivschat$create_room_output()
  config <- get_config()
  svc <- .ivschat$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.ivschat$operations$create_room <- ivschat_create_room

#' Deletes the specified logging configuration
#'
#' @description
#' Deletes the specified logging configuration.
#'
#' See [https://www.paws-r-sdk.com/docs/ivschat_delete_logging_configuration/](https://www.paws-r-sdk.com/docs/ivschat_delete_logging_configuration/) for full documentation.
#'
#' @param identifier &#91;required&#93; Identifier of the logging configuration to be deleted.
#'
#' @keywords internal
#'
#' @rdname ivschat_delete_logging_configuration
ivschat_delete_logging_configuration <- function(identifier) {
  op <- new_operation(
    name = "DeleteLoggingConfiguration",
    http_method = "POST",
    http_path = "/DeleteLoggingConfiguration",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .ivschat$delete_logging_configuration_input(identifier = identifier)
  output <- .ivschat$delete_logging_configuration_output()
  config <- get_config()
  svc <- .ivschat$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.ivschat$operations$delete_logging_configuration <- ivschat_delete_logging_configuration

#' Sends an event to a specific room which directs clients to delete a
#' specific message; that is, unrender it from view and delete it from the
#' client’s chat history
#'
#' @description
#' Sends an event to a specific room which directs clients to delete a specific message; that is, unrender it from view and delete it from the client’s chat history. This event’s `EventName` is `aws:DELETE_MESSAGE`. This replicates the [DeleteMessage](https://docs.aws.amazon.com/ivs/latest/chatmsgapireference/actions-deletemessage-publish.html) WebSocket operation in the Amazon IVS Chat Messaging API.
#'
#' See [https://www.paws-r-sdk.com/docs/ivschat_delete_message/](https://www.paws-r-sdk.com/docs/ivschat_delete_message/) for full documentation.
#'
#' @param roomIdentifier &#91;required&#93; Identifier of the room where the message should be deleted. Currently this must be an ARN.
#' @param id &#91;required&#93; ID of the message to be deleted. This is the `Id` field in the received message (see [Message (Subscribe)](https://docs.aws.amazon.com/ivs/latest/chatmsgapireference/actions-message-subscribe.html) in the Chat Messaging API).
#' @param reason Reason for deleting the message.
#'
#' @keywords internal
#'
#' @rdname ivschat_delete_message
ivschat_delete_message <- function(roomIdentifier, id, reason = NULL) {
  op <- new_operation(
    name = "DeleteMessage",
    http_method = "POST",
    http_path = "/DeleteMessage",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .ivschat$delete_message_input(roomIdentifier = roomIdentifier, id = id, reason = reason)
  output <- .ivschat$delete_message_output()
  config <- get_config()
  svc <- .ivschat$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.ivschat$operations$delete_message <- ivschat_delete_message

#' Deletes the specified room
#'
#' @description
#' Deletes the specified room.
#'
#' See [https://www.paws-r-sdk.com/docs/ivschat_delete_room/](https://www.paws-r-sdk.com/docs/ivschat_delete_room/) for full documentation.
#'
#' @param identifier &#91;required&#93; Identifier of the room to be deleted. Currently this must be an ARN.
#'
#' @keywords internal
#'
#' @rdname ivschat_delete_room
ivschat_delete_room <- function(identifier) {
  op <- new_operation(
    name = "DeleteRoom",
    http_method = "POST",
    http_path = "/DeleteRoom",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .ivschat$delete_room_input(identifier = identifier)
  output <- .ivschat$delete_room_output()
  config <- get_config()
  svc <- .ivschat$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.ivschat$operations$delete_room <- ivschat_delete_room

#' Disconnects all connections using a specified user ID from a room
#'
#' @description
#' Disconnects all connections using a specified user ID from a room. This replicates the [DisconnectUser](https://docs.aws.amazon.com/ivs/latest/chatmsgapireference/actions-disconnectuser-publish.html) WebSocket operation in the Amazon IVS Chat Messaging API.
#'
#' See [https://www.paws-r-sdk.com/docs/ivschat_disconnect_user/](https://www.paws-r-sdk.com/docs/ivschat_disconnect_user/) for full documentation.
#'
#' @param roomIdentifier &#91;required&#93; Identifier of the room from which the user's clients should be disconnected. Currently this must be an ARN.
#' @param userId &#91;required&#93; ID of the user (connection) to disconnect from the room.
#' @param reason Reason for disconnecting the user.
#'
#' @keywords internal
#'
#' @rdname ivschat_disconnect_user
ivschat_disconnect_user <- function(roomIdentifier, userId, reason = NULL) {
  op <- new_operation(
    name = "DisconnectUser",
    http_method = "POST",
    http_path = "/DisconnectUser",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .ivschat$disconnect_user_input(roomIdentifier = roomIdentifier, userId = userId, reason = reason)
  output <- .ivschat$disconnect_user_output()
  config <- get_config()
  svc <- .ivschat$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.ivschat$operations$disconnect_user <- ivschat_disconnect_user

#' Gets the specified logging configuration
#'
#' @description
#' Gets the specified logging configuration.
#'
#' See [https://www.paws-r-sdk.com/docs/ivschat_get_logging_configuration/](https://www.paws-r-sdk.com/docs/ivschat_get_logging_configuration/) for full documentation.
#'
#' @param identifier &#91;required&#93; Identifier of the logging configuration to be retrieved.
#'
#' @keywords internal
#'
#' @rdname ivschat_get_logging_configuration
ivschat_get_logging_configuration <- function(identifier) {
  op <- new_operation(
    name = "GetLoggingConfiguration",
    http_method = "POST",
    http_path = "/GetLoggingConfiguration",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .ivschat$get_logging_configuration_input(identifier = identifier)
  output <- .ivschat$get_logging_configuration_output()
  config <- get_config()
  svc <- .ivschat$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.ivschat$operations$get_logging_configuration <- ivschat_get_logging_configuration

#' Gets the specified room
#'
#' @description
#' Gets the specified room.
#'
#' See [https://www.paws-r-sdk.com/docs/ivschat_get_room/](https://www.paws-r-sdk.com/docs/ivschat_get_room/) for full documentation.
#'
#' @param identifier &#91;required&#93; Identifier of the room for which the configuration is to be retrieved. Currently this must be an ARN.
#'
#' @keywords internal
#'
#' @rdname ivschat_get_room
ivschat_get_room <- function(identifier) {
  op <- new_operation(
    name = "GetRoom",
    http_method = "POST",
    http_path = "/GetRoom",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .ivschat$get_room_input(identifier = identifier)
  output <- .ivschat$get_room_output()
  config <- get_config()
  svc <- .ivschat$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.ivschat$operations$get_room <- ivschat_get_room

#' Gets summary information about all your logging configurations in the
#' AWS region where the API request is processed
#'
#' @description
#' Gets summary information about all your logging configurations in the AWS region where the API request is processed.
#'
#' See [https://www.paws-r-sdk.com/docs/ivschat_list_logging_configurations/](https://www.paws-r-sdk.com/docs/ivschat_list_logging_configurations/) for full documentation.
#'
#' @param nextToken The first logging configurations to retrieve. This is used for pagination; see the `nextToken` response field.
#' @param maxResults Maximum number of logging configurations to return. Default: 50.
#'
#' @keywords internal
#'
#' @rdname ivschat_list_logging_configurations
ivschat_list_logging_configurations <- function(nextToken = NULL, maxResults = NULL) {
  op <- new_operation(
    name = "ListLoggingConfigurations",
    http_method = "POST",
    http_path = "/ListLoggingConfigurations",
    host_prefix = "",
    paginator = list(input_token = "nextToken", output_token = "nextToken", limit_key = "maxResults"),
    stream_api = FALSE
  )
  input <- .ivschat$list_logging_configurations_input(nextToken = nextToken, maxResults = maxResults)
  output <- .ivschat$list_logging_configurations_output()
  config <- get_config()
  svc <- .ivschat$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.ivschat$operations$list_logging_configurations <- ivschat_list_logging_configurations

#' Gets summary information about all your rooms in the AWS region where
#' the API request is processed
#'
#' @description
#' Gets summary information about all your rooms in the AWS region where the API request is processed. Results are sorted in descending order of `updateTime`.
#'
#' See [https://www.paws-r-sdk.com/docs/ivschat_list_rooms/](https://www.paws-r-sdk.com/docs/ivschat_list_rooms/) for full documentation.
#'
#' @param name Filters the list to match the specified room name.
#' @param nextToken The first room to retrieve. This is used for pagination; see the `nextToken` response field.
#' @param maxResults Maximum number of rooms to return. Default: 50.
#' @param messageReviewHandlerUri Filters the list to match the specified message review handler URI.
#' @param loggingConfigurationIdentifier Logging-configuration identifier.
#'
#' @keywords internal
#'
#' @rdname ivschat_list_rooms
ivschat_list_rooms <- function(name = NULL, nextToken = NULL, maxResults = NULL, messageReviewHandlerUri = NULL, loggingConfigurationIdentifier = NULL) {
  op <- new_operation(
    name = "ListRooms",
    http_method = "POST",
    http_path = "/ListRooms",
    host_prefix = "",
    paginator = list(input_token = "nextToken", output_token = "nextToken", limit_key = "maxResults"),
    stream_api = FALSE
  )
  input <- .ivschat$list_rooms_input(name = name, nextToken = nextToken, maxResults = maxResults, messageReviewHandlerUri = messageReviewHandlerUri, loggingConfigurationIdentifier = loggingConfigurationIdentifier)
  output <- .ivschat$list_rooms_output()
  config <- get_config()
  svc <- .ivschat$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.ivschat$operations$list_rooms <- ivschat_list_rooms

#' Gets information about AWS tags for the specified ARN
#'
#' @description
#' Gets information about AWS tags for the specified ARN.
#'
#' See [https://www.paws-r-sdk.com/docs/ivschat_list_tags_for_resource/](https://www.paws-r-sdk.com/docs/ivschat_list_tags_for_resource/) for full documentation.
#'
#' @param resourceArn &#91;required&#93; The ARN of the resource to be retrieved. The ARN must be URL-encoded.
#'
#' @keywords internal
#'
#' @rdname ivschat_list_tags_for_resource
ivschat_list_tags_for_resource <- function(resourceArn) {
  op <- new_operation(
    name = "ListTagsForResource",
    http_method = "GET",
    http_path = "/tags/{resourceArn}",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .ivschat$list_tags_for_resource_input(resourceArn = resourceArn)
  output <- .ivschat$list_tags_for_resource_output()
  config <- get_config()
  svc <- .ivschat$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.ivschat$operations$list_tags_for_resource <- ivschat_list_tags_for_resource

#' Sends an event to a room
#'
#' @description
#' Sends an event to a room. Use this within your application’s business logic to send events to clients of a room; e.g., to notify clients to change the way the chat UI is rendered.
#'
#' See [https://www.paws-r-sdk.com/docs/ivschat_send_event/](https://www.paws-r-sdk.com/docs/ivschat_send_event/) for full documentation.
#'
#' @param roomIdentifier &#91;required&#93; Identifier of the room to which the event will be sent. Currently this must be an ARN.
#' @param eventName &#91;required&#93; Application-defined name of the event to send to clients.
#' @param attributes Application-defined metadata to attach to the event sent to clients. The maximum length of the metadata is 1 KB total.
#'
#' @keywords internal
#'
#' @rdname ivschat_send_event
ivschat_send_event <- function(roomIdentifier, eventName, attributes = NULL) {
  op <- new_operation(
    name = "SendEvent",
    http_method = "POST",
    http_path = "/SendEvent",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .ivschat$send_event_input(roomIdentifier = roomIdentifier, eventName = eventName, attributes = attributes)
  output <- .ivschat$send_event_output()
  config <- get_config()
  svc <- .ivschat$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.ivschat$operations$send_event <- ivschat_send_event

#' Adds or updates tags for the AWS resource with the specified ARN
#'
#' @description
#' Adds or updates tags for the AWS resource with the specified ARN.
#'
#' See [https://www.paws-r-sdk.com/docs/ivschat_tag_resource/](https://www.paws-r-sdk.com/docs/ivschat_tag_resource/) for full documentation.
#'
#' @param resourceArn &#91;required&#93; The ARN of the resource to be tagged. The ARN must be URL-encoded.
#' @param tags &#91;required&#93; Array of tags to be added or updated. Array of maps, each of the form `string:string (key:value)`. See [Best practices and strategies](https://docs.aws.amazon.com/tag-editor/latest/userguide/best-practices-and-strats.html) in *Tagging Amazon Web Services Resources and Tag Editor* for details, including restrictions that apply to tags and "Tag naming limits and requirements"; Amazon IVS Chat has no constraints beyond what is documented there.
#'
#' @keywords internal
#'
#' @rdname ivschat_tag_resource
ivschat_tag_resource <- function(resourceArn, tags) {
  op <- new_operation(
    name = "TagResource",
    http_method = "POST",
    http_path = "/tags/{resourceArn}",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .ivschat$tag_resource_input(resourceArn = resourceArn, tags = tags)
  output <- .ivschat$tag_resource_output()
  config <- get_config()
  svc <- .ivschat$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.ivschat$operations$tag_resource <- ivschat_tag_resource

#' Removes tags from the resource with the specified ARN
#'
#' @description
#' Removes tags from the resource with the specified ARN.
#'
#' See [https://www.paws-r-sdk.com/docs/ivschat_untag_resource/](https://www.paws-r-sdk.com/docs/ivschat_untag_resource/) for full documentation.
#'
#' @param resourceArn &#91;required&#93; The ARN of the resource to be untagged. The ARN must be URL-encoded.
#' @param tagKeys &#91;required&#93; Array of tags to be removed. Array of maps, each of the form `string:string (key:value)`. See [Best practices and strategies](https://docs.aws.amazon.com/tag-editor/latest/userguide/best-practices-and-strats.html) in *Tagging Amazon Web Services Resources and Tag Editor* for details, including restrictions that apply to tags and "Tag naming limits and requirements"; Amazon IVS Chat has no constraints beyond what is documented there.
#'
#' @keywords internal
#'
#' @rdname ivschat_untag_resource
ivschat_untag_resource <- function(resourceArn, tagKeys) {
  op <- new_operation(
    name = "UntagResource",
    http_method = "DELETE",
    http_path = "/tags/{resourceArn}",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .ivschat$untag_resource_input(resourceArn = resourceArn, tagKeys = tagKeys)
  output <- .ivschat$untag_resource_output()
  config <- get_config()
  svc <- .ivschat$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.ivschat$operations$untag_resource <- ivschat_untag_resource

#' Updates a specified logging configuration
#'
#' @description
#' Updates a specified logging configuration.
#'
#' See [https://www.paws-r-sdk.com/docs/ivschat_update_logging_configuration/](https://www.paws-r-sdk.com/docs/ivschat_update_logging_configuration/) for full documentation.
#'
#' @param identifier &#91;required&#93; Identifier of the logging configuration to be updated.
#' @param name Logging-configuration name. The value does not need to be unique.
#' @param destinationConfiguration A complex type that contains a destination configuration for where chat content will be logged. There can be only one type of destination (`cloudWatchLogs`, `firehose`, or `s3`) in a `destinationConfiguration`.
#'
#' @keywords internal
#'
#' @rdname ivschat_update_logging_configuration
ivschat_update_logging_configuration <- function(identifier, name = NULL, destinationConfiguration = NULL) {
  op <- new_operation(
    name = "UpdateLoggingConfiguration",
    http_method = "POST",
    http_path = "/UpdateLoggingConfiguration",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .ivschat$update_logging_configuration_input(identifier = identifier, name = name, destinationConfiguration = destinationConfiguration)
  output <- .ivschat$update_logging_configuration_output()
  config <- get_config()
  svc <- .ivschat$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.ivschat$operations$update_logging_configuration <- ivschat_update_logging_configuration

#' Updates a room’s configuration
#'
#' @description
#' Updates a room’s configuration.
#'
#' See [https://www.paws-r-sdk.com/docs/ivschat_update_room/](https://www.paws-r-sdk.com/docs/ivschat_update_room/) for full documentation.
#'
#' @param identifier &#91;required&#93; Identifier of the room to be updated. Currently this must be an ARN.
#' @param name Room name. The value does not need to be unique.
#' @param maximumMessageRatePerSecond Maximum number of messages per second that can be sent to the room (by all clients). Default: 10.
#' @param maximumMessageLength The maximum number of characters in a single message. Messages are expected to be UTF-8 encoded and this limit applies specifically to rune/code-point count, not number of bytes. Default: 500.
#' @param messageReviewHandler Configuration information for optional review of messages. Specify an empty `uri` string to disassociate a message review handler from the specified room.
#' @param loggingConfigurationIdentifiers Array of logging-configuration identifiers attached to the room.
#'
#' @keywords internal
#'
#' @rdname ivschat_update_room
ivschat_update_room <- function(identifier, name = NULL, maximumMessageRatePerSecond = NULL, maximumMessageLength = NULL, messageReviewHandler = NULL, loggingConfigurationIdentifiers = NULL) {
  op <- new_operation(
    name = "UpdateRoom",
    http_method = "POST",
    http_path = "/UpdateRoom",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .ivschat$update_room_input(identifier = identifier, name = name, maximumMessageRatePerSecond = maximumMessageRatePerSecond, maximumMessageLength = maximumMessageLength, messageReviewHandler = messageReviewHandler, loggingConfigurationIdentifiers = loggingConfigurationIdentifiers)
  output <- .ivschat$update_room_output()
  config <- get_config()
  svc <- .ivschat$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.ivschat$operations$update_room <- ivschat_update_room

# This file is generated by make.paws. Please do not edit here.
#' @importFrom paws.common new_handlers new_service set_config merge_config
NULL

#' Amazon WorkMail
#'
#' @description
#' WorkMail is a secure, managed business email and calendaring service with support for existing desktop and mobile email clients. You can access your email, contacts, and calendars using Microsoft Outlook, your browser, or other native iOS and Android email applications. You can integrate WorkMail with your existing corporate directory and control both the keys that encrypt your data and the location in which your data is stored.
#' 
#' The WorkMail API is designed for the following scenarios:
#' 
#' -   Listing and describing organizations
#' 
#' 
#' -   Managing users
#' 
#' 
#' -   Managing groups
#' 
#' 
#' -   Managing resources
#' 
#' All WorkMail API operations are Amazon-authenticated and certificate-signed. They not only require the use of the AWS SDK, but also allow for the exclusive use of AWS Identity and Access Management users and roles to help facilitate access, trust, and permission policies. By creating a role and allowing an IAM user to access the WorkMail site, the IAM user gains full administrative visibility into the entire WorkMail organization (or as set in the IAM policy). This includes, but is not limited to, the ability to create, update, and delete users, groups, and resources. This allows developers to perform the scenarios listed above, as well as give users the ability to grant access on a selective basis using the IAM model.
#'
#' @param
#' config
#' Optional configuration of credentials, endpoint, and/or region.
#' \itemize{
#' \item{\strong{credentials}: \itemize{
#' \item{\strong{creds}: \itemize{
#' \item{\strong{access_key_id}: AWS access key ID}
#' \item{\strong{secret_access_key}: AWS secret access key}
#' \item{\strong{session_token}: AWS temporary session token}
#' }}
#' \item{\strong{profile}: The name of a profile to use. If not given, then the default profile is used.}
#' \item{\strong{anonymous}: Set anonymous credentials.}
#' }}
#' \item{\strong{endpoint}: The complete URL to use for the constructed client.}
#' \item{\strong{region}: The AWS Region used in instantiating the client.}
#' \item{\strong{close_connection}: Immediately close all HTTP connections.}
#' \item{\strong{timeout}: The time in seconds till a timeout exception is thrown when attempting to make a connection. The default is 60 seconds.}
#' \item{\strong{s3_force_path_style}: Set this to `true` to force the request to use path-style addressing, i.e. `http://s3.amazonaws.com/BUCKET/KEY`.}
#' \item{\strong{sts_regional_endpoint}: Set sts regional endpoint resolver to regional or legacy \url{https://docs.aws.amazon.com/sdkref/latest/guide/feature-sts-regionalized-endpoints.html}}
#' }
#' @param
#' credentials
#' Optional credentials shorthand for the config parameter
#' \itemize{
#' \item{\strong{creds}: \itemize{
#' \item{\strong{access_key_id}: AWS access key ID}
#' \item{\strong{secret_access_key}: AWS secret access key}
#' \item{\strong{session_token}: AWS temporary session token}
#' }}
#' \item{\strong{profile}: The name of a profile to use. If not given, then the default profile is used.}
#' \item{\strong{anonymous}: Set anonymous credentials.}
#' }
#' @param
#' endpoint
#' Optional shorthand for complete URL to use for the constructed client.
#' @param
#' region
#' Optional shorthand for AWS Region used in instantiating the client.
#'
#' @section Service syntax:
#' ```
#' svc <- workmail(
#'   config = list(
#'     credentials = list(
#'       creds = list(
#'         access_key_id = "string",
#'         secret_access_key = "string",
#'         session_token = "string"
#'       ),
#'       profile = "string",
#'       anonymous = "logical"
#'     ),
#'     endpoint = "string",
#'     region = "string",
#'     close_connection = "logical",
#'     timeout = "numeric",
#'     s3_force_path_style = "logical",
#'     sts_regional_endpoint = "string"
#'   ),
#'   credentials = list(
#'     creds = list(
#'       access_key_id = "string",
#'       secret_access_key = "string",
#'       session_token = "string"
#'     ),
#'     profile = "string",
#'     anonymous = "logical"
#'   ),
#'   endpoint = "string",
#'   region = "string"
#' )
#' ```
#'
#' @examples
#' \dontrun{
#' svc <- workmail()
#' svc$associate_delegate_to_resource(
#'   Foo = 123
#' )
#' }
#'
#' @section Operations:
#' \tabular{ll}{
#'  \link[=workmail_associate_delegate_to_resource]{associate_delegate_to_resource} \tab Adds a member (user or group) to the resource's set of delegates\cr
#'  \link[=workmail_associate_member_to_group]{associate_member_to_group} \tab Adds a member (user or group) to the group's set\cr
#'  \link[=workmail_assume_impersonation_role]{assume_impersonation_role} \tab Assumes an impersonation role for the given WorkMail organization\cr
#'  \link[=workmail_cancel_mailbox_export_job]{cancel_mailbox_export_job} \tab Cancels a mailbox export job\cr
#'  \link[=workmail_create_alias]{create_alias} \tab Adds an alias to the set of a given member (user or group) of WorkMail\cr
#'  \link[=workmail_create_availability_configuration]{create_availability_configuration} \tab Creates an AvailabilityConfiguration for the given WorkMail organization and domain\cr
#'  \link[=workmail_create_group]{create_group} \tab Creates a group that can be used in WorkMail by calling the RegisterToWorkMail operation\cr
#'  \link[=workmail_create_identity_center_application]{create_identity_center_application} \tab Creates the WorkMail application in IAM Identity Center that can be used later in the WorkMail - IdC integration\cr
#'  \link[=workmail_create_impersonation_role]{create_impersonation_role} \tab Creates an impersonation role for the given WorkMail organization\cr
#'  \link[=workmail_create_mobile_device_access_rule]{create_mobile_device_access_rule} \tab Creates a new mobile device access rule for the specified WorkMail organization\cr
#'  \link[=workmail_create_organization]{create_organization} \tab Creates a new WorkMail organization\cr
#'  \link[=workmail_create_resource]{create_resource} \tab Creates a new WorkMail resource\cr
#'  \link[=workmail_create_user]{create_user} \tab Creates a user who can be used in WorkMail by calling the RegisterToWorkMail operation\cr
#'  \link[=workmail_delete_access_control_rule]{delete_access_control_rule} \tab Deletes an access control rule for the specified WorkMail organization\cr
#'  \link[=workmail_delete_alias]{delete_alias} \tab Remove one or more specified aliases from a set of aliases for a given user\cr
#'  \link[=workmail_delete_availability_configuration]{delete_availability_configuration} \tab Deletes the AvailabilityConfiguration for the given WorkMail organization and domain\cr
#'  \link[=workmail_delete_email_monitoring_configuration]{delete_email_monitoring_configuration} \tab Deletes the email monitoring configuration for a specified organization\cr
#'  \link[=workmail_delete_group]{delete_group} \tab Deletes a group from WorkMail\cr
#'  \link[=workmail_delete_identity_center_application]{delete_identity_center_application} \tab Deletes the IAM Identity Center application from WorkMail\cr
#'  \link[=workmail_delete_identity_provider_configuration]{delete_identity_provider_configuration} \tab Disables the integration between IdC and WorkMail\cr
#'  \link[=workmail_delete_impersonation_role]{delete_impersonation_role} \tab Deletes an impersonation role for the given WorkMail organization\cr
#'  \link[=workmail_delete_mailbox_permissions]{delete_mailbox_permissions} \tab Deletes permissions granted to a member (user or group)\cr
#'  \link[=workmail_delete_mobile_device_access_override]{delete_mobile_device_access_override} \tab Deletes the mobile device access override for the given WorkMail organization, user, and device\cr
#'  \link[=workmail_delete_mobile_device_access_rule]{delete_mobile_device_access_rule} \tab Deletes a mobile device access rule for the specified WorkMail organization\cr
#'  \link[=workmail_delete_organization]{delete_organization} \tab Deletes an WorkMail organization and all underlying AWS resources managed by WorkMail as part of the organization\cr
#'  \link[=workmail_delete_personal_access_token]{delete_personal_access_token} \tab Deletes the Personal Access Token from the provided WorkMail Organization\cr
#'  \link[=workmail_delete_resource]{delete_resource} \tab Deletes the specified resource\cr
#'  \link[=workmail_delete_retention_policy]{delete_retention_policy} \tab Deletes the specified retention policy from the specified organization\cr
#'  \link[=workmail_delete_user]{delete_user} \tab Deletes a user from WorkMail and all subsequent systems\cr
#'  \link[=workmail_deregister_from_work_mail]{deregister_from_work_mail} \tab Mark a user, group, or resource as no longer used in WorkMail\cr
#'  \link[=workmail_deregister_mail_domain]{deregister_mail_domain} \tab Removes a domain from WorkMail, stops email routing to WorkMail, and removes the authorization allowing WorkMail use\cr
#'  \link[=workmail_describe_email_monitoring_configuration]{describe_email_monitoring_configuration} \tab Describes the current email monitoring configuration for a specified organization\cr
#'  \link[=workmail_describe_entity]{describe_entity} \tab Returns basic details about an entity in WorkMail\cr
#'  \link[=workmail_describe_group]{describe_group} \tab Returns the data available for the group\cr
#'  \link[=workmail_describe_identity_provider_configuration]{describe_identity_provider_configuration} \tab Returns detailed information on the current IdC setup for the WorkMail organization\cr
#'  \link[=workmail_describe_inbound_dmarc_settings]{describe_inbound_dmarc_settings} \tab Lists the settings in a DMARC policy for a specified organization\cr
#'  \link[=workmail_describe_mailbox_export_job]{describe_mailbox_export_job} \tab Describes the current status of a mailbox export job\cr
#'  \link[=workmail_describe_organization]{describe_organization} \tab Provides more information regarding a given organization based on its identifier\cr
#'  \link[=workmail_describe_resource]{describe_resource} \tab Returns the data available for the resource\cr
#'  \link[=workmail_describe_user]{describe_user} \tab Provides information regarding the user\cr
#'  \link[=workmail_disassociate_delegate_from_resource]{disassociate_delegate_from_resource} \tab Removes a member from the resource's set of delegates\cr
#'  \link[=workmail_disassociate_member_from_group]{disassociate_member_from_group} \tab Removes a member from a group\cr
#'  \link[=workmail_get_access_control_effect]{get_access_control_effect} \tab Gets the effects of an organization's access control rules as they apply to a specified IPv4 address, access protocol action, and user ID or impersonation role ID\cr
#'  \link[=workmail_get_default_retention_policy]{get_default_retention_policy} \tab Gets the default retention policy details for the specified organization\cr
#'  \link[=workmail_get_impersonation_role]{get_impersonation_role} \tab Gets the impersonation role details for the given WorkMail organization\cr
#'  \link[=workmail_get_impersonation_role_effect]{get_impersonation_role_effect} \tab Tests whether the given impersonation role can impersonate a target user\cr
#'  \link[=workmail_get_mailbox_details]{get_mailbox_details} \tab Requests a user's mailbox details for a specified organization and user\cr
#'  \link[=workmail_get_mail_domain]{get_mail_domain} \tab Gets details for a mail domain, including domain records required to configure your domain with recommended security\cr
#'  \link[=workmail_get_mobile_device_access_effect]{get_mobile_device_access_effect} \tab Simulates the effect of the mobile device access rules for the given attributes of a sample access event\cr
#'  \link[=workmail_get_mobile_device_access_override]{get_mobile_device_access_override} \tab Gets the mobile device access override for the given WorkMail organization, user, and device\cr
#'  \link[=workmail_get_personal_access_token_metadata]{get_personal_access_token_metadata} \tab Requests details of a specific Personal Access Token within the WorkMail organization\cr
#'  \link[=workmail_list_access_control_rules]{list_access_control_rules} \tab Lists the access control rules for the specified organization\cr
#'  \link[=workmail_list_aliases]{list_aliases} \tab Creates a paginated call to list the aliases associated with a given entity\cr
#'  \link[=workmail_list_availability_configurations]{list_availability_configurations} \tab List all the AvailabilityConfiguration's for the given WorkMail organization\cr
#'  \link[=workmail_list_group_members]{list_group_members} \tab Returns an overview of the members of a group\cr
#'  \link[=workmail_list_groups]{list_groups} \tab Returns summaries of the organization's groups\cr
#'  \link[=workmail_list_groups_for_entity]{list_groups_for_entity} \tab Returns all the groups to which an entity belongs\cr
#'  \link[=workmail_list_impersonation_roles]{list_impersonation_roles} \tab Lists all the impersonation roles for the given WorkMail organization\cr
#'  \link[=workmail_list_mailbox_export_jobs]{list_mailbox_export_jobs} \tab Lists the mailbox export jobs started for the specified organization within the last seven days\cr
#'  \link[=workmail_list_mailbox_permissions]{list_mailbox_permissions} \tab Lists the mailbox permissions associated with a user, group, or resource mailbox\cr
#'  \link[=workmail_list_mail_domains]{list_mail_domains} \tab Lists the mail domains in a given WorkMail organization\cr
#'  \link[=workmail_list_mobile_device_access_overrides]{list_mobile_device_access_overrides} \tab Lists all the mobile device access overrides for any given combination of WorkMail organization, user, or device\cr
#'  \link[=workmail_list_mobile_device_access_rules]{list_mobile_device_access_rules} \tab Lists the mobile device access rules for the specified WorkMail organization\cr
#'  \link[=workmail_list_organizations]{list_organizations} \tab Returns summaries of the customer's organizations\cr
#'  \link[=workmail_list_personal_access_tokens]{list_personal_access_tokens} \tab Returns a summary of your Personal Access Tokens\cr
#'  \link[=workmail_list_resource_delegates]{list_resource_delegates} \tab Lists the delegates associated with a resource\cr
#'  \link[=workmail_list_resources]{list_resources} \tab Returns summaries of the organization's resources\cr
#'  \link[=workmail_list_tags_for_resource]{list_tags_for_resource} \tab Lists the tags applied to an WorkMail organization resource\cr
#'  \link[=workmail_list_users]{list_users} \tab Returns summaries of the organization's users\cr
#'  \link[=workmail_put_access_control_rule]{put_access_control_rule} \tab Adds a new access control rule for the specified organization\cr
#'  \link[=workmail_put_email_monitoring_configuration]{put_email_monitoring_configuration} \tab Creates or updates the email monitoring configuration for a specified organization\cr
#'  \link[=workmail_put_identity_provider_configuration]{put_identity_provider_configuration} \tab Enables integration between IAM Identity Center (IdC) and WorkMail to proxy authentication requests for mailbox users\cr
#'  \link[=workmail_put_inbound_dmarc_settings]{put_inbound_dmarc_settings} \tab Enables or disables a DMARC policy for a given organization\cr
#'  \link[=workmail_put_mailbox_permissions]{put_mailbox_permissions} \tab Sets permissions for a user, group, or resource\cr
#'  \link[=workmail_put_mobile_device_access_override]{put_mobile_device_access_override} \tab Creates or updates a mobile device access override for the given WorkMail organization, user, and device\cr
#'  \link[=workmail_put_retention_policy]{put_retention_policy} \tab Puts a retention policy to the specified organization\cr
#'  \link[=workmail_register_mail_domain]{register_mail_domain} \tab Registers a new domain in WorkMail and SES, and configures it for use by WorkMail\cr
#'  \link[=workmail_register_to_work_mail]{register_to_work_mail} \tab Registers an existing and disabled user, group, or resource for WorkMail use by associating a mailbox and calendaring capabilities\cr
#'  \link[=workmail_reset_password]{reset_password} \tab Allows the administrator to reset the password for a user\cr
#'  \link[=workmail_start_mailbox_export_job]{start_mailbox_export_job} \tab Starts a mailbox export job to export MIME-format email messages and calendar items from the specified mailbox to the specified Amazon Simple Storage Service (Amazon S3) bucket\cr
#'  \link[=workmail_tag_resource]{tag_resource} \tab Applies the specified tags to the specified WorkMailorganization resource\cr
#'  \link[=workmail_test_availability_configuration]{test_availability_configuration} \tab Performs a test on an availability provider to ensure that access is allowed\cr
#'  \link[=workmail_untag_resource]{untag_resource} \tab Untags the specified tags from the specified WorkMail organization resource\cr
#'  \link[=workmail_update_availability_configuration]{update_availability_configuration} \tab Updates an existing AvailabilityConfiguration for the given WorkMail organization and domain\cr
#'  \link[=workmail_update_default_mail_domain]{update_default_mail_domain} \tab Updates the default mail domain for an organization\cr
#'  \link[=workmail_update_group]{update_group} \tab Updates attributes in a group\cr
#'  \link[=workmail_update_impersonation_role]{update_impersonation_role} \tab Updates an impersonation role for the given WorkMail organization\cr
#'  \link[=workmail_update_mailbox_quota]{update_mailbox_quota} \tab Updates a user's current mailbox quota for a specified organization and user\cr
#'  \link[=workmail_update_mobile_device_access_rule]{update_mobile_device_access_rule} \tab Updates a mobile device access rule for the specified WorkMail organization\cr
#'  \link[=workmail_update_primary_email_address]{update_primary_email_address} \tab Updates the primary email for a user, group, or resource\cr
#'  \link[=workmail_update_resource]{update_resource} \tab Updates data for the resource\cr
#'  \link[=workmail_update_user]{update_user} \tab Updates data for the user
#' }
#'
#' @return
#' A client for the service. You can call the service's operations using
#' syntax like `svc$operation(...)`, where `svc` is the name you've assigned
#' to the client. The available operations are listed in the
#' Operations section.
#'
#' @rdname workmail
#' @export
workmail <- function(config = list(), credentials = list(), endpoint = NULL, region = NULL) {
  config <- merge_config(
    config,
    list(
      credentials = credentials,
      endpoint = endpoint,
      region = region
    )
  )
  svc <- .workmail$operations
  svc <- set_config(svc, config)
  return(svc)
}

# Private API objects: metadata, handlers, interfaces, etc.
.workmail <- list()

.workmail$operations <- list()

.workmail$metadata <- list(
  service_name = "workmail",
  endpoints = list("^(us|eu|ap|sa|ca|me|af|il|mx)\\-\\w+\\-\\d+$" = list(endpoint = "workmail.{region}.amazonaws.com", global = FALSE), "^cn\\-\\w+\\-\\d+$" = list(endpoint = "workmail.{region}.amazonaws.com.cn", global = FALSE), "^us\\-gov\\-\\w+\\-\\d+$" = list(endpoint = "workmail.{region}.amazonaws.com", global = FALSE), "^us\\-iso\\-\\w+\\-\\d+$" = list(endpoint = "workmail.{region}.c2s.ic.gov", global = FALSE), "^us\\-isob\\-\\w+\\-\\d+$" = list(endpoint = "workmail.{region}.sc2s.sgov.gov", global = FALSE), "^eu\\-isoe\\-\\w+\\-\\d+$" = list(endpoint = "workmail.{region}.cloud.adc-e.uk", global = FALSE), "^us\\-isof\\-\\w+\\-\\d+$" = list(endpoint = "workmail.{region}.csp.hci.ic.gov", global = FALSE), "^eusc\\-(de)\\-\\w+\\-\\d+$" = list(endpoint = "workmail.{region}.amazonaws.eu", global = FALSE)),
  service_id = "WorkMail",
  api_version = "2017-10-01",
  signing_name = "workmail",
  json_version = "1.1",
  target_prefix = "WorkMailService"
)

.workmail$service <- function(config = list(), op = NULL) {
  handlers <- new_handlers("jsonrpc", "v4")
  new_service(.workmail$metadata, handlers, config, op)
}

svc <- paws::workmail()

test_that("list_organizations", {
  expect_error(svc$list_organizations(), NA)
})

test_that("list_organizations", {
  expect_error(svc$list_organizations(MaxResults = 20), NA)
})

# This file is generated by make.paws. Please do not edit here.
#' @importFrom paws.common new_handlers new_service set_config merge_config
NULL

#' AWS Chatbot
#'
#' @description
#' The *AWS Chatbot API Reference* provides descriptions, API request parameters, and the XML response for each of the AWS Chatbot API actions.
#' 
#' AWS Chatbot APIs are currently available in the following Regions:
#' 
#' -   US East (Ohio) - `us-east-2`
#' 
#' -   US West (Oregon) - `us-west-2`
#' 
#' -   Asia Pacific (Singapore) - `ap-southeast-1`
#' 
#' -   Europe (Ireland) - `eu-west-1`
#' 
#' The AWS Chatbot console can only be used in US East (Ohio). Your configuration data however, is stored in each of the relevant available Regions.
#' 
#' Your AWS CloudTrail events are logged in whatever Region you call from, not US East (N. Virginia) by default.
#'
#' @param
#' config
#' Optional configuration of credentials, endpoint, and/or region.
#' \itemize{
#' \item{\strong{credentials}: \itemize{
#' \item{\strong{creds}: \itemize{
#' \item{\strong{access_key_id}: AWS access key ID}
#' \item{\strong{secret_access_key}: AWS secret access key}
#' \item{\strong{session_token}: AWS temporary session token}
#' }}
#' \item{\strong{profile}: The name of a profile to use. If not given, then the default profile is used.}
#' \item{\strong{anonymous}: Set anonymous credentials.}
#' }}
#' \item{\strong{endpoint}: The complete URL to use for the constructed client.}
#' \item{\strong{region}: The AWS Region used in instantiating the client.}
#' \item{\strong{close_connection}: Immediately close all HTTP connections.}
#' \item{\strong{timeout}: The time in seconds till a timeout exception is thrown when attempting to make a connection. The default is 60 seconds.}
#' \item{\strong{s3_force_path_style}: Set this to `true` to force the request to use path-style addressing, i.e. `http://s3.amazonaws.com/BUCKET/KEY`.}
#' \item{\strong{sts_regional_endpoint}: Set sts regional endpoint resolver to regional or legacy \url{https://docs.aws.amazon.com/sdkref/latest/guide/feature-sts-regionalized-endpoints.html}}
#' }
#' @param
#' credentials
#' Optional credentials shorthand for the config parameter
#' \itemize{
#' \item{\strong{creds}: \itemize{
#' \item{\strong{access_key_id}: AWS access key ID}
#' \item{\strong{secret_access_key}: AWS secret access key}
#' \item{\strong{session_token}: AWS temporary session token}
#' }}
#' \item{\strong{profile}: The name of a profile to use. If not given, then the default profile is used.}
#' \item{\strong{anonymous}: Set anonymous credentials.}
#' }
#' @param
#' endpoint
#' Optional shorthand for complete URL to use for the constructed client.
#' @param
#' region
#' Optional shorthand for AWS Region used in instantiating the client.
#'
#' @section Service syntax:
#' ```
#' svc <- chatbot(
#'   config = list(
#'     credentials = list(
#'       creds = list(
#'         access_key_id = "string",
#'         secret_access_key = "string",
#'         session_token = "string"
#'       ),
#'       profile = "string",
#'       anonymous = "logical"
#'     ),
#'     endpoint = "string",
#'     region = "string",
#'     close_connection = "logical",
#'     timeout = "numeric",
#'     s3_force_path_style = "logical",
#'     sts_regional_endpoint = "string"
#'   ),
#'   credentials = list(
#'     creds = list(
#'       access_key_id = "string",
#'       secret_access_key = "string",
#'       session_token = "string"
#'     ),
#'     profile = "string",
#'     anonymous = "logical"
#'   ),
#'   endpoint = "string",
#'   region = "string"
#' )
#' ```
#'
#' @examples
#' \dontrun{
#' svc <- chatbot()
#' svc$associate_to_configuration(
#'   Foo = 123
#' )
#' }
#'
#' @section Operations:
#' \tabular{ll}{
#'  \link[=chatbot_associate_to_configuration]{associate_to_configuration} \tab Links a resource (for example, a custom action) to a channel configuration\cr
#'  \link[=chatbot_create_chime_webhook_configuration]{create_chime_webhook_configuration} \tab Creates an AWS Chatbot configuration for Amazon Chime\cr
#'  \link[=chatbot_create_custom_action]{create_custom_action} \tab Creates a custom action that can be invoked as an alias or as a button on a notification\cr
#'  \link[=chatbot_create_microsoft_teams_channel_configuration]{create_microsoft_teams_channel_configuration} \tab Creates an AWS Chatbot configuration for Microsoft Teams\cr
#'  \link[=chatbot_create_slack_channel_configuration]{create_slack_channel_configuration} \tab Creates an AWS Chatbot confugration for Slack\cr
#'  \link[=chatbot_delete_chime_webhook_configuration]{delete_chime_webhook_configuration} \tab Deletes a Amazon Chime webhook configuration for AWS Chatbot\cr
#'  \link[=chatbot_delete_custom_action]{delete_custom_action} \tab Deletes a custom action\cr
#'  \link[=chatbot_delete_microsoft_teams_channel_configuration]{delete_microsoft_teams_channel_configuration} \tab Deletes a Microsoft Teams channel configuration for AWS Chatbot\cr
#'  \link[=chatbot_delete_microsoft_teams_configured_team]{delete_microsoft_teams_configured_team} \tab Deletes the Microsoft Teams team authorization allowing for channels to be configured in that Microsoft Teams team\cr
#'  \link[=chatbot_delete_microsoft_teams_user_identity]{delete_microsoft_teams_user_identity} \tab Identifes a user level permission for a channel configuration\cr
#'  \link[=chatbot_delete_slack_channel_configuration]{delete_slack_channel_configuration} \tab Deletes a Slack channel configuration for AWS Chatbot\cr
#'  \link[=chatbot_delete_slack_user_identity]{delete_slack_user_identity} \tab Deletes a user level permission for a Slack channel configuration\cr
#'  \link[=chatbot_delete_slack_workspace_authorization]{delete_slack_workspace_authorization} \tab Deletes the Slack workspace authorization that allows channels to be configured in that workspace\cr
#'  \link[=chatbot_describe_chime_webhook_configurations]{describe_chime_webhook_configurations} \tab Lists Amazon Chime webhook configurations optionally filtered by ChatConfigurationArn\cr
#'  \link[=chatbot_describe_slack_channel_configurations]{describe_slack_channel_configurations} \tab Lists Slack channel configurations optionally filtered by ChatConfigurationArn\cr
#'  \link[=chatbot_describe_slack_user_identities]{describe_slack_user_identities} \tab Lists all Slack user identities with a mapped role\cr
#'  \link[=chatbot_describe_slack_workspaces]{describe_slack_workspaces} \tab List all authorized Slack workspaces connected to the AWS Account onboarded with AWS Chatbot\cr
#'  \link[=chatbot_disassociate_from_configuration]{disassociate_from_configuration} \tab Unlink a resource, for example a custom action, from a channel configuration\cr
#'  \link[=chatbot_get_account_preferences]{get_account_preferences} \tab Returns AWS Chatbot account preferences\cr
#'  \link[=chatbot_get_custom_action]{get_custom_action} \tab Returns a custom action\cr
#'  \link[=chatbot_get_microsoft_teams_channel_configuration]{get_microsoft_teams_channel_configuration} \tab Returns a Microsoft Teams channel configuration in an AWS account\cr
#'  \link[=chatbot_list_associations]{list_associations} \tab Lists resources associated with a channel configuration\cr
#'  \link[=chatbot_list_custom_actions]{list_custom_actions} \tab Lists custom actions defined in this account\cr
#'  \link[=chatbot_list_microsoft_teams_channel_configurations]{list_microsoft_teams_channel_configurations} \tab Lists all AWS Chatbot Microsoft Teams channel configurations in an AWS account\cr
#'  \link[=chatbot_list_microsoft_teams_configured_teams]{list_microsoft_teams_configured_teams} \tab Lists all authorized Microsoft Teams for an AWS Account\cr
#'  \link[=chatbot_list_microsoft_teams_user_identities]{list_microsoft_teams_user_identities} \tab A list all Microsoft Teams user identities with a mapped role\cr
#'  \link[=chatbot_list_tags_for_resource]{list_tags_for_resource} \tab Lists all of the tags associated with the Amazon Resource Name (ARN) that you specify\cr
#'  \link[=chatbot_tag_resource]{tag_resource} \tab Attaches a key-value pair to a resource, as identified by its Amazon Resource Name (ARN)\cr
#'  \link[=chatbot_untag_resource]{untag_resource} \tab Detaches a key-value pair from a resource, as identified by its Amazon Resource Name (ARN)\cr
#'  \link[=chatbot_update_account_preferences]{update_account_preferences} \tab Updates AWS Chatbot account preferences\cr
#'  \link[=chatbot_update_chime_webhook_configuration]{update_chime_webhook_configuration} \tab Updates a Amazon Chime webhook configuration\cr
#'  \link[=chatbot_update_custom_action]{update_custom_action} \tab Updates a custom action\cr
#'  \link[=chatbot_update_microsoft_teams_channel_configuration]{update_microsoft_teams_channel_configuration} \tab Updates an Microsoft Teams channel configuration\cr
#'  \link[=chatbot_update_slack_channel_configuration]{update_slack_channel_configuration} \tab Updates a Slack channel configuration
#' }
#'
#' @return
#' A client for the service. You can call the service's operations using
#' syntax like `svc$operation(...)`, where `svc` is the name you've assigned
#' to the client. The available operations are listed in the
#' Operations section.
#'
#' @rdname chatbot
#' @export
chatbot <- function(config = list(), credentials = list(), endpoint = NULL, region = NULL) {
  config <- merge_config(
    config,
    list(
      credentials = credentials,
      endpoint = endpoint,
      region = region
    )
  )
  svc <- .chatbot$operations
  svc <- set_config(svc, config)
  return(svc)
}

# Private API objects: metadata, handlers, interfaces, etc.
.chatbot <- list()

.chatbot$operations <- list()

.chatbot$metadata <- list(
  service_name = "chatbot",
  endpoints = list("^(us|eu|ap|sa|ca|me|af|il|mx)\\-\\w+\\-\\d+$" = list(endpoint = "chatbot.{region}.amazonaws.com", global = FALSE), "^cn\\-\\w+\\-\\d+$" = list(endpoint = "chatbot.{region}.amazonaws.com.cn", global = FALSE), "^us\\-gov\\-\\w+\\-\\d+$" = list(endpoint = "chatbot.{region}.amazonaws.com", global = FALSE), "^us\\-iso\\-\\w+\\-\\d+$" = list(endpoint = "chatbot.{region}.c2s.ic.gov", global = FALSE), "^us\\-isob\\-\\w+\\-\\d+$" = list(endpoint = "chatbot.{region}.sc2s.sgov.gov", global = FALSE), "^eu\\-isoe\\-\\w+\\-\\d+$" = list(endpoint = "chatbot.{region}.cloud.adc-e.uk", global = FALSE), "^us\\-isof\\-\\w+\\-\\d+$" = list(endpoint = "chatbot.{region}.csp.hci.ic.gov", global = FALSE), "^eusc\\-(de)\\-\\w+\\-\\d+$" = list(endpoint = "chatbot.{region}.amazonaws.eu", global = FALSE)),
  service_id = "chatbot",
  api_version = "2017-10-11",
  signing_name = "chatbot",
  json_version = "",
  target_prefix = ""
)

.chatbot$service <- function(config = list(), op = NULL) {
  handlers <- new_handlers("restjson", "v4")
  new_service(.chatbot$metadata, handlers, config, op)
}

svc <- paws::chatbot()

test_that("describe_chime_webhook_configurations", {
  expect_error(svc$describe_chime_webhook_configurations(), NA)
})

test_that("describe_chime_webhook_configurations", {
  expect_error(svc$describe_chime_webhook_configurations(MaxResults = 20), NA)
})

test_that("describe_slack_channel_configurations", {
  expect_error(svc$describe_slack_channel_configurations(), NA)
})

test_that("describe_slack_channel_configurations", {
  expect_error(svc$describe_slack_channel_configurations(MaxResults = 20), NA)
})

test_that("describe_slack_user_identities", {
  expect_error(svc$describe_slack_user_identities(), NA)
})

test_that("describe_slack_user_identities", {
  expect_error(svc$describe_slack_user_identities(MaxResults = 20), NA)
})

test_that("describe_slack_workspaces", {
  expect_error(svc$describe_slack_workspaces(), NA)
})

test_that("describe_slack_workspaces", {
  expect_error(svc$describe_slack_workspaces(MaxResults = 20), NA)
})

test_that("list_custom_actions", {
  expect_error(svc$list_custom_actions(), NA)
})

test_that("list_custom_actions", {
  expect_error(svc$list_custom_actions(MaxResults = 20), NA)
})

test_that("list_microsoft_teams_channel_configurations", {
  expect_error(svc$list_microsoft_teams_channel_configurations(), NA)
})

test_that("list_microsoft_teams_channel_configurations", {
  expect_error(svc$list_microsoft_teams_channel_configurations(MaxResults = 20), NA)
})

test_that("list_microsoft_teams_configured_teams", {
  expect_error(svc$list_microsoft_teams_configured_teams(), NA)
})

test_that("list_microsoft_teams_configured_teams", {
  expect_error(svc$list_microsoft_teams_configured_teams(MaxResults = 20), NA)
})

test_that("list_microsoft_teams_user_identities", {
  expect_error(svc$list_microsoft_teams_user_identities(), NA)
})

test_that("list_microsoft_teams_user_identities", {
  expect_error(svc$list_microsoft_teams_user_identities(MaxResults = 20), NA)
})

# This file is generated by make.paws. Please do not edit here.
#' @importFrom paws.common get_config new_operation new_request send_request
#' @include workmailmessageflow_service.R
NULL

#' Retrieves the raw content of an in-transit email message, in MIME format
#'
#' @description
#' Retrieves the raw content of an in-transit email message, in MIME format.
#'
#' See [https://www.paws-r-sdk.com/docs/workmailmessageflow_get_raw_message_content/](https://www.paws-r-sdk.com/docs/workmailmessageflow_get_raw_message_content/) for full documentation.
#'
#' @param messageId &#91;required&#93; The identifier of the email message to retrieve.
#'
#' @keywords internal
#'
#' @rdname workmailmessageflow_get_raw_message_content
workmailmessageflow_get_raw_message_content <- function(messageId) {
  op <- new_operation(
    name = "GetRawMessageContent",
    http_method = "GET",
    http_path = "/messages/{messageId}",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmailmessageflow$get_raw_message_content_input(messageId = messageId)
  output <- .workmailmessageflow$get_raw_message_content_output()
  config <- get_config()
  svc <- .workmailmessageflow$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmailmessageflow$operations$get_raw_message_content <- workmailmessageflow_get_raw_message_content

#' Updates the raw content of an in-transit email message, in MIME format
#'
#' @description
#' Updates the raw content of an in-transit email message, in MIME format.
#'
#' See [https://www.paws-r-sdk.com/docs/workmailmessageflow_put_raw_message_content/](https://www.paws-r-sdk.com/docs/workmailmessageflow_put_raw_message_content/) for full documentation.
#'
#' @param messageId &#91;required&#93; The identifier of the email message being updated.
#' @param content &#91;required&#93; Describes the raw message content of the updated email message.
#'
#' @keywords internal
#'
#' @rdname workmailmessageflow_put_raw_message_content
workmailmessageflow_put_raw_message_content <- function(messageId, content) {
  op <- new_operation(
    name = "PutRawMessageContent",
    http_method = "POST",
    http_path = "/messages/{messageId}",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmailmessageflow$put_raw_message_content_input(messageId = messageId, content = content)
  output <- .workmailmessageflow$put_raw_message_content_output()
  config <- get_config()
  svc <- .workmailmessageflow$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmailmessageflow$operations$put_raw_message_content <- workmailmessageflow_put_raw_message_content

# This file is generated by make.paws. Please do not edit here.
#' @importFrom paws.common get_config new_operation new_request send_request
#' @include workdocs_service.R
NULL

#' Aborts the upload of the specified document version that was previously
#' initiated by InitiateDocumentVersionUpload
#'
#' @description
#' Aborts the upload of the specified document version that was previously initiated by [`initiate_document_version_upload`][workdocs_initiate_document_version_upload]. The client should make this call only when it no longer intends to upload the document version, or fails to do so.
#'
#' See [https://www.paws-r-sdk.com/docs/workdocs_abort_document_version_upload/](https://www.paws-r-sdk.com/docs/workdocs_abort_document_version_upload/) for full documentation.
#'
#' @param AuthenticationToken Amazon WorkDocs authentication token. Not required when using Amazon Web Services administrator credentials to access the API.
#' @param DocumentId &#91;required&#93; The ID of the document.
#' @param VersionId &#91;required&#93; The ID of the version.
#'
#' @keywords internal
#'
#' @rdname workdocs_abort_document_version_upload
workdocs_abort_document_version_upload <- function(AuthenticationToken = NULL, DocumentId, VersionId) {
  op <- new_operation(
    name = "AbortDocumentVersionUpload",
    http_method = "DELETE",
    http_path = "/api/v1/documents/{DocumentId}/versions/{VersionId}",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workdocs$abort_document_version_upload_input(AuthenticationToken = AuthenticationToken, DocumentId = DocumentId, VersionId = VersionId)
  output <- .workdocs$abort_document_version_upload_output()
  config <- get_config()
  svc <- .workdocs$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workdocs$operations$abort_document_version_upload <- workdocs_abort_document_version_upload

#' Activates the specified user
#'
#' @description
#' Activates the specified user. Only active users can access Amazon WorkDocs.
#'
#' See [https://www.paws-r-sdk.com/docs/workdocs_activate_user/](https://www.paws-r-sdk.com/docs/workdocs_activate_user/) for full documentation.
#'
#' @param UserId &#91;required&#93; The ID of the user.
#' @param AuthenticationToken Amazon WorkDocs authentication token. Not required when using Amazon Web Services administrator credentials to access the API.
#'
#' @keywords internal
#'
#' @rdname workdocs_activate_user
workdocs_activate_user <- function(UserId, AuthenticationToken = NULL) {
  op <- new_operation(
    name = "ActivateUser",
    http_method = "POST",
    http_path = "/api/v1/users/{UserId}/activation",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workdocs$activate_user_input(UserId = UserId, AuthenticationToken = AuthenticationToken)
  output <- .workdocs$activate_user_output()
  config <- get_config()
  svc <- .workdocs$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workdocs$operations$activate_user <- workdocs_activate_user

#' Creates a set of permissions for the specified folder or document
#'
#' @description
#' Creates a set of permissions for the specified folder or document. The resource permissions are overwritten if the principals already have different permissions.
#'
#' See [https://www.paws-r-sdk.com/docs/workdocs_add_resource_permissions/](https://www.paws-r-sdk.com/docs/workdocs_add_resource_permissions/) for full documentation.
#'
#' @param AuthenticationToken Amazon WorkDocs authentication token. Not required when using Amazon Web Services administrator credentials to access the API.
#' @param ResourceId &#91;required&#93; The ID of the resource.
#' @param Principals &#91;required&#93; The users, groups, or organization being granted permission.
#' @param NotificationOptions The notification options.
#'
#' @keywords internal
#'
#' @rdname workdocs_add_resource_permissions
workdocs_add_resource_permissions <- function(AuthenticationToken = NULL, ResourceId, Principals, NotificationOptions = NULL) {
  op <- new_operation(
    name = "AddResourcePermissions",
    http_method = "POST",
    http_path = "/api/v1/resources/{ResourceId}/permissions",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workdocs$add_resource_permissions_input(AuthenticationToken = AuthenticationToken, ResourceId = ResourceId, Principals = Principals, NotificationOptions = NotificationOptions)
  output <- .workdocs$add_resource_permissions_output()
  config <- get_config()
  svc <- .workdocs$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workdocs$operations$add_resource_permissions <- workdocs_add_resource_permissions

#' Adds a new comment to the specified document version
#'
#' @description
#' Adds a new comment to the specified document version.
#'
#' See [https://www.paws-r-sdk.com/docs/workdocs_create_comment/](https://www.paws-r-sdk.com/docs/workdocs_create_comment/) for full documentation.
#'
#' @param AuthenticationToken Amazon WorkDocs authentication token. Not required when using Amazon Web Services administrator credentials to access the API.
#' @param DocumentId &#91;required&#93; The ID of the document.
#' @param VersionId &#91;required&#93; The ID of the document version.
#' @param ParentId The ID of the parent comment.
#' @param ThreadId The ID of the root comment in the thread.
#' @param Text &#91;required&#93; The text of the comment.
#' @param Visibility The visibility of the comment. Options are either PRIVATE, where the comment is visible only to the comment author and document owner and co-owners, or PUBLIC, where the comment is visible to document owners, co-owners, and contributors.
#' @param NotifyCollaborators Set this parameter to TRUE to send an email out to the document collaborators after the comment is created.
#'
#' @keywords internal
#'
#' @rdname workdocs_create_comment
workdocs_create_comment <- function(AuthenticationToken = NULL, DocumentId, VersionId, ParentId = NULL, ThreadId = NULL, Text, Visibility = NULL, NotifyCollaborators = NULL) {
  op <- new_operation(
    name = "CreateComment",
    http_method = "POST",
    http_path = "/api/v1/documents/{DocumentId}/versions/{VersionId}/comment",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workdocs$create_comment_input(AuthenticationToken = AuthenticationToken, DocumentId = DocumentId, VersionId = VersionId, ParentId = ParentId, ThreadId = ThreadId, Text = Text, Visibility = Visibility, NotifyCollaborators = NotifyCollaborators)
  output <- .workdocs$create_comment_output()
  config <- get_config()
  svc <- .workdocs$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workdocs$operations$create_comment <- workdocs_create_comment

#' Adds one or more custom properties to the specified resource (a folder,
#' document, or version)
#'
#' @description
#' Adds one or more custom properties to the specified resource (a folder, document, or version).
#'
#' See [https://www.paws-r-sdk.com/docs/workdocs_create_custom_metadata/](https://www.paws-r-sdk.com/docs/workdocs_create_custom_metadata/) for full documentation.
#'
#' @param AuthenticationToken Amazon WorkDocs authentication token. Not required when using Amazon Web Services administrator credentials to access the API.
#' @param ResourceId &#91;required&#93; The ID of the resource.
#' @param VersionId The ID of the version, if the custom metadata is being added to a document version.
#' @param CustomMetadata &#91;required&#93; Custom metadata in the form of name-value pairs.
#'
#' @keywords internal
#'
#' @rdname workdocs_create_custom_metadata
workdocs_create_custom_metadata <- function(AuthenticationToken = NULL, ResourceId, VersionId = NULL, CustomMetadata) {
  op <- new_operation(
    name = "CreateCustomMetadata",
    http_method = "PUT",
    http_path = "/api/v1/resources/{ResourceId}/customMetadata",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workdocs$create_custom_metadata_input(AuthenticationToken = AuthenticationToken, ResourceId = ResourceId, VersionId = VersionId, CustomMetadata = CustomMetadata)
  output <- .workdocs$create_custom_metadata_output()
  config <- get_config()
  svc <- .workdocs$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workdocs$operations$create_custom_metadata <- workdocs_create_custom_metadata

#' Creates a folder with the specified name and parent folder
#'
#' @description
#' Creates a folder with the specified name and parent folder.
#'
#' See [https://www.paws-r-sdk.com/docs/workdocs_create_folder/](https://www.paws-r-sdk.com/docs/workdocs_create_folder/) for full documentation.
#'
#' @param AuthenticationToken Amazon WorkDocs authentication token. Not required when using Amazon Web Services administrator credentials to access the API.
#' @param Name The name of the new folder.
#' @param ParentFolderId &#91;required&#93; The ID of the parent folder.
#'
#' @keywords internal
#'
#' @rdname workdocs_create_folder
workdocs_create_folder <- function(AuthenticationToken = NULL, Name = NULL, ParentFolderId) {
  op <- new_operation(
    name = "CreateFolder",
    http_method = "POST",
    http_path = "/api/v1/folders",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workdocs$create_folder_input(AuthenticationToken = AuthenticationToken, Name = Name, ParentFolderId = ParentFolderId)
  output <- .workdocs$create_folder_output()
  config <- get_config()
  svc <- .workdocs$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workdocs$operations$create_folder <- workdocs_create_folder

#' Adds the specified list of labels to the given resource (a document or
#' folder)
#'
#' @description
#' Adds the specified list of labels to the given resource (a document or folder)
#'
#' See [https://www.paws-r-sdk.com/docs/workdocs_create_labels/](https://www.paws-r-sdk.com/docs/workdocs_create_labels/) for full documentation.
#'
#' @param ResourceId &#91;required&#93; The ID of the resource.
#' @param Labels &#91;required&#93; List of labels to add to the resource.
#' @param AuthenticationToken Amazon WorkDocs authentication token. Not required when using Amazon Web Services administrator credentials to access the API.
#'
#' @keywords internal
#'
#' @rdname workdocs_create_labels
workdocs_create_labels <- function(ResourceId, Labels, AuthenticationToken = NULL) {
  op <- new_operation(
    name = "CreateLabels",
    http_method = "PUT",
    http_path = "/api/v1/resources/{ResourceId}/labels",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workdocs$create_labels_input(ResourceId = ResourceId, Labels = Labels, AuthenticationToken = AuthenticationToken)
  output <- .workdocs$create_labels_output()
  config <- get_config()
  svc <- .workdocs$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workdocs$operations$create_labels <- workdocs_create_labels

#' Configure Amazon WorkDocs to use Amazon SNS notifications
#'
#' @description
#' Configure Amazon WorkDocs to use Amazon SNS notifications. The endpoint receives a confirmation message, and must confirm the subscription.
#'
#' See [https://www.paws-r-sdk.com/docs/workdocs_create_notification_subscription/](https://www.paws-r-sdk.com/docs/workdocs_create_notification_subscription/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; The ID of the organization.
#' @param Endpoint &#91;required&#93; The endpoint to receive the notifications. If the protocol is HTTPS, the endpoint is a URL that begins with `https`.
#' @param Protocol &#91;required&#93; The protocol to use. The supported value is https, which delivers JSON-encoded messages using HTTPS POST.
#' @param SubscriptionType &#91;required&#93; The notification type.
#'
#' @keywords internal
#'
#' @rdname workdocs_create_notification_subscription
workdocs_create_notification_subscription <- function(OrganizationId, Endpoint, Protocol, SubscriptionType) {
  op <- new_operation(
    name = "CreateNotificationSubscription",
    http_method = "POST",
    http_path = "/api/v1/organizations/{OrganizationId}/subscriptions",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workdocs$create_notification_subscription_input(OrganizationId = OrganizationId, Endpoint = Endpoint, Protocol = Protocol, SubscriptionType = SubscriptionType)
  output <- .workdocs$create_notification_subscription_output()
  config <- get_config()
  svc <- .workdocs$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workdocs$operations$create_notification_subscription <- workdocs_create_notification_subscription

#' Creates a user in a Simple AD or Microsoft AD directory
#'
#' @description
#' Creates a user in a Simple AD or Microsoft AD directory. The status of a newly created user is "ACTIVE". New users can access Amazon WorkDocs.
#'
#' See [https://www.paws-r-sdk.com/docs/workdocs_create_user/](https://www.paws-r-sdk.com/docs/workdocs_create_user/) for full documentation.
#'
#' @param OrganizationId The ID of the organization.
#' @param Username &#91;required&#93; The login name of the user.
#' @param EmailAddress The email address of the user.
#' @param GivenName &#91;required&#93; The given name of the user.
#' @param Surname &#91;required&#93; The surname of the user.
#' @param Password &#91;required&#93; The password of the user.
#' @param TimeZoneId The time zone ID of the user.
#' @param StorageRule The amount of storage for the user.
#' @param AuthenticationToken Amazon WorkDocs authentication token. Not required when using Amazon Web Services administrator credentials to access the API.
#'
#' @keywords internal
#'
#' @rdname workdocs_create_user
workdocs_create_user <- function(OrganizationId = NULL, Username, EmailAddress = NULL, GivenName, Surname, Password, TimeZoneId = NULL, StorageRule = NULL, AuthenticationToken = NULL) {
  op <- new_operation(
    name = "CreateUser",
    http_method = "POST",
    http_path = "/api/v1/users",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workdocs$create_user_input(OrganizationId = OrganizationId, Username = Username, EmailAddress = EmailAddress, GivenName = GivenName, Surname = Surname, Password = Password, TimeZoneId = TimeZoneId, StorageRule = StorageRule, AuthenticationToken = AuthenticationToken)
  output <- .workdocs$create_user_output()
  config <- get_config()
  svc <- .workdocs$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workdocs$operations$create_user <- workdocs_create_user

#' Deactivates the specified user, which revokes the user's access to
#' Amazon WorkDocs
#'
#' @description
#' Deactivates the specified user, which revokes the user's access to Amazon WorkDocs.
#'
#' See [https://www.paws-r-sdk.com/docs/workdocs_deactivate_user/](https://www.paws-r-sdk.com/docs/workdocs_deactivate_user/) for full documentation.
#'
#' @param UserId &#91;required&#93; The ID of the user.
#' @param AuthenticationToken Amazon WorkDocs authentication token. Not required when using Amazon Web Services administrator credentials to access the API.
#'
#' @keywords internal
#'
#' @rdname workdocs_deactivate_user
workdocs_deactivate_user <- function(UserId, AuthenticationToken = NULL) {
  op <- new_operation(
    name = "DeactivateUser",
    http_method = "DELETE",
    http_path = "/api/v1/users/{UserId}/activation",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workdocs$deactivate_user_input(UserId = UserId, AuthenticationToken = AuthenticationToken)
  output <- .workdocs$deactivate_user_output()
  config <- get_config()
  svc <- .workdocs$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workdocs$operations$deactivate_user <- workdocs_deactivate_user

#' Deletes the specified comment from the document version
#'
#' @description
#' Deletes the specified comment from the document version.
#'
#' See [https://www.paws-r-sdk.com/docs/workdocs_delete_comment/](https://www.paws-r-sdk.com/docs/workdocs_delete_comment/) for full documentation.
#'
#' @param AuthenticationToken Amazon WorkDocs authentication token. Not required when using Amazon Web Services administrator credentials to access the API.
#' @param DocumentId &#91;required&#93; The ID of the document.
#' @param VersionId &#91;required&#93; The ID of the document version.
#' @param CommentId &#91;required&#93; The ID of the comment.
#'
#' @keywords internal
#'
#' @rdname workdocs_delete_comment
workdocs_delete_comment <- function(AuthenticationToken = NULL, DocumentId, VersionId, CommentId) {
  op <- new_operation(
    name = "DeleteComment",
    http_method = "DELETE",
    http_path = "/api/v1/documents/{DocumentId}/versions/{VersionId}/comment/{CommentId}",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workdocs$delete_comment_input(AuthenticationToken = AuthenticationToken, DocumentId = DocumentId, VersionId = VersionId, CommentId = CommentId)
  output <- .workdocs$delete_comment_output()
  config <- get_config()
  svc <- .workdocs$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workdocs$operations$delete_comment <- workdocs_delete_comment

#' Deletes custom metadata from the specified resource
#'
#' @description
#' Deletes custom metadata from the specified resource.
#'
#' See [https://www.paws-r-sdk.com/docs/workdocs_delete_custom_metadata/](https://www.paws-r-sdk.com/docs/workdocs_delete_custom_metadata/) for full documentation.
#'
#' @param AuthenticationToken Amazon WorkDocs authentication token. Not required when using Amazon Web Services administrator credentials to access the API.
#' @param ResourceId &#91;required&#93; The ID of the resource, either a document or folder.
#' @param VersionId The ID of the version, if the custom metadata is being deleted from a document version.
#' @param Keys List of properties to remove.
#' @param DeleteAll Flag to indicate removal of all custom metadata properties from the specified resource.
#'
#' @keywords internal
#'
#' @rdname workdocs_delete_custom_metadata
workdocs_delete_custom_metadata <- function(AuthenticationToken = NULL, ResourceId, VersionId = NULL, Keys = NULL, DeleteAll = NULL) {
  op <- new_operation(
    name = "DeleteCustomMetadata",
    http_method = "DELETE",
    http_path = "/api/v1/resources/{ResourceId}/customMetadata",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workdocs$delete_custom_metadata_input(AuthenticationToken = AuthenticationToken, ResourceId = ResourceId, VersionId = VersionId, Keys = Keys, DeleteAll = DeleteAll)
  output <- .workdocs$delete_custom_metadata_output()
  config <- get_config()
  svc <- .workdocs$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workdocs$operations$delete_custom_metadata <- workdocs_delete_custom_metadata

#' Permanently deletes the specified document and its associated metadata
#'
#' @description
#' Permanently deletes the specified document and its associated metadata.
#'
#' See [https://www.paws-r-sdk.com/docs/workdocs_delete_document/](https://www.paws-r-sdk.com/docs/workdocs_delete_document/) for full documentation.
#'
#' @param AuthenticationToken Amazon WorkDocs authentication token. Not required when using Amazon Web Services administrator credentials to access the API.
#' @param DocumentId &#91;required&#93; The ID of the document.
#'
#' @keywords internal
#'
#' @rdname workdocs_delete_document
workdocs_delete_document <- function(AuthenticationToken = NULL, DocumentId) {
  op <- new_operation(
    name = "DeleteDocument",
    http_method = "DELETE",
    http_path = "/api/v1/documents/{DocumentId}",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workdocs$delete_document_input(AuthenticationToken = AuthenticationToken, DocumentId = DocumentId)
  output <- .workdocs$delete_document_output()
  config <- get_config()
  svc <- .workdocs$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workdocs$operations$delete_document <- workdocs_delete_document

#' Deletes a specific version of a document
#'
#' @description
#' Deletes a specific version of a document.
#'
#' See [https://www.paws-r-sdk.com/docs/workdocs_delete_document_version/](https://www.paws-r-sdk.com/docs/workdocs_delete_document_version/) for full documentation.
#'
#' @param AuthenticationToken Amazon WorkDocs authentication token. Not required when using Amazon Web Services administrator credentials to access the API.
#' @param DocumentId &#91;required&#93; The ID of the document associated with the version being deleted.
#' @param VersionId &#91;required&#93; The ID of the version being deleted.
#' @param DeletePriorVersions &#91;required&#93; Deletes all versions of a document prior to the current version.
#'
#' @keywords internal
#'
#' @rdname workdocs_delete_document_version
workdocs_delete_document_version <- function(AuthenticationToken = NULL, DocumentId, VersionId, DeletePriorVersions) {
  op <- new_operation(
    name = "DeleteDocumentVersion",
    http_method = "DELETE",
    http_path = "/api/v1/documentVersions/{DocumentId}/versions/{VersionId}",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workdocs$delete_document_version_input(AuthenticationToken = AuthenticationToken, DocumentId = DocumentId, VersionId = VersionId, DeletePriorVersions = DeletePriorVersions)
  output <- .workdocs$delete_document_version_output()
  config <- get_config()
  svc <- .workdocs$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workdocs$operations$delete_document_version <- workdocs_delete_document_version

#' Permanently deletes the specified folder and its contents
#'
#' @description
#' Permanently deletes the specified folder and its contents.
#'
#' See [https://www.paws-r-sdk.com/docs/workdocs_delete_folder/](https://www.paws-r-sdk.com/docs/workdocs_delete_folder/) for full documentation.
#'
#' @param AuthenticationToken Amazon WorkDocs authentication token. Not required when using Amazon Web Services administrator credentials to access the API.
#' @param FolderId &#91;required&#93; The ID of the folder.
#'
#' @keywords internal
#'
#' @rdname workdocs_delete_folder
workdocs_delete_folder <- function(AuthenticationToken = NULL, FolderId) {
  op <- new_operation(
    name = "DeleteFolder",
    http_method = "DELETE",
    http_path = "/api/v1/folders/{FolderId}",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workdocs$delete_folder_input(AuthenticationToken = AuthenticationToken, FolderId = FolderId)
  output <- .workdocs$delete_folder_output()
  config <- get_config()
  svc <- .workdocs$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workdocs$operations$delete_folder <- workdocs_delete_folder

#' Deletes the contents of the specified folder
#'
#' @description
#' Deletes the contents of the specified folder.
#'
#' See [https://www.paws-r-sdk.com/docs/workdocs_delete_folder_contents/](https://www.paws-r-sdk.com/docs/workdocs_delete_folder_contents/) for full documentation.
#'
#' @param AuthenticationToken Amazon WorkDocs authentication token. Not required when using Amazon Web Services administrator credentials to access the API.
#' @param FolderId &#91;required&#93; The ID of the folder.
#'
#' @keywords internal
#'
#' @rdname workdocs_delete_folder_contents
workdocs_delete_folder_contents <- function(AuthenticationToken = NULL, FolderId) {
  op <- new_operation(
    name = "DeleteFolderContents",
    http_method = "DELETE",
    http_path = "/api/v1/folders/{FolderId}/contents",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workdocs$delete_folder_contents_input(AuthenticationToken = AuthenticationToken, FolderId = FolderId)
  output <- .workdocs$delete_folder_contents_output()
  config <- get_config()
  svc <- .workdocs$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workdocs$operations$delete_folder_contents <- workdocs_delete_folder_contents

#' Deletes the specified list of labels from a resource
#'
#' @description
#' Deletes the specified list of labels from a resource.
#'
#' See [https://www.paws-r-sdk.com/docs/workdocs_delete_labels/](https://www.paws-r-sdk.com/docs/workdocs_delete_labels/) for full documentation.
#'
#' @param ResourceId &#91;required&#93; The ID of the resource.
#' @param AuthenticationToken Amazon WorkDocs authentication token. Not required when using Amazon Web Services administrator credentials to access the API.
#' @param Labels List of labels to delete from the resource.
#' @param DeleteAll Flag to request removal of all labels from the specified resource.
#'
#' @keywords internal
#'
#' @rdname workdocs_delete_labels
workdocs_delete_labels <- function(ResourceId, AuthenticationToken = NULL, Labels = NULL, DeleteAll = NULL) {
  op <- new_operation(
    name = "DeleteLabels",
    http_method = "DELETE",
    http_path = "/api/v1/resources/{ResourceId}/labels",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workdocs$delete_labels_input(ResourceId = ResourceId, AuthenticationToken = AuthenticationToken, Labels = Labels, DeleteAll = DeleteAll)
  output <- .workdocs$delete_labels_output()
  config <- get_config()
  svc <- .workdocs$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workdocs$operations$delete_labels <- workdocs_delete_labels

#' Deletes the specified subscription from the specified organization
#'
#' @description
#' Deletes the specified subscription from the specified organization.
#'
#' See [https://www.paws-r-sdk.com/docs/workdocs_delete_notification_subscription/](https://www.paws-r-sdk.com/docs/workdocs_delete_notification_subscription/) for full documentation.
#'
#' @param SubscriptionId &#91;required&#93; The ID of the subscription.
#' @param OrganizationId &#91;required&#93; The ID of the organization.
#'
#' @keywords internal
#'
#' @rdname workdocs_delete_notification_subscription
workdocs_delete_notification_subscription <- function(SubscriptionId, OrganizationId) {
  op <- new_operation(
    name = "DeleteNotificationSubscription",
    http_method = "DELETE",
    http_path = "/api/v1/organizations/{OrganizationId}/subscriptions/{SubscriptionId}",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workdocs$delete_notification_subscription_input(SubscriptionId = SubscriptionId, OrganizationId = OrganizationId)
  output <- .workdocs$delete_notification_subscription_output()
  config <- get_config()
  svc <- .workdocs$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workdocs$operations$delete_notification_subscription <- workdocs_delete_notification_subscription

#' Deletes the specified user from a Simple AD or Microsoft AD directory
#'
#' @description
#' Deletes the specified user from a Simple AD or Microsoft AD directory.
#'
#' See [https://www.paws-r-sdk.com/docs/workdocs_delete_user/](https://www.paws-r-sdk.com/docs/workdocs_delete_user/) for full documentation.
#'
#' @param AuthenticationToken Amazon WorkDocs authentication token. Do not set this field when using administrative API actions, as in accessing the API using Amazon Web Services credentials.
#' @param UserId &#91;required&#93; The ID of the user.
#'
#' @keywords internal
#'
#' @rdname workdocs_delete_user
workdocs_delete_user <- function(AuthenticationToken = NULL, UserId) {
  op <- new_operation(
    name = "DeleteUser",
    http_method = "DELETE",
    http_path = "/api/v1/users/{UserId}",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workdocs$delete_user_input(AuthenticationToken = AuthenticationToken, UserId = UserId)
  output <- .workdocs$delete_user_output()
  config <- get_config()
  svc <- .workdocs$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workdocs$operations$delete_user <- workdocs_delete_user

#' Describes the user activities in a specified time period
#'
#' @description
#' Describes the user activities in a specified time period.
#'
#' See [https://www.paws-r-sdk.com/docs/workdocs_describe_activities/](https://www.paws-r-sdk.com/docs/workdocs_describe_activities/) for full documentation.
#'
#' @param AuthenticationToken Amazon WorkDocs authentication token. Not required when using Amazon Web Services administrator credentials to access the API.
#' @param StartTime The timestamp that determines the starting time of the activities. The response includes the activities performed after the specified timestamp.
#' @param EndTime The timestamp that determines the end time of the activities. The response includes the activities performed before the specified timestamp.
#' @param OrganizationId The ID of the organization. This is a mandatory parameter when using administrative API (SigV4) requests.
#' @param ActivityTypes Specifies which activity types to include in the response. If this field is left empty, all activity types are returned.
#' @param ResourceId The document or folder ID for which to describe activity types.
#' @param UserId The ID of the user who performed the action. The response includes activities pertaining to this user. This is an optional parameter and is only applicable for administrative API (SigV4) requests.
#' @param IncludeIndirectActivities Includes indirect activities. An indirect activity results from a direct activity performed on a parent resource. For example, sharing a parent folder (the direct activity) shares all of the subfolders and documents within the parent folder (the indirect activity).
#' @param Limit The maximum number of items to return.
#' @param Marker The marker for the next set of results.
#'
#' @keywords internal
#'
#' @rdname workdocs_describe_activities
workdocs_describe_activities <- function(AuthenticationToken = NULL, StartTime = NULL, EndTime = NULL, OrganizationId = NULL, ActivityTypes = NULL, ResourceId = NULL, UserId = NULL, IncludeIndirectActivities = NULL, Limit = NULL, Marker = NULL) {
  op <- new_operation(
    name = "DescribeActivities",
    http_method = "GET",
    http_path = "/api/v1/activities",
    host_prefix = "",
    paginator = list(input_token = "Marker", limit_key = "Limit", output_token = "Marker", result_key = "UserActivities"),
    stream_api = FALSE
  )
  input <- .workdocs$describe_activities_input(AuthenticationToken = AuthenticationToken, StartTime = StartTime, EndTime = EndTime, OrganizationId = OrganizationId, ActivityTypes = ActivityTypes, ResourceId = ResourceId, UserId = UserId, IncludeIndirectActivities = IncludeIndirectActivities, Limit = Limit, Marker = Marker)
  output <- .workdocs$describe_activities_output()
  config <- get_config()
  svc <- .workdocs$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workdocs$operations$describe_activities <- workdocs_describe_activities

#' List all the comments for the specified document version
#'
#' @description
#' List all the comments for the specified document version.
#'
#' See [https://www.paws-r-sdk.com/docs/workdocs_describe_comments/](https://www.paws-r-sdk.com/docs/workdocs_describe_comments/) for full documentation.
#'
#' @param AuthenticationToken Amazon WorkDocs authentication token. Not required when using Amazon Web Services administrator credentials to access the API.
#' @param DocumentId &#91;required&#93; The ID of the document.
#' @param VersionId &#91;required&#93; The ID of the document version.
#' @param Limit The maximum number of items to return.
#' @param Marker The marker for the next set of results. This marker was received from a previous call.
#'
#' @keywords internal
#'
#' @rdname workdocs_describe_comments
workdocs_describe_comments <- function(AuthenticationToken = NULL, DocumentId, VersionId, Limit = NULL, Marker = NULL) {
  op <- new_operation(
    name = "DescribeComments",
    http_method = "GET",
    http_path = "/api/v1/documents/{DocumentId}/versions/{VersionId}/comments",
    host_prefix = "",
    paginator = list(input_token = "Marker", limit_key = "Limit", output_token = "Marker", result_key = "Comments"),
    stream_api = FALSE
  )
  input <- .workdocs$describe_comments_input(AuthenticationToken = AuthenticationToken, DocumentId = DocumentId, VersionId = VersionId, Limit = Limit, Marker = Marker)
  output <- .workdocs$describe_comments_output()
  config <- get_config()
  svc <- .workdocs$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workdocs$operations$describe_comments <- workdocs_describe_comments

#' Retrieves the document versions for the specified document
#'
#' @description
#' Retrieves the document versions for the specified document.
#'
#' See [https://www.paws-r-sdk.com/docs/workdocs_describe_document_versions/](https://www.paws-r-sdk.com/docs/workdocs_describe_document_versions/) for full documentation.
#'
#' @param AuthenticationToken Amazon WorkDocs authentication token. Not required when using Amazon Web Services administrator credentials to access the API.
#' @param DocumentId &#91;required&#93; The ID of the document.
#' @param Marker The marker for the next set of results. (You received this marker from a previous call.)
#' @param Limit The maximum number of versions to return with this call.
#' @param Include A comma-separated list of values. Specify "INITIALIZED" to include incomplete versions.
#' @param Fields Specify "SOURCE" to include initialized versions and a URL for the source document.
#'
#' @keywords internal
#'
#' @rdname workdocs_describe_document_versions
workdocs_describe_document_versions <- function(AuthenticationToken = NULL, DocumentId, Marker = NULL, Limit = NULL, Include = NULL, Fields = NULL) {
  op <- new_operation(
    name = "DescribeDocumentVersions",
    http_method = "GET",
    http_path = "/api/v1/documents/{DocumentId}/versions",
    host_prefix = "",
    paginator = list(input_token = "Marker", limit_key = "Limit", output_token = "Marker", result_key = "DocumentVersions"),
    stream_api = FALSE
  )
  input <- .workdocs$describe_document_versions_input(AuthenticationToken = AuthenticationToken, DocumentId = DocumentId, Marker = Marker, Limit = Limit, Include = Include, Fields = Fields)
  output <- .workdocs$describe_document_versions_output()
  config <- get_config()
  svc <- .workdocs$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workdocs$operations$describe_document_versions <- workdocs_describe_document_versions

#' Describes the contents of the specified folder, including its documents
#' and subfolders
#'
#' @description
#' Describes the contents of the specified folder, including its documents and subfolders.
#'
#' See [https://www.paws-r-sdk.com/docs/workdocs_describe_folder_contents/](https://www.paws-r-sdk.com/docs/workdocs_describe_folder_contents/) for full documentation.
#'
#' @param AuthenticationToken Amazon WorkDocs authentication token. Not required when using Amazon Web Services administrator credentials to access the API.
#' @param FolderId &#91;required&#93; The ID of the folder.
#' @param Sort The sorting criteria.
#' @param Order The order for the contents of the folder.
#' @param Limit The maximum number of items to return with this call.
#' @param Marker The marker for the next set of results. This marker was received from a previous call.
#' @param Type The type of items.
#' @param Include The contents to include. Specify "INITIALIZED" to include initialized documents.
#'
#' @keywords internal
#'
#' @rdname workdocs_describe_folder_contents
workdocs_describe_folder_contents <- function(AuthenticationToken = NULL, FolderId, Sort = NULL, Order = NULL, Limit = NULL, Marker = NULL, Type = NULL, Include = NULL) {
  op <- new_operation(
    name = "DescribeFolderContents",
    http_method = "GET",
    http_path = "/api/v1/folders/{FolderId}/contents",
    host_prefix = "",
    paginator = list(input_token = "Marker", limit_key = "Limit", output_token = "Marker", result_key = list("Folders", "Documents")),
    stream_api = FALSE
  )
  input <- .workdocs$describe_folder_contents_input(AuthenticationToken = AuthenticationToken, FolderId = FolderId, Sort = Sort, Order = Order, Limit = Limit, Marker = Marker, Type = Type, Include = Include)
  output <- .workdocs$describe_folder_contents_output()
  config <- get_config()
  svc <- .workdocs$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workdocs$operations$describe_folder_contents <- workdocs_describe_folder_contents

#' Describes the groups specified by the query
#'
#' @description
#' Describes the groups specified by the query. Groups are defined by the underlying Active Directory.
#'
#' See [https://www.paws-r-sdk.com/docs/workdocs_describe_groups/](https://www.paws-r-sdk.com/docs/workdocs_describe_groups/) for full documentation.
#'
#' @param AuthenticationToken Amazon WorkDocs authentication token. Not required when using Amazon Web Services administrator credentials to access the API.
#' @param SearchQuery &#91;required&#93; A query to describe groups by group name.
#' @param OrganizationId The ID of the organization.
#' @param Marker The marker for the next set of results. (You received this marker from a previous call.)
#' @param Limit The maximum number of items to return with this call.
#'
#' @keywords internal
#'
#' @rdname workdocs_describe_groups
workdocs_describe_groups <- function(AuthenticationToken = NULL, SearchQuery, OrganizationId = NULL, Marker = NULL, Limit = NULL) {
  op <- new_operation(
    name = "DescribeGroups",
    http_method = "GET",
    http_path = "/api/v1/groups",
    host_prefix = "",
    paginator = list(input_token = "Marker", limit_key = "Limit", output_token = "Marker", result_key = "Groups"),
    stream_api = FALSE
  )
  input <- .workdocs$describe_groups_input(AuthenticationToken = AuthenticationToken, SearchQuery = SearchQuery, OrganizationId = OrganizationId, Marker = Marker, Limit = Limit)
  output <- .workdocs$describe_groups_output()
  config <- get_config()
  svc <- .workdocs$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workdocs$operations$describe_groups <- workdocs_describe_groups

#' Lists the specified notification subscriptions
#'
#' @description
#' Lists the specified notification subscriptions.
#'
#' See [https://www.paws-r-sdk.com/docs/workdocs_describe_notification_subscriptions/](https://www.paws-r-sdk.com/docs/workdocs_describe_notification_subscriptions/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; The ID of the organization.
#' @param Marker The marker for the next set of results. (You received this marker from a previous call.)
#' @param Limit The maximum number of items to return with this call.
#'
#' @keywords internal
#'
#' @rdname workdocs_describe_notification_subscriptions
workdocs_describe_notification_subscriptions <- function(OrganizationId, Marker = NULL, Limit = NULL) {
  op <- new_operation(
    name = "DescribeNotificationSubscriptions",
    http_method = "GET",
    http_path = "/api/v1/organizations/{OrganizationId}/subscriptions",
    host_prefix = "",
    paginator = list(input_token = "Marker", limit_key = "Limit", output_token = "Marker", result_key = "Subscriptions"),
    stream_api = FALSE
  )
  input <- .workdocs$describe_notification_subscriptions_input(OrganizationId = OrganizationId, Marker = Marker, Limit = Limit)
  output <- .workdocs$describe_notification_subscriptions_output()
  config <- get_config()
  svc <- .workdocs$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workdocs$operations$describe_notification_subscriptions <- workdocs_describe_notification_subscriptions

#' Describes the permissions of a specified resource
#'
#' @description
#' Describes the permissions of a specified resource.
#'
#' See [https://www.paws-r-sdk.com/docs/workdocs_describe_resource_permissions/](https://www.paws-r-sdk.com/docs/workdocs_describe_resource_permissions/) for full documentation.
#'
#' @param AuthenticationToken Amazon WorkDocs authentication token. Not required when using Amazon Web Services administrator credentials to access the API.
#' @param ResourceId &#91;required&#93; The ID of the resource.
#' @param PrincipalId The ID of the principal to filter permissions by.
#' @param Limit The maximum number of items to return with this call.
#' @param Marker The marker for the next set of results. (You received this marker from a previous call)
#'
#' @keywords internal
#'
#' @rdname workdocs_describe_resource_permissions
workdocs_describe_resource_permissions <- function(AuthenticationToken = NULL, ResourceId, PrincipalId = NULL, Limit = NULL, Marker = NULL) {
  op <- new_operation(
    name = "DescribeResourcePermissions",
    http_method = "GET",
    http_path = "/api/v1/resources/{ResourceId}/permissions",
    host_prefix = "",
    paginator = list(input_token = "Marker", limit_key = "Limit", output_token = "Marker", result_key = "Principals"),
    stream_api = FALSE
  )
  input <- .workdocs$describe_resource_permissions_input(AuthenticationToken = AuthenticationToken, ResourceId = ResourceId, PrincipalId = PrincipalId, Limit = Limit, Marker = Marker)
  output <- .workdocs$describe_resource_permissions_output()
  config <- get_config()
  svc <- .workdocs$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workdocs$operations$describe_resource_permissions <- workdocs_describe_resource_permissions

#' Describes the current user's special folders; the RootFolder and the
#' RecycleBin
#'
#' @description
#' Describes the current user's special folders; the `RootFolder` and the `RecycleBin`. `RootFolder` is the root of user's files and folders and `RecycleBin` is the root of recycled items. This is not a valid action for SigV4 (administrative API) clients.
#'
#' See [https://www.paws-r-sdk.com/docs/workdocs_describe_root_folders/](https://www.paws-r-sdk.com/docs/workdocs_describe_root_folders/) for full documentation.
#'
#' @param AuthenticationToken &#91;required&#93; Amazon WorkDocs authentication token.
#' @param Limit The maximum number of items to return.
#' @param Marker The marker for the next set of results. (You received this marker from a previous call.)
#'
#' @keywords internal
#'
#' @rdname workdocs_describe_root_folders
workdocs_describe_root_folders <- function(AuthenticationToken, Limit = NULL, Marker = NULL) {
  op <- new_operation(
    name = "DescribeRootFolders",
    http_method = "GET",
    http_path = "/api/v1/me/root",
    host_prefix = "",
    paginator = list(input_token = "Marker", limit_key = "Limit", output_token = "Marker", result_key = "Folders"),
    stream_api = FALSE
  )
  input <- .workdocs$describe_root_folders_input(AuthenticationToken = AuthenticationToken, Limit = Limit, Marker = Marker)
  output <- .workdocs$describe_root_folders_output()
  config <- get_config()
  svc <- .workdocs$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workdocs$operations$describe_root_folders <- workdocs_describe_root_folders

#' Describes the specified users
#'
#' @description
#' Describes the specified users. You can describe all users or filter the results (for example, by status or organization).
#'
#' See [https://www.paws-r-sdk.com/docs/workdocs_describe_users/](https://www.paws-r-sdk.com/docs/workdocs_describe_users/) for full documentation.
#'
#' @param AuthenticationToken Amazon WorkDocs authentication token. Not required when using Amazon Web Services administrator credentials to access the API.
#' @param OrganizationId The ID of the organization.
#' @param UserIds The IDs of the users.
#' @param Query A query to filter users by user name. Remember the following about the `Userids` and `Query` parameters:
#' 
#' -   If you don't use either parameter, the API returns a paginated list of all users on the site.
#' 
#' -   If you use both parameters, the API ignores the `Query` parameter.
#' 
#' -   The `Userid` parameter only returns user names that match a corresponding user ID.
#' 
#' -   The `Query` parameter runs a "prefix" search for users by the `GivenName`, `SurName`, or `UserName` fields included in a [`create_user`][workdocs_create_user] API call. For example, querying on `Ma` returns Márcia Oliveira, María García, and Mateo Jackson. If you use multiple characters, the API only returns data that matches all characters. For example, querying on `Ma J` only returns Mateo Jackson.
#' @param Include The state of the users. Specify "ALL" to include inactive users.
#' @param Order The order for the results.
#' @param Sort The sorting criteria.
#' @param Marker The marker for the next set of results. (You received this marker from a previous call.)
#' @param Limit The maximum number of items to return.
#' @param Fields A comma-separated list of values. Specify "STORAGE_METADATA" to include the user storage quota and utilization information.
#'
#' @keywords internal
#'
#' @rdname workdocs_describe_users
workdocs_describe_users <- function(AuthenticationToken = NULL, OrganizationId = NULL, UserIds = NULL, Query = NULL, Include = NULL, Order = NULL, Sort = NULL, Marker = NULL, Limit = NULL, Fields = NULL) {
  op <- new_operation(
    name = "DescribeUsers",
    http_method = "GET",
    http_path = "/api/v1/users",
    host_prefix = "",
    paginator = list(input_token = "Marker", limit_key = "Limit", output_token = "Marker", result_key = "Users"),
    stream_api = FALSE
  )
  input <- .workdocs$describe_users_input(AuthenticationToken = AuthenticationToken, OrganizationId = OrganizationId, UserIds = UserIds, Query = Query, Include = Include, Order = Order, Sort = Sort, Marker = Marker, Limit = Limit, Fields = Fields)
  output <- .workdocs$describe_users_output()
  config <- get_config()
  svc <- .workdocs$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workdocs$operations$describe_users <- workdocs_describe_users

#' Retrieves details of the current user for whom the authentication token
#' was generated
#'
#' @description
#' Retrieves details of the current user for whom the authentication token was generated. This is not a valid action for SigV4 (administrative API) clients.
#'
#' See [https://www.paws-r-sdk.com/docs/workdocs_get_current_user/](https://www.paws-r-sdk.com/docs/workdocs_get_current_user/) for full documentation.
#'
#' @param AuthenticationToken &#91;required&#93; Amazon WorkDocs authentication token.
#'
#' @keywords internal
#'
#' @rdname workdocs_get_current_user
workdocs_get_current_user <- function(AuthenticationToken) {
  op <- new_operation(
    name = "GetCurrentUser",
    http_method = "GET",
    http_path = "/api/v1/me",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workdocs$get_current_user_input(AuthenticationToken = AuthenticationToken)
  output <- .workdocs$get_current_user_output()
  config <- get_config()
  svc <- .workdocs$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workdocs$operations$get_current_user <- workdocs_get_current_user

#' Retrieves details of a document
#'
#' @description
#' Retrieves details of a document.
#'
#' See [https://www.paws-r-sdk.com/docs/workdocs_get_document/](https://www.paws-r-sdk.com/docs/workdocs_get_document/) for full documentation.
#'
#' @param AuthenticationToken Amazon WorkDocs authentication token. Not required when using Amazon Web Services administrator credentials to access the API.
#' @param DocumentId &#91;required&#93; The ID of the document.
#' @param IncludeCustomMetadata Set this to `TRUE` to include custom metadata in the response.
#'
#' @keywords internal
#'
#' @rdname workdocs_get_document
workdocs_get_document <- function(AuthenticationToken = NULL, DocumentId, IncludeCustomMetadata = NULL) {
  op <- new_operation(
    name = "GetDocument",
    http_method = "GET",
    http_path = "/api/v1/documents/{DocumentId}",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workdocs$get_document_input(AuthenticationToken = AuthenticationToken, DocumentId = DocumentId, IncludeCustomMetadata = IncludeCustomMetadata)
  output <- .workdocs$get_document_output()
  config <- get_config()
  svc <- .workdocs$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workdocs$operations$get_document <- workdocs_get_document

#' Retrieves the path information (the hierarchy from the root folder) for
#' the requested document
#'
#' @description
#' Retrieves the path information (the hierarchy from the root folder) for the requested document.
#'
#' See [https://www.paws-r-sdk.com/docs/workdocs_get_document_path/](https://www.paws-r-sdk.com/docs/workdocs_get_document_path/) for full documentation.
#'
#' @param AuthenticationToken Amazon WorkDocs authentication token. Not required when using Amazon Web Services administrator credentials to access the API.
#' @param DocumentId &#91;required&#93; The ID of the document.
#' @param Limit The maximum number of levels in the hierarchy to return.
#' @param Fields A comma-separated list of values. Specify `NAME` to include the names of the parent folders.
#' @param Marker This value is not supported.
#'
#' @keywords internal
#'
#' @rdname workdocs_get_document_path
workdocs_get_document_path <- function(AuthenticationToken = NULL, DocumentId, Limit = NULL, Fields = NULL, Marker = NULL) {
  op <- new_operation(
    name = "GetDocumentPath",
    http_method = "GET",
    http_path = "/api/v1/documents/{DocumentId}/path",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workdocs$get_document_path_input(AuthenticationToken = AuthenticationToken, DocumentId = DocumentId, Limit = Limit, Fields = Fields, Marker = Marker)
  output <- .workdocs$get_document_path_output()
  config <- get_config()
  svc <- .workdocs$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workdocs$operations$get_document_path <- workdocs_get_document_path

#' Retrieves version metadata for the specified document
#'
#' @description
#' Retrieves version metadata for the specified document.
#'
#' See [https://www.paws-r-sdk.com/docs/workdocs_get_document_version/](https://www.paws-r-sdk.com/docs/workdocs_get_document_version/) for full documentation.
#'
#' @param AuthenticationToken Amazon WorkDocs authentication token. Not required when using Amazon Web Services administrator credentials to access the API.
#' @param DocumentId &#91;required&#93; The ID of the document.
#' @param VersionId &#91;required&#93; The version ID of the document.
#' @param Fields A comma-separated list of values. Specify "SOURCE" to include a URL for the source document.
#' @param IncludeCustomMetadata Set this to TRUE to include custom metadata in the response.
#'
#' @keywords internal
#'
#' @rdname workdocs_get_document_version
workdocs_get_document_version <- function(AuthenticationToken = NULL, DocumentId, VersionId, Fields = NULL, IncludeCustomMetadata = NULL) {
  op <- new_operation(
    name = "GetDocumentVersion",
    http_method = "GET",
    http_path = "/api/v1/documents/{DocumentId}/versions/{VersionId}",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workdocs$get_document_version_input(AuthenticationToken = AuthenticationToken, DocumentId = DocumentId, VersionId = VersionId, Fields = Fields, IncludeCustomMetadata = IncludeCustomMetadata)
  output <- .workdocs$get_document_version_output()
  config <- get_config()
  svc <- .workdocs$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workdocs$operations$get_document_version <- workdocs_get_document_version

#' Retrieves the metadata of the specified folder
#'
#' @description
#' Retrieves the metadata of the specified folder.
#'
#' See [https://www.paws-r-sdk.com/docs/workdocs_get_folder/](https://www.paws-r-sdk.com/docs/workdocs_get_folder/) for full documentation.
#'
#' @param AuthenticationToken Amazon WorkDocs authentication token. Not required when using Amazon Web Services administrator credentials to access the API.
#' @param FolderId &#91;required&#93; The ID of the folder.
#' @param IncludeCustomMetadata Set to TRUE to include custom metadata in the response.
#'
#' @keywords internal
#'
#' @rdname workdocs_get_folder
workdocs_get_folder <- function(AuthenticationToken = NULL, FolderId, IncludeCustomMetadata = NULL) {
  op <- new_operation(
    name = "GetFolder",
    http_method = "GET",
    http_path = "/api/v1/folders/{FolderId}",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workdocs$get_folder_input(AuthenticationToken = AuthenticationToken, FolderId = FolderId, IncludeCustomMetadata = IncludeCustomMetadata)
  output <- .workdocs$get_folder_output()
  config <- get_config()
  svc <- .workdocs$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workdocs$operations$get_folder <- workdocs_get_folder

#' Retrieves the path information (the hierarchy from the root folder) for
#' the specified folder
#'
#' @description
#' Retrieves the path information (the hierarchy from the root folder) for the specified folder.
#'
#' See [https://www.paws-r-sdk.com/docs/workdocs_get_folder_path/](https://www.paws-r-sdk.com/docs/workdocs_get_folder_path/) for full documentation.
#'
#' @param AuthenticationToken Amazon WorkDocs authentication token. Not required when using Amazon Web Services administrator credentials to access the API.
#' @param FolderId &#91;required&#93; The ID of the folder.
#' @param Limit The maximum number of levels in the hierarchy to return.
#' @param Fields A comma-separated list of values. Specify "NAME" to include the names of the parent folders.
#' @param Marker This value is not supported.
#'
#' @keywords internal
#'
#' @rdname workdocs_get_folder_path
workdocs_get_folder_path <- function(AuthenticationToken = NULL, FolderId, Limit = NULL, Fields = NULL, Marker = NULL) {
  op <- new_operation(
    name = "GetFolderPath",
    http_method = "GET",
    http_path = "/api/v1/folders/{FolderId}/path",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workdocs$get_folder_path_input(AuthenticationToken = AuthenticationToken, FolderId = FolderId, Limit = Limit, Fields = Fields, Marker = Marker)
  output <- .workdocs$get_folder_path_output()
  config <- get_config()
  svc <- .workdocs$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workdocs$operations$get_folder_path <- workdocs_get_folder_path

#' Retrieves a collection of resources, including folders and documents
#'
#' @description
#' Retrieves a collection of resources, including folders and documents. The only `CollectionType` supported is `SHARED_WITH_ME`.
#'
#' See [https://www.paws-r-sdk.com/docs/workdocs_get_resources/](https://www.paws-r-sdk.com/docs/workdocs_get_resources/) for full documentation.
#'
#' @param AuthenticationToken The Amazon WorkDocs authentication token. Not required when using Amazon Web Services administrator credentials to access the API.
#' @param UserId The user ID for the resource collection. This is a required field for accessing the API operation using IAM credentials.
#' @param CollectionType The collection type.
#' @param Limit The maximum number of resources to return.
#' @param Marker The marker for the next set of results. This marker was received from a previous call.
#'
#' @keywords internal
#'
#' @rdname workdocs_get_resources
workdocs_get_resources <- function(AuthenticationToken = NULL, UserId = NULL, CollectionType = NULL, Limit = NULL, Marker = NULL) {
  op <- new_operation(
    name = "GetResources",
    http_method = "GET",
    http_path = "/api/v1/resources",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workdocs$get_resources_input(AuthenticationToken = AuthenticationToken, UserId = UserId, CollectionType = CollectionType, Limit = Limit, Marker = Marker)
  output <- .workdocs$get_resources_output()
  config <- get_config()
  svc <- .workdocs$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workdocs$operations$get_resources <- workdocs_get_resources

#' Creates a new document object and version object
#'
#' @description
#' Creates a new document object and version object.
#'
#' See [https://www.paws-r-sdk.com/docs/workdocs_initiate_document_version_upload/](https://www.paws-r-sdk.com/docs/workdocs_initiate_document_version_upload/) for full documentation.
#'
#' @param AuthenticationToken Amazon WorkDocs authentication token. Not required when using Amazon Web Services administrator credentials to access the API.
#' @param Id The ID of the document.
#' @param Name The name of the document.
#' @param ContentCreatedTimestamp The timestamp when the content of the document was originally created.
#' @param ContentModifiedTimestamp The timestamp when the content of the document was modified.
#' @param ContentType The content type of the document.
#' @param DocumentSizeInBytes The size of the document, in bytes.
#' @param ParentFolderId The ID of the parent folder.
#'
#' @keywords internal
#'
#' @rdname workdocs_initiate_document_version_upload
workdocs_initiate_document_version_upload <- function(AuthenticationToken = NULL, Id = NULL, Name = NULL, ContentCreatedTimestamp = NULL, ContentModifiedTimestamp = NULL, ContentType = NULL, DocumentSizeInBytes = NULL, ParentFolderId = NULL) {
  op <- new_operation(
    name = "InitiateDocumentVersionUpload",
    http_method = "POST",
    http_path = "/api/v1/documents",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workdocs$initiate_document_version_upload_input(AuthenticationToken = AuthenticationToken, Id = Id, Name = Name, ContentCreatedTimestamp = ContentCreatedTimestamp, ContentModifiedTimestamp = ContentModifiedTimestamp, ContentType = ContentType, DocumentSizeInBytes = DocumentSizeInBytes, ParentFolderId = ParentFolderId)
  output <- .workdocs$initiate_document_version_upload_output()
  config <- get_config()
  svc <- .workdocs$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workdocs$operations$initiate_document_version_upload <- workdocs_initiate_document_version_upload

#' Removes all the permissions from the specified resource
#'
#' @description
#' Removes all the permissions from the specified resource.
#'
#' See [https://www.paws-r-sdk.com/docs/workdocs_remove_all_resource_permissions/](https://www.paws-r-sdk.com/docs/workdocs_remove_all_resource_permissions/) for full documentation.
#'
#' @param AuthenticationToken Amazon WorkDocs authentication token. Not required when using Amazon Web Services administrator credentials to access the API.
#' @param ResourceId &#91;required&#93; The ID of the resource.
#'
#' @keywords internal
#'
#' @rdname workdocs_remove_all_resource_permissions
workdocs_remove_all_resource_permissions <- function(AuthenticationToken = NULL, ResourceId) {
  op <- new_operation(
    name = "RemoveAllResourcePermissions",
    http_method = "DELETE",
    http_path = "/api/v1/resources/{ResourceId}/permissions",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workdocs$remove_all_resource_permissions_input(AuthenticationToken = AuthenticationToken, ResourceId = ResourceId)
  output <- .workdocs$remove_all_resource_permissions_output()
  config <- get_config()
  svc <- .workdocs$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workdocs$operations$remove_all_resource_permissions <- workdocs_remove_all_resource_permissions

#' Removes the permission for the specified principal from the specified
#' resource
#'
#' @description
#' Removes the permission for the specified principal from the specified resource.
#'
#' See [https://www.paws-r-sdk.com/docs/workdocs_remove_resource_permission/](https://www.paws-r-sdk.com/docs/workdocs_remove_resource_permission/) for full documentation.
#'
#' @param AuthenticationToken Amazon WorkDocs authentication token. Not required when using Amazon Web Services administrator credentials to access the API.
#' @param ResourceId &#91;required&#93; The ID of the resource.
#' @param PrincipalId &#91;required&#93; The principal ID of the resource.
#' @param PrincipalType The principal type of the resource.
#'
#' @keywords internal
#'
#' @rdname workdocs_remove_resource_permission
workdocs_remove_resource_permission <- function(AuthenticationToken = NULL, ResourceId, PrincipalId, PrincipalType = NULL) {
  op <- new_operation(
    name = "RemoveResourcePermission",
    http_method = "DELETE",
    http_path = "/api/v1/resources/{ResourceId}/permissions/{PrincipalId}",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workdocs$remove_resource_permission_input(AuthenticationToken = AuthenticationToken, ResourceId = ResourceId, PrincipalId = PrincipalId, PrincipalType = PrincipalType)
  output <- .workdocs$remove_resource_permission_output()
  config <- get_config()
  svc <- .workdocs$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workdocs$operations$remove_resource_permission <- workdocs_remove_resource_permission

#' Recovers a deleted version of an Amazon WorkDocs document
#'
#' @description
#' Recovers a deleted version of an Amazon WorkDocs document.
#'
#' See [https://www.paws-r-sdk.com/docs/workdocs_restore_document_versions/](https://www.paws-r-sdk.com/docs/workdocs_restore_document_versions/) for full documentation.
#'
#' @param AuthenticationToken Amazon WorkDocs authentication token. Not required when using Amazon Web Services administrator credentials to access the API.
#' @param DocumentId &#91;required&#93; The ID of the document.
#'
#' @keywords internal
#'
#' @rdname workdocs_restore_document_versions
workdocs_restore_document_versions <- function(AuthenticationToken = NULL, DocumentId) {
  op <- new_operation(
    name = "RestoreDocumentVersions",
    http_method = "POST",
    http_path = "/api/v1/documentVersions/restore/{DocumentId}",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workdocs$restore_document_versions_input(AuthenticationToken = AuthenticationToken, DocumentId = DocumentId)
  output <- .workdocs$restore_document_versions_output()
  config <- get_config()
  svc <- .workdocs$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workdocs$operations$restore_document_versions <- workdocs_restore_document_versions

#' Searches metadata and the content of folders, documents, document
#' versions, and comments
#'
#' @description
#' Searches metadata and the content of folders, documents, document versions, and comments.
#'
#' See [https://www.paws-r-sdk.com/docs/workdocs_search_resources/](https://www.paws-r-sdk.com/docs/workdocs_search_resources/) for full documentation.
#'
#' @param AuthenticationToken Amazon WorkDocs authentication token. Not required when using Amazon Web Services administrator credentials to access the API.
#' @param QueryText The String to search for. Searches across different text fields based on request parameters. Use double quotes around the query string for exact phrase matches.
#' @param QueryScopes Filter based on the text field type. A Folder has only a name and no content. A Comment has only content and no name. A Document or Document Version has a name and content
#' @param OrganizationId Filters based on the resource owner OrgId. This is a mandatory parameter when using Admin SigV4 credentials.
#' @param AdditionalResponseFields A list of attributes to include in the response. Used to request fields that are not normally returned in a standard response.
#' @param Filters Filters results based on entity metadata.
#' @param OrderBy Order by results in one or more categories.
#' @param Limit Max results count per page.
#' @param Marker The marker for the next set of results.
#'
#' @keywords internal
#'
#' @rdname workdocs_search_resources
workdocs_search_resources <- function(AuthenticationToken = NULL, QueryText = NULL, QueryScopes = NULL, OrganizationId = NULL, AdditionalResponseFields = NULL, Filters = NULL, OrderBy = NULL, Limit = NULL, Marker = NULL) {
  op <- new_operation(
    name = "SearchResources",
    http_method = "POST",
    http_path = "/api/v1/search",
    host_prefix = "",
    paginator = list(input_token = "Marker", limit_key = "Limit", output_token = "Marker", result_key = "Items"),
    stream_api = FALSE
  )
  input <- .workdocs$search_resources_input(AuthenticationToken = AuthenticationToken, QueryText = QueryText, QueryScopes = QueryScopes, OrganizationId = OrganizationId, AdditionalResponseFields = AdditionalResponseFields, Filters = Filters, OrderBy = OrderBy, Limit = Limit, Marker = Marker)
  output <- .workdocs$search_resources_output()
  config <- get_config()
  svc <- .workdocs$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workdocs$operations$search_resources <- workdocs_search_resources

#' Updates the specified attributes of a document
#'
#' @description
#' Updates the specified attributes of a document. The user must have access to both the document and its parent folder, if applicable.
#'
#' See [https://www.paws-r-sdk.com/docs/workdocs_update_document/](https://www.paws-r-sdk.com/docs/workdocs_update_document/) for full documentation.
#'
#' @param AuthenticationToken Amazon WorkDocs authentication token. Not required when using Amazon Web Services administrator credentials to access the API.
#' @param DocumentId &#91;required&#93; The ID of the document.
#' @param Name The name of the document.
#' @param ParentFolderId The ID of the parent folder.
#' @param ResourceState The resource state of the document. Only ACTIVE and RECYCLED are supported.
#'
#' @keywords internal
#'
#' @rdname workdocs_update_document
workdocs_update_document <- function(AuthenticationToken = NULL, DocumentId, Name = NULL, ParentFolderId = NULL, ResourceState = NULL) {
  op <- new_operation(
    name = "UpdateDocument",
    http_method = "PATCH",
    http_path = "/api/v1/documents/{DocumentId}",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workdocs$update_document_input(AuthenticationToken = AuthenticationToken, DocumentId = DocumentId, Name = Name, ParentFolderId = ParentFolderId, ResourceState = ResourceState)
  output <- .workdocs$update_document_output()
  config <- get_config()
  svc <- .workdocs$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workdocs$operations$update_document <- workdocs_update_document

#' Changes the status of the document version to ACTIVE
#'
#' @description
#' Changes the status of the document version to ACTIVE.
#'
#' See [https://www.paws-r-sdk.com/docs/workdocs_update_document_version/](https://www.paws-r-sdk.com/docs/workdocs_update_document_version/) for full documentation.
#'
#' @param AuthenticationToken Amazon WorkDocs authentication token. Not required when using Amazon Web Services administrator credentials to access the API.
#' @param DocumentId &#91;required&#93; The ID of the document.
#' @param VersionId &#91;required&#93; The version ID of the document.
#' @param VersionStatus The status of the version.
#'
#' @keywords internal
#'
#' @rdname workdocs_update_document_version
workdocs_update_document_version <- function(AuthenticationToken = NULL, DocumentId, VersionId, VersionStatus = NULL) {
  op <- new_operation(
    name = "UpdateDocumentVersion",
    http_method = "PATCH",
    http_path = "/api/v1/documents/{DocumentId}/versions/{VersionId}",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workdocs$update_document_version_input(AuthenticationToken = AuthenticationToken, DocumentId = DocumentId, VersionId = VersionId, VersionStatus = VersionStatus)
  output <- .workdocs$update_document_version_output()
  config <- get_config()
  svc <- .workdocs$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workdocs$operations$update_document_version <- workdocs_update_document_version

#' Updates the specified attributes of the specified folder
#'
#' @description
#' Updates the specified attributes of the specified folder. The user must have access to both the folder and its parent folder, if applicable.
#'
#' See [https://www.paws-r-sdk.com/docs/workdocs_update_folder/](https://www.paws-r-sdk.com/docs/workdocs_update_folder/) for full documentation.
#'
#' @param AuthenticationToken Amazon WorkDocs authentication token. Not required when using Amazon Web Services administrator credentials to access the API.
#' @param FolderId &#91;required&#93; The ID of the folder.
#' @param Name The name of the folder.
#' @param ParentFolderId The ID of the parent folder.
#' @param ResourceState The resource state of the folder. Only ACTIVE and RECYCLED are accepted values from the API.
#'
#' @keywords internal
#'
#' @rdname workdocs_update_folder
workdocs_update_folder <- function(AuthenticationToken = NULL, FolderId, Name = NULL, ParentFolderId = NULL, ResourceState = NULL) {
  op <- new_operation(
    name = "UpdateFolder",
    http_method = "PATCH",
    http_path = "/api/v1/folders/{FolderId}",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workdocs$update_folder_input(AuthenticationToken = AuthenticationToken, FolderId = FolderId, Name = Name, ParentFolderId = ParentFolderId, ResourceState = ResourceState)
  output <- .workdocs$update_folder_output()
  config <- get_config()
  svc <- .workdocs$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workdocs$operations$update_folder <- workdocs_update_folder

#' Updates the specified attributes of the specified user, and grants or
#' revokes administrative privileges to the Amazon WorkDocs site
#'
#' @description
#' Updates the specified attributes of the specified user, and grants or revokes administrative privileges to the Amazon WorkDocs site.
#'
#' See [https://www.paws-r-sdk.com/docs/workdocs_update_user/](https://www.paws-r-sdk.com/docs/workdocs_update_user/) for full documentation.
#'
#' @param AuthenticationToken Amazon WorkDocs authentication token. Not required when using Amazon Web Services administrator credentials to access the API.
#' @param UserId &#91;required&#93; The ID of the user.
#' @param GivenName The given name of the user.
#' @param Surname The surname of the user.
#' @param Type The type of the user.
#' @param StorageRule The amount of storage for the user.
#' @param TimeZoneId The time zone ID of the user.
#' @param Locale The locale of the user.
#' @param GrantPoweruserPrivileges Boolean value to determine whether the user is granted Power user privileges.
#'
#' @keywords internal
#'
#' @rdname workdocs_update_user
workdocs_update_user <- function(AuthenticationToken = NULL, UserId, GivenName = NULL, Surname = NULL, Type = NULL, StorageRule = NULL, TimeZoneId = NULL, Locale = NULL, GrantPoweruserPrivileges = NULL) {
  op <- new_operation(
    name = "UpdateUser",
    http_method = "PATCH",
    http_path = "/api/v1/users/{UserId}",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workdocs$update_user_input(AuthenticationToken = AuthenticationToken, UserId = UserId, GivenName = GivenName, Surname = Surname, Type = Type, StorageRule = StorageRule, TimeZoneId = TimeZoneId, Locale = Locale, GrantPoweruserPrivileges = GrantPoweruserPrivileges)
  output <- .workdocs$update_user_output()
  config <- get_config()
  svc <- .workdocs$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workdocs$operations$update_user <- workdocs_update_user

# This file is generated by make.paws. Please do not edit here.
#' @importFrom paws.common new_handlers new_service set_config merge_config
NULL

#' Amazon WorkDocs
#'
#' @description
#' The Amazon WorkDocs API is designed for the following use cases:
#' 
#' -   File Migration: File migration applications are supported for users who want to migrate their files from an on-premises or off-premises file system or service. Users can insert files into a user directory structure, as well as allow for basic metadata changes, such as modifications to the permissions of files.
#' 
#' -   Security: Support security applications are supported for users who have additional security needs, such as antivirus or data loss prevention. The API actions, along with CloudTrail, allow these applications to detect when changes occur in Amazon WorkDocs. Then, the application can take the necessary actions and replace the target file. If the target file violates the policy, the application can also choose to email the user.
#' 
#' -   eDiscovery/Analytics: General administrative applications are supported, such as eDiscovery and analytics. These applications can choose to mimic or record the actions in an Amazon WorkDocs site, along with CloudTrail, to replicate data for eDiscovery, backup, or analytical applications.
#' 
#' All Amazon WorkDocs API actions are Amazon authenticated and certificate-signed. They not only require the use of the Amazon Web Services SDK, but also allow for the exclusive use of IAM users and roles to help facilitate access, trust, and permission policies. By creating a role and allowing an IAM user to access the Amazon WorkDocs site, the IAM user gains full administrative visibility into the entire Amazon WorkDocs site (or as set in the IAM policy). This includes, but is not limited to, the ability to modify file permissions and upload any file to any user. This allows developers to perform the three use cases above, as well as give users the ability to grant access on a selective basis using the IAM model.
#' 
#' The pricing for Amazon WorkDocs APIs varies depending on the API call type for these actions:
#' 
#' -   `READ (Get*)`
#' 
#' -   `WRITE (Activate*, Add*, Create*, Deactivate*, Initiate*, Update*)`
#' 
#' -   `LIST (Describe*)`
#' 
#' -   `DELETE*, CANCEL`
#' 
#' For information about Amazon WorkDocs API pricing, see [Amazon WorkDocs Pricing](https://aws.amazon.com/).
#'
#' @param
#' config
#' Optional configuration of credentials, endpoint, and/or region.
#' \itemize{
#' \item{\strong{credentials}: \itemize{
#' \item{\strong{creds}: \itemize{
#' \item{\strong{access_key_id}: AWS access key ID}
#' \item{\strong{secret_access_key}: AWS secret access key}
#' \item{\strong{session_token}: AWS temporary session token}
#' }}
#' \item{\strong{profile}: The name of a profile to use. If not given, then the default profile is used.}
#' \item{\strong{anonymous}: Set anonymous credentials.}
#' }}
#' \item{\strong{endpoint}: The complete URL to use for the constructed client.}
#' \item{\strong{region}: The AWS Region used in instantiating the client.}
#' \item{\strong{close_connection}: Immediately close all HTTP connections.}
#' \item{\strong{timeout}: The time in seconds till a timeout exception is thrown when attempting to make a connection. The default is 60 seconds.}
#' \item{\strong{s3_force_path_style}: Set this to `true` to force the request to use path-style addressing, i.e. `http://s3.amazonaws.com/BUCKET/KEY`.}
#' \item{\strong{sts_regional_endpoint}: Set sts regional endpoint resolver to regional or legacy \url{https://docs.aws.amazon.com/sdkref/latest/guide/feature-sts-regionalized-endpoints.html}}
#' }
#' @param
#' credentials
#' Optional credentials shorthand for the config parameter
#' \itemize{
#' \item{\strong{creds}: \itemize{
#' \item{\strong{access_key_id}: AWS access key ID}
#' \item{\strong{secret_access_key}: AWS secret access key}
#' \item{\strong{session_token}: AWS temporary session token}
#' }}
#' \item{\strong{profile}: The name of a profile to use. If not given, then the default profile is used.}
#' \item{\strong{anonymous}: Set anonymous credentials.}
#' }
#' @param
#' endpoint
#' Optional shorthand for complete URL to use for the constructed client.
#' @param
#' region
#' Optional shorthand for AWS Region used in instantiating the client.
#'
#' @section Service syntax:
#' ```
#' svc <- workdocs(
#'   config = list(
#'     credentials = list(
#'       creds = list(
#'         access_key_id = "string",
#'         secret_access_key = "string",
#'         session_token = "string"
#'       ),
#'       profile = "string",
#'       anonymous = "logical"
#'     ),
#'     endpoint = "string",
#'     region = "string",
#'     close_connection = "logical",
#'     timeout = "numeric",
#'     s3_force_path_style = "logical",
#'     sts_regional_endpoint = "string"
#'   ),
#'   credentials = list(
#'     creds = list(
#'       access_key_id = "string",
#'       secret_access_key = "string",
#'       session_token = "string"
#'     ),
#'     profile = "string",
#'     anonymous = "logical"
#'   ),
#'   endpoint = "string",
#'   region = "string"
#' )
#' ```
#'
#' @examples
#' \dontrun{
#' svc <- workdocs()
#' svc$abort_document_version_upload(
#'   Foo = 123
#' )
#' }
#'
#' @section Operations:
#' \tabular{ll}{
#'  \link[=workdocs_abort_document_version_upload]{abort_document_version_upload} \tab Aborts the upload of the specified document version that was previously initiated by InitiateDocumentVersionUpload\cr
#'  \link[=workdocs_activate_user]{activate_user} \tab Activates the specified user\cr
#'  \link[=workdocs_add_resource_permissions]{add_resource_permissions} \tab Creates a set of permissions for the specified folder or document\cr
#'  \link[=workdocs_create_comment]{create_comment} \tab Adds a new comment to the specified document version\cr
#'  \link[=workdocs_create_custom_metadata]{create_custom_metadata} \tab Adds one or more custom properties to the specified resource (a folder, document, or version)\cr
#'  \link[=workdocs_create_folder]{create_folder} \tab Creates a folder with the specified name and parent folder\cr
#'  \link[=workdocs_create_labels]{create_labels} \tab Adds the specified list of labels to the given resource (a document or folder)\cr
#'  \link[=workdocs_create_notification_subscription]{create_notification_subscription} \tab Configure Amazon WorkDocs to use Amazon SNS notifications\cr
#'  \link[=workdocs_create_user]{create_user} \tab Creates a user in a Simple AD or Microsoft AD directory\cr
#'  \link[=workdocs_deactivate_user]{deactivate_user} \tab Deactivates the specified user, which revokes the user's access to Amazon WorkDocs\cr
#'  \link[=workdocs_delete_comment]{delete_comment} \tab Deletes the specified comment from the document version\cr
#'  \link[=workdocs_delete_custom_metadata]{delete_custom_metadata} \tab Deletes custom metadata from the specified resource\cr
#'  \link[=workdocs_delete_document]{delete_document} \tab Permanently deletes the specified document and its associated metadata\cr
#'  \link[=workdocs_delete_document_version]{delete_document_version} \tab Deletes a specific version of a document\cr
#'  \link[=workdocs_delete_folder]{delete_folder} \tab Permanently deletes the specified folder and its contents\cr
#'  \link[=workdocs_delete_folder_contents]{delete_folder_contents} \tab Deletes the contents of the specified folder\cr
#'  \link[=workdocs_delete_labels]{delete_labels} \tab Deletes the specified list of labels from a resource\cr
#'  \link[=workdocs_delete_notification_subscription]{delete_notification_subscription} \tab Deletes the specified subscription from the specified organization\cr
#'  \link[=workdocs_delete_user]{delete_user} \tab Deletes the specified user from a Simple AD or Microsoft AD directory\cr
#'  \link[=workdocs_describe_activities]{describe_activities} \tab Describes the user activities in a specified time period\cr
#'  \link[=workdocs_describe_comments]{describe_comments} \tab List all the comments for the specified document version\cr
#'  \link[=workdocs_describe_document_versions]{describe_document_versions} \tab Retrieves the document versions for the specified document\cr
#'  \link[=workdocs_describe_folder_contents]{describe_folder_contents} \tab Describes the contents of the specified folder, including its documents and subfolders\cr
#'  \link[=workdocs_describe_groups]{describe_groups} \tab Describes the groups specified by the query\cr
#'  \link[=workdocs_describe_notification_subscriptions]{describe_notification_subscriptions} \tab Lists the specified notification subscriptions\cr
#'  \link[=workdocs_describe_resource_permissions]{describe_resource_permissions} \tab Describes the permissions of a specified resource\cr
#'  \link[=workdocs_describe_root_folders]{describe_root_folders} \tab Describes the current user's special folders; the RootFolder and the RecycleBin\cr
#'  \link[=workdocs_describe_users]{describe_users} \tab Describes the specified users\cr
#'  \link[=workdocs_get_current_user]{get_current_user} \tab Retrieves details of the current user for whom the authentication token was generated\cr
#'  \link[=workdocs_get_document]{get_document} \tab Retrieves details of a document\cr
#'  \link[=workdocs_get_document_path]{get_document_path} \tab Retrieves the path information (the hierarchy from the root folder) for the requested document\cr
#'  \link[=workdocs_get_document_version]{get_document_version} \tab Retrieves version metadata for the specified document\cr
#'  \link[=workdocs_get_folder]{get_folder} \tab Retrieves the metadata of the specified folder\cr
#'  \link[=workdocs_get_folder_path]{get_folder_path} \tab Retrieves the path information (the hierarchy from the root folder) for the specified folder\cr
#'  \link[=workdocs_get_resources]{get_resources} \tab Retrieves a collection of resources, including folders and documents\cr
#'  \link[=workdocs_initiate_document_version_upload]{initiate_document_version_upload} \tab Creates a new document object and version object\cr
#'  \link[=workdocs_remove_all_resource_permissions]{remove_all_resource_permissions} \tab Removes all the permissions from the specified resource\cr
#'  \link[=workdocs_remove_resource_permission]{remove_resource_permission} \tab Removes the permission for the specified principal from the specified resource\cr
#'  \link[=workdocs_restore_document_versions]{restore_document_versions} \tab Recovers a deleted version of an Amazon WorkDocs document\cr
#'  \link[=workdocs_search_resources]{search_resources} \tab Searches metadata and the content of folders, documents, document versions, and comments\cr
#'  \link[=workdocs_update_document]{update_document} \tab Updates the specified attributes of a document\cr
#'  \link[=workdocs_update_document_version]{update_document_version} \tab Changes the status of the document version to ACTIVE\cr
#'  \link[=workdocs_update_folder]{update_folder} \tab Updates the specified attributes of the specified folder\cr
#'  \link[=workdocs_update_user]{update_user} \tab Updates the specified attributes of the specified user, and grants or revokes administrative privileges to the Amazon WorkDocs site
#' }
#'
#' @return
#' A client for the service. You can call the service's operations using
#' syntax like `svc$operation(...)`, where `svc` is the name you've assigned
#' to the client. The available operations are listed in the
#' Operations section.
#'
#' @rdname workdocs
#' @export
workdocs <- function(config = list(), credentials = list(), endpoint = NULL, region = NULL) {
  config <- merge_config(
    config,
    list(
      credentials = credentials,
      endpoint = endpoint,
      region = region
    )
  )
  svc <- .workdocs$operations
  svc <- set_config(svc, config)
  return(svc)
}

# Private API objects: metadata, handlers, interfaces, etc.
.workdocs <- list()

.workdocs$operations <- list()

.workdocs$metadata <- list(
  service_name = "workdocs",
  endpoints = list("^(us|eu|ap|sa|ca|me|af|il|mx)\\-\\w+\\-\\d+$" = list(endpoint = "workdocs.{region}.amazonaws.com", global = FALSE), "^cn\\-\\w+\\-\\d+$" = list(endpoint = "workdocs.{region}.amazonaws.com.cn", global = FALSE), "^us\\-gov\\-\\w+\\-\\d+$" = list(endpoint = "workdocs.{region}.amazonaws.com", global = FALSE), "^us\\-iso\\-\\w+\\-\\d+$" = list(endpoint = "workdocs.{region}.c2s.ic.gov", global = FALSE), "^us\\-isob\\-\\w+\\-\\d+$" = list(endpoint = "workdocs.{region}.sc2s.sgov.gov", global = FALSE), "^eu\\-isoe\\-\\w+\\-\\d+$" = list(endpoint = "workdocs.{region}.cloud.adc-e.uk", global = FALSE), "^us\\-isof\\-\\w+\\-\\d+$" = list(endpoint = "workdocs.{region}.csp.hci.ic.gov", global = FALSE), "^eusc\\-(de)\\-\\w+\\-\\d+$" = list(endpoint = "workdocs.{region}.amazonaws.eu", global = FALSE)),
  service_id = "WorkDocs",
  api_version = "2016-05-01",
  signing_name = "workdocs",
  json_version = "1.1",
  target_prefix = ""
)

.workdocs$service <- function(config = list(), op = NULL) {
  handlers <- new_handlers("restjson", "v4")
  new_service(.workdocs$metadata, handlers, config, op)
}

# This file is generated by make.paws. Please do not edit here.
#' @importFrom paws.common new_handlers new_service set_config merge_config
NULL

#' Amazon WorkSpaces Web
#'
#' @description
#' Amazon WorkSpaces Secure Browser is a low cost, fully managed WorkSpace built specifically to facilitate secure, web-based workloads. WorkSpaces Secure Browser makes it easy for customers to safely provide their employees with access to internal websites and SaaS web applications without the administrative burden of appliances or specialized client software. WorkSpaces Secure Browser provides simple policy tools tailored for user interactions, while offloading common tasks like capacity management, scaling, and maintaining browser images.
#'
#' @param
#' config
#' Optional configuration of credentials, endpoint, and/or region.
#' \itemize{
#' \item{\strong{credentials}: \itemize{
#' \item{\strong{creds}: \itemize{
#' \item{\strong{access_key_id}: AWS access key ID}
#' \item{\strong{secret_access_key}: AWS secret access key}
#' \item{\strong{session_token}: AWS temporary session token}
#' }}
#' \item{\strong{profile}: The name of a profile to use. If not given, then the default profile is used.}
#' \item{\strong{anonymous}: Set anonymous credentials.}
#' }}
#' \item{\strong{endpoint}: The complete URL to use for the constructed client.}
#' \item{\strong{region}: The AWS Region used in instantiating the client.}
#' \item{\strong{close_connection}: Immediately close all HTTP connections.}
#' \item{\strong{timeout}: The time in seconds till a timeout exception is thrown when attempting to make a connection. The default is 60 seconds.}
#' \item{\strong{s3_force_path_style}: Set this to `true` to force the request to use path-style addressing, i.e. `http://s3.amazonaws.com/BUCKET/KEY`.}
#' \item{\strong{sts_regional_endpoint}: Set sts regional endpoint resolver to regional or legacy \url{https://docs.aws.amazon.com/sdkref/latest/guide/feature-sts-regionalized-endpoints.html}}
#' }
#' @param
#' credentials
#' Optional credentials shorthand for the config parameter
#' \itemize{
#' \item{\strong{creds}: \itemize{
#' \item{\strong{access_key_id}: AWS access key ID}
#' \item{\strong{secret_access_key}: AWS secret access key}
#' \item{\strong{session_token}: AWS temporary session token}
#' }}
#' \item{\strong{profile}: The name of a profile to use. If not given, then the default profile is used.}
#' \item{\strong{anonymous}: Set anonymous credentials.}
#' }
#' @param
#' endpoint
#' Optional shorthand for complete URL to use for the constructed client.
#' @param
#' region
#' Optional shorthand for AWS Region used in instantiating the client.
#'
#' @section Service syntax:
#' ```
#' svc <- workspacesweb(
#'   config = list(
#'     credentials = list(
#'       creds = list(
#'         access_key_id = "string",
#'         secret_access_key = "string",
#'         session_token = "string"
#'       ),
#'       profile = "string",
#'       anonymous = "logical"
#'     ),
#'     endpoint = "string",
#'     region = "string",
#'     close_connection = "logical",
#'     timeout = "numeric",
#'     s3_force_path_style = "logical",
#'     sts_regional_endpoint = "string"
#'   ),
#'   credentials = list(
#'     creds = list(
#'       access_key_id = "string",
#'       secret_access_key = "string",
#'       session_token = "string"
#'     ),
#'     profile = "string",
#'     anonymous = "logical"
#'   ),
#'   endpoint = "string",
#'   region = "string"
#' )
#' ```
#'
#' @examples
#' \dontrun{
#' svc <- workspacesweb()
#' svc$associate_browser_settings(
#'   Foo = 123
#' )
#' }
#'
#' @section Operations:
#' \tabular{ll}{
#'  \link[=workspacesweb_associate_browser_settings]{associate_browser_settings} \tab Associates a browser settings resource with a web portal\cr
#'  \link[=workspacesweb_associate_data_protection_settings]{associate_data_protection_settings} \tab Associates a data protection settings resource with a web portal\cr
#'  \link[=workspacesweb_associate_ip_access_settings]{associate_ip_access_settings} \tab Associates an IP access settings resource with a web portal\cr
#'  \link[=workspacesweb_associate_network_settings]{associate_network_settings} \tab Associates a network settings resource with a web portal\cr
#'  \link[=workspacesweb_associate_session_logger]{associate_session_logger} \tab Associates a session logger with a portal\cr
#'  \link[=workspacesweb_associate_trust_store]{associate_trust_store} \tab Associates a trust store with a web portal\cr
#'  \link[=workspacesweb_associate_user_access_logging_settings]{associate_user_access_logging_settings} \tab Associates a user access logging settings resource with a web portal\cr
#'  \link[=workspacesweb_associate_user_settings]{associate_user_settings} \tab Associates a user settings resource with a web portal\cr
#'  \link[=workspacesweb_create_browser_settings]{create_browser_settings} \tab Creates a browser settings resource that can be associated with a web portal\cr
#'  \link[=workspacesweb_create_data_protection_settings]{create_data_protection_settings} \tab Creates a data protection settings resource that can be associated with a web portal\cr
#'  \link[=workspacesweb_create_identity_provider]{create_identity_provider} \tab Creates an identity provider resource that is then associated with a web portal\cr
#'  \link[=workspacesweb_create_ip_access_settings]{create_ip_access_settings} \tab Creates an IP access settings resource that can be associated with a web portal\cr
#'  \link[=workspacesweb_create_network_settings]{create_network_settings} \tab Creates a network settings resource that can be associated with a web portal\cr
#'  \link[=workspacesweb_create_portal]{create_portal} \tab Creates a web portal\cr
#'  \link[=workspacesweb_create_session_logger]{create_session_logger} \tab Creates a session logger\cr
#'  \link[=workspacesweb_create_trust_store]{create_trust_store} \tab Creates a trust store that can be associated with a web portal\cr
#'  \link[=workspacesweb_create_user_access_logging_settings]{create_user_access_logging_settings} \tab Creates a user access logging settings resource that can be associated with a web portal\cr
#'  \link[=workspacesweb_create_user_settings]{create_user_settings} \tab Creates a user settings resource that can be associated with a web portal\cr
#'  \link[=workspacesweb_delete_browser_settings]{delete_browser_settings} \tab Deletes browser settings\cr
#'  \link[=workspacesweb_delete_data_protection_settings]{delete_data_protection_settings} \tab Deletes data protection settings\cr
#'  \link[=workspacesweb_delete_identity_provider]{delete_identity_provider} \tab Deletes the identity provider\cr
#'  \link[=workspacesweb_delete_ip_access_settings]{delete_ip_access_settings} \tab Deletes IP access settings\cr
#'  \link[=workspacesweb_delete_network_settings]{delete_network_settings} \tab Deletes network settings\cr
#'  \link[=workspacesweb_delete_portal]{delete_portal} \tab Deletes a web portal\cr
#'  \link[=workspacesweb_delete_session_logger]{delete_session_logger} \tab Deletes a session logger resource\cr
#'  \link[=workspacesweb_delete_trust_store]{delete_trust_store} \tab Deletes the trust store\cr
#'  \link[=workspacesweb_delete_user_access_logging_settings]{delete_user_access_logging_settings} \tab Deletes user access logging settings\cr
#'  \link[=workspacesweb_delete_user_settings]{delete_user_settings} \tab Deletes user settings\cr
#'  \link[=workspacesweb_disassociate_browser_settings]{disassociate_browser_settings} \tab Disassociates browser settings from a web portal\cr
#'  \link[=workspacesweb_disassociate_data_protection_settings]{disassociate_data_protection_settings} \tab Disassociates data protection settings from a web portal\cr
#'  \link[=workspacesweb_disassociate_ip_access_settings]{disassociate_ip_access_settings} \tab Disassociates IP access settings from a web portal\cr
#'  \link[=workspacesweb_disassociate_network_settings]{disassociate_network_settings} \tab Disassociates network settings from a web portal\cr
#'  \link[=workspacesweb_disassociate_session_logger]{disassociate_session_logger} \tab Disassociates a session logger from a portal\cr
#'  \link[=workspacesweb_disassociate_trust_store]{disassociate_trust_store} \tab Disassociates a trust store from a web portal\cr
#'  \link[=workspacesweb_disassociate_user_access_logging_settings]{disassociate_user_access_logging_settings} \tab Disassociates user access logging settings from a web portal\cr
#'  \link[=workspacesweb_disassociate_user_settings]{disassociate_user_settings} \tab Disassociates user settings from a web portal\cr
#'  \link[=workspacesweb_expire_session]{expire_session} \tab Expires an active secure browser session\cr
#'  \link[=workspacesweb_get_browser_settings]{get_browser_settings} \tab Gets browser settings\cr
#'  \link[=workspacesweb_get_data_protection_settings]{get_data_protection_settings} \tab Gets the data protection settings\cr
#'  \link[=workspacesweb_get_identity_provider]{get_identity_provider} \tab Gets the identity provider\cr
#'  \link[=workspacesweb_get_ip_access_settings]{get_ip_access_settings} \tab Gets the IP access settings\cr
#'  \link[=workspacesweb_get_network_settings]{get_network_settings} \tab Gets the network settings\cr
#'  \link[=workspacesweb_get_portal]{get_portal} \tab Gets the web portal\cr
#'  \link[=workspacesweb_get_portal_service_provider_metadata]{get_portal_service_provider_metadata} \tab Gets the service provider metadata\cr
#'  \link[=workspacesweb_get_session]{get_session} \tab Gets information for a secure browser session\cr
#'  \link[=workspacesweb_get_session_logger]{get_session_logger} \tab Gets details about a specific session logger resource\cr
#'  \link[=workspacesweb_get_trust_store]{get_trust_store} \tab Gets the trust store\cr
#'  \link[=workspacesweb_get_trust_store_certificate]{get_trust_store_certificate} \tab Gets the trust store certificate\cr
#'  \link[=workspacesweb_get_user_access_logging_settings]{get_user_access_logging_settings} \tab Gets user access logging settings\cr
#'  \link[=workspacesweb_get_user_settings]{get_user_settings} \tab Gets user settings\cr
#'  \link[=workspacesweb_list_browser_settings]{list_browser_settings} \tab Retrieves a list of browser settings\cr
#'  \link[=workspacesweb_list_data_protection_settings]{list_data_protection_settings} \tab Retrieves a list of data protection settings\cr
#'  \link[=workspacesweb_list_identity_providers]{list_identity_providers} \tab Retrieves a list of identity providers for a specific web portal\cr
#'  \link[=workspacesweb_list_ip_access_settings]{list_ip_access_settings} \tab Retrieves a list of IP access settings\cr
#'  \link[=workspacesweb_list_network_settings]{list_network_settings} \tab Retrieves a list of network settings\cr
#'  \link[=workspacesweb_list_portals]{list_portals} \tab Retrieves a list or web portals\cr
#'  \link[=workspacesweb_list_session_loggers]{list_session_loggers} \tab Lists all available session logger resources\cr
#'  \link[=workspacesweb_list_sessions]{list_sessions} \tab Lists information for multiple secure browser sessions from a specific portal\cr
#'  \link[=workspacesweb_list_tags_for_resource]{list_tags_for_resource} \tab Retrieves a list of tags for a resource\cr
#'  \link[=workspacesweb_list_trust_store_certificates]{list_trust_store_certificates} \tab Retrieves a list of trust store certificates\cr
#'  \link[=workspacesweb_list_trust_stores]{list_trust_stores} \tab Retrieves a list of trust stores\cr
#'  \link[=workspacesweb_list_user_access_logging_settings]{list_user_access_logging_settings} \tab Retrieves a list of user access logging settings\cr
#'  \link[=workspacesweb_list_user_settings]{list_user_settings} \tab Retrieves a list of user settings\cr
#'  \link[=workspacesweb_tag_resource]{tag_resource} \tab Adds or overwrites one or more tags for the specified resource\cr
#'  \link[=workspacesweb_untag_resource]{untag_resource} \tab Removes one or more tags from the specified resource\cr
#'  \link[=workspacesweb_update_browser_settings]{update_browser_settings} \tab Updates browser settings\cr
#'  \link[=workspacesweb_update_data_protection_settings]{update_data_protection_settings} \tab Updates data protection settings\cr
#'  \link[=workspacesweb_update_identity_provider]{update_identity_provider} \tab Updates the identity provider\cr
#'  \link[=workspacesweb_update_ip_access_settings]{update_ip_access_settings} \tab Updates IP access settings\cr
#'  \link[=workspacesweb_update_network_settings]{update_network_settings} \tab Updates network settings\cr
#'  \link[=workspacesweb_update_portal]{update_portal} \tab Updates a web portal\cr
#'  \link[=workspacesweb_update_session_logger]{update_session_logger} \tab Updates the details of a session logger\cr
#'  \link[=workspacesweb_update_trust_store]{update_trust_store} \tab Updates the trust store\cr
#'  \link[=workspacesweb_update_user_access_logging_settings]{update_user_access_logging_settings} \tab Updates the user access logging settings\cr
#'  \link[=workspacesweb_update_user_settings]{update_user_settings} \tab Updates the user settings
#' }
#'
#' @return
#' A client for the service. You can call the service's operations using
#' syntax like `svc$operation(...)`, where `svc` is the name you've assigned
#' to the client. The available operations are listed in the
#' Operations section.
#'
#' @rdname workspacesweb
#' @export
workspacesweb <- function(config = list(), credentials = list(), endpoint = NULL, region = NULL) {
  config <- merge_config(
    config,
    list(
      credentials = credentials,
      endpoint = endpoint,
      region = region
    )
  )
  svc <- .workspacesweb$operations
  svc <- set_config(svc, config)
  return(svc)
}

# Private API objects: metadata, handlers, interfaces, etc.
.workspacesweb <- list()

.workspacesweb$operations <- list()

.workspacesweb$metadata <- list(
  service_name = "workspacesweb",
  endpoints = list("^(us|eu|ap|sa|ca|me|af|il|mx)\\-\\w+\\-\\d+$" = list(endpoint = "workspaces-web.{region}.amazonaws.com", global = FALSE), "^cn\\-\\w+\\-\\d+$" = list(endpoint = "workspaces-web.{region}.amazonaws.com.cn", global = FALSE), "^us\\-gov\\-\\w+\\-\\d+$" = list(endpoint = "workspaces-web.{region}.amazonaws.com", global = FALSE), "^us\\-iso\\-\\w+\\-\\d+$" = list(endpoint = "workspaces-web.{region}.c2s.ic.gov", global = FALSE), "^us\\-isob\\-\\w+\\-\\d+$" = list(endpoint = "workspaces-web.{region}.sc2s.sgov.gov", global = FALSE), "^eu\\-isoe\\-\\w+\\-\\d+$" = list(endpoint = "workspaces-web.{region}.cloud.adc-e.uk", global = FALSE), "^us\\-isof\\-\\w+\\-\\d+$" = list(endpoint = "workspaces-web.{region}.csp.hci.ic.gov", global = FALSE), "^eusc\\-(de)\\-\\w+\\-\\d+$" = list(endpoint = "workspaces-web.{region}.amazonaws.eu", global = FALSE)),
  service_id = "WorkSpaces Web",
  api_version = "2020-07-08",
  signing_name = "workspaces-web",
  json_version = "",
  target_prefix = ""
)

.workspacesweb$service <- function(config = list(), op = NULL) {
  handlers <- new_handlers("restjson", "v4")
  new_service(.workspacesweb$metadata, handlers, config, op)
}

svc <- paws::workspacesweb()

test_that("list_browser_settings", {
  expect_error(svc$list_browser_settings(), NA)
})

test_that("list_data_protection_settings", {
  expect_error(svc$list_data_protection_settings(), NA)
})

test_that("list_ip_access_settings", {
  expect_error(svc$list_ip_access_settings(), NA)
})

test_that("list_network_settings", {
  expect_error(svc$list_network_settings(), NA)
})

test_that("list_portals", {
  expect_error(svc$list_portals(), NA)
})

test_that("list_session_loggers", {
  expect_error(svc$list_session_loggers(), NA)
})

test_that("list_trust_stores", {
  expect_error(svc$list_trust_stores(), NA)
})

test_that("list_user_access_logging_settings", {
  expect_error(svc$list_user_access_logging_settings(), NA)
})

test_that("list_user_settings", {
  expect_error(svc$list_user_settings(), NA)
})

# This file is generated by make.paws. Please do not edit here.
#' @importFrom paws.common get_config new_operation new_request send_request
#' @include workmail_service.R
NULL

#' Adds a member (user or group) to the resource's set of delegates
#'
#' @description
#' Adds a member (user or group) to the resource's set of delegates.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_associate_delegate_to_resource/](https://www.paws-r-sdk.com/docs/workmail_associate_delegate_to_resource/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; The organization under which the resource exists.
#' @param ResourceId &#91;required&#93; The resource for which members (users or groups) are associated.
#' 
#' The identifier can accept *ResourceId*, *Resourcename*, or *email*. The following identity formats are available:
#' 
#' -   Resource ID: r-0123456789a0123456789b0123456789
#' 
#' -   Email address: resource@@domain.tld
#' 
#' -   Resource name: resource
#' @param EntityId &#91;required&#93; The member (user or group) to associate to the resource.
#' 
#' The entity ID can accept *UserId or GroupID*, *Username or Groupname*, or *email*.
#' 
#' -   Entity: 12345678-1234-1234-1234-123456789012 or S-1-1-12-1234567890-123456789-123456789-1234
#' 
#' -   Email address: entity@@domain.tld
#' 
#' -   Entity: entity
#'
#' @keywords internal
#'
#' @rdname workmail_associate_delegate_to_resource
workmail_associate_delegate_to_resource <- function(OrganizationId, ResourceId, EntityId) {
  op <- new_operation(
    name = "AssociateDelegateToResource",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmail$associate_delegate_to_resource_input(OrganizationId = OrganizationId, ResourceId = ResourceId, EntityId = EntityId)
  output <- .workmail$associate_delegate_to_resource_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$associate_delegate_to_resource <- workmail_associate_delegate_to_resource

#' Adds a member (user or group) to the group's set
#'
#' @description
#' Adds a member (user or group) to the group's set.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_associate_member_to_group/](https://www.paws-r-sdk.com/docs/workmail_associate_member_to_group/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; The organization under which the group exists.
#' @param GroupId &#91;required&#93; The group to which the member (user or group) is associated.
#' 
#' The identifier can accept *GroupId*, *Groupname*, or *email*. The following identity formats are available:
#' 
#' -   Group ID: 12345678-1234-1234-1234-123456789012 or S-1-1-12-1234567890-123456789-123456789-1234
#' 
#' -   Email address: group@@domain.tld
#' 
#' -   Group name: group
#' @param MemberId &#91;required&#93; The member (user or group) to associate to the group.
#' 
#' The member ID can accept *UserID or GroupId*, *Username or Groupname*, or *email*.
#' 
#' -   Member: 12345678-1234-1234-1234-123456789012 or S-1-1-12-1234567890-123456789-123456789-1234
#' 
#' -   Email address: member@@domain.tld
#' 
#' -   Member name: member
#'
#' @keywords internal
#'
#' @rdname workmail_associate_member_to_group
workmail_associate_member_to_group <- function(OrganizationId, GroupId, MemberId) {
  op <- new_operation(
    name = "AssociateMemberToGroup",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmail$associate_member_to_group_input(OrganizationId = OrganizationId, GroupId = GroupId, MemberId = MemberId)
  output <- .workmail$associate_member_to_group_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$associate_member_to_group <- workmail_associate_member_to_group

#' Assumes an impersonation role for the given WorkMail organization
#'
#' @description
#' Assumes an impersonation role for the given WorkMail organization. This method returns an authentication token you can use to make impersonated calls.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_assume_impersonation_role/](https://www.paws-r-sdk.com/docs/workmail_assume_impersonation_role/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; The WorkMail organization under which the impersonation role will be assumed.
#' @param ImpersonationRoleId &#91;required&#93; The impersonation role ID to assume.
#'
#' @keywords internal
#'
#' @rdname workmail_assume_impersonation_role
workmail_assume_impersonation_role <- function(OrganizationId, ImpersonationRoleId) {
  op <- new_operation(
    name = "AssumeImpersonationRole",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmail$assume_impersonation_role_input(OrganizationId = OrganizationId, ImpersonationRoleId = ImpersonationRoleId)
  output <- .workmail$assume_impersonation_role_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$assume_impersonation_role <- workmail_assume_impersonation_role

#' Cancels a mailbox export job
#'
#' @description
#' Cancels a mailbox export job.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_cancel_mailbox_export_job/](https://www.paws-r-sdk.com/docs/workmail_cancel_mailbox_export_job/) for full documentation.
#'
#' @param ClientToken &#91;required&#93; The idempotency token for the client request.
#' @param JobId &#91;required&#93; The job ID.
#' @param OrganizationId &#91;required&#93; The organization ID.
#'
#' @keywords internal
#'
#' @rdname workmail_cancel_mailbox_export_job
workmail_cancel_mailbox_export_job <- function(ClientToken, JobId, OrganizationId) {
  op <- new_operation(
    name = "CancelMailboxExportJob",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmail$cancel_mailbox_export_job_input(ClientToken = ClientToken, JobId = JobId, OrganizationId = OrganizationId)
  output <- .workmail$cancel_mailbox_export_job_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$cancel_mailbox_export_job <- workmail_cancel_mailbox_export_job

#' Adds an alias to the set of a given member (user or group) of WorkMail
#'
#' @description
#' Adds an alias to the set of a given member (user or group) of WorkMail.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_create_alias/](https://www.paws-r-sdk.com/docs/workmail_create_alias/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; The organization under which the member (user or group) exists.
#' @param EntityId &#91;required&#93; The member (user or group) to which this alias is added.
#' @param Alias &#91;required&#93; The alias to add to the member set.
#'
#' @keywords internal
#'
#' @rdname workmail_create_alias
workmail_create_alias <- function(OrganizationId, EntityId, Alias) {
  op <- new_operation(
    name = "CreateAlias",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmail$create_alias_input(OrganizationId = OrganizationId, EntityId = EntityId, Alias = Alias)
  output <- .workmail$create_alias_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$create_alias <- workmail_create_alias

#' Creates an AvailabilityConfiguration for the given WorkMail organization
#' and domain
#'
#' @description
#' Creates an `AvailabilityConfiguration` for the given WorkMail organization and domain.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_create_availability_configuration/](https://www.paws-r-sdk.com/docs/workmail_create_availability_configuration/) for full documentation.
#'
#' @param ClientToken An idempotent token that ensures that an API request is executed only once.
#' @param OrganizationId &#91;required&#93; The WorkMail organization for which the `AvailabilityConfiguration` will be created.
#' @param DomainName &#91;required&#93; The domain to which the provider applies.
#' @param EwsProvider Exchange Web Services (EWS) availability provider definition. The request must contain exactly one provider definition, either `EwsProvider` or `LambdaProvider`.
#' @param LambdaProvider Lambda availability provider definition. The request must contain exactly one provider definition, either `EwsProvider` or `LambdaProvider`.
#'
#' @keywords internal
#'
#' @rdname workmail_create_availability_configuration
workmail_create_availability_configuration <- function(ClientToken = NULL, OrganizationId, DomainName, EwsProvider = NULL, LambdaProvider = NULL) {
  op <- new_operation(
    name = "CreateAvailabilityConfiguration",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmail$create_availability_configuration_input(ClientToken = ClientToken, OrganizationId = OrganizationId, DomainName = DomainName, EwsProvider = EwsProvider, LambdaProvider = LambdaProvider)
  output <- .workmail$create_availability_configuration_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$create_availability_configuration <- workmail_create_availability_configuration

#' Creates a group that can be used in WorkMail by calling the
#' RegisterToWorkMail operation
#'
#' @description
#' Creates a group that can be used in WorkMail by calling the [`register_to_work_mail`][workmail_register_to_work_mail] operation.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_create_group/](https://www.paws-r-sdk.com/docs/workmail_create_group/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; The organization under which the group is to be created.
#' @param Name &#91;required&#93; The name of the group.
#' @param HiddenFromGlobalAddressList If this parameter is enabled, the group will be hidden from the address book.
#'
#' @keywords internal
#'
#' @rdname workmail_create_group
workmail_create_group <- function(OrganizationId, Name, HiddenFromGlobalAddressList = NULL) {
  op <- new_operation(
    name = "CreateGroup",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmail$create_group_input(OrganizationId = OrganizationId, Name = Name, HiddenFromGlobalAddressList = HiddenFromGlobalAddressList)
  output <- .workmail$create_group_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$create_group <- workmail_create_group

#' Creates the WorkMail application in IAM Identity Center that can be used
#' later in the WorkMail - IdC integration
#'
#' @description
#' Creates the WorkMail application in IAM Identity Center that can be used later in the WorkMail - IdC integration. For more information, see PutIdentityProviderConfiguration. This action does not affect the authentication settings for any WorkMail organizations.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_create_identity_center_application/](https://www.paws-r-sdk.com/docs/workmail_create_identity_center_application/) for full documentation.
#'
#' @param Name &#91;required&#93; The name of the IAM Identity Center application.
#' @param InstanceArn &#91;required&#93; The Amazon Resource Name (ARN) of the instance.
#' @param ClientToken The idempotency token associated with the request.
#'
#' @keywords internal
#'
#' @rdname workmail_create_identity_center_application
workmail_create_identity_center_application <- function(Name, InstanceArn, ClientToken = NULL) {
  op <- new_operation(
    name = "CreateIdentityCenterApplication",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmail$create_identity_center_application_input(Name = Name, InstanceArn = InstanceArn, ClientToken = ClientToken)
  output <- .workmail$create_identity_center_application_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$create_identity_center_application <- workmail_create_identity_center_application

#' Creates an impersonation role for the given WorkMail organization
#'
#' @description
#' Creates an impersonation role for the given WorkMail organization.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_create_impersonation_role/](https://www.paws-r-sdk.com/docs/workmail_create_impersonation_role/) for full documentation.
#'
#' @param ClientToken The idempotency token for the client request.
#' @param OrganizationId &#91;required&#93; The WorkMail organization to create the new impersonation role within.
#' @param Name &#91;required&#93; The name of the new impersonation role.
#' @param Type &#91;required&#93; The impersonation role's type. The available impersonation role types are `READ_ONLY` or `FULL_ACCESS`.
#' @param Description The description of the new impersonation role.
#' @param Rules &#91;required&#93; The list of rules for the impersonation role.
#'
#' @keywords internal
#'
#' @rdname workmail_create_impersonation_role
workmail_create_impersonation_role <- function(ClientToken = NULL, OrganizationId, Name, Type, Description = NULL, Rules) {
  op <- new_operation(
    name = "CreateImpersonationRole",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmail$create_impersonation_role_input(ClientToken = ClientToken, OrganizationId = OrganizationId, Name = Name, Type = Type, Description = Description, Rules = Rules)
  output <- .workmail$create_impersonation_role_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$create_impersonation_role <- workmail_create_impersonation_role

#' Creates a new mobile device access rule for the specified WorkMail
#' organization
#'
#' @description
#' Creates a new mobile device access rule for the specified WorkMail organization.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_create_mobile_device_access_rule/](https://www.paws-r-sdk.com/docs/workmail_create_mobile_device_access_rule/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; The WorkMail organization under which the rule will be created.
#' @param ClientToken The idempotency token for the client request.
#' @param Name &#91;required&#93; The rule name.
#' @param Description The rule description.
#' @param Effect &#91;required&#93; The effect of the rule when it matches. Allowed values are `ALLOW` or `DENY`.
#' @param DeviceTypes Device types that the rule will match.
#' @param NotDeviceTypes Device types that the rule **will not** match. All other device types will match.
#' @param DeviceModels Device models that the rule will match.
#' @param NotDeviceModels Device models that the rule **will not** match. All other device models will match.
#' @param DeviceOperatingSystems Device operating systems that the rule will match.
#' @param NotDeviceOperatingSystems Device operating systems that the rule **will not** match. All other device operating systems will match.
#' @param DeviceUserAgents Device user agents that the rule will match.
#' @param NotDeviceUserAgents Device user agents that the rule **will not** match. All other device user agents will match.
#'
#' @keywords internal
#'
#' @rdname workmail_create_mobile_device_access_rule
workmail_create_mobile_device_access_rule <- function(OrganizationId, ClientToken = NULL, Name, Description = NULL, Effect, DeviceTypes = NULL, NotDeviceTypes = NULL, DeviceModels = NULL, NotDeviceModels = NULL, DeviceOperatingSystems = NULL, NotDeviceOperatingSystems = NULL, DeviceUserAgents = NULL, NotDeviceUserAgents = NULL) {
  op <- new_operation(
    name = "CreateMobileDeviceAccessRule",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmail$create_mobile_device_access_rule_input(OrganizationId = OrganizationId, ClientToken = ClientToken, Name = Name, Description = Description, Effect = Effect, DeviceTypes = DeviceTypes, NotDeviceTypes = NotDeviceTypes, DeviceModels = DeviceModels, NotDeviceModels = NotDeviceModels, DeviceOperatingSystems = DeviceOperatingSystems, NotDeviceOperatingSystems = NotDeviceOperatingSystems, DeviceUserAgents = DeviceUserAgents, NotDeviceUserAgents = NotDeviceUserAgents)
  output <- .workmail$create_mobile_device_access_rule_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$create_mobile_device_access_rule <- workmail_create_mobile_device_access_rule

#' Creates a new WorkMail organization
#'
#' @description
#' Creates a new WorkMail organization. Optionally, you can choose to associate an existing AWS Directory Service directory with your organization. If an AWS Directory Service directory ID is specified, the organization alias must match the directory alias. If you choose not to associate an existing directory with your organization, then we create a new WorkMail directory for you. For more information, see [Adding an organization](https://docs.aws.amazon.com/workmail/latest/adminguide/add_new_organization.html) in the *WorkMail Administrator Guide*.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_create_organization/](https://www.paws-r-sdk.com/docs/workmail_create_organization/) for full documentation.
#'
#' @param DirectoryId The AWS Directory Service directory ID.
#' @param Alias &#91;required&#93; The organization alias.
#' @param ClientToken The idempotency token associated with the request.
#' @param Domains The email domains to associate with the organization.
#' @param KmsKeyArn The Amazon Resource Name (ARN) of a customer managed key from AWS KMS.
#' @param EnableInteroperability When `true`, allows organization interoperability between WorkMail and Microsoft Exchange. If `true`, you must include a AD Connector directory ID in the request.
#'
#' @keywords internal
#'
#' @rdname workmail_create_organization
workmail_create_organization <- function(DirectoryId = NULL, Alias, ClientToken = NULL, Domains = NULL, KmsKeyArn = NULL, EnableInteroperability = NULL) {
  op <- new_operation(
    name = "CreateOrganization",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmail$create_organization_input(DirectoryId = DirectoryId, Alias = Alias, ClientToken = ClientToken, Domains = Domains, KmsKeyArn = KmsKeyArn, EnableInteroperability = EnableInteroperability)
  output <- .workmail$create_organization_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$create_organization <- workmail_create_organization

#' Creates a new WorkMail resource
#'
#' @description
#' Creates a new WorkMail resource.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_create_resource/](https://www.paws-r-sdk.com/docs/workmail_create_resource/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; The identifier associated with the organization for which the resource is created.
#' @param Name &#91;required&#93; The name of the new resource.
#' @param Type &#91;required&#93; The type of the new resource. The available types are `equipment` and `room`.
#' @param Description Resource description.
#' @param HiddenFromGlobalAddressList If this parameter is enabled, the resource will be hidden from the address book.
#'
#' @keywords internal
#'
#' @rdname workmail_create_resource
workmail_create_resource <- function(OrganizationId, Name, Type, Description = NULL, HiddenFromGlobalAddressList = NULL) {
  op <- new_operation(
    name = "CreateResource",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmail$create_resource_input(OrganizationId = OrganizationId, Name = Name, Type = Type, Description = Description, HiddenFromGlobalAddressList = HiddenFromGlobalAddressList)
  output <- .workmail$create_resource_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$create_resource <- workmail_create_resource

#' Creates a user who can be used in WorkMail by calling the
#' RegisterToWorkMail operation
#'
#' @description
#' Creates a user who can be used in WorkMail by calling the [`register_to_work_mail`][workmail_register_to_work_mail] operation.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_create_user/](https://www.paws-r-sdk.com/docs/workmail_create_user/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; The identifier of the organization for which the user is created.
#' @param Name &#91;required&#93; The name for the new user. WorkMail directory user names have a maximum length of 64. All others have a maximum length of 20.
#' @param DisplayName &#91;required&#93; The display name for the new user.
#' @param Password The password for the new user.
#' @param Role The role of the new user.
#' 
#' You cannot pass *SYSTEM_USER* or *RESOURCE* role in a single request. When a user role is not selected, the default role of *USER* is selected.
#' @param FirstName The first name of the new user.
#' @param LastName The last name of the new user.
#' @param HiddenFromGlobalAddressList If this parameter is enabled, the user will be hidden from the address book.
#' @param IdentityProviderUserId User ID from the IAM Identity Center. If this parameter is empty it will be updated automatically when the user logs in for the first time to the mailbox associated with WorkMail.
#'
#' @keywords internal
#'
#' @rdname workmail_create_user
workmail_create_user <- function(OrganizationId, Name, DisplayName, Password = NULL, Role = NULL, FirstName = NULL, LastName = NULL, HiddenFromGlobalAddressList = NULL, IdentityProviderUserId = NULL) {
  op <- new_operation(
    name = "CreateUser",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmail$create_user_input(OrganizationId = OrganizationId, Name = Name, DisplayName = DisplayName, Password = Password, Role = Role, FirstName = FirstName, LastName = LastName, HiddenFromGlobalAddressList = HiddenFromGlobalAddressList, IdentityProviderUserId = IdentityProviderUserId)
  output <- .workmail$create_user_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$create_user <- workmail_create_user

#' Deletes an access control rule for the specified WorkMail organization
#'
#' @description
#' Deletes an access control rule for the specified WorkMail organization.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_delete_access_control_rule/](https://www.paws-r-sdk.com/docs/workmail_delete_access_control_rule/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; The identifier for the organization.
#' @param Name &#91;required&#93; The name of the access control rule.
#'
#' @keywords internal
#'
#' @rdname workmail_delete_access_control_rule
workmail_delete_access_control_rule <- function(OrganizationId, Name) {
  op <- new_operation(
    name = "DeleteAccessControlRule",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmail$delete_access_control_rule_input(OrganizationId = OrganizationId, Name = Name)
  output <- .workmail$delete_access_control_rule_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$delete_access_control_rule <- workmail_delete_access_control_rule

#' Remove one or more specified aliases from a set of aliases for a given
#' user
#'
#' @description
#' Remove one or more specified aliases from a set of aliases for a given user.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_delete_alias/](https://www.paws-r-sdk.com/docs/workmail_delete_alias/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; The identifier for the organization under which the user exists.
#' @param EntityId &#91;required&#93; The identifier for the member (user or group) from which to have the aliases removed.
#' @param Alias &#91;required&#93; The aliases to be removed from the user's set of aliases. Duplicate entries in the list are collapsed into single entries (the list is transformed into a set).
#'
#' @keywords internal
#'
#' @rdname workmail_delete_alias
workmail_delete_alias <- function(OrganizationId, EntityId, Alias) {
  op <- new_operation(
    name = "DeleteAlias",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmail$delete_alias_input(OrganizationId = OrganizationId, EntityId = EntityId, Alias = Alias)
  output <- .workmail$delete_alias_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$delete_alias <- workmail_delete_alias

#' Deletes the AvailabilityConfiguration for the given WorkMail
#' organization and domain
#'
#' @description
#' Deletes the `AvailabilityConfiguration` for the given WorkMail organization and domain.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_delete_availability_configuration/](https://www.paws-r-sdk.com/docs/workmail_delete_availability_configuration/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; The WorkMail organization for which the `AvailabilityConfiguration` will be deleted.
#' @param DomainName &#91;required&#93; The domain for which the `AvailabilityConfiguration` will be deleted.
#'
#' @keywords internal
#'
#' @rdname workmail_delete_availability_configuration
workmail_delete_availability_configuration <- function(OrganizationId, DomainName) {
  op <- new_operation(
    name = "DeleteAvailabilityConfiguration",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmail$delete_availability_configuration_input(OrganizationId = OrganizationId, DomainName = DomainName)
  output <- .workmail$delete_availability_configuration_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$delete_availability_configuration <- workmail_delete_availability_configuration

#' Deletes the email monitoring configuration for a specified organization
#'
#' @description
#' Deletes the email monitoring configuration for a specified organization.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_delete_email_monitoring_configuration/](https://www.paws-r-sdk.com/docs/workmail_delete_email_monitoring_configuration/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; The ID of the organization from which the email monitoring configuration is deleted.
#'
#' @keywords internal
#'
#' @rdname workmail_delete_email_monitoring_configuration
workmail_delete_email_monitoring_configuration <- function(OrganizationId) {
  op <- new_operation(
    name = "DeleteEmailMonitoringConfiguration",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmail$delete_email_monitoring_configuration_input(OrganizationId = OrganizationId)
  output <- .workmail$delete_email_monitoring_configuration_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$delete_email_monitoring_configuration <- workmail_delete_email_monitoring_configuration

#' Deletes a group from WorkMail
#'
#' @description
#' Deletes a group from WorkMail.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_delete_group/](https://www.paws-r-sdk.com/docs/workmail_delete_group/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; The organization that contains the group.
#' @param GroupId &#91;required&#93; The identifier of the group to be deleted.
#' 
#' The identifier can be the *GroupId*, or *Groupname*. The following identity formats are available:
#' 
#' -   Group ID: 12345678-1234-1234-1234-123456789012 or S-1-1-12-1234567890-123456789-123456789-1234
#' 
#' -   Group name: group
#'
#' @keywords internal
#'
#' @rdname workmail_delete_group
workmail_delete_group <- function(OrganizationId, GroupId) {
  op <- new_operation(
    name = "DeleteGroup",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmail$delete_group_input(OrganizationId = OrganizationId, GroupId = GroupId)
  output <- .workmail$delete_group_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$delete_group <- workmail_delete_group

#' Deletes the IAM Identity Center application from WorkMail
#'
#' @description
#' Deletes the IAM Identity Center application from WorkMail. This action does not affect the authentication settings for any WorkMail organizations.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_delete_identity_center_application/](https://www.paws-r-sdk.com/docs/workmail_delete_identity_center_application/) for full documentation.
#'
#' @param ApplicationArn &#91;required&#93; The Amazon Resource Name (ARN) of the application.
#'
#' @keywords internal
#'
#' @rdname workmail_delete_identity_center_application
workmail_delete_identity_center_application <- function(ApplicationArn) {
  op <- new_operation(
    name = "DeleteIdentityCenterApplication",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmail$delete_identity_center_application_input(ApplicationArn = ApplicationArn)
  output <- .workmail$delete_identity_center_application_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$delete_identity_center_application <- workmail_delete_identity_center_application

#' Disables the integration between IdC and WorkMail
#'
#' @description
#' Disables the integration between IdC and WorkMail. Authentication will continue with the directory as it was before the IdC integration. You might have to reset your directory passwords and reconfigure your desktop and mobile email clients.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_delete_identity_provider_configuration/](https://www.paws-r-sdk.com/docs/workmail_delete_identity_provider_configuration/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; The Organization ID.
#'
#' @keywords internal
#'
#' @rdname workmail_delete_identity_provider_configuration
workmail_delete_identity_provider_configuration <- function(OrganizationId) {
  op <- new_operation(
    name = "DeleteIdentityProviderConfiguration",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmail$delete_identity_provider_configuration_input(OrganizationId = OrganizationId)
  output <- .workmail$delete_identity_provider_configuration_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$delete_identity_provider_configuration <- workmail_delete_identity_provider_configuration

#' Deletes an impersonation role for the given WorkMail organization
#'
#' @description
#' Deletes an impersonation role for the given WorkMail organization.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_delete_impersonation_role/](https://www.paws-r-sdk.com/docs/workmail_delete_impersonation_role/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; The WorkMail organization from which to delete the impersonation role.
#' @param ImpersonationRoleId &#91;required&#93; The ID of the impersonation role to delete.
#'
#' @keywords internal
#'
#' @rdname workmail_delete_impersonation_role
workmail_delete_impersonation_role <- function(OrganizationId, ImpersonationRoleId) {
  op <- new_operation(
    name = "DeleteImpersonationRole",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmail$delete_impersonation_role_input(OrganizationId = OrganizationId, ImpersonationRoleId = ImpersonationRoleId)
  output <- .workmail$delete_impersonation_role_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$delete_impersonation_role <- workmail_delete_impersonation_role

#' Deletes permissions granted to a member (user or group)
#'
#' @description
#' Deletes permissions granted to a member (user or group).
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_delete_mailbox_permissions/](https://www.paws-r-sdk.com/docs/workmail_delete_mailbox_permissions/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; The identifier of the organization under which the member (user or group) exists.
#' @param EntityId &#91;required&#93; The identifier of the entity that owns the mailbox.
#' 
#' The identifier can be *UserId or Group Id*, *Username or Groupname*, or *email*.
#' 
#' -   Entity ID: 12345678-1234-1234-1234-123456789012, r-0123456789a0123456789b0123456789, or S-1-1-12-1234567890-123456789-123456789-1234
#' 
#' -   Email address: entity@@domain.tld
#' 
#' -   Entity name: entity
#' @param GranteeId &#91;required&#93; The identifier of the entity for which to delete granted permissions.
#' 
#' The identifier can be *UserId, ResourceID, or Group Id*, *Username or Groupname*, or *email*.
#' 
#' -   Grantee ID: 12345678-1234-1234-1234-123456789012,r-0123456789a0123456789b0123456789, or S-1-1-12-1234567890-123456789-123456789-1234
#' 
#' -   Email address: grantee@@domain.tld
#' 
#' -   Grantee name: grantee
#'
#' @keywords internal
#'
#' @rdname workmail_delete_mailbox_permissions
workmail_delete_mailbox_permissions <- function(OrganizationId, EntityId, GranteeId) {
  op <- new_operation(
    name = "DeleteMailboxPermissions",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmail$delete_mailbox_permissions_input(OrganizationId = OrganizationId, EntityId = EntityId, GranteeId = GranteeId)
  output <- .workmail$delete_mailbox_permissions_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$delete_mailbox_permissions <- workmail_delete_mailbox_permissions

#' Deletes the mobile device access override for the given WorkMail
#' organization, user, and device
#'
#' @description
#' Deletes the mobile device access override for the given WorkMail organization, user, and device.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_delete_mobile_device_access_override/](https://www.paws-r-sdk.com/docs/workmail_delete_mobile_device_access_override/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; The WorkMail organization for which the access override will be deleted.
#' @param UserId &#91;required&#93; The WorkMail user for which you want to delete the override. Accepts the following types of user identities:
#' 
#' -   User ID: `12345678-1234-1234-1234-123456789012` or `S-1-1-12-1234567890-123456789-123456789-1234`
#' 
#' -   Email address: `user@@domain.tld`
#' 
#' -   User name: `user`
#' @param DeviceId &#91;required&#93; The mobile device for which you delete the override. `DeviceId` is case insensitive.
#'
#' @keywords internal
#'
#' @rdname workmail_delete_mobile_device_access_override
workmail_delete_mobile_device_access_override <- function(OrganizationId, UserId, DeviceId) {
  op <- new_operation(
    name = "DeleteMobileDeviceAccessOverride",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmail$delete_mobile_device_access_override_input(OrganizationId = OrganizationId, UserId = UserId, DeviceId = DeviceId)
  output <- .workmail$delete_mobile_device_access_override_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$delete_mobile_device_access_override <- workmail_delete_mobile_device_access_override

#' Deletes a mobile device access rule for the specified WorkMail
#' organization
#'
#' @description
#' Deletes a mobile device access rule for the specified WorkMail organization.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_delete_mobile_device_access_rule/](https://www.paws-r-sdk.com/docs/workmail_delete_mobile_device_access_rule/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; The WorkMail organization under which the rule will be deleted.
#' @param MobileDeviceAccessRuleId &#91;required&#93; The identifier of the rule to be deleted.
#'
#' @keywords internal
#'
#' @rdname workmail_delete_mobile_device_access_rule
workmail_delete_mobile_device_access_rule <- function(OrganizationId, MobileDeviceAccessRuleId) {
  op <- new_operation(
    name = "DeleteMobileDeviceAccessRule",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmail$delete_mobile_device_access_rule_input(OrganizationId = OrganizationId, MobileDeviceAccessRuleId = MobileDeviceAccessRuleId)
  output <- .workmail$delete_mobile_device_access_rule_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$delete_mobile_device_access_rule <- workmail_delete_mobile_device_access_rule

#' Deletes an WorkMail organization and all underlying AWS resources
#' managed by WorkMail as part of the organization
#'
#' @description
#' Deletes an WorkMail organization and all underlying AWS resources managed by WorkMail as part of the organization. You can choose whether to delete the associated directory. For more information, see [Removing an organization](https://docs.aws.amazon.com/workmail/latest/adminguide/delete_organization.html) in the *WorkMail Administrator Guide*.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_delete_organization/](https://www.paws-r-sdk.com/docs/workmail_delete_organization/) for full documentation.
#'
#' @param ClientToken The idempotency token associated with the request.
#' @param OrganizationId &#91;required&#93; The organization ID.
#' @param DeleteDirectory &#91;required&#93; If true, deletes the AWS Directory Service directory associated with the organization.
#' @param ForceDelete Deletes a WorkMail organization even if the organization has enabled users.
#' @param DeleteIdentityCenterApplication Deletes IAM Identity Center application for WorkMail. This action does not affect authentication settings for any organization.
#'
#' @keywords internal
#'
#' @rdname workmail_delete_organization
workmail_delete_organization <- function(ClientToken = NULL, OrganizationId, DeleteDirectory, ForceDelete = NULL, DeleteIdentityCenterApplication = NULL) {
  op <- new_operation(
    name = "DeleteOrganization",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmail$delete_organization_input(ClientToken = ClientToken, OrganizationId = OrganizationId, DeleteDirectory = DeleteDirectory, ForceDelete = ForceDelete, DeleteIdentityCenterApplication = DeleteIdentityCenterApplication)
  output <- .workmail$delete_organization_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$delete_organization <- workmail_delete_organization

#' Deletes the Personal Access Token from the provided WorkMail
#' Organization
#'
#' @description
#' Deletes the Personal Access Token from the provided WorkMail Organization.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_delete_personal_access_token/](https://www.paws-r-sdk.com/docs/workmail_delete_personal_access_token/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; The Organization ID.
#' @param PersonalAccessTokenId &#91;required&#93; The Personal Access Token ID.
#'
#' @keywords internal
#'
#' @rdname workmail_delete_personal_access_token
workmail_delete_personal_access_token <- function(OrganizationId, PersonalAccessTokenId) {
  op <- new_operation(
    name = "DeletePersonalAccessToken",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmail$delete_personal_access_token_input(OrganizationId = OrganizationId, PersonalAccessTokenId = PersonalAccessTokenId)
  output <- .workmail$delete_personal_access_token_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$delete_personal_access_token <- workmail_delete_personal_access_token

#' Deletes the specified resource
#'
#' @description
#' Deletes the specified resource.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_delete_resource/](https://www.paws-r-sdk.com/docs/workmail_delete_resource/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; The identifier associated with the organization from which the resource is deleted.
#' @param ResourceId &#91;required&#93; The identifier of the resource to be deleted.
#' 
#' The identifier can accept *ResourceId*, or *Resourcename*. The following identity formats are available:
#' 
#' -   Resource ID: r-0123456789a0123456789b0123456789
#' 
#' -   Resource name: resource
#'
#' @keywords internal
#'
#' @rdname workmail_delete_resource
workmail_delete_resource <- function(OrganizationId, ResourceId) {
  op <- new_operation(
    name = "DeleteResource",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmail$delete_resource_input(OrganizationId = OrganizationId, ResourceId = ResourceId)
  output <- .workmail$delete_resource_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$delete_resource <- workmail_delete_resource

#' Deletes the specified retention policy from the specified organization
#'
#' @description
#' Deletes the specified retention policy from the specified organization.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_delete_retention_policy/](https://www.paws-r-sdk.com/docs/workmail_delete_retention_policy/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; The organization ID.
#' @param Id &#91;required&#93; The retention policy ID.
#'
#' @keywords internal
#'
#' @rdname workmail_delete_retention_policy
workmail_delete_retention_policy <- function(OrganizationId, Id) {
  op <- new_operation(
    name = "DeleteRetentionPolicy",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmail$delete_retention_policy_input(OrganizationId = OrganizationId, Id = Id)
  output <- .workmail$delete_retention_policy_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$delete_retention_policy <- workmail_delete_retention_policy

#' Deletes a user from WorkMail and all subsequent systems
#'
#' @description
#' Deletes a user from WorkMail and all subsequent systems. Before you can delete a user, the user state must be `DISABLED`. Use the [`describe_user`][workmail_describe_user] action to confirm the user state.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_delete_user/](https://www.paws-r-sdk.com/docs/workmail_delete_user/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; The organization that contains the user to be deleted.
#' @param UserId &#91;required&#93; The identifier of the user to be deleted.
#' 
#' The identifier can be the *UserId* or *Username*. The following identity formats are available:
#' 
#' -   User ID: 12345678-1234-1234-1234-123456789012 or S-1-1-12-1234567890-123456789-123456789-1234
#' 
#' -   User name: user
#'
#' @keywords internal
#'
#' @rdname workmail_delete_user
workmail_delete_user <- function(OrganizationId, UserId) {
  op <- new_operation(
    name = "DeleteUser",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmail$delete_user_input(OrganizationId = OrganizationId, UserId = UserId)
  output <- .workmail$delete_user_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$delete_user <- workmail_delete_user

#' Mark a user, group, or resource as no longer used in WorkMail
#'
#' @description
#' Mark a user, group, or resource as no longer used in WorkMail. This action disassociates the mailbox and schedules it for clean-up. WorkMail keeps mailboxes for 30 days before they are permanently removed. The functionality in the console is *Disable*.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_deregister_from_work_mail/](https://www.paws-r-sdk.com/docs/workmail_deregister_from_work_mail/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; The identifier for the organization under which the WorkMail entity exists.
#' @param EntityId &#91;required&#93; The identifier for the member to be updated.
#' 
#' The identifier can be *UserId, ResourceId, or Group Id*, *Username, Resourcename, or Groupname*, or *email*.
#' 
#' -   Entity ID: 12345678-1234-1234-1234-123456789012, r-0123456789a0123456789b0123456789, or S-1-1-12-1234567890-123456789-123456789-1234
#' 
#' -   Email address: entity@@domain.tld
#' 
#' -   Entity name: entity
#'
#' @keywords internal
#'
#' @rdname workmail_deregister_from_work_mail
workmail_deregister_from_work_mail <- function(OrganizationId, EntityId) {
  op <- new_operation(
    name = "DeregisterFromWorkMail",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmail$deregister_from_work_mail_input(OrganizationId = OrganizationId, EntityId = EntityId)
  output <- .workmail$deregister_from_work_mail_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$deregister_from_work_mail <- workmail_deregister_from_work_mail

#' Removes a domain from WorkMail, stops email routing to WorkMail, and
#' removes the authorization allowing WorkMail use
#'
#' @description
#' Removes a domain from WorkMail, stops email routing to WorkMail, and removes the authorization allowing WorkMail use. SES keeps the domain because other applications may use it. You must first remove any email address used by WorkMail entities before you remove the domain.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_deregister_mail_domain/](https://www.paws-r-sdk.com/docs/workmail_deregister_mail_domain/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; The WorkMail organization for which the domain will be deregistered.
#' @param DomainName &#91;required&#93; The domain to deregister in WorkMail and SES.
#'
#' @keywords internal
#'
#' @rdname workmail_deregister_mail_domain
workmail_deregister_mail_domain <- function(OrganizationId, DomainName) {
  op <- new_operation(
    name = "DeregisterMailDomain",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmail$deregister_mail_domain_input(OrganizationId = OrganizationId, DomainName = DomainName)
  output <- .workmail$deregister_mail_domain_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$deregister_mail_domain <- workmail_deregister_mail_domain

#' Describes the current email monitoring configuration for a specified
#' organization
#'
#' @description
#' Describes the current email monitoring configuration for a specified organization.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_describe_email_monitoring_configuration/](https://www.paws-r-sdk.com/docs/workmail_describe_email_monitoring_configuration/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; The ID of the organization for which the email monitoring configuration is described.
#'
#' @keywords internal
#'
#' @rdname workmail_describe_email_monitoring_configuration
workmail_describe_email_monitoring_configuration <- function(OrganizationId) {
  op <- new_operation(
    name = "DescribeEmailMonitoringConfiguration",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmail$describe_email_monitoring_configuration_input(OrganizationId = OrganizationId)
  output <- .workmail$describe_email_monitoring_configuration_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$describe_email_monitoring_configuration <- workmail_describe_email_monitoring_configuration

#' Returns basic details about an entity in WorkMail
#'
#' @description
#' Returns basic details about an entity in WorkMail.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_describe_entity/](https://www.paws-r-sdk.com/docs/workmail_describe_entity/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; The identifier for the organization under which the entity exists.
#' @param Email &#91;required&#93; The email under which the entity exists.
#'
#' @keywords internal
#'
#' @rdname workmail_describe_entity
workmail_describe_entity <- function(OrganizationId, Email) {
  op <- new_operation(
    name = "DescribeEntity",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmail$describe_entity_input(OrganizationId = OrganizationId, Email = Email)
  output <- .workmail$describe_entity_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$describe_entity <- workmail_describe_entity

#' Returns the data available for the group
#'
#' @description
#' Returns the data available for the group.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_describe_group/](https://www.paws-r-sdk.com/docs/workmail_describe_group/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; The identifier for the organization under which the group exists.
#' @param GroupId &#91;required&#93; The identifier for the group to be described.
#' 
#' The identifier can accept *GroupId*, *Groupname*, or *email*. The following identity formats are available:
#' 
#' -   Group ID: 12345678-1234-1234-1234-123456789012 or S-1-1-12-1234567890-123456789-123456789-1234
#' 
#' -   Email address: group@@domain.tld
#' 
#' -   Group name: group
#'
#' @keywords internal
#'
#' @rdname workmail_describe_group
workmail_describe_group <- function(OrganizationId, GroupId) {
  op <- new_operation(
    name = "DescribeGroup",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmail$describe_group_input(OrganizationId = OrganizationId, GroupId = GroupId)
  output <- .workmail$describe_group_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$describe_group <- workmail_describe_group

#' Returns detailed information on the current IdC setup for the WorkMail
#' organization
#'
#' @description
#' Returns detailed information on the current IdC setup for the WorkMail organization.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_describe_identity_provider_configuration/](https://www.paws-r-sdk.com/docs/workmail_describe_identity_provider_configuration/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; The Organization ID.
#'
#' @keywords internal
#'
#' @rdname workmail_describe_identity_provider_configuration
workmail_describe_identity_provider_configuration <- function(OrganizationId) {
  op <- new_operation(
    name = "DescribeIdentityProviderConfiguration",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmail$describe_identity_provider_configuration_input(OrganizationId = OrganizationId)
  output <- .workmail$describe_identity_provider_configuration_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$describe_identity_provider_configuration <- workmail_describe_identity_provider_configuration

#' Lists the settings in a DMARC policy for a specified organization
#'
#' @description
#' Lists the settings in a DMARC policy for a specified organization.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_describe_inbound_dmarc_settings/](https://www.paws-r-sdk.com/docs/workmail_describe_inbound_dmarc_settings/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; Lists the ID of the given organization.
#'
#' @keywords internal
#'
#' @rdname workmail_describe_inbound_dmarc_settings
workmail_describe_inbound_dmarc_settings <- function(OrganizationId) {
  op <- new_operation(
    name = "DescribeInboundDmarcSettings",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmail$describe_inbound_dmarc_settings_input(OrganizationId = OrganizationId)
  output <- .workmail$describe_inbound_dmarc_settings_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$describe_inbound_dmarc_settings <- workmail_describe_inbound_dmarc_settings

#' Describes the current status of a mailbox export job
#'
#' @description
#' Describes the current status of a mailbox export job.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_describe_mailbox_export_job/](https://www.paws-r-sdk.com/docs/workmail_describe_mailbox_export_job/) for full documentation.
#'
#' @param JobId &#91;required&#93; The mailbox export job ID.
#' @param OrganizationId &#91;required&#93; The organization ID.
#'
#' @keywords internal
#'
#' @rdname workmail_describe_mailbox_export_job
workmail_describe_mailbox_export_job <- function(JobId, OrganizationId) {
  op <- new_operation(
    name = "DescribeMailboxExportJob",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmail$describe_mailbox_export_job_input(JobId = JobId, OrganizationId = OrganizationId)
  output <- .workmail$describe_mailbox_export_job_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$describe_mailbox_export_job <- workmail_describe_mailbox_export_job

#' Provides more information regarding a given organization based on its
#' identifier
#'
#' @description
#' Provides more information regarding a given organization based on its identifier.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_describe_organization/](https://www.paws-r-sdk.com/docs/workmail_describe_organization/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; The identifier for the organization to be described.
#'
#' @keywords internal
#'
#' @rdname workmail_describe_organization
workmail_describe_organization <- function(OrganizationId) {
  op <- new_operation(
    name = "DescribeOrganization",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmail$describe_organization_input(OrganizationId = OrganizationId)
  output <- .workmail$describe_organization_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$describe_organization <- workmail_describe_organization

#' Returns the data available for the resource
#'
#' @description
#' Returns the data available for the resource.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_describe_resource/](https://www.paws-r-sdk.com/docs/workmail_describe_resource/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; The identifier associated with the organization for which the resource is described.
#' @param ResourceId &#91;required&#93; The identifier of the resource to be described.
#' 
#' The identifier can accept *ResourceId*, *Resourcename*, or *email*. The following identity formats are available:
#' 
#' -   Resource ID: r-0123456789a0123456789b0123456789
#' 
#' -   Email address: resource@@domain.tld
#' 
#' -   Resource name: resource
#'
#' @keywords internal
#'
#' @rdname workmail_describe_resource
workmail_describe_resource <- function(OrganizationId, ResourceId) {
  op <- new_operation(
    name = "DescribeResource",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmail$describe_resource_input(OrganizationId = OrganizationId, ResourceId = ResourceId)
  output <- .workmail$describe_resource_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$describe_resource <- workmail_describe_resource

#' Provides information regarding the user
#'
#' @description
#' Provides information regarding the user.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_describe_user/](https://www.paws-r-sdk.com/docs/workmail_describe_user/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; The identifier for the organization under which the user exists.
#' @param UserId &#91;required&#93; The identifier for the user to be described.
#' 
#' The identifier can be the *UserId*, *Username*, or *email*. The following identity formats are available:
#' 
#' -   User ID: 12345678-1234-1234-1234-123456789012 or S-1-1-12-1234567890-123456789-123456789-1234
#' 
#' -   Email address: user@@domain.tld
#' 
#' -   User name: user
#'
#' @keywords internal
#'
#' @rdname workmail_describe_user
workmail_describe_user <- function(OrganizationId, UserId) {
  op <- new_operation(
    name = "DescribeUser",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmail$describe_user_input(OrganizationId = OrganizationId, UserId = UserId)
  output <- .workmail$describe_user_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$describe_user <- workmail_describe_user

#' Removes a member from the resource's set of delegates
#'
#' @description
#' Removes a member from the resource's set of delegates.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_disassociate_delegate_from_resource/](https://www.paws-r-sdk.com/docs/workmail_disassociate_delegate_from_resource/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; The identifier for the organization under which the resource exists.
#' @param ResourceId &#91;required&#93; The identifier of the resource from which delegates' set members are removed.
#' 
#' The identifier can accept *ResourceId*, *Resourcename*, or *email*. The following identity formats are available:
#' 
#' -   Resource ID: r-0123456789a0123456789b0123456789
#' 
#' -   Email address: resource@@domain.tld
#' 
#' -   Resource name: resource
#' @param EntityId &#91;required&#93; The identifier for the member (user, group) to be removed from the resource's delegates.
#' 
#' The entity ID can accept *UserId or GroupID*, *Username or Groupname*, or *email*.
#' 
#' -   Entity: 12345678-1234-1234-1234-123456789012 or S-1-1-12-1234567890-123456789-123456789-1234
#' 
#' -   Email address: entity@@domain.tld
#' 
#' -   Entity: entity
#'
#' @keywords internal
#'
#' @rdname workmail_disassociate_delegate_from_resource
workmail_disassociate_delegate_from_resource <- function(OrganizationId, ResourceId, EntityId) {
  op <- new_operation(
    name = "DisassociateDelegateFromResource",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmail$disassociate_delegate_from_resource_input(OrganizationId = OrganizationId, ResourceId = ResourceId, EntityId = EntityId)
  output <- .workmail$disassociate_delegate_from_resource_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$disassociate_delegate_from_resource <- workmail_disassociate_delegate_from_resource

#' Removes a member from a group
#'
#' @description
#' Removes a member from a group.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_disassociate_member_from_group/](https://www.paws-r-sdk.com/docs/workmail_disassociate_member_from_group/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; The identifier for the organization under which the group exists.
#' @param GroupId &#91;required&#93; The identifier for the group from which members are removed.
#' 
#' The identifier can accept *GroupId*, *Groupname*, or *email*. The following identity formats are available:
#' 
#' -   Group ID: 12345678-1234-1234-1234-123456789012 or S-1-1-12-1234567890-123456789-123456789-1234
#' 
#' -   Email address: group@@domain.tld
#' 
#' -   Group name: group
#' @param MemberId &#91;required&#93; The identifier for the member to be removed from the group.
#' 
#' The member ID can accept *UserID or GroupId*, *Username or Groupname*, or *email*.
#' 
#' -   Member ID: 12345678-1234-1234-1234-123456789012 or S-1-1-12-1234567890-123456789-123456789-1234
#' 
#' -   Email address: member@@domain.tld
#' 
#' -   Member name: member
#'
#' @keywords internal
#'
#' @rdname workmail_disassociate_member_from_group
workmail_disassociate_member_from_group <- function(OrganizationId, GroupId, MemberId) {
  op <- new_operation(
    name = "DisassociateMemberFromGroup",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmail$disassociate_member_from_group_input(OrganizationId = OrganizationId, GroupId = GroupId, MemberId = MemberId)
  output <- .workmail$disassociate_member_from_group_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$disassociate_member_from_group <- workmail_disassociate_member_from_group

#' Gets the effects of an organization's access control rules as they apply
#' to a specified IPv4 address, access protocol action, and user ID or
#' impersonation role ID
#'
#' @description
#' Gets the effects of an organization's access control rules as they apply to a specified IPv4 address, access protocol action, and user ID or impersonation role ID. You must provide either the user ID or impersonation role ID. Impersonation role ID can only be used with Action EWS.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_get_access_control_effect/](https://www.paws-r-sdk.com/docs/workmail_get_access_control_effect/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; The identifier for the organization.
#' @param IpAddress &#91;required&#93; The IPv4 address.
#' @param Action &#91;required&#93; The access protocol action. Valid values include `ActiveSync`, `AutoDiscover`, `EWS`, `IMAP`, `SMTP`, `WindowsOutlook`, and `WebMail`.
#' @param UserId The user ID.
#' @param ImpersonationRoleId The impersonation role ID.
#'
#' @keywords internal
#'
#' @rdname workmail_get_access_control_effect
workmail_get_access_control_effect <- function(OrganizationId, IpAddress, Action, UserId = NULL, ImpersonationRoleId = NULL) {
  op <- new_operation(
    name = "GetAccessControlEffect",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmail$get_access_control_effect_input(OrganizationId = OrganizationId, IpAddress = IpAddress, Action = Action, UserId = UserId, ImpersonationRoleId = ImpersonationRoleId)
  output <- .workmail$get_access_control_effect_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$get_access_control_effect <- workmail_get_access_control_effect

#' Gets the default retention policy details for the specified organization
#'
#' @description
#' Gets the default retention policy details for the specified organization.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_get_default_retention_policy/](https://www.paws-r-sdk.com/docs/workmail_get_default_retention_policy/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; The organization ID.
#'
#' @keywords internal
#'
#' @rdname workmail_get_default_retention_policy
workmail_get_default_retention_policy <- function(OrganizationId) {
  op <- new_operation(
    name = "GetDefaultRetentionPolicy",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmail$get_default_retention_policy_input(OrganizationId = OrganizationId)
  output <- .workmail$get_default_retention_policy_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$get_default_retention_policy <- workmail_get_default_retention_policy

#' Gets the impersonation role details for the given WorkMail organization
#'
#' @description
#' Gets the impersonation role details for the given WorkMail organization.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_get_impersonation_role/](https://www.paws-r-sdk.com/docs/workmail_get_impersonation_role/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; The WorkMail organization from which to retrieve the impersonation role.
#' @param ImpersonationRoleId &#91;required&#93; The impersonation role ID to retrieve.
#'
#' @keywords internal
#'
#' @rdname workmail_get_impersonation_role
workmail_get_impersonation_role <- function(OrganizationId, ImpersonationRoleId) {
  op <- new_operation(
    name = "GetImpersonationRole",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmail$get_impersonation_role_input(OrganizationId = OrganizationId, ImpersonationRoleId = ImpersonationRoleId)
  output <- .workmail$get_impersonation_role_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$get_impersonation_role <- workmail_get_impersonation_role

#' Tests whether the given impersonation role can impersonate a target user
#'
#' @description
#' Tests whether the given impersonation role can impersonate a target user.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_get_impersonation_role_effect/](https://www.paws-r-sdk.com/docs/workmail_get_impersonation_role_effect/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; The WorkMail organization where the impersonation role is defined.
#' @param ImpersonationRoleId &#91;required&#93; The impersonation role ID to test.
#' @param TargetUser &#91;required&#93; The WorkMail organization user chosen to test the impersonation role. The following identity formats are available:
#' 
#' -   User ID: `12345678-1234-1234-1234-123456789012` or `S-1-1-12-1234567890-123456789-123456789-1234`
#' 
#' -   Email address: `user@@domain.tld`
#' 
#' -   User name: `user`
#'
#' @keywords internal
#'
#' @rdname workmail_get_impersonation_role_effect
workmail_get_impersonation_role_effect <- function(OrganizationId, ImpersonationRoleId, TargetUser) {
  op <- new_operation(
    name = "GetImpersonationRoleEffect",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmail$get_impersonation_role_effect_input(OrganizationId = OrganizationId, ImpersonationRoleId = ImpersonationRoleId, TargetUser = TargetUser)
  output <- .workmail$get_impersonation_role_effect_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$get_impersonation_role_effect <- workmail_get_impersonation_role_effect

#' Gets details for a mail domain, including domain records required to
#' configure your domain with recommended security
#'
#' @description
#' Gets details for a mail domain, including domain records required to configure your domain with recommended security.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_get_mail_domain/](https://www.paws-r-sdk.com/docs/workmail_get_mail_domain/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; The WorkMail organization for which the domain is retrieved.
#' @param DomainName &#91;required&#93; The domain from which you want to retrieve details.
#'
#' @keywords internal
#'
#' @rdname workmail_get_mail_domain
workmail_get_mail_domain <- function(OrganizationId, DomainName) {
  op <- new_operation(
    name = "GetMailDomain",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmail$get_mail_domain_input(OrganizationId = OrganizationId, DomainName = DomainName)
  output <- .workmail$get_mail_domain_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$get_mail_domain <- workmail_get_mail_domain

#' Requests a user's mailbox details for a specified organization and user
#'
#' @description
#' Requests a user's mailbox details for a specified organization and user.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_get_mailbox_details/](https://www.paws-r-sdk.com/docs/workmail_get_mailbox_details/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; The identifier for the organization that contains the user whose mailbox details are being requested.
#' @param UserId &#91;required&#93; The identifier for the user whose mailbox details are being requested.
#' 
#' The identifier can be the *UserId*, *Username*, or *email*. The following identity formats are available:
#' 
#' -   User ID: 12345678-1234-1234-1234-123456789012 or S-1-1-12-1234567890-123456789-123456789-1234
#' 
#' -   Email address: user@@domain.tld
#' 
#' -   User name: user
#'
#' @keywords internal
#'
#' @rdname workmail_get_mailbox_details
workmail_get_mailbox_details <- function(OrganizationId, UserId) {
  op <- new_operation(
    name = "GetMailboxDetails",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmail$get_mailbox_details_input(OrganizationId = OrganizationId, UserId = UserId)
  output <- .workmail$get_mailbox_details_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$get_mailbox_details <- workmail_get_mailbox_details

#' Simulates the effect of the mobile device access rules for the given
#' attributes of a sample access event
#'
#' @description
#' Simulates the effect of the mobile device access rules for the given attributes of a sample access event. Use this method to test the effects of the current set of mobile device access rules for the WorkMail organization for a particular user's attributes.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_get_mobile_device_access_effect/](https://www.paws-r-sdk.com/docs/workmail_get_mobile_device_access_effect/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; The WorkMail organization to simulate the access effect for.
#' @param DeviceType Device type the simulated user will report.
#' @param DeviceModel Device model the simulated user will report.
#' @param DeviceOperatingSystem Device operating system the simulated user will report.
#' @param DeviceUserAgent Device user agent the simulated user will report.
#'
#' @keywords internal
#'
#' @rdname workmail_get_mobile_device_access_effect
workmail_get_mobile_device_access_effect <- function(OrganizationId, DeviceType = NULL, DeviceModel = NULL, DeviceOperatingSystem = NULL, DeviceUserAgent = NULL) {
  op <- new_operation(
    name = "GetMobileDeviceAccessEffect",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmail$get_mobile_device_access_effect_input(OrganizationId = OrganizationId, DeviceType = DeviceType, DeviceModel = DeviceModel, DeviceOperatingSystem = DeviceOperatingSystem, DeviceUserAgent = DeviceUserAgent)
  output <- .workmail$get_mobile_device_access_effect_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$get_mobile_device_access_effect <- workmail_get_mobile_device_access_effect

#' Gets the mobile device access override for the given WorkMail
#' organization, user, and device
#'
#' @description
#' Gets the mobile device access override for the given WorkMail organization, user, and device.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_get_mobile_device_access_override/](https://www.paws-r-sdk.com/docs/workmail_get_mobile_device_access_override/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; The WorkMail organization to which you want to apply the override.
#' @param UserId &#91;required&#93; Identifies the WorkMail user for the override. Accepts the following types of user identities:
#' 
#' -   User ID: `12345678-1234-1234-1234-123456789012` or `S-1-1-12-1234567890-123456789-123456789-1234`
#' 
#' -   Email address: `user@@domain.tld`
#' 
#' -   User name: `user`
#' @param DeviceId &#91;required&#93; The mobile device to which the override applies. `DeviceId` is case insensitive.
#'
#' @keywords internal
#'
#' @rdname workmail_get_mobile_device_access_override
workmail_get_mobile_device_access_override <- function(OrganizationId, UserId, DeviceId) {
  op <- new_operation(
    name = "GetMobileDeviceAccessOverride",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmail$get_mobile_device_access_override_input(OrganizationId = OrganizationId, UserId = UserId, DeviceId = DeviceId)
  output <- .workmail$get_mobile_device_access_override_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$get_mobile_device_access_override <- workmail_get_mobile_device_access_override

#' Requests details of a specific Personal Access Token within the WorkMail
#' organization
#'
#' @description
#' Requests details of a specific Personal Access Token within the WorkMail organization.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_get_personal_access_token_metadata/](https://www.paws-r-sdk.com/docs/workmail_get_personal_access_token_metadata/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; The Organization ID.
#' @param PersonalAccessTokenId &#91;required&#93; The Personal Access Token ID.
#'
#' @keywords internal
#'
#' @rdname workmail_get_personal_access_token_metadata
workmail_get_personal_access_token_metadata <- function(OrganizationId, PersonalAccessTokenId) {
  op <- new_operation(
    name = "GetPersonalAccessTokenMetadata",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmail$get_personal_access_token_metadata_input(OrganizationId = OrganizationId, PersonalAccessTokenId = PersonalAccessTokenId)
  output <- .workmail$get_personal_access_token_metadata_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$get_personal_access_token_metadata <- workmail_get_personal_access_token_metadata

#' Lists the access control rules for the specified organization
#'
#' @description
#' Lists the access control rules for the specified organization.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_list_access_control_rules/](https://www.paws-r-sdk.com/docs/workmail_list_access_control_rules/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; The identifier for the organization.
#'
#' @keywords internal
#'
#' @rdname workmail_list_access_control_rules
workmail_list_access_control_rules <- function(OrganizationId) {
  op <- new_operation(
    name = "ListAccessControlRules",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmail$list_access_control_rules_input(OrganizationId = OrganizationId)
  output <- .workmail$list_access_control_rules_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$list_access_control_rules <- workmail_list_access_control_rules

#' Creates a paginated call to list the aliases associated with a given
#' entity
#'
#' @description
#' Creates a paginated call to list the aliases associated with a given entity.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_list_aliases/](https://www.paws-r-sdk.com/docs/workmail_list_aliases/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; The identifier for the organization under which the entity exists.
#' @param EntityId &#91;required&#93; The identifier for the entity for which to list the aliases.
#' @param NextToken The token to use to retrieve the next page of results. The first call does not contain any tokens.
#' @param MaxResults The maximum number of results to return in a single call.
#'
#' @keywords internal
#'
#' @rdname workmail_list_aliases
workmail_list_aliases <- function(OrganizationId, EntityId, NextToken = NULL, MaxResults = NULL) {
  op <- new_operation(
    name = "ListAliases",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(result_key = "Aliases", output_token = "NextToken", input_token = "NextToken", limit_key = "MaxResults"),
    stream_api = FALSE
  )
  input <- .workmail$list_aliases_input(OrganizationId = OrganizationId, EntityId = EntityId, NextToken = NextToken, MaxResults = MaxResults)
  output <- .workmail$list_aliases_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$list_aliases <- workmail_list_aliases

#' List all the AvailabilityConfiguration's for the given WorkMail
#' organization
#'
#' @description
#' List all the `AvailabilityConfiguration`'s for the given WorkMail organization.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_list_availability_configurations/](https://www.paws-r-sdk.com/docs/workmail_list_availability_configurations/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; The WorkMail organization for which the `AvailabilityConfiguration`'s will be listed.
#' @param MaxResults The maximum number of results to return in a single call.
#' @param NextToken The token to use to retrieve the next page of results. The first call does not require a token.
#'
#' @keywords internal
#'
#' @rdname workmail_list_availability_configurations
workmail_list_availability_configurations <- function(OrganizationId, MaxResults = NULL, NextToken = NULL) {
  op <- new_operation(
    name = "ListAvailabilityConfigurations",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(input_token = "NextToken", output_token = "NextToken", limit_key = "MaxResults", result_key = "AvailabilityConfigurations"),
    stream_api = FALSE
  )
  input <- .workmail$list_availability_configurations_input(OrganizationId = OrganizationId, MaxResults = MaxResults, NextToken = NextToken)
  output <- .workmail$list_availability_configurations_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$list_availability_configurations <- workmail_list_availability_configurations

#' Returns an overview of the members of a group
#'
#' @description
#' Returns an overview of the members of a group. Users and groups can be members of a group.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_list_group_members/](https://www.paws-r-sdk.com/docs/workmail_list_group_members/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; The identifier for the organization under which the group exists.
#' @param GroupId &#91;required&#93; The identifier for the group to which the members (users or groups) are associated.
#' 
#' The identifier can accept *GroupId*, *Groupname*, or *email*. The following identity formats are available:
#' 
#' -   Group ID: 12345678-1234-1234-1234-123456789012 or S-1-1-12-1234567890-123456789-123456789-1234
#' 
#' -   Email address: group@@domain.tld
#' 
#' -   Group name: group
#' @param NextToken The token to use to retrieve the next page of results. The first call does not contain any tokens.
#' @param MaxResults The maximum number of results to return in a single call.
#'
#' @keywords internal
#'
#' @rdname workmail_list_group_members
workmail_list_group_members <- function(OrganizationId, GroupId, NextToken = NULL, MaxResults = NULL) {
  op <- new_operation(
    name = "ListGroupMembers",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(result_key = "Members", output_token = "NextToken", input_token = "NextToken", limit_key = "MaxResults"),
    stream_api = FALSE
  )
  input <- .workmail$list_group_members_input(OrganizationId = OrganizationId, GroupId = GroupId, NextToken = NextToken, MaxResults = MaxResults)
  output <- .workmail$list_group_members_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$list_group_members <- workmail_list_group_members

#' Returns summaries of the organization's groups
#'
#' @description
#' Returns summaries of the organization's groups.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_list_groups/](https://www.paws-r-sdk.com/docs/workmail_list_groups/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; The identifier for the organization under which the groups exist.
#' @param NextToken The token to use to retrieve the next page of results. The first call does not contain any tokens.
#' @param MaxResults The maximum number of results to return in a single call.
#' @param Filters Limit the search results based on the filter criteria. Only one filter per request is supported.
#'
#' @keywords internal
#'
#' @rdname workmail_list_groups
workmail_list_groups <- function(OrganizationId, NextToken = NULL, MaxResults = NULL, Filters = NULL) {
  op <- new_operation(
    name = "ListGroups",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(result_key = "Groups", output_token = "NextToken", input_token = "NextToken", limit_key = "MaxResults"),
    stream_api = FALSE
  )
  input <- .workmail$list_groups_input(OrganizationId = OrganizationId, NextToken = NextToken, MaxResults = MaxResults, Filters = Filters)
  output <- .workmail$list_groups_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$list_groups <- workmail_list_groups

#' Returns all the groups to which an entity belongs
#'
#' @description
#' Returns all the groups to which an entity belongs.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_list_groups_for_entity/](https://www.paws-r-sdk.com/docs/workmail_list_groups_for_entity/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; The identifier for the organization under which the entity exists.
#' @param EntityId &#91;required&#93; The identifier for the entity.
#' 
#' The entity ID can accept *UserId or GroupID*, *Username or Groupname*, or *email*.
#' 
#' -   Entity ID: 12345678-1234-1234-1234-123456789012 or S-1-1-12-1234567890-123456789-123456789-1234
#' 
#' -   Email address: entity@@domain.tld
#' 
#' -   Entity name: entity
#' @param Filters Limit the search results based on the filter criteria.
#' @param NextToken The token to use to retrieve the next page of results. The first call does not contain any tokens.
#' @param MaxResults The maximum number of results to return in a single call.
#'
#' @keywords internal
#'
#' @rdname workmail_list_groups_for_entity
workmail_list_groups_for_entity <- function(OrganizationId, EntityId, Filters = NULL, NextToken = NULL, MaxResults = NULL) {
  op <- new_operation(
    name = "ListGroupsForEntity",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(input_token = "NextToken", output_token = "NextToken", limit_key = "MaxResults"),
    stream_api = FALSE
  )
  input <- .workmail$list_groups_for_entity_input(OrganizationId = OrganizationId, EntityId = EntityId, Filters = Filters, NextToken = NextToken, MaxResults = MaxResults)
  output <- .workmail$list_groups_for_entity_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$list_groups_for_entity <- workmail_list_groups_for_entity

#' Lists all the impersonation roles for the given WorkMail organization
#'
#' @description
#' Lists all the impersonation roles for the given WorkMail organization.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_list_impersonation_roles/](https://www.paws-r-sdk.com/docs/workmail_list_impersonation_roles/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; The WorkMail organization to which the listed impersonation roles belong.
#' @param NextToken The token used to retrieve the next page of results. The first call doesn't require a token.
#' @param MaxResults The maximum number of results returned in a single call.
#'
#' @keywords internal
#'
#' @rdname workmail_list_impersonation_roles
workmail_list_impersonation_roles <- function(OrganizationId, NextToken = NULL, MaxResults = NULL) {
  op <- new_operation(
    name = "ListImpersonationRoles",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(input_token = "NextToken", output_token = "NextToken", limit_key = "MaxResults"),
    stream_api = FALSE
  )
  input <- .workmail$list_impersonation_roles_input(OrganizationId = OrganizationId, NextToken = NextToken, MaxResults = MaxResults)
  output <- .workmail$list_impersonation_roles_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$list_impersonation_roles <- workmail_list_impersonation_roles

#' Lists the mail domains in a given WorkMail organization
#'
#' @description
#' Lists the mail domains in a given WorkMail organization.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_list_mail_domains/](https://www.paws-r-sdk.com/docs/workmail_list_mail_domains/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; The WorkMail organization for which to list domains.
#' @param MaxResults The maximum number of results to return in a single call.
#' @param NextToken The token to use to retrieve the next page of results. The first call does not require a token.
#'
#' @keywords internal
#'
#' @rdname workmail_list_mail_domains
workmail_list_mail_domains <- function(OrganizationId, MaxResults = NULL, NextToken = NULL) {
  op <- new_operation(
    name = "ListMailDomains",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(input_token = "NextToken", output_token = "NextToken", limit_key = "MaxResults"),
    stream_api = FALSE
  )
  input <- .workmail$list_mail_domains_input(OrganizationId = OrganizationId, MaxResults = MaxResults, NextToken = NextToken)
  output <- .workmail$list_mail_domains_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$list_mail_domains <- workmail_list_mail_domains

#' Lists the mailbox export jobs started for the specified organization
#' within the last seven days
#'
#' @description
#' Lists the mailbox export jobs started for the specified organization within the last seven days.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_list_mailbox_export_jobs/](https://www.paws-r-sdk.com/docs/workmail_list_mailbox_export_jobs/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; The organization ID.
#' @param NextToken The token to use to retrieve the next page of results.
#' @param MaxResults The maximum number of results to return in a single call.
#'
#' @keywords internal
#'
#' @rdname workmail_list_mailbox_export_jobs
workmail_list_mailbox_export_jobs <- function(OrganizationId, NextToken = NULL, MaxResults = NULL) {
  op <- new_operation(
    name = "ListMailboxExportJobs",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(input_token = "NextToken", output_token = "NextToken", limit_key = "MaxResults"),
    stream_api = FALSE
  )
  input <- .workmail$list_mailbox_export_jobs_input(OrganizationId = OrganizationId, NextToken = NextToken, MaxResults = MaxResults)
  output <- .workmail$list_mailbox_export_jobs_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$list_mailbox_export_jobs <- workmail_list_mailbox_export_jobs

#' Lists the mailbox permissions associated with a user, group, or resource
#' mailbox
#'
#' @description
#' Lists the mailbox permissions associated with a user, group, or resource mailbox.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_list_mailbox_permissions/](https://www.paws-r-sdk.com/docs/workmail_list_mailbox_permissions/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; The identifier of the organization under which the user, group, or resource exists.
#' @param EntityId &#91;required&#93; The identifier of the user, or resource for which to list mailbox permissions.
#' 
#' The entity ID can accept *UserId or ResourceId*, *Username or Resourcename*, or *email*.
#' 
#' -   Entity ID: 12345678-1234-1234-1234-123456789012, or r-0123456789a0123456789b0123456789
#' 
#' -   Email address: entity@@domain.tld
#' 
#' -   Entity name: entity
#' @param NextToken The token to use to retrieve the next page of results. The first call does not contain any tokens.
#' @param MaxResults The maximum number of results to return in a single call.
#'
#' @keywords internal
#'
#' @rdname workmail_list_mailbox_permissions
workmail_list_mailbox_permissions <- function(OrganizationId, EntityId, NextToken = NULL, MaxResults = NULL) {
  op <- new_operation(
    name = "ListMailboxPermissions",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(input_token = "NextToken", limit_key = "MaxResults", output_token = "NextToken", result_key = "Permissions"),
    stream_api = FALSE
  )
  input <- .workmail$list_mailbox_permissions_input(OrganizationId = OrganizationId, EntityId = EntityId, NextToken = NextToken, MaxResults = MaxResults)
  output <- .workmail$list_mailbox_permissions_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$list_mailbox_permissions <- workmail_list_mailbox_permissions

#' Lists all the mobile device access overrides for any given combination
#' of WorkMail organization, user, or device
#'
#' @description
#' Lists all the mobile device access overrides for any given combination of WorkMail organization, user, or device.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_list_mobile_device_access_overrides/](https://www.paws-r-sdk.com/docs/workmail_list_mobile_device_access_overrides/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; The WorkMail organization under which to list mobile device access overrides.
#' @param UserId The WorkMail user under which you list the mobile device access overrides. Accepts the following types of user identities:
#' 
#' -   User ID: `12345678-1234-1234-1234-123456789012` or `S-1-1-12-1234567890-123456789-123456789-1234`
#' 
#' -   Email address: `user@@domain.tld`
#' 
#' -   User name: `user`
#' @param DeviceId The mobile device to which the access override applies.
#' @param NextToken The token to use to retrieve the next page of results. The first call does not require a token.
#' @param MaxResults The maximum number of results to return in a single call.
#'
#' @keywords internal
#'
#' @rdname workmail_list_mobile_device_access_overrides
workmail_list_mobile_device_access_overrides <- function(OrganizationId, UserId = NULL, DeviceId = NULL, NextToken = NULL, MaxResults = NULL) {
  op <- new_operation(
    name = "ListMobileDeviceAccessOverrides",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(input_token = "NextToken", output_token = "NextToken", limit_key = "MaxResults"),
    stream_api = FALSE
  )
  input <- .workmail$list_mobile_device_access_overrides_input(OrganizationId = OrganizationId, UserId = UserId, DeviceId = DeviceId, NextToken = NextToken, MaxResults = MaxResults)
  output <- .workmail$list_mobile_device_access_overrides_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$list_mobile_device_access_overrides <- workmail_list_mobile_device_access_overrides

#' Lists the mobile device access rules for the specified WorkMail
#' organization
#'
#' @description
#' Lists the mobile device access rules for the specified WorkMail organization.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_list_mobile_device_access_rules/](https://www.paws-r-sdk.com/docs/workmail_list_mobile_device_access_rules/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; The WorkMail organization for which to list the rules.
#'
#' @keywords internal
#'
#' @rdname workmail_list_mobile_device_access_rules
workmail_list_mobile_device_access_rules <- function(OrganizationId) {
  op <- new_operation(
    name = "ListMobileDeviceAccessRules",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmail$list_mobile_device_access_rules_input(OrganizationId = OrganizationId)
  output <- .workmail$list_mobile_device_access_rules_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$list_mobile_device_access_rules <- workmail_list_mobile_device_access_rules

#' Returns summaries of the customer's organizations
#'
#' @description
#' Returns summaries of the customer's organizations.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_list_organizations/](https://www.paws-r-sdk.com/docs/workmail_list_organizations/) for full documentation.
#'
#' @param NextToken The token to use to retrieve the next page of results. The first call does not contain any tokens.
#' @param MaxResults The maximum number of results to return in a single call.
#'
#' @keywords internal
#'
#' @rdname workmail_list_organizations
workmail_list_organizations <- function(NextToken = NULL, MaxResults = NULL) {
  op <- new_operation(
    name = "ListOrganizations",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(result_key = "OrganizationSummaries", output_token = "NextToken", input_token = "NextToken", limit_key = "MaxResults"),
    stream_api = FALSE
  )
  input <- .workmail$list_organizations_input(NextToken = NextToken, MaxResults = MaxResults)
  output <- .workmail$list_organizations_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$list_organizations <- workmail_list_organizations

#' Returns a summary of your Personal Access Tokens
#'
#' @description
#' Returns a summary of your Personal Access Tokens.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_list_personal_access_tokens/](https://www.paws-r-sdk.com/docs/workmail_list_personal_access_tokens/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; The Organization ID.
#' @param UserId The WorkMail User ID.
#' @param NextToken The token from the previous response to query the next page.
#' @param MaxResults The maximum amount of items that should be returned in a response.
#'
#' @keywords internal
#'
#' @rdname workmail_list_personal_access_tokens
workmail_list_personal_access_tokens <- function(OrganizationId, UserId = NULL, NextToken = NULL, MaxResults = NULL) {
  op <- new_operation(
    name = "ListPersonalAccessTokens",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(input_token = "NextToken", output_token = "NextToken", limit_key = "MaxResults", result_key = "PersonalAccessTokenSummaries"),
    stream_api = FALSE
  )
  input <- .workmail$list_personal_access_tokens_input(OrganizationId = OrganizationId, UserId = UserId, NextToken = NextToken, MaxResults = MaxResults)
  output <- .workmail$list_personal_access_tokens_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$list_personal_access_tokens <- workmail_list_personal_access_tokens

#' Lists the delegates associated with a resource
#'
#' @description
#' Lists the delegates associated with a resource. Users and groups can be resource delegates and answer requests on behalf of the resource.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_list_resource_delegates/](https://www.paws-r-sdk.com/docs/workmail_list_resource_delegates/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; The identifier for the organization that contains the resource for which delegates are listed.
#' @param ResourceId &#91;required&#93; The identifier for the resource whose delegates are listed.
#' 
#' The identifier can accept *ResourceId*, *Resourcename*, or *email*. The following identity formats are available:
#' 
#' -   Resource ID: r-0123456789a0123456789b0123456789
#' 
#' -   Email address: resource@@domain.tld
#' 
#' -   Resource name: resource
#' @param NextToken The token used to paginate through the delegates associated with a resource.
#' @param MaxResults The number of maximum results in a page.
#'
#' @keywords internal
#'
#' @rdname workmail_list_resource_delegates
workmail_list_resource_delegates <- function(OrganizationId, ResourceId, NextToken = NULL, MaxResults = NULL) {
  op <- new_operation(
    name = "ListResourceDelegates",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(input_token = "NextToken", limit_key = "MaxResults", output_token = "NextToken", result_key = "Delegates"),
    stream_api = FALSE
  )
  input <- .workmail$list_resource_delegates_input(OrganizationId = OrganizationId, ResourceId = ResourceId, NextToken = NextToken, MaxResults = MaxResults)
  output <- .workmail$list_resource_delegates_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$list_resource_delegates <- workmail_list_resource_delegates

#' Returns summaries of the organization's resources
#'
#' @description
#' Returns summaries of the organization's resources.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_list_resources/](https://www.paws-r-sdk.com/docs/workmail_list_resources/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; The identifier for the organization under which the resources exist.
#' @param NextToken The token to use to retrieve the next page of results. The first call does not contain any tokens.
#' @param MaxResults The maximum number of results to return in a single call.
#' @param Filters Limit the resource search results based on the filter criteria. You can only use one filter per request.
#'
#' @keywords internal
#'
#' @rdname workmail_list_resources
workmail_list_resources <- function(OrganizationId, NextToken = NULL, MaxResults = NULL, Filters = NULL) {
  op <- new_operation(
    name = "ListResources",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(result_key = "Resources", output_token = "NextToken", input_token = "NextToken", limit_key = "MaxResults"),
    stream_api = FALSE
  )
  input <- .workmail$list_resources_input(OrganizationId = OrganizationId, NextToken = NextToken, MaxResults = MaxResults, Filters = Filters)
  output <- .workmail$list_resources_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$list_resources <- workmail_list_resources

#' Lists the tags applied to an WorkMail organization resource
#'
#' @description
#' Lists the tags applied to an WorkMail organization resource.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_list_tags_for_resource/](https://www.paws-r-sdk.com/docs/workmail_list_tags_for_resource/) for full documentation.
#'
#' @param ResourceARN &#91;required&#93; The resource ARN.
#'
#' @keywords internal
#'
#' @rdname workmail_list_tags_for_resource
workmail_list_tags_for_resource <- function(ResourceARN) {
  op <- new_operation(
    name = "ListTagsForResource",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmail$list_tags_for_resource_input(ResourceARN = ResourceARN)
  output <- .workmail$list_tags_for_resource_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$list_tags_for_resource <- workmail_list_tags_for_resource

#' Returns summaries of the organization's users
#'
#' @description
#' Returns summaries of the organization's users.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_list_users/](https://www.paws-r-sdk.com/docs/workmail_list_users/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; The identifier for the organization under which the users exist.
#' @param NextToken The token to use to retrieve the next page of results. The first call does not contain any tokens.
#' @param MaxResults The maximum number of results to return in a single call.
#' @param Filters Limit the user search results based on the filter criteria. You can only use one filter per request.
#'
#' @keywords internal
#'
#' @rdname workmail_list_users
workmail_list_users <- function(OrganizationId, NextToken = NULL, MaxResults = NULL, Filters = NULL) {
  op <- new_operation(
    name = "ListUsers",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(result_key = "Users", output_token = "NextToken", input_token = "NextToken", limit_key = "MaxResults"),
    stream_api = FALSE
  )
  input <- .workmail$list_users_input(OrganizationId = OrganizationId, NextToken = NextToken, MaxResults = MaxResults, Filters = Filters)
  output <- .workmail$list_users_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$list_users <- workmail_list_users

#' Adds a new access control rule for the specified organization
#'
#' @description
#' Adds a new access control rule for the specified organization. The rule allows or denies access to the organization for the specified IPv4 addresses, access protocol actions, user IDs and impersonation IDs. Adding a new rule with the same name as an existing rule replaces the older rule.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_put_access_control_rule/](https://www.paws-r-sdk.com/docs/workmail_put_access_control_rule/) for full documentation.
#'
#' @param Name &#91;required&#93; The rule name.
#' @param Effect &#91;required&#93; The rule effect.
#' @param Description &#91;required&#93; The rule description.
#' @param IpRanges IPv4 CIDR ranges to include in the rule.
#' @param NotIpRanges IPv4 CIDR ranges to exclude from the rule.
#' @param Actions Access protocol actions to include in the rule. Valid values include `ActiveSync`, `AutoDiscover`, `EWS`, `IMAP`, `SMTP`, `WindowsOutlook`, and `WebMail`.
#' @param NotActions Access protocol actions to exclude from the rule. Valid values include `ActiveSync`, `AutoDiscover`, `EWS`, `IMAP`, `SMTP`, `WindowsOutlook`, and `WebMail`.
#' @param UserIds User IDs to include in the rule.
#' @param NotUserIds User IDs to exclude from the rule.
#' @param OrganizationId &#91;required&#93; The identifier of the organization.
#' @param ImpersonationRoleIds Impersonation role IDs to include in the rule.
#' @param NotImpersonationRoleIds Impersonation role IDs to exclude from the rule.
#'
#' @keywords internal
#'
#' @rdname workmail_put_access_control_rule
workmail_put_access_control_rule <- function(Name, Effect, Description, IpRanges = NULL, NotIpRanges = NULL, Actions = NULL, NotActions = NULL, UserIds = NULL, NotUserIds = NULL, OrganizationId, ImpersonationRoleIds = NULL, NotImpersonationRoleIds = NULL) {
  op <- new_operation(
    name = "PutAccessControlRule",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmail$put_access_control_rule_input(Name = Name, Effect = Effect, Description = Description, IpRanges = IpRanges, NotIpRanges = NotIpRanges, Actions = Actions, NotActions = NotActions, UserIds = UserIds, NotUserIds = NotUserIds, OrganizationId = OrganizationId, ImpersonationRoleIds = ImpersonationRoleIds, NotImpersonationRoleIds = NotImpersonationRoleIds)
  output <- .workmail$put_access_control_rule_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$put_access_control_rule <- workmail_put_access_control_rule

#' Creates or updates the email monitoring configuration for a specified
#' organization
#'
#' @description
#' Creates or updates the email monitoring configuration for a specified organization.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_put_email_monitoring_configuration/](https://www.paws-r-sdk.com/docs/workmail_put_email_monitoring_configuration/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; The ID of the organization for which the email monitoring configuration is set.
#' @param RoleArn The Amazon Resource Name (ARN) of the IAM Role associated with the email monitoring configuration. If absent, the IAM Role Arn of AWSServiceRoleForAmazonWorkMailEvents will be used.
#' @param LogGroupArn &#91;required&#93; The Amazon Resource Name (ARN) of the CloudWatch Log group associated with the email monitoring configuration.
#'
#' @keywords internal
#'
#' @rdname workmail_put_email_monitoring_configuration
workmail_put_email_monitoring_configuration <- function(OrganizationId, RoleArn = NULL, LogGroupArn) {
  op <- new_operation(
    name = "PutEmailMonitoringConfiguration",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmail$put_email_monitoring_configuration_input(OrganizationId = OrganizationId, RoleArn = RoleArn, LogGroupArn = LogGroupArn)
  output <- .workmail$put_email_monitoring_configuration_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$put_email_monitoring_configuration <- workmail_put_email_monitoring_configuration

#' Enables integration between IAM Identity Center (IdC) and WorkMail to
#' proxy authentication requests for mailbox users
#'
#' @description
#' Enables integration between IAM Identity Center (IdC) and WorkMail to proxy authentication requests for mailbox users. You can connect your IdC directory or your external directory to WorkMail through IdC and manage access to WorkMail mailboxes in a single place. For enhanced protection, you could enable Multifactor Authentication (MFA) and Personal Access Tokens.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_put_identity_provider_configuration/](https://www.paws-r-sdk.com/docs/workmail_put_identity_provider_configuration/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; The ID of the WorkMail Organization.
#' @param AuthenticationMode &#91;required&#93; The authentication mode used in WorkMail.
#' @param IdentityCenterConfiguration &#91;required&#93; The details of the IAM Identity Center configuration.
#' @param PersonalAccessTokenConfiguration &#91;required&#93; The details of the Personal Access Token configuration.
#'
#' @keywords internal
#'
#' @rdname workmail_put_identity_provider_configuration
workmail_put_identity_provider_configuration <- function(OrganizationId, AuthenticationMode, IdentityCenterConfiguration, PersonalAccessTokenConfiguration) {
  op <- new_operation(
    name = "PutIdentityProviderConfiguration",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmail$put_identity_provider_configuration_input(OrganizationId = OrganizationId, AuthenticationMode = AuthenticationMode, IdentityCenterConfiguration = IdentityCenterConfiguration, PersonalAccessTokenConfiguration = PersonalAccessTokenConfiguration)
  output <- .workmail$put_identity_provider_configuration_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$put_identity_provider_configuration <- workmail_put_identity_provider_configuration

#' Enables or disables a DMARC policy for a given organization
#'
#' @description
#' Enables or disables a DMARC policy for a given organization.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_put_inbound_dmarc_settings/](https://www.paws-r-sdk.com/docs/workmail_put_inbound_dmarc_settings/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; The ID of the organization that you are applying the DMARC policy to.
#' @param Enforced &#91;required&#93; Enforces or suspends a policy after it's applied.
#'
#' @keywords internal
#'
#' @rdname workmail_put_inbound_dmarc_settings
workmail_put_inbound_dmarc_settings <- function(OrganizationId, Enforced) {
  op <- new_operation(
    name = "PutInboundDmarcSettings",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmail$put_inbound_dmarc_settings_input(OrganizationId = OrganizationId, Enforced = Enforced)
  output <- .workmail$put_inbound_dmarc_settings_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$put_inbound_dmarc_settings <- workmail_put_inbound_dmarc_settings

#' Sets permissions for a user, group, or resource
#'
#' @description
#' Sets permissions for a user, group, or resource. This replaces any pre-existing permissions.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_put_mailbox_permissions/](https://www.paws-r-sdk.com/docs/workmail_put_mailbox_permissions/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; The identifier of the organization under which the user, group, or resource exists.
#' @param EntityId &#91;required&#93; The identifier of the user or resource for which to update mailbox permissions.
#' 
#' The identifier can be *UserId, ResourceID, or Group Id*, *Username, Resourcename, or Groupname*, or *email*.
#' 
#' -   Entity ID: 12345678-1234-1234-1234-123456789012, r-0123456789a0123456789b0123456789, or S-1-1-12-1234567890-123456789-123456789-1234
#' 
#' -   Email address: entity@@domain.tld
#' 
#' -   Entity name: entity
#' @param GranteeId &#91;required&#93; The identifier of the user, group, or resource to which to grant the permissions.
#' 
#' The identifier can be *UserId, ResourceID, or Group Id*, *Username, Resourcename, or Groupname*, or *email*.
#' 
#' -   Grantee ID: 12345678-1234-1234-1234-123456789012, r-0123456789a0123456789b0123456789, or S-1-1-12-1234567890-123456789-123456789-1234
#' 
#' -   Email address: grantee@@domain.tld
#' 
#' -   Grantee name: grantee
#' @param PermissionValues &#91;required&#93; The permissions granted to the grantee. SEND_AS allows the grantee to send email as the owner of the mailbox (the grantee is not mentioned on these emails). SEND_ON_BEHALF allows the grantee to send email on behalf of the owner of the mailbox (the grantee is not mentioned as the physical sender of these emails). FULL_ACCESS allows the grantee full access to the mailbox, irrespective of other folder-level permissions set on the mailbox.
#'
#' @keywords internal
#'
#' @rdname workmail_put_mailbox_permissions
workmail_put_mailbox_permissions <- function(OrganizationId, EntityId, GranteeId, PermissionValues) {
  op <- new_operation(
    name = "PutMailboxPermissions",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmail$put_mailbox_permissions_input(OrganizationId = OrganizationId, EntityId = EntityId, GranteeId = GranteeId, PermissionValues = PermissionValues)
  output <- .workmail$put_mailbox_permissions_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$put_mailbox_permissions <- workmail_put_mailbox_permissions

#' Creates or updates a mobile device access override for the given
#' WorkMail organization, user, and device
#'
#' @description
#' Creates or updates a mobile device access override for the given WorkMail organization, user, and device.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_put_mobile_device_access_override/](https://www.paws-r-sdk.com/docs/workmail_put_mobile_device_access_override/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; Identifies the WorkMail organization for which you create the override.
#' @param UserId &#91;required&#93; The WorkMail user for which you create the override. Accepts the following types of user identities:
#' 
#' -   User ID: `12345678-1234-1234-1234-123456789012` or `S-1-1-12-1234567890-123456789-123456789-1234`
#' 
#' -   Email address: `user@@domain.tld`
#' 
#' -   User name: `user`
#' @param DeviceId &#91;required&#93; The mobile device for which you create the override. `DeviceId` is case insensitive.
#' @param Effect &#91;required&#93; The effect of the override, `ALLOW` or `DENY`.
#' @param Description A description of the override.
#'
#' @keywords internal
#'
#' @rdname workmail_put_mobile_device_access_override
workmail_put_mobile_device_access_override <- function(OrganizationId, UserId, DeviceId, Effect, Description = NULL) {
  op <- new_operation(
    name = "PutMobileDeviceAccessOverride",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmail$put_mobile_device_access_override_input(OrganizationId = OrganizationId, UserId = UserId, DeviceId = DeviceId, Effect = Effect, Description = Description)
  output <- .workmail$put_mobile_device_access_override_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$put_mobile_device_access_override <- workmail_put_mobile_device_access_override

#' Puts a retention policy to the specified organization
#'
#' @description
#' Puts a retention policy to the specified organization.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_put_retention_policy/](https://www.paws-r-sdk.com/docs/workmail_put_retention_policy/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; The organization ID.
#' @param Id The retention policy ID.
#' @param Name &#91;required&#93; The retention policy name.
#' @param Description The retention policy description.
#' @param FolderConfigurations &#91;required&#93; The retention policy folder configurations.
#'
#' @keywords internal
#'
#' @rdname workmail_put_retention_policy
workmail_put_retention_policy <- function(OrganizationId, Id = NULL, Name, Description = NULL, FolderConfigurations) {
  op <- new_operation(
    name = "PutRetentionPolicy",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmail$put_retention_policy_input(OrganizationId = OrganizationId, Id = Id, Name = Name, Description = Description, FolderConfigurations = FolderConfigurations)
  output <- .workmail$put_retention_policy_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$put_retention_policy <- workmail_put_retention_policy

#' Registers a new domain in WorkMail and SES, and configures it for use by
#' WorkMail
#'
#' @description
#' Registers a new domain in WorkMail and SES, and configures it for use by WorkMail. Emails received by SES for this domain are routed to the specified WorkMail organization, and WorkMail has permanent permission to use the specified domain for sending your users' emails.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_register_mail_domain/](https://www.paws-r-sdk.com/docs/workmail_register_mail_domain/) for full documentation.
#'
#' @param ClientToken Idempotency token used when retrying requests.
#' @param OrganizationId &#91;required&#93; The WorkMail organization under which you're creating the domain.
#' @param DomainName &#91;required&#93; The name of the mail domain to create in WorkMail and SES.
#'
#' @keywords internal
#'
#' @rdname workmail_register_mail_domain
workmail_register_mail_domain <- function(ClientToken = NULL, OrganizationId, DomainName) {
  op <- new_operation(
    name = "RegisterMailDomain",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmail$register_mail_domain_input(ClientToken = ClientToken, OrganizationId = OrganizationId, DomainName = DomainName)
  output <- .workmail$register_mail_domain_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$register_mail_domain <- workmail_register_mail_domain

#' Registers an existing and disabled user, group, or resource for WorkMail
#' use by associating a mailbox and calendaring capabilities
#'
#' @description
#' Registers an existing and disabled user, group, or resource for WorkMail use by associating a mailbox and calendaring capabilities. It performs no change if the user, group, or resource is enabled and fails if the user, group, or resource is deleted. This operation results in the accumulation of costs. For more information, see [Pricing](https://aws.amazon.com/workmail/pricing/). The equivalent console functionality for this operation is *Enable*.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_register_to_work_mail/](https://www.paws-r-sdk.com/docs/workmail_register_to_work_mail/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; The identifier for the organization under which the user, group, or resource exists.
#' @param EntityId &#91;required&#93; The identifier for the user, group, or resource to be updated.
#' 
#' The identifier can accept *UserId, ResourceId, or GroupId*, or *Username, Resourcename, or Groupname*. The following identity formats are available:
#' 
#' -   Entity ID: 12345678-1234-1234-1234-123456789012, r-0123456789a0123456789b0123456789, or S-1-1-12-1234567890-123456789-123456789-1234
#' 
#' -   Entity name: entity
#' @param Email &#91;required&#93; The email for the user, group, or resource to be updated.
#'
#' @keywords internal
#'
#' @rdname workmail_register_to_work_mail
workmail_register_to_work_mail <- function(OrganizationId, EntityId, Email) {
  op <- new_operation(
    name = "RegisterToWorkMail",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmail$register_to_work_mail_input(OrganizationId = OrganizationId, EntityId = EntityId, Email = Email)
  output <- .workmail$register_to_work_mail_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$register_to_work_mail <- workmail_register_to_work_mail

#' Allows the administrator to reset the password for a user
#'
#' @description
#' Allows the administrator to reset the password for a user.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_reset_password/](https://www.paws-r-sdk.com/docs/workmail_reset_password/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; The identifier of the organization that contains the user for which the password is reset.
#' @param UserId &#91;required&#93; The identifier of the user for whom the password is reset.
#' @param Password &#91;required&#93; The new password for the user.
#'
#' @keywords internal
#'
#' @rdname workmail_reset_password
workmail_reset_password <- function(OrganizationId, UserId, Password) {
  op <- new_operation(
    name = "ResetPassword",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmail$reset_password_input(OrganizationId = OrganizationId, UserId = UserId, Password = Password)
  output <- .workmail$reset_password_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$reset_password <- workmail_reset_password

#' Starts a mailbox export job to export MIME-format email messages and
#' calendar items from the specified mailbox to the specified Amazon Simple
#' Storage Service (Amazon S3) bucket
#'
#' @description
#' Starts a mailbox export job to export MIME-format email messages and calendar items from the specified mailbox to the specified Amazon Simple Storage Service (Amazon S3) bucket. For more information, see [Exporting mailbox content](https://docs.aws.amazon.com/workmail/latest/adminguide/mail-export.html) in the *WorkMail Administrator Guide*.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_start_mailbox_export_job/](https://www.paws-r-sdk.com/docs/workmail_start_mailbox_export_job/) for full documentation.
#'
#' @param ClientToken &#91;required&#93; The idempotency token for the client request.
#' @param OrganizationId &#91;required&#93; The identifier associated with the organization.
#' @param EntityId &#91;required&#93; The identifier of the user or resource associated with the mailbox.
#' 
#' The identifier can accept *UserId or ResourceId*, *Username or Resourcename*, or *email*. The following identity formats are available:
#' 
#' -   Entity ID: 12345678-1234-1234-1234-123456789012, r-0123456789a0123456789b0123456789 , or S-1-1-12-1234567890-123456789-123456789-1234
#' 
#' -   Email address: entity@@domain.tld
#' 
#' -   Entity name: entity
#' @param Description The mailbox export job description.
#' @param RoleArn &#91;required&#93; The ARN of the AWS Identity and Access Management (IAM) role that grants write permission to the S3 bucket.
#' @param KmsKeyArn &#91;required&#93; The Amazon Resource Name (ARN) of the symmetric AWS Key Management Service (AWS KMS) key that encrypts the exported mailbox content.
#' @param S3BucketName &#91;required&#93; The name of the S3 bucket.
#' @param S3Prefix &#91;required&#93; The S3 bucket prefix.
#'
#' @keywords internal
#'
#' @rdname workmail_start_mailbox_export_job
workmail_start_mailbox_export_job <- function(ClientToken, OrganizationId, EntityId, Description = NULL, RoleArn, KmsKeyArn, S3BucketName, S3Prefix) {
  op <- new_operation(
    name = "StartMailboxExportJob",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmail$start_mailbox_export_job_input(ClientToken = ClientToken, OrganizationId = OrganizationId, EntityId = EntityId, Description = Description, RoleArn = RoleArn, KmsKeyArn = KmsKeyArn, S3BucketName = S3BucketName, S3Prefix = S3Prefix)
  output <- .workmail$start_mailbox_export_job_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$start_mailbox_export_job <- workmail_start_mailbox_export_job

#' Applies the specified tags to the specified WorkMailorganization
#' resource
#'
#' @description
#' Applies the specified tags to the specified WorkMailorganization resource.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_tag_resource/](https://www.paws-r-sdk.com/docs/workmail_tag_resource/) for full documentation.
#'
#' @param ResourceARN &#91;required&#93; The resource ARN.
#' @param Tags &#91;required&#93; The tag key-value pairs.
#'
#' @keywords internal
#'
#' @rdname workmail_tag_resource
workmail_tag_resource <- function(ResourceARN, Tags) {
  op <- new_operation(
    name = "TagResource",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmail$tag_resource_input(ResourceARN = ResourceARN, Tags = Tags)
  output <- .workmail$tag_resource_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$tag_resource <- workmail_tag_resource

#' Performs a test on an availability provider to ensure that access is
#' allowed
#'
#' @description
#' Performs a test on an availability provider to ensure that access is allowed. For EWS, it verifies the provided credentials can be used to successfully log in. For Lambda, it verifies that the Lambda function can be invoked and that the resource access policy was configured to deny anonymous access. An anonymous invocation is one done without providing either a `SourceArn` or `SourceAccount` header.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_test_availability_configuration/](https://www.paws-r-sdk.com/docs/workmail_test_availability_configuration/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; The WorkMail organization where the availability provider will be tested.
#' @param DomainName The domain to which the provider applies. If this field is provided, a stored availability provider associated to this domain name will be tested.
#' @param EwsProvider Describes an EWS based availability provider. This is only used as input to the service.
#' @param LambdaProvider Describes a Lambda based availability provider.
#'
#' @keywords internal
#'
#' @rdname workmail_test_availability_configuration
workmail_test_availability_configuration <- function(OrganizationId, DomainName = NULL, EwsProvider = NULL, LambdaProvider = NULL) {
  op <- new_operation(
    name = "TestAvailabilityConfiguration",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmail$test_availability_configuration_input(OrganizationId = OrganizationId, DomainName = DomainName, EwsProvider = EwsProvider, LambdaProvider = LambdaProvider)
  output <- .workmail$test_availability_configuration_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$test_availability_configuration <- workmail_test_availability_configuration

#' Untags the specified tags from the specified WorkMail organization
#' resource
#'
#' @description
#' Untags the specified tags from the specified WorkMail organization resource.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_untag_resource/](https://www.paws-r-sdk.com/docs/workmail_untag_resource/) for full documentation.
#'
#' @param ResourceARN &#91;required&#93; The resource ARN.
#' @param TagKeys &#91;required&#93; The tag keys.
#'
#' @keywords internal
#'
#' @rdname workmail_untag_resource
workmail_untag_resource <- function(ResourceARN, TagKeys) {
  op <- new_operation(
    name = "UntagResource",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmail$untag_resource_input(ResourceARN = ResourceARN, TagKeys = TagKeys)
  output <- .workmail$untag_resource_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$untag_resource <- workmail_untag_resource

#' Updates an existing AvailabilityConfiguration for the given WorkMail
#' organization and domain
#'
#' @description
#' Updates an existing `AvailabilityConfiguration` for the given WorkMail organization and domain.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_update_availability_configuration/](https://www.paws-r-sdk.com/docs/workmail_update_availability_configuration/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; The WorkMail organization for which the `AvailabilityConfiguration` will be updated.
#' @param DomainName &#91;required&#93; The domain to which the provider applies the availability configuration.
#' @param EwsProvider The EWS availability provider definition. The request must contain exactly one provider definition, either `EwsProvider` or `LambdaProvider`. The previously stored provider will be overridden by the one provided.
#' @param LambdaProvider The Lambda availability provider definition. The request must contain exactly one provider definition, either `EwsProvider` or `LambdaProvider`. The previously stored provider will be overridden by the one provided.
#'
#' @keywords internal
#'
#' @rdname workmail_update_availability_configuration
workmail_update_availability_configuration <- function(OrganizationId, DomainName, EwsProvider = NULL, LambdaProvider = NULL) {
  op <- new_operation(
    name = "UpdateAvailabilityConfiguration",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmail$update_availability_configuration_input(OrganizationId = OrganizationId, DomainName = DomainName, EwsProvider = EwsProvider, LambdaProvider = LambdaProvider)
  output <- .workmail$update_availability_configuration_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$update_availability_configuration <- workmail_update_availability_configuration

#' Updates the default mail domain for an organization
#'
#' @description
#' Updates the default mail domain for an organization. The default mail domain is used by the WorkMail AWS Console to suggest an email address when enabling a mail user. You can only have one default domain.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_update_default_mail_domain/](https://www.paws-r-sdk.com/docs/workmail_update_default_mail_domain/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; The WorkMail organization for which to list domains.
#' @param DomainName &#91;required&#93; The domain name that will become the default domain.
#'
#' @keywords internal
#'
#' @rdname workmail_update_default_mail_domain
workmail_update_default_mail_domain <- function(OrganizationId, DomainName) {
  op <- new_operation(
    name = "UpdateDefaultMailDomain",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmail$update_default_mail_domain_input(OrganizationId = OrganizationId, DomainName = DomainName)
  output <- .workmail$update_default_mail_domain_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$update_default_mail_domain <- workmail_update_default_mail_domain

#' Updates attributes in a group
#'
#' @description
#' Updates attributes in a group.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_update_group/](https://www.paws-r-sdk.com/docs/workmail_update_group/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; The identifier for the organization under which the group exists.
#' @param GroupId &#91;required&#93; The identifier for the group to be updated.
#' 
#' The identifier can accept *GroupId*, *Groupname*, or *email*. The following identity formats are available:
#' 
#' -   Group ID: 12345678-1234-1234-1234-123456789012 or S-1-1-12-1234567890-123456789-123456789-1234
#' 
#' -   Email address: group@@domain.tld
#' 
#' -   Group name: group
#' @param HiddenFromGlobalAddressList If enabled, the group is hidden from the global address list.
#'
#' @keywords internal
#'
#' @rdname workmail_update_group
workmail_update_group <- function(OrganizationId, GroupId, HiddenFromGlobalAddressList = NULL) {
  op <- new_operation(
    name = "UpdateGroup",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmail$update_group_input(OrganizationId = OrganizationId, GroupId = GroupId, HiddenFromGlobalAddressList = HiddenFromGlobalAddressList)
  output <- .workmail$update_group_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$update_group <- workmail_update_group

#' Updates an impersonation role for the given WorkMail organization
#'
#' @description
#' Updates an impersonation role for the given WorkMail organization.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_update_impersonation_role/](https://www.paws-r-sdk.com/docs/workmail_update_impersonation_role/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; The WorkMail organization that contains the impersonation role to update.
#' @param ImpersonationRoleId &#91;required&#93; The ID of the impersonation role to update.
#' @param Name &#91;required&#93; The updated impersonation role name.
#' @param Type &#91;required&#93; The updated impersonation role type.
#' @param Description The updated impersonation role description.
#' @param Rules &#91;required&#93; The updated list of rules.
#'
#' @keywords internal
#'
#' @rdname workmail_update_impersonation_role
workmail_update_impersonation_role <- function(OrganizationId, ImpersonationRoleId, Name, Type, Description = NULL, Rules) {
  op <- new_operation(
    name = "UpdateImpersonationRole",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmail$update_impersonation_role_input(OrganizationId = OrganizationId, ImpersonationRoleId = ImpersonationRoleId, Name = Name, Type = Type, Description = Description, Rules = Rules)
  output <- .workmail$update_impersonation_role_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$update_impersonation_role <- workmail_update_impersonation_role

#' Updates a user's current mailbox quota for a specified organization and
#' user
#'
#' @description
#' Updates a user's current mailbox quota for a specified organization and user.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_update_mailbox_quota/](https://www.paws-r-sdk.com/docs/workmail_update_mailbox_quota/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; The identifier for the organization that contains the user for whom to update the mailbox quota.
#' @param UserId &#91;required&#93; The identifer for the user for whom to update the mailbox quota.
#' 
#' The identifier can be the *UserId*, *Username*, or *email*. The following identity formats are available:
#' 
#' -   User ID: 12345678-1234-1234-1234-123456789012 or S-1-1-12-1234567890-123456789-123456789-1234
#' 
#' -   Email address: user@@domain.tld
#' 
#' -   User name: user
#' @param MailboxQuota &#91;required&#93; The updated mailbox quota, in MB, for the specified user.
#'
#' @keywords internal
#'
#' @rdname workmail_update_mailbox_quota
workmail_update_mailbox_quota <- function(OrganizationId, UserId, MailboxQuota) {
  op <- new_operation(
    name = "UpdateMailboxQuota",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmail$update_mailbox_quota_input(OrganizationId = OrganizationId, UserId = UserId, MailboxQuota = MailboxQuota)
  output <- .workmail$update_mailbox_quota_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$update_mailbox_quota <- workmail_update_mailbox_quota

#' Updates a mobile device access rule for the specified WorkMail
#' organization
#'
#' @description
#' Updates a mobile device access rule for the specified WorkMail organization.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_update_mobile_device_access_rule/](https://www.paws-r-sdk.com/docs/workmail_update_mobile_device_access_rule/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; The WorkMail organization under which the rule will be updated.
#' @param MobileDeviceAccessRuleId &#91;required&#93; The identifier of the rule to be updated.
#' @param Name &#91;required&#93; The updated rule name.
#' @param Description The updated rule description.
#' @param Effect &#91;required&#93; The effect of the rule when it matches. Allowed values are `ALLOW` or `DENY`.
#' @param DeviceTypes Device types that the updated rule will match.
#' @param NotDeviceTypes Device types that the updated rule **will not** match. All other device types will match.
#' @param DeviceModels Device models that the updated rule will match.
#' @param NotDeviceModels Device models that the updated rule **will not** match. All other device models will match.
#' @param DeviceOperatingSystems Device operating systems that the updated rule will match.
#' @param NotDeviceOperatingSystems Device operating systems that the updated rule **will not** match. All other device operating systems will match.
#' @param DeviceUserAgents User agents that the updated rule will match.
#' @param NotDeviceUserAgents User agents that the updated rule **will not** match. All other user agents will match.
#'
#' @keywords internal
#'
#' @rdname workmail_update_mobile_device_access_rule
workmail_update_mobile_device_access_rule <- function(OrganizationId, MobileDeviceAccessRuleId, Name, Description = NULL, Effect, DeviceTypes = NULL, NotDeviceTypes = NULL, DeviceModels = NULL, NotDeviceModels = NULL, DeviceOperatingSystems = NULL, NotDeviceOperatingSystems = NULL, DeviceUserAgents = NULL, NotDeviceUserAgents = NULL) {
  op <- new_operation(
    name = "UpdateMobileDeviceAccessRule",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmail$update_mobile_device_access_rule_input(OrganizationId = OrganizationId, MobileDeviceAccessRuleId = MobileDeviceAccessRuleId, Name = Name, Description = Description, Effect = Effect, DeviceTypes = DeviceTypes, NotDeviceTypes = NotDeviceTypes, DeviceModels = DeviceModels, NotDeviceModels = NotDeviceModels, DeviceOperatingSystems = DeviceOperatingSystems, NotDeviceOperatingSystems = NotDeviceOperatingSystems, DeviceUserAgents = DeviceUserAgents, NotDeviceUserAgents = NotDeviceUserAgents)
  output <- .workmail$update_mobile_device_access_rule_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$update_mobile_device_access_rule <- workmail_update_mobile_device_access_rule

#' Updates the primary email for a user, group, or resource
#'
#' @description
#' Updates the primary email for a user, group, or resource. The current email is moved into the list of aliases (or swapped between an existing alias and the current primary email), and the email provided in the input is promoted as the primary.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_update_primary_email_address/](https://www.paws-r-sdk.com/docs/workmail_update_primary_email_address/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; The organization that contains the user, group, or resource to update.
#' @param EntityId &#91;required&#93; The user, group, or resource to update.
#' 
#' The identifier can accept *UseriD, ResourceId, or GroupId*, *Username, Resourcename, or Groupname*, or *email*. The following identity formats are available:
#' 
#' -   Entity ID: 12345678-1234-1234-1234-123456789012, r-0123456789a0123456789b0123456789, or S-1-1-12-1234567890-123456789-123456789-1234
#' 
#' -   Email address: entity@@domain.tld
#' 
#' -   Entity name: entity
#' @param Email &#91;required&#93; The value of the email to be updated as primary.
#'
#' @keywords internal
#'
#' @rdname workmail_update_primary_email_address
workmail_update_primary_email_address <- function(OrganizationId, EntityId, Email) {
  op <- new_operation(
    name = "UpdatePrimaryEmailAddress",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmail$update_primary_email_address_input(OrganizationId = OrganizationId, EntityId = EntityId, Email = Email)
  output <- .workmail$update_primary_email_address_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$update_primary_email_address <- workmail_update_primary_email_address

#' Updates data for the resource
#'
#' @description
#' Updates data for the resource. To have the latest information, it must be preceded by a [`describe_resource`][workmail_describe_resource] call. The dataset in the request should be the one expected when performing another [`describe_resource`][workmail_describe_resource] call.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_update_resource/](https://www.paws-r-sdk.com/docs/workmail_update_resource/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; The identifier associated with the organization for which the resource is updated.
#' @param ResourceId &#91;required&#93; The identifier of the resource to be updated.
#' 
#' The identifier can accept *ResourceId*, *Resourcename*, or *email*. The following identity formats are available:
#' 
#' -   Resource ID: r-0123456789a0123456789b0123456789
#' 
#' -   Email address: resource@@domain.tld
#' 
#' -   Resource name: resource
#' @param Name The name of the resource to be updated.
#' @param BookingOptions The resource's booking options to be updated.
#' @param Description Updates the resource description.
#' @param Type Updates the resource type.
#' @param HiddenFromGlobalAddressList If enabled, the resource is hidden from the global address list.
#'
#' @keywords internal
#'
#' @rdname workmail_update_resource
workmail_update_resource <- function(OrganizationId, ResourceId, Name = NULL, BookingOptions = NULL, Description = NULL, Type = NULL, HiddenFromGlobalAddressList = NULL) {
  op <- new_operation(
    name = "UpdateResource",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmail$update_resource_input(OrganizationId = OrganizationId, ResourceId = ResourceId, Name = Name, BookingOptions = BookingOptions, Description = Description, Type = Type, HiddenFromGlobalAddressList = HiddenFromGlobalAddressList)
  output <- .workmail$update_resource_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$update_resource <- workmail_update_resource

#' Updates data for the user
#'
#' @description
#' Updates data for the user. To have the latest information, it must be preceded by a [`describe_user`][workmail_describe_user] call. The dataset in the request should be the one expected when performing another [`describe_user`][workmail_describe_user] call.
#'
#' See [https://www.paws-r-sdk.com/docs/workmail_update_user/](https://www.paws-r-sdk.com/docs/workmail_update_user/) for full documentation.
#'
#' @param OrganizationId &#91;required&#93; The identifier for the organization under which the user exists.
#' @param UserId &#91;required&#93; The identifier for the user to be updated.
#' 
#' The identifier can be the *UserId*, *Username*, or *email*. The following identity formats are available:
#' 
#' -   User ID: 12345678-1234-1234-1234-123456789012 or S-1-1-12-1234567890-123456789-123456789-1234
#' 
#' -   Email address: user@@domain.tld
#' 
#' -   User name: user
#' @param Role Updates the user role.
#' 
#' You cannot pass *SYSTEM_USER* or *RESOURCE*.
#' @param DisplayName Updates the display name of the user.
#' @param FirstName Updates the user's first name.
#' @param LastName Updates the user's last name.
#' @param HiddenFromGlobalAddressList If enabled, the user is hidden from the global address list.
#' @param Initials Updates the user's initials.
#' @param Telephone Updates the user's contact details.
#' @param Street Updates the user's street address.
#' @param JobTitle Updates the user's job title.
#' @param City Updates the user's city.
#' @param Company Updates the user's company.
#' @param ZipCode Updates the user's zip code.
#' @param Department Updates the user's department.
#' @param Country Updates the user's country.
#' @param Office Updates the user's office.
#' @param IdentityProviderUserId User ID from the IAM Identity Center. If this parameter is empty it will be updated automatically when the user logs in for the first time to the mailbox associated with WorkMail.
#'
#' @keywords internal
#'
#' @rdname workmail_update_user
workmail_update_user <- function(OrganizationId, UserId, Role = NULL, DisplayName = NULL, FirstName = NULL, LastName = NULL, HiddenFromGlobalAddressList = NULL, Initials = NULL, Telephone = NULL, Street = NULL, JobTitle = NULL, City = NULL, Company = NULL, ZipCode = NULL, Department = NULL, Country = NULL, Office = NULL, IdentityProviderUserId = NULL) {
  op <- new_operation(
    name = "UpdateUser",
    http_method = "POST",
    http_path = "/",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .workmail$update_user_input(OrganizationId = OrganizationId, UserId = UserId, Role = Role, DisplayName = DisplayName, FirstName = FirstName, LastName = LastName, HiddenFromGlobalAddressList = HiddenFromGlobalAddressList, Initials = Initials, Telephone = Telephone, Street = Street, JobTitle = JobTitle, City = City, Company = Company, ZipCode = ZipCode, Department = Department, Country = Country, Office = Office, IdentityProviderUserId = IdentityProviderUserId)
  output <- .workmail$update_user_output()
  config <- get_config()
  svc <- .workmail$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.workmail$operations$update_user <- workmail_update_user

# This file is generated by make.paws. Please do not edit here.
#' @importFrom paws.common get_config new_operation new_request send_request
#' @include chatbot_service.R
NULL

#' Links a resource (for example, a custom action) to a channel
#' configuration
#'
#' @description
#' Links a resource (for example, a custom action) to a channel configuration.
#'
#' See [https://www.paws-r-sdk.com/docs/chatbot_associate_to_configuration/](https://www.paws-r-sdk.com/docs/chatbot_associate_to_configuration/) for full documentation.
#'
#' @param Resource &#91;required&#93; The resource Amazon Resource Name (ARN) to link.
#' @param ChatConfiguration &#91;required&#93; The channel configuration to associate with the resource.
#'
#' @keywords internal
#'
#' @rdname chatbot_associate_to_configuration
chatbot_associate_to_configuration <- function(Resource, ChatConfiguration) {
  op <- new_operation(
    name = "AssociateToConfiguration",
    http_method = "POST",
    http_path = "/associate-to-configuration",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .chatbot$associate_to_configuration_input(Resource = Resource, ChatConfiguration = ChatConfiguration)
  output <- .chatbot$associate_to_configuration_output()
  config <- get_config()
  svc <- .chatbot$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.chatbot$operations$associate_to_configuration <- chatbot_associate_to_configuration

#' Creates an AWS Chatbot configuration for Amazon Chime
#'
#' @description
#' Creates an AWS Chatbot configuration for Amazon Chime.
#'
#' See [https://www.paws-r-sdk.com/docs/chatbot_create_chime_webhook_configuration/](https://www.paws-r-sdk.com/docs/chatbot_create_chime_webhook_configuration/) for full documentation.
#'
#' @param WebhookDescription &#91;required&#93; A description of the webhook. We recommend using the convention `RoomName/WebhookName`.
#' 
#' For more information, see [Tutorial: Get started with Amazon Chime](https://docs.aws.amazon.com/chatbot/latest/adminguide/chime-setup.html) in the *AWS Chatbot Administrator Guide*.
#' @param WebhookUrl &#91;required&#93; The URL for the Amazon Chime webhook.
#' @param SnsTopicArns &#91;required&#93; The Amazon Resource Names (ARNs) of the SNS topics that deliver notifications to AWS Chatbot.
#' @param IamRoleArn &#91;required&#93; A user-defined role that AWS Chatbot assumes. This is not the service-linked role.
#' 
#' For more information, see [IAM policies for AWS Chatbot](https://docs.aws.amazon.com/chatbot/latest/adminguide/chatbot-iam-policies.html) in the *AWS Chatbot Administrator Guide*.
#' @param ConfigurationName &#91;required&#93; The name of the configuration.
#' @param LoggingLevel Logging levels include `ERROR`, `INFO`, or `NONE`.
#' @param Tags A map of tags assigned to a resource. A tag is a string-to-string map of key-value pairs.
#'
#' @keywords internal
#'
#' @rdname chatbot_create_chime_webhook_configuration
chatbot_create_chime_webhook_configuration <- function(WebhookDescription, WebhookUrl, SnsTopicArns, IamRoleArn, ConfigurationName, LoggingLevel = NULL, Tags = NULL) {
  op <- new_operation(
    name = "CreateChimeWebhookConfiguration",
    http_method = "POST",
    http_path = "/create-chime-webhook-configuration",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .chatbot$create_chime_webhook_configuration_input(WebhookDescription = WebhookDescription, WebhookUrl = WebhookUrl, SnsTopicArns = SnsTopicArns, IamRoleArn = IamRoleArn, ConfigurationName = ConfigurationName, LoggingLevel = LoggingLevel, Tags = Tags)
  output <- .chatbot$create_chime_webhook_configuration_output()
  config <- get_config()
  svc <- .chatbot$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.chatbot$operations$create_chime_webhook_configuration <- chatbot_create_chime_webhook_configuration

#' Creates a custom action that can be invoked as an alias or as a button
#' on a notification
#'
#' @description
#' Creates a custom action that can be invoked as an alias or as a button on a notification.
#'
#' See [https://www.paws-r-sdk.com/docs/chatbot_create_custom_action/](https://www.paws-r-sdk.com/docs/chatbot_create_custom_action/) for full documentation.
#'
#' @param Definition &#91;required&#93; The definition of the command to run when invoked as an alias or as an action button.
#' @param AliasName The name used to invoke this action in a chat channel. For example, `@@aws run my-alias`.
#' @param Attachments Defines when this custom action button should be attached to a notification.
#' @param Tags A map of tags assigned to a resource. A tag is a string-to-string map of key-value pairs.
#' @param ClientToken A unique, case-sensitive identifier that you provide to ensure the idempotency of the request. Idempotency ensures that an API request completes only once. With an idempotent request, if the original request completes successfully, subsequent retries with the same client token returns the result from the original successful request.
#' 
#' If you do not specify a client token, one is automatically generated by the SDK.
#' @param ActionName &#91;required&#93; The name of the custom action. This name is included in the Amazon Resource Name (ARN).
#'
#' @keywords internal
#'
#' @rdname chatbot_create_custom_action
chatbot_create_custom_action <- function(Definition, AliasName = NULL, Attachments = NULL, Tags = NULL, ClientToken = NULL, ActionName) {
  op <- new_operation(
    name = "CreateCustomAction",
    http_method = "POST",
    http_path = "/create-custom-action",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .chatbot$create_custom_action_input(Definition = Definition, AliasName = AliasName, Attachments = Attachments, Tags = Tags, ClientToken = ClientToken, ActionName = ActionName)
  output <- .chatbot$create_custom_action_output()
  config <- get_config()
  svc <- .chatbot$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.chatbot$operations$create_custom_action <- chatbot_create_custom_action

#' Creates an AWS Chatbot configuration for Microsoft Teams
#'
#' @description
#' Creates an AWS Chatbot configuration for Microsoft Teams.
#'
#' See [https://www.paws-r-sdk.com/docs/chatbot_create_microsoft_teams_channel_configuration/](https://www.paws-r-sdk.com/docs/chatbot_create_microsoft_teams_channel_configuration/) for full documentation.
#'
#' @param ChannelId &#91;required&#93; The ID of the Microsoft Teams channel.
#' @param ChannelName The name of the Microsoft Teams channel.
#' @param TeamId &#91;required&#93; The ID of the Microsoft Teams authorized with AWS Chatbot.
#' 
#' To get the team ID, you must perform the initial authorization flow with Microsoft Teams in the AWS Chatbot console. Then you can copy and paste the team ID from the console. For more information, see [Step 1: Configure a Microsoft Teams client](https://docs.aws.amazon.com/chatbot/latest/adminguide/teams-setup.html#teams-client-setup) in the *AWS Chatbot Administrator Guide*.
#' @param TeamName The name of the Microsoft Teams Team.
#' @param TenantId &#91;required&#93; The ID of the Microsoft Teams tenant.
#' @param SnsTopicArns The Amazon Resource Names (ARNs) of the SNS topics that deliver notifications to AWS Chatbot.
#' @param IamRoleArn &#91;required&#93; A user-defined role that AWS Chatbot assumes. This is not the service-linked role.
#' 
#' For more information, see [IAM policies for AWS Chatbot](https://docs.aws.amazon.com/chatbot/latest/adminguide/chatbot-iam-policies.html) in the *AWS Chatbot Administrator Guide*.
#' @param ConfigurationName &#91;required&#93; The name of the configuration.
#' @param LoggingLevel Logging levels include `ERROR`, `INFO`, or `NONE`.
#' @param GuardrailPolicyArns The list of IAM policy ARNs that are applied as channel guardrails. The AWS managed `AdministratorAccess` policy is applied by default if this is not set.
#' @param UserAuthorizationRequired Enables use of a user role requirement in your chat configuration.
#' @param Tags A map of tags assigned to a resource. A tag is a string-to-string map of key-value pairs.
#'
#' @keywords internal
#'
#' @rdname chatbot_create_microsoft_teams_channel_configuration
chatbot_create_microsoft_teams_channel_configuration <- function(ChannelId, ChannelName = NULL, TeamId, TeamName = NULL, TenantId, SnsTopicArns = NULL, IamRoleArn, ConfigurationName, LoggingLevel = NULL, GuardrailPolicyArns = NULL, UserAuthorizationRequired = NULL, Tags = NULL) {
  op <- new_operation(
    name = "CreateMicrosoftTeamsChannelConfiguration",
    http_method = "POST",
    http_path = "/create-ms-teams-channel-configuration",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .chatbot$create_microsoft_teams_channel_configuration_input(ChannelId = ChannelId, ChannelName = ChannelName, TeamId = TeamId, TeamName = TeamName, TenantId = TenantId, SnsTopicArns = SnsTopicArns, IamRoleArn = IamRoleArn, ConfigurationName = ConfigurationName, LoggingLevel = LoggingLevel, GuardrailPolicyArns = GuardrailPolicyArns, UserAuthorizationRequired = UserAuthorizationRequired, Tags = Tags)
  output <- .chatbot$create_microsoft_teams_channel_configuration_output()
  config <- get_config()
  svc <- .chatbot$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.chatbot$operations$create_microsoft_teams_channel_configuration <- chatbot_create_microsoft_teams_channel_configuration

#' Creates an AWS Chatbot confugration for Slack
#'
#' @description
#' Creates an AWS Chatbot confugration for Slack.
#'
#' See [https://www.paws-r-sdk.com/docs/chatbot_create_slack_channel_configuration/](https://www.paws-r-sdk.com/docs/chatbot_create_slack_channel_configuration/) for full documentation.
#'
#' @param SlackTeamId &#91;required&#93; The ID of the Slack workspace authorized with AWS Chatbot.
#' @param SlackChannelId &#91;required&#93; The ID of the Slack channel.
#' 
#' To get this ID, open Slack, right click on the channel name in the left pane, then choose Copy Link. The channel ID is the 9-character string at the end of the URL. For example, ABCBBLZZZ.
#' @param SlackChannelName The name of the Slack channel.
#' @param SnsTopicArns The Amazon Resource Names (ARNs) of the SNS topics that deliver notifications to AWS Chatbot.
#' @param IamRoleArn &#91;required&#93; A user-defined role that AWS Chatbot assumes. This is not the service-linked role.
#' 
#' For more information, see [IAM policies for AWS Chatbot](https://docs.aws.amazon.com/chatbot/latest/adminguide/chatbot-iam-policies.html) in the *AWS Chatbot Administrator Guide*.
#' @param ConfigurationName &#91;required&#93; The name of the configuration.
#' @param LoggingLevel Logging levels include `ERROR`, `INFO`, or `NONE`.
#' @param GuardrailPolicyArns The list of IAM policy ARNs that are applied as channel guardrails. The AWS managed `AdministratorAccess` policy is applied by default if this is not set.
#' @param UserAuthorizationRequired Enables use of a user role requirement in your chat configuration.
#' @param Tags A map of tags assigned to a resource. A tag is a string-to-string map of key-value pairs.
#'
#' @keywords internal
#'
#' @rdname chatbot_create_slack_channel_configuration
chatbot_create_slack_channel_configuration <- function(SlackTeamId, SlackChannelId, SlackChannelName = NULL, SnsTopicArns = NULL, IamRoleArn, ConfigurationName, LoggingLevel = NULL, GuardrailPolicyArns = NULL, UserAuthorizationRequired = NULL, Tags = NULL) {
  op <- new_operation(
    name = "CreateSlackChannelConfiguration",
    http_method = "POST",
    http_path = "/create-slack-channel-configuration",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .chatbot$create_slack_channel_configuration_input(SlackTeamId = SlackTeamId, SlackChannelId = SlackChannelId, SlackChannelName = SlackChannelName, SnsTopicArns = SnsTopicArns, IamRoleArn = IamRoleArn, ConfigurationName = ConfigurationName, LoggingLevel = LoggingLevel, GuardrailPolicyArns = GuardrailPolicyArns, UserAuthorizationRequired = UserAuthorizationRequired, Tags = Tags)
  output <- .chatbot$create_slack_channel_configuration_output()
  config <- get_config()
  svc <- .chatbot$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.chatbot$operations$create_slack_channel_configuration <- chatbot_create_slack_channel_configuration

#' Deletes a Amazon Chime webhook configuration for AWS Chatbot
#'
#' @description
#' Deletes a Amazon Chime webhook configuration for AWS Chatbot.
#'
#' See [https://www.paws-r-sdk.com/docs/chatbot_delete_chime_webhook_configuration/](https://www.paws-r-sdk.com/docs/chatbot_delete_chime_webhook_configuration/) for full documentation.
#'
#' @param ChatConfigurationArn &#91;required&#93; The Amazon Resource Name (ARN) of the ChimeWebhookConfiguration to delete.
#'
#' @keywords internal
#'
#' @rdname chatbot_delete_chime_webhook_configuration
chatbot_delete_chime_webhook_configuration <- function(ChatConfigurationArn) {
  op <- new_operation(
    name = "DeleteChimeWebhookConfiguration",
    http_method = "POST",
    http_path = "/delete-chime-webhook-configuration",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .chatbot$delete_chime_webhook_configuration_input(ChatConfigurationArn = ChatConfigurationArn)
  output <- .chatbot$delete_chime_webhook_configuration_output()
  config <- get_config()
  svc <- .chatbot$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.chatbot$operations$delete_chime_webhook_configuration <- chatbot_delete_chime_webhook_configuration

#' Deletes a custom action
#'
#' @description
#' Deletes a custom action.
#'
#' See [https://www.paws-r-sdk.com/docs/chatbot_delete_custom_action/](https://www.paws-r-sdk.com/docs/chatbot_delete_custom_action/) for full documentation.
#'
#' @param CustomActionArn &#91;required&#93; The fully defined ARN of the custom action.
#'
#' @keywords internal
#'
#' @rdname chatbot_delete_custom_action
chatbot_delete_custom_action <- function(CustomActionArn) {
  op <- new_operation(
    name = "DeleteCustomAction",
    http_method = "POST",
    http_path = "/delete-custom-action",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .chatbot$delete_custom_action_input(CustomActionArn = CustomActionArn)
  output <- .chatbot$delete_custom_action_output()
  config <- get_config()
  svc <- .chatbot$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.chatbot$operations$delete_custom_action <- chatbot_delete_custom_action

#' Deletes a Microsoft Teams channel configuration for AWS Chatbot
#'
#' @description
#' Deletes a Microsoft Teams channel configuration for AWS Chatbot
#'
#' See [https://www.paws-r-sdk.com/docs/chatbot_delete_microsoft_teams_channel_configuration/](https://www.paws-r-sdk.com/docs/chatbot_delete_microsoft_teams_channel_configuration/) for full documentation.
#'
#' @param ChatConfigurationArn &#91;required&#93; The Amazon Resource Name (ARN) of the MicrosoftTeamsChannelConfiguration associated with the user identity to delete.
#'
#' @keywords internal
#'
#' @rdname chatbot_delete_microsoft_teams_channel_configuration
chatbot_delete_microsoft_teams_channel_configuration <- function(ChatConfigurationArn) {
  op <- new_operation(
    name = "DeleteMicrosoftTeamsChannelConfiguration",
    http_method = "POST",
    http_path = "/delete-ms-teams-channel-configuration",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .chatbot$delete_microsoft_teams_channel_configuration_input(ChatConfigurationArn = ChatConfigurationArn)
  output <- .chatbot$delete_microsoft_teams_channel_configuration_output()
  config <- get_config()
  svc <- .chatbot$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.chatbot$operations$delete_microsoft_teams_channel_configuration <- chatbot_delete_microsoft_teams_channel_configuration

#' Deletes the Microsoft Teams team authorization allowing for channels to
#' be configured in that Microsoft Teams team
#'
#' @description
#' Deletes the Microsoft Teams team authorization allowing for channels to be configured in that Microsoft Teams team. Note that the Microsoft Teams team must have no channels configured to remove it.
#'
#' See [https://www.paws-r-sdk.com/docs/chatbot_delete_microsoft_teams_configured_team/](https://www.paws-r-sdk.com/docs/chatbot_delete_microsoft_teams_configured_team/) for full documentation.
#'
#' @param TeamId &#91;required&#93; The ID of the Microsoft Teams team authorized with AWS Chatbot.
#' 
#' To get the team ID, you must perform the initial authorization flow with Microsoft Teams in the AWS Chatbot console. Then you can copy and paste the team ID from the console. For more information, see [Step 1: Configure a Microsoft Teams client](https://docs.aws.amazon.com/chatbot/latest/adminguide/teams-setup.html#teams-client-setup) in the *AWS Chatbot Administrator Guide*.
#'
#' @keywords internal
#'
#' @rdname chatbot_delete_microsoft_teams_configured_team
chatbot_delete_microsoft_teams_configured_team <- function(TeamId) {
  op <- new_operation(
    name = "DeleteMicrosoftTeamsConfiguredTeam",
    http_method = "POST",
    http_path = "/delete-ms-teams-configured-teams",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .chatbot$delete_microsoft_teams_configured_team_input(TeamId = TeamId)
  output <- .chatbot$delete_microsoft_teams_configured_team_output()
  config <- get_config()
  svc <- .chatbot$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.chatbot$operations$delete_microsoft_teams_configured_team <- chatbot_delete_microsoft_teams_configured_team

#' Identifes a user level permission for a channel configuration
#'
#' @description
#' Identifes a user level permission for a channel configuration.
#'
#' See [https://www.paws-r-sdk.com/docs/chatbot_delete_microsoft_teams_user_identity/](https://www.paws-r-sdk.com/docs/chatbot_delete_microsoft_teams_user_identity/) for full documentation.
#'
#' @param ChatConfigurationArn &#91;required&#93; The ARN of the MicrosoftTeamsChannelConfiguration associated with the user identity to delete.
#' @param UserId &#91;required&#93; The Microsoft Teams user ID.
#'
#' @keywords internal
#'
#' @rdname chatbot_delete_microsoft_teams_user_identity
chatbot_delete_microsoft_teams_user_identity <- function(ChatConfigurationArn, UserId) {
  op <- new_operation(
    name = "DeleteMicrosoftTeamsUserIdentity",
    http_method = "POST",
    http_path = "/delete-ms-teams-user-identity",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .chatbot$delete_microsoft_teams_user_identity_input(ChatConfigurationArn = ChatConfigurationArn, UserId = UserId)
  output <- .chatbot$delete_microsoft_teams_user_identity_output()
  config <- get_config()
  svc <- .chatbot$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.chatbot$operations$delete_microsoft_teams_user_identity <- chatbot_delete_microsoft_teams_user_identity

#' Deletes a Slack channel configuration for AWS Chatbot
#'
#' @description
#' Deletes a Slack channel configuration for AWS Chatbot
#'
#' See [https://www.paws-r-sdk.com/docs/chatbot_delete_slack_channel_configuration/](https://www.paws-r-sdk.com/docs/chatbot_delete_slack_channel_configuration/) for full documentation.
#'
#' @param ChatConfigurationArn &#91;required&#93; The Amazon Resource Name (ARN) of the SlackChannelConfiguration to delete.
#'
#' @keywords internal
#'
#' @rdname chatbot_delete_slack_channel_configuration
chatbot_delete_slack_channel_configuration <- function(ChatConfigurationArn) {
  op <- new_operation(
    name = "DeleteSlackChannelConfiguration",
    http_method = "POST",
    http_path = "/delete-slack-channel-configuration",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .chatbot$delete_slack_channel_configuration_input(ChatConfigurationArn = ChatConfigurationArn)
  output <- .chatbot$delete_slack_channel_configuration_output()
  config <- get_config()
  svc <- .chatbot$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.chatbot$operations$delete_slack_channel_configuration <- chatbot_delete_slack_channel_configuration

#' Deletes a user level permission for a Slack channel configuration
#'
#' @description
#' Deletes a user level permission for a Slack channel configuration.
#'
#' See [https://www.paws-r-sdk.com/docs/chatbot_delete_slack_user_identity/](https://www.paws-r-sdk.com/docs/chatbot_delete_slack_user_identity/) for full documentation.
#'
#' @param ChatConfigurationArn &#91;required&#93; The ARN of the SlackChannelConfiguration associated with the user identity to delete.
#' @param SlackTeamId &#91;required&#93; The ID of the Slack workspace authorized with AWS Chatbot.
#' @param SlackUserId &#91;required&#93; The ID of the user in Slack
#'
#' @keywords internal
#'
#' @rdname chatbot_delete_slack_user_identity
chatbot_delete_slack_user_identity <- function(ChatConfigurationArn, SlackTeamId, SlackUserId) {
  op <- new_operation(
    name = "DeleteSlackUserIdentity",
    http_method = "POST",
    http_path = "/delete-slack-user-identity",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .chatbot$delete_slack_user_identity_input(ChatConfigurationArn = ChatConfigurationArn, SlackTeamId = SlackTeamId, SlackUserId = SlackUserId)
  output <- .chatbot$delete_slack_user_identity_output()
  config <- get_config()
  svc <- .chatbot$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.chatbot$operations$delete_slack_user_identity <- chatbot_delete_slack_user_identity

#' Deletes the Slack workspace authorization that allows channels to be
#' configured in that workspace
#'
#' @description
#' Deletes the Slack workspace authorization that allows channels to be configured in that workspace. This requires all configured channels in the workspace to be deleted.
#'
#' See [https://www.paws-r-sdk.com/docs/chatbot_delete_slack_workspace_authorization/](https://www.paws-r-sdk.com/docs/chatbot_delete_slack_workspace_authorization/) for full documentation.
#'
#' @param SlackTeamId &#91;required&#93; The ID of the Slack workspace authorized with AWS Chatbot.
#'
#' @keywords internal
#'
#' @rdname chatbot_delete_slack_workspace_authorization
chatbot_delete_slack_workspace_authorization <- function(SlackTeamId) {
  op <- new_operation(
    name = "DeleteSlackWorkspaceAuthorization",
    http_method = "POST",
    http_path = "/delete-slack-workspace-authorization",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .chatbot$delete_slack_workspace_authorization_input(SlackTeamId = SlackTeamId)
  output <- .chatbot$delete_slack_workspace_authorization_output()
  config <- get_config()
  svc <- .chatbot$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.chatbot$operations$delete_slack_workspace_authorization <- chatbot_delete_slack_workspace_authorization

#' Lists Amazon Chime webhook configurations optionally filtered by
#' ChatConfigurationArn
#'
#' @description
#' Lists Amazon Chime webhook configurations optionally filtered by ChatConfigurationArn
#'
#' See [https://www.paws-r-sdk.com/docs/chatbot_describe_chime_webhook_configurations/](https://www.paws-r-sdk.com/docs/chatbot_describe_chime_webhook_configurations/) for full documentation.
#'
#' @param MaxResults The maximum number of results to include in the response. If more results exist than the specified MaxResults value, a token is included in the response so that the remaining results can be retrieved.
#' @param NextToken An optional token returned from a prior request. Use this token for pagination of results from this action. If this parameter is specified, the response includes only results beyond the token, up to the value specified by MaxResults.
#' @param ChatConfigurationArn An optional Amazon Resource Name (ARN) of a ChimeWebhookConfiguration to describe.
#'
#' @keywords internal
#'
#' @rdname chatbot_describe_chime_webhook_configurations
chatbot_describe_chime_webhook_configurations <- function(MaxResults = NULL, NextToken = NULL, ChatConfigurationArn = NULL) {
  op <- new_operation(
    name = "DescribeChimeWebhookConfigurations",
    http_method = "POST",
    http_path = "/describe-chime-webhook-configurations",
    host_prefix = "",
    paginator = list(input_token = "NextToken", output_token = "NextToken", limit_key = "MaxResults", result_key = "WebhookConfigurations"),
    stream_api = FALSE
  )
  input <- .chatbot$describe_chime_webhook_configurations_input(MaxResults = MaxResults, NextToken = NextToken, ChatConfigurationArn = ChatConfigurationArn)
  output <- .chatbot$describe_chime_webhook_configurations_output()
  config <- get_config()
  svc <- .chatbot$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.chatbot$operations$describe_chime_webhook_configurations <- chatbot_describe_chime_webhook_configurations

#' Lists Slack channel configurations optionally filtered by
#' ChatConfigurationArn
#'
#' @description
#' Lists Slack channel configurations optionally filtered by ChatConfigurationArn
#'
#' See [https://www.paws-r-sdk.com/docs/chatbot_describe_slack_channel_configurations/](https://www.paws-r-sdk.com/docs/chatbot_describe_slack_channel_configurations/) for full documentation.
#'
#' @param MaxResults The maximum number of results to include in the response. If more results exist than the specified MaxResults value, a token is included in the response so that the remaining results can be retrieved.
#' @param NextToken An optional token returned from a prior request. Use this token for pagination of results from this action. If this parameter is specified, the response includes only results beyond the token, up to the value specified by MaxResults.
#' @param ChatConfigurationArn An optional Amazon Resource Name (ARN) of a SlackChannelConfiguration to describe.
#'
#' @keywords internal
#'
#' @rdname chatbot_describe_slack_channel_configurations
chatbot_describe_slack_channel_configurations <- function(MaxResults = NULL, NextToken = NULL, ChatConfigurationArn = NULL) {
  op <- new_operation(
    name = "DescribeSlackChannelConfigurations",
    http_method = "POST",
    http_path = "/describe-slack-channel-configurations",
    host_prefix = "",
    paginator = list(input_token = "NextToken", output_token = "NextToken", limit_key = "MaxResults", result_key = "SlackChannelConfigurations"),
    stream_api = FALSE
  )
  input <- .chatbot$describe_slack_channel_configurations_input(MaxResults = MaxResults, NextToken = NextToken, ChatConfigurationArn = ChatConfigurationArn)
  output <- .chatbot$describe_slack_channel_configurations_output()
  config <- get_config()
  svc <- .chatbot$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.chatbot$operations$describe_slack_channel_configurations <- chatbot_describe_slack_channel_configurations

#' Lists all Slack user identities with a mapped role
#'
#' @description
#' Lists all Slack user identities with a mapped role.
#'
#' See [https://www.paws-r-sdk.com/docs/chatbot_describe_slack_user_identities/](https://www.paws-r-sdk.com/docs/chatbot_describe_slack_user_identities/) for full documentation.
#'
#' @param ChatConfigurationArn The Amazon Resource Name (ARN) of the SlackChannelConfiguration associated with the user identities to describe.
#' @param NextToken An optional token returned from a prior request. Use this token for pagination of results from this action. If this parameter is specified, the response includes only results beyond the token, up to the value specified by MaxResults.
#' @param MaxResults The maximum number of results to include in the response. If more results exist than the specified MaxResults value, a token is included in the response so that the remaining results can be retrieved.
#'
#' @keywords internal
#'
#' @rdname chatbot_describe_slack_user_identities
chatbot_describe_slack_user_identities <- function(ChatConfigurationArn = NULL, NextToken = NULL, MaxResults = NULL) {
  op <- new_operation(
    name = "DescribeSlackUserIdentities",
    http_method = "POST",
    http_path = "/describe-slack-user-identities",
    host_prefix = "",
    paginator = list(input_token = "NextToken", output_token = "NextToken", limit_key = "MaxResults", result_key = "SlackUserIdentities"),
    stream_api = FALSE
  )
  input <- .chatbot$describe_slack_user_identities_input(ChatConfigurationArn = ChatConfigurationArn, NextToken = NextToken, MaxResults = MaxResults)
  output <- .chatbot$describe_slack_user_identities_output()
  config <- get_config()
  svc <- .chatbot$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.chatbot$operations$describe_slack_user_identities <- chatbot_describe_slack_user_identities

#' List all authorized Slack workspaces connected to the AWS Account
#' onboarded with AWS Chatbot
#'
#' @description
#' List all authorized Slack workspaces connected to the AWS Account onboarded with AWS Chatbot.
#'
#' See [https://www.paws-r-sdk.com/docs/chatbot_describe_slack_workspaces/](https://www.paws-r-sdk.com/docs/chatbot_describe_slack_workspaces/) for full documentation.
#'
#' @param MaxResults The maximum number of results to include in the response. If more results exist than the specified MaxResults value, a token is included in the response so that the remaining results can be retrieved.
#' @param NextToken An optional token returned from a prior request. Use this token for pagination of results from this action. If this parameter is specified, the response includes only results beyond the token, up to the value specified by MaxResults.
#'
#' @keywords internal
#'
#' @rdname chatbot_describe_slack_workspaces
chatbot_describe_slack_workspaces <- function(MaxResults = NULL, NextToken = NULL) {
  op <- new_operation(
    name = "DescribeSlackWorkspaces",
    http_method = "POST",
    http_path = "/describe-slack-workspaces",
    host_prefix = "",
    paginator = list(input_token = "NextToken", output_token = "NextToken", limit_key = "MaxResults", result_key = "SlackWorkspaces"),
    stream_api = FALSE
  )
  input <- .chatbot$describe_slack_workspaces_input(MaxResults = MaxResults, NextToken = NextToken)
  output <- .chatbot$describe_slack_workspaces_output()
  config <- get_config()
  svc <- .chatbot$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.chatbot$operations$describe_slack_workspaces <- chatbot_describe_slack_workspaces

#' Unlink a resource, for example a custom action, from a channel
#' configuration
#'
#' @description
#' Unlink a resource, for example a custom action, from a channel configuration.
#'
#' See [https://www.paws-r-sdk.com/docs/chatbot_disassociate_from_configuration/](https://www.paws-r-sdk.com/docs/chatbot_disassociate_from_configuration/) for full documentation.
#'
#' @param Resource &#91;required&#93; The resource (for example, a custom action) Amazon Resource Name (ARN) to unlink.
#' @param ChatConfiguration &#91;required&#93; The channel configuration the resource is being disassociated from.
#'
#' @keywords internal
#'
#' @rdname chatbot_disassociate_from_configuration
chatbot_disassociate_from_configuration <- function(Resource, ChatConfiguration) {
  op <- new_operation(
    name = "DisassociateFromConfiguration",
    http_method = "POST",
    http_path = "/disassociate-from-configuration",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .chatbot$disassociate_from_configuration_input(Resource = Resource, ChatConfiguration = ChatConfiguration)
  output <- .chatbot$disassociate_from_configuration_output()
  config <- get_config()
  svc <- .chatbot$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.chatbot$operations$disassociate_from_configuration <- chatbot_disassociate_from_configuration

#' Returns AWS Chatbot account preferences
#'
#' @description
#' Returns AWS Chatbot account preferences.
#'
#' See [https://www.paws-r-sdk.com/docs/chatbot_get_account_preferences/](https://www.paws-r-sdk.com/docs/chatbot_get_account_preferences/) for full documentation.
#'

#'
#' @keywords internal
#'
#' @rdname chatbot_get_account_preferences
chatbot_get_account_preferences <- function() {
  op <- new_operation(
    name = "GetAccountPreferences",
    http_method = "POST",
    http_path = "/get-account-preferences",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .chatbot$get_account_preferences_input()
  output <- .chatbot$get_account_preferences_output()
  config <- get_config()
  svc <- .chatbot$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.chatbot$operations$get_account_preferences <- chatbot_get_account_preferences

#' Returns a custom action
#'
#' @description
#' Returns a custom action.
#'
#' See [https://www.paws-r-sdk.com/docs/chatbot_get_custom_action/](https://www.paws-r-sdk.com/docs/chatbot_get_custom_action/) for full documentation.
#'
#' @param CustomActionArn &#91;required&#93; Returns the fully defined Amazon Resource Name (ARN) of the custom action.
#'
#' @keywords internal
#'
#' @rdname chatbot_get_custom_action
chatbot_get_custom_action <- function(CustomActionArn) {
  op <- new_operation(
    name = "GetCustomAction",
    http_method = "POST",
    http_path = "/get-custom-action",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .chatbot$get_custom_action_input(CustomActionArn = CustomActionArn)
  output <- .chatbot$get_custom_action_output()
  config <- get_config()
  svc <- .chatbot$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.chatbot$operations$get_custom_action <- chatbot_get_custom_action

#' Returns a Microsoft Teams channel configuration in an AWS account
#'
#' @description
#' Returns a Microsoft Teams channel configuration in an AWS account.
#'
#' See [https://www.paws-r-sdk.com/docs/chatbot_get_microsoft_teams_channel_configuration/](https://www.paws-r-sdk.com/docs/chatbot_get_microsoft_teams_channel_configuration/) for full documentation.
#'
#' @param ChatConfigurationArn &#91;required&#93; The Amazon Resource Name (ARN) of the MicrosoftTeamsChannelConfiguration to retrieve.
#'
#' @keywords internal
#'
#' @rdname chatbot_get_microsoft_teams_channel_configuration
chatbot_get_microsoft_teams_channel_configuration <- function(ChatConfigurationArn) {
  op <- new_operation(
    name = "GetMicrosoftTeamsChannelConfiguration",
    http_method = "POST",
    http_path = "/get-ms-teams-channel-configuration",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .chatbot$get_microsoft_teams_channel_configuration_input(ChatConfigurationArn = ChatConfigurationArn)
  output <- .chatbot$get_microsoft_teams_channel_configuration_output()
  config <- get_config()
  svc <- .chatbot$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.chatbot$operations$get_microsoft_teams_channel_configuration <- chatbot_get_microsoft_teams_channel_configuration

#' Lists resources associated with a channel configuration
#'
#' @description
#' Lists resources associated with a channel configuration.
#'
#' See [https://www.paws-r-sdk.com/docs/chatbot_list_associations/](https://www.paws-r-sdk.com/docs/chatbot_list_associations/) for full documentation.
#'
#' @param ChatConfiguration &#91;required&#93; The channel configuration to list associations for.
#' @param MaxResults The maximum number of results to include in the response. If more results exist than the specified MaxResults value, a token is included in the response so that the remaining results can be retrieved.
#' @param NextToken An optional token returned from a prior request. Use this token for pagination of results from this action. If this parameter is specified, the response includes only results beyond the token, up to the value specified by MaxResults.
#'
#' @keywords internal
#'
#' @rdname chatbot_list_associations
chatbot_list_associations <- function(ChatConfiguration, MaxResults = NULL, NextToken = NULL) {
  op <- new_operation(
    name = "ListAssociations",
    http_method = "POST",
    http_path = "/list-associations",
    host_prefix = "",
    paginator = list(input_token = "NextToken", output_token = "NextToken", limit_key = "MaxResults", result_key = "Associations"),
    stream_api = FALSE
  )
  input <- .chatbot$list_associations_input(ChatConfiguration = ChatConfiguration, MaxResults = MaxResults, NextToken = NextToken)
  output <- .chatbot$list_associations_output()
  config <- get_config()
  svc <- .chatbot$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.chatbot$operations$list_associations <- chatbot_list_associations

#' Lists custom actions defined in this account
#'
#' @description
#' Lists custom actions defined in this account.
#'
#' See [https://www.paws-r-sdk.com/docs/chatbot_list_custom_actions/](https://www.paws-r-sdk.com/docs/chatbot_list_custom_actions/) for full documentation.
#'
#' @param MaxResults The maximum number of results to include in the response. If more results exist than the specified MaxResults value, a token is included in the response so that the remaining results can be retrieved.
#' @param NextToken An optional token returned from a prior request. Use this token for pagination of results from this action. If this parameter is specified, the response includes only results beyond the token, up to the value specified by MaxResults.
#'
#' @keywords internal
#'
#' @rdname chatbot_list_custom_actions
chatbot_list_custom_actions <- function(MaxResults = NULL, NextToken = NULL) {
  op <- new_operation(
    name = "ListCustomActions",
    http_method = "POST",
    http_path = "/list-custom-actions",
    host_prefix = "",
    paginator = list(input_token = "NextToken", output_token = "NextToken", limit_key = "MaxResults", result_key = "CustomActions"),
    stream_api = FALSE
  )
  input <- .chatbot$list_custom_actions_input(MaxResults = MaxResults, NextToken = NextToken)
  output <- .chatbot$list_custom_actions_output()
  config <- get_config()
  svc <- .chatbot$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.chatbot$operations$list_custom_actions <- chatbot_list_custom_actions

#' Lists all AWS Chatbot Microsoft Teams channel configurations in an AWS
#' account
#'
#' @description
#' Lists all AWS Chatbot Microsoft Teams channel configurations in an AWS account.
#'
#' See [https://www.paws-r-sdk.com/docs/chatbot_list_microsoft_teams_channel_configurations/](https://www.paws-r-sdk.com/docs/chatbot_list_microsoft_teams_channel_configurations/) for full documentation.
#'
#' @param MaxResults The maximum number of results to include in the response. If more results exist than the specified MaxResults value, a token is included in the response so that the remaining results can be retrieved.
#' @param NextToken An optional token returned from a prior request. Use this token for pagination of results from this action. If this parameter is specified, the response includes only results beyond the token, up to the value specified by MaxResults.
#' @param TeamId The ID of the Microsoft Teams authorized with AWS Chatbot.
#' 
#' To get the team ID, you must perform the initial authorization flow with Microsoft Teams in the AWS Chatbot console. Then you can copy and paste the team ID from the console. For more information, see [Step 1: Configure a Microsoft Teams client](https://docs.aws.amazon.com/chatbot/latest/adminguide/teams-setup.html#teams-client-setup) in the *AWS Chatbot Administrator Guide*.
#'
#' @keywords internal
#'
#' @rdname chatbot_list_microsoft_teams_channel_configurations
chatbot_list_microsoft_teams_channel_configurations <- function(MaxResults = NULL, NextToken = NULL, TeamId = NULL) {
  op <- new_operation(
    name = "ListMicrosoftTeamsChannelConfigurations",
    http_method = "POST",
    http_path = "/list-ms-teams-channel-configurations",
    host_prefix = "",
    paginator = list(input_token = "NextToken", output_token = "NextToken", limit_key = "MaxResults", result_key = "TeamChannelConfigurations"),
    stream_api = FALSE
  )
  input <- .chatbot$list_microsoft_teams_channel_configurations_input(MaxResults = MaxResults, NextToken = NextToken, TeamId = TeamId)
  output <- .chatbot$list_microsoft_teams_channel_configurations_output()
  config <- get_config()
  svc <- .chatbot$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.chatbot$operations$list_microsoft_teams_channel_configurations <- chatbot_list_microsoft_teams_channel_configurations

#' Lists all authorized Microsoft Teams for an AWS Account
#'
#' @description
#' Lists all authorized Microsoft Teams for an AWS Account
#'
#' See [https://www.paws-r-sdk.com/docs/chatbot_list_microsoft_teams_configured_teams/](https://www.paws-r-sdk.com/docs/chatbot_list_microsoft_teams_configured_teams/) for full documentation.
#'
#' @param MaxResults The maximum number of results to include in the response. If more results exist than the specified MaxResults value, a token is included in the response so that the remaining results can be retrieved.
#' @param NextToken An optional token returned from a prior request. Use this token for pagination of results from this action. If this parameter is specified, the response includes only results beyond the token, up to the value specified by MaxResults.
#'
#' @keywords internal
#'
#' @rdname chatbot_list_microsoft_teams_configured_teams
chatbot_list_microsoft_teams_configured_teams <- function(MaxResults = NULL, NextToken = NULL) {
  op <- new_operation(
    name = "ListMicrosoftTeamsConfiguredTeams",
    http_method = "POST",
    http_path = "/list-ms-teams-configured-teams",
    host_prefix = "",
    paginator = list(input_token = "NextToken", output_token = "NextToken", limit_key = "MaxResults", result_key = "ConfiguredTeams"),
    stream_api = FALSE
  )
  input <- .chatbot$list_microsoft_teams_configured_teams_input(MaxResults = MaxResults, NextToken = NextToken)
  output <- .chatbot$list_microsoft_teams_configured_teams_output()
  config <- get_config()
  svc <- .chatbot$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.chatbot$operations$list_microsoft_teams_configured_teams <- chatbot_list_microsoft_teams_configured_teams

#' A list all Microsoft Teams user identities with a mapped role
#'
#' @description
#' A list all Microsoft Teams user identities with a mapped role.
#'
#' See [https://www.paws-r-sdk.com/docs/chatbot_list_microsoft_teams_user_identities/](https://www.paws-r-sdk.com/docs/chatbot_list_microsoft_teams_user_identities/) for full documentation.
#'
#' @param ChatConfigurationArn The Amazon Resource Name (ARN) of the MicrosoftTeamsChannelConfiguration associated with the user identities to list.
#' @param NextToken An optional token returned from a prior request. Use this token for pagination of results from this action. If this parameter is specified, the response includes only results beyond the token, up to the value specified by MaxResults.
#' @param MaxResults The maximum number of results to include in the response. If more results exist than the specified MaxResults value, a token is included in the response so that the remaining results can be retrieved.
#'
#' @keywords internal
#'
#' @rdname chatbot_list_microsoft_teams_user_identities
chatbot_list_microsoft_teams_user_identities <- function(ChatConfigurationArn = NULL, NextToken = NULL, MaxResults = NULL) {
  op <- new_operation(
    name = "ListMicrosoftTeamsUserIdentities",
    http_method = "POST",
    http_path = "/list-ms-teams-user-identities",
    host_prefix = "",
    paginator = list(input_token = "NextToken", output_token = "NextToken", limit_key = "MaxResults", result_key = "TeamsUserIdentities"),
    stream_api = FALSE
  )
  input <- .chatbot$list_microsoft_teams_user_identities_input(ChatConfigurationArn = ChatConfigurationArn, NextToken = NextToken, MaxResults = MaxResults)
  output <- .chatbot$list_microsoft_teams_user_identities_output()
  config <- get_config()
  svc <- .chatbot$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.chatbot$operations$list_microsoft_teams_user_identities <- chatbot_list_microsoft_teams_user_identities

#' Lists all of the tags associated with the Amazon Resource Name (ARN)
#' that you specify
#'
#' @description
#' Lists all of the tags associated with the Amazon Resource Name (ARN) that you specify. The resource can be a user, server, or role.
#'
#' See [https://www.paws-r-sdk.com/docs/chatbot_list_tags_for_resource/](https://www.paws-r-sdk.com/docs/chatbot_list_tags_for_resource/) for full documentation.
#'
#' @param ResourceARN &#91;required&#93; The ARN of the resource to list tags for.
#'
#' @keywords internal
#'
#' @rdname chatbot_list_tags_for_resource
chatbot_list_tags_for_resource <- function(ResourceARN) {
  op <- new_operation(
    name = "ListTagsForResource",
    http_method = "POST",
    http_path = "/list-tags-for-resource",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .chatbot$list_tags_for_resource_input(ResourceARN = ResourceARN)
  output <- .chatbot$list_tags_for_resource_output()
  config <- get_config()
  svc <- .chatbot$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.chatbot$operations$list_tags_for_resource <- chatbot_list_tags_for_resource

#' Attaches a key-value pair to a resource, as identified by its Amazon
#' Resource Name (ARN)
#'
#' @description
#' Attaches a key-value pair to a resource, as identified by its Amazon Resource Name (ARN). Resources are users, servers, roles, and other entities.
#'
#' See [https://www.paws-r-sdk.com/docs/chatbot_tag_resource/](https://www.paws-r-sdk.com/docs/chatbot_tag_resource/) for full documentation.
#'
#' @param ResourceARN &#91;required&#93; The ARN of the configuration.
#' @param Tags &#91;required&#93; A list of tags to apply to the configuration.
#'
#' @keywords internal
#'
#' @rdname chatbot_tag_resource
chatbot_tag_resource <- function(ResourceARN, Tags) {
  op <- new_operation(
    name = "TagResource",
    http_method = "POST",
    http_path = "/tag-resource",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .chatbot$tag_resource_input(ResourceARN = ResourceARN, Tags = Tags)
  output <- .chatbot$tag_resource_output()
  config <- get_config()
  svc <- .chatbot$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.chatbot$operations$tag_resource <- chatbot_tag_resource

#' Detaches a key-value pair from a resource, as identified by its Amazon
#' Resource Name (ARN)
#'
#' @description
#' Detaches a key-value pair from a resource, as identified by its Amazon Resource Name (ARN). Resources are users, servers, roles, and other entities.
#'
#' See [https://www.paws-r-sdk.com/docs/chatbot_untag_resource/](https://www.paws-r-sdk.com/docs/chatbot_untag_resource/) for full documentation.
#'
#' @param ResourceARN &#91;required&#93; The value of the resource that will have the tag removed. An Amazon Resource Name (ARN) is an identifier for a specific AWS resource, such as a server, user, or role.
#' @param TagKeys &#91;required&#93; TagKeys are key-value pairs assigned to ARNs that can be used to group and search for resources by type. This metadata can be attached to resources for any purpose.
#'
#' @keywords internal
#'
#' @rdname chatbot_untag_resource
chatbot_untag_resource <- function(ResourceARN, TagKeys) {
  op <- new_operation(
    name = "UntagResource",
    http_method = "POST",
    http_path = "/untag-resource",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .chatbot$untag_resource_input(ResourceARN = ResourceARN, TagKeys = TagKeys)
  output <- .chatbot$untag_resource_output()
  config <- get_config()
  svc <- .chatbot$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.chatbot$operations$untag_resource <- chatbot_untag_resource

#' Updates AWS Chatbot account preferences
#'
#' @description
#' Updates AWS Chatbot account preferences.
#'
#' See [https://www.paws-r-sdk.com/docs/chatbot_update_account_preferences/](https://www.paws-r-sdk.com/docs/chatbot_update_account_preferences/) for full documentation.
#'
#' @param UserAuthorizationRequired Enables use of a user role requirement in your chat configuration.
#' @param TrainingDataCollectionEnabled Turns on training data collection.
#' 
#' This helps improve the AWS Chatbot experience by allowing AWS Chatbot to store and use your customer information, such as AWS Chatbot configurations, notifications, user inputs, AWS Chatbot generated responses, and interaction data. This data helps us to continuously improve and develop Artificial Intelligence (AI) technologies. Your data is not shared with any third parties and is protected using sophisticated controls to prevent unauthorized access and misuse. AWS Chatbot does not store or use interactions in chat channels with Amazon Q for training AI technologies for AWS Chatbot.
#'
#' @keywords internal
#'
#' @rdname chatbot_update_account_preferences
chatbot_update_account_preferences <- function(UserAuthorizationRequired = NULL, TrainingDataCollectionEnabled = NULL) {
  op <- new_operation(
    name = "UpdateAccountPreferences",
    http_method = "POST",
    http_path = "/update-account-preferences",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .chatbot$update_account_preferences_input(UserAuthorizationRequired = UserAuthorizationRequired, TrainingDataCollectionEnabled = TrainingDataCollectionEnabled)
  output <- .chatbot$update_account_preferences_output()
  config <- get_config()
  svc <- .chatbot$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.chatbot$operations$update_account_preferences <- chatbot_update_account_preferences

#' Updates a Amazon Chime webhook configuration
#'
#' @description
#' Updates a Amazon Chime webhook configuration.
#'
#' See [https://www.paws-r-sdk.com/docs/chatbot_update_chime_webhook_configuration/](https://www.paws-r-sdk.com/docs/chatbot_update_chime_webhook_configuration/) for full documentation.
#'
#' @param ChatConfigurationArn &#91;required&#93; The Amazon Resource Name (ARN) of the ChimeWebhookConfiguration to update.
#' @param WebhookDescription A description of the webhook. We recommend using the convention `RoomName/WebhookName`.
#' 
#' For more information, see [Tutorial: Get started with Amazon Chime](https://docs.aws.amazon.com/chatbot/latest/adminguide/chime-setup.html) in the *AWS Chatbot Administrator Guide*.
#' @param WebhookUrl The URL for the Amazon Chime webhook.
#' @param SnsTopicArns The ARNs of the SNS topics that deliver notifications to AWS Chatbot.
#' @param IamRoleArn A user-defined role that AWS Chatbot assumes. This is not the service-linked role.
#' 
#' For more information, see [IAM policies for AWS Chatbot](https://docs.aws.amazon.com/chatbot/latest/adminguide/chatbot-iam-policies.html) in the *AWS Chatbot Administrator Guide*.
#' @param LoggingLevel Logging levels include `ERROR`, `INFO`, or `NONE`.
#'
#' @keywords internal
#'
#' @rdname chatbot_update_chime_webhook_configuration
chatbot_update_chime_webhook_configuration <- function(ChatConfigurationArn, WebhookDescription = NULL, WebhookUrl = NULL, SnsTopicArns = NULL, IamRoleArn = NULL, LoggingLevel = NULL) {
  op <- new_operation(
    name = "UpdateChimeWebhookConfiguration",
    http_method = "POST",
    http_path = "/update-chime-webhook-configuration",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .chatbot$update_chime_webhook_configuration_input(ChatConfigurationArn = ChatConfigurationArn, WebhookDescription = WebhookDescription, WebhookUrl = WebhookUrl, SnsTopicArns = SnsTopicArns, IamRoleArn = IamRoleArn, LoggingLevel = LoggingLevel)
  output <- .chatbot$update_chime_webhook_configuration_output()
  config <- get_config()
  svc <- .chatbot$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.chatbot$operations$update_chime_webhook_configuration <- chatbot_update_chime_webhook_configuration

#' Updates a custom action
#'
#' @description
#' Updates a custom action.
#'
#' See [https://www.paws-r-sdk.com/docs/chatbot_update_custom_action/](https://www.paws-r-sdk.com/docs/chatbot_update_custom_action/) for full documentation.
#'
#' @param CustomActionArn &#91;required&#93; The fully defined Amazon Resource Name (ARN) of the custom action.
#' @param Definition &#91;required&#93; The definition of the command to run when invoked as an alias or as an action button.
#' @param AliasName The name used to invoke this action in the chat channel. For example, `@@aws run my-alias`.
#' @param Attachments Defines when this custom action button should be attached to a notification.
#'
#' @keywords internal
#'
#' @rdname chatbot_update_custom_action
chatbot_update_custom_action <- function(CustomActionArn, Definition, AliasName = NULL, Attachments = NULL) {
  op <- new_operation(
    name = "UpdateCustomAction",
    http_method = "POST",
    http_path = "/update-custom-action",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .chatbot$update_custom_action_input(CustomActionArn = CustomActionArn, Definition = Definition, AliasName = AliasName, Attachments = Attachments)
  output <- .chatbot$update_custom_action_output()
  config <- get_config()
  svc <- .chatbot$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.chatbot$operations$update_custom_action <- chatbot_update_custom_action

#' Updates an Microsoft Teams channel configuration
#'
#' @description
#' Updates an Microsoft Teams channel configuration.
#'
#' See [https://www.paws-r-sdk.com/docs/chatbot_update_microsoft_teams_channel_configuration/](https://www.paws-r-sdk.com/docs/chatbot_update_microsoft_teams_channel_configuration/) for full documentation.
#'
#' @param ChatConfigurationArn &#91;required&#93; The Amazon Resource Name (ARN) of the TeamsChannelConfiguration to update.
#' @param ChannelId &#91;required&#93; The ID of the Microsoft Teams channel.
#' @param ChannelName The name of the Microsoft Teams channel.
#' @param SnsTopicArns The Amazon Resource Names (ARNs) of the SNS topics that deliver notifications to AWS Chatbot.
#' @param IamRoleArn A user-defined role that AWS Chatbot assumes. This is not the service-linked role.
#' 
#' For more information, see [IAM policies for AWS Chatbot](https://docs.aws.amazon.com/chatbot/latest/adminguide/chatbot-iam-policies.html) in the *AWS Chatbot Administrator Guide*.
#' @param LoggingLevel Logging levels include `ERROR`, `INFO`, or `NONE`.
#' @param GuardrailPolicyArns The list of IAM policy ARNs that are applied as channel guardrails. The AWS managed `AdministratorAccess` policy is applied by default if this is not set.
#' @param UserAuthorizationRequired Enables use of a user role requirement in your chat configuration.
#'
#' @keywords internal
#'
#' @rdname chatbot_update_microsoft_teams_channel_configuration
chatbot_update_microsoft_teams_channel_configuration <- function(ChatConfigurationArn, ChannelId, ChannelName = NULL, SnsTopicArns = NULL, IamRoleArn = NULL, LoggingLevel = NULL, GuardrailPolicyArns = NULL, UserAuthorizationRequired = NULL) {
  op <- new_operation(
    name = "UpdateMicrosoftTeamsChannelConfiguration",
    http_method = "POST",
    http_path = "/update-ms-teams-channel-configuration",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .chatbot$update_microsoft_teams_channel_configuration_input(ChatConfigurationArn = ChatConfigurationArn, ChannelId = ChannelId, ChannelName = ChannelName, SnsTopicArns = SnsTopicArns, IamRoleArn = IamRoleArn, LoggingLevel = LoggingLevel, GuardrailPolicyArns = GuardrailPolicyArns, UserAuthorizationRequired = UserAuthorizationRequired)
  output <- .chatbot$update_microsoft_teams_channel_configuration_output()
  config <- get_config()
  svc <- .chatbot$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.chatbot$operations$update_microsoft_teams_channel_configuration <- chatbot_update_microsoft_teams_channel_configuration

#' Updates a Slack channel configuration
#'
#' @description
#' Updates a Slack channel configuration.
#'
#' See [https://www.paws-r-sdk.com/docs/chatbot_update_slack_channel_configuration/](https://www.paws-r-sdk.com/docs/chatbot_update_slack_channel_configuration/) for full documentation.
#'
#' @param ChatConfigurationArn &#91;required&#93; The Amazon Resource Name (ARN) of the SlackChannelConfiguration to update.
#' @param SlackChannelId &#91;required&#93; The ID of the Slack channel.
#' 
#' To get this ID, open Slack, right click on the channel name in the left pane, then choose Copy Link. The channel ID is the 9-character string at the end of the URL. For example, ABCBBLZZZ.
#' @param SlackChannelName The name of the Slack channel.
#' @param SnsTopicArns The Amazon Resource Names (ARNs) of the SNS topics that deliver notifications to AWS Chatbot.
#' @param IamRoleArn A user-defined role that AWS Chatbot assumes. This is not the service-linked role.
#' 
#' For more information, see [IAM policies for AWS Chatbot](https://docs.aws.amazon.com/chatbot/latest/adminguide/chatbot-iam-policies.html) in the *AWS Chatbot Administrator Guide*.
#' @param LoggingLevel Logging levels include `ERROR`, `INFO`, or `NONE`.
#' @param GuardrailPolicyArns The list of IAM policy ARNs that are applied as channel guardrails. The AWS managed `AdministratorAccess` policy is applied by default if this is not set.
#' @param UserAuthorizationRequired Enables use of a user role requirement in your chat configuration.
#'
#' @keywords internal
#'
#' @rdname chatbot_update_slack_channel_configuration
chatbot_update_slack_channel_configuration <- function(ChatConfigurationArn, SlackChannelId, SlackChannelName = NULL, SnsTopicArns = NULL, IamRoleArn = NULL, LoggingLevel = NULL, GuardrailPolicyArns = NULL, UserAuthorizationRequired = NULL) {
  op <- new_operation(
    name = "UpdateSlackChannelConfiguration",
    http_method = "POST",
    http_path = "/update-slack-channel-configuration",
    host_prefix = "",
    paginator = list(),
    stream_api = FALSE
  )
  input <- .chatbot$update_slack_channel_configuration_input(ChatConfigurationArn = ChatConfigurationArn, SlackChannelId = SlackChannelId, SlackChannelName = SlackChannelName, SnsTopicArns = SnsTopicArns, IamRoleArn = IamRoleArn, LoggingLevel = LoggingLevel, GuardrailPolicyArns = GuardrailPolicyArns, UserAuthorizationRequired = UserAuthorizationRequired)
  output <- .chatbot$update_slack_channel_configuration_output()
  config <- get_config()
  svc <- .chatbot$service(config, op)
  request <- new_request(svc, op, input, output)
  response <- send_request(request)
  return(response)
}
.chatbot$operations$update_slack_channel_configuration <- chatbot_update_slack_channel_configuration

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_delete_mobile_device_access_rule}
\alias{workmail_delete_mobile_device_access_rule}
\title{Deletes a mobile device access rule for the specified WorkMail
organization}
\usage{
workmail_delete_mobile_device_access_rule(
  OrganizationId,
  MobileDeviceAccessRuleId
)
}
\arguments{
\item{OrganizationId}{[required] The WorkMail organization under which the rule will be deleted.}

\item{MobileDeviceAccessRuleId}{[required] The identifier of the rule to be deleted.}
}
\description{
Deletes a mobile device access rule for the specified WorkMail organization.

See \url{https://www.paws-r-sdk.com/docs/workmail_delete_mobile_device_access_rule/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/appstream_operations.R
\name{appstream_delete_image_permissions}
\alias{appstream_delete_image_permissions}
\title{Deletes permissions for the specified private image}
\usage{
appstream_delete_image_permissions(Name, SharedAccountId)
}
\arguments{
\item{Name}{[required] The name of the private image.}

\item{SharedAccountId}{[required] The 12-digit identifier of the AWS account for which to delete image permissions.}
}
\description{
Deletes permissions for the specified private image. After you delete permissions for an image, AWS accounts to which you previously granted these permissions can no longer use the image.

See \url{https://www.paws-r-sdk.com/docs/appstream_delete_image_permissions/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_delete_organization}
\alias{workmail_delete_organization}
\title{Deletes an WorkMail organization and all underlying AWS resources
managed by WorkMail as part of the organization}
\usage{
workmail_delete_organization(
  ClientToken = NULL,
  OrganizationId,
  DeleteDirectory,
  ForceDelete = NULL,
  DeleteIdentityCenterApplication = NULL
)
}
\arguments{
\item{ClientToken}{The idempotency token associated with the request.}

\item{OrganizationId}{[required] The organization ID.}

\item{DeleteDirectory}{[required] If true, deletes the AWS Directory Service directory associated with the organization.}

\item{ForceDelete}{Deletes a WorkMail organization even if the organization has enabled users.}

\item{DeleteIdentityCenterApplication}{Deletes IAM Identity Center application for WorkMail. This action does not affect authentication settings for any organization.}
}
\description{
Deletes an WorkMail organization and all underlying AWS resources managed by WorkMail as part of the organization. You can choose whether to delete the associated directory. For more information, see \href{https://docs.aws.amazon.com/workmail/latest/adminguide/delete_organization.html}{Removing an organization} in the \emph{WorkMail Administrator Guide}.

See \url{https://www.paws-r-sdk.com/docs/workmail_delete_organization/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workdocs_operations.R
\name{workdocs_get_resources}
\alias{workdocs_get_resources}
\title{Retrieves a collection of resources, including folders and documents}
\usage{
workdocs_get_resources(
  AuthenticationToken = NULL,
  UserId = NULL,
  CollectionType = NULL,
  Limit = NULL,
  Marker = NULL
)
}
\arguments{
\item{AuthenticationToken}{The Amazon WorkDocs authentication token. Not required when using Amazon Web Services administrator credentials to access the API.}

\item{UserId}{The user ID for the resource collection. This is a required field for accessing the API operation using IAM credentials.}

\item{CollectionType}{The collection type.}

\item{Limit}{The maximum number of resources to return.}

\item{Marker}{The marker for the next set of results. This marker was received from a previous call.}
}
\description{
Retrieves a collection of resources, including folders and documents. The only \code{CollectionType} supported is \code{SHARED_WITH_ME}.

See \url{https://www.paws-r-sdk.com/docs/workdocs_get_resources/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/appstream_operations.R
\name{appstream_update_stack}
\alias{appstream_update_stack}
\title{Updates the specified fields for the specified stack}
\usage{
appstream_update_stack(
  DisplayName = NULL,
  Description = NULL,
  Name,
  StorageConnectors = NULL,
  DeleteStorageConnectors = NULL,
  RedirectURL = NULL,
  FeedbackURL = NULL,
  AttributesToDelete = NULL,
  UserSettings = NULL,
  ApplicationSettings = NULL,
  AccessEndpoints = NULL,
  EmbedHostDomains = NULL,
  StreamingExperienceSettings = NULL,
  ContentRedirection = NULL,
  AgentAccessConfig = NULL
)
}
\arguments{
\item{DisplayName}{The stack name to display.}

\item{Description}{The description to display.}

\item{Name}{[required] The name of the stack.}

\item{StorageConnectors}{The storage connectors to enable.}

\item{DeleteStorageConnectors}{Deletes the storage connectors currently enabled for the stack.}

\item{RedirectURL}{The URL that users are redirected to after their streaming session ends.}

\item{FeedbackURL}{The URL that users are redirected to after they choose the Send Feedback link. If no URL is specified, no Send Feedback link is displayed.}

\item{AttributesToDelete}{The stack attributes to delete.}

\item{UserSettings}{The actions that are enabled or disabled for users during their streaming sessions. By default, these actions are enabled.}

\item{ApplicationSettings}{The persistent application settings for users of a stack. When these settings are enabled, changes that users make to applications and Windows settings are automatically saved after each session and applied to the next session.}

\item{AccessEndpoints}{The list of interface VPC endpoint (interface endpoint) objects. Users of the stack can connect to WorkSpaces Applications only through the specified endpoints.}

\item{EmbedHostDomains}{The domains where WorkSpaces Applications streaming sessions can be embedded in an iframe. You must approve the domains that you want to host embedded WorkSpaces Applications streaming sessions.}

\item{StreamingExperienceSettings}{The streaming protocol you want your stack to prefer. This can be UDP or TCP. Currently, UDP is only supported in the Windows native client.}

\item{ContentRedirection}{Configuration for bidirectional URL redirection between the streaming session and the local client. Use HostToClient to redirect URLs from the remote desktop to the local browser.}

\item{AgentAccessConfig}{The configuration for agent access on the stack. Specify this to update agent access settings. To remove agent access, use AttributesToDelete with the AGENT_ACCESS_CONFIG value.}
}
\description{
Updates the specified fields for the specified stack.

See \url{https://www.paws-r-sdk.com/docs/appstream_update_stack/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_delete_personal_access_token}
\alias{workmail_delete_personal_access_token}
\title{Deletes the Personal Access Token from the provided WorkMail
Organization}
\usage{
workmail_delete_personal_access_token(OrganizationId, PersonalAccessTokenId)
}
\arguments{
\item{OrganizationId}{[required] The Organization ID.}

\item{PersonalAccessTokenId}{[required] The Personal Access Token ID.}
}
\description{
Deletes the Personal Access Token from the provided WorkMail Organization.

See \url{https://www.paws-r-sdk.com/docs/workmail_delete_personal_access_token/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspaces_operations.R
\name{workspaces_describe_client_branding}
\alias{workspaces_describe_client_branding}
\title{Describes the specified client branding}
\usage{
workspaces_describe_client_branding(ResourceId)
}
\arguments{
\item{ResourceId}{[required] The directory identifier of the WorkSpace for which you want to view client branding information.}
}
\description{
Describes the specified client branding. Client branding allows you to customize the log in page of various device types for your users. You can add your company logo, the support email address, support link, link to reset password, and a custom message for users trying to sign in.

See \url{https://www.paws-r-sdk.com/docs/workspaces_describe_client_branding/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspaces_operations.R
\name{workspaces_describe_workspaces_pool_sessions}
\alias{workspaces_describe_workspaces_pool_sessions}
\title{Retrieves a list that describes the streaming sessions for a specified
pool}
\usage{
workspaces_describe_workspaces_pool_sessions(
  PoolId,
  UserId = NULL,
  Limit = NULL,
  NextToken = NULL
)
}
\arguments{
\item{PoolId}{[required] The identifier of the pool.}

\item{UserId}{The identifier of the user.}

\item{Limit}{The maximum size of each page of results. The default value is 20 and the maximum value is 50.}

\item{NextToken}{If you received a \code{NextToken} from a previous call that was paginated, provide this token to receive the next set of results.}
}
\description{
Retrieves a list that describes the streaming sessions for a specified pool.

See \url{https://www.paws-r-sdk.com/docs/workspaces_describe_workspaces_pool_sessions/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspaces_operations.R
\name{workspaces_delete_workspace_bundle}
\alias{workspaces_delete_workspace_bundle}
\title{Deletes the specified WorkSpace bundle}
\usage{
workspaces_delete_workspace_bundle(BundleId = NULL)
}
\arguments{
\item{BundleId}{The identifier of the bundle.}
}
\description{
Deletes the specified WorkSpace bundle. For more information about deleting WorkSpace bundles, see \href{https://docs.aws.amazon.com/workspaces/latest/adminguide/delete_bundle.html}{Delete a Custom WorkSpaces Bundle or Image}.

See \url{https://www.paws-r-sdk.com/docs/workspaces_delete_workspace_bundle/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_update_mailbox_quota}
\alias{workmail_update_mailbox_quota}
\title{Updates a user's current mailbox quota for a specified organization and
user}
\usage{
workmail_update_mailbox_quota(OrganizationId, UserId, MailboxQuota)
}
\arguments{
\item{OrganizationId}{[required] The identifier for the organization that contains the user for whom to update the mailbox quota.}

\item{UserId}{[required] The identifer for the user for whom to update the mailbox quota.

The identifier can be the \emph{UserId}, \emph{Username}, or \emph{email}. The following identity formats are available:
\itemize{
\item User ID: 12345678-1234-1234-1234-123456789012 or S-1-1-12-1234567890-123456789-123456789-1234
\item Email address: user@domain.tld
\item User name: user
}}

\item{MailboxQuota}{[required] The updated mailbox quota, in MB, for the specified user.}
}
\description{
Updates a user's current mailbox quota for a specified organization and user.

See \url{https://www.paws-r-sdk.com/docs/workmail_update_mailbox_quota/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspaces_operations.R
\name{workspaces_modify_workspace_access_properties}
\alias{workspaces_modify_workspace_access_properties}
\title{Specifies which devices and operating systems users can use to access
their WorkSpaces}
\usage{
workspaces_modify_workspace_access_properties(
  ResourceId,
  WorkspaceAccessProperties
)
}
\arguments{
\item{ResourceId}{[required] The identifier of the directory.}

\item{WorkspaceAccessProperties}{[required] The device types and operating systems to enable or disable for access.}
}
\description{
Specifies which devices and operating systems users can use to access their WorkSpaces. For more information, see \href{https://docs.aws.amazon.com/workspaces/latest/adminguide/#control-device-access}{Control Device Access}.

See \url{https://www.paws-r-sdk.com/docs/workspaces_modify_workspace_access_properties/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_get_default_retention_policy}
\alias{workmail_get_default_retention_policy}
\title{Gets the default retention policy details for the specified organization}
\usage{
workmail_get_default_retention_policy(OrganizationId)
}
\arguments{
\item{OrganizationId}{[required] The organization ID.}
}
\description{
Gets the default retention policy details for the specified organization.

See \url{https://www.paws-r-sdk.com/docs/workmail_get_default_retention_policy/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/appstream_operations.R
\name{appstream_stop_app_block_builder}
\alias{appstream_stop_app_block_builder}
\title{Stops an app block builder}
\usage{
appstream_stop_app_block_builder(Name)
}
\arguments{
\item{Name}{[required] The name of the app block builder.}
}
\description{
Stops an app block builder.

See \url{https://www.paws-r-sdk.com/docs/appstream_stop_app_block_builder/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspaces_operations.R
\name{workspaces_describe_workspace_image_permissions}
\alias{workspaces_describe_workspace_image_permissions}
\title{Describes the permissions that the owner of an image has granted to
other Amazon Web Services accounts for an image}
\usage{
workspaces_describe_workspace_image_permissions(
  ImageId,
  NextToken = NULL,
  MaxResults = NULL
)
}
\arguments{
\item{ImageId}{[required] The identifier of the image.}

\item{NextToken}{If you received a \code{NextToken} from a previous call that was paginated, provide this token to receive the next set of results.}

\item{MaxResults}{The maximum number of items to return.}
}
\description{
Describes the permissions that the owner of an image has granted to other Amazon Web Services accounts for an image.

See \url{https://www.paws-r-sdk.com/docs/workspaces_describe_workspace_image_permissions/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_untag_resource}
\alias{workmail_untag_resource}
\title{Untags the specified tags from the specified WorkMail organization
resource}
\usage{
workmail_untag_resource(ResourceARN, TagKeys)
}
\arguments{
\item{ResourceARN}{[required] The resource ARN.}

\item{TagKeys}{[required] The tag keys.}
}
\description{
Untags the specified tags from the specified WorkMail organization resource.

See \url{https://www.paws-r-sdk.com/docs/workmail_untag_resource/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_update_default_mail_domain}
\alias{workmail_update_default_mail_domain}
\title{Updates the default mail domain for an organization}
\usage{
workmail_update_default_mail_domain(OrganizationId, DomainName)
}
\arguments{
\item{OrganizationId}{[required] The WorkMail organization for which to list domains.}

\item{DomainName}{[required] The domain name that will become the default domain.}
}
\description{
Updates the default mail domain for an organization. The default mail domain is used by the WorkMail AWS Console to suggest an email address when enabling a mail user. You can only have one default domain.

See \url{https://www.paws-r-sdk.com/docs/workmail_update_default_mail_domain/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workdocs_operations.R
\name{workdocs_abort_document_version_upload}
\alias{workdocs_abort_document_version_upload}
\title{Aborts the upload of the specified document version that was previously
initiated by InitiateDocumentVersionUpload}
\usage{
workdocs_abort_document_version_upload(
  AuthenticationToken = NULL,
  DocumentId,
  VersionId
)
}
\arguments{
\item{AuthenticationToken}{Amazon WorkDocs authentication token. Not required when using Amazon Web Services administrator credentials to access the API.}

\item{DocumentId}{[required] The ID of the document.}

\item{VersionId}{[required] The ID of the version.}
}
\description{
Aborts the upload of the specified document version that was previously initiated by \code{\link[=workdocs_initiate_document_version_upload]{initiate_document_version_upload}}. The client should make this call only when it no longer intends to upload the document version, or fails to do so.

See \url{https://www.paws-r-sdk.com/docs/workdocs_abort_document_version_upload/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workdocs_operations.R
\name{workdocs_get_document_version}
\alias{workdocs_get_document_version}
\title{Retrieves version metadata for the specified document}
\usage{
workdocs_get_document_version(
  AuthenticationToken = NULL,
  DocumentId,
  VersionId,
  Fields = NULL,
  IncludeCustomMetadata = NULL
)
}
\arguments{
\item{AuthenticationToken}{Amazon WorkDocs authentication token. Not required when using Amazon Web Services administrator credentials to access the API.}

\item{DocumentId}{[required] The ID of the document.}

\item{VersionId}{[required] The version ID of the document.}

\item{Fields}{A comma-separated list of values. Specify "SOURCE" to include a URL for the source document.}

\item{IncludeCustomMetadata}{Set this to TRUE to include custom metadata in the response.}
}
\description{
Retrieves version metadata for the specified document.

See \url{https://www.paws-r-sdk.com/docs/workdocs_get_document_version/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_update_primary_email_address}
\alias{workmail_update_primary_email_address}
\title{Updates the primary email for a user, group, or resource}
\usage{
workmail_update_primary_email_address(OrganizationId, EntityId, Email)
}
\arguments{
\item{OrganizationId}{[required] The organization that contains the user, group, or resource to update.}

\item{EntityId}{[required] The user, group, or resource to update.

The identifier can accept \emph{UseriD, ResourceId, or GroupId}, \emph{Username, Resourcename, or Groupname}, or \emph{email}. The following identity formats are available:
\itemize{
\item Entity ID: 12345678-1234-1234-1234-123456789012, r-0123456789a0123456789b0123456789, or S-1-1-12-1234567890-123456789-123456789-1234
\item Email address: entity@domain.tld
\item Entity name: entity
}}

\item{Email}{[required] The value of the email to be updated as primary.}
}
\description{
Updates the primary email for a user, group, or resource. The current email is moved into the list of aliases (or swapped between an existing alias and the current primary email), and the email provided in the input is promoted as the primary.

See \url{https://www.paws-r-sdk.com/docs/workmail_update_primary_email_address/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspaces_operations.R
\name{workspaces_delete_ip_group}
\alias{workspaces_delete_ip_group}
\title{Deletes the specified IP access control group}
\usage{
workspaces_delete_ip_group(GroupId)
}
\arguments{
\item{GroupId}{[required] The identifier of the IP access control group.}
}
\description{
Deletes the specified IP access control group.

See \url{https://www.paws-r-sdk.com/docs/workspaces_delete_ip_group/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_delete_alias}
\alias{workmail_delete_alias}
\title{Remove one or more specified aliases from a set of aliases for a given
user}
\usage{
workmail_delete_alias(OrganizationId, EntityId, Alias)
}
\arguments{
\item{OrganizationId}{[required] The identifier for the organization under which the user exists.}

\item{EntityId}{[required] The identifier for the member (user or group) from which to have the aliases removed.}

\item{Alias}{[required] The aliases to be removed from the user's set of aliases. Duplicate entries in the list are collapsed into single entries (the list is transformed into a set).}
}
\description{
Remove one or more specified aliases from a set of aliases for a given user.

See \url{https://www.paws-r-sdk.com/docs/workmail_delete_alias/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspaces_operations.R
\name{workspaces_register_workspace_directory}
\alias{workspaces_register_workspace_directory}
\title{Registers the specified directory}
\usage{
workspaces_register_workspace_directory(
  DirectoryId = NULL,
  SubnetIds = NULL,
  EnableSelfService = NULL,
  Tenancy = NULL,
  Tags = NULL,
  WorkspaceDirectoryName = NULL,
  WorkspaceDirectoryDescription = NULL,
  UserIdentityType = NULL,
  IdcInstanceArn = NULL,
  MicrosoftEntraConfig = NULL,
  WorkspaceType = NULL,
  ActiveDirectoryConfig = NULL
)
}
\arguments{
\item{DirectoryId}{The identifier of the directory. You cannot register a directory if it does not have a status of Active. If the directory does not have a status of Active, you will receive an InvalidResourceStateException error. If you have already registered the maximum number of directories that you can register with Amazon WorkSpaces, you will receive a ResourceLimitExceededException error. Deregister directories that you are not using for WorkSpaces, and try again.}

\item{SubnetIds}{The identifiers of the subnets for your virtual private cloud (VPC). Make sure that the subnets are in supported Availability Zones. The subnets must also be in separate Availability Zones. If these conditions are not met, you will receive an OperationNotSupportedException error.}

\item{EnableSelfService}{Indicates whether self-service capabilities are enabled or disabled.}

\item{Tenancy}{Indicates whether your WorkSpace directory is dedicated or shared. To use Bring Your Own License (BYOL) images, this value must be set to \code{DEDICATED} and your Amazon Web Services account must be enabled for BYOL. If your account has not been enabled for BYOL, you will receive an InvalidParameterValuesException error. For more information about BYOL images, see \href{https://docs.aws.amazon.com/workspaces/latest/adminguide/byol-windows-images.html}{Bring Your Own Windows Desktop Images}.}

\item{Tags}{The tags associated with the directory.}

\item{WorkspaceDirectoryName}{The name of the directory to register.}

\item{WorkspaceDirectoryDescription}{Description of the directory to register.}

\item{UserIdentityType}{The type of identity management the user is using.}

\item{IdcInstanceArn}{The Amazon Resource Name (ARN) of the identity center instance.}

\item{MicrosoftEntraConfig}{The details about Microsoft Entra config.}

\item{WorkspaceType}{Indicates whether the directory's WorkSpace type is personal or pools.}

\item{ActiveDirectoryConfig}{The active directory config of the directory.}
}
\description{
Registers the specified directory. This operation is asynchronous and returns before the WorkSpace directory is registered. If this is the first time you are registering a directory, you will need to create the workspaces_DefaultRole role before you can register a directory. For more information, see \href{https://docs.aws.amazon.com/workspaces/latest/adminguide/workspaces-access-control.html#create-default-role}{Creating the workspaces_DefaultRole Role}.

See \url{https://www.paws-r-sdk.com/docs/workspaces_register_workspace_directory/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspacesweb_operations.R
\name{workspacesweb_list_sessions}
\alias{workspacesweb_list_sessions}
\title{Lists information for multiple secure browser sessions from a specific
portal}
\usage{
workspacesweb_list_sessions(
  portalId,
  username = NULL,
  sessionId = NULL,
  sortBy = NULL,
  status = NULL,
  maxResults = NULL,
  nextToken = NULL
)
}
\arguments{
\item{portalId}{[required] The ID of the web portal for the sessions.}

\item{username}{The username of the session.}

\item{sessionId}{The ID of the session.}

\item{sortBy}{The method in which the returned sessions should be sorted.}

\item{status}{The status of the session.}

\item{maxResults}{The maximum number of results to be included in the next page.}

\item{nextToken}{The pagination token used to retrieve the next page of results for this operation.}
}
\description{
Lists information for multiple secure browser sessions from a specific portal.

See \url{https://www.paws-r-sdk.com/docs/workspacesweb_list_sessions/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspaces_operations.R
\name{workspaces_rebuild_workspaces}
\alias{workspaces_rebuild_workspaces}
\title{Rebuilds the specified WorkSpace}
\usage{
workspaces_rebuild_workspaces(RebuildWorkspaceRequests)
}
\arguments{
\item{RebuildWorkspaceRequests}{[required] The WorkSpace to rebuild. You can specify a single WorkSpace.}
}
\description{
Rebuilds the specified WorkSpace.

See \url{https://www.paws-r-sdk.com/docs/workspaces_rebuild_workspaces/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspacesweb_operations.R
\name{workspacesweb_associate_session_logger}
\alias{workspacesweb_associate_session_logger}
\title{Associates a session logger with a portal}
\usage{
workspacesweb_associate_session_logger(portalArn, sessionLoggerArn)
}
\arguments{
\item{portalArn}{[required] The ARN of the portal to associate to the session logger ARN.}

\item{sessionLoggerArn}{[required] The ARN of the session logger to associate to the portal ARN.}
}
\description{
Associates a session logger with a portal.

See \url{https://www.paws-r-sdk.com/docs/workspacesweb_associate_session_logger/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workdocs_operations.R
\name{workdocs_update_folder}
\alias{workdocs_update_folder}
\title{Updates the specified attributes of the specified folder}
\usage{
workdocs_update_folder(
  AuthenticationToken = NULL,
  FolderId,
  Name = NULL,
  ParentFolderId = NULL,
  ResourceState = NULL
)
}
\arguments{
\item{AuthenticationToken}{Amazon WorkDocs authentication token. Not required when using Amazon Web Services administrator credentials to access the API.}

\item{FolderId}{[required] The ID of the folder.}

\item{Name}{The name of the folder.}

\item{ParentFolderId}{The ID of the parent folder.}

\item{ResourceState}{The resource state of the folder. Only ACTIVE and RECYCLED are accepted values from the API.}
}
\description{
Updates the specified attributes of the specified folder. The user must have access to both the folder and its parent folder, if applicable.

See \url{https://www.paws-r-sdk.com/docs/workdocs_update_folder/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspaces_operations.R
\name{workspaces_modify_workspace_creation_properties}
\alias{workspaces_modify_workspace_creation_properties}
\title{Modify the default properties used to create WorkSpaces}
\usage{
workspaces_modify_workspace_creation_properties(
  ResourceId,
  WorkspaceCreationProperties
)
}
\arguments{
\item{ResourceId}{[required] The identifier of the directory.}

\item{WorkspaceCreationProperties}{[required] The default properties for creating WorkSpaces.}
}
\description{
Modify the default properties used to create WorkSpaces.

See \url{https://www.paws-r-sdk.com/docs/workspaces_modify_workspace_creation_properties/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspaces_operations.R
\name{workspaces_import_workspace_image}
\alias{workspaces_import_workspace_image}
\title{Imports the specified Windows 10 or 11 Bring Your Own License (BYOL)
image into Amazon WorkSpaces}
\usage{
workspaces_import_workspace_image(
  Ec2ImageId,
  IngestionProcess,
  ImageName,
  ImageDescription,
  Tags = NULL,
  Applications = NULL
)
}
\arguments{
\item{Ec2ImageId}{[required] The identifier of the EC2 image.}

\item{IngestionProcess}{[required] The ingestion process to be used when importing the image, depending on which protocol you want to use for your BYOL Workspace image, either PCoIP, WSP, or bring your own protocol (BYOP). To use DCV, specify a value that ends in \verb{_WSP}. To use PCoIP, specify a value that does not end in \verb{_WSP}. To use BYOP, specify a value that ends in \verb{_BYOP}.

For non-GPU-enabled bundles (bundles other than Graphics or GraphicsPro), specify \code{BYOL_REGULAR}, \code{BYOL_REGULAR_WSP}, or \code{BYOL_REGULAR_BYOP}, depending on the protocol.

The \code{BYOL_REGULAR_BYOP} and \code{BYOL_GRAPHICS_G4DN_BYOP} values are only supported by Amazon WorkSpaces Core. Contact your account team to be allow-listed to use these values. For more information, see \href{https://aws.amazon.com/workspaces/vdi-partners/}{Amazon WorkSpaces Core}.}

\item{ImageName}{[required] The name of the WorkSpace image.}

\item{ImageDescription}{[required] The description of the WorkSpace image.}

\item{Tags}{The tags. Each WorkSpaces resource can have a maximum of 50 tags.}

\item{Applications}{If specified, the version of Microsoft Office to subscribe to. Valid only for Windows 10 and 11 BYOL images. For more information about subscribing to Office for BYOL images, see \href{https://docs.aws.amazon.com/workspaces/latest/adminguide/byol-windows-images.html}{Bring Your Own Windows Desktop Licenses}.
\itemize{
\item Although this parameter is an array, only one item is allowed at this time.
\item During the image import process, non-GPU DCV (formerly WSP) WorkSpaces with Windows 11 support only \code{Microsoft_Office_2019}. GPU DCV (formerly WSP) WorkSpaces with Windows 11 do not support Office installation.
}}
}
\description{
Imports the specified Windows 10 or 11 Bring Your Own License (BYOL) image into Amazon WorkSpaces. The image must be an already licensed Amazon EC2 image that is in your Amazon Web Services account, and you must own the image. For more information about creating BYOL images, see \href{https://docs.aws.amazon.com/workspaces/latest/adminguide/byol-windows-images.html}{Bring Your Own Windows Desktop Licenses}.

See \url{https://www.paws-r-sdk.com/docs/workspaces_import_workspace_image/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workdocs_operations.R
\name{workdocs_delete_user}
\alias{workdocs_delete_user}
\title{Deletes the specified user from a Simple AD or Microsoft AD directory}
\usage{
workdocs_delete_user(AuthenticationToken = NULL, UserId)
}
\arguments{
\item{AuthenticationToken}{Amazon WorkDocs authentication token. Do not set this field when using administrative API actions, as in accessing the API using Amazon Web Services credentials.}

\item{UserId}{[required] The ID of the user.}
}
\description{
Deletes the specified user from a Simple AD or Microsoft AD directory.

See \url{https://www.paws-r-sdk.com/docs/workdocs_delete_user/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workdocs_operations.R
\name{workdocs_describe_root_folders}
\alias{workdocs_describe_root_folders}
\title{Describes the current user's special folders; the RootFolder and the
RecycleBin}
\usage{
workdocs_describe_root_folders(
  AuthenticationToken,
  Limit = NULL,
  Marker = NULL
)
}
\arguments{
\item{AuthenticationToken}{[required] Amazon WorkDocs authentication token.}

\item{Limit}{The maximum number of items to return.}

\item{Marker}{The marker for the next set of results. (You received this marker from a previous call.)}
}
\description{
Describes the current user's special folders; the \code{RootFolder} and the \code{RecycleBin}. \code{RootFolder} is the root of user's files and folders and \code{RecycleBin} is the root of recycled items. This is not a valid action for SigV4 (administrative API) clients.

See \url{https://www.paws-r-sdk.com/docs/workdocs_describe_root_folders/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/chatbot_operations.R
\name{chatbot_disassociate_from_configuration}
\alias{chatbot_disassociate_from_configuration}
\title{Unlink a resource, for example a custom action, from a channel
configuration}
\usage{
chatbot_disassociate_from_configuration(Resource, ChatConfiguration)
}
\arguments{
\item{Resource}{[required] The resource (for example, a custom action) Amazon Resource Name (ARN) to unlink.}

\item{ChatConfiguration}{[required] The channel configuration the resource is being disassociated from.}
}
\description{
Unlink a resource, for example a custom action, from a channel configuration.

See \url{https://www.paws-r-sdk.com/docs/chatbot_disassociate_from_configuration/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/appstream_operations.R
\name{appstream_associate_app_block_builder_app_block}
\alias{appstream_associate_app_block_builder_app_block}
\title{Associates the specified app block builder with the specified app block}
\usage{
appstream_associate_app_block_builder_app_block(
  AppBlockArn,
  AppBlockBuilderName
)
}
\arguments{
\item{AppBlockArn}{[required] The ARN of the app block.}

\item{AppBlockBuilderName}{[required] The name of the app block builder.}
}
\description{
Associates the specified app block builder with the specified app block.

See \url{https://www.paws-r-sdk.com/docs/appstream_associate_app_block_builder_app_block/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ivschat_operations.R
\name{ivschat_tag_resource}
\alias{ivschat_tag_resource}
\title{Adds or updates tags for the AWS resource with the specified ARN}
\usage{
ivschat_tag_resource(resourceArn, tags)
}
\arguments{
\item{resourceArn}{[required] The ARN of the resource to be tagged. The ARN must be URL-encoded.}

\item{tags}{[required] Array of tags to be added or updated. Array of maps, each of the form \code{string:string (key:value)}. See \href{https://docs.aws.amazon.com/tag-editor/latest/userguide/best-practices-and-strats.html}{Best practices and strategies} in \emph{Tagging Amazon Web Services Resources and Tag Editor} for details, including restrictions that apply to tags and "Tag naming limits and requirements"; Amazon IVS Chat has no constraints beyond what is documented there.}
}
\description{
Adds or updates tags for the AWS resource with the specified ARN.

See \url{https://www.paws-r-sdk.com/docs/ivschat_tag_resource/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/chatbot_operations.R
\name{chatbot_update_microsoft_teams_channel_configuration}
\alias{chatbot_update_microsoft_teams_channel_configuration}
\title{Updates an Microsoft Teams channel configuration}
\usage{
chatbot_update_microsoft_teams_channel_configuration(
  ChatConfigurationArn,
  ChannelId,
  ChannelName = NULL,
  SnsTopicArns = NULL,
  IamRoleArn = NULL,
  LoggingLevel = NULL,
  GuardrailPolicyArns = NULL,
  UserAuthorizationRequired = NULL
)
}
\arguments{
\item{ChatConfigurationArn}{[required] The Amazon Resource Name (ARN) of the TeamsChannelConfiguration to update.}

\item{ChannelId}{[required] The ID of the Microsoft Teams channel.}

\item{ChannelName}{The name of the Microsoft Teams channel.}

\item{SnsTopicArns}{The Amazon Resource Names (ARNs) of the SNS topics that deliver notifications to AWS Chatbot.}

\item{IamRoleArn}{A user-defined role that AWS Chatbot assumes. This is not the service-linked role.

For more information, see \href{https://docs.aws.amazon.com/chatbot/latest/adminguide/chatbot-iam-policies.html}{IAM policies for AWS Chatbot} in the \emph{AWS Chatbot Administrator Guide}.}

\item{LoggingLevel}{Logging levels include \code{ERROR}, \code{INFO}, or \code{NONE}.}

\item{GuardrailPolicyArns}{The list of IAM policy ARNs that are applied as channel guardrails. The AWS managed \code{AdministratorAccess} policy is applied by default if this is not set.}

\item{UserAuthorizationRequired}{Enables use of a user role requirement in your chat configuration.}
}
\description{
Updates an Microsoft Teams channel configuration.

See \url{https://www.paws-r-sdk.com/docs/chatbot_update_microsoft_teams_channel_configuration/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_start_mailbox_export_job}
\alias{workmail_start_mailbox_export_job}
\title{Starts a mailbox export job to export MIME-format email messages and
calendar items from the specified mailbox to the specified Amazon Simple
Storage Service (Amazon S3) bucket}
\usage{
workmail_start_mailbox_export_job(
  ClientToken,
  OrganizationId,
  EntityId,
  Description = NULL,
  RoleArn,
  KmsKeyArn,
  S3BucketName,
  S3Prefix
)
}
\arguments{
\item{ClientToken}{[required] The idempotency token for the client request.}

\item{OrganizationId}{[required] The identifier associated with the organization.}

\item{EntityId}{[required] The identifier of the user or resource associated with the mailbox.

The identifier can accept \emph{UserId or ResourceId}, \emph{Username or Resourcename}, or \emph{email}. The following identity formats are available:
\itemize{
\item Entity ID: 12345678-1234-1234-1234-123456789012, r-0123456789a0123456789b0123456789 , or S-1-1-12-1234567890-123456789-123456789-1234
\item Email address: entity@domain.tld
\item Entity name: entity
}}

\item{Description}{The mailbox export job description.}

\item{RoleArn}{[required] The ARN of the AWS Identity and Access Management (IAM) role that grants write permission to the S3 bucket.}

\item{KmsKeyArn}{[required] The Amazon Resource Name (ARN) of the symmetric AWS Key Management Service (AWS KMS) key that encrypts the exported mailbox content.}

\item{S3BucketName}{[required] The name of the S3 bucket.}

\item{S3Prefix}{[required] The S3 bucket prefix.}
}
\description{
Starts a mailbox export job to export MIME-format email messages and calendar items from the specified mailbox to the specified Amazon Simple Storage Service (Amazon S3) bucket. For more information, see \href{https://docs.aws.amazon.com/workmail/latest/adminguide/mail-export.html}{Exporting mailbox content} in the \emph{WorkMail Administrator Guide}.

See \url{https://www.paws-r-sdk.com/docs/workmail_start_mailbox_export_job/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/appstream_operations.R
\name{appstream_describe_directory_configs}
\alias{appstream_describe_directory_configs}
\title{Retrieves a list that describes one or more specified Directory Config
objects for WorkSpaces Applications, if the names for these objects are
provided}
\usage{
appstream_describe_directory_configs(
  DirectoryNames = NULL,
  MaxResults = NULL,
  NextToken = NULL
)
}
\arguments{
\item{DirectoryNames}{The directory names.}

\item{MaxResults}{The maximum size of each page of results.}

\item{NextToken}{The pagination token to use to retrieve the next page of results for this operation. If this value is null, it retrieves the first page.}
}
\description{
Retrieves a list that describes one or more specified Directory Config objects for WorkSpaces Applications, if the names for these objects are provided. Otherwise, all Directory Config objects in the account are described. These objects include the configuration information required to join fleets and image builders to Microsoft Active Directory domains.

See \url{https://www.paws-r-sdk.com/docs/appstream_describe_directory_configs/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/chatbot_operations.R
\name{chatbot_delete_microsoft_teams_configured_team}
\alias{chatbot_delete_microsoft_teams_configured_team}
\title{Deletes the Microsoft Teams team authorization allowing for channels to
be configured in that Microsoft Teams team}
\usage{
chatbot_delete_microsoft_teams_configured_team(TeamId)
}
\arguments{
\item{TeamId}{[required] The ID of the Microsoft Teams team authorized with AWS Chatbot.

To get the team ID, you must perform the initial authorization flow with Microsoft Teams in the AWS Chatbot console. Then you can copy and paste the team ID from the console. For more information, see \href{https://docs.aws.amazon.com/chatbot/latest/adminguide/teams-setup.html#teams-client-setup}{Step 1: Configure a Microsoft Teams client} in the \emph{AWS Chatbot Administrator Guide}.}
}
\description{
Deletes the Microsoft Teams team authorization allowing for channels to be configured in that Microsoft Teams team. Note that the Microsoft Teams team must have no channels configured to remove it.

See \url{https://www.paws-r-sdk.com/docs/chatbot_delete_microsoft_teams_configured_team/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_put_mobile_device_access_override}
\alias{workmail_put_mobile_device_access_override}
\title{Creates or updates a mobile device access override for the given
WorkMail organization, user, and device}
\usage{
workmail_put_mobile_device_access_override(
  OrganizationId,
  UserId,
  DeviceId,
  Effect,
  Description = NULL
)
}
\arguments{
\item{OrganizationId}{[required] Identifies the WorkMail organization for which you create the override.}

\item{UserId}{[required] The WorkMail user for which you create the override. Accepts the following types of user identities:
\itemize{
\item User ID: \code{12345678-1234-1234-1234-123456789012} or \code{S-1-1-12-1234567890-123456789-123456789-1234}
\item Email address: \code{user@domain.tld}
\item User name: \code{user}
}}

\item{DeviceId}{[required] The mobile device for which you create the override. \code{DeviceId} is case insensitive.}

\item{Effect}{[required] The effect of the override, \code{ALLOW} or \code{DENY}.}

\item{Description}{A description of the override.}
}
\description{
Creates or updates a mobile device access override for the given WorkMail organization, user, and device.

See \url{https://www.paws-r-sdk.com/docs/workmail_put_mobile_device_access_override/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_list_aliases}
\alias{workmail_list_aliases}
\title{Creates a paginated call to list the aliases associated with a given
entity}
\usage{
workmail_list_aliases(
  OrganizationId,
  EntityId,
  NextToken = NULL,
  MaxResults = NULL
)
}
\arguments{
\item{OrganizationId}{[required] The identifier for the organization under which the entity exists.}

\item{EntityId}{[required] The identifier for the entity for which to list the aliases.}

\item{NextToken}{The token to use to retrieve the next page of results. The first call does not contain any tokens.}

\item{MaxResults}{The maximum number of results to return in a single call.}
}
\description{
Creates a paginated call to list the aliases associated with a given entity.

See \url{https://www.paws-r-sdk.com/docs/workmail_list_aliases/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/appstream_operations.R
\name{appstream_drain_session_instance}
\alias{appstream_drain_session_instance}
\title{Drains the instance hosting the specified streaming session}
\usage{
appstream_drain_session_instance(SessionId)
}
\arguments{
\item{SessionId}{[required] The identifier of the streaming session.}
}
\description{
Drains the instance hosting the specified streaming session. The instance stops accepting new sessions while existing sessions continue uninterrupted. Once all sessions end, the instance is reclaimed and replaced. This only applies to multi-session fleets.

See \url{https://www.paws-r-sdk.com/docs/appstream_drain_session_instance/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspaces_operations.R
\name{workspaces_describe_image_associations}
\alias{workspaces_describe_image_associations}
\title{Describes the associations between the applications and the specified
image}
\usage{
workspaces_describe_image_associations(ImageId, AssociatedResourceTypes)
}
\arguments{
\item{ImageId}{[required] The identifier of the image.}

\item{AssociatedResourceTypes}{[required] The resource types of the associated resource.}
}
\description{
Describes the associations between the applications and the specified image.

See \url{https://www.paws-r-sdk.com/docs/workspaces_describe_image_associations/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspaces_operations.R
\name{workspaces_modify_workspace_state}
\alias{workspaces_modify_workspace_state}
\title{Sets the state of the specified WorkSpace}
\usage{
workspaces_modify_workspace_state(WorkspaceId, WorkspaceState)
}
\arguments{
\item{WorkspaceId}{[required] The identifier of the WorkSpace.}

\item{WorkspaceState}{[required] The WorkSpace state.}
}
\description{
Sets the state of the specified WorkSpace.

See \url{https://www.paws-r-sdk.com/docs/workspaces_modify_workspace_state/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workdocs_operations.R
\name{workdocs_create_custom_metadata}
\alias{workdocs_create_custom_metadata}
\title{Adds one or more custom properties to the specified resource (a folder,
document, or version)}
\usage{
workdocs_create_custom_metadata(
  AuthenticationToken = NULL,
  ResourceId,
  VersionId = NULL,
  CustomMetadata
)
}
\arguments{
\item{AuthenticationToken}{Amazon WorkDocs authentication token. Not required when using Amazon Web Services administrator credentials to access the API.}

\item{ResourceId}{[required] The ID of the resource.}

\item{VersionId}{The ID of the version, if the custom metadata is being added to a document version.}

\item{CustomMetadata}{[required] Custom metadata in the form of name-value pairs.}
}
\description{
Adds one or more custom properties to the specified resource (a folder, document, or version).

See \url{https://www.paws-r-sdk.com/docs/workdocs_create_custom_metadata/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_put_retention_policy}
\alias{workmail_put_retention_policy}
\title{Puts a retention policy to the specified organization}
\usage{
workmail_put_retention_policy(
  OrganizationId,
  Id = NULL,
  Name,
  Description = NULL,
  FolderConfigurations
)
}
\arguments{
\item{OrganizationId}{[required] The organization ID.}

\item{Id}{The retention policy ID.}

\item{Name}{[required] The retention policy name.}

\item{Description}{The retention policy description.}

\item{FolderConfigurations}{[required] The retention policy folder configurations.}
}
\description{
Puts a retention policy to the specified organization.

See \url{https://www.paws-r-sdk.com/docs/workmail_put_retention_policy/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspaces_operations.R
\name{workspaces_modify_saml_properties}
\alias{workspaces_modify_saml_properties}
\title{Modifies multiple properties related to SAML 2}
\usage{
workspaces_modify_saml_properties(
  ResourceId,
  SamlProperties = NULL,
  PropertiesToDelete = NULL
)
}
\arguments{
\item{ResourceId}{[required] The directory identifier for which you want to configure SAML properties.}

\item{SamlProperties}{The properties for configuring SAML 2.0 authentication.}

\item{PropertiesToDelete}{The SAML properties to delete as part of your request.

Specify one of the following options:
\itemize{
\item \code{SAML_PROPERTIES_USER_ACCESS_URL} to delete the user access URL.
\item \code{SAML_PROPERTIES_RELAY_STATE_PARAMETER_NAME} to delete the relay state parameter name.
}}
}
\description{
Modifies multiple properties related to SAML 2.0 authentication, including the enablement status, user access URL, and relay state parameter name that are used for configuring federation with an SAML 2.0 identity provider.

See \url{https://www.paws-r-sdk.com/docs/workspaces_modify_saml_properties/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/appstream_operations.R
\name{appstream_create_streaming_url}
\alias{appstream_create_streaming_url}
\title{Creates a temporary URL to start an WorkSpaces Applications streaming
session for the specified user}
\usage{
appstream_create_streaming_url(
  StackName,
  FleetName,
  UserId,
  ApplicationId = NULL,
  Validity = NULL,
  SessionContext = NULL
)
}
\arguments{
\item{StackName}{[required] The name of the stack.}

\item{FleetName}{[required] The name of the fleet.}

\item{UserId}{[required] The identifier of the user.}

\item{ApplicationId}{The name of the application to launch after the session starts. This is the name that you specified as \strong{Name} in the Image Assistant. If your fleet is enabled for the \strong{Desktop} stream view, you can also choose to launch directly to the operating system desktop. To do so, specify \strong{Desktop}.}

\item{Validity}{The time that the streaming URL will be valid, in seconds. Specify a value between 1 and 604800 seconds. The default is 60 seconds.}

\item{SessionContext}{The session context. For more information, see \href{https://docs.aws.amazon.com/appstream2/latest/developerguide/managing-stacks-fleets.html#managing-stacks-fleets-parameters}{Session Context} in the \emph{Amazon WorkSpaces Applications Administration Guide}.}
}
\description{
Creates a temporary URL to start an WorkSpaces Applications streaming session for the specified user. A streaming URL enables application streaming to be tested without user setup.

See \url{https://www.paws-r-sdk.com/docs/appstream_create_streaming_url/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspaces_operations.R
\name{workspaces_modify_account}
\alias{workspaces_modify_account}
\title{Modifies the configuration of Bring Your Own License (BYOL) for the
specified account}
\usage{
workspaces_modify_account(
  DedicatedTenancySupport = NULL,
  DedicatedTenancyManagementCidrRange = NULL
)
}
\arguments{
\item{DedicatedTenancySupport}{The status of BYOL.}

\item{DedicatedTenancyManagementCidrRange}{The IP address range, specified as an IPv4 CIDR block, for the management network interface. Specify an IP address range that is compatible with your network and in CIDR notation (that is, specify the range as an IPv4 CIDR block). The CIDR block size must be /16 (for example, 203.0.113.25/16). It must also be specified as available by the \code{\link[=workspaces_list_available_management_cidr_ranges]{list_available_management_cidr_ranges}} operation.}
}
\description{
Modifies the configuration of Bring Your Own License (BYOL) for the specified account.

See \url{https://www.paws-r-sdk.com/docs/workspaces_modify_account/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_cancel_mailbox_export_job}
\alias{workmail_cancel_mailbox_export_job}
\title{Cancels a mailbox export job}
\usage{
workmail_cancel_mailbox_export_job(ClientToken, JobId, OrganizationId)
}
\arguments{
\item{ClientToken}{[required] The idempotency token for the client request.}

\item{JobId}{[required] The job ID.}

\item{OrganizationId}{[required] The organization ID.}
}
\description{
Cancels a mailbox export job.

See \url{https://www.paws-r-sdk.com/docs/workmail_cancel_mailbox_export_job/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspaces_operations.R
\name{workspaces_restore_workspace}
\alias{workspaces_restore_workspace}
\title{Restores the specified WorkSpace to its last known healthy state}
\usage{
workspaces_restore_workspace(WorkspaceId)
}
\arguments{
\item{WorkspaceId}{[required] The identifier of the WorkSpace.}
}
\description{
Restores the specified WorkSpace to its last known healthy state.

See \url{https://www.paws-r-sdk.com/docs/workspaces_restore_workspace/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspaces_operations.R
\name{workspaces_deploy_workspace_applications}
\alias{workspaces_deploy_workspace_applications}
\title{Deploys associated applications to the specified WorkSpace}
\usage{
workspaces_deploy_workspace_applications(WorkspaceId, Force = NULL)
}
\arguments{
\item{WorkspaceId}{[required] The identifier of the WorkSpace.}

\item{Force}{Indicates whether the force flag is applied for the specified WorkSpace. When the force flag is enabled, it allows previously failed deployments to be retried.}
}
\description{
Deploys associated applications to the specified WorkSpace

See \url{https://www.paws-r-sdk.com/docs/workspaces_deploy_workspace_applications/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspaces_operations.R
\name{workspaces_associate_workspace_application}
\alias{workspaces_associate_workspace_application}
\title{Associates the specified application to the specified WorkSpace}
\usage{
workspaces_associate_workspace_application(WorkspaceId, ApplicationId)
}
\arguments{
\item{WorkspaceId}{[required] The identifier of the WorkSpace.}

\item{ApplicationId}{[required] The identifier of the application.}
}
\description{
Associates the specified application to the specified WorkSpace.

See \url{https://www.paws-r-sdk.com/docs/workspaces_associate_workspace_application/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/appstream_operations.R
\name{appstream_list_associated_fleets}
\alias{appstream_list_associated_fleets}
\title{Retrieves the name of the fleet that is associated with the specified
stack}
\usage{
appstream_list_associated_fleets(StackName, NextToken = NULL)
}
\arguments{
\item{StackName}{[required] The name of the stack.}

\item{NextToken}{The pagination token to use to retrieve the next page of results for this operation. If this value is null, it retrieves the first page.}
}
\description{
Retrieves the name of the fleet that is associated with the specified stack.

See \url{https://www.paws-r-sdk.com/docs/appstream_list_associated_fleets/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workdocs_operations.R
\name{workdocs_delete_notification_subscription}
\alias{workdocs_delete_notification_subscription}
\title{Deletes the specified subscription from the specified organization}
\usage{
workdocs_delete_notification_subscription(SubscriptionId, OrganizationId)
}
\arguments{
\item{SubscriptionId}{[required] The ID of the subscription.}

\item{OrganizationId}{[required] The ID of the organization.}
}
\description{
Deletes the specified subscription from the specified organization.

See \url{https://www.paws-r-sdk.com/docs/workdocs_delete_notification_subscription/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspaces_operations.R
\name{workspaces_create_connect_client_add_in}
\alias{workspaces_create_connect_client_add_in}
\title{Creates a client-add-in for Amazon Connect within a directory}
\usage{
workspaces_create_connect_client_add_in(ResourceId, Name, URL)
}
\arguments{
\item{ResourceId}{[required] The directory identifier for which to configure the client add-in.}

\item{Name}{[required] The name of the client add-in.}

\item{URL}{[required] The endpoint URL of the Amazon Connect client add-in.}
}
\description{
Creates a client-add-in for Amazon Connect within a directory. You can create only one Amazon Connect client add-in within a directory.

See \url{https://www.paws-r-sdk.com/docs/workspaces_create_connect_client_add_in/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspaces_operations.R
\name{workspaces_describe_applications}
\alias{workspaces_describe_applications}
\title{Describes the specified applications by filtering based on their compute
types, license availability, operating systems, and owners}
\usage{
workspaces_describe_applications(
  ApplicationIds = NULL,
  ComputeTypeNames = NULL,
  LicenseType = NULL,
  OperatingSystemNames = NULL,
  Owner = NULL,
  MaxResults = NULL,
  NextToken = NULL
)
}
\arguments{
\item{ApplicationIds}{The identifiers of one or more applications.}

\item{ComputeTypeNames}{The compute types supported by the applications.}

\item{LicenseType}{The license availability for the applications.}

\item{OperatingSystemNames}{The operating systems supported by the applications.}

\item{Owner}{The owner of the applications.}

\item{MaxResults}{The maximum number of applications to return.}

\item{NextToken}{If you received a \code{NextToken} from a previous call that was paginated, provide this token to receive the next set of results.}
}
\description{
Describes the specified applications by filtering based on their compute types, license availability, operating systems, and owners.

See \url{https://www.paws-r-sdk.com/docs/workspaces_describe_applications/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workdocs_operations.R
\name{workdocs_remove_all_resource_permissions}
\alias{workdocs_remove_all_resource_permissions}
\title{Removes all the permissions from the specified resource}
\usage{
workdocs_remove_all_resource_permissions(
  AuthenticationToken = NULL,
  ResourceId
)
}
\arguments{
\item{AuthenticationToken}{Amazon WorkDocs authentication token. Not required when using Amazon Web Services administrator credentials to access the API.}

\item{ResourceId}{[required] The ID of the resource.}
}
\description{
Removes all the permissions from the specified resource.

See \url{https://www.paws-r-sdk.com/docs/workdocs_remove_all_resource_permissions/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspaces_operations.R
\name{workspaces_associate_connection_alias}
\alias{workspaces_associate_connection_alias}
\title{Associates the specified connection alias with the specified directory
to enable cross-Region redirection}
\usage{
workspaces_associate_connection_alias(AliasId, ResourceId)
}
\arguments{
\item{AliasId}{[required] The identifier of the connection alias.}

\item{ResourceId}{[required] The identifier of the directory to associate the connection alias with.}
}
\description{
Associates the specified connection alias with the specified directory to enable cross-Region redirection. For more information, see \href{https://docs.aws.amazon.com/workspaces/latest/adminguide/cross-region-redirection.html}{Cross-Region Redirection for Amazon WorkSpaces}.

See \url{https://www.paws-r-sdk.com/docs/workspaces_associate_connection_alias/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/appstream_operations.R
\name{appstream_create_entitlement}
\alias{appstream_create_entitlement}
\title{Creates a new entitlement}
\usage{
appstream_create_entitlement(
  Name,
  StackName,
  Description = NULL,
  AppVisibility,
  Attributes
)
}
\arguments{
\item{Name}{[required] The name of the entitlement.}

\item{StackName}{[required] The name of the stack with which the entitlement is associated.}

\item{Description}{The description of the entitlement.}

\item{AppVisibility}{[required] Specifies whether all or selected apps are entitled.}

\item{Attributes}{[required] The attributes of the entitlement.}
}
\description{
Creates a new entitlement. Entitlements control access to specific applications within a stack, based on user attributes. Entitlements apply to SAML 2.0 federated user identities. WorkSpaces Applications user pool and streaming URL users are entitled to all applications in a stack. Entitlements don't apply to the desktop stream view application, or to applications managed by a dynamic app provider using the Dynamic Application Framework.

See \url{https://www.paws-r-sdk.com/docs/appstream_create_entitlement/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_service.R
\name{workmail}
\alias{workmail}
\title{Amazon WorkMail}
\usage{
workmail(config = list(), credentials = list(), endpoint = NULL, region = NULL)
}
\arguments{
\item{config}{Optional configuration of credentials, endpoint, and/or region.
\itemize{
\item{\strong{credentials}: \itemize{
\item{\strong{creds}: \itemize{
\item{\strong{access_key_id}: AWS access key ID}
\item{\strong{secret_access_key}: AWS secret access key}
\item{\strong{session_token}: AWS temporary session token}
}}
\item{\strong{profile}: The name of a profile to use. If not given, then the default profile is used.}
\item{\strong{anonymous}: Set anonymous credentials.}
}}
\item{\strong{endpoint}: The complete URL to use for the constructed client.}
\item{\strong{region}: The AWS Region used in instantiating the client.}
\item{\strong{close_connection}: Immediately close all HTTP connections.}
\item{\strong{timeout}: The time in seconds till a timeout exception is thrown when attempting to make a connection. The default is 60 seconds.}
\item{\strong{s3_force_path_style}: Set this to \code{true} to force the request to use path-style addressing, i.e. \verb{http://s3.amazonaws.com/BUCKET/KEY}.}
\item{\strong{sts_regional_endpoint}: Set sts regional endpoint resolver to regional or legacy \url{https://docs.aws.amazon.com/sdkref/latest/guide/feature-sts-regionalized-endpoints.html}}
}}

\item{credentials}{Optional credentials shorthand for the config parameter
\itemize{
\item{\strong{creds}: \itemize{
\item{\strong{access_key_id}: AWS access key ID}
\item{\strong{secret_access_key}: AWS secret access key}
\item{\strong{session_token}: AWS temporary session token}
}}
\item{\strong{profile}: The name of a profile to use. If not given, then the default profile is used.}
\item{\strong{anonymous}: Set anonymous credentials.}
}}

\item{endpoint}{Optional shorthand for complete URL to use for the constructed client.}

\item{region}{Optional shorthand for AWS Region used in instantiating the client.}
}
\value{
A client for the service. You can call the service's operations using
syntax like \code{svc$operation(...)}, where \code{svc} is the name you've assigned
to the client. The available operations are listed in the
Operations section.
}
\description{
WorkMail is a secure, managed business email and calendaring service with support for existing desktop and mobile email clients. You can access your email, contacts, and calendars using Microsoft Outlook, your browser, or other native iOS and Android email applications. You can integrate WorkMail with your existing corporate directory and control both the keys that encrypt your data and the location in which your data is stored.

The WorkMail API is designed for the following scenarios:
\itemize{
\item Listing and describing organizations
\item Managing users
\item Managing groups
\item Managing resources
}

All WorkMail API operations are Amazon-authenticated and certificate-signed. They not only require the use of the AWS SDK, but also allow for the exclusive use of AWS Identity and Access Management users and roles to help facilitate access, trust, and permission policies. By creating a role and allowing an IAM user to access the WorkMail site, the IAM user gains full administrative visibility into the entire WorkMail organization (or as set in the IAM policy). This includes, but is not limited to, the ability to create, update, and delete users, groups, and resources. This allows developers to perform the scenarios listed above, as well as give users the ability to grant access on a selective basis using the IAM model.
}
\section{Service syntax}{


\if{html}{\out{<div class="sourceCode">}}\preformatted{svc <- workmail(
  config = list(
    credentials = list(
      creds = list(
        access_key_id = "string",
        secret_access_key = "string",
        session_token = "string"
      ),
      profile = "string",
      anonymous = "logical"
    ),
    endpoint = "string",
    region = "string",
    close_connection = "logical",
    timeout = "numeric",
    s3_force_path_style = "logical",
    sts_regional_endpoint = "string"
  ),
  credentials = list(
    creds = list(
      access_key_id = "string",
      secret_access_key = "string",
      session_token = "string"
    ),
    profile = "string",
    anonymous = "logical"
  ),
  endpoint = "string",
  region = "string"
)
}\if{html}{\out{</div>}}
}

\section{Operations}{

\tabular{ll}{
\link[=workmail_associate_delegate_to_resource]{associate_delegate_to_resource} \tab Adds a member (user or group) to the resource's set of delegates\cr
\link[=workmail_associate_member_to_group]{associate_member_to_group} \tab Adds a member (user or group) to the group's set\cr
\link[=workmail_assume_impersonation_role]{assume_impersonation_role} \tab Assumes an impersonation role for the given WorkMail organization\cr
\link[=workmail_cancel_mailbox_export_job]{cancel_mailbox_export_job} \tab Cancels a mailbox export job\cr
\link[=workmail_create_alias]{create_alias} \tab Adds an alias to the set of a given member (user or group) of WorkMail\cr
\link[=workmail_create_availability_configuration]{create_availability_configuration} \tab Creates an AvailabilityConfiguration for the given WorkMail organization and domain\cr
\link[=workmail_create_group]{create_group} \tab Creates a group that can be used in WorkMail by calling the RegisterToWorkMail operation\cr
\link[=workmail_create_identity_center_application]{create_identity_center_application} \tab Creates the WorkMail application in IAM Identity Center that can be used later in the WorkMail - IdC integration\cr
\link[=workmail_create_impersonation_role]{create_impersonation_role} \tab Creates an impersonation role for the given WorkMail organization\cr
\link[=workmail_create_mobile_device_access_rule]{create_mobile_device_access_rule} \tab Creates a new mobile device access rule for the specified WorkMail organization\cr
\link[=workmail_create_organization]{create_organization} \tab Creates a new WorkMail organization\cr
\link[=workmail_create_resource]{create_resource} \tab Creates a new WorkMail resource\cr
\link[=workmail_create_user]{create_user} \tab Creates a user who can be used in WorkMail by calling the RegisterToWorkMail operation\cr
\link[=workmail_delete_access_control_rule]{delete_access_control_rule} \tab Deletes an access control rule for the specified WorkMail organization\cr
\link[=workmail_delete_alias]{delete_alias} \tab Remove one or more specified aliases from a set of aliases for a given user\cr
\link[=workmail_delete_availability_configuration]{delete_availability_configuration} \tab Deletes the AvailabilityConfiguration for the given WorkMail organization and domain\cr
\link[=workmail_delete_email_monitoring_configuration]{delete_email_monitoring_configuration} \tab Deletes the email monitoring configuration for a specified organization\cr
\link[=workmail_delete_group]{delete_group} \tab Deletes a group from WorkMail\cr
\link[=workmail_delete_identity_center_application]{delete_identity_center_application} \tab Deletes the IAM Identity Center application from WorkMail\cr
\link[=workmail_delete_identity_provider_configuration]{delete_identity_provider_configuration} \tab Disables the integration between IdC and WorkMail\cr
\link[=workmail_delete_impersonation_role]{delete_impersonation_role} \tab Deletes an impersonation role for the given WorkMail organization\cr
\link[=workmail_delete_mailbox_permissions]{delete_mailbox_permissions} \tab Deletes permissions granted to a member (user or group)\cr
\link[=workmail_delete_mobile_device_access_override]{delete_mobile_device_access_override} \tab Deletes the mobile device access override for the given WorkMail organization, user, and device\cr
\link[=workmail_delete_mobile_device_access_rule]{delete_mobile_device_access_rule} \tab Deletes a mobile device access rule for the specified WorkMail organization\cr
\link[=workmail_delete_organization]{delete_organization} \tab Deletes an WorkMail organization and all underlying AWS resources managed by WorkMail as part of the organization\cr
\link[=workmail_delete_personal_access_token]{delete_personal_access_token} \tab Deletes the Personal Access Token from the provided WorkMail Organization\cr
\link[=workmail_delete_resource]{delete_resource} \tab Deletes the specified resource\cr
\link[=workmail_delete_retention_policy]{delete_retention_policy} \tab Deletes the specified retention policy from the specified organization\cr
\link[=workmail_delete_user]{delete_user} \tab Deletes a user from WorkMail and all subsequent systems\cr
\link[=workmail_deregister_from_work_mail]{deregister_from_work_mail} \tab Mark a user, group, or resource as no longer used in WorkMail\cr
\link[=workmail_deregister_mail_domain]{deregister_mail_domain} \tab Removes a domain from WorkMail, stops email routing to WorkMail, and removes the authorization allowing WorkMail use\cr
\link[=workmail_describe_email_monitoring_configuration]{describe_email_monitoring_configuration} \tab Describes the current email monitoring configuration for a specified organization\cr
\link[=workmail_describe_entity]{describe_entity} \tab Returns basic details about an entity in WorkMail\cr
\link[=workmail_describe_group]{describe_group} \tab Returns the data available for the group\cr
\link[=workmail_describe_identity_provider_configuration]{describe_identity_provider_configuration} \tab Returns detailed information on the current IdC setup for the WorkMail organization\cr
\link[=workmail_describe_inbound_dmarc_settings]{describe_inbound_dmarc_settings} \tab Lists the settings in a DMARC policy for a specified organization\cr
\link[=workmail_describe_mailbox_export_job]{describe_mailbox_export_job} \tab Describes the current status of a mailbox export job\cr
\link[=workmail_describe_organization]{describe_organization} \tab Provides more information regarding a given organization based on its identifier\cr
\link[=workmail_describe_resource]{describe_resource} \tab Returns the data available for the resource\cr
\link[=workmail_describe_user]{describe_user} \tab Provides information regarding the user\cr
\link[=workmail_disassociate_delegate_from_resource]{disassociate_delegate_from_resource} \tab Removes a member from the resource's set of delegates\cr
\link[=workmail_disassociate_member_from_group]{disassociate_member_from_group} \tab Removes a member from a group\cr
\link[=workmail_get_access_control_effect]{get_access_control_effect} \tab Gets the effects of an organization's access control rules as they apply to a specified IPv4 address, access protocol action, and user ID or impersonation role ID\cr
\link[=workmail_get_default_retention_policy]{get_default_retention_policy} \tab Gets the default retention policy details for the specified organization\cr
\link[=workmail_get_impersonation_role]{get_impersonation_role} \tab Gets the impersonation role details for the given WorkMail organization\cr
\link[=workmail_get_impersonation_role_effect]{get_impersonation_role_effect} \tab Tests whether the given impersonation role can impersonate a target user\cr
\link[=workmail_get_mailbox_details]{get_mailbox_details} \tab Requests a user's mailbox details for a specified organization and user\cr
\link[=workmail_get_mail_domain]{get_mail_domain} \tab Gets details for a mail domain, including domain records required to configure your domain with recommended security\cr
\link[=workmail_get_mobile_device_access_effect]{get_mobile_device_access_effect} \tab Simulates the effect of the mobile device access rules for the given attributes of a sample access event\cr
\link[=workmail_get_mobile_device_access_override]{get_mobile_device_access_override} \tab Gets the mobile device access override for the given WorkMail organization, user, and device\cr
\link[=workmail_get_personal_access_token_metadata]{get_personal_access_token_metadata} \tab Requests details of a specific Personal Access Token within the WorkMail organization\cr
\link[=workmail_list_access_control_rules]{list_access_control_rules} \tab Lists the access control rules for the specified organization\cr
\link[=workmail_list_aliases]{list_aliases} \tab Creates a paginated call to list the aliases associated with a given entity\cr
\link[=workmail_list_availability_configurations]{list_availability_configurations} \tab List all the AvailabilityConfiguration's for the given WorkMail organization\cr
\link[=workmail_list_group_members]{list_group_members} \tab Returns an overview of the members of a group\cr
\link[=workmail_list_groups]{list_groups} \tab Returns summaries of the organization's groups\cr
\link[=workmail_list_groups_for_entity]{list_groups_for_entity} \tab Returns all the groups to which an entity belongs\cr
\link[=workmail_list_impersonation_roles]{list_impersonation_roles} \tab Lists all the impersonation roles for the given WorkMail organization\cr
\link[=workmail_list_mailbox_export_jobs]{list_mailbox_export_jobs} \tab Lists the mailbox export jobs started for the specified organization within the last seven days\cr
\link[=workmail_list_mailbox_permissions]{list_mailbox_permissions} \tab Lists the mailbox permissions associated with a user, group, or resource mailbox\cr
\link[=workmail_list_mail_domains]{list_mail_domains} \tab Lists the mail domains in a given WorkMail organization\cr
\link[=workmail_list_mobile_device_access_overrides]{list_mobile_device_access_overrides} \tab Lists all the mobile device access overrides for any given combination of WorkMail organization, user, or device\cr
\link[=workmail_list_mobile_device_access_rules]{list_mobile_device_access_rules} \tab Lists the mobile device access rules for the specified WorkMail organization\cr
\link[=workmail_list_organizations]{list_organizations} \tab Returns summaries of the customer's organizations\cr
\link[=workmail_list_personal_access_tokens]{list_personal_access_tokens} \tab Returns a summary of your Personal Access Tokens\cr
\link[=workmail_list_resource_delegates]{list_resource_delegates} \tab Lists the delegates associated with a resource\cr
\link[=workmail_list_resources]{list_resources} \tab Returns summaries of the organization's resources\cr
\link[=workmail_list_tags_for_resource]{list_tags_for_resource} \tab Lists the tags applied to an WorkMail organization resource\cr
\link[=workmail_list_users]{list_users} \tab Returns summaries of the organization's users\cr
\link[=workmail_put_access_control_rule]{put_access_control_rule} \tab Adds a new access control rule for the specified organization\cr
\link[=workmail_put_email_monitoring_configuration]{put_email_monitoring_configuration} \tab Creates or updates the email monitoring configuration for a specified organization\cr
\link[=workmail_put_identity_provider_configuration]{put_identity_provider_configuration} \tab Enables integration between IAM Identity Center (IdC) and WorkMail to proxy authentication requests for mailbox users\cr
\link[=workmail_put_inbound_dmarc_settings]{put_inbound_dmarc_settings} \tab Enables or disables a DMARC policy for a given organization\cr
\link[=workmail_put_mailbox_permissions]{put_mailbox_permissions} \tab Sets permissions for a user, group, or resource\cr
\link[=workmail_put_mobile_device_access_override]{put_mobile_device_access_override} \tab Creates or updates a mobile device access override for the given WorkMail organization, user, and device\cr
\link[=workmail_put_retention_policy]{put_retention_policy} \tab Puts a retention policy to the specified organization\cr
\link[=workmail_register_mail_domain]{register_mail_domain} \tab Registers a new domain in WorkMail and SES, and configures it for use by WorkMail\cr
\link[=workmail_register_to_work_mail]{register_to_work_mail} \tab Registers an existing and disabled user, group, or resource for WorkMail use by associating a mailbox and calendaring capabilities\cr
\link[=workmail_reset_password]{reset_password} \tab Allows the administrator to reset the password for a user\cr
\link[=workmail_start_mailbox_export_job]{start_mailbox_export_job} \tab Starts a mailbox export job to export MIME-format email messages and calendar items from the specified mailbox to the specified Amazon Simple Storage Service (Amazon S3) bucket\cr
\link[=workmail_tag_resource]{tag_resource} \tab Applies the specified tags to the specified WorkMailorganization resource\cr
\link[=workmail_test_availability_configuration]{test_availability_configuration} \tab Performs a test on an availability provider to ensure that access is allowed\cr
\link[=workmail_untag_resource]{untag_resource} \tab Untags the specified tags from the specified WorkMail organization resource\cr
\link[=workmail_update_availability_configuration]{update_availability_configuration} \tab Updates an existing AvailabilityConfiguration for the given WorkMail organization and domain\cr
\link[=workmail_update_default_mail_domain]{update_default_mail_domain} \tab Updates the default mail domain for an organization\cr
\link[=workmail_update_group]{update_group} \tab Updates attributes in a group\cr
\link[=workmail_update_impersonation_role]{update_impersonation_role} \tab Updates an impersonation role for the given WorkMail organization\cr
\link[=workmail_update_mailbox_quota]{update_mailbox_quota} \tab Updates a user's current mailbox quota for a specified organization and user\cr
\link[=workmail_update_mobile_device_access_rule]{update_mobile_device_access_rule} \tab Updates a mobile device access rule for the specified WorkMail organization\cr
\link[=workmail_update_primary_email_address]{update_primary_email_address} \tab Updates the primary email for a user, group, or resource\cr
\link[=workmail_update_resource]{update_resource} \tab Updates data for the resource\cr
\link[=workmail_update_user]{update_user} \tab Updates data for the user
}
}

\examples{
\dontrun{
svc <- workmail()
svc$associate_delegate_to_resource(
  Foo = 123
)
}

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_get_impersonation_role}
\alias{workmail_get_impersonation_role}
\title{Gets the impersonation role details for the given WorkMail organization}
\usage{
workmail_get_impersonation_role(OrganizationId, ImpersonationRoleId)
}
\arguments{
\item{OrganizationId}{[required] The WorkMail organization from which to retrieve the impersonation role.}

\item{ImpersonationRoleId}{[required] The impersonation role ID to retrieve.}
}
\description{
Gets the impersonation role details for the given WorkMail organization.

See \url{https://www.paws-r-sdk.com/docs/workmail_get_impersonation_role/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_describe_email_monitoring_configuration}
\alias{workmail_describe_email_monitoring_configuration}
\title{Describes the current email monitoring configuration for a specified
organization}
\usage{
workmail_describe_email_monitoring_configuration(OrganizationId)
}
\arguments{
\item{OrganizationId}{[required] The ID of the organization for which the email monitoring configuration is described.}
}
\description{
Describes the current email monitoring configuration for a specified organization.

See \url{https://www.paws-r-sdk.com/docs/workmail_describe_email_monitoring_configuration/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ivschat_service.R
\name{ivschat}
\alias{ivschat}
\title{Amazon Interactive Video Service Chat}
\usage{
ivschat(config = list(), credentials = list(), endpoint = NULL, region = NULL)
}
\arguments{
\item{config}{Optional configuration of credentials, endpoint, and/or region.
\itemize{
\item{\strong{credentials}: \itemize{
\item{\strong{creds}: \itemize{
\item{\strong{access_key_id}: AWS access key ID}
\item{\strong{secret_access_key}: AWS secret access key}
\item{\strong{session_token}: AWS temporary session token}
}}
\item{\strong{profile}: The name of a profile to use. If not given, then the default profile is used.}
\item{\strong{anonymous}: Set anonymous credentials.}
}}
\item{\strong{endpoint}: The complete URL to use for the constructed client.}
\item{\strong{region}: The AWS Region used in instantiating the client.}
\item{\strong{close_connection}: Immediately close all HTTP connections.}
\item{\strong{timeout}: The time in seconds till a timeout exception is thrown when attempting to make a connection. The default is 60 seconds.}
\item{\strong{s3_force_path_style}: Set this to \code{true} to force the request to use path-style addressing, i.e. \verb{http://s3.amazonaws.com/BUCKET/KEY}.}
\item{\strong{sts_regional_endpoint}: Set sts regional endpoint resolver to regional or legacy \url{https://docs.aws.amazon.com/sdkref/latest/guide/feature-sts-regionalized-endpoints.html}}
}}

\item{credentials}{Optional credentials shorthand for the config parameter
\itemize{
\item{\strong{creds}: \itemize{
\item{\strong{access_key_id}: AWS access key ID}
\item{\strong{secret_access_key}: AWS secret access key}
\item{\strong{session_token}: AWS temporary session token}
}}
\item{\strong{profile}: The name of a profile to use. If not given, then the default profile is used.}
\item{\strong{anonymous}: Set anonymous credentials.}
}}

\item{endpoint}{Optional shorthand for complete URL to use for the constructed client.}

\item{region}{Optional shorthand for AWS Region used in instantiating the client.}
}
\value{
A client for the service. You can call the service's operations using
syntax like \code{svc$operation(...)}, where \code{svc} is the name you've assigned
to the client. The available operations are listed in the
Operations section.
}
\description{
\strong{Introduction}

The Amazon IVS Chat control-plane API enables you to create and manage Amazon IVS Chat resources. You also need to integrate with the \href{https://docs.aws.amazon.com/ivs/latest/chatmsgapireference/}{Amazon IVS Chat Messaging API}, to enable users to interact with chat rooms in real time.

The API is an AWS regional service. For a list of supported regions and Amazon IVS Chat HTTPS service endpoints, see the Amazon IVS Chat information on the \href{https://docs.aws.amazon.com/general/latest/gr/ivs.html}{Amazon IVS page} in the \emph{AWS General Reference}.

This document describes HTTP operations. There is a separate \emph{messaging} API for managing Chat resources; see the \href{https://docs.aws.amazon.com/ivs/latest/chatmsgapireference/}{Amazon IVS Chat Messaging API Reference}.

\strong{Notes on terminology:}
\itemize{
\item You create service applications using the Amazon IVS Chat API. We refer to these as \emph{applications}.
\item You create front-end client applications (browser and Android/iOS apps) using the Amazon IVS Chat Messaging API. We refer to these as \emph{clients}.
}

\strong{Resources}

The following resources are part of Amazon IVS Chat:
\itemize{
\item \strong{LoggingConfiguration} — A configuration that allows customers to store and record sent messages in a chat room. See the Logging Configuration endpoints for more information.
\item \strong{Room} — The central Amazon IVS Chat resource through which clients connect to and exchange chat messages. See the Room endpoints for more information.
}

\strong{Tagging}

A \emph{tag} is a metadata label that you assign to an AWS resource. A tag comprises a \emph{key} and a \emph{value}, both set by you. For example, you might set a tag as \code{topic:nature} to label a particular video category. See \href{https://docs.aws.amazon.com/tag-editor/latest/userguide/best-practices-and-strats.html}{Best practices and strategies} in \emph{Tagging Amazon Web Services Resources and Tag Editor} for details, including restrictions that apply to tags and "Tag naming limits and requirements"; Amazon IVS Chat has no service-specific constraints beyond what is documented there.

Tags can help you identify and organize your AWS resources. For example, you can use the same tag for different resources to indicate that they are related. You can also use tags to manage access (see \href{https://docs.aws.amazon.com/IAM/latest/UserGuide/access_tags.html}{Access Tags}).

The Amazon IVS Chat API has these tag-related operations: \code{\link[=ivschat_tag_resource]{tag_resource}}, \code{\link[=ivschat_untag_resource]{untag_resource}}, and \code{\link[=ivschat_list_tags_for_resource]{list_tags_for_resource}}. The following resource supports tagging: Room.

At most 50 tags can be applied to a resource.

\strong{API Access Security}

Your Amazon IVS Chat applications (service applications and clients) must be authenticated and authorized to access Amazon IVS Chat resources. Note the differences between these concepts:
\itemize{
\item \emph{Authentication} is about verifying identity. Requests to the Amazon IVS Chat API must be signed to verify your identity.
\item \emph{Authorization} is about granting permissions. Your IAM roles need to have permissions for Amazon IVS Chat API requests.
}

Users (viewers) connect to a room using secure access tokens that you create using the \code{\link[=ivschat_create_chat_token]{create_chat_token}} operation through the AWS SDK. You call CreateChatToken for every user’s chat session, passing identity and authorization information about the user.

\strong{Signing API Requests}

HTTP API requests must be signed with an AWS SigV4 signature using your AWS security credentials. The AWS Command Line Interface (CLI) and the AWS SDKs take care of signing the underlying API calls for you. However, if your application calls the Amazon IVS Chat HTTP API directly, it’s your responsibility to sign the requests.

You generate a signature using valid AWS credentials for an IAM role that has permission to perform the requested action. For example, DeleteMessage requests must be made using an IAM role that has the \code{ivschat:DeleteMessage} permission.

For more information:
\itemize{
\item Authentication and generating signatures — See \href{https://docs.aws.amazon.com/AmazonS3/latest/API/sig-v4-authenticating-requests.html}{Authenticating Requests (Amazon Web Services Signature Version 4)} in the \emph{Amazon Web Services General Reference}.
\item Managing Amazon IVS permissions — See \href{https://docs.aws.amazon.com/ivs/latest/LowLatencyUserGuide/security-iam.html}{Identity and Access Management} on the Security page of the \emph{Amazon IVS User Guide}.
}

\strong{Amazon Resource Names (ARNs)}

ARNs uniquely identify AWS resources. An ARN is required when you need to specify a resource unambiguously across all of AWS, such as in IAM policies and API calls. For more information, see \href{https://docs.aws.amazon.com/IAM/latest/UserGuide/reference-arns.html}{Amazon Resource Names} in the \emph{AWS General Reference}.
}
\section{Service syntax}{


\if{html}{\out{<div class="sourceCode">}}\preformatted{svc <- ivschat(
  config = list(
    credentials = list(
      creds = list(
        access_key_id = "string",
        secret_access_key = "string",
        session_token = "string"
      ),
      profile = "string",
      anonymous = "logical"
    ),
    endpoint = "string",
    region = "string",
    close_connection = "logical",
    timeout = "numeric",
    s3_force_path_style = "logical",
    sts_regional_endpoint = "string"
  ),
  credentials = list(
    creds = list(
      access_key_id = "string",
      secret_access_key = "string",
      session_token = "string"
    ),
    profile = "string",
    anonymous = "logical"
  ),
  endpoint = "string",
  region = "string"
)
}\if{html}{\out{</div>}}
}

\section{Operations}{

\tabular{ll}{
\link[=ivschat_create_chat_token]{create_chat_token} \tab Creates an encrypted token that is used by a chat participant to establish an individual WebSocket chat connection to a room\cr
\link[=ivschat_create_logging_configuration]{create_logging_configuration} \tab Creates a logging configuration that allows clients to store and record sent messages\cr
\link[=ivschat_create_room]{create_room} \tab Creates a room that allows clients to connect and pass messages\cr
\link[=ivschat_delete_logging_configuration]{delete_logging_configuration} \tab Deletes the specified logging configuration\cr
\link[=ivschat_delete_message]{delete_message} \tab Sends an event to a specific room which directs clients to delete a specific message; that is, unrender it from view and delete it from the client’s chat history\cr
\link[=ivschat_delete_room]{delete_room} \tab Deletes the specified room\cr
\link[=ivschat_disconnect_user]{disconnect_user} \tab Disconnects all connections using a specified user ID from a room\cr
\link[=ivschat_get_logging_configuration]{get_logging_configuration} \tab Gets the specified logging configuration\cr
\link[=ivschat_get_room]{get_room} \tab Gets the specified room\cr
\link[=ivschat_list_logging_configurations]{list_logging_configurations} \tab Gets summary information about all your logging configurations in the AWS region where the API request is processed\cr
\link[=ivschat_list_rooms]{list_rooms} \tab Gets summary information about all your rooms in the AWS region where the API request is processed\cr
\link[=ivschat_list_tags_for_resource]{list_tags_for_resource} \tab Gets information about AWS tags for the specified ARN\cr
\link[=ivschat_send_event]{send_event} \tab Sends an event to a room\cr
\link[=ivschat_tag_resource]{tag_resource} \tab Adds or updates tags for the AWS resource with the specified ARN\cr
\link[=ivschat_untag_resource]{untag_resource} \tab Removes tags from the resource with the specified ARN\cr
\link[=ivschat_update_logging_configuration]{update_logging_configuration} \tab Updates a specified logging configuration\cr
\link[=ivschat_update_room]{update_room} \tab Updates a room’s configuration
}
}

\examples{
\dontrun{
svc <- ivschat()
svc$create_chat_token(
  Foo = 123
)
}

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspaces_operations.R
\name{workspaces_modify_workspace_properties}
\alias{workspaces_modify_workspace_properties}
\title{Modifies the specified WorkSpace properties}
\usage{
workspaces_modify_workspace_properties(
  WorkspaceId,
  WorkspaceProperties = NULL,
  DataReplication = NULL
)
}
\arguments{
\item{WorkspaceId}{[required] The identifier of the WorkSpace.}

\item{WorkspaceProperties}{The properties of the WorkSpace.}

\item{DataReplication}{Indicates the data replication status.}
}
\description{
Modifies the specified WorkSpace properties. For important information about how to modify the size of the root and user volumes, see \href{https://docs.aws.amazon.com/workspaces/latest/adminguide/modify-workspaces.html}{Modify a WorkSpace}.

See \url{https://www.paws-r-sdk.com/docs/workspaces_modify_workspace_properties/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workdocs_operations.R
\name{workdocs_delete_labels}
\alias{workdocs_delete_labels}
\title{Deletes the specified list of labels from a resource}
\usage{
workdocs_delete_labels(
  ResourceId,
  AuthenticationToken = NULL,
  Labels = NULL,
  DeleteAll = NULL
)
}
\arguments{
\item{ResourceId}{[required] The ID of the resource.}

\item{AuthenticationToken}{Amazon WorkDocs authentication token. Not required when using Amazon Web Services administrator credentials to access the API.}

\item{Labels}{List of labels to delete from the resource.}

\item{DeleteAll}{Flag to request removal of all labels from the specified resource.}
}
\description{
Deletes the specified list of labels from a resource.

See \url{https://www.paws-r-sdk.com/docs/workdocs_delete_labels/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_get_impersonation_role_effect}
\alias{workmail_get_impersonation_role_effect}
\title{Tests whether the given impersonation role can impersonate a target user}
\usage{
workmail_get_impersonation_role_effect(
  OrganizationId,
  ImpersonationRoleId,
  TargetUser
)
}
\arguments{
\item{OrganizationId}{[required] The WorkMail organization where the impersonation role is defined.}

\item{ImpersonationRoleId}{[required] The impersonation role ID to test.}

\item{TargetUser}{[required] The WorkMail organization user chosen to test the impersonation role. The following identity formats are available:
\itemize{
\item User ID: \code{12345678-1234-1234-1234-123456789012} or \code{S-1-1-12-1234567890-123456789-123456789-1234}
\item Email address: \code{user@domain.tld}
\item User name: \code{user}
}}
}
\description{
Tests whether the given impersonation role can impersonate a target user.

See \url{https://www.paws-r-sdk.com/docs/workmail_get_impersonation_role_effect/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/appstream_operations.R
\name{appstream_update_image_permissions}
\alias{appstream_update_image_permissions}
\title{Adds or updates permissions for the specified private image}
\usage{
appstream_update_image_permissions(Name, SharedAccountId, ImagePermissions)
}
\arguments{
\item{Name}{[required] The name of the private image.}

\item{SharedAccountId}{[required] The 12-digit identifier of the AWS account for which you want add or update image permissions.}

\item{ImagePermissions}{[required] The permissions for the image.}
}
\description{
Adds or updates permissions for the specified private image.

See \url{https://www.paws-r-sdk.com/docs/appstream_update_image_permissions/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/chatbot_operations.R
\name{chatbot_delete_microsoft_teams_user_identity}
\alias{chatbot_delete_microsoft_teams_user_identity}
\title{Identifes a user level permission for a channel configuration}
\usage{
chatbot_delete_microsoft_teams_user_identity(ChatConfigurationArn, UserId)
}
\arguments{
\item{ChatConfigurationArn}{[required] The ARN of the MicrosoftTeamsChannelConfiguration associated with the user identity to delete.}

\item{UserId}{[required] The Microsoft Teams user ID.}
}
\description{
Identifes a user level permission for a channel configuration.

See \url{https://www.paws-r-sdk.com/docs/chatbot_delete_microsoft_teams_user_identity/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/appstream_operations.R
\name{appstream_disassociate_application_from_entitlement}
\alias{appstream_disassociate_application_from_entitlement}
\title{Deletes the specified application from the specified entitlement}
\usage{
appstream_disassociate_application_from_entitlement(
  StackName,
  EntitlementName,
  ApplicationIdentifier
)
}
\arguments{
\item{StackName}{[required] The name of the stack with which the entitlement is associated.}

\item{EntitlementName}{[required] The name of the entitlement.}

\item{ApplicationIdentifier}{[required] The identifier of the application to remove from the entitlement.}
}
\description{
Deletes the specified application from the specified entitlement.

See \url{https://www.paws-r-sdk.com/docs/appstream_disassociate_application_from_entitlement/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/appstream_operations.R
\name{appstream_create_application}
\alias{appstream_create_application}
\title{Creates an application}
\usage{
appstream_create_application(
  Name,
  DisplayName = NULL,
  Description = NULL,
  IconS3Location,
  LaunchPath,
  WorkingDirectory = NULL,
  LaunchParameters = NULL,
  Platforms,
  InstanceFamilies,
  AppBlockArn,
  Tags = NULL
)
}
\arguments{
\item{Name}{[required] The name of the application. This name is visible to users when display name is not specified.}

\item{DisplayName}{The display name of the application. This name is visible to users in the application catalog.}

\item{Description}{The description of the application.}

\item{IconS3Location}{[required] The location in S3 of the application icon.}

\item{LaunchPath}{[required] The launch path of the application.}

\item{WorkingDirectory}{The working directory of the application.}

\item{LaunchParameters}{The launch parameters of the application.}

\item{Platforms}{[required] The platforms the application supports. WINDOWS_SERVER_2019, AMAZON_LINUX2 and UBUNTU_PRO_2404 are supported for Elastic fleets.}

\item{InstanceFamilies}{[required] The instance families the application supports. Valid values are GENERAL_PURPOSE and GRAPHICS_G4.}

\item{AppBlockArn}{[required] The app block ARN to which the application should be associated}

\item{Tags}{The tags assigned to the application.}
}
\description{
Creates an application.

See \url{https://www.paws-r-sdk.com/docs/appstream_create_application/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/appstream_operations.R
\name{appstream_describe_images}
\alias{appstream_describe_images}
\title{Retrieves a list that describes one or more specified images, if the
image names or image ARNs are provided}
\usage{
appstream_describe_images(
  Names = NULL,
  Arns = NULL,
  Type = NULL,
  NextToken = NULL,
  MaxResults = NULL
)
}
\arguments{
\item{Names}{The names of the public or private images to describe.}

\item{Arns}{The ARNs of the public, private, and shared images to describe.}

\item{Type}{The type of image (public, private, or shared) to describe.}

\item{NextToken}{The pagination token to use to retrieve the next page of results for this operation. If this value is null, it retrieves the first page.}

\item{MaxResults}{The maximum size of each page of results.}
}
\description{
Retrieves a list that describes one or more specified images, if the image names or image ARNs are provided. Otherwise, all images in the account are described.

See \url{https://www.paws-r-sdk.com/docs/appstream_describe_images/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workdocs_operations.R
\name{workdocs_activate_user}
\alias{workdocs_activate_user}
\title{Activates the specified user}
\usage{
workdocs_activate_user(UserId, AuthenticationToken = NULL)
}
\arguments{
\item{UserId}{[required] The ID of the user.}

\item{AuthenticationToken}{Amazon WorkDocs authentication token. Not required when using Amazon Web Services administrator credentials to access the API.}
}
\description{
Activates the specified user. Only active users can access Amazon WorkDocs.

See \url{https://www.paws-r-sdk.com/docs/workdocs_activate_user/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmailmessageflow_operations.R
\name{workmailmessageflow_get_raw_message_content}
\alias{workmailmessageflow_get_raw_message_content}
\title{Retrieves the raw content of an in-transit email message, in MIME format}
\usage{
workmailmessageflow_get_raw_message_content(messageId)
}
\arguments{
\item{messageId}{[required] The identifier of the email message to retrieve.}
}
\description{
Retrieves the raw content of an in-transit email message, in MIME format.

See \url{https://www.paws-r-sdk.com/docs/workmailmessageflow_get_raw_message_content/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ivschat_operations.R
\name{ivschat_list_tags_for_resource}
\alias{ivschat_list_tags_for_resource}
\title{Gets information about AWS tags for the specified ARN}
\usage{
ivschat_list_tags_for_resource(resourceArn)
}
\arguments{
\item{resourceArn}{[required] The ARN of the resource to be retrieved. The ARN must be URL-encoded.}
}
\description{
Gets information about AWS tags for the specified ARN.

See \url{https://www.paws-r-sdk.com/docs/ivschat_list_tags_for_resource/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_put_inbound_dmarc_settings}
\alias{workmail_put_inbound_dmarc_settings}
\title{Enables or disables a DMARC policy for a given organization}
\usage{
workmail_put_inbound_dmarc_settings(OrganizationId, Enforced)
}
\arguments{
\item{OrganizationId}{[required] The ID of the organization that you are applying the DMARC policy to.}

\item{Enforced}{[required] Enforces or suspends a policy after it's applied.}
}
\description{
Enables or disables a DMARC policy for a given organization.

See \url{https://www.paws-r-sdk.com/docs/workmail_put_inbound_dmarc_settings/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_reset_password}
\alias{workmail_reset_password}
\title{Allows the administrator to reset the password for a user}
\usage{
workmail_reset_password(OrganizationId, UserId, Password)
}
\arguments{
\item{OrganizationId}{[required] The identifier of the organization that contains the user for which the password is reset.}

\item{UserId}{[required] The identifier of the user for whom the password is reset.}

\item{Password}{[required] The new password for the user.}
}
\description{
Allows the administrator to reset the password for a user.

See \url{https://www.paws-r-sdk.com/docs/workmail_reset_password/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspacesweb_operations.R
\name{workspacesweb_expire_session}
\alias{workspacesweb_expire_session}
\title{Expires an active secure browser session}
\usage{
workspacesweb_expire_session(portalId, sessionId)
}
\arguments{
\item{portalId}{[required] The ID of the web portal for the session.}

\item{sessionId}{[required] The ID of the session to expire.}
}
\description{
Expires an active secure browser session.

See \url{https://www.paws-r-sdk.com/docs/workspacesweb_expire_session/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspacesweb_operations.R
\name{workspacesweb_create_network_settings}
\alias{workspacesweb_create_network_settings}
\title{Creates a network settings resource that can be associated with a web
portal}
\usage{
workspacesweb_create_network_settings(
  vpcId,
  subnetIds,
  securityGroupIds,
  tags = NULL,
  clientToken = NULL
)
}
\arguments{
\item{vpcId}{[required] The VPC that streaming instances will connect to.}

\item{subnetIds}{[required] The subnets in which network interfaces are created to connect streaming instances to your VPC. At least two of these subnets must be in different availability zones.}

\item{securityGroupIds}{[required] One or more security groups used to control access from streaming instances to your VPC.}

\item{tags}{The tags to add to the network settings resource. A tag is a key-value pair.}

\item{clientToken}{A unique, case-sensitive identifier that you provide to ensure the idempotency of the request. Idempotency ensures that an API request completes only once. With an idempotent request, if the original request completes successfully, subsequent retries with the same client token returns the result from the original successful request.

If you do not specify a client token, one is automatically generated by the Amazon Web Services SDK.}
}
\description{
Creates a network settings resource that can be associated with a web portal. Once associated with a web portal, network settings define how streaming instances will connect with your specified VPC.

See \url{https://www.paws-r-sdk.com/docs/workspacesweb_create_network_settings/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_test_availability_configuration}
\alias{workmail_test_availability_configuration}
\title{Performs a test on an availability provider to ensure that access is
allowed}
\usage{
workmail_test_availability_configuration(
  OrganizationId,
  DomainName = NULL,
  EwsProvider = NULL,
  LambdaProvider = NULL
)
}
\arguments{
\item{OrganizationId}{[required] The WorkMail organization where the availability provider will be tested.}

\item{DomainName}{The domain to which the provider applies. If this field is provided, a stored availability provider associated to this domain name will be tested.}

\item{EwsProvider}{Describes an EWS based availability provider. This is only used as input to the service.}

\item{LambdaProvider}{Describes a Lambda based availability provider.}
}
\description{
Performs a test on an availability provider to ensure that access is allowed. For EWS, it verifies the provided credentials can be used to successfully log in. For Lambda, it verifies that the Lambda function can be invoked and that the resource access policy was configured to deny anonymous access. An anonymous invocation is one done without providing either a \code{SourceArn} or \code{SourceAccount} header.

See \url{https://www.paws-r-sdk.com/docs/workmail_test_availability_configuration/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/appstream_operations.R
\name{appstream_create_app_block}
\alias{appstream_create_app_block}
\title{Creates an app block}
\usage{
appstream_create_app_block(
  Name,
  Description = NULL,
  DisplayName = NULL,
  SourceS3Location,
  SetupScriptDetails = NULL,
  Tags = NULL,
  PostSetupScriptDetails = NULL,
  PackagingType = NULL
)
}
\arguments{
\item{Name}{[required] The name of the app block.}

\item{Description}{The description of the app block.}

\item{DisplayName}{The display name of the app block. This is not displayed to the user.}

\item{SourceS3Location}{[required] The source S3 location of the app block.}

\item{SetupScriptDetails}{The setup script details of the app block. This must be provided for the \code{CUSTOM} PackagingType.}

\item{Tags}{The tags assigned to the app block.}

\item{PostSetupScriptDetails}{The post setup script details of the app block. This can only be provided for the \code{APPSTREAM2} PackagingType.}

\item{PackagingType}{The packaging type of the app block.}
}
\description{
Creates an app block.

See \url{https://www.paws-r-sdk.com/docs/appstream_create_app_block/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/appstream_operations.R
\name{appstream_delete_entitlement}
\alias{appstream_delete_entitlement}
\title{Deletes the specified entitlement}
\usage{
appstream_delete_entitlement(Name, StackName)
}
\arguments{
\item{Name}{[required] The name of the entitlement.}

\item{StackName}{[required] The name of the stack with which the entitlement is associated.}
}
\description{
Deletes the specified entitlement.

See \url{https://www.paws-r-sdk.com/docs/appstream_delete_entitlement/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspacesweb_operations.R
\name{workspacesweb_associate_trust_store}
\alias{workspacesweb_associate_trust_store}
\title{Associates a trust store with a web portal}
\usage{
workspacesweb_associate_trust_store(portalArn, trustStoreArn)
}
\arguments{
\item{portalArn}{[required] The ARN of the web portal.}

\item{trustStoreArn}{[required] The ARN of the trust store.}
}
\description{
Associates a trust store with a web portal.

See \url{https://www.paws-r-sdk.com/docs/workspacesweb_associate_trust_store/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_list_access_control_rules}
\alias{workmail_list_access_control_rules}
\title{Lists the access control rules for the specified organization}
\usage{
workmail_list_access_control_rules(OrganizationId)
}
\arguments{
\item{OrganizationId}{[required] The identifier for the organization.}
}
\description{
Lists the access control rules for the specified organization.

See \url{https://www.paws-r-sdk.com/docs/workmail_list_access_control_rules/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/appstream_operations.R
\name{appstream_delete_stack}
\alias{appstream_delete_stack}
\title{Deletes the specified stack}
\usage{
appstream_delete_stack(Name)
}
\arguments{
\item{Name}{[required] The name of the stack.}
}
\description{
Deletes the specified stack. After the stack is deleted, the application streaming environment provided by the stack is no longer available to users. Also, any reservations made for application streaming sessions for the stack are released.

See \url{https://www.paws-r-sdk.com/docs/appstream_delete_stack/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_list_group_members}
\alias{workmail_list_group_members}
\title{Returns an overview of the members of a group}
\usage{
workmail_list_group_members(
  OrganizationId,
  GroupId,
  NextToken = NULL,
  MaxResults = NULL
)
}
\arguments{
\item{OrganizationId}{[required] The identifier for the organization under which the group exists.}

\item{GroupId}{[required] The identifier for the group to which the members (users or groups) are associated.

The identifier can accept \emph{GroupId}, \emph{Groupname}, or \emph{email}. The following identity formats are available:
\itemize{
\item Group ID: 12345678-1234-1234-1234-123456789012 or S-1-1-12-1234567890-123456789-123456789-1234
\item Email address: group@domain.tld
\item Group name: group
}}

\item{NextToken}{The token to use to retrieve the next page of results. The first call does not contain any tokens.}

\item{MaxResults}{The maximum number of results to return in a single call.}
}
\description{
Returns an overview of the members of a group. Users and groups can be members of a group.

See \url{https://www.paws-r-sdk.com/docs/workmail_list_group_members/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/appstream_operations.R
\name{appstream_untag_resource}
\alias{appstream_untag_resource}
\title{Disassociates one or more specified tags from the specified WorkSpaces
Applications resource}
\usage{
appstream_untag_resource(ResourceArn, TagKeys)
}
\arguments{
\item{ResourceArn}{[required] The Amazon Resource Name (ARN) of the resource.}

\item{TagKeys}{[required] The tag keys for the tags to disassociate.}
}
\description{
Disassociates one or more specified tags from the specified WorkSpaces Applications resource.

See \url{https://www.paws-r-sdk.com/docs/appstream_untag_resource/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/appstream_operations.R
\name{appstream_describe_app_license_usage}
\alias{appstream_describe_app_license_usage}
\title{Retrieves license included application usage information}
\usage{
appstream_describe_app_license_usage(
  BillingPeriod,
  MaxResults = NULL,
  NextToken = NULL
)
}
\arguments{
\item{BillingPeriod}{[required] Billing period for the usage record.

Specify the value in \emph{yyyy-mm} format. For example, for August 2025, use \emph{2025-08}.}

\item{MaxResults}{The maximum number of results to return.}

\item{NextToken}{Token for pagination of results.}
}
\description{
Retrieves license included application usage information.

See \url{https://www.paws-r-sdk.com/docs/appstream_describe_app_license_usage/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_delete_identity_provider_configuration}
\alias{workmail_delete_identity_provider_configuration}
\title{Disables the integration between IdC and WorkMail}
\usage{
workmail_delete_identity_provider_configuration(OrganizationId)
}
\arguments{
\item{OrganizationId}{[required] The Organization ID.}
}
\description{
Disables the integration between IdC and WorkMail. Authentication will continue with the directory as it was before the IdC integration. You might have to reset your directory passwords and reconfigure your desktop and mobile email clients.

See \url{https://www.paws-r-sdk.com/docs/workmail_delete_identity_provider_configuration/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_deregister_mail_domain}
\alias{workmail_deregister_mail_domain}
\title{Removes a domain from WorkMail, stops email routing to WorkMail, and
removes the authorization allowing WorkMail use}
\usage{
workmail_deregister_mail_domain(OrganizationId, DomainName)
}
\arguments{
\item{OrganizationId}{[required] The WorkMail organization for which the domain will be deregistered.}

\item{DomainName}{[required] The domain to deregister in WorkMail and SES.}
}
\description{
Removes a domain from WorkMail, stops email routing to WorkMail, and removes the authorization allowing WorkMail use. SES keeps the domain because other applications may use it. You must first remove any email address used by WorkMail entities before you remove the domain.

See \url{https://www.paws-r-sdk.com/docs/workmail_deregister_mail_domain/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspaces_service.R
\name{workspaces}
\alias{workspaces}
\title{Amazon WorkSpaces}
\usage{
workspaces(
  config = list(),
  credentials = list(),
  endpoint = NULL,
  region = NULL
)
}
\arguments{
\item{config}{Optional configuration of credentials, endpoint, and/or region.
\itemize{
\item{\strong{credentials}: \itemize{
\item{\strong{creds}: \itemize{
\item{\strong{access_key_id}: AWS access key ID}
\item{\strong{secret_access_key}: AWS secret access key}
\item{\strong{session_token}: AWS temporary session token}
}}
\item{\strong{profile}: The name of a profile to use. If not given, then the default profile is used.}
\item{\strong{anonymous}: Set anonymous credentials.}
}}
\item{\strong{endpoint}: The complete URL to use for the constructed client.}
\item{\strong{region}: The AWS Region used in instantiating the client.}
\item{\strong{close_connection}: Immediately close all HTTP connections.}
\item{\strong{timeout}: The time in seconds till a timeout exception is thrown when attempting to make a connection. The default is 60 seconds.}
\item{\strong{s3_force_path_style}: Set this to \code{true} to force the request to use path-style addressing, i.e. \verb{http://s3.amazonaws.com/BUCKET/KEY}.}
\item{\strong{sts_regional_endpoint}: Set sts regional endpoint resolver to regional or legacy \url{https://docs.aws.amazon.com/sdkref/latest/guide/feature-sts-regionalized-endpoints.html}}
}}

\item{credentials}{Optional credentials shorthand for the config parameter
\itemize{
\item{\strong{creds}: \itemize{
\item{\strong{access_key_id}: AWS access key ID}
\item{\strong{secret_access_key}: AWS secret access key}
\item{\strong{session_token}: AWS temporary session token}
}}
\item{\strong{profile}: The name of a profile to use. If not given, then the default profile is used.}
\item{\strong{anonymous}: Set anonymous credentials.}
}}

\item{endpoint}{Optional shorthand for complete URL to use for the constructed client.}

\item{region}{Optional shorthand for AWS Region used in instantiating the client.}
}
\value{
A client for the service. You can call the service's operations using
syntax like \code{svc$operation(...)}, where \code{svc} is the name you've assigned
to the client. The available operations are listed in the
Operations section.
}
\description{
Amazon WorkSpaces Service

Amazon WorkSpaces enables you to provision virtual, cloud-based Microsoft Windows or Amazon Linux desktops for your users, known as \emph{WorkSpaces}. WorkSpaces eliminates the need to procure and deploy hardware or install complex software. You can quickly add or remove users as your needs change. Users can access their virtual desktops from multiple devices or web browsers.

This API Reference provides detailed information about the actions, data types, parameters, and errors of the WorkSpaces service. For more information about the supported Amazon Web Services Regions, endpoints, and service quotas of the Amazon WorkSpaces service, see \href{https://docs.aws.amazon.com/general/latest/gr/wsp.html}{WorkSpaces endpoints and quotas} in the \emph{Amazon Web Services General Reference}.

You can also manage your WorkSpaces resources using the WorkSpaces console, Command Line Interface (CLI), and SDKs. For more information about administering WorkSpaces, see the \href{https://docs.aws.amazon.com/workspaces/latest/adminguide/}{Amazon WorkSpaces Administration Guide}. For more information about using the Amazon WorkSpaces client application or web browser to access provisioned WorkSpaces, see the \href{https://docs.aws.amazon.com/workspaces/latest/userguide/}{Amazon WorkSpaces User Guide}. For more information about using the CLI to manage your WorkSpaces resources, see the \href{https://docs.aws.amazon.com/cli/latest/reference/workspaces/}{WorkSpaces section of the CLI Reference}.
}
\section{Service syntax}{


\if{html}{\out{<div class="sourceCode">}}\preformatted{svc <- workspaces(
  config = list(
    credentials = list(
      creds = list(
        access_key_id = "string",
        secret_access_key = "string",
        session_token = "string"
      ),
      profile = "string",
      anonymous = "logical"
    ),
    endpoint = "string",
    region = "string",
    close_connection = "logical",
    timeout = "numeric",
    s3_force_path_style = "logical",
    sts_regional_endpoint = "string"
  ),
  credentials = list(
    creds = list(
      access_key_id = "string",
      secret_access_key = "string",
      session_token = "string"
    ),
    profile = "string",
    anonymous = "logical"
  ),
  endpoint = "string",
  region = "string"
)
}\if{html}{\out{</div>}}
}

\section{Operations}{

\tabular{ll}{
\link[=workspaces_accept_account_link_invitation]{accept_account_link_invitation} \tab Accepts the account link invitation\cr
\link[=workspaces_associate_connection_alias]{associate_connection_alias} \tab Associates the specified connection alias with the specified directory to enable cross-Region redirection\cr
\link[=workspaces_associate_ip_groups]{associate_ip_groups} \tab Associates the specified IP access control group with the specified directory\cr
\link[=workspaces_associate_workspace_application]{associate_workspace_application} \tab Associates the specified application to the specified WorkSpace\cr
\link[=workspaces_authorize_ip_rules]{authorize_ip_rules} \tab Adds one or more rules to the specified IP access control group\cr
\link[=workspaces_copy_workspace_image]{copy_workspace_image} \tab Copies the specified image from the specified Region to the current Region\cr
\link[=workspaces_create_account_link_invitation]{create_account_link_invitation} \tab Creates the account link invitation\cr
\link[=workspaces_create_connect_client_add_in]{create_connect_client_add_in} \tab Creates a client-add-in for Amazon Connect within a directory\cr
\link[=workspaces_create_connection_alias]{create_connection_alias} \tab Creates the specified connection alias for use with cross-Region redirection\cr
\link[=workspaces_create_ip_group]{create_ip_group} \tab Creates an IP access control group\cr
\link[=workspaces_create_standby_workspaces]{create_standby_workspaces} \tab Creates a standby WorkSpace in a secondary Region\cr
\link[=workspaces_create_tags]{create_tags} \tab Creates the specified tags for the specified WorkSpaces resource\cr
\link[=workspaces_create_updated_workspace_image]{create_updated_workspace_image} \tab Creates a new updated WorkSpace image based on the specified source image\cr
\link[=workspaces_create_workspace_bundle]{create_workspace_bundle} \tab Creates the specified WorkSpace bundle\cr
\link[=workspaces_create_workspace_image]{create_workspace_image} \tab Creates a new WorkSpace image from an existing WorkSpace\cr
\link[=workspaces_create_workspaces]{create_workspaces} \tab Creates one or more WorkSpaces\cr
\link[=workspaces_create_workspaces_pool]{create_workspaces_pool} \tab Creates a pool of WorkSpaces\cr
\link[=workspaces_delete_account_link_invitation]{delete_account_link_invitation} \tab Deletes the account link invitation\cr
\link[=workspaces_delete_client_branding]{delete_client_branding} \tab Deletes customized client branding\cr
\link[=workspaces_delete_connect_client_add_in]{delete_connect_client_add_in} \tab Deletes a client-add-in for Amazon Connect that is configured within a directory\cr
\link[=workspaces_delete_connection_alias]{delete_connection_alias} \tab Deletes the specified connection alias\cr
\link[=workspaces_delete_ip_group]{delete_ip_group} \tab Deletes the specified IP access control group\cr
\link[=workspaces_delete_tags]{delete_tags} \tab Deletes the specified tags from the specified WorkSpaces resource\cr
\link[=workspaces_delete_workspace_bundle]{delete_workspace_bundle} \tab Deletes the specified WorkSpace bundle\cr
\link[=workspaces_delete_workspace_image]{delete_workspace_image} \tab Deletes the specified image from your account\cr
\link[=workspaces_deploy_workspace_applications]{deploy_workspace_applications} \tab Deploys associated applications to the specified WorkSpace\cr
\link[=workspaces_deregister_workspace_directory]{deregister_workspace_directory} \tab Deregisters the specified directory\cr
\link[=workspaces_describe_account]{describe_account} \tab Retrieves a list that describes the configuration of Bring Your Own License (BYOL) for the specified account\cr
\link[=workspaces_describe_account_modifications]{describe_account_modifications} \tab Retrieves a list that describes modifications to the configuration of Bring Your Own License (BYOL) for the specified account\cr
\link[=workspaces_describe_application_associations]{describe_application_associations} \tab Describes the associations between the application and the specified associated resources\cr
\link[=workspaces_describe_applications]{describe_applications} \tab Describes the specified applications by filtering based on their compute types, license availability, operating systems, and owners\cr
\link[=workspaces_describe_bundle_associations]{describe_bundle_associations} \tab Describes the associations between the applications and the specified bundle\cr
\link[=workspaces_describe_client_branding]{describe_client_branding} \tab Describes the specified client branding\cr
\link[=workspaces_describe_client_properties]{describe_client_properties} \tab Retrieves a list that describes one or more specified Amazon WorkSpaces clients\cr
\link[=workspaces_describe_connect_client_add_ins]{describe_connect_client_add_ins} \tab Retrieves a list of Amazon Connect client add-ins that have been created\cr
\link[=workspaces_describe_connection_aliases]{describe_connection_aliases} \tab Retrieves a list that describes the connection aliases used for cross-Region redirection\cr
\link[=workspaces_describe_connection_alias_permissions]{describe_connection_alias_permissions} \tab Describes the permissions that the owner of a connection alias has granted to another Amazon Web Services account for the specified connection alias\cr
\link[=workspaces_describe_custom_workspace_image_import]{describe_custom_workspace_image_import} \tab Retrieves information about a WorkSpace BYOL image being imported via ImportCustomWorkspaceImage\cr
\link[=workspaces_describe_image_associations]{describe_image_associations} \tab Describes the associations between the applications and the specified image\cr
\link[=workspaces_describe_ip_groups]{describe_ip_groups} \tab Describes one or more of your IP access control groups\cr
\link[=workspaces_describe_tags]{describe_tags} \tab Describes the specified tags for the specified WorkSpaces resource\cr
\link[=workspaces_describe_workspace_associations]{describe_workspace_associations} \tab Describes the associations betweens applications and the specified WorkSpace\cr
\link[=workspaces_describe_workspace_bundles]{describe_workspace_bundles} \tab Retrieves a list that describes the available WorkSpace bundles\cr
\link[=workspaces_describe_workspace_directories]{describe_workspace_directories} \tab Describes the available directories that are registered with Amazon WorkSpaces\cr
\link[=workspaces_describe_workspace_image_permissions]{describe_workspace_image_permissions} \tab Describes the permissions that the owner of an image has granted to other Amazon Web Services accounts for an image\cr
\link[=workspaces_describe_workspace_images]{describe_workspace_images} \tab Retrieves a list that describes one or more specified images, if the image identifiers are provided\cr
\link[=workspaces_describe_workspaces]{describe_workspaces} \tab Describes the specified WorkSpaces\cr
\link[=workspaces_describe_workspaces_connection_status]{describe_workspaces_connection_status} \tab Describes the connection status of the specified WorkSpaces\cr
\link[=workspaces_describe_workspace_snapshots]{describe_workspace_snapshots} \tab Describes the snapshots for the specified WorkSpace\cr
\link[=workspaces_describe_workspaces_pools]{describe_workspaces_pools} \tab Describes the specified WorkSpaces Pools\cr
\link[=workspaces_describe_workspaces_pool_sessions]{describe_workspaces_pool_sessions} \tab Retrieves a list that describes the streaming sessions for a specified pool\cr
\link[=workspaces_disassociate_connection_alias]{disassociate_connection_alias} \tab Disassociates a connection alias from a directory\cr
\link[=workspaces_disassociate_ip_groups]{disassociate_ip_groups} \tab Disassociates the specified IP access control group from the specified directory\cr
\link[=workspaces_disassociate_workspace_application]{disassociate_workspace_application} \tab Disassociates the specified application from a WorkSpace\cr
\link[=workspaces_get_account_link]{get_account_link} \tab Retrieves account link information\cr
\link[=workspaces_import_client_branding]{import_client_branding} \tab Imports client branding\cr
\link[=workspaces_import_custom_workspace_image]{import_custom_workspace_image} \tab Imports the specified Windows 10 or 11 Bring Your Own License (BYOL) image into Amazon WorkSpaces using EC2 Image Builder\cr
\link[=workspaces_import_workspace_image]{import_workspace_image} \tab Imports the specified Windows 10 or 11 Bring Your Own License (BYOL) image into Amazon WorkSpaces\cr
\link[=workspaces_list_account_links]{list_account_links} \tab Lists all account links\cr
\link[=workspaces_list_available_management_cidr_ranges]{list_available_management_cidr_ranges} \tab Retrieves a list of IP address ranges, specified as IPv4 CIDR blocks, that you can use for the network management interface when you enable Bring Your Own License (BYOL)\cr
\link[=workspaces_migrate_workspace]{migrate_workspace} \tab Migrates a WorkSpace from one operating system or bundle type to another, while retaining the data on the user volume\cr
\link[=workspaces_modify_account]{modify_account} \tab Modifies the configuration of Bring Your Own License (BYOL) for the specified account\cr
\link[=workspaces_modify_certificate_based_auth_properties]{modify_certificate_based_auth_properties} \tab Modifies the properties of the certificate-based authentication you want to use with your WorkSpaces\cr
\link[=workspaces_modify_client_properties]{modify_client_properties} \tab Modifies the properties of the specified Amazon WorkSpaces clients\cr
\link[=workspaces_modify_endpoint_encryption_mode]{modify_endpoint_encryption_mode} \tab Modifies the endpoint encryption mode that allows you to configure the specified directory between Standard TLS and FIPS 140-2 validated mode\cr
\link[=workspaces_modify_saml_properties]{modify_saml_properties} \tab Modifies multiple properties related to SAML 2\cr
\link[=workspaces_modify_selfservice_permissions]{modify_selfservice_permissions} \tab Modifies the self-service WorkSpace management capabilities for your users\cr
\link[=workspaces_modify_streaming_properties]{modify_streaming_properties} \tab Modifies the specified streaming properties\cr
\link[=workspaces_modify_workspace_access_properties]{modify_workspace_access_properties} \tab Specifies which devices and operating systems users can use to access their WorkSpaces\cr
\link[=workspaces_modify_workspace_creation_properties]{modify_workspace_creation_properties} \tab Modify the default properties used to create WorkSpaces\cr
\link[=workspaces_modify_workspace_properties]{modify_workspace_properties} \tab Modifies the specified WorkSpace properties\cr
\link[=workspaces_modify_workspace_state]{modify_workspace_state} \tab Sets the state of the specified WorkSpace\cr
\link[=workspaces_reboot_workspaces]{reboot_workspaces} \tab Reboots the specified WorkSpaces\cr
\link[=workspaces_rebuild_workspaces]{rebuild_workspaces} \tab Rebuilds the specified WorkSpace\cr
\link[=workspaces_register_workspace_directory]{register_workspace_directory} \tab Registers the specified directory\cr
\link[=workspaces_reject_account_link_invitation]{reject_account_link_invitation} \tab Rejects the account link invitation\cr
\link[=workspaces_restore_workspace]{restore_workspace} \tab Restores the specified WorkSpace to its last known healthy state\cr
\link[=workspaces_revoke_ip_rules]{revoke_ip_rules} \tab Removes one or more rules from the specified IP access control group\cr
\link[=workspaces_start_workspaces]{start_workspaces} \tab Starts the specified WorkSpaces\cr
\link[=workspaces_start_workspaces_pool]{start_workspaces_pool} \tab Starts the specified pool\cr
\link[=workspaces_stop_workspaces]{stop_workspaces} \tab Stops the specified WorkSpaces\cr
\link[=workspaces_stop_workspaces_pool]{stop_workspaces_pool} \tab Stops the specified pool\cr
\link[=workspaces_terminate_workspaces]{terminate_workspaces} \tab Terminates the specified WorkSpaces\cr
\link[=workspaces_terminate_workspaces_pool]{terminate_workspaces_pool} \tab Terminates the specified pool\cr
\link[=workspaces_terminate_workspaces_pool_session]{terminate_workspaces_pool_session} \tab Terminates the pool session\cr
\link[=workspaces_update_connect_client_add_in]{update_connect_client_add_in} \tab Updates a Amazon Connect client add-in\cr
\link[=workspaces_update_connection_alias_permission]{update_connection_alias_permission} \tab Shares or unshares a connection alias with one account by specifying whether that account has permission to associate the connection alias with a directory\cr
\link[=workspaces_update_rules_of_ip_group]{update_rules_of_ip_group} \tab Replaces the current rules of the specified IP access control group with the specified rules\cr
\link[=workspaces_update_workspace_bundle]{update_workspace_bundle} \tab Updates a WorkSpace bundle with a new image\cr
\link[=workspaces_update_workspace_image_permission]{update_workspace_image_permission} \tab Shares or unshares an image with one account in the same Amazon Web Services Region by specifying whether that account has permission to copy the image\cr
\link[=workspaces_update_workspaces_pool]{update_workspaces_pool} \tab Updates the specified pool
}
}

\examples{
\dontrun{
svc <- workspaces()
svc$accept_account_link_invitation(
  Foo = 123
)
}

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/appstream_operations.R
\name{appstream_create_updated_image}
\alias{appstream_create_updated_image}
\title{Creates a new image with the latest Windows operating system updates,
driver updates, and WorkSpaces Applications agent software}
\usage{
appstream_create_updated_image(
  existingImageName,
  newImageName,
  newImageDescription = NULL,
  newImageDisplayName = NULL,
  newImageTags = NULL,
  dryRun = NULL
)
}
\arguments{
\item{existingImageName}{[required] The name of the image to update.}

\item{newImageName}{[required] The name of the new image. The name must be unique within the AWS account and Region.}

\item{newImageDescription}{The description to display for the new image.}

\item{newImageDisplayName}{The name to display for the new image.}

\item{newImageTags}{The tags to associate with the new image. A tag is a key-value pair, and the value is optional. For example, Environment=Test. If you do not specify a value, Environment=.

Generally allowed characters are: letters, numbers, and spaces representable in UTF-8, and the following special characters:

_ . : / = + \\ - @

If you do not specify a value, the value is set to an empty string.

For more information about tags, see \href{https://docs.aws.amazon.com/appstream2/latest/developerguide/tagging-basic.html}{Tagging Your Resources} in the \emph{Amazon WorkSpaces Applications Administration Guide}.}

\item{dryRun}{Indicates whether to display the status of image update availability before WorkSpaces Applications initiates the process of creating a new updated image. If this value is set to \code{true}, WorkSpaces Applications displays whether image updates are available. If this value is set to \code{false}, WorkSpaces Applications initiates the process of creating a new updated image without displaying whether image updates are available.}
}
\description{
Creates a new image with the latest Windows operating system updates, driver updates, and WorkSpaces Applications agent software.

See \url{https://www.paws-r-sdk.com/docs/appstream_create_updated_image/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspaces_operations.R
\name{workspaces_modify_streaming_properties}
\alias{workspaces_modify_streaming_properties}
\title{Modifies the specified streaming properties}
\usage{
workspaces_modify_streaming_properties(ResourceId, StreamingProperties = NULL)
}
\arguments{
\item{ResourceId}{[required] The identifier of the resource.}

\item{StreamingProperties}{The streaming properties to configure.}
}
\description{
Modifies the specified streaming properties.

See \url{https://www.paws-r-sdk.com/docs/workspaces_modify_streaming_properties/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspaces_operations.R
\name{workspaces_describe_workspace_directories}
\alias{workspaces_describe_workspace_directories}
\title{Describes the available directories that are registered with Amazon
WorkSpaces}
\usage{
workspaces_describe_workspace_directories(
  DirectoryIds = NULL,
  WorkspaceDirectoryNames = NULL,
  Limit = NULL,
  NextToken = NULL,
  Filters = NULL
)
}
\arguments{
\item{DirectoryIds}{The identifiers of the directories. If the value is null, all directories are retrieved.}

\item{WorkspaceDirectoryNames}{The names of the WorkSpace directories.}

\item{Limit}{The maximum number of directories to return.}

\item{NextToken}{If you received a \code{NextToken} from a previous call that was paginated, provide this token to receive the next set of results.}

\item{Filters}{The filter condition for the WorkSpaces.}
}
\description{
Describes the available directories that are registered with Amazon WorkSpaces.

See \url{https://www.paws-r-sdk.com/docs/workspaces_describe_workspace_directories/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspaces_operations.R
\name{workspaces_delete_client_branding}
\alias{workspaces_delete_client_branding}
\title{Deletes customized client branding}
\usage{
workspaces_delete_client_branding(ResourceId, Platforms)
}
\arguments{
\item{ResourceId}{[required] The directory identifier of the WorkSpace for which you want to delete client branding.}

\item{Platforms}{[required] The device type for which you want to delete client branding.}
}
\description{
Deletes customized client branding. Client branding allows you to customize your WorkSpace's client login portal. You can tailor your login portal company logo, the support email address, support link, link to reset password, and a custom message for users trying to sign in.

See \url{https://www.paws-r-sdk.com/docs/workspaces_delete_client_branding/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/appstream_operations.R
\name{appstream_describe_user_stack_associations}
\alias{appstream_describe_user_stack_associations}
\title{Retrieves a list that describes the UserStackAssociation objects}
\usage{
appstream_describe_user_stack_associations(
  StackName = NULL,
  UserName = NULL,
  AuthenticationType = NULL,
  MaxResults = NULL,
  NextToken = NULL
)
}
\arguments{
\item{StackName}{The name of the stack that is associated with the user.}

\item{UserName}{The email address of the user who is associated with the stack.

Users' email addresses are case-sensitive.}

\item{AuthenticationType}{The authentication type for the user who is associated with the stack. You must specify USERPOOL.}

\item{MaxResults}{The maximum size of each page of results.}

\item{NextToken}{The pagination token to use to retrieve the next page of results for this operation. If this value is null, it retrieves the first page.}
}
\description{
Retrieves a list that describes the UserStackAssociation objects. You must specify either or both of the following:

See \url{https://www.paws-r-sdk.com/docs/appstream_describe_user_stack_associations/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/appstream_operations.R
\name{appstream_describe_entitlements}
\alias{appstream_describe_entitlements}
\title{Retrieves a list that describes one of more entitlements}
\usage{
appstream_describe_entitlements(
  Name = NULL,
  StackName,
  NextToken = NULL,
  MaxResults = NULL
)
}
\arguments{
\item{Name}{The name of the entitlement.}

\item{StackName}{[required] The name of the stack with which the entitlement is associated.}

\item{NextToken}{The pagination token used to retrieve the next page of results for this operation.}

\item{MaxResults}{The maximum size of each page of results.}
}
\description{
Retrieves a list that describes one of more entitlements.

See \url{https://www.paws-r-sdk.com/docs/appstream_describe_entitlements/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/appstream_operations.R
\name{appstream_enable_user}
\alias{appstream_enable_user}
\title{Enables a user in the user pool}
\usage{
appstream_enable_user(UserName, AuthenticationType)
}
\arguments{
\item{UserName}{[required] The email address of the user.

Users' email addresses are case-sensitive. During login, if they specify an email address that doesn't use the same capitalization as the email address specified when their user pool account was created, a "user does not exist" error message displays.}

\item{AuthenticationType}{[required] The authentication type for the user. You must specify USERPOOL.}
}
\description{
Enables a user in the user pool. After being enabled, users can sign in to WorkSpaces Applications and open applications from the stacks to which they are assigned.

See \url{https://www.paws-r-sdk.com/docs/appstream_enable_user/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspacesweb_operations.R
\name{workspacesweb_delete_trust_store}
\alias{workspacesweb_delete_trust_store}
\title{Deletes the trust store}
\usage{
workspacesweb_delete_trust_store(trustStoreArn)
}
\arguments{
\item{trustStoreArn}{[required] The ARN of the trust store.}
}
\description{
Deletes the trust store.

See \url{https://www.paws-r-sdk.com/docs/workspacesweb_delete_trust_store/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspacesweb_operations.R
\name{workspacesweb_create_identity_provider}
\alias{workspacesweb_create_identity_provider}
\title{Creates an identity provider resource that is then associated with a web
portal}
\usage{
workspacesweb_create_identity_provider(
  portalArn,
  identityProviderName,
  identityProviderType,
  identityProviderDetails,
  clientToken = NULL,
  tags = NULL
)
}
\arguments{
\item{portalArn}{[required] The ARN of the web portal.}

\item{identityProviderName}{[required] The identity provider name.}

\item{identityProviderType}{[required] The identity provider type.}

\item{identityProviderDetails}{[required] The identity provider details. The following list describes the provider detail keys for each identity provider type.
\itemize{
\item For Google and Login with Amazon:
\itemize{
\item \code{client_id}
\item \code{client_secret}
\item \code{authorize_scopes}
}
\item For Facebook:
\itemize{
\item \code{client_id}
\item \code{client_secret}
\item \code{authorize_scopes}
\item \code{api_version}
}
\item For Sign in with Apple:
\itemize{
\item \code{client_id}
\item \code{team_id}
\item \code{key_id}
\item \code{private_key}
\item \code{authorize_scopes}
}
\item For OIDC providers:
\itemize{
\item \code{client_id}
\item \code{client_secret}
\item \code{attributes_request_method}
\item \code{oidc_issuer}
\item \code{authorize_scopes}
\item \code{authorize_url} \emph{if not available from discovery URL specified by oidc_issuer key}
\item \code{token_url} \emph{if not available from discovery URL specified by oidc_issuer key}
\item \code{attributes_url} \emph{if not available from discovery URL specified by oidc_issuer key}
\item \code{jwks_uri} \emph{if not available from discovery URL specified by oidc_issuer key}
}
\item For SAML providers:
\itemize{
\item \code{MetadataFile} OR \code{MetadataURL}
\item \code{IDPSignout} (boolean) \emph{optional}
\item \code{IDPInit} (boolean) \emph{optional}
\item \code{RequestSigningAlgorithm} (string) \emph{optional} - Only accepts \code{rsa-sha256}
\item \code{EncryptedResponses} (boolean) \emph{optional}
}
}}

\item{clientToken}{A unique, case-sensitive identifier that you provide to ensure the idempotency of the request. Idempotency ensures that an API request completes only once. With an idempotent request, if the original request completes successfully, subsequent retries with the same client token returns the result from the original successful request.

If you do not specify a client token, one is automatically generated by the Amazon Web Services SDK.}

\item{tags}{The tags to add to the identity provider resource. A tag is a key-value pair.}
}
\description{
Creates an identity provider resource that is then associated with a web portal.

See \url{https://www.paws-r-sdk.com/docs/workspacesweb_create_identity_provider/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspacesweb_operations.R
\name{workspacesweb_update_trust_store}
\alias{workspacesweb_update_trust_store}
\title{Updates the trust store}
\usage{
workspacesweb_update_trust_store(
  trustStoreArn,
  certificatesToAdd = NULL,
  certificatesToDelete = NULL,
  clientToken = NULL
)
}
\arguments{
\item{trustStoreArn}{[required] The ARN of the trust store.}

\item{certificatesToAdd}{A list of CA certificates to add to the trust store.}

\item{certificatesToDelete}{A list of CA certificates to delete from a trust store.}

\item{clientToken}{A unique, case-sensitive identifier that you provide to ensure the idempotency of the request. Idempotency ensures that an API request completes only once. With an idempotent request, if the original request completes successfully, subsequent retries with the same client token return the result from the original successful request.

If you do not specify a client token, one is automatically generated by the Amazon Web Services SDK.}
}
\description{
Updates the trust store.

See \url{https://www.paws-r-sdk.com/docs/workspacesweb_update_trust_store/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspaces_operations.R
\name{workspaces_describe_workspace_snapshots}
\alias{workspaces_describe_workspace_snapshots}
\title{Describes the snapshots for the specified WorkSpace}
\usage{
workspaces_describe_workspace_snapshots(WorkspaceId)
}
\arguments{
\item{WorkspaceId}{[required] The identifier of the WorkSpace.}
}
\description{
Describes the snapshots for the specified WorkSpace.

See \url{https://www.paws-r-sdk.com/docs/workspaces_describe_workspace_snapshots/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/appstream_operations.R
\name{appstream_create_usage_report_subscription}
\alias{appstream_create_usage_report_subscription}
\title{Creates a usage report subscription}
\usage{
appstream_create_usage_report_subscription()
}
\description{
Creates a usage report subscription. Usage reports are generated daily.

See \url{https://www.paws-r-sdk.com/docs/appstream_create_usage_report_subscription/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ivschat_operations.R
\name{ivschat_delete_logging_configuration}
\alias{ivschat_delete_logging_configuration}
\title{Deletes the specified logging configuration}
\usage{
ivschat_delete_logging_configuration(identifier)
}
\arguments{
\item{identifier}{[required] Identifier of the logging configuration to be deleted.}
}
\description{
Deletes the specified logging configuration.

See \url{https://www.paws-r-sdk.com/docs/ivschat_delete_logging_configuration/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/appstream_operations.R
\name{appstream_describe_theme_for_stack}
\alias{appstream_describe_theme_for_stack}
\title{Retrieves a list that describes the theme for a specified stack}
\usage{
appstream_describe_theme_for_stack(StackName)
}
\arguments{
\item{StackName}{[required] The name of the stack for the theme.}
}
\description{
Retrieves a list that describes the theme for a specified stack. A theme is custom branding that customizes the appearance of the streaming application catalog page.

See \url{https://www.paws-r-sdk.com/docs/appstream_describe_theme_for_stack/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/chatbot_operations.R
\name{chatbot_create_slack_channel_configuration}
\alias{chatbot_create_slack_channel_configuration}
\title{Creates an AWS Chatbot confugration for Slack}
\usage{
chatbot_create_slack_channel_configuration(
  SlackTeamId,
  SlackChannelId,
  SlackChannelName = NULL,
  SnsTopicArns = NULL,
  IamRoleArn,
  ConfigurationName,
  LoggingLevel = NULL,
  GuardrailPolicyArns = NULL,
  UserAuthorizationRequired = NULL,
  Tags = NULL
)
}
\arguments{
\item{SlackTeamId}{[required] The ID of the Slack workspace authorized with AWS Chatbot.}

\item{SlackChannelId}{[required] The ID of the Slack channel.

To get this ID, open Slack, right click on the channel name in the left pane, then choose Copy Link. The channel ID is the 9-character string at the end of the URL. For example, ABCBBLZZZ.}

\item{SlackChannelName}{The name of the Slack channel.}

\item{SnsTopicArns}{The Amazon Resource Names (ARNs) of the SNS topics that deliver notifications to AWS Chatbot.}

\item{IamRoleArn}{[required] A user-defined role that AWS Chatbot assumes. This is not the service-linked role.

For more information, see \href{https://docs.aws.amazon.com/chatbot/latest/adminguide/chatbot-iam-policies.html}{IAM policies for AWS Chatbot} in the \emph{AWS Chatbot Administrator Guide}.}

\item{ConfigurationName}{[required] The name of the configuration.}

\item{LoggingLevel}{Logging levels include \code{ERROR}, \code{INFO}, or \code{NONE}.}

\item{GuardrailPolicyArns}{The list of IAM policy ARNs that are applied as channel guardrails. The AWS managed \code{AdministratorAccess} policy is applied by default if this is not set.}

\item{UserAuthorizationRequired}{Enables use of a user role requirement in your chat configuration.}

\item{Tags}{A map of tags assigned to a resource. A tag is a string-to-string map of key-value pairs.}
}
\description{
Creates an AWS Chatbot confugration for Slack.

See \url{https://www.paws-r-sdk.com/docs/chatbot_create_slack_channel_configuration/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspaces_operations.R
\name{workspaces_update_workspaces_pool}
\alias{workspaces_update_workspaces_pool}
\title{Updates the specified pool}
\usage{
workspaces_update_workspaces_pool(
  PoolId,
  Description = NULL,
  BundleId = NULL,
  DirectoryId = NULL,
  Capacity = NULL,
  ApplicationSettings = NULL,
  TimeoutSettings = NULL,
  RunningMode = NULL
)
}
\arguments{
\item{PoolId}{[required] The identifier of the specified pool to update.}

\item{Description}{Describes the specified pool to update.}

\item{BundleId}{The identifier of the bundle.}

\item{DirectoryId}{The identifier of the directory.}

\item{Capacity}{The desired capacity for the pool.}

\item{ApplicationSettings}{The persistent application settings for users in the pool.}

\item{TimeoutSettings}{Indicates the timeout settings of the specified pool.}

\item{RunningMode}{The desired running mode for the pool. The running mode can only be updated when the pool is in a stopped state.}
}
\description{
Updates the specified pool.

See \url{https://www.paws-r-sdk.com/docs/workspaces_update_workspaces_pool/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/appstream_operations.R
\name{appstream_disable_user}
\alias{appstream_disable_user}
\title{Disables the specified user in the user pool}
\usage{
appstream_disable_user(UserName, AuthenticationType)
}
\arguments{
\item{UserName}{[required] The email address of the user.

Users' email addresses are case-sensitive.}

\item{AuthenticationType}{[required] The authentication type for the user. You must specify USERPOOL.}
}
\description{
Disables the specified user in the user pool. Users can't sign in to WorkSpaces Applications until they are re-enabled. This action does not delete the user.

See \url{https://www.paws-r-sdk.com/docs/appstream_disable_user/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/appstream_operations.R
\name{appstream_update_fleet}
\alias{appstream_update_fleet}
\title{Updates the specified fleet}
\usage{
appstream_update_fleet(
  ImageName = NULL,
  ImageArn = NULL,
  Name = NULL,
  InstanceType = NULL,
  ComputeCapacity = NULL,
  VpcConfig = NULL,
  MaxUserDurationInSeconds = NULL,
  DisconnectTimeoutInSeconds = NULL,
  DeleteVpcConfig = NULL,
  Description = NULL,
  DisplayName = NULL,
  EnableDefaultInternetAccess = NULL,
  DomainJoinInfo = NULL,
  IdleDisconnectTimeoutInSeconds = NULL,
  AttributesToDelete = NULL,
  IamRoleArn = NULL,
  StreamView = NULL,
  Platform = NULL,
  MaxConcurrentSessions = NULL,
  UsbDeviceFilterStrings = NULL,
  SessionScriptS3Location = NULL,
  MaxSessionsPerInstance = NULL,
  RootVolumeConfig = NULL,
  DisableIMDSV1 = NULL
)
}
\arguments{
\item{ImageName}{The name of the image used to create the fleet.}

\item{ImageArn}{The ARN of the public, private, or shared image to use.}

\item{Name}{A unique name for the fleet.}

\item{InstanceType}{The instance type to use when launching fleet instances. The following instance types are available:
\itemize{
\item stream.standard.small
\item stream.standard.medium
\item stream.standard.large
\item stream.standard.xlarge
\item stream.standard.2xlarge
\item stream.compute.large
\item stream.compute.xlarge
\item stream.compute.2xlarge
\item stream.compute.4xlarge
\item stream.compute.8xlarge
\item stream.memory.large
\item stream.memory.xlarge
\item stream.memory.2xlarge
\item stream.memory.4xlarge
\item stream.memory.8xlarge
\item stream.memory.z1d.large
\item stream.memory.z1d.xlarge
\item stream.memory.z1d.2xlarge
\item stream.memory.z1d.3xlarge
\item stream.memory.z1d.6xlarge
\item stream.memory.z1d.12xlarge
\item stream.graphics.g4dn.xlarge
\item stream.graphics.g4dn.2xlarge
\item stream.graphics.g4dn.4xlarge
\item stream.graphics.g4dn.8xlarge
\item stream.graphics.g4dn.12xlarge
\item stream.graphics.g4dn.16xlarge
\item stream.graphics.g5.xlarge
\item stream.graphics.g5.2xlarge
\item stream.graphics.g5.4xlarge
\item stream.graphics.g5.8xlarge
\item stream.graphics.g5.16xlarge
\item stream.graphics.g5.12xlarge
\item stream.graphics.g5.24xlarge
\item stream.graphics.g6.xlarge
\item stream.graphics.g6.2xlarge
\item stream.graphics.g6.4xlarge
\item stream.graphics.g6.8xlarge
\item stream.graphics.g6.16xlarge
\item stream.graphics.g6.12xlarge
\item stream.graphics.g6.24xlarge
\item stream.graphics.gr6.4xlarge
\item stream.graphics.gr6.8xlarge
\item stream.graphics.g6f.large
\item stream.graphics.g6f.xlarge
\item stream.graphics.g6f.2xlarge
\item stream.graphics.g6f.4xlarge
\item stream.graphics.gr6f.4xlarge
}

The following instance types are available for Elastic fleets:
\itemize{
\item stream.standard.small
\item stream.standard.medium
\item stream.standard.large
\item stream.standard.xlarge
\item stream.standard.2xlarge
}}

\item{ComputeCapacity}{The desired capacity for the fleet. This is not allowed for Elastic fleets.}

\item{VpcConfig}{The VPC configuration for the fleet. This is required for Elastic fleets, but not required for other fleet types. Elastic fleets require that you specify at least two subnets in different availability zones.}

\item{MaxUserDurationInSeconds}{The maximum amount of time that a streaming session can remain active, in seconds. If users are still connected to a streaming instance five minutes before this limit is reached, they are prompted to save any open documents before being disconnected. After this time elapses, the instance is terminated and replaced by a new instance.

Specify a value between 600 and 432000.}

\item{DisconnectTimeoutInSeconds}{The amount of time that a streaming session remains active after users disconnect. If users try to reconnect to the streaming session after a disconnection or network interruption within this time interval, they are connected to their previous session. Otherwise, they are connected to a new session with a new streaming instance.

Specify a value between 60 and 36000.}

\item{DeleteVpcConfig}{Deletes the VPC association for the specified fleet.}

\item{Description}{The description to display.}

\item{DisplayName}{The fleet name to display.}

\item{EnableDefaultInternetAccess}{Enables or disables default internet access for the fleet.}

\item{DomainJoinInfo}{The name of the directory and organizational unit (OU) to use to join the fleet to a Microsoft Active Directory domain.}

\item{IdleDisconnectTimeoutInSeconds}{The amount of time that users can be idle (inactive) before they are disconnected from their streaming session and the \code{DisconnectTimeoutInSeconds} time interval begins. Users are notified before they are disconnected due to inactivity. If users try to reconnect to the streaming session before the time interval specified in \code{DisconnectTimeoutInSeconds} elapses, they are connected to their previous session. Users are considered idle when they stop providing keyboard or mouse input during their streaming session. File uploads and downloads, audio in, audio out, and pixels changing do not qualify as user activity. If users continue to be idle after the time interval in \code{IdleDisconnectTimeoutInSeconds} elapses, they are disconnected.

To prevent users from being disconnected due to inactivity, specify a value of 0. Otherwise, specify a value between 60 and 36000. The default value is 0.

If you enable this feature, we recommend that you specify a value that corresponds exactly to a whole number of minutes (for example, 60, 120, and 180). If you don't do this, the value is rounded to the nearest minute. For example, if you specify a value of 70, users are disconnected after 1 minute of inactivity. If you specify a value that is at the midpoint between two different minutes, the value is rounded up. For example, if you specify a value of 90, users are disconnected after 2 minutes of inactivity.}

\item{AttributesToDelete}{The fleet attributes to delete.}

\item{IamRoleArn}{The Amazon Resource Name (ARN) of the IAM role to apply to the fleet. To assume a role, a fleet instance calls the AWS Security Token Service (STS) \code{AssumeRole} API operation and passes the ARN of the role to use. The operation creates a new session with temporary credentials. WorkSpaces Applications retrieves the temporary credentials and creates the \strong{appstream_machine_role} credential profile on the instance.

For more information, see \href{https://docs.aws.amazon.com/appstream2/latest/developerguide/using-iam-roles-to-grant-permissions-to-applications-scripts-streaming-instances.html}{Using an IAM Role to Grant Permissions to Applications and Scripts Running on WorkSpaces Applications Streaming Instances} in the \emph{Amazon WorkSpaces Applications Administration Guide}.}

\item{StreamView}{The WorkSpaces Applications view that is displayed to your users when they stream from the fleet. When \code{APP} is specified, only the windows of applications opened by users display. When \code{DESKTOP} is specified, the standard desktop that is provided by the operating system displays.

The default value is \code{APP}.}

\item{Platform}{The platform of the fleet. WINDOWS_SERVER_2019, AMAZON_LINUX2 and UBUNTU_PRO_2404 are supported for Elastic fleets.}

\item{MaxConcurrentSessions}{The maximum number of concurrent sessions for a fleet.}

\item{UsbDeviceFilterStrings}{The USB device filter strings that specify which USB devices a user can redirect to the fleet streaming session, when using the Windows native client. This is allowed but not required for Elastic fleets.}

\item{SessionScriptS3Location}{The S3 location of the session scripts configuration zip file. This only applies to Elastic fleets.}

\item{MaxSessionsPerInstance}{The maximum number of user sessions on an instance. This only applies to multi-session fleets.}

\item{RootVolumeConfig}{The updated configuration for the root volume of fleet instances. Note that volume size cannot be decreased below the image volume size.}

\item{DisableIMDSV1}{Set to true to disable Instance Metadata Service Version 1 (IMDSv1) and enforce IMDSv2. Set to false to enable both IMDSv1 and IMDSv2.

Before disabling IMDSv1, ensure your WorkSpaces Applications images are running the agent version or managed image update released on or after January 16, 2024 to support IMDSv2 enforcement.}
}
\description{
Updates the specified fleet.

See \url{https://www.paws-r-sdk.com/docs/appstream_update_fleet/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workdocs_operations.R
\name{workdocs_delete_document}
\alias{workdocs_delete_document}
\title{Permanently deletes the specified document and its associated metadata}
\usage{
workdocs_delete_document(AuthenticationToken = NULL, DocumentId)
}
\arguments{
\item{AuthenticationToken}{Amazon WorkDocs authentication token. Not required when using Amazon Web Services administrator credentials to access the API.}

\item{DocumentId}{[required] The ID of the document.}
}
\description{
Permanently deletes the specified document and its associated metadata.

See \url{https://www.paws-r-sdk.com/docs/workdocs_delete_document/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ivschat_operations.R
\name{ivschat_untag_resource}
\alias{ivschat_untag_resource}
\title{Removes tags from the resource with the specified ARN}
\usage{
ivschat_untag_resource(resourceArn, tagKeys)
}
\arguments{
\item{resourceArn}{[required] The ARN of the resource to be untagged. The ARN must be URL-encoded.}

\item{tagKeys}{[required] Array of tags to be removed. Array of maps, each of the form \code{string:string (key:value)}. See \href{https://docs.aws.amazon.com/tag-editor/latest/userguide/best-practices-and-strats.html}{Best practices and strategies} in \emph{Tagging Amazon Web Services Resources and Tag Editor} for details, including restrictions that apply to tags and "Tag naming limits and requirements"; Amazon IVS Chat has no constraints beyond what is documented there.}
}
\description{
Removes tags from the resource with the specified ARN.

See \url{https://www.paws-r-sdk.com/docs/ivschat_untag_resource/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspaces_operations.R
\name{workspaces_describe_workspace_bundles}
\alias{workspaces_describe_workspace_bundles}
\title{Retrieves a list that describes the available WorkSpace bundles}
\usage{
workspaces_describe_workspace_bundles(
  BundleIds = NULL,
  Owner = NULL,
  NextToken = NULL
)
}
\arguments{
\item{BundleIds}{The identifiers of the bundles. You cannot combine this parameter with any other filter.}

\item{Owner}{The owner of the bundles. You cannot combine this parameter with any other filter.

To describe the bundles provided by Amazon Web Services, specify \code{AMAZON}. To describe the bundles that belong to your account, don't specify a value.}

\item{NextToken}{The token for the next set of results. (You received this token from a previous call.)}
}
\description{
Retrieves a list that describes the available WorkSpace bundles.

See \url{https://www.paws-r-sdk.com/docs/workspaces_describe_workspace_bundles/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspacesweb_operations.R
\name{workspacesweb_tag_resource}
\alias{workspacesweb_tag_resource}
\title{Adds or overwrites one or more tags for the specified resource}
\usage{
workspacesweb_tag_resource(resourceArn, tags, clientToken = NULL)
}
\arguments{
\item{resourceArn}{[required] The ARN of the resource.}

\item{tags}{[required] The tags of the resource.}

\item{clientToken}{A unique, case-sensitive identifier that you provide to ensure the idempotency of the request. Idempotency ensures that an API request completes only once. With an idempotent request, if the original request completes successfully, subsequent retries with the same client token returns the result from the original successful request.

If you do not specify a client token, one is automatically generated by the Amazon Web Services SDK.}
}
\description{
Adds or overwrites one or more tags for the specified resource.

See \url{https://www.paws-r-sdk.com/docs/workspacesweb_tag_resource/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/appstream_operations.R
\name{appstream_tag_resource}
\alias{appstream_tag_resource}
\title{Adds or overwrites one or more tags for the specified WorkSpaces
Applications resource}
\usage{
appstream_tag_resource(ResourceArn, Tags)
}
\arguments{
\item{ResourceArn}{[required] The Amazon Resource Name (ARN) of the resource.}

\item{Tags}{[required] The tags to associate. A tag is a key-value pair, and the value is optional. For example, Environment=Test. If you do not specify a value, Environment=.

If you do not specify a value, the value is set to an empty string.

Generally allowed characters are: letters, numbers, and spaces representable in UTF-8, and the following special characters:

_ . : / = + \\ - @}
}
\description{
Adds or overwrites one or more tags for the specified WorkSpaces Applications resource. You can tag WorkSpaces Applications image builders, images, fleets, and stacks.

See \url{https://www.paws-r-sdk.com/docs/appstream_tag_resource/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/chatbot_operations.R
\name{chatbot_list_microsoft_teams_channel_configurations}
\alias{chatbot_list_microsoft_teams_channel_configurations}
\title{Lists all AWS Chatbot Microsoft Teams channel configurations in an AWS
account}
\usage{
chatbot_list_microsoft_teams_channel_configurations(
  MaxResults = NULL,
  NextToken = NULL,
  TeamId = NULL
)
}
\arguments{
\item{MaxResults}{The maximum number of results to include in the response. If more results exist than the specified MaxResults value, a token is included in the response so that the remaining results can be retrieved.}

\item{NextToken}{An optional token returned from a prior request. Use this token for pagination of results from this action. If this parameter is specified, the response includes only results beyond the token, up to the value specified by MaxResults.}

\item{TeamId}{The ID of the Microsoft Teams authorized with AWS Chatbot.

To get the team ID, you must perform the initial authorization flow with Microsoft Teams in the AWS Chatbot console. Then you can copy and paste the team ID from the console. For more information, see \href{https://docs.aws.amazon.com/chatbot/latest/adminguide/teams-setup.html#teams-client-setup}{Step 1: Configure a Microsoft Teams client} in the \emph{AWS Chatbot Administrator Guide}.}
}
\description{
Lists all AWS Chatbot Microsoft Teams channel configurations in an AWS account.

See \url{https://www.paws-r-sdk.com/docs/chatbot_list_microsoft_teams_channel_configurations/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workdocs_operations.R
\name{workdocs_get_folder_path}
\alias{workdocs_get_folder_path}
\title{Retrieves the path information (the hierarchy from the root folder) for
the specified folder}
\usage{
workdocs_get_folder_path(
  AuthenticationToken = NULL,
  FolderId,
  Limit = NULL,
  Fields = NULL,
  Marker = NULL
)
}
\arguments{
\item{AuthenticationToken}{Amazon WorkDocs authentication token. Not required when using Amazon Web Services administrator credentials to access the API.}

\item{FolderId}{[required] The ID of the folder.}

\item{Limit}{The maximum number of levels in the hierarchy to return.}

\item{Fields}{A comma-separated list of values. Specify "NAME" to include the names of the parent folders.}

\item{Marker}{This value is not supported.}
}
\description{
Retrieves the path information (the hierarchy from the root folder) for the specified folder.

See \url{https://www.paws-r-sdk.com/docs/workdocs_get_folder_path/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/appstream_operations.R
\name{appstream_update_app_block_builder}
\alias{appstream_update_app_block_builder}
\title{Updates an app block builder}
\usage{
appstream_update_app_block_builder(
  Name,
  Description = NULL,
  DisplayName = NULL,
  Platform = NULL,
  InstanceType = NULL,
  VpcConfig = NULL,
  EnableDefaultInternetAccess = NULL,
  IamRoleArn = NULL,
  AccessEndpoints = NULL,
  AttributesToDelete = NULL,
  DisableIMDSV1 = NULL
)
}
\arguments{
\item{Name}{[required] The unique name for the app block builder.}

\item{Description}{The description of the app block builder.}

\item{DisplayName}{The display name of the app block builder.}

\item{Platform}{The platform of the app block builder.

\code{WINDOWS_SERVER_2019} is the only valid value.}

\item{InstanceType}{The instance type to use when launching the app block builder. The following instance types are available:
\itemize{
\item stream.standard.small
\item stream.standard.medium
\item stream.standard.large
\item stream.standard.xlarge
\item stream.standard.2xlarge
}}

\item{VpcConfig}{The VPC configuration for the app block builder.

App block builders require that you specify at least two subnets in different availability zones.}

\item{EnableDefaultInternetAccess}{Enables or disables default internet access for the app block builder.}

\item{IamRoleArn}{The Amazon Resource Name (ARN) of the IAM role to apply to the app block builder. To assume a role, the app block builder calls the AWS Security Token Service (STS) \code{AssumeRole} API operation and passes the ARN of the role to use. The operation creates a new session with temporary credentials. WorkSpaces Applications retrieves the temporary credentials and creates the \strong{appstream_machine_role} credential profile on the instance.

For more information, see \href{https://docs.aws.amazon.com/appstream2/latest/developerguide/using-iam-roles-to-grant-permissions-to-applications-scripts-streaming-instances.html}{Using an IAM Role to Grant Permissions to Applications and Scripts Running on WorkSpaces Applications Streaming Instances} in the \emph{Amazon WorkSpaces Applications Administration Guide}.}

\item{AccessEndpoints}{The list of interface VPC endpoint (interface endpoint) objects. Administrators can connect to the app block builder only through the specified endpoints.}

\item{AttributesToDelete}{The attributes to delete from the app block builder.}

\item{DisableIMDSV1}{Set to true to disable Instance Metadata Service Version 1 (IMDSv1) and enforce IMDSv2. Set to false to enable both IMDSv1 and IMDSv2.}
}
\description{
Updates an app block builder.

See \url{https://www.paws-r-sdk.com/docs/appstream_update_app_block_builder/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_update_availability_configuration}
\alias{workmail_update_availability_configuration}
\title{Updates an existing AvailabilityConfiguration for the given WorkMail
organization and domain}
\usage{
workmail_update_availability_configuration(
  OrganizationId,
  DomainName,
  EwsProvider = NULL,
  LambdaProvider = NULL
)
}
\arguments{
\item{OrganizationId}{[required] The WorkMail organization for which the \code{AvailabilityConfiguration} will be updated.}

\item{DomainName}{[required] The domain to which the provider applies the availability configuration.}

\item{EwsProvider}{The EWS availability provider definition. The request must contain exactly one provider definition, either \code{EwsProvider} or \code{LambdaProvider}. The previously stored provider will be overridden by the one provided.}

\item{LambdaProvider}{The Lambda availability provider definition. The request must contain exactly one provider definition, either \code{EwsProvider} or \code{LambdaProvider}. The previously stored provider will be overridden by the one provided.}
}
\description{
Updates an existing \code{AvailabilityConfiguration} for the given WorkMail organization and domain.

See \url{https://www.paws-r-sdk.com/docs/workmail_update_availability_configuration/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspaces_operations.R
\name{workspaces_modify_certificate_based_auth_properties}
\alias{workspaces_modify_certificate_based_auth_properties}
\title{Modifies the properties of the certificate-based authentication you want
to use with your WorkSpaces}
\usage{
workspaces_modify_certificate_based_auth_properties(
  ResourceId,
  CertificateBasedAuthProperties = NULL,
  PropertiesToDelete = NULL
)
}
\arguments{
\item{ResourceId}{[required] The resource identifiers, in the form of directory IDs.}

\item{CertificateBasedAuthProperties}{The properties of the certificate-based authentication.}

\item{PropertiesToDelete}{The properties of the certificate-based authentication you want to delete.}
}
\description{
Modifies the properties of the certificate-based authentication you want to use with your WorkSpaces.

See \url{https://www.paws-r-sdk.com/docs/workspaces_modify_certificate_based_auth_properties/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_create_mobile_device_access_rule}
\alias{workmail_create_mobile_device_access_rule}
\title{Creates a new mobile device access rule for the specified WorkMail
organization}
\usage{
workmail_create_mobile_device_access_rule(
  OrganizationId,
  ClientToken = NULL,
  Name,
  Description = NULL,
  Effect,
  DeviceTypes = NULL,
  NotDeviceTypes = NULL,
  DeviceModels = NULL,
  NotDeviceModels = NULL,
  DeviceOperatingSystems = NULL,
  NotDeviceOperatingSystems = NULL,
  DeviceUserAgents = NULL,
  NotDeviceUserAgents = NULL
)
}
\arguments{
\item{OrganizationId}{[required] The WorkMail organization under which the rule will be created.}

\item{ClientToken}{The idempotency token for the client request.}

\item{Name}{[required] The rule name.}

\item{Description}{The rule description.}

\item{Effect}{[required] The effect of the rule when it matches. Allowed values are \code{ALLOW} or \code{DENY}.}

\item{DeviceTypes}{Device types that the rule will match.}

\item{NotDeviceTypes}{Device types that the rule \strong{will not} match. All other device types will match.}

\item{DeviceModels}{Device models that the rule will match.}

\item{NotDeviceModels}{Device models that the rule \strong{will not} match. All other device models will match.}

\item{DeviceOperatingSystems}{Device operating systems that the rule will match.}

\item{NotDeviceOperatingSystems}{Device operating systems that the rule \strong{will not} match. All other device operating systems will match.}

\item{DeviceUserAgents}{Device user agents that the rule will match.}

\item{NotDeviceUserAgents}{Device user agents that the rule \strong{will not} match. All other device user agents will match.}
}
\description{
Creates a new mobile device access rule for the specified WorkMail organization.

See \url{https://www.paws-r-sdk.com/docs/workmail_create_mobile_device_access_rule/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_describe_entity}
\alias{workmail_describe_entity}
\title{Returns basic details about an entity in WorkMail}
\usage{
workmail_describe_entity(OrganizationId, Email)
}
\arguments{
\item{OrganizationId}{[required] The identifier for the organization under which the entity exists.}

\item{Email}{[required] The email under which the entity exists.}
}
\description{
Returns basic details about an entity in WorkMail.

See \url{https://www.paws-r-sdk.com/docs/workmail_describe_entity/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspacesweb_operations.R
\name{workspacesweb_delete_identity_provider}
\alias{workspacesweb_delete_identity_provider}
\title{Deletes the identity provider}
\usage{
workspacesweb_delete_identity_provider(identityProviderArn)
}
\arguments{
\item{identityProviderArn}{[required] The ARN of the identity provider.}
}
\description{
Deletes the identity provider.

See \url{https://www.paws-r-sdk.com/docs/workspacesweb_delete_identity_provider/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspacesweb_operations.R
\name{workspacesweb_update_user_settings}
\alias{workspacesweb_update_user_settings}
\title{Updates the user settings}
\usage{
workspacesweb_update_user_settings(
  userSettingsArn,
  copyAllowed = NULL,
  pasteAllowed = NULL,
  downloadAllowed = NULL,
  uploadAllowed = NULL,
  printAllowed = NULL,
  disconnectTimeoutInMinutes = NULL,
  idleDisconnectTimeoutInMinutes = NULL,
  clientToken = NULL,
  cookieSynchronizationConfiguration = NULL,
  deepLinkAllowed = NULL,
  toolbarConfiguration = NULL,
  brandingConfigurationInput = NULL,
  webAuthnAllowed = NULL
)
}
\arguments{
\item{userSettingsArn}{[required] The ARN of the user settings.}

\item{copyAllowed}{Specifies whether the user can copy text from the streaming session to the local device.}

\item{pasteAllowed}{Specifies whether the user can paste text from the local device to the streaming session.}

\item{downloadAllowed}{Specifies whether the user can download files from the streaming session to the local device.}

\item{uploadAllowed}{Specifies whether the user can upload files from the local device to the streaming session.}

\item{printAllowed}{Specifies whether the user can print to the local device.}

\item{disconnectTimeoutInMinutes}{The amount of time that a streaming session remains active after users disconnect.}

\item{idleDisconnectTimeoutInMinutes}{The amount of time that users can be idle (inactive) before they are disconnected from their streaming session and the disconnect timeout interval begins.}

\item{clientToken}{A unique, case-sensitive identifier that you provide to ensure the idempotency of the request. Idempotency ensures that an API request completes only once. With an idempotent request, if the original request completes successfully, subsequent retries with the same client token return the result from the original successful request.

If you do not specify a client token, one is automatically generated by the Amazon Web Services SDK.}

\item{cookieSynchronizationConfiguration}{The configuration that specifies which cookies should be synchronized from the end user's local browser to the remote browser.

If the allowlist and blocklist are empty, the configuration becomes null.}

\item{deepLinkAllowed}{Specifies whether the user can use deep links that open automatically when connecting to a session.}

\item{toolbarConfiguration}{The configuration of the toolbar. This allows administrators to select the toolbar type and visual mode, set maximum display resolution for sessions, and choose which items are visible to end users during their sessions. If administrators do not modify these settings, end users retain control over their toolbar preferences.}

\item{brandingConfigurationInput}{The branding configuration that customizes the appearance of the web portal for end users. When updating user settings without an existing branding configuration, all fields (logo, favicon, localized strings, and color theme) are required except for wallpaper and terms of service. When updating user settings with an existing branding configuration, all fields are optional.}

\item{webAuthnAllowed}{Specifies whether the user can use WebAuthn redirection for passwordless login to websites within the streaming session.}
}
\description{
Updates the user settings.

See \url{https://www.paws-r-sdk.com/docs/workspacesweb_update_user_settings/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/appstream_operations.R
\name{appstream_describe_sessions}
\alias{appstream_describe_sessions}
\title{Retrieves a list that describes the streaming sessions for a specified
stack and fleet}
\usage{
appstream_describe_sessions(
  StackName,
  FleetName,
  UserId = NULL,
  NextToken = NULL,
  Limit = NULL,
  AuthenticationType = NULL,
  InstanceId = NULL
)
}
\arguments{
\item{StackName}{[required] The name of the stack. This value is case-sensitive.}

\item{FleetName}{[required] The name of the fleet. This value is case-sensitive.}

\item{UserId}{The user identifier (ID). If you specify a user ID, you must also specify the authentication type.}

\item{NextToken}{The pagination token to use to retrieve the next page of results for this operation. If this value is null, it retrieves the first page.}

\item{Limit}{The size of each page of results. The default value is 20 and the maximum value is 50.}

\item{AuthenticationType}{The authentication method. Specify \code{API} for a user authenticated using a streaming URL or \code{SAML} for a SAML federated user. The default is to authenticate users using a streaming URL.}

\item{InstanceId}{The identifier for the instance hosting the session.}
}
\description{
Retrieves a list that describes the streaming sessions for a specified stack and fleet. If a UserId is provided for the stack and fleet, only streaming sessions for that user are described. If an authentication type is not provided, the default is to authenticate users using a streaming URL.

See \url{https://www.paws-r-sdk.com/docs/appstream_describe_sessions/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspacesweb_operations.R
\name{workspacesweb_update_session_logger}
\alias{workspacesweb_update_session_logger}
\title{Updates the details of a session logger}
\usage{
workspacesweb_update_session_logger(
  sessionLoggerArn,
  eventFilter = NULL,
  logConfiguration = NULL,
  displayName = NULL
)
}
\arguments{
\item{sessionLoggerArn}{[required] The ARN of the session logger to update.}

\item{eventFilter}{The updated eventFilter.}

\item{logConfiguration}{The updated logConfiguration.}

\item{displayName}{The updated display name.}
}
\description{
Updates the details of a session logger.

See \url{https://www.paws-r-sdk.com/docs/workspacesweb_update_session_logger/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/appstream_operations.R
\name{appstream_copy_image}
\alias{appstream_copy_image}
\title{Copies the image within the same region or to a new region within the
same AWS account}
\usage{
appstream_copy_image(
  SourceImageName,
  DestinationImageName,
  DestinationRegion,
  DestinationImageDescription = NULL
)
}
\arguments{
\item{SourceImageName}{[required] The name of the image to copy.}

\item{DestinationImageName}{[required] The name that the image will have when it is copied to the destination.}

\item{DestinationRegion}{[required] The destination region to which the image will be copied. This parameter is required, even if you are copying an image within the same region.}

\item{DestinationImageDescription}{The description that the image will have when it is copied to the destination.}
}
\description{
Copies the image within the same region or to a new region within the same AWS account. Note that any tags you added to the image will not be copied.

See \url{https://www.paws-r-sdk.com/docs/appstream_copy_image/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_update_resource}
\alias{workmail_update_resource}
\title{Updates data for the resource}
\usage{
workmail_update_resource(
  OrganizationId,
  ResourceId,
  Name = NULL,
  BookingOptions = NULL,
  Description = NULL,
  Type = NULL,
  HiddenFromGlobalAddressList = NULL
)
}
\arguments{
\item{OrganizationId}{[required] The identifier associated with the organization for which the resource is updated.}

\item{ResourceId}{[required] The identifier of the resource to be updated.

The identifier can accept \emph{ResourceId}, \emph{Resourcename}, or \emph{email}. The following identity formats are available:
\itemize{
\item Resource ID: r-0123456789a0123456789b0123456789
\item Email address: resource@domain.tld
\item Resource name: resource
}}

\item{Name}{The name of the resource to be updated.}

\item{BookingOptions}{The resource's booking options to be updated.}

\item{Description}{Updates the resource description.}

\item{Type}{Updates the resource type.}

\item{HiddenFromGlobalAddressList}{If enabled, the resource is hidden from the global address list.}
}
\description{
Updates data for the resource. To have the latest information, it must be preceded by a \code{\link[=workmail_describe_resource]{describe_resource}} call. The dataset in the request should be the one expected when performing another \code{\link[=workmail_describe_resource]{describe_resource}} call.

See \url{https://www.paws-r-sdk.com/docs/workmail_update_resource/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_delete_group}
\alias{workmail_delete_group}
\title{Deletes a group from WorkMail}
\usage{
workmail_delete_group(OrganizationId, GroupId)
}
\arguments{
\item{OrganizationId}{[required] The organization that contains the group.}

\item{GroupId}{[required] The identifier of the group to be deleted.

The identifier can be the \emph{GroupId}, or \emph{Groupname}. The following identity formats are available:
\itemize{
\item Group ID: 12345678-1234-1234-1234-123456789012 or S-1-1-12-1234567890-123456789-123456789-1234
\item Group name: group
}}
}
\description{
Deletes a group from WorkMail.

See \url{https://www.paws-r-sdk.com/docs/workmail_delete_group/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workdocs_operations.R
\name{workdocs_add_resource_permissions}
\alias{workdocs_add_resource_permissions}
\title{Creates a set of permissions for the specified folder or document}
\usage{
workdocs_add_resource_permissions(
  AuthenticationToken = NULL,
  ResourceId,
  Principals,
  NotificationOptions = NULL
)
}
\arguments{
\item{AuthenticationToken}{Amazon WorkDocs authentication token. Not required when using Amazon Web Services administrator credentials to access the API.}

\item{ResourceId}{[required] The ID of the resource.}

\item{Principals}{[required] The users, groups, or organization being granted permission.}

\item{NotificationOptions}{The notification options.}
}
\description{
Creates a set of permissions for the specified folder or document. The resource permissions are overwritten if the principals already have different permissions.

See \url{https://www.paws-r-sdk.com/docs/workdocs_add_resource_permissions/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspaces_operations.R
\name{workspaces_disassociate_ip_groups}
\alias{workspaces_disassociate_ip_groups}
\title{Disassociates the specified IP access control group from the specified
directory}
\usage{
workspaces_disassociate_ip_groups(DirectoryId, GroupIds)
}
\arguments{
\item{DirectoryId}{[required] The identifier of the directory.}

\item{GroupIds}{[required] The identifiers of one or more IP access control groups.}
}
\description{
Disassociates the specified IP access control group from the specified directory.

See \url{https://www.paws-r-sdk.com/docs/workspaces_disassociate_ip_groups/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ivschat_operations.R
\name{ivschat_send_event}
\alias{ivschat_send_event}
\title{Sends an event to a room}
\usage{
ivschat_send_event(roomIdentifier, eventName, attributes = NULL)
}
\arguments{
\item{roomIdentifier}{[required] Identifier of the room to which the event will be sent. Currently this must be an ARN.}

\item{eventName}{[required] Application-defined name of the event to send to clients.}

\item{attributes}{Application-defined metadata to attach to the event sent to clients. The maximum length of the metadata is 1 KB total.}
}
\description{
Sends an event to a room. Use this within your application’s business logic to send events to clients of a room; e.g., to notify clients to change the way the chat UI is rendered.

See \url{https://www.paws-r-sdk.com/docs/ivschat_send_event/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspaces_operations.R
\name{workspaces_start_workspaces_pool}
\alias{workspaces_start_workspaces_pool}
\title{Starts the specified pool}
\usage{
workspaces_start_workspaces_pool(PoolId)
}
\arguments{
\item{PoolId}{[required] The identifier of the pool.}
}
\description{
Starts the specified pool.

See \url{https://www.paws-r-sdk.com/docs/workspaces_start_workspaces_pool/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_list_resources}
\alias{workmail_list_resources}
\title{Returns summaries of the organization's resources}
\usage{
workmail_list_resources(
  OrganizationId,
  NextToken = NULL,
  MaxResults = NULL,
  Filters = NULL
)
}
\arguments{
\item{OrganizationId}{[required] The identifier for the organization under which the resources exist.}

\item{NextToken}{The token to use to retrieve the next page of results. The first call does not contain any tokens.}

\item{MaxResults}{The maximum number of results to return in a single call.}

\item{Filters}{Limit the resource search results based on the filter criteria. You can only use one filter per request.}
}
\description{
Returns summaries of the organization's resources.

See \url{https://www.paws-r-sdk.com/docs/workmail_list_resources/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspacesweb_operations.R
\name{workspacesweb_create_data_protection_settings}
\alias{workspacesweb_create_data_protection_settings}
\title{Creates a data protection settings resource that can be associated with
a web portal}
\usage{
workspacesweb_create_data_protection_settings(
  displayName = NULL,
  description = NULL,
  tags = NULL,
  customerManagedKey = NULL,
  additionalEncryptionContext = NULL,
  inlineRedactionConfiguration = NULL,
  clientToken = NULL
)
}
\arguments{
\item{displayName}{The display name of the data protection settings.}

\item{description}{The description of the data protection settings.}

\item{tags}{The tags to add to the data protection settings resource. A tag is a key-value pair.}

\item{customerManagedKey}{The custom managed key of the data protection settings.}

\item{additionalEncryptionContext}{Additional encryption context of the data protection settings.}

\item{inlineRedactionConfiguration}{The inline redaction configuration of the data protection settings that will be applied to all sessions.}

\item{clientToken}{A unique, case-sensitive identifier that you provide to ensure the idempotency of the request. Idempotency ensures that an API request completes only once. With an idempotent request, if the original request completes successfully, subsequent retries with the same client token returns the result from the original successful request.

If you do not specify a client token, one is automatically generated by the Amazon Web Services SDK.}
}
\description{
Creates a data protection settings resource that can be associated with a web portal.

See \url{https://www.paws-r-sdk.com/docs/workspacesweb_create_data_protection_settings/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_register_mail_domain}
\alias{workmail_register_mail_domain}
\title{Registers a new domain in WorkMail and SES, and configures it for use by
WorkMail}
\usage{
workmail_register_mail_domain(ClientToken = NULL, OrganizationId, DomainName)
}
\arguments{
\item{ClientToken}{Idempotency token used when retrying requests.}

\item{OrganizationId}{[required] The WorkMail organization under which you're creating the domain.}

\item{DomainName}{[required] The name of the mail domain to create in WorkMail and SES.}
}
\description{
Registers a new domain in WorkMail and SES, and configures it for use by WorkMail. Emails received by SES for this domain are routed to the specified WorkMail organization, and WorkMail has permanent permission to use the specified domain for sending your users' emails.

See \url{https://www.paws-r-sdk.com/docs/workmail_register_mail_domain/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_create_availability_configuration}
\alias{workmail_create_availability_configuration}
\title{Creates an AvailabilityConfiguration for the given WorkMail organization
and domain}
\usage{
workmail_create_availability_configuration(
  ClientToken = NULL,
  OrganizationId,
  DomainName,
  EwsProvider = NULL,
  LambdaProvider = NULL
)
}
\arguments{
\item{ClientToken}{An idempotent token that ensures that an API request is executed only once.}

\item{OrganizationId}{[required] The WorkMail organization for which the \code{AvailabilityConfiguration} will be created.}

\item{DomainName}{[required] The domain to which the provider applies.}

\item{EwsProvider}{Exchange Web Services (EWS) availability provider definition. The request must contain exactly one provider definition, either \code{EwsProvider} or \code{LambdaProvider}.}

\item{LambdaProvider}{Lambda availability provider definition. The request must contain exactly one provider definition, either \code{EwsProvider} or \code{LambdaProvider}.}
}
\description{
Creates an \code{AvailabilityConfiguration} for the given WorkMail organization and domain.

See \url{https://www.paws-r-sdk.com/docs/workmail_create_availability_configuration/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspaces_operations.R
\name{workspaces_modify_selfservice_permissions}
\alias{workspaces_modify_selfservice_permissions}
\title{Modifies the self-service WorkSpace management capabilities for your
users}
\usage{
workspaces_modify_selfservice_permissions(ResourceId, SelfservicePermissions)
}
\arguments{
\item{ResourceId}{[required] The identifier of the directory.}

\item{SelfservicePermissions}{[required] The permissions to enable or disable self-service capabilities.}
}
\description{
Modifies the self-service WorkSpace management capabilities for your users. For more information, see \href{https://docs.aws.amazon.com/workspaces/latest/adminguide/enable-user-self-service-workspace-management.html}{Enable Self-Service WorkSpace Management Capabilities for Your Users}.

See \url{https://www.paws-r-sdk.com/docs/workspaces_modify_selfservice_permissions/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/chatbot_operations.R
\name{chatbot_delete_slack_user_identity}
\alias{chatbot_delete_slack_user_identity}
\title{Deletes a user level permission for a Slack channel configuration}
\usage{
chatbot_delete_slack_user_identity(
  ChatConfigurationArn,
  SlackTeamId,
  SlackUserId
)
}
\arguments{
\item{ChatConfigurationArn}{[required] The ARN of the SlackChannelConfiguration associated with the user identity to delete.}

\item{SlackTeamId}{[required] The ID of the Slack workspace authorized with AWS Chatbot.}

\item{SlackUserId}{[required] The ID of the user in Slack}
}
\description{
Deletes a user level permission for a Slack channel configuration.

See \url{https://www.paws-r-sdk.com/docs/chatbot_delete_slack_user_identity/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workdocs_operations.R
\name{workdocs_describe_groups}
\alias{workdocs_describe_groups}
\title{Describes the groups specified by the query}
\usage{
workdocs_describe_groups(
  AuthenticationToken = NULL,
  SearchQuery,
  OrganizationId = NULL,
  Marker = NULL,
  Limit = NULL
)
}
\arguments{
\item{AuthenticationToken}{Amazon WorkDocs authentication token. Not required when using Amazon Web Services administrator credentials to access the API.}

\item{SearchQuery}{[required] A query to describe groups by group name.}

\item{OrganizationId}{The ID of the organization.}

\item{Marker}{The marker for the next set of results. (You received this marker from a previous call.)}

\item{Limit}{The maximum number of items to return with this call.}
}
\description{
Describes the groups specified by the query. Groups are defined by the underlying Active Directory.

See \url{https://www.paws-r-sdk.com/docs/workdocs_describe_groups/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspacesweb_operations.R
\name{workspacesweb_update_ip_access_settings}
\alias{workspacesweb_update_ip_access_settings}
\title{Updates IP access settings}
\usage{
workspacesweb_update_ip_access_settings(
  ipAccessSettingsArn,
  displayName = NULL,
  description = NULL,
  ipRules = NULL,
  clientToken = NULL
)
}
\arguments{
\item{ipAccessSettingsArn}{[required] The ARN of the IP access settings.}

\item{displayName}{The display name of the IP access settings.}

\item{description}{The description of the IP access settings.}

\item{ipRules}{The updated IP rules of the IP access settings.}

\item{clientToken}{A unique, case-sensitive identifier that you provide to ensure the idempotency of the request. Idempotency ensures that an API request completes only once. With an idempotent request, if the original request completes successfully, subsequent retries with the same client token return the result from the original successful request.

If you do not specify a client token, one is automatically generated by the Amazon Web Services SDK.}
}
\description{
Updates IP access settings.

See \url{https://www.paws-r-sdk.com/docs/workspacesweb_update_ip_access_settings/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ivschat_operations.R
\name{ivschat_list_logging_configurations}
\alias{ivschat_list_logging_configurations}
\title{Gets summary information about all your logging configurations in the
AWS region where the API request is processed}
\usage{
ivschat_list_logging_configurations(nextToken = NULL, maxResults = NULL)
}
\arguments{
\item{nextToken}{The first logging configurations to retrieve. This is used for pagination; see the \code{nextToken} response field.}

\item{maxResults}{Maximum number of logging configurations to return. Default: 50.}
}
\description{
Gets summary information about all your logging configurations in the AWS region where the API request is processed.

See \url{https://www.paws-r-sdk.com/docs/ivschat_list_logging_configurations/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_get_personal_access_token_metadata}
\alias{workmail_get_personal_access_token_metadata}
\title{Requests details of a specific Personal Access Token within the WorkMail
organization}
\usage{
workmail_get_personal_access_token_metadata(
  OrganizationId,
  PersonalAccessTokenId
)
}
\arguments{
\item{OrganizationId}{[required] The Organization ID.}

\item{PersonalAccessTokenId}{[required] The Personal Access Token ID.}
}
\description{
Requests details of a specific Personal Access Token within the WorkMail organization.

See \url{https://www.paws-r-sdk.com/docs/workmail_get_personal_access_token_metadata/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_create_user}
\alias{workmail_create_user}
\title{Creates a user who can be used in WorkMail by calling the
RegisterToWorkMail operation}
\usage{
workmail_create_user(
  OrganizationId,
  Name,
  DisplayName,
  Password = NULL,
  Role = NULL,
  FirstName = NULL,
  LastName = NULL,
  HiddenFromGlobalAddressList = NULL,
  IdentityProviderUserId = NULL
)
}
\arguments{
\item{OrganizationId}{[required] The identifier of the organization for which the user is created.}

\item{Name}{[required] The name for the new user. WorkMail directory user names have a maximum length of 64. All others have a maximum length of 20.}

\item{DisplayName}{[required] The display name for the new user.}

\item{Password}{The password for the new user.}

\item{Role}{The role of the new user.

You cannot pass \emph{SYSTEM_USER} or \emph{RESOURCE} role in a single request. When a user role is not selected, the default role of \emph{USER} is selected.}

\item{FirstName}{The first name of the new user.}

\item{LastName}{The last name of the new user.}

\item{HiddenFromGlobalAddressList}{If this parameter is enabled, the user will be hidden from the address book.}

\item{IdentityProviderUserId}{User ID from the IAM Identity Center. If this parameter is empty it will be updated automatically when the user logs in for the first time to the mailbox associated with WorkMail.}
}
\description{
Creates a user who can be used in WorkMail by calling the \code{\link[=workmail_register_to_work_mail]{register_to_work_mail}} operation.

See \url{https://www.paws-r-sdk.com/docs/workmail_create_user/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/appstream_operations.R
\name{appstream_create_user}
\alias{appstream_create_user}
\title{Creates a new user in the user pool}
\usage{
appstream_create_user(
  UserName,
  MessageAction = NULL,
  FirstName = NULL,
  LastName = NULL,
  AuthenticationType
)
}
\arguments{
\item{UserName}{[required] The email address of the user.

Users' email addresses are case-sensitive. During login, if they specify an email address that doesn't use the same capitalization as the email address specified when their user pool account was created, a "user does not exist" error message displays.}

\item{MessageAction}{The action to take for the welcome email that is sent to a user after the user is created in the user pool. If you specify SUPPRESS, no email is sent. If you specify RESEND, do not specify the first name or last name of the user. If the value is null, the email is sent.

The temporary password in the welcome email is valid for only 7 days. If users don’t set their passwords within 7 days, you must send them a new welcome email.}

\item{FirstName}{The first name, or given name, of the user.}

\item{LastName}{The last name, or surname, of the user.}

\item{AuthenticationType}{[required] The authentication type for the user. You must specify USERPOOL.}
}
\description{
Creates a new user in the user pool.

See \url{https://www.paws-r-sdk.com/docs/appstream_create_user/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/appstream_operations.R
\name{appstream_create_app_block_builder_streaming_url}
\alias{appstream_create_app_block_builder_streaming_url}
\title{Creates a URL to start a create app block builder streaming session}
\usage{
appstream_create_app_block_builder_streaming_url(
  AppBlockBuilderName,
  Validity = NULL
)
}
\arguments{
\item{AppBlockBuilderName}{[required] The name of the app block builder.}

\item{Validity}{The time that the streaming URL will be valid, in seconds. Specify a value between 1 and 604800 seconds. The default is 3600 seconds.}
}
\description{
Creates a URL to start a create app block builder streaming session.

See \url{https://www.paws-r-sdk.com/docs/appstream_create_app_block_builder_streaming_url/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_put_email_monitoring_configuration}
\alias{workmail_put_email_monitoring_configuration}
\title{Creates or updates the email monitoring configuration for a specified
organization}
\usage{
workmail_put_email_monitoring_configuration(
  OrganizationId,
  RoleArn = NULL,
  LogGroupArn
)
}
\arguments{
\item{OrganizationId}{[required] The ID of the organization for which the email monitoring configuration is set.}

\item{RoleArn}{The Amazon Resource Name (ARN) of the IAM Role associated with the email monitoring configuration. If absent, the IAM Role Arn of AWSServiceRoleForAmazonWorkMailEvents will be used.}

\item{LogGroupArn}{[required] The Amazon Resource Name (ARN) of the CloudWatch Log group associated with the email monitoring configuration.}
}
\description{
Creates or updates the email monitoring configuration for a specified organization.

See \url{https://www.paws-r-sdk.com/docs/workmail_put_email_monitoring_configuration/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspaces_operations.R
\name{workspaces_list_available_management_cidr_ranges}
\alias{workspaces_list_available_management_cidr_ranges}
\title{Retrieves a list of IP address ranges, specified as IPv4 CIDR blocks,
that you can use for the network management interface when you enable
Bring Your Own License (BYOL)}
\usage{
workspaces_list_available_management_cidr_ranges(
  ManagementCidrRangeConstraint,
  MaxResults = NULL,
  NextToken = NULL
)
}
\arguments{
\item{ManagementCidrRangeConstraint}{[required] The IP address range to search. Specify an IP address range that is compatible with your network and in CIDR notation (that is, specify the range as an IPv4 CIDR block).}

\item{MaxResults}{The maximum number of items to return.}

\item{NextToken}{If you received a \code{NextToken} from a previous call that was paginated, provide this token to receive the next set of results.}
}
\description{
Retrieves a list of IP address ranges, specified as IPv4 CIDR blocks, that you can use for the network management interface when you enable Bring Your Own License (BYOL).

See \url{https://www.paws-r-sdk.com/docs/workspaces_list_available_management_cidr_ranges/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ivschat_operations.R
\name{ivschat_update_logging_configuration}
\alias{ivschat_update_logging_configuration}
\title{Updates a specified logging configuration}
\usage{
ivschat_update_logging_configuration(
  identifier,
  name = NULL,
  destinationConfiguration = NULL
)
}
\arguments{
\item{identifier}{[required] Identifier of the logging configuration to be updated.}

\item{name}{Logging-configuration name. The value does not need to be unique.}

\item{destinationConfiguration}{A complex type that contains a destination configuration for where chat content will be logged. There can be only one type of destination (\code{cloudWatchLogs}, \code{firehose}, or \code{s3}) in a \code{destinationConfiguration}.}
}
\description{
Updates a specified logging configuration.

See \url{https://www.paws-r-sdk.com/docs/ivschat_update_logging_configuration/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_delete_user}
\alias{workmail_delete_user}
\title{Deletes a user from WorkMail and all subsequent systems}
\usage{
workmail_delete_user(OrganizationId, UserId)
}
\arguments{
\item{OrganizationId}{[required] The organization that contains the user to be deleted.}

\item{UserId}{[required] The identifier of the user to be deleted.

The identifier can be the \emph{UserId} or \emph{Username}. The following identity formats are available:
\itemize{
\item User ID: 12345678-1234-1234-1234-123456789012 or S-1-1-12-1234567890-123456789-123456789-1234
\item User name: user
}}
}
\description{
Deletes a user from WorkMail and all subsequent systems. Before you can delete a user, the user state must be \code{DISABLED}. Use the \code{\link[=workmail_describe_user]{describe_user}} action to confirm the user state.

See \url{https://www.paws-r-sdk.com/docs/workmail_delete_user/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspaces_operations.R
\name{workspaces_modify_endpoint_encryption_mode}
\alias{workspaces_modify_endpoint_encryption_mode}
\title{Modifies the endpoint encryption mode that allows you to configure the
specified directory between Standard TLS and FIPS 140-2 validated mode}
\usage{
workspaces_modify_endpoint_encryption_mode(DirectoryId, EndpointEncryptionMode)
}
\arguments{
\item{DirectoryId}{[required] The identifier of the directory.}

\item{EndpointEncryptionMode}{[required] The encryption mode used for endpoint connections when streaming to WorkSpaces Personal or WorkSpace Pools.}
}
\description{
Modifies the endpoint encryption mode that allows you to configure the specified directory between Standard TLS and FIPS 140-2 validated mode.

See \url{https://www.paws-r-sdk.com/docs/workspaces_modify_endpoint_encryption_mode/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/chatbot_operations.R
\name{chatbot_associate_to_configuration}
\alias{chatbot_associate_to_configuration}
\title{Links a resource (for example, a custom action) to a channel
configuration}
\usage{
chatbot_associate_to_configuration(Resource, ChatConfiguration)
}
\arguments{
\item{Resource}{[required] The resource Amazon Resource Name (ARN) to link.}

\item{ChatConfiguration}{[required] The channel configuration to associate with the resource.}
}
\description{
Links a resource (for example, a custom action) to a channel configuration.

See \url{https://www.paws-r-sdk.com/docs/chatbot_associate_to_configuration/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspaces_operations.R
\name{workspaces_modify_client_properties}
\alias{workspaces_modify_client_properties}
\title{Modifies the properties of the specified Amazon WorkSpaces clients}
\usage{
workspaces_modify_client_properties(ResourceId, ClientProperties)
}
\arguments{
\item{ResourceId}{[required] The resource identifiers, in the form of directory IDs.}

\item{ClientProperties}{[required] Information about the Amazon WorkSpaces client.}
}
\description{
Modifies the properties of the specified Amazon WorkSpaces clients.

See \url{https://www.paws-r-sdk.com/docs/workspaces_modify_client_properties/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspaces_operations.R
\name{workspaces_describe_client_properties}
\alias{workspaces_describe_client_properties}
\title{Retrieves a list that describes one or more specified Amazon WorkSpaces
clients}
\usage{
workspaces_describe_client_properties(ResourceIds)
}
\arguments{
\item{ResourceIds}{[required] The resource identifier, in the form of directory IDs.}
}
\description{
Retrieves a list that describes one or more specified Amazon WorkSpaces clients.

See \url{https://www.paws-r-sdk.com/docs/workspaces_describe_client_properties/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspacesweb_operations.R
\name{workspacesweb_delete_user_access_logging_settings}
\alias{workspacesweb_delete_user_access_logging_settings}
\title{Deletes user access logging settings}
\usage{
workspacesweb_delete_user_access_logging_settings(userAccessLoggingSettingsArn)
}
\arguments{
\item{userAccessLoggingSettingsArn}{[required] The ARN of the user access logging settings.}
}
\description{
Deletes user access logging settings.

See \url{https://www.paws-r-sdk.com/docs/workspacesweb_delete_user_access_logging_settings/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/appstream_operations.R
\name{appstream_delete_fleet}
\alias{appstream_delete_fleet}
\title{Deletes the specified fleet}
\usage{
appstream_delete_fleet(Name)
}
\arguments{
\item{Name}{[required] The name of the fleet.}
}
\description{
Deletes the specified fleet.

See \url{https://www.paws-r-sdk.com/docs/appstream_delete_fleet/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/appstream_operations.R
\name{appstream_update_directory_config}
\alias{appstream_update_directory_config}
\title{Updates the specified Directory Config object in WorkSpaces Applications}
\usage{
appstream_update_directory_config(
  DirectoryName,
  OrganizationalUnitDistinguishedNames = NULL,
  ServiceAccountCredentials = NULL,
  CertificateBasedAuthProperties = NULL
)
}
\arguments{
\item{DirectoryName}{[required] The name of the Directory Config object.}

\item{OrganizationalUnitDistinguishedNames}{The distinguished names of the organizational units for computer accounts.}

\item{ServiceAccountCredentials}{The credentials for the service account used by the fleet or image builder to connect to the directory.}

\item{CertificateBasedAuthProperties}{The certificate-based authentication properties used to authenticate SAML 2.0 Identity Provider (IdP) user identities to Active Directory domain-joined streaming instances. Fallback is turned on by default when certificate-based authentication is \strong{Enabled} . Fallback allows users to log in using their AD domain password if certificate-based authentication is unsuccessful, or to unlock a desktop lock screen. \strong{Enabled_no_directory_login_fallback} enables certificate-based authentication, but does not allow users to log in using their AD domain password. Users will be disconnected to re-authenticate using certificates.}
}
\description{
Updates the specified Directory Config object in WorkSpaces Applications. This object includes the configuration information required to join fleets and image builders to Microsoft Active Directory domains.

See \url{https://www.paws-r-sdk.com/docs/appstream_update_directory_config/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/appstream_operations.R
\name{appstream_list_tags_for_resource}
\alias{appstream_list_tags_for_resource}
\title{Retrieves a list of all tags for the specified WorkSpaces Applications
resource}
\usage{
appstream_list_tags_for_resource(ResourceArn)
}
\arguments{
\item{ResourceArn}{[required] The Amazon Resource Name (ARN) of the resource.}
}
\description{
Retrieves a list of all tags for the specified WorkSpaces Applications resource. You can tag WorkSpaces Applications image builders, images, fleets, and stacks.

See \url{https://www.paws-r-sdk.com/docs/appstream_list_tags_for_resource/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_associate_member_to_group}
\alias{workmail_associate_member_to_group}
\title{Adds a member (user or group) to the group's set}
\usage{
workmail_associate_member_to_group(OrganizationId, GroupId, MemberId)
}
\arguments{
\item{OrganizationId}{[required] The organization under which the group exists.}

\item{GroupId}{[required] The group to which the member (user or group) is associated.

The identifier can accept \emph{GroupId}, \emph{Groupname}, or \emph{email}. The following identity formats are available:
\itemize{
\item Group ID: 12345678-1234-1234-1234-123456789012 or S-1-1-12-1234567890-123456789-123456789-1234
\item Email address: group@domain.tld
\item Group name: group
}}

\item{MemberId}{[required] The member (user or group) to associate to the group.

The member ID can accept \emph{UserID or GroupId}, \emph{Username or Groupname}, or \emph{email}.
\itemize{
\item Member: 12345678-1234-1234-1234-123456789012 or S-1-1-12-1234567890-123456789-123456789-1234
\item Email address: member@domain.tld
\item Member name: member
}}
}
\description{
Adds a member (user or group) to the group's set.

See \url{https://www.paws-r-sdk.com/docs/workmail_associate_member_to_group/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspaces_operations.R
\name{workspaces_update_connection_alias_permission}
\alias{workspaces_update_connection_alias_permission}
\title{Shares or unshares a connection alias with one account by specifying
whether that account has permission to associate the connection alias
with a directory}
\usage{
workspaces_update_connection_alias_permission(
  AliasId,
  ConnectionAliasPermission
)
}
\arguments{
\item{AliasId}{[required] The identifier of the connection alias that you want to update permissions for.}

\item{ConnectionAliasPermission}{[required] Indicates whether to share or unshare the connection alias with the specified Amazon Web Services account.}
}
\description{
Shares or unshares a connection alias with one account by specifying whether that account has permission to associate the connection alias with a directory. If the association permission is granted, the connection alias is shared with that account. If the association permission is revoked, the connection alias is unshared with the account. For more information, see \href{https://docs.aws.amazon.com/workspaces/latest/adminguide/cross-region-redirection.html}{Cross-Region Redirection for Amazon WorkSpaces}.

See \url{https://www.paws-r-sdk.com/docs/workspaces_update_connection_alias_permission/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/appstream_operations.R
\name{appstream_update_theme_for_stack}
\alias{appstream_update_theme_for_stack}
\title{Updates custom branding that customizes the appearance of the streaming
application catalog page}
\usage{
appstream_update_theme_for_stack(
  StackName,
  FooterLinks = NULL,
  TitleText = NULL,
  ThemeStyling = NULL,
  OrganizationLogoS3Location = NULL,
  FaviconS3Location = NULL,
  State = NULL,
  AttributesToDelete = NULL
)
}
\arguments{
\item{StackName}{[required] The name of the stack for the theme.}

\item{FooterLinks}{The links that are displayed in the footer of the streaming application catalog page. These links are helpful resources for users, such as the organization's IT support and product marketing sites.}

\item{TitleText}{The title that is displayed at the top of the browser tab during users' application streaming sessions.}

\item{ThemeStyling}{The color theme that is applied to website links, text, and buttons. These colors are also applied as accents in the background for the streaming application catalog page.}

\item{OrganizationLogoS3Location}{The organization logo that appears on the streaming application catalog page.}

\item{FaviconS3Location}{The S3 location of the favicon. The favicon enables users to recognize their application streaming site in a browser full of tabs or bookmarks. It is displayed at the top of the browser tab for the application streaming site during users' streaming sessions.}

\item{State}{Specifies whether custom branding should be applied to catalog page or not.}

\item{AttributesToDelete}{The attributes to delete.}
}
\description{
Updates custom branding that customizes the appearance of the streaming application catalog page.

See \url{https://www.paws-r-sdk.com/docs/appstream_update_theme_for_stack/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/chatbot_operations.R
\name{chatbot_list_tags_for_resource}
\alias{chatbot_list_tags_for_resource}
\title{Lists all of the tags associated with the Amazon Resource Name (ARN)
that you specify}
\usage{
chatbot_list_tags_for_resource(ResourceARN)
}
\arguments{
\item{ResourceARN}{[required] The ARN of the resource to list tags for.}
}
\description{
Lists all of the tags associated with the Amazon Resource Name (ARN) that you specify. The resource can be a user, server, or role.

See \url{https://www.paws-r-sdk.com/docs/chatbot_list_tags_for_resource/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_delete_mailbox_permissions}
\alias{workmail_delete_mailbox_permissions}
\title{Deletes permissions granted to a member (user or group)}
\usage{
workmail_delete_mailbox_permissions(OrganizationId, EntityId, GranteeId)
}
\arguments{
\item{OrganizationId}{[required] The identifier of the organization under which the member (user or group) exists.}

\item{EntityId}{[required] The identifier of the entity that owns the mailbox.

The identifier can be \emph{UserId or Group Id}, \emph{Username or Groupname}, or \emph{email}.
\itemize{
\item Entity ID: 12345678-1234-1234-1234-123456789012, r-0123456789a0123456789b0123456789, or S-1-1-12-1234567890-123456789-123456789-1234
\item Email address: entity@domain.tld
\item Entity name: entity
}}

\item{GranteeId}{[required] The identifier of the entity for which to delete granted permissions.

The identifier can be \emph{UserId, ResourceID, or Group Id}, \emph{Username or Groupname}, or \emph{email}.
\itemize{
\item Grantee ID: 12345678-1234-1234-1234-123456789012,r-0123456789a0123456789b0123456789, or S-1-1-12-1234567890-123456789-123456789-1234
\item Email address: grantee@domain.tld
\item Grantee name: grantee
}}
}
\description{
Deletes permissions granted to a member (user or group).

See \url{https://www.paws-r-sdk.com/docs/workmail_delete_mailbox_permissions/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/chatbot_operations.R
\name{chatbot_update_account_preferences}
\alias{chatbot_update_account_preferences}
\title{Updates AWS Chatbot account preferences}
\usage{
chatbot_update_account_preferences(
  UserAuthorizationRequired = NULL,
  TrainingDataCollectionEnabled = NULL
)
}
\arguments{
\item{UserAuthorizationRequired}{Enables use of a user role requirement in your chat configuration.}

\item{TrainingDataCollectionEnabled}{Turns on training data collection.

This helps improve the AWS Chatbot experience by allowing AWS Chatbot to store and use your customer information, such as AWS Chatbot configurations, notifications, user inputs, AWS Chatbot generated responses, and interaction data. This data helps us to continuously improve and develop Artificial Intelligence (AI) technologies. Your data is not shared with any third parties and is protected using sophisticated controls to prevent unauthorized access and misuse. AWS Chatbot does not store or use interactions in chat channels with Amazon Q for training AI technologies for AWS Chatbot.}
}
\description{
Updates AWS Chatbot account preferences.

See \url{https://www.paws-r-sdk.com/docs/chatbot_update_account_preferences/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_list_tags_for_resource}
\alias{workmail_list_tags_for_resource}
\title{Lists the tags applied to an WorkMail organization resource}
\usage{
workmail_list_tags_for_resource(ResourceARN)
}
\arguments{
\item{ResourceARN}{[required] The resource ARN.}
}
\description{
Lists the tags applied to an WorkMail organization resource.

See \url{https://www.paws-r-sdk.com/docs/workmail_list_tags_for_resource/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workdocs_operations.R
\name{workdocs_get_current_user}
\alias{workdocs_get_current_user}
\title{Retrieves details of the current user for whom the authentication token
was generated}
\usage{
workdocs_get_current_user(AuthenticationToken)
}
\arguments{
\item{AuthenticationToken}{[required] Amazon WorkDocs authentication token.}
}
\description{
Retrieves details of the current user for whom the authentication token was generated. This is not a valid action for SigV4 (administrative API) clients.

See \url{https://www.paws-r-sdk.com/docs/workdocs_get_current_user/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workdocs_operations.R
\name{workdocs_describe_notification_subscriptions}
\alias{workdocs_describe_notification_subscriptions}
\title{Lists the specified notification subscriptions}
\usage{
workdocs_describe_notification_subscriptions(
  OrganizationId,
  Marker = NULL,
  Limit = NULL
)
}
\arguments{
\item{OrganizationId}{[required] The ID of the organization.}

\item{Marker}{The marker for the next set of results. (You received this marker from a previous call.)}

\item{Limit}{The maximum number of items to return with this call.}
}
\description{
Lists the specified notification subscriptions.

See \url{https://www.paws-r-sdk.com/docs/workdocs_describe_notification_subscriptions/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/appstream_operations.R
\name{appstream_disassociate_software_from_image_builder}
\alias{appstream_disassociate_software_from_image_builder}
\title{Removes license included application(s) association(s) from an image
builder instance}
\usage{
appstream_disassociate_software_from_image_builder(
  ImageBuilderName,
  SoftwareNames
)
}
\arguments{
\item{ImageBuilderName}{[required] The name of the target image builder instance.}

\item{SoftwareNames}{[required] The list of license included applications to disassociate from the image builder.

Possible values include the following:
\itemize{
\item Microsoft_Office_2021_LTSC_Professional_Plus_32Bit
\item Microsoft_Office_2021_LTSC_Professional_Plus_64Bit
\item Microsoft_Office_2024_LTSC_Professional_Plus_32Bit
\item Microsoft_Office_2024_LTSC_Professional_Plus_64Bit
\item Microsoft_Visio_2021_LTSC_Professional_32Bit
\item Microsoft_Visio_2021_LTSC_Professional_64Bit
\item Microsoft_Visio_2024_LTSC_Professional_32Bit
\item Microsoft_Visio_2024_LTSC_Professional_64Bit
\item Microsoft_Project_2021_Professional_32Bit
\item Microsoft_Project_2021_Professional_64Bit
\item Microsoft_Project_2024_Professional_32Bit
\item Microsoft_Project_2024_Professional_64Bit
\item Microsoft_Office_2021_LTSC_Standard_32Bit
\item Microsoft_Office_2021_LTSC_Standard_64Bit
\item Microsoft_Office_2024_LTSC_Standard_32Bit
\item Microsoft_Office_2024_LTSC_Standard_64Bit
\item Microsoft_Visio_2021_LTSC_Standard_32Bit
\item Microsoft_Visio_2021_LTSC_Standard_64Bit
\item Microsoft_Visio_2024_LTSC_Standard_32Bit
\item Microsoft_Visio_2024_LTSC_Standard_64Bit
\item Microsoft_Project_2021_Standard_32Bit
\item Microsoft_Project_2021_Standard_64Bit
\item Microsoft_Project_2024_Standard_32Bit
\item Microsoft_Project_2024_Standard_64Bit
}}
}
\description{
Removes license included application(s) association(s) from an image builder instance.

See \url{https://www.paws-r-sdk.com/docs/appstream_disassociate_software_from_image_builder/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workdocs_operations.R
\name{workdocs_describe_activities}
\alias{workdocs_describe_activities}
\title{Describes the user activities in a specified time period}
\usage{
workdocs_describe_activities(
  AuthenticationToken = NULL,
  StartTime = NULL,
  EndTime = NULL,
  OrganizationId = NULL,
  ActivityTypes = NULL,
  ResourceId = NULL,
  UserId = NULL,
  IncludeIndirectActivities = NULL,
  Limit = NULL,
  Marker = NULL
)
}
\arguments{
\item{AuthenticationToken}{Amazon WorkDocs authentication token. Not required when using Amazon Web Services administrator credentials to access the API.}

\item{StartTime}{The timestamp that determines the starting time of the activities. The response includes the activities performed after the specified timestamp.}

\item{EndTime}{The timestamp that determines the end time of the activities. The response includes the activities performed before the specified timestamp.}

\item{OrganizationId}{The ID of the organization. This is a mandatory parameter when using administrative API (SigV4) requests.}

\item{ActivityTypes}{Specifies which activity types to include in the response. If this field is left empty, all activity types are returned.}

\item{ResourceId}{The document or folder ID for which to describe activity types.}

\item{UserId}{The ID of the user who performed the action. The response includes activities pertaining to this user. This is an optional parameter and is only applicable for administrative API (SigV4) requests.}

\item{IncludeIndirectActivities}{Includes indirect activities. An indirect activity results from a direct activity performed on a parent resource. For example, sharing a parent folder (the direct activity) shares all of the subfolders and documents within the parent folder (the indirect activity).}

\item{Limit}{The maximum number of items to return.}

\item{Marker}{The marker for the next set of results.}
}
\description{
Describes the user activities in a specified time period.

See \url{https://www.paws-r-sdk.com/docs/workdocs_describe_activities/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workdocs_operations.R
\name{workdocs_deactivate_user}
\alias{workdocs_deactivate_user}
\title{Deactivates the specified user, which revokes the user's access to
Amazon WorkDocs}
\usage{
workdocs_deactivate_user(UserId, AuthenticationToken = NULL)
}
\arguments{
\item{UserId}{[required] The ID of the user.}

\item{AuthenticationToken}{Amazon WorkDocs authentication token. Not required when using Amazon Web Services administrator credentials to access the API.}
}
\description{
Deactivates the specified user, which revokes the user's access to Amazon WorkDocs.

See \url{https://www.paws-r-sdk.com/docs/workdocs_deactivate_user/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/appstream_operations.R
\name{appstream_delete_app_block}
\alias{appstream_delete_app_block}
\title{Deletes an app block}
\usage{
appstream_delete_app_block(Name)
}
\arguments{
\item{Name}{[required] The name of the app block.}
}
\description{
Deletes an app block.

See \url{https://www.paws-r-sdk.com/docs/appstream_delete_app_block/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ivschat_operations.R
\name{ivschat_disconnect_user}
\alias{ivschat_disconnect_user}
\title{Disconnects all connections using a specified user ID from a room}
\usage{
ivschat_disconnect_user(roomIdentifier, userId, reason = NULL)
}
\arguments{
\item{roomIdentifier}{[required] Identifier of the room from which the user's clients should be disconnected. Currently this must be an ARN.}

\item{userId}{[required] ID of the user (connection) to disconnect from the room.}

\item{reason}{Reason for disconnecting the user.}
}
\description{
Disconnects all connections using a specified user ID from a room. This replicates the \href{https://docs.aws.amazon.com/ivs/latest/chatmsgapireference/actions-disconnectuser-publish.html}{DisconnectUser} WebSocket operation in the Amazon IVS Chat Messaging API.

See \url{https://www.paws-r-sdk.com/docs/ivschat_disconnect_user/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workdocs_operations.R
\name{workdocs_remove_resource_permission}
\alias{workdocs_remove_resource_permission}
\title{Removes the permission for the specified principal from the specified
resource}
\usage{
workdocs_remove_resource_permission(
  AuthenticationToken = NULL,
  ResourceId,
  PrincipalId,
  PrincipalType = NULL
)
}
\arguments{
\item{AuthenticationToken}{Amazon WorkDocs authentication token. Not required when using Amazon Web Services administrator credentials to access the API.}

\item{ResourceId}{[required] The ID of the resource.}

\item{PrincipalId}{[required] The principal ID of the resource.}

\item{PrincipalType}{The principal type of the resource.}
}
\description{
Removes the permission for the specified principal from the specified resource.

See \url{https://www.paws-r-sdk.com/docs/workdocs_remove_resource_permission/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workdocs_operations.R
\name{workdocs_search_resources}
\alias{workdocs_search_resources}
\title{Searches metadata and the content of folders, documents, document
versions, and comments}
\usage{
workdocs_search_resources(
  AuthenticationToken = NULL,
  QueryText = NULL,
  QueryScopes = NULL,
  OrganizationId = NULL,
  AdditionalResponseFields = NULL,
  Filters = NULL,
  OrderBy = NULL,
  Limit = NULL,
  Marker = NULL
)
}
\arguments{
\item{AuthenticationToken}{Amazon WorkDocs authentication token. Not required when using Amazon Web Services administrator credentials to access the API.}

\item{QueryText}{The String to search for. Searches across different text fields based on request parameters. Use double quotes around the query string for exact phrase matches.}

\item{QueryScopes}{Filter based on the text field type. A Folder has only a name and no content. A Comment has only content and no name. A Document or Document Version has a name and content}

\item{OrganizationId}{Filters based on the resource owner OrgId. This is a mandatory parameter when using Admin SigV4 credentials.}

\item{AdditionalResponseFields}{A list of attributes to include in the response. Used to request fields that are not normally returned in a standard response.}

\item{Filters}{Filters results based on entity metadata.}

\item{OrderBy}{Order by results in one or more categories.}

\item{Limit}{Max results count per page.}

\item{Marker}{The marker for the next set of results.}
}
\description{
Searches metadata and the content of folders, documents, document versions, and comments.

See \url{https://www.paws-r-sdk.com/docs/workdocs_search_resources/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspacesweb_operations.R
\name{workspacesweb_create_user_access_logging_settings}
\alias{workspacesweb_create_user_access_logging_settings}
\title{Creates a user access logging settings resource that can be associated
with a web portal}
\usage{
workspacesweb_create_user_access_logging_settings(
  kinesisStreamArn,
  tags = NULL,
  clientToken = NULL
)
}
\arguments{
\item{kinesisStreamArn}{[required] The ARN of the Kinesis stream.}

\item{tags}{The tags to add to the user settings resource. A tag is a key-value pair.}

\item{clientToken}{A unique, case-sensitive identifier that you provide to ensure the idempotency of the request. Idempotency ensures that an API request completes only once. With an idempotent request, if the original request completes successfully, subsequent retries with the same client token returns the result from the original successful request.

If you do not specify a client token, one is automatically generated by the Amazon Web Services SDK.}
}
\description{
Creates a user access logging settings resource that can be associated with a web portal.

See \url{https://www.paws-r-sdk.com/docs/workspacesweb_create_user_access_logging_settings/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_get_mobile_device_access_effect}
\alias{workmail_get_mobile_device_access_effect}
\title{Simulates the effect of the mobile device access rules for the given
attributes of a sample access event}
\usage{
workmail_get_mobile_device_access_effect(
  OrganizationId,
  DeviceType = NULL,
  DeviceModel = NULL,
  DeviceOperatingSystem = NULL,
  DeviceUserAgent = NULL
)
}
\arguments{
\item{OrganizationId}{[required] The WorkMail organization to simulate the access effect for.}

\item{DeviceType}{Device type the simulated user will report.}

\item{DeviceModel}{Device model the simulated user will report.}

\item{DeviceOperatingSystem}{Device operating system the simulated user will report.}

\item{DeviceUserAgent}{Device user agent the simulated user will report.}
}
\description{
Simulates the effect of the mobile device access rules for the given attributes of a sample access event. Use this method to test the effects of the current set of mobile device access rules for the WorkMail organization for a particular user's attributes.

See \url{https://www.paws-r-sdk.com/docs/workmail_get_mobile_device_access_effect/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_disassociate_delegate_from_resource}
\alias{workmail_disassociate_delegate_from_resource}
\title{Removes a member from the resource's set of delegates}
\usage{
workmail_disassociate_delegate_from_resource(
  OrganizationId,
  ResourceId,
  EntityId
)
}
\arguments{
\item{OrganizationId}{[required] The identifier for the organization under which the resource exists.}

\item{ResourceId}{[required] The identifier of the resource from which delegates' set members are removed.

The identifier can accept \emph{ResourceId}, \emph{Resourcename}, or \emph{email}. The following identity formats are available:
\itemize{
\item Resource ID: r-0123456789a0123456789b0123456789
\item Email address: resource@domain.tld
\item Resource name: resource
}}

\item{EntityId}{[required] The identifier for the member (user, group) to be removed from the resource's delegates.

The entity ID can accept \emph{UserId or GroupID}, \emph{Username or Groupname}, or \emph{email}.
\itemize{
\item Entity: 12345678-1234-1234-1234-123456789012 or S-1-1-12-1234567890-123456789-123456789-1234
\item Email address: entity@domain.tld
\item Entity: entity
}}
}
\description{
Removes a member from the resource's set of delegates.

See \url{https://www.paws-r-sdk.com/docs/workmail_disassociate_delegate_from_resource/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_put_identity_provider_configuration}
\alias{workmail_put_identity_provider_configuration}
\title{Enables integration between IAM Identity Center (IdC) and WorkMail to
proxy authentication requests for mailbox users}
\usage{
workmail_put_identity_provider_configuration(
  OrganizationId,
  AuthenticationMode,
  IdentityCenterConfiguration,
  PersonalAccessTokenConfiguration
)
}
\arguments{
\item{OrganizationId}{[required] The ID of the WorkMail Organization.}

\item{AuthenticationMode}{[required] The authentication mode used in WorkMail.}

\item{IdentityCenterConfiguration}{[required] The details of the IAM Identity Center configuration.}

\item{PersonalAccessTokenConfiguration}{[required] The details of the Personal Access Token configuration.}
}
\description{
Enables integration between IAM Identity Center (IdC) and WorkMail to proxy authentication requests for mailbox users. You can connect your IdC directory or your external directory to WorkMail through IdC and manage access to WorkMail mailboxes in a single place. For enhanced protection, you could enable Multifactor Authentication (MFA) and Personal Access Tokens.

See \url{https://www.paws-r-sdk.com/docs/workmail_put_identity_provider_configuration/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/chatbot_operations.R
\name{chatbot_tag_resource}
\alias{chatbot_tag_resource}
\title{Attaches a key-value pair to a resource, as identified by its Amazon
Resource Name (ARN)}
\usage{
chatbot_tag_resource(ResourceARN, Tags)
}
\arguments{
\item{ResourceARN}{[required] The ARN of the configuration.}

\item{Tags}{[required] A list of tags to apply to the configuration.}
}
\description{
Attaches a key-value pair to a resource, as identified by its Amazon Resource Name (ARN). Resources are users, servers, roles, and other entities.

See \url{https://www.paws-r-sdk.com/docs/chatbot_tag_resource/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workdocs_operations.R
\name{workdocs_create_notification_subscription}
\alias{workdocs_create_notification_subscription}
\title{Configure Amazon WorkDocs to use Amazon SNS notifications}
\usage{
workdocs_create_notification_subscription(
  OrganizationId,
  Endpoint,
  Protocol,
  SubscriptionType
)
}
\arguments{
\item{OrganizationId}{[required] The ID of the organization.}

\item{Endpoint}{[required] The endpoint to receive the notifications. If the protocol is HTTPS, the endpoint is a URL that begins with \code{https}.}

\item{Protocol}{[required] The protocol to use. The supported value is https, which delivers JSON-encoded messages using HTTPS POST.}

\item{SubscriptionType}{[required] The notification type.}
}
\description{
Configure Amazon WorkDocs to use Amazon SNS notifications. The endpoint receives a confirmation message, and must confirm the subscription.

See \url{https://www.paws-r-sdk.com/docs/workdocs_create_notification_subscription/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspaces_operations.R
\name{workspaces_terminate_workspaces_pool_session}
\alias{workspaces_terminate_workspaces_pool_session}
\title{Terminates the pool session}
\usage{
workspaces_terminate_workspaces_pool_session(SessionId)
}
\arguments{
\item{SessionId}{[required] The identifier of the pool session.}
}
\description{
Terminates the pool session.

See \url{https://www.paws-r-sdk.com/docs/workspaces_terminate_workspaces_pool_session/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspaces_operations.R
\name{workspaces_migrate_workspace}
\alias{workspaces_migrate_workspace}
\title{Migrates a WorkSpace from one operating system or bundle type to
another, while retaining the data on the user volume}
\usage{
workspaces_migrate_workspace(SourceWorkspaceId, BundleId)
}
\arguments{
\item{SourceWorkspaceId}{[required] The identifier of the WorkSpace to migrate from.}

\item{BundleId}{[required] The identifier of the target bundle type to migrate the WorkSpace to.}
}
\description{
Migrates a WorkSpace from one operating system or bundle type to another, while retaining the data on the user volume.

See \url{https://www.paws-r-sdk.com/docs/workspaces_migrate_workspace/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspacesweb_operations.R
\name{workspacesweb_create_trust_store}
\alias{workspacesweb_create_trust_store}
\title{Creates a trust store that can be associated with a web portal}
\usage{
workspacesweb_create_trust_store(
  certificateList,
  tags = NULL,
  clientToken = NULL
)
}
\arguments{
\item{certificateList}{[required] A list of CA certificates to be added to the trust store.}

\item{tags}{The tags to add to the trust store. A tag is a key-value pair.}

\item{clientToken}{A unique, case-sensitive identifier that you provide to ensure the idempotency of the request. Idempotency ensures that an API request completes only once. With an idempotent request, if the original request completes successfully, subsequent retries with the same client token returns the result from the original successful request.

If you do not specify a client token, one is automatically generated by the Amazon Web Services SDK.}
}
\description{
Creates a trust store that can be associated with a web portal. A trust store contains certificate authority (CA) certificates. Once associated with a web portal, the browser in a streaming session will recognize certificates that have been issued using any of the CAs in the trust store. If your organization has internal websites that use certificates issued by private CAs, you should add the private CA certificate to the trust store.

See \url{https://www.paws-r-sdk.com/docs/workspacesweb_create_trust_store/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspaces_operations.R
\name{workspaces_describe_workspaces_pools}
\alias{workspaces_describe_workspaces_pools}
\title{Describes the specified WorkSpaces Pools}
\usage{
workspaces_describe_workspaces_pools(
  PoolIds = NULL,
  Filters = NULL,
  Limit = NULL,
  NextToken = NULL
)
}
\arguments{
\item{PoolIds}{The identifier of the WorkSpaces Pools.}

\item{Filters}{The filter conditions for the WorkSpaces Pool to return.}

\item{Limit}{The maximum number of items to return.}

\item{NextToken}{If you received a \code{NextToken} from a previous call that was paginated, provide this token to receive the next set of results.}
}
\description{
Describes the specified WorkSpaces Pools.

See \url{https://www.paws-r-sdk.com/docs/workspaces_describe_workspaces_pools/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_register_to_work_mail}
\alias{workmail_register_to_work_mail}
\title{Registers an existing and disabled user, group, or resource for WorkMail
use by associating a mailbox and calendaring capabilities}
\usage{
workmail_register_to_work_mail(OrganizationId, EntityId, Email)
}
\arguments{
\item{OrganizationId}{[required] The identifier for the organization under which the user, group, or resource exists.}

\item{EntityId}{[required] The identifier for the user, group, or resource to be updated.

The identifier can accept \emph{UserId, ResourceId, or GroupId}, or \emph{Username, Resourcename, or Groupname}. The following identity formats are available:
\itemize{
\item Entity ID: 12345678-1234-1234-1234-123456789012, r-0123456789a0123456789b0123456789, or S-1-1-12-1234567890-123456789-123456789-1234
\item Entity name: entity
}}

\item{Email}{[required] The email for the user, group, or resource to be updated.}
}
\description{
Registers an existing and disabled user, group, or resource for WorkMail use by associating a mailbox and calendaring capabilities. It performs no change if the user, group, or resource is enabled and fails if the user, group, or resource is deleted. This operation results in the accumulation of costs. For more information, see \href{https://aws.amazon.com/workmail/pricing/}{Pricing}. The equivalent console functionality for this operation is \emph{Enable}.

See \url{https://www.paws-r-sdk.com/docs/workmail_register_to_work_mail/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspaces_operations.R
\name{workspaces_describe_connection_aliases}
\alias{workspaces_describe_connection_aliases}
\title{Retrieves a list that describes the connection aliases used for
cross-Region redirection}
\usage{
workspaces_describe_connection_aliases(
  AliasIds = NULL,
  ResourceId = NULL,
  Limit = NULL,
  NextToken = NULL
)
}
\arguments{
\item{AliasIds}{The identifiers of the connection aliases to describe.}

\item{ResourceId}{The identifier of the directory associated with the connection alias.}

\item{Limit}{The maximum number of connection aliases to return.}

\item{NextToken}{If you received a \code{NextToken} from a previous call that was paginated, provide this token to receive the next set of results.}
}
\description{
Retrieves a list that describes the connection aliases used for cross-Region redirection. For more information, see \href{https://docs.aws.amazon.com/workspaces/latest/adminguide/cross-region-redirection.html}{Cross-Region Redirection for Amazon WorkSpaces}.

See \url{https://www.paws-r-sdk.com/docs/workspaces_describe_connection_aliases/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workdocs_operations.R
\name{workdocs_describe_folder_contents}
\alias{workdocs_describe_folder_contents}
\title{Describes the contents of the specified folder, including its documents
and subfolders}
\usage{
workdocs_describe_folder_contents(
  AuthenticationToken = NULL,
  FolderId,
  Sort = NULL,
  Order = NULL,
  Limit = NULL,
  Marker = NULL,
  Type = NULL,
  Include = NULL
)
}
\arguments{
\item{AuthenticationToken}{Amazon WorkDocs authentication token. Not required when using Amazon Web Services administrator credentials to access the API.}

\item{FolderId}{[required] The ID of the folder.}

\item{Sort}{The sorting criteria.}

\item{Order}{The order for the contents of the folder.}

\item{Limit}{The maximum number of items to return with this call.}

\item{Marker}{The marker for the next set of results. This marker was received from a previous call.}

\item{Type}{The type of items.}

\item{Include}{The contents to include. Specify "INITIALIZED" to include initialized documents.}
}
\description{
Describes the contents of the specified folder, including its documents and subfolders.

See \url{https://www.paws-r-sdk.com/docs/workdocs_describe_folder_contents/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/chatbot_operations.R
\name{chatbot_create_chime_webhook_configuration}
\alias{chatbot_create_chime_webhook_configuration}
\title{Creates an AWS Chatbot configuration for Amazon Chime}
\usage{
chatbot_create_chime_webhook_configuration(
  WebhookDescription,
  WebhookUrl,
  SnsTopicArns,
  IamRoleArn,
  ConfigurationName,
  LoggingLevel = NULL,
  Tags = NULL
)
}
\arguments{
\item{WebhookDescription}{[required] A description of the webhook. We recommend using the convention \code{RoomName/WebhookName}.

For more information, see \href{https://docs.aws.amazon.com/chatbot/latest/adminguide/chime-setup.html}{Tutorial: Get started with Amazon Chime} in the \emph{AWS Chatbot Administrator Guide}.}

\item{WebhookUrl}{[required] The URL for the Amazon Chime webhook.}

\item{SnsTopicArns}{[required] The Amazon Resource Names (ARNs) of the SNS topics that deliver notifications to AWS Chatbot.}

\item{IamRoleArn}{[required] A user-defined role that AWS Chatbot assumes. This is not the service-linked role.

For more information, see \href{https://docs.aws.amazon.com/chatbot/latest/adminguide/chatbot-iam-policies.html}{IAM policies for AWS Chatbot} in the \emph{AWS Chatbot Administrator Guide}.}

\item{ConfigurationName}{[required] The name of the configuration.}

\item{LoggingLevel}{Logging levels include \code{ERROR}, \code{INFO}, or \code{NONE}.}

\item{Tags}{A map of tags assigned to a resource. A tag is a string-to-string map of key-value pairs.}
}
\description{
Creates an AWS Chatbot configuration for Amazon Chime.

See \url{https://www.paws-r-sdk.com/docs/chatbot_create_chime_webhook_configuration/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspaces_operations.R
\name{workspaces_update_workspace_image_permission}
\alias{workspaces_update_workspace_image_permission}
\title{Shares or unshares an image with one account in the same Amazon Web
Services Region by specifying whether that account has permission to
copy the image}
\usage{
workspaces_update_workspace_image_permission(
  ImageId,
  AllowCopyImage,
  SharedAccountId
)
}
\arguments{
\item{ImageId}{[required] The identifier of the image.}

\item{AllowCopyImage}{[required] The permission to copy the image. This permission can be revoked only after an image has been shared.}

\item{SharedAccountId}{[required] The identifier of the Amazon Web Services account to share or unshare the image with.

Before sharing the image, confirm that you are sharing to the correct Amazon Web Services account ID.}
}
\description{
Shares or unshares an image with one account in the same Amazon Web Services Region by specifying whether that account has permission to copy the image. If the copy image permission is granted, the image is shared with that account. If the copy image permission is revoked, the image is unshared with the account.

See \url{https://www.paws-r-sdk.com/docs/workspaces_update_workspace_image_permission/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workdocs_operations.R
\name{workdocs_restore_document_versions}
\alias{workdocs_restore_document_versions}
\title{Recovers a deleted version of an Amazon WorkDocs document}
\usage{
workdocs_restore_document_versions(AuthenticationToken = NULL, DocumentId)
}
\arguments{
\item{AuthenticationToken}{Amazon WorkDocs authentication token. Not required when using Amazon Web Services administrator credentials to access the API.}

\item{DocumentId}{[required] The ID of the document.}
}
\description{
Recovers a deleted version of an Amazon WorkDocs document.

See \url{https://www.paws-r-sdk.com/docs/workdocs_restore_document_versions/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_update_impersonation_role}
\alias{workmail_update_impersonation_role}
\title{Updates an impersonation role for the given WorkMail organization}
\usage{
workmail_update_impersonation_role(
  OrganizationId,
  ImpersonationRoleId,
  Name,
  Type,
  Description = NULL,
  Rules
)
}
\arguments{
\item{OrganizationId}{[required] The WorkMail organization that contains the impersonation role to update.}

\item{ImpersonationRoleId}{[required] The ID of the impersonation role to update.}

\item{Name}{[required] The updated impersonation role name.}

\item{Type}{[required] The updated impersonation role type.}

\item{Description}{The updated impersonation role description.}

\item{Rules}{[required] The updated list of rules.}
}
\description{
Updates an impersonation role for the given WorkMail organization.

See \url{https://www.paws-r-sdk.com/docs/workmail_update_impersonation_role/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspacesweb_operations.R
\name{workspacesweb_delete_session_logger}
\alias{workspacesweb_delete_session_logger}
\title{Deletes a session logger resource}
\usage{
workspacesweb_delete_session_logger(sessionLoggerArn)
}
\arguments{
\item{sessionLoggerArn}{[required] The ARN of the session logger.}
}
\description{
Deletes a session logger resource.

See \url{https://www.paws-r-sdk.com/docs/workspacesweb_delete_session_logger/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_tag_resource}
\alias{workmail_tag_resource}
\title{Applies the specified tags to the specified WorkMailorganization
resource}
\usage{
workmail_tag_resource(ResourceARN, Tags)
}
\arguments{
\item{ResourceARN}{[required] The resource ARN.}

\item{Tags}{[required] The tag key-value pairs.}
}
\description{
Applies the specified tags to the specified WorkMailorganization resource.

See \url{https://www.paws-r-sdk.com/docs/workmail_tag_resource/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/appstream_operations.R
\name{appstream_delete_directory_config}
\alias{appstream_delete_directory_config}
\title{Deletes the specified Directory Config object from WorkSpaces
Applications}
\usage{
appstream_delete_directory_config(DirectoryName)
}
\arguments{
\item{DirectoryName}{[required] The name of the directory configuration.}
}
\description{
Deletes the specified Directory Config object from WorkSpaces Applications. This object includes the information required to join streaming instances to an Active Directory domain.

See \url{https://www.paws-r-sdk.com/docs/appstream_delete_directory_config/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_create_organization}
\alias{workmail_create_organization}
\title{Creates a new WorkMail organization}
\usage{
workmail_create_organization(
  DirectoryId = NULL,
  Alias,
  ClientToken = NULL,
  Domains = NULL,
  KmsKeyArn = NULL,
  EnableInteroperability = NULL
)
}
\arguments{
\item{DirectoryId}{The AWS Directory Service directory ID.}

\item{Alias}{[required] The organization alias.}

\item{ClientToken}{The idempotency token associated with the request.}

\item{Domains}{The email domains to associate with the organization.}

\item{KmsKeyArn}{The Amazon Resource Name (ARN) of a customer managed key from AWS KMS.}

\item{EnableInteroperability}{When \code{true}, allows organization interoperability between WorkMail and Microsoft Exchange. If \code{true}, you must include a AD Connector directory ID in the request.}
}
\description{
Creates a new WorkMail organization. Optionally, you can choose to associate an existing AWS Directory Service directory with your organization. If an AWS Directory Service directory ID is specified, the organization alias must match the directory alias. If you choose not to associate an existing directory with your organization, then we create a new WorkMail directory for you. For more information, see \href{https://docs.aws.amazon.com/workmail/latest/adminguide/add_new_organization.html}{Adding an organization} in the \emph{WorkMail Administrator Guide}.

See \url{https://www.paws-r-sdk.com/docs/workmail_create_organization/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_delete_access_control_rule}
\alias{workmail_delete_access_control_rule}
\title{Deletes an access control rule for the specified WorkMail organization}
\usage{
workmail_delete_access_control_rule(OrganizationId, Name)
}
\arguments{
\item{OrganizationId}{[required] The identifier for the organization.}

\item{Name}{[required] The name of the access control rule.}
}
\description{
Deletes an access control rule for the specified WorkMail organization.

See \url{https://www.paws-r-sdk.com/docs/workmail_delete_access_control_rule/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/appstream_operations.R
\name{appstream_batch_disassociate_user_stack}
\alias{appstream_batch_disassociate_user_stack}
\title{Disassociates the specified users from the specified stacks}
\usage{
appstream_batch_disassociate_user_stack(UserStackAssociations)
}
\arguments{
\item{UserStackAssociations}{[required] The list of UserStackAssociation objects.}
}
\description{
Disassociates the specified users from the specified stacks.

See \url{https://www.paws-r-sdk.com/docs/appstream_batch_disassociate_user_stack/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ivschat_operations.R
\name{ivschat_create_logging_configuration}
\alias{ivschat_create_logging_configuration}
\title{Creates a logging configuration that allows clients to store and record
sent messages}
\usage{
ivschat_create_logging_configuration(
  name = NULL,
  destinationConfiguration,
  tags = NULL
)
}
\arguments{
\item{name}{Logging-configuration name. The value does not need to be unique.}

\item{destinationConfiguration}{[required] A complex type that contains a destination configuration for where chat content will be logged. There can be only one type of destination (\code{cloudWatchLogs}, \code{firehose}, or \code{s3}) in a \code{destinationConfiguration}.}

\item{tags}{Tags to attach to the resource. Array of maps, each of the form \code{string:string (key:value)}. See \href{https://docs.aws.amazon.com/tag-editor/latest/userguide/best-practices-and-strats.html}{Best practices and strategies} in \emph{Tagging Amazon Web Services Resources and Tag Editor} for details, including restrictions that apply to tags and "Tag naming limits and requirements"; Amazon IVS Chat has no constraints on tags beyond what is documented there.}
}
\description{
Creates a logging configuration that allows clients to store and record sent messages.

See \url{https://www.paws-r-sdk.com/docs/ivschat_create_logging_configuration/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspacesweb_operations.R
\name{workspacesweb_update_browser_settings}
\alias{workspacesweb_update_browser_settings}
\title{Updates browser settings}
\usage{
workspacesweb_update_browser_settings(
  browserSettingsArn,
  browserPolicy = NULL,
  clientToken = NULL,
  webContentFilteringPolicy = NULL
)
}
\arguments{
\item{browserSettingsArn}{[required] The ARN of the browser settings.}

\item{browserPolicy}{A JSON string containing Chrome Enterprise policies that will be applied to all streaming sessions.}

\item{clientToken}{A unique, case-sensitive identifier that you provide to ensure the idempotency of the request. Idempotency ensures that an API request completes only once. With an idempotent request, if the original request completes successfully, subsequent retries with the same client token return the result from the original successful request.

If you do not specify a client token, one is automatically generated by the Amazon Web Services SDK.}

\item{webContentFilteringPolicy}{The policy that specifies which URLs end users are allowed to access or which URLs or domain categories they are restricted from accessing for enhanced security.}
}
\description{
Updates browser settings.

See \url{https://www.paws-r-sdk.com/docs/workspacesweb_update_browser_settings/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workdocs_operations.R
\name{workdocs_update_user}
\alias{workdocs_update_user}
\title{Updates the specified attributes of the specified user, and grants or
revokes administrative privileges to the Amazon WorkDocs site}
\usage{
workdocs_update_user(
  AuthenticationToken = NULL,
  UserId,
  GivenName = NULL,
  Surname = NULL,
  Type = NULL,
  StorageRule = NULL,
  TimeZoneId = NULL,
  Locale = NULL,
  GrantPoweruserPrivileges = NULL
)
}
\arguments{
\item{AuthenticationToken}{Amazon WorkDocs authentication token. Not required when using Amazon Web Services administrator credentials to access the API.}

\item{UserId}{[required] The ID of the user.}

\item{GivenName}{The given name of the user.}

\item{Surname}{The surname of the user.}

\item{Type}{The type of the user.}

\item{StorageRule}{The amount of storage for the user.}

\item{TimeZoneId}{The time zone ID of the user.}

\item{Locale}{The locale of the user.}

\item{GrantPoweruserPrivileges}{Boolean value to determine whether the user is granted Power user privileges.}
}
\description{
Updates the specified attributes of the specified user, and grants or revokes administrative privileges to the Amazon WorkDocs site.

See \url{https://www.paws-r-sdk.com/docs/workdocs_update_user/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspaces_operations.R
\name{workspaces_update_connect_client_add_in}
\alias{workspaces_update_connect_client_add_in}
\title{Updates a Amazon Connect client add-in}
\usage{
workspaces_update_connect_client_add_in(
  AddInId,
  ResourceId,
  Name = NULL,
  URL = NULL
)
}
\arguments{
\item{AddInId}{[required] The identifier of the client add-in to update.}

\item{ResourceId}{[required] The directory identifier for which the client add-in is configured.}

\item{Name}{The name of the client add-in.}

\item{URL}{The endpoint URL of the Amazon Connect client add-in.}
}
\description{
Updates a Amazon Connect client add-in. Use this action to update the name and endpoint URL of a Amazon Connect client add-in.

See \url{https://www.paws-r-sdk.com/docs/workspaces_update_connect_client_add_in/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspacesweb_operations.R
\name{workspacesweb_disassociate_trust_store}
\alias{workspacesweb_disassociate_trust_store}
\title{Disassociates a trust store from a web portal}
\usage{
workspacesweb_disassociate_trust_store(portalArn)
}
\arguments{
\item{portalArn}{[required] The ARN of the web portal.}
}
\description{
Disassociates a trust store from a web portal.

See \url{https://www.paws-r-sdk.com/docs/workspacesweb_disassociate_trust_store/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspaces_operations.R
\name{workspaces_create_ip_group}
\alias{workspaces_create_ip_group}
\title{Creates an IP access control group}
\usage{
workspaces_create_ip_group(
  GroupName,
  GroupDesc = NULL,
  UserRules = NULL,
  Tags = NULL
)
}
\arguments{
\item{GroupName}{[required] The name of the group.}

\item{GroupDesc}{The description of the group.}

\item{UserRules}{The rules to add to the group.}

\item{Tags}{The tags. Each WorkSpaces resource can have a maximum of 50 tags.}
}
\description{
Creates an IP access control group.

See \url{https://www.paws-r-sdk.com/docs/workspaces_create_ip_group/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/chatbot_operations.R
\name{chatbot_update_chime_webhook_configuration}
\alias{chatbot_update_chime_webhook_configuration}
\title{Updates a Amazon Chime webhook configuration}
\usage{
chatbot_update_chime_webhook_configuration(
  ChatConfigurationArn,
  WebhookDescription = NULL,
  WebhookUrl = NULL,
  SnsTopicArns = NULL,
  IamRoleArn = NULL,
  LoggingLevel = NULL
)
}
\arguments{
\item{ChatConfigurationArn}{[required] The Amazon Resource Name (ARN) of the ChimeWebhookConfiguration to update.}

\item{WebhookDescription}{A description of the webhook. We recommend using the convention \code{RoomName/WebhookName}.

For more information, see \href{https://docs.aws.amazon.com/chatbot/latest/adminguide/chime-setup.html}{Tutorial: Get started with Amazon Chime} in the \emph{AWS Chatbot Administrator Guide}.}

\item{WebhookUrl}{The URL for the Amazon Chime webhook.}

\item{SnsTopicArns}{The ARNs of the SNS topics that deliver notifications to AWS Chatbot.}

\item{IamRoleArn}{A user-defined role that AWS Chatbot assumes. This is not the service-linked role.

For more information, see \href{https://docs.aws.amazon.com/chatbot/latest/adminguide/chatbot-iam-policies.html}{IAM policies for AWS Chatbot} in the \emph{AWS Chatbot Administrator Guide}.}

\item{LoggingLevel}{Logging levels include \code{ERROR}, \code{INFO}, or \code{NONE}.}
}
\description{
Updates a Amazon Chime webhook configuration.

See \url{https://www.paws-r-sdk.com/docs/chatbot_update_chime_webhook_configuration/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_list_impersonation_roles}
\alias{workmail_list_impersonation_roles}
\title{Lists all the impersonation roles for the given WorkMail organization}
\usage{
workmail_list_impersonation_roles(
  OrganizationId,
  NextToken = NULL,
  MaxResults = NULL
)
}
\arguments{
\item{OrganizationId}{[required] The WorkMail organization to which the listed impersonation roles belong.}

\item{NextToken}{The token used to retrieve the next page of results. The first call doesn't require a token.}

\item{MaxResults}{The maximum number of results returned in a single call.}
}
\description{
Lists all the impersonation roles for the given WorkMail organization.

See \url{https://www.paws-r-sdk.com/docs/workmail_list_impersonation_roles/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workdocs_operations.R
\name{workdocs_describe_document_versions}
\alias{workdocs_describe_document_versions}
\title{Retrieves the document versions for the specified document}
\usage{
workdocs_describe_document_versions(
  AuthenticationToken = NULL,
  DocumentId,
  Marker = NULL,
  Limit = NULL,
  Include = NULL,
  Fields = NULL
)
}
\arguments{
\item{AuthenticationToken}{Amazon WorkDocs authentication token. Not required when using Amazon Web Services administrator credentials to access the API.}

\item{DocumentId}{[required] The ID of the document.}

\item{Marker}{The marker for the next set of results. (You received this marker from a previous call.)}

\item{Limit}{The maximum number of versions to return with this call.}

\item{Include}{A comma-separated list of values. Specify "INITIALIZED" to include incomplete versions.}

\item{Fields}{Specify "SOURCE" to include initialized versions and a URL for the source document.}
}
\description{
Retrieves the document versions for the specified document.

See \url{https://www.paws-r-sdk.com/docs/workdocs_describe_document_versions/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspaces_operations.R
\name{workspaces_describe_account}
\alias{workspaces_describe_account}
\title{Retrieves a list that describes the configuration of Bring Your Own
License (BYOL) for the specified account}
\usage{
workspaces_describe_account()
}
\description{
Retrieves a list that describes the configuration of Bring Your Own License (BYOL) for the specified account.

See \url{https://www.paws-r-sdk.com/docs/workspaces_describe_account/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/appstream_operations.R
\name{appstream_describe_image_permissions}
\alias{appstream_describe_image_permissions}
\title{Retrieves a list that describes the permissions for shared AWS account
IDs on a private image that you own}
\usage{
appstream_describe_image_permissions(
  Name,
  MaxResults = NULL,
  SharedAwsAccountIds = NULL,
  NextToken = NULL
)
}
\arguments{
\item{Name}{[required] The name of the private image for which to describe permissions. The image must be one that you own.}

\item{MaxResults}{The maximum size of each page of results.}

\item{SharedAwsAccountIds}{The 12-digit identifier of one or more AWS accounts with which the image is shared.}

\item{NextToken}{The pagination token to use to retrieve the next page of results for this operation. If this value is null, it retrieves the first page.}
}
\description{
Retrieves a list that describes the permissions for shared AWS account IDs on a private image that you own.

See \url{https://www.paws-r-sdk.com/docs/appstream_describe_image_permissions/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workdocs_service.R
\name{workdocs}
\alias{workdocs}
\title{Amazon WorkDocs}
\usage{
workdocs(config = list(), credentials = list(), endpoint = NULL, region = NULL)
}
\arguments{
\item{config}{Optional configuration of credentials, endpoint, and/or region.
\itemize{
\item{\strong{credentials}: \itemize{
\item{\strong{creds}: \itemize{
\item{\strong{access_key_id}: AWS access key ID}
\item{\strong{secret_access_key}: AWS secret access key}
\item{\strong{session_token}: AWS temporary session token}
}}
\item{\strong{profile}: The name of a profile to use. If not given, then the default profile is used.}
\item{\strong{anonymous}: Set anonymous credentials.}
}}
\item{\strong{endpoint}: The complete URL to use for the constructed client.}
\item{\strong{region}: The AWS Region used in instantiating the client.}
\item{\strong{close_connection}: Immediately close all HTTP connections.}
\item{\strong{timeout}: The time in seconds till a timeout exception is thrown when attempting to make a connection. The default is 60 seconds.}
\item{\strong{s3_force_path_style}: Set this to \code{true} to force the request to use path-style addressing, i.e. \verb{http://s3.amazonaws.com/BUCKET/KEY}.}
\item{\strong{sts_regional_endpoint}: Set sts regional endpoint resolver to regional or legacy \url{https://docs.aws.amazon.com/sdkref/latest/guide/feature-sts-regionalized-endpoints.html}}
}}

\item{credentials}{Optional credentials shorthand for the config parameter
\itemize{
\item{\strong{creds}: \itemize{
\item{\strong{access_key_id}: AWS access key ID}
\item{\strong{secret_access_key}: AWS secret access key}
\item{\strong{session_token}: AWS temporary session token}
}}
\item{\strong{profile}: The name of a profile to use. If not given, then the default profile is used.}
\item{\strong{anonymous}: Set anonymous credentials.}
}}

\item{endpoint}{Optional shorthand for complete URL to use for the constructed client.}

\item{region}{Optional shorthand for AWS Region used in instantiating the client.}
}
\value{
A client for the service. You can call the service's operations using
syntax like \code{svc$operation(...)}, where \code{svc} is the name you've assigned
to the client. The available operations are listed in the
Operations section.
}
\description{
The Amazon WorkDocs API is designed for the following use cases:
\itemize{
\item File Migration: File migration applications are supported for users who want to migrate their files from an on-premises or off-premises file system or service. Users can insert files into a user directory structure, as well as allow for basic metadata changes, such as modifications to the permissions of files.
\item Security: Support security applications are supported for users who have additional security needs, such as antivirus or data loss prevention. The API actions, along with CloudTrail, allow these applications to detect when changes occur in Amazon WorkDocs. Then, the application can take the necessary actions and replace the target file. If the target file violates the policy, the application can also choose to email the user.
\item eDiscovery/Analytics: General administrative applications are supported, such as eDiscovery and analytics. These applications can choose to mimic or record the actions in an Amazon WorkDocs site, along with CloudTrail, to replicate data for eDiscovery, backup, or analytical applications.
}

All Amazon WorkDocs API actions are Amazon authenticated and certificate-signed. They not only require the use of the Amazon Web Services SDK, but also allow for the exclusive use of IAM users and roles to help facilitate access, trust, and permission policies. By creating a role and allowing an IAM user to access the Amazon WorkDocs site, the IAM user gains full administrative visibility into the entire Amazon WorkDocs site (or as set in the IAM policy). This includes, but is not limited to, the ability to modify file permissions and upload any file to any user. This allows developers to perform the three use cases above, as well as give users the ability to grant access on a selective basis using the IAM model.

The pricing for Amazon WorkDocs APIs varies depending on the API call type for these actions:
\itemize{
\item \verb{READ (Get*)}
\item \verb{WRITE (Activate*, Add*, Create*, Deactivate*, Initiate*, Update*)}
\item \verb{LIST (Describe*)}
\item \verb{DELETE*, CANCEL}
}

For information about Amazon WorkDocs API pricing, see \href{https://aws.amazon.com/}{Amazon WorkDocs Pricing}.
}
\section{Service syntax}{


\if{html}{\out{<div class="sourceCode">}}\preformatted{svc <- workdocs(
  config = list(
    credentials = list(
      creds = list(
        access_key_id = "string",
        secret_access_key = "string",
        session_token = "string"
      ),
      profile = "string",
      anonymous = "logical"
    ),
    endpoint = "string",
    region = "string",
    close_connection = "logical",
    timeout = "numeric",
    s3_force_path_style = "logical",
    sts_regional_endpoint = "string"
  ),
  credentials = list(
    creds = list(
      access_key_id = "string",
      secret_access_key = "string",
      session_token = "string"
    ),
    profile = "string",
    anonymous = "logical"
  ),
  endpoint = "string",
  region = "string"
)
}\if{html}{\out{</div>}}
}

\section{Operations}{

\tabular{ll}{
\link[=workdocs_abort_document_version_upload]{abort_document_version_upload} \tab Aborts the upload of the specified document version that was previously initiated by InitiateDocumentVersionUpload\cr
\link[=workdocs_activate_user]{activate_user} \tab Activates the specified user\cr
\link[=workdocs_add_resource_permissions]{add_resource_permissions} \tab Creates a set of permissions for the specified folder or document\cr
\link[=workdocs_create_comment]{create_comment} \tab Adds a new comment to the specified document version\cr
\link[=workdocs_create_custom_metadata]{create_custom_metadata} \tab Adds one or more custom properties to the specified resource (a folder, document, or version)\cr
\link[=workdocs_create_folder]{create_folder} \tab Creates a folder with the specified name and parent folder\cr
\link[=workdocs_create_labels]{create_labels} \tab Adds the specified list of labels to the given resource (a document or folder)\cr
\link[=workdocs_create_notification_subscription]{create_notification_subscription} \tab Configure Amazon WorkDocs to use Amazon SNS notifications\cr
\link[=workdocs_create_user]{create_user} \tab Creates a user in a Simple AD or Microsoft AD directory\cr
\link[=workdocs_deactivate_user]{deactivate_user} \tab Deactivates the specified user, which revokes the user's access to Amazon WorkDocs\cr
\link[=workdocs_delete_comment]{delete_comment} \tab Deletes the specified comment from the document version\cr
\link[=workdocs_delete_custom_metadata]{delete_custom_metadata} \tab Deletes custom metadata from the specified resource\cr
\link[=workdocs_delete_document]{delete_document} \tab Permanently deletes the specified document and its associated metadata\cr
\link[=workdocs_delete_document_version]{delete_document_version} \tab Deletes a specific version of a document\cr
\link[=workdocs_delete_folder]{delete_folder} \tab Permanently deletes the specified folder and its contents\cr
\link[=workdocs_delete_folder_contents]{delete_folder_contents} \tab Deletes the contents of the specified folder\cr
\link[=workdocs_delete_labels]{delete_labels} \tab Deletes the specified list of labels from a resource\cr
\link[=workdocs_delete_notification_subscription]{delete_notification_subscription} \tab Deletes the specified subscription from the specified organization\cr
\link[=workdocs_delete_user]{delete_user} \tab Deletes the specified user from a Simple AD or Microsoft AD directory\cr
\link[=workdocs_describe_activities]{describe_activities} \tab Describes the user activities in a specified time period\cr
\link[=workdocs_describe_comments]{describe_comments} \tab List all the comments for the specified document version\cr
\link[=workdocs_describe_document_versions]{describe_document_versions} \tab Retrieves the document versions for the specified document\cr
\link[=workdocs_describe_folder_contents]{describe_folder_contents} \tab Describes the contents of the specified folder, including its documents and subfolders\cr
\link[=workdocs_describe_groups]{describe_groups} \tab Describes the groups specified by the query\cr
\link[=workdocs_describe_notification_subscriptions]{describe_notification_subscriptions} \tab Lists the specified notification subscriptions\cr
\link[=workdocs_describe_resource_permissions]{describe_resource_permissions} \tab Describes the permissions of a specified resource\cr
\link[=workdocs_describe_root_folders]{describe_root_folders} \tab Describes the current user's special folders; the RootFolder and the RecycleBin\cr
\link[=workdocs_describe_users]{describe_users} \tab Describes the specified users\cr
\link[=workdocs_get_current_user]{get_current_user} \tab Retrieves details of the current user for whom the authentication token was generated\cr
\link[=workdocs_get_document]{get_document} \tab Retrieves details of a document\cr
\link[=workdocs_get_document_path]{get_document_path} \tab Retrieves the path information (the hierarchy from the root folder) for the requested document\cr
\link[=workdocs_get_document_version]{get_document_version} \tab Retrieves version metadata for the specified document\cr
\link[=workdocs_get_folder]{get_folder} \tab Retrieves the metadata of the specified folder\cr
\link[=workdocs_get_folder_path]{get_folder_path} \tab Retrieves the path information (the hierarchy from the root folder) for the specified folder\cr
\link[=workdocs_get_resources]{get_resources} \tab Retrieves a collection of resources, including folders and documents\cr
\link[=workdocs_initiate_document_version_upload]{initiate_document_version_upload} \tab Creates a new document object and version object\cr
\link[=workdocs_remove_all_resource_permissions]{remove_all_resource_permissions} \tab Removes all the permissions from the specified resource\cr
\link[=workdocs_remove_resource_permission]{remove_resource_permission} \tab Removes the permission for the specified principal from the specified resource\cr
\link[=workdocs_restore_document_versions]{restore_document_versions} \tab Recovers a deleted version of an Amazon WorkDocs document\cr
\link[=workdocs_search_resources]{search_resources} \tab Searches metadata and the content of folders, documents, document versions, and comments\cr
\link[=workdocs_update_document]{update_document} \tab Updates the specified attributes of a document\cr
\link[=workdocs_update_document_version]{update_document_version} \tab Changes the status of the document version to ACTIVE\cr
\link[=workdocs_update_folder]{update_folder} \tab Updates the specified attributes of the specified folder\cr
\link[=workdocs_update_user]{update_user} \tab Updates the specified attributes of the specified user, and grants or revokes administrative privileges to the Amazon WorkDocs site
}
}

\examples{
\dontrun{
svc <- workdocs()
svc$abort_document_version_upload(
  Foo = 123
)
}

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/chatbot_operations.R
\name{chatbot_delete_microsoft_teams_channel_configuration}
\alias{chatbot_delete_microsoft_teams_channel_configuration}
\title{Deletes a Microsoft Teams channel configuration for AWS Chatbot}
\usage{
chatbot_delete_microsoft_teams_channel_configuration(ChatConfigurationArn)
}
\arguments{
\item{ChatConfigurationArn}{[required] The Amazon Resource Name (ARN) of the MicrosoftTeamsChannelConfiguration associated with the user identity to delete.}
}
\description{
Deletes a Microsoft Teams channel configuration for AWS Chatbot

See \url{https://www.paws-r-sdk.com/docs/chatbot_delete_microsoft_teams_channel_configuration/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_list_mobile_device_access_overrides}
\alias{workmail_list_mobile_device_access_overrides}
\title{Lists all the mobile device access overrides for any given combination
of WorkMail organization, user, or device}
\usage{
workmail_list_mobile_device_access_overrides(
  OrganizationId,
  UserId = NULL,
  DeviceId = NULL,
  NextToken = NULL,
  MaxResults = NULL
)
}
\arguments{
\item{OrganizationId}{[required] The WorkMail organization under which to list mobile device access overrides.}

\item{UserId}{The WorkMail user under which you list the mobile device access overrides. Accepts the following types of user identities:
\itemize{
\item User ID: \code{12345678-1234-1234-1234-123456789012} or \code{S-1-1-12-1234567890-123456789-123456789-1234}
\item Email address: \code{user@domain.tld}
\item User name: \code{user}
}}

\item{DeviceId}{The mobile device to which the access override applies.}

\item{NextToken}{The token to use to retrieve the next page of results. The first call does not require a token.}

\item{MaxResults}{The maximum number of results to return in a single call.}
}
\description{
Lists all the mobile device access overrides for any given combination of WorkMail organization, user, or device.

See \url{https://www.paws-r-sdk.com/docs/workmail_list_mobile_device_access_overrides/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspaces_operations.R
\name{workspaces_create_workspaces_pool}
\alias{workspaces_create_workspaces_pool}
\title{Creates a pool of WorkSpaces}
\usage{
workspaces_create_workspaces_pool(
  PoolName,
  Description,
  BundleId,
  DirectoryId,
  Capacity,
  Tags = NULL,
  ApplicationSettings = NULL,
  TimeoutSettings = NULL,
  RunningMode = NULL
)
}
\arguments{
\item{PoolName}{[required] The name of the pool.}

\item{Description}{[required] The pool description.}

\item{BundleId}{[required] The identifier of the bundle for the pool.}

\item{DirectoryId}{[required] The identifier of the directory for the pool.}

\item{Capacity}{[required] The user capacity of the pool.}

\item{Tags}{The tags for the pool.}

\item{ApplicationSettings}{Indicates the application settings of the pool.}

\item{TimeoutSettings}{Indicates the timeout settings of the pool.}

\item{RunningMode}{The running mode for the pool.}
}
\description{
Creates a pool of WorkSpaces.

See \url{https://www.paws-r-sdk.com/docs/workspaces_create_workspaces_pool/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/chatbot_operations.R
\name{chatbot_create_custom_action}
\alias{chatbot_create_custom_action}
\title{Creates a custom action that can be invoked as an alias or as a button
on a notification}
\usage{
chatbot_create_custom_action(
  Definition,
  AliasName = NULL,
  Attachments = NULL,
  Tags = NULL,
  ClientToken = NULL,
  ActionName
)
}
\arguments{
\item{Definition}{[required] The definition of the command to run when invoked as an alias or as an action button.}

\item{AliasName}{The name used to invoke this action in a chat channel. For example, \verb{@aws run my-alias}.}

\item{Attachments}{Defines when this custom action button should be attached to a notification.}

\item{Tags}{A map of tags assigned to a resource. A tag is a string-to-string map of key-value pairs.}

\item{ClientToken}{A unique, case-sensitive identifier that you provide to ensure the idempotency of the request. Idempotency ensures that an API request completes only once. With an idempotent request, if the original request completes successfully, subsequent retries with the same client token returns the result from the original successful request.

If you do not specify a client token, one is automatically generated by the SDK.}

\item{ActionName}{[required] The name of the custom action. This name is included in the Amazon Resource Name (ARN).}
}
\description{
Creates a custom action that can be invoked as an alias or as a button on a notification.

See \url{https://www.paws-r-sdk.com/docs/chatbot_create_custom_action/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspaces_operations.R
\name{workspaces_create_workspace_bundle}
\alias{workspaces_create_workspace_bundle}
\title{Creates the specified WorkSpace bundle}
\usage{
workspaces_create_workspace_bundle(
  BundleName,
  BundleDescription,
  ImageId,
  ComputeType,
  UserStorage,
  RootStorage = NULL,
  Tags = NULL
)
}
\arguments{
\item{BundleName}{[required] The name of the bundle.}

\item{BundleDescription}{[required] The description of the bundle.}

\item{ImageId}{[required] The identifier of the image that is used to create the bundle.}

\item{ComputeType}{[required] Describes the compute type of the bundle.}

\item{UserStorage}{[required] Describes the user volume for a WorkSpace bundle.}

\item{RootStorage}{Describes the root volume for a WorkSpace bundle.}

\item{Tags}{The tags associated with the bundle.

To add tags at the same time when you're creating the bundle, you must create an IAM policy that grants your IAM user permissions to use \code{workspaces:CreateTags}.}
}
\description{
Creates the specified WorkSpace bundle. For more information about creating WorkSpace bundles, see \href{https://docs.aws.amazon.com/workspaces/latest/adminguide/create-custom-bundle.html}{Create a Custom WorkSpaces Image and Bundle}.

See \url{https://www.paws-r-sdk.com/docs/workspaces_create_workspace_bundle/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspacesweb_operations.R
\name{workspacesweb_update_data_protection_settings}
\alias{workspacesweb_update_data_protection_settings}
\title{Updates data protection settings}
\usage{
workspacesweb_update_data_protection_settings(
  dataProtectionSettingsArn,
  inlineRedactionConfiguration = NULL,
  displayName = NULL,
  description = NULL,
  clientToken = NULL
)
}
\arguments{
\item{dataProtectionSettingsArn}{[required] The ARN of the data protection settings.}

\item{inlineRedactionConfiguration}{The inline redaction configuration of the data protection settings that will be applied to all sessions.}

\item{displayName}{The display name of the data protection settings.}

\item{description}{The description of the data protection settings.}

\item{clientToken}{A unique, case-sensitive identifier that you provide to ensure the idempotency of the request. Idempotency ensures that an API request completes only once. With an idempotent request, if the original request completes successfully, subsequent retries with the same client token return the result from the original successful request.

If you do not specify a client token, one is automatically generated by the Amazon Web Services SDK.}
}
\description{
Updates data protection settings.

See \url{https://www.paws-r-sdk.com/docs/workspacesweb_update_data_protection_settings/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_delete_email_monitoring_configuration}
\alias{workmail_delete_email_monitoring_configuration}
\title{Deletes the email monitoring configuration for a specified organization}
\usage{
workmail_delete_email_monitoring_configuration(OrganizationId)
}
\arguments{
\item{OrganizationId}{[required] The ID of the organization from which the email monitoring configuration is deleted.}
}
\description{
Deletes the email monitoring configuration for a specified organization.

See \url{https://www.paws-r-sdk.com/docs/workmail_delete_email_monitoring_configuration/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspaces_operations.R
\name{workspaces_delete_connect_client_add_in}
\alias{workspaces_delete_connect_client_add_in}
\title{Deletes a client-add-in for Amazon Connect that is configured within a
directory}
\usage{
workspaces_delete_connect_client_add_in(AddInId, ResourceId)
}
\arguments{
\item{AddInId}{[required] The identifier of the client add-in to delete.}

\item{ResourceId}{[required] The directory identifier for which the client add-in is configured.}
}
\description{
Deletes a client-add-in for Amazon Connect that is configured within a directory.

See \url{https://www.paws-r-sdk.com/docs/workspaces_delete_connect_client_add_in/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_create_impersonation_role}
\alias{workmail_create_impersonation_role}
\title{Creates an impersonation role for the given WorkMail organization}
\usage{
workmail_create_impersonation_role(
  ClientToken = NULL,
  OrganizationId,
  Name,
  Type,
  Description = NULL,
  Rules
)
}
\arguments{
\item{ClientToken}{The idempotency token for the client request.}

\item{OrganizationId}{[required] The WorkMail organization to create the new impersonation role within.}

\item{Name}{[required] The name of the new impersonation role.}

\item{Type}{[required] The impersonation role's type. The available impersonation role types are \code{READ_ONLY} or \code{FULL_ACCESS}.}

\item{Description}{The description of the new impersonation role.}

\item{Rules}{[required] The list of rules for the impersonation role.}
}
\description{
Creates an impersonation role for the given WorkMail organization.

See \url{https://www.paws-r-sdk.com/docs/workmail_create_impersonation_role/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspaces_operations.R
\name{workspaces_import_custom_workspace_image}
\alias{workspaces_import_custom_workspace_image}
\title{Imports the specified Windows 10 or 11 Bring Your Own License (BYOL)
image into Amazon WorkSpaces using EC2 Image Builder}
\usage{
workspaces_import_custom_workspace_image(
  ImageName,
  ImageDescription,
  ComputeType,
  Protocol,
  ImageSource,
  InfrastructureConfigurationArn,
  Platform,
  OsVersion,
  Tags = NULL
)
}
\arguments{
\item{ImageName}{[required] The name of the WorkSpace image.}

\item{ImageDescription}{[required] The description of the WorkSpace image.}

\item{ComputeType}{[required] The supported compute type for the WorkSpace image.}

\item{Protocol}{[required] The supported protocol for the WorkSpace image. Windows 11 does not support PCOIP protocol.}

\item{ImageSource}{[required] The options for image import source.}

\item{InfrastructureConfigurationArn}{[required] The infrastructure configuration ARN that specifies how the WorkSpace image is built.}

\item{Platform}{[required] The platform for the WorkSpace image source.}

\item{OsVersion}{[required] The OS version for the WorkSpace image source.}

\item{Tags}{The resource tags. Each WorkSpaces resource can have a maximum of 50 tags.}
}
\description{
Imports the specified Windows 10 or 11 Bring Your Own License (BYOL) image into Amazon WorkSpaces using EC2 Image Builder. The image must be an already licensed image that is in your Amazon Web Services account, and you must own the image. For more information about creating BYOL images, see \href{https://docs.aws.amazon.com/workspaces/latest/adminguide/byol-windows-images.html}{Bring Your Own Windows Desktop Licenses}.

See \url{https://www.paws-r-sdk.com/docs/workspaces_import_custom_workspace_image/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspaces_operations.R
\name{workspaces_delete_workspace_image}
\alias{workspaces_delete_workspace_image}
\title{Deletes the specified image from your account}
\usage{
workspaces_delete_workspace_image(ImageId)
}
\arguments{
\item{ImageId}{[required] The identifier of the image.}
}
\description{
Deletes the specified image from your account. To delete an image, you must first delete any bundles that are associated with the image and unshare the image if it is shared with other accounts.

See \url{https://www.paws-r-sdk.com/docs/workspaces_delete_workspace_image/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ivschat_operations.R
\name{ivschat_create_room}
\alias{ivschat_create_room}
\title{Creates a room that allows clients to connect and pass messages}
\usage{
ivschat_create_room(
  name = NULL,
  maximumMessageRatePerSecond = NULL,
  maximumMessageLength = NULL,
  messageReviewHandler = NULL,
  tags = NULL,
  loggingConfigurationIdentifiers = NULL
)
}
\arguments{
\item{name}{Room name. The value does not need to be unique.}

\item{maximumMessageRatePerSecond}{Maximum number of messages per second that can be sent to the room (by all clients). Default: 10.}

\item{maximumMessageLength}{Maximum number of characters in a single message. Messages are expected to be UTF-8 encoded and this limit applies specifically to rune/code-point count, not number of bytes. Default: 500.}

\item{messageReviewHandler}{Configuration information for optional review of messages.}

\item{tags}{Tags to attach to the resource. Array of maps, each of the form \code{string:string (key:value)}. See \href{https://docs.aws.amazon.com/tag-editor/latest/userguide/best-practices-and-strats.html}{Best practices and strategies} in \emph{Tagging Amazon Web Services Resources and Tag Editor} for details, including restrictions that apply to tags and "Tag naming limits and requirements"; Amazon IVS Chat has no constraints beyond what is documented there.}

\item{loggingConfigurationIdentifiers}{Array of logging-configuration identifiers attached to the room.}
}
\description{
Creates a room that allows clients to connect and pass messages.

See \url{https://www.paws-r-sdk.com/docs/ivschat_create_room/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspacesweb_service.R
\name{workspacesweb}
\alias{workspacesweb}
\title{Amazon WorkSpaces Web}
\usage{
workspacesweb(
  config = list(),
  credentials = list(),
  endpoint = NULL,
  region = NULL
)
}
\arguments{
\item{config}{Optional configuration of credentials, endpoint, and/or region.
\itemize{
\item{\strong{credentials}: \itemize{
\item{\strong{creds}: \itemize{
\item{\strong{access_key_id}: AWS access key ID}
\item{\strong{secret_access_key}: AWS secret access key}
\item{\strong{session_token}: AWS temporary session token}
}}
\item{\strong{profile}: The name of a profile to use. If not given, then the default profile is used.}
\item{\strong{anonymous}: Set anonymous credentials.}
}}
\item{\strong{endpoint}: The complete URL to use for the constructed client.}
\item{\strong{region}: The AWS Region used in instantiating the client.}
\item{\strong{close_connection}: Immediately close all HTTP connections.}
\item{\strong{timeout}: The time in seconds till a timeout exception is thrown when attempting to make a connection. The default is 60 seconds.}
\item{\strong{s3_force_path_style}: Set this to \code{true} to force the request to use path-style addressing, i.e. \verb{http://s3.amazonaws.com/BUCKET/KEY}.}
\item{\strong{sts_regional_endpoint}: Set sts regional endpoint resolver to regional or legacy \url{https://docs.aws.amazon.com/sdkref/latest/guide/feature-sts-regionalized-endpoints.html}}
}}

\item{credentials}{Optional credentials shorthand for the config parameter
\itemize{
\item{\strong{creds}: \itemize{
\item{\strong{access_key_id}: AWS access key ID}
\item{\strong{secret_access_key}: AWS secret access key}
\item{\strong{session_token}: AWS temporary session token}
}}
\item{\strong{profile}: The name of a profile to use. If not given, then the default profile is used.}
\item{\strong{anonymous}: Set anonymous credentials.}
}}

\item{endpoint}{Optional shorthand for complete URL to use for the constructed client.}

\item{region}{Optional shorthand for AWS Region used in instantiating the client.}
}
\value{
A client for the service. You can call the service's operations using
syntax like \code{svc$operation(...)}, where \code{svc} is the name you've assigned
to the client. The available operations are listed in the
Operations section.
}
\description{
Amazon WorkSpaces Secure Browser is a low cost, fully managed WorkSpace built specifically to facilitate secure, web-based workloads. WorkSpaces Secure Browser makes it easy for customers to safely provide their employees with access to internal websites and SaaS web applications without the administrative burden of appliances or specialized client software. WorkSpaces Secure Browser provides simple policy tools tailored for user interactions, while offloading common tasks like capacity management, scaling, and maintaining browser images.
}
\section{Service syntax}{


\if{html}{\out{<div class="sourceCode">}}\preformatted{svc <- workspacesweb(
  config = list(
    credentials = list(
      creds = list(
        access_key_id = "string",
        secret_access_key = "string",
        session_token = "string"
      ),
      profile = "string",
      anonymous = "logical"
    ),
    endpoint = "string",
    region = "string",
    close_connection = "logical",
    timeout = "numeric",
    s3_force_path_style = "logical",
    sts_regional_endpoint = "string"
  ),
  credentials = list(
    creds = list(
      access_key_id = "string",
      secret_access_key = "string",
      session_token = "string"
    ),
    profile = "string",
    anonymous = "logical"
  ),
  endpoint = "string",
  region = "string"
)
}\if{html}{\out{</div>}}
}

\section{Operations}{

\tabular{ll}{
\link[=workspacesweb_associate_browser_settings]{associate_browser_settings} \tab Associates a browser settings resource with a web portal\cr
\link[=workspacesweb_associate_data_protection_settings]{associate_data_protection_settings} \tab Associates a data protection settings resource with a web portal\cr
\link[=workspacesweb_associate_ip_access_settings]{associate_ip_access_settings} \tab Associates an IP access settings resource with a web portal\cr
\link[=workspacesweb_associate_network_settings]{associate_network_settings} \tab Associates a network settings resource with a web portal\cr
\link[=workspacesweb_associate_session_logger]{associate_session_logger} \tab Associates a session logger with a portal\cr
\link[=workspacesweb_associate_trust_store]{associate_trust_store} \tab Associates a trust store with a web portal\cr
\link[=workspacesweb_associate_user_access_logging_settings]{associate_user_access_logging_settings} \tab Associates a user access logging settings resource with a web portal\cr
\link[=workspacesweb_associate_user_settings]{associate_user_settings} \tab Associates a user settings resource with a web portal\cr
\link[=workspacesweb_create_browser_settings]{create_browser_settings} \tab Creates a browser settings resource that can be associated with a web portal\cr
\link[=workspacesweb_create_data_protection_settings]{create_data_protection_settings} \tab Creates a data protection settings resource that can be associated with a web portal\cr
\link[=workspacesweb_create_identity_provider]{create_identity_provider} \tab Creates an identity provider resource that is then associated with a web portal\cr
\link[=workspacesweb_create_ip_access_settings]{create_ip_access_settings} \tab Creates an IP access settings resource that can be associated with a web portal\cr
\link[=workspacesweb_create_network_settings]{create_network_settings} \tab Creates a network settings resource that can be associated with a web portal\cr
\link[=workspacesweb_create_portal]{create_portal} \tab Creates a web portal\cr
\link[=workspacesweb_create_session_logger]{create_session_logger} \tab Creates a session logger\cr
\link[=workspacesweb_create_trust_store]{create_trust_store} \tab Creates a trust store that can be associated with a web portal\cr
\link[=workspacesweb_create_user_access_logging_settings]{create_user_access_logging_settings} \tab Creates a user access logging settings resource that can be associated with a web portal\cr
\link[=workspacesweb_create_user_settings]{create_user_settings} \tab Creates a user settings resource that can be associated with a web portal\cr
\link[=workspacesweb_delete_browser_settings]{delete_browser_settings} \tab Deletes browser settings\cr
\link[=workspacesweb_delete_data_protection_settings]{delete_data_protection_settings} \tab Deletes data protection settings\cr
\link[=workspacesweb_delete_identity_provider]{delete_identity_provider} \tab Deletes the identity provider\cr
\link[=workspacesweb_delete_ip_access_settings]{delete_ip_access_settings} \tab Deletes IP access settings\cr
\link[=workspacesweb_delete_network_settings]{delete_network_settings} \tab Deletes network settings\cr
\link[=workspacesweb_delete_portal]{delete_portal} \tab Deletes a web portal\cr
\link[=workspacesweb_delete_session_logger]{delete_session_logger} \tab Deletes a session logger resource\cr
\link[=workspacesweb_delete_trust_store]{delete_trust_store} \tab Deletes the trust store\cr
\link[=workspacesweb_delete_user_access_logging_settings]{delete_user_access_logging_settings} \tab Deletes user access logging settings\cr
\link[=workspacesweb_delete_user_settings]{delete_user_settings} \tab Deletes user settings\cr
\link[=workspacesweb_disassociate_browser_settings]{disassociate_browser_settings} \tab Disassociates browser settings from a web portal\cr
\link[=workspacesweb_disassociate_data_protection_settings]{disassociate_data_protection_settings} \tab Disassociates data protection settings from a web portal\cr
\link[=workspacesweb_disassociate_ip_access_settings]{disassociate_ip_access_settings} \tab Disassociates IP access settings from a web portal\cr
\link[=workspacesweb_disassociate_network_settings]{disassociate_network_settings} \tab Disassociates network settings from a web portal\cr
\link[=workspacesweb_disassociate_session_logger]{disassociate_session_logger} \tab Disassociates a session logger from a portal\cr
\link[=workspacesweb_disassociate_trust_store]{disassociate_trust_store} \tab Disassociates a trust store from a web portal\cr
\link[=workspacesweb_disassociate_user_access_logging_settings]{disassociate_user_access_logging_settings} \tab Disassociates user access logging settings from a web portal\cr
\link[=workspacesweb_disassociate_user_settings]{disassociate_user_settings} \tab Disassociates user settings from a web portal\cr
\link[=workspacesweb_expire_session]{expire_session} \tab Expires an active secure browser session\cr
\link[=workspacesweb_get_browser_settings]{get_browser_settings} \tab Gets browser settings\cr
\link[=workspacesweb_get_data_protection_settings]{get_data_protection_settings} \tab Gets the data protection settings\cr
\link[=workspacesweb_get_identity_provider]{get_identity_provider} \tab Gets the identity provider\cr
\link[=workspacesweb_get_ip_access_settings]{get_ip_access_settings} \tab Gets the IP access settings\cr
\link[=workspacesweb_get_network_settings]{get_network_settings} \tab Gets the network settings\cr
\link[=workspacesweb_get_portal]{get_portal} \tab Gets the web portal\cr
\link[=workspacesweb_get_portal_service_provider_metadata]{get_portal_service_provider_metadata} \tab Gets the service provider metadata\cr
\link[=workspacesweb_get_session]{get_session} \tab Gets information for a secure browser session\cr
\link[=workspacesweb_get_session_logger]{get_session_logger} \tab Gets details about a specific session logger resource\cr
\link[=workspacesweb_get_trust_store]{get_trust_store} \tab Gets the trust store\cr
\link[=workspacesweb_get_trust_store_certificate]{get_trust_store_certificate} \tab Gets the trust store certificate\cr
\link[=workspacesweb_get_user_access_logging_settings]{get_user_access_logging_settings} \tab Gets user access logging settings\cr
\link[=workspacesweb_get_user_settings]{get_user_settings} \tab Gets user settings\cr
\link[=workspacesweb_list_browser_settings]{list_browser_settings} \tab Retrieves a list of browser settings\cr
\link[=workspacesweb_list_data_protection_settings]{list_data_protection_settings} \tab Retrieves a list of data protection settings\cr
\link[=workspacesweb_list_identity_providers]{list_identity_providers} \tab Retrieves a list of identity providers for a specific web portal\cr
\link[=workspacesweb_list_ip_access_settings]{list_ip_access_settings} \tab Retrieves a list of IP access settings\cr
\link[=workspacesweb_list_network_settings]{list_network_settings} \tab Retrieves a list of network settings\cr
\link[=workspacesweb_list_portals]{list_portals} \tab Retrieves a list or web portals\cr
\link[=workspacesweb_list_session_loggers]{list_session_loggers} \tab Lists all available session logger resources\cr
\link[=workspacesweb_list_sessions]{list_sessions} \tab Lists information for multiple secure browser sessions from a specific portal\cr
\link[=workspacesweb_list_tags_for_resource]{list_tags_for_resource} \tab Retrieves a list of tags for a resource\cr
\link[=workspacesweb_list_trust_store_certificates]{list_trust_store_certificates} \tab Retrieves a list of trust store certificates\cr
\link[=workspacesweb_list_trust_stores]{list_trust_stores} \tab Retrieves a list of trust stores\cr
\link[=workspacesweb_list_user_access_logging_settings]{list_user_access_logging_settings} \tab Retrieves a list of user access logging settings\cr
\link[=workspacesweb_list_user_settings]{list_user_settings} \tab Retrieves a list of user settings\cr
\link[=workspacesweb_tag_resource]{tag_resource} \tab Adds or overwrites one or more tags for the specified resource\cr
\link[=workspacesweb_untag_resource]{untag_resource} \tab Removes one or more tags from the specified resource\cr
\link[=workspacesweb_update_browser_settings]{update_browser_settings} \tab Updates browser settings\cr
\link[=workspacesweb_update_data_protection_settings]{update_data_protection_settings} \tab Updates data protection settings\cr
\link[=workspacesweb_update_identity_provider]{update_identity_provider} \tab Updates the identity provider\cr
\link[=workspacesweb_update_ip_access_settings]{update_ip_access_settings} \tab Updates IP access settings\cr
\link[=workspacesweb_update_network_settings]{update_network_settings} \tab Updates network settings\cr
\link[=workspacesweb_update_portal]{update_portal} \tab Updates a web portal\cr
\link[=workspacesweb_update_session_logger]{update_session_logger} \tab Updates the details of a session logger\cr
\link[=workspacesweb_update_trust_store]{update_trust_store} \tab Updates the trust store\cr
\link[=workspacesweb_update_user_access_logging_settings]{update_user_access_logging_settings} \tab Updates the user access logging settings\cr
\link[=workspacesweb_update_user_settings]{update_user_settings} \tab Updates the user settings
}
}

\examples{
\dontrun{
svc <- workspacesweb()
svc$associate_browser_settings(
  Foo = 123
)
}

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_list_groups}
\alias{workmail_list_groups}
\title{Returns summaries of the organization's groups}
\usage{
workmail_list_groups(
  OrganizationId,
  NextToken = NULL,
  MaxResults = NULL,
  Filters = NULL
)
}
\arguments{
\item{OrganizationId}{[required] The identifier for the organization under which the groups exist.}

\item{NextToken}{The token to use to retrieve the next page of results. The first call does not contain any tokens.}

\item{MaxResults}{The maximum number of results to return in a single call.}

\item{Filters}{Limit the search results based on the filter criteria. Only one filter per request is supported.}
}
\description{
Returns summaries of the organization's groups.

See \url{https://www.paws-r-sdk.com/docs/workmail_list_groups/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workdocs_operations.R
\name{workdocs_create_comment}
\alias{workdocs_create_comment}
\title{Adds a new comment to the specified document version}
\usage{
workdocs_create_comment(
  AuthenticationToken = NULL,
  DocumentId,
  VersionId,
  ParentId = NULL,
  ThreadId = NULL,
  Text,
  Visibility = NULL,
  NotifyCollaborators = NULL
)
}
\arguments{
\item{AuthenticationToken}{Amazon WorkDocs authentication token. Not required when using Amazon Web Services administrator credentials to access the API.}

\item{DocumentId}{[required] The ID of the document.}

\item{VersionId}{[required] The ID of the document version.}

\item{ParentId}{The ID of the parent comment.}

\item{ThreadId}{The ID of the root comment in the thread.}

\item{Text}{[required] The text of the comment.}

\item{Visibility}{The visibility of the comment. Options are either PRIVATE, where the comment is visible only to the comment author and document owner and co-owners, or PUBLIC, where the comment is visible to document owners, co-owners, and contributors.}

\item{NotifyCollaborators}{Set this parameter to TRUE to send an email out to the document collaborators after the comment is created.}
}
\description{
Adds a new comment to the specified document version.

See \url{https://www.paws-r-sdk.com/docs/workdocs_create_comment/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/appstream_operations.R
\name{appstream_create_imported_image}
\alias{appstream_create_imported_image}
\title{Creates a custom WorkSpaces Applications image by importing an EC2 AMI}
\usage{
appstream_create_imported_image(
  Name,
  SourceAmiId,
  IamRoleArn,
  Description = NULL,
  DisplayName = NULL,
  Tags = NULL,
  RuntimeValidationConfig = NULL,
  AgentSoftwareVersion = NULL,
  AppCatalogConfig = NULL,
  DryRun = NULL
)
}
\arguments{
\item{Name}{[required] A unique name for the imported image. The name must be between 1 and 100 characters and can contain letters, numbers, underscores, periods, and hyphens.}

\item{SourceAmiId}{[required] The ID of the EC2 AMI to import. The AMI must meet specific requirements including Windows Server 2022 Full Base, UEFI boot mode, TPM 2.0 support, and proper drivers.}

\item{IamRoleArn}{[required] The ARN of the IAM role that allows WorkSpaces Applications to access your AMI. The role must have permissions to modify image attributes and describe images, with a trust relationship allowing appstream.amazonaws.com to assume the role.}

\item{Description}{An optional description for the imported image. The description must match approved regex patterns and can be up to 256 characters.}

\item{DisplayName}{An optional display name for the imported image. The display name must match approved regex patterns and can be up to 100 characters.}

\item{Tags}{The tags to apply to the imported image. Tags help you organize and manage your WorkSpaces Applications resources.}

\item{RuntimeValidationConfig}{Configuration for runtime validation of the imported image. When specified, WorkSpaces Applications provisions an instance to test streaming functionality, which helps ensure the image is suitable for use.}

\item{AgentSoftwareVersion}{The version of the WorkSpaces Applications agent to use for the imported image. Choose CURRENT_LATEST to use the agent version available at the time of import, or ALWAYS_LATEST to automatically update to the latest agent version when new versions are released.}

\item{AppCatalogConfig}{Configuration for the application catalog of the imported image. This allows you to specify applications available for streaming, including their paths, icons, and launch parameters. This field contains sensitive data.}

\item{DryRun}{When set to true, performs validation checks without actually creating the imported image. Use this to verify your configuration before executing the actual import operation.}
}
\description{
Creates a custom WorkSpaces Applications image by importing an EC2 AMI. This allows you to use your own customized AMI to create WorkSpaces Applications images that support additional instance types beyond the standard stream.* instances.

See \url{https://www.paws-r-sdk.com/docs/appstream_create_imported_image/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_get_mail_domain}
\alias{workmail_get_mail_domain}
\title{Gets details for a mail domain, including domain records required to
configure your domain with recommended security}
\usage{
workmail_get_mail_domain(OrganizationId, DomainName)
}
\arguments{
\item{OrganizationId}{[required] The WorkMail organization for which the domain is retrieved.}

\item{DomainName}{[required] The domain from which you want to retrieve details.}
}
\description{
Gets details for a mail domain, including domain records required to configure your domain with recommended security.

See \url{https://www.paws-r-sdk.com/docs/workmail_get_mail_domain/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_delete_identity_center_application}
\alias{workmail_delete_identity_center_application}
\title{Deletes the IAM Identity Center application from WorkMail}
\usage{
workmail_delete_identity_center_application(ApplicationArn)
}
\arguments{
\item{ApplicationArn}{[required] The Amazon Resource Name (ARN) of the application.}
}
\description{
Deletes the IAM Identity Center application from WorkMail. This action does not affect the authentication settings for any WorkMail organizations.

See \url{https://www.paws-r-sdk.com/docs/workmail_delete_identity_center_application/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_list_groups_for_entity}
\alias{workmail_list_groups_for_entity}
\title{Returns all the groups to which an entity belongs}
\usage{
workmail_list_groups_for_entity(
  OrganizationId,
  EntityId,
  Filters = NULL,
  NextToken = NULL,
  MaxResults = NULL
)
}
\arguments{
\item{OrganizationId}{[required] The identifier for the organization under which the entity exists.}

\item{EntityId}{[required] The identifier for the entity.

The entity ID can accept \emph{UserId or GroupID}, \emph{Username or Groupname}, or \emph{email}.
\itemize{
\item Entity ID: 12345678-1234-1234-1234-123456789012 or S-1-1-12-1234567890-123456789-123456789-1234
\item Email address: entity@domain.tld
\item Entity name: entity
}}

\item{Filters}{Limit the search results based on the filter criteria.}

\item{NextToken}{The token to use to retrieve the next page of results. The first call does not contain any tokens.}

\item{MaxResults}{The maximum number of results to return in a single call.}
}
\description{
Returns all the groups to which an entity belongs.

See \url{https://www.paws-r-sdk.com/docs/workmail_list_groups_for_entity/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/appstream_operations.R
\name{appstream_associate_application_fleet}
\alias{appstream_associate_application_fleet}
\title{Associates the specified application with the specified fleet}
\usage{
appstream_associate_application_fleet(FleetName, ApplicationArn)
}
\arguments{
\item{FleetName}{[required] The name of the fleet.}

\item{ApplicationArn}{[required] The ARN of the application.}
}
\description{
Associates the specified application with the specified fleet. This is only supported for Elastic fleets.

See \url{https://www.paws-r-sdk.com/docs/appstream_associate_application_fleet/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/appstream_operations.R
\name{appstream_describe_software_associations}
\alias{appstream_describe_software_associations}
\title{Retrieves license included application associations for a specified
resource}
\usage{
appstream_describe_software_associations(
  AssociatedResource,
  MaxResults = NULL,
  NextToken = NULL
)
}
\arguments{
\item{AssociatedResource}{[required] The ARN of the resource to describe software associations. Possible resources are Image and ImageBuilder.}

\item{MaxResults}{The maximum number of results to return.}

\item{NextToken}{The pagination token to use to retrieve the next page of results for this operation.}
}
\description{
Retrieves license included application associations for a specified resource.

See \url{https://www.paws-r-sdk.com/docs/appstream_describe_software_associations/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspaces_operations.R
\name{workspaces_disassociate_connection_alias}
\alias{workspaces_disassociate_connection_alias}
\title{Disassociates a connection alias from a directory}
\usage{
workspaces_disassociate_connection_alias(AliasId)
}
\arguments{
\item{AliasId}{[required] The identifier of the connection alias to disassociate.}
}
\description{
Disassociates a connection alias from a directory. Disassociating a connection alias disables cross-Region redirection between two directories in different Regions. For more information, see \href{https://docs.aws.amazon.com/workspaces/latest/adminguide/cross-region-redirection.html}{Cross-Region Redirection for Amazon WorkSpaces}.

See \url{https://www.paws-r-sdk.com/docs/workspaces_disassociate_connection_alias/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/appstream_operations.R
\name{appstream_update_application}
\alias{appstream_update_application}
\title{Updates the specified application}
\usage{
appstream_update_application(
  Name,
  DisplayName = NULL,
  Description = NULL,
  IconS3Location = NULL,
  LaunchPath = NULL,
  WorkingDirectory = NULL,
  LaunchParameters = NULL,
  AppBlockArn = NULL,
  AttributesToDelete = NULL
)
}
\arguments{
\item{Name}{[required] The name of the application. This name is visible to users when display name is not specified.}

\item{DisplayName}{The display name of the application. This name is visible to users in the application catalog.}

\item{Description}{The description of the application.}

\item{IconS3Location}{The icon S3 location of the application.}

\item{LaunchPath}{The launch path of the application.}

\item{WorkingDirectory}{The working directory of the application.}

\item{LaunchParameters}{The launch parameters of the application.}

\item{AppBlockArn}{The ARN of the app block.}

\item{AttributesToDelete}{The attributes to delete for an application.}
}
\description{
Updates the specified application.

See \url{https://www.paws-r-sdk.com/docs/appstream_update_application/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_list_organizations}
\alias{workmail_list_organizations}
\title{Returns summaries of the customer's organizations}
\usage{
workmail_list_organizations(NextToken = NULL, MaxResults = NULL)
}
\arguments{
\item{NextToken}{The token to use to retrieve the next page of results. The first call does not contain any tokens.}

\item{MaxResults}{The maximum number of results to return in a single call.}
}
\description{
Returns summaries of the customer's organizations.

See \url{https://www.paws-r-sdk.com/docs/workmail_list_organizations/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspacesweb_operations.R
\name{workspacesweb_create_portal}
\alias{workspacesweb_create_portal}
\title{Creates a web portal}
\usage{
workspacesweb_create_portal(
  displayName = NULL,
  tags = NULL,
  customerManagedKey = NULL,
  additionalEncryptionContext = NULL,
  clientToken = NULL,
  authenticationType = NULL,
  instanceType = NULL,
  maxConcurrentSessions = NULL,
  portalCustomDomain = NULL
)
}
\arguments{
\item{displayName}{The name of the web portal. This is not visible to users who log into the web portal.}

\item{tags}{The tags to add to the web portal. A tag is a key-value pair.}

\item{customerManagedKey}{The customer managed key of the web portal.}

\item{additionalEncryptionContext}{The additional encryption context of the portal.}

\item{clientToken}{A unique, case-sensitive identifier that you provide to ensure the idempotency of the request. Idempotency ensures that an API request completes only once. With an idempotent request, if the original request completes successfully, subsequent retries with the same client token returns the result from the original successful request.

If you do not specify a client token, one is automatically generated by the Amazon Web Services SDK.}

\item{authenticationType}{The type of authentication integration points used when signing into the web portal. Defaults to \code{Standard}.

\code{Standard} web portals are authenticated directly through your identity provider. You need to call \code{\link[=workspacesweb_create_identity_provider]{create_identity_provider}} to integrate your identity provider with your web portal. User and group access to your web portal is controlled through your identity provider.

\verb{IAM Identity Center} web portals are authenticated through IAM Identity Center. Identity sources (including external identity provider integration), plus user and group access to your web portal, can be configured in the IAM Identity Center.}

\item{instanceType}{The type and resources of the underlying instance.}

\item{maxConcurrentSessions}{The maximum number of concurrent sessions for the portal.}

\item{portalCustomDomain}{The custom domain of the web portal that users access in order to start streaming sessions.}
}
\description{
Creates a web portal.

See \url{https://www.paws-r-sdk.com/docs/workspacesweb_create_portal/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspaces_operations.R
\name{workspaces_describe_application_associations}
\alias{workspaces_describe_application_associations}
\title{Describes the associations between the application and the specified
associated resources}
\usage{
workspaces_describe_application_associations(
  MaxResults = NULL,
  NextToken = NULL,
  ApplicationId,
  AssociatedResourceTypes
)
}
\arguments{
\item{MaxResults}{The maximum number of associations to return.}

\item{NextToken}{If you received a \code{NextToken} from a previous call that was paginated, provide this token to receive the next set of results.}

\item{ApplicationId}{[required] The identifier of the specified application.}

\item{AssociatedResourceTypes}{[required] The resource type of the associated resources.}
}
\description{
Describes the associations between the application and the specified associated resources.

See \url{https://www.paws-r-sdk.com/docs/workspaces_describe_application_associations/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspaces_operations.R
\name{workspaces_reject_account_link_invitation}
\alias{workspaces_reject_account_link_invitation}
\title{Rejects the account link invitation}
\usage{
workspaces_reject_account_link_invitation(LinkId, ClientToken = NULL)
}
\arguments{
\item{LinkId}{[required] The identifier of the account link}

\item{ClientToken}{The client token of the account link invitation to reject.}
}
\description{
Rejects the account link invitation.

See \url{https://www.paws-r-sdk.com/docs/workspaces_reject_account_link_invitation/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspacesweb_operations.R
\name{workspacesweb_get_trust_store_certificate}
\alias{workspacesweb_get_trust_store_certificate}
\title{Gets the trust store certificate}
\usage{
workspacesweb_get_trust_store_certificate(trustStoreArn, thumbprint)
}
\arguments{
\item{trustStoreArn}{[required] The ARN of the trust store certificate.}

\item{thumbprint}{[required] The thumbprint of the trust store certificate.}
}
\description{
Gets the trust store certificate.

See \url{https://www.paws-r-sdk.com/docs/workspacesweb_get_trust_store_certificate/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/appstream_operations.R
\name{appstream_describe_usage_report_subscriptions}
\alias{appstream_describe_usage_report_subscriptions}
\title{Retrieves a list that describes one or more usage report subscriptions}
\usage{
appstream_describe_usage_report_subscriptions(
  MaxResults = NULL,
  NextToken = NULL
)
}
\arguments{
\item{MaxResults}{The maximum size of each page of results.}

\item{NextToken}{The pagination token to use to retrieve the next page of results for this operation. If this value is null, it retrieves the first page.}
}
\description{
Retrieves a list that describes one or more usage report subscriptions.

See \url{https://www.paws-r-sdk.com/docs/appstream_describe_usage_report_subscriptions/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workdocs_operations.R
\name{workdocs_describe_users}
\alias{workdocs_describe_users}
\title{Describes the specified users}
\usage{
workdocs_describe_users(
  AuthenticationToken = NULL,
  OrganizationId = NULL,
  UserIds = NULL,
  Query = NULL,
  Include = NULL,
  Order = NULL,
  Sort = NULL,
  Marker = NULL,
  Limit = NULL,
  Fields = NULL
)
}
\arguments{
\item{AuthenticationToken}{Amazon WorkDocs authentication token. Not required when using Amazon Web Services administrator credentials to access the API.}

\item{OrganizationId}{The ID of the organization.}

\item{UserIds}{The IDs of the users.}

\item{Query}{A query to filter users by user name. Remember the following about the \code{Userids} and \code{Query} parameters:
\itemize{
\item If you don't use either parameter, the API returns a paginated list of all users on the site.
\item If you use both parameters, the API ignores the \code{Query} parameter.
\item The \code{Userid} parameter only returns user names that match a corresponding user ID.
\item The \code{Query} parameter runs a "prefix" search for users by the \code{GivenName}, \code{SurName}, or \code{UserName} fields included in a \code{\link[=workdocs_create_user]{create_user}} API call. For example, querying on \code{Ma} returns Márcia Oliveira, María García, and Mateo Jackson. If you use multiple characters, the API only returns data that matches all characters. For example, querying on \verb{Ma J} only returns Mateo Jackson.
}}

\item{Include}{The state of the users. Specify "ALL" to include inactive users.}

\item{Order}{The order for the results.}

\item{Sort}{The sorting criteria.}

\item{Marker}{The marker for the next set of results. (You received this marker from a previous call.)}

\item{Limit}{The maximum number of items to return.}

\item{Fields}{A comma-separated list of values. Specify "STORAGE_METADATA" to include the user storage quota and utilization information.}
}
\description{
Describes the specified users. You can describe all users or filter the results (for example, by status or organization).

See \url{https://www.paws-r-sdk.com/docs/workdocs_describe_users/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspacesweb_operations.R
\name{workspacesweb_create_browser_settings}
\alias{workspacesweb_create_browser_settings}
\title{Creates a browser settings resource that can be associated with a web
portal}
\usage{
workspacesweb_create_browser_settings(
  tags = NULL,
  customerManagedKey = NULL,
  additionalEncryptionContext = NULL,
  browserPolicy = NULL,
  clientToken = NULL,
  webContentFilteringPolicy = NULL
)
}
\arguments{
\item{tags}{The tags to add to the browser settings resource. A tag is a key-value pair.}

\item{customerManagedKey}{The custom managed key of the browser settings.}

\item{additionalEncryptionContext}{Additional encryption context of the browser settings.}

\item{browserPolicy}{A JSON string containing Chrome Enterprise policies that will be applied to all streaming sessions.}

\item{clientToken}{A unique, case-sensitive identifier that you provide to ensure the idempotency of the request. Idempotency ensures that an API request completes only once. With an idempotent request, if the original request completes successfully, subsequent retries with the same client token returns the result from the original successful request.

If you do not specify a client token, one is automatically generated by the Amazon Web Services SDK.}

\item{webContentFilteringPolicy}{The policy that specifies which URLs end users are allowed to access or which URLs or domain categories they are restricted from accessing for enhanced security.}
}
\description{
Creates a browser settings resource that can be associated with a web portal. Once associated with a web portal, browser settings control how the browser will behave once a user starts a streaming session for the web portal.

See \url{https://www.paws-r-sdk.com/docs/workspacesweb_create_browser_settings/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_list_availability_configurations}
\alias{workmail_list_availability_configurations}
\title{List all the AvailabilityConfiguration's for the given WorkMail
organization}
\usage{
workmail_list_availability_configurations(
  OrganizationId,
  MaxResults = NULL,
  NextToken = NULL
)
}
\arguments{
\item{OrganizationId}{[required] The WorkMail organization for which the \code{AvailabilityConfiguration}'s will be listed.}

\item{MaxResults}{The maximum number of results to return in a single call.}

\item{NextToken}{The token to use to retrieve the next page of results. The first call does not require a token.}
}
\description{
List all the \code{AvailabilityConfiguration}'s for the given WorkMail organization.

See \url{https://www.paws-r-sdk.com/docs/workmail_list_availability_configurations/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_create_alias}
\alias{workmail_create_alias}
\title{Adds an alias to the set of a given member (user or group) of WorkMail}
\usage{
workmail_create_alias(OrganizationId, EntityId, Alias)
}
\arguments{
\item{OrganizationId}{[required] The organization under which the member (user or group) exists.}

\item{EntityId}{[required] The member (user or group) to which this alias is added.}

\item{Alias}{[required] The alias to add to the member set.}
}
\description{
Adds an alias to the set of a given member (user or group) of WorkMail.

See \url{https://www.paws-r-sdk.com/docs/workmail_create_alias/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_get_access_control_effect}
\alias{workmail_get_access_control_effect}
\title{Gets the effects of an organization's access control rules as they apply
to a specified IPv4 address, access protocol action, and user ID or
impersonation role ID}
\usage{
workmail_get_access_control_effect(
  OrganizationId,
  IpAddress,
  Action,
  UserId = NULL,
  ImpersonationRoleId = NULL
)
}
\arguments{
\item{OrganizationId}{[required] The identifier for the organization.}

\item{IpAddress}{[required] The IPv4 address.}

\item{Action}{[required] The access protocol action. Valid values include \code{ActiveSync}, \code{AutoDiscover}, \code{EWS}, \code{IMAP}, \code{SMTP}, \code{WindowsOutlook}, and \code{WebMail}.}

\item{UserId}{The user ID.}

\item{ImpersonationRoleId}{The impersonation role ID.}
}
\description{
Gets the effects of an organization's access control rules as they apply to a specified IPv4 address, access protocol action, and user ID or impersonation role ID. You must provide either the user ID or impersonation role ID. Impersonation role ID can only be used with Action EWS.

See \url{https://www.paws-r-sdk.com/docs/workmail_get_access_control_effect/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspacesweb_operations.R
\name{workspacesweb_get_network_settings}
\alias{workspacesweb_get_network_settings}
\title{Gets the network settings}
\usage{
workspacesweb_get_network_settings(networkSettingsArn)
}
\arguments{
\item{networkSettingsArn}{[required] The ARN of the network settings.}
}
\description{
Gets the network settings.

See \url{https://www.paws-r-sdk.com/docs/workspacesweb_get_network_settings/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/appstream_service.R
\name{appstream}
\alias{appstream}
\title{Amazon AppStream}
\usage{
appstream(
  config = list(),
  credentials = list(),
  endpoint = NULL,
  region = NULL
)
}
\arguments{
\item{config}{Optional configuration of credentials, endpoint, and/or region.
\itemize{
\item{\strong{credentials}: \itemize{
\item{\strong{creds}: \itemize{
\item{\strong{access_key_id}: AWS access key ID}
\item{\strong{secret_access_key}: AWS secret access key}
\item{\strong{session_token}: AWS temporary session token}
}}
\item{\strong{profile}: The name of a profile to use. If not given, then the default profile is used.}
\item{\strong{anonymous}: Set anonymous credentials.}
}}
\item{\strong{endpoint}: The complete URL to use for the constructed client.}
\item{\strong{region}: The AWS Region used in instantiating the client.}
\item{\strong{close_connection}: Immediately close all HTTP connections.}
\item{\strong{timeout}: The time in seconds till a timeout exception is thrown when attempting to make a connection. The default is 60 seconds.}
\item{\strong{s3_force_path_style}: Set this to \code{true} to force the request to use path-style addressing, i.e. \verb{http://s3.amazonaws.com/BUCKET/KEY}.}
\item{\strong{sts_regional_endpoint}: Set sts regional endpoint resolver to regional or legacy \url{https://docs.aws.amazon.com/sdkref/latest/guide/feature-sts-regionalized-endpoints.html}}
}}

\item{credentials}{Optional credentials shorthand for the config parameter
\itemize{
\item{\strong{creds}: \itemize{
\item{\strong{access_key_id}: AWS access key ID}
\item{\strong{secret_access_key}: AWS secret access key}
\item{\strong{session_token}: AWS temporary session token}
}}
\item{\strong{profile}: The name of a profile to use. If not given, then the default profile is used.}
\item{\strong{anonymous}: Set anonymous credentials.}
}}

\item{endpoint}{Optional shorthand for complete URL to use for the constructed client.}

\item{region}{Optional shorthand for AWS Region used in instantiating the client.}
}
\value{
A client for the service. You can call the service's operations using
syntax like \code{svc$operation(...)}, where \code{svc} is the name you've assigned
to the client. The available operations are listed in the
Operations section.
}
\description{
Amazon WorkSpaces Applications

This is the \emph{Amazon WorkSpaces Applications API Reference}. This documentation provides descriptions and syntax for each of the actions and data types in WorkSpaces Applications. WorkSpaces Applications is a fully managed, secure application streaming service that lets you stream desktop applications to users without rewriting applications. WorkSpaces Applications manages the AWS resources that are required to host and run your applications, scales automatically, and provides access to your users on demand.

You can call the WorkSpaces Applications API operations by using an interface VPC endpoint (interface endpoint). For more information, see \href{https://docs.aws.amazon.com/appstream2/latest/developerguide/access-api-cli-through-interface-vpc-endpoint.html}{Access WorkSpaces Applications API Operations and CLI Commands Through an Interface VPC Endpoint} in the \emph{Amazon WorkSpaces Applications Administration Guide}.

To learn more about WorkSpaces Applications, see the following resources:
\itemize{
\item \href{https://aws.amazon.com/workspaces/applications/}{Amazon WorkSpaces Applications product page}
\item \href{https://docs.aws.amazon.com/appstream2/}{Amazon WorkSpaces Applications documentation}
}
}
\section{Service syntax}{


\if{html}{\out{<div class="sourceCode">}}\preformatted{svc <- appstream(
  config = list(
    credentials = list(
      creds = list(
        access_key_id = "string",
        secret_access_key = "string",
        session_token = "string"
      ),
      profile = "string",
      anonymous = "logical"
    ),
    endpoint = "string",
    region = "string",
    close_connection = "logical",
    timeout = "numeric",
    s3_force_path_style = "logical",
    sts_regional_endpoint = "string"
  ),
  credentials = list(
    creds = list(
      access_key_id = "string",
      secret_access_key = "string",
      session_token = "string"
    ),
    profile = "string",
    anonymous = "logical"
  ),
  endpoint = "string",
  region = "string"
)
}\if{html}{\out{</div>}}
}

\section{Operations}{

\tabular{ll}{
\link[=appstream_associate_app_block_builder_app_block]{associate_app_block_builder_app_block} \tab Associates the specified app block builder with the specified app block\cr
\link[=appstream_associate_application_fleet]{associate_application_fleet} \tab Associates the specified application with the specified fleet\cr
\link[=appstream_associate_application_to_entitlement]{associate_application_to_entitlement} \tab Associates an application to entitle\cr
\link[=appstream_associate_fleet]{associate_fleet} \tab Associates the specified fleet with the specified stack\cr
\link[=appstream_associate_software_to_image_builder]{associate_software_to_image_builder} \tab Associates license included application(s) with an existing image builder instance\cr
\link[=appstream_batch_associate_user_stack]{batch_associate_user_stack} \tab Associates the specified users with the specified stacks\cr
\link[=appstream_batch_disassociate_user_stack]{batch_disassociate_user_stack} \tab Disassociates the specified users from the specified stacks\cr
\link[=appstream_copy_image]{copy_image} \tab Copies the image within the same region or to a new region within the same AWS account\cr
\link[=appstream_create_app_block]{create_app_block} \tab Creates an app block\cr
\link[=appstream_create_app_block_builder]{create_app_block_builder} \tab Creates an app block builder\cr
\link[=appstream_create_app_block_builder_streaming_url]{create_app_block_builder_streaming_url} \tab Creates a URL to start a create app block builder streaming session\cr
\link[=appstream_create_application]{create_application} \tab Creates an application\cr
\link[=appstream_create_directory_config]{create_directory_config} \tab Creates a Directory Config object in WorkSpaces Applications\cr
\link[=appstream_create_entitlement]{create_entitlement} \tab Creates a new entitlement\cr
\link[=appstream_create_export_image_task]{create_export_image_task} \tab Creates a task to export a WorkSpaces Applications image to an EC2 AMI\cr
\link[=appstream_create_fleet]{create_fleet} \tab Creates a fleet\cr
\link[=appstream_create_image_builder]{create_image_builder} \tab Creates an image builder\cr
\link[=appstream_create_image_builder_streaming_url]{create_image_builder_streaming_url} \tab Creates a URL to start an image builder streaming session\cr
\link[=appstream_create_imported_image]{create_imported_image} \tab Creates a custom WorkSpaces Applications image by importing an EC2 AMI\cr
\link[=appstream_create_stack]{create_stack} \tab Creates a stack to start streaming applications to users\cr
\link[=appstream_create_streaming_url]{create_streaming_url} \tab Creates a temporary URL to start an WorkSpaces Applications streaming session for the specified user\cr
\link[=appstream_create_theme_for_stack]{create_theme_for_stack} \tab Creates custom branding that customizes the appearance of the streaming application catalog page\cr
\link[=appstream_create_updated_image]{create_updated_image} \tab Creates a new image with the latest Windows operating system updates, driver updates, and WorkSpaces Applications agent software\cr
\link[=appstream_create_usage_report_subscription]{create_usage_report_subscription} \tab Creates a usage report subscription\cr
\link[=appstream_create_user]{create_user} \tab Creates a new user in the user pool\cr
\link[=appstream_delete_app_block]{delete_app_block} \tab Deletes an app block\cr
\link[=appstream_delete_app_block_builder]{delete_app_block_builder} \tab Deletes an app block builder\cr
\link[=appstream_delete_application]{delete_application} \tab Deletes an application\cr
\link[=appstream_delete_directory_config]{delete_directory_config} \tab Deletes the specified Directory Config object from WorkSpaces Applications\cr
\link[=appstream_delete_entitlement]{delete_entitlement} \tab Deletes the specified entitlement\cr
\link[=appstream_delete_fleet]{delete_fleet} \tab Deletes the specified fleet\cr
\link[=appstream_delete_image]{delete_image} \tab Deletes the specified image\cr
\link[=appstream_delete_image_builder]{delete_image_builder} \tab Deletes the specified image builder and releases the capacity\cr
\link[=appstream_delete_image_permissions]{delete_image_permissions} \tab Deletes permissions for the specified private image\cr
\link[=appstream_delete_stack]{delete_stack} \tab Deletes the specified stack\cr
\link[=appstream_delete_theme_for_stack]{delete_theme_for_stack} \tab Deletes custom branding that customizes the appearance of the streaming application catalog page\cr
\link[=appstream_delete_usage_report_subscription]{delete_usage_report_subscription} \tab Disables usage report generation\cr
\link[=appstream_delete_user]{delete_user} \tab Deletes a user from the user pool\cr
\link[=appstream_describe_app_block_builder_app_block_associations]{describe_app_block_builder_app_block_associations} \tab Retrieves a list that describes one or more app block builder associations\cr
\link[=appstream_describe_app_block_builders]{describe_app_block_builders} \tab Retrieves a list that describes one or more app block builders\cr
\link[=appstream_describe_app_blocks]{describe_app_blocks} \tab Retrieves a list that describes one or more app blocks\cr
\link[=appstream_describe_application_fleet_associations]{describe_application_fleet_associations} \tab Retrieves a list that describes one or more application fleet associations\cr
\link[=appstream_describe_applications]{describe_applications} \tab Retrieves a list that describes one or more applications\cr
\link[=appstream_describe_app_license_usage]{describe_app_license_usage} \tab Retrieves license included application usage information\cr
\link[=appstream_describe_directory_configs]{describe_directory_configs} \tab Retrieves a list that describes one or more specified Directory Config objects for WorkSpaces Applications, if the names for these objects are provided\cr
\link[=appstream_describe_entitlements]{describe_entitlements} \tab Retrieves a list that describes one of more entitlements\cr
\link[=appstream_describe_fleets]{describe_fleets} \tab Retrieves a list that describes one or more specified fleets, if the fleet names are provided\cr
\link[=appstream_describe_image_builders]{describe_image_builders} \tab Retrieves a list that describes one or more specified image builders, if the image builder names are provided\cr
\link[=appstream_describe_image_permissions]{describe_image_permissions} \tab Retrieves a list that describes the permissions for shared AWS account IDs on a private image that you own\cr
\link[=appstream_describe_images]{describe_images} \tab Retrieves a list that describes one or more specified images, if the image names or image ARNs are provided\cr
\link[=appstream_describe_sessions]{describe_sessions} \tab Retrieves a list that describes the streaming sessions for a specified stack and fleet\cr
\link[=appstream_describe_software_associations]{describe_software_associations} \tab Retrieves license included application associations for a specified resource\cr
\link[=appstream_describe_stacks]{describe_stacks} \tab Retrieves a list that describes one or more specified stacks, if the stack names are provided\cr
\link[=appstream_describe_theme_for_stack]{describe_theme_for_stack} \tab Retrieves a list that describes the theme for a specified stack\cr
\link[=appstream_describe_usage_report_subscriptions]{describe_usage_report_subscriptions} \tab Retrieves a list that describes one or more usage report subscriptions\cr
\link[=appstream_describe_users]{describe_users} \tab Retrieves a list that describes one or more specified users in the user pool\cr
\link[=appstream_describe_user_stack_associations]{describe_user_stack_associations} \tab Retrieves a list that describes the UserStackAssociation objects\cr
\link[=appstream_disable_user]{disable_user} \tab Disables the specified user in the user pool\cr
\link[=appstream_disassociate_app_block_builder_app_block]{disassociate_app_block_builder_app_block} \tab Disassociates a specified app block builder from a specified app block\cr
\link[=appstream_disassociate_application_fleet]{disassociate_application_fleet} \tab Disassociates the specified application from the fleet\cr
\link[=appstream_disassociate_application_from_entitlement]{disassociate_application_from_entitlement} \tab Deletes the specified application from the specified entitlement\cr
\link[=appstream_disassociate_fleet]{disassociate_fleet} \tab Disassociates the specified fleet from the specified stack\cr
\link[=appstream_disassociate_software_from_image_builder]{disassociate_software_from_image_builder} \tab Removes license included application(s) association(s) from an image builder instance\cr
\link[=appstream_drain_session_instance]{drain_session_instance} \tab Drains the instance hosting the specified streaming session\cr
\link[=appstream_enable_user]{enable_user} \tab Enables a user in the user pool\cr
\link[=appstream_expire_session]{expire_session} \tab Immediately stops the specified streaming session\cr
\link[=appstream_get_export_image_task]{get_export_image_task} \tab Retrieves information about an export image task, including its current state, progress, and any error details\cr
\link[=appstream_list_associated_fleets]{list_associated_fleets} \tab Retrieves the name of the fleet that is associated with the specified stack\cr
\link[=appstream_list_associated_stacks]{list_associated_stacks} \tab Retrieves the name of the stack with which the specified fleet is associated\cr
\link[=appstream_list_entitled_applications]{list_entitled_applications} \tab Retrieves a list of entitled applications\cr
\link[=appstream_list_export_image_tasks]{list_export_image_tasks} \tab Lists export image tasks, with optional filtering and pagination\cr
\link[=appstream_list_tags_for_resource]{list_tags_for_resource} \tab Retrieves a list of all tags for the specified WorkSpaces Applications resource\cr
\link[=appstream_start_app_block_builder]{start_app_block_builder} \tab Starts an app block builder\cr
\link[=appstream_start_fleet]{start_fleet} \tab Starts the specified fleet\cr
\link[=appstream_start_image_builder]{start_image_builder} \tab Starts the specified image builder\cr
\link[=appstream_start_software_deployment_to_image_builder]{start_software_deployment_to_image_builder} \tab Initiates license included applications deployment to an image builder instance\cr
\link[=appstream_stop_app_block_builder]{stop_app_block_builder} \tab Stops an app block builder\cr
\link[=appstream_stop_fleet]{stop_fleet} \tab Stops the specified fleet\cr
\link[=appstream_stop_image_builder]{stop_image_builder} \tab Stops the specified image builder\cr
\link[=appstream_tag_resource]{tag_resource} \tab Adds or overwrites one or more tags for the specified WorkSpaces Applications resource\cr
\link[=appstream_untag_resource]{untag_resource} \tab Disassociates one or more specified tags from the specified WorkSpaces Applications resource\cr
\link[=appstream_update_app_block_builder]{update_app_block_builder} \tab Updates an app block builder\cr
\link[=appstream_update_application]{update_application} \tab Updates the specified application\cr
\link[=appstream_update_directory_config]{update_directory_config} \tab Updates the specified Directory Config object in WorkSpaces Applications\cr
\link[=appstream_update_entitlement]{update_entitlement} \tab Updates the specified entitlement\cr
\link[=appstream_update_fleet]{update_fleet} \tab Updates the specified fleet\cr
\link[=appstream_update_image_permissions]{update_image_permissions} \tab Adds or updates permissions for the specified private image\cr
\link[=appstream_update_stack]{update_stack} \tab Updates the specified fields for the specified stack\cr
\link[=appstream_update_theme_for_stack]{update_theme_for_stack} \tab Updates custom branding that customizes the appearance of the streaming application catalog page
}
}

\examples{
\dontrun{
svc <- appstream()
svc$associate_app_block_builder_app_block(
  Foo = 123
)
}

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_delete_retention_policy}
\alias{workmail_delete_retention_policy}
\title{Deletes the specified retention policy from the specified organization}
\usage{
workmail_delete_retention_policy(OrganizationId, Id)
}
\arguments{
\item{OrganizationId}{[required] The organization ID.}

\item{Id}{[required] The retention policy ID.}
}
\description{
Deletes the specified retention policy from the specified organization.

See \url{https://www.paws-r-sdk.com/docs/workmail_delete_retention_policy/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workdocs_operations.R
\name{workdocs_delete_custom_metadata}
\alias{workdocs_delete_custom_metadata}
\title{Deletes custom metadata from the specified resource}
\usage{
workdocs_delete_custom_metadata(
  AuthenticationToken = NULL,
  ResourceId,
  VersionId = NULL,
  Keys = NULL,
  DeleteAll = NULL
)
}
\arguments{
\item{AuthenticationToken}{Amazon WorkDocs authentication token. Not required when using Amazon Web Services administrator credentials to access the API.}

\item{ResourceId}{[required] The ID of the resource, either a document or folder.}

\item{VersionId}{The ID of the version, if the custom metadata is being deleted from a document version.}

\item{Keys}{List of properties to remove.}

\item{DeleteAll}{Flag to indicate removal of all custom metadata properties from the specified resource.}
}
\description{
Deletes custom metadata from the specified resource.

See \url{https://www.paws-r-sdk.com/docs/workdocs_delete_custom_metadata/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspaces_operations.R
\name{workspaces_disassociate_workspace_application}
\alias{workspaces_disassociate_workspace_application}
\title{Disassociates the specified application from a WorkSpace}
\usage{
workspaces_disassociate_workspace_application(WorkspaceId, ApplicationId)
}
\arguments{
\item{WorkspaceId}{[required] The identifier of the WorkSpace.}

\item{ApplicationId}{[required] The identifier of the application.}
}
\description{
Disassociates the specified application from a WorkSpace.

See \url{https://www.paws-r-sdk.com/docs/workspaces_disassociate_workspace_application/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspaces_operations.R
\name{workspaces_list_account_links}
\alias{workspaces_list_account_links}
\title{Lists all account links}
\usage{
workspaces_list_account_links(
  LinkStatusFilter = NULL,
  NextToken = NULL,
  MaxResults = NULL
)
}
\arguments{
\item{LinkStatusFilter}{Filters the account based on their link status.}

\item{NextToken}{The token to use to retrieve the next page of results. This value is null when there are no more results to return.}

\item{MaxResults}{The maximum number of accounts to return.}
}
\description{
Lists all account links.

See \url{https://www.paws-r-sdk.com/docs/workspaces_list_account_links/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/appstream_operations.R
\name{appstream_expire_session}
\alias{appstream_expire_session}
\title{Immediately stops the specified streaming session}
\usage{
appstream_expire_session(SessionId)
}
\arguments{
\item{SessionId}{[required] The identifier of the streaming session.}
}
\description{
Immediately stops the specified streaming session.

See \url{https://www.paws-r-sdk.com/docs/appstream_expire_session/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspacesweb_operations.R
\name{workspacesweb_update_network_settings}
\alias{workspacesweb_update_network_settings}
\title{Updates network settings}
\usage{
workspacesweb_update_network_settings(
  networkSettingsArn,
  vpcId = NULL,
  subnetIds = NULL,
  securityGroupIds = NULL,
  clientToken = NULL
)
}
\arguments{
\item{networkSettingsArn}{[required] The ARN of the network settings.}

\item{vpcId}{The VPC that streaming instances will connect to.}

\item{subnetIds}{The subnets in which network interfaces are created to connect streaming instances to your VPC. At least two of these subnets must be in different availability zones.}

\item{securityGroupIds}{One or more security groups used to control access from streaming instances to your VPC.}

\item{clientToken}{A unique, case-sensitive identifier that you provide to ensure the idempotency of the request. Idempotency ensures that an API request completes only once. With an idempotent request, if the original request completes successfully, subsequent retries with the same client token return the result from the original successful request.

If you do not specify a client token, one is automatically generated by the Amazon Web Services SDK.}
}
\description{
Updates network settings.

See \url{https://www.paws-r-sdk.com/docs/workspacesweb_update_network_settings/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_delete_mobile_device_access_override}
\alias{workmail_delete_mobile_device_access_override}
\title{Deletes the mobile device access override for the given WorkMail
organization, user, and device}
\usage{
workmail_delete_mobile_device_access_override(OrganizationId, UserId, DeviceId)
}
\arguments{
\item{OrganizationId}{[required] The WorkMail organization for which the access override will be deleted.}

\item{UserId}{[required] The WorkMail user for which you want to delete the override. Accepts the following types of user identities:
\itemize{
\item User ID: \code{12345678-1234-1234-1234-123456789012} or \code{S-1-1-12-1234567890-123456789-123456789-1234}
\item Email address: \code{user@domain.tld}
\item User name: \code{user}
}}

\item{DeviceId}{[required] The mobile device for which you delete the override. \code{DeviceId} is case insensitive.}
}
\description{
Deletes the mobile device access override for the given WorkMail organization, user, and device.

See \url{https://www.paws-r-sdk.com/docs/workmail_delete_mobile_device_access_override/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workdocs_operations.R
\name{workdocs_create_user}
\alias{workdocs_create_user}
\title{Creates a user in a Simple AD or Microsoft AD directory}
\usage{
workdocs_create_user(
  OrganizationId = NULL,
  Username,
  EmailAddress = NULL,
  GivenName,
  Surname,
  Password,
  TimeZoneId = NULL,
  StorageRule = NULL,
  AuthenticationToken = NULL
)
}
\arguments{
\item{OrganizationId}{The ID of the organization.}

\item{Username}{[required] The login name of the user.}

\item{EmailAddress}{The email address of the user.}

\item{GivenName}{[required] The given name of the user.}

\item{Surname}{[required] The surname of the user.}

\item{Password}{[required] The password of the user.}

\item{TimeZoneId}{The time zone ID of the user.}

\item{StorageRule}{The amount of storage for the user.}

\item{AuthenticationToken}{Amazon WorkDocs authentication token. Not required when using Amazon Web Services administrator credentials to access the API.}
}
\description{
Creates a user in a Simple AD or Microsoft AD directory. The status of a newly created user is "ACTIVE". New users can access Amazon WorkDocs.

See \url{https://www.paws-r-sdk.com/docs/workdocs_create_user/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_disassociate_member_from_group}
\alias{workmail_disassociate_member_from_group}
\title{Removes a member from a group}
\usage{
workmail_disassociate_member_from_group(OrganizationId, GroupId, MemberId)
}
\arguments{
\item{OrganizationId}{[required] The identifier for the organization under which the group exists.}

\item{GroupId}{[required] The identifier for the group from which members are removed.

The identifier can accept \emph{GroupId}, \emph{Groupname}, or \emph{email}. The following identity formats are available:
\itemize{
\item Group ID: 12345678-1234-1234-1234-123456789012 or S-1-1-12-1234567890-123456789-123456789-1234
\item Email address: group@domain.tld
\item Group name: group
}}

\item{MemberId}{[required] The identifier for the member to be removed from the group.

The member ID can accept \emph{UserID or GroupId}, \emph{Username or Groupname}, or \emph{email}.
\itemize{
\item Member ID: 12345678-1234-1234-1234-123456789012 or S-1-1-12-1234567890-123456789-123456789-1234
\item Email address: member@domain.tld
\item Member name: member
}}
}
\description{
Removes a member from a group.

See \url{https://www.paws-r-sdk.com/docs/workmail_disassociate_member_from_group/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/chatbot_operations.R
\name{chatbot_delete_slack_workspace_authorization}
\alias{chatbot_delete_slack_workspace_authorization}
\title{Deletes the Slack workspace authorization that allows channels to be
configured in that workspace}
\usage{
chatbot_delete_slack_workspace_authorization(SlackTeamId)
}
\arguments{
\item{SlackTeamId}{[required] The ID of the Slack workspace authorized with AWS Chatbot.}
}
\description{
Deletes the Slack workspace authorization that allows channels to be configured in that workspace. This requires all configured channels in the workspace to be deleted.

See \url{https://www.paws-r-sdk.com/docs/chatbot_delete_slack_workspace_authorization/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_create_resource}
\alias{workmail_create_resource}
\title{Creates a new WorkMail resource}
\usage{
workmail_create_resource(
  OrganizationId,
  Name,
  Type,
  Description = NULL,
  HiddenFromGlobalAddressList = NULL
)
}
\arguments{
\item{OrganizationId}{[required] The identifier associated with the organization for which the resource is created.}

\item{Name}{[required] The name of the new resource.}

\item{Type}{[required] The type of the new resource. The available types are \code{equipment} and \code{room}.}

\item{Description}{Resource description.}

\item{HiddenFromGlobalAddressList}{If this parameter is enabled, the resource will be hidden from the address book.}
}
\description{
Creates a new WorkMail resource.

See \url{https://www.paws-r-sdk.com/docs/workmail_create_resource/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/chatbot_operations.R
\name{chatbot_get_account_preferences}
\alias{chatbot_get_account_preferences}
\title{Returns AWS Chatbot account preferences}
\usage{
chatbot_get_account_preferences()
}
\description{
Returns AWS Chatbot account preferences.

See \url{https://www.paws-r-sdk.com/docs/chatbot_get_account_preferences/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workdocs_operations.R
\name{workdocs_describe_resource_permissions}
\alias{workdocs_describe_resource_permissions}
\title{Describes the permissions of a specified resource}
\usage{
workdocs_describe_resource_permissions(
  AuthenticationToken = NULL,
  ResourceId,
  PrincipalId = NULL,
  Limit = NULL,
  Marker = NULL
)
}
\arguments{
\item{AuthenticationToken}{Amazon WorkDocs authentication token. Not required when using Amazon Web Services administrator credentials to access the API.}

\item{ResourceId}{[required] The ID of the resource.}

\item{PrincipalId}{The ID of the principal to filter permissions by.}

\item{Limit}{The maximum number of items to return with this call.}

\item{Marker}{The marker for the next set of results. (You received this marker from a previous call)}
}
\description{
Describes the permissions of a specified resource.

See \url{https://www.paws-r-sdk.com/docs/workdocs_describe_resource_permissions/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_associate_delegate_to_resource}
\alias{workmail_associate_delegate_to_resource}
\title{Adds a member (user or group) to the resource's set of delegates}
\usage{
workmail_associate_delegate_to_resource(OrganizationId, ResourceId, EntityId)
}
\arguments{
\item{OrganizationId}{[required] The organization under which the resource exists.}

\item{ResourceId}{[required] The resource for which members (users or groups) are associated.

The identifier can accept \emph{ResourceId}, \emph{Resourcename}, or \emph{email}. The following identity formats are available:
\itemize{
\item Resource ID: r-0123456789a0123456789b0123456789
\item Email address: resource@domain.tld
\item Resource name: resource
}}

\item{EntityId}{[required] The member (user or group) to associate to the resource.

The entity ID can accept \emph{UserId or GroupID}, \emph{Username or Groupname}, or \emph{email}.
\itemize{
\item Entity: 12345678-1234-1234-1234-123456789012 or S-1-1-12-1234567890-123456789-123456789-1234
\item Email address: entity@domain.tld
\item Entity: entity
}}
}
\description{
Adds a member (user or group) to the resource's set of delegates.

See \url{https://www.paws-r-sdk.com/docs/workmail_associate_delegate_to_resource/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_create_group}
\alias{workmail_create_group}
\title{Creates a group that can be used in WorkMail by calling the
RegisterToWorkMail operation}
\usage{
workmail_create_group(OrganizationId, Name, HiddenFromGlobalAddressList = NULL)
}
\arguments{
\item{OrganizationId}{[required] The organization under which the group is to be created.}

\item{Name}{[required] The name of the group.}

\item{HiddenFromGlobalAddressList}{If this parameter is enabled, the group will be hidden from the address book.}
}
\description{
Creates a group that can be used in WorkMail by calling the \code{\link[=workmail_register_to_work_mail]{register_to_work_mail}} operation.

See \url{https://www.paws-r-sdk.com/docs/workmail_create_group/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspacesweb_operations.R
\name{workspacesweb_list_browser_settings}
\alias{workspacesweb_list_browser_settings}
\title{Retrieves a list of browser settings}
\usage{
workspacesweb_list_browser_settings(nextToken = NULL, maxResults = NULL)
}
\arguments{
\item{nextToken}{The pagination token used to retrieve the next page of results for this operation.}

\item{maxResults}{The maximum number of results to be included in the next page.}
}
\description{
Retrieves a list of browser settings.

See \url{https://www.paws-r-sdk.com/docs/workspacesweb_list_browser_settings/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_update_group}
\alias{workmail_update_group}
\title{Updates attributes in a group}
\usage{
workmail_update_group(
  OrganizationId,
  GroupId,
  HiddenFromGlobalAddressList = NULL
)
}
\arguments{
\item{OrganizationId}{[required] The identifier for the organization under which the group exists.}

\item{GroupId}{[required] The identifier for the group to be updated.

The identifier can accept \emph{GroupId}, \emph{Groupname}, or \emph{email}. The following identity formats are available:
\itemize{
\item Group ID: 12345678-1234-1234-1234-123456789012 or S-1-1-12-1234567890-123456789-123456789-1234
\item Email address: group@domain.tld
\item Group name: group
}}

\item{HiddenFromGlobalAddressList}{If enabled, the group is hidden from the global address list.}
}
\description{
Updates attributes in a group.

See \url{https://www.paws-r-sdk.com/docs/workmail_update_group/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workdocs_operations.R
\name{workdocs_create_labels}
\alias{workdocs_create_labels}
\title{Adds the specified list of labels to the given resource (a document or
folder)}
\usage{
workdocs_create_labels(ResourceId, Labels, AuthenticationToken = NULL)
}
\arguments{
\item{ResourceId}{[required] The ID of the resource.}

\item{Labels}{[required] List of labels to add to the resource.}

\item{AuthenticationToken}{Amazon WorkDocs authentication token. Not required when using Amazon Web Services administrator credentials to access the API.}
}
\description{
Adds the specified list of labels to the given resource (a document or folder)

See \url{https://www.paws-r-sdk.com/docs/workdocs_create_labels/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_update_user}
\alias{workmail_update_user}
\title{Updates data for the user}
\usage{
workmail_update_user(
  OrganizationId,
  UserId,
  Role = NULL,
  DisplayName = NULL,
  FirstName = NULL,
  LastName = NULL,
  HiddenFromGlobalAddressList = NULL,
  Initials = NULL,
  Telephone = NULL,
  Street = NULL,
  JobTitle = NULL,
  City = NULL,
  Company = NULL,
  ZipCode = NULL,
  Department = NULL,
  Country = NULL,
  Office = NULL,
  IdentityProviderUserId = NULL
)
}
\arguments{
\item{OrganizationId}{[required] The identifier for the organization under which the user exists.}

\item{UserId}{[required] The identifier for the user to be updated.

The identifier can be the \emph{UserId}, \emph{Username}, or \emph{email}. The following identity formats are available:
\itemize{
\item User ID: 12345678-1234-1234-1234-123456789012 or S-1-1-12-1234567890-123456789-123456789-1234
\item Email address: user@domain.tld
\item User name: user
}}

\item{Role}{Updates the user role.

You cannot pass \emph{SYSTEM_USER} or \emph{RESOURCE}.}

\item{DisplayName}{Updates the display name of the user.}

\item{FirstName}{Updates the user's first name.}

\item{LastName}{Updates the user's last name.}

\item{HiddenFromGlobalAddressList}{If enabled, the user is hidden from the global address list.}

\item{Initials}{Updates the user's initials.}

\item{Telephone}{Updates the user's contact details.}

\item{Street}{Updates the user's street address.}

\item{JobTitle}{Updates the user's job title.}

\item{City}{Updates the user's city.}

\item{Company}{Updates the user's company.}

\item{ZipCode}{Updates the user's zip code.}

\item{Department}{Updates the user's department.}

\item{Country}{Updates the user's country.}

\item{Office}{Updates the user's office.}

\item{IdentityProviderUserId}{User ID from the IAM Identity Center. If this parameter is empty it will be updated automatically when the user logs in for the first time to the mailbox associated with WorkMail.}
}
\description{
Updates data for the user. To have the latest information, it must be preceded by a \code{\link[=workmail_describe_user]{describe_user}} call. The dataset in the request should be the one expected when performing another \code{\link[=workmail_describe_user]{describe_user}} call.

See \url{https://www.paws-r-sdk.com/docs/workmail_update_user/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspaces_operations.R
\name{workspaces_describe_workspaces_connection_status}
\alias{workspaces_describe_workspaces_connection_status}
\title{Describes the connection status of the specified WorkSpaces}
\usage{
workspaces_describe_workspaces_connection_status(
  WorkspaceIds = NULL,
  NextToken = NULL
)
}
\arguments{
\item{WorkspaceIds}{The identifiers of the WorkSpaces. You can specify up to 25 WorkSpaces.}

\item{NextToken}{If you received a \code{NextToken} from a previous call that was paginated, provide this token to receive the next set of results.}
}
\description{
Describes the connection status of the specified WorkSpaces.

See \url{https://www.paws-r-sdk.com/docs/workspaces_describe_workspaces_connection_status/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_describe_inbound_dmarc_settings}
\alias{workmail_describe_inbound_dmarc_settings}
\title{Lists the settings in a DMARC policy for a specified organization}
\usage{
workmail_describe_inbound_dmarc_settings(OrganizationId)
}
\arguments{
\item{OrganizationId}{[required] Lists the ID of the given organization.}
}
\description{
Lists the settings in a DMARC policy for a specified organization.

See \url{https://www.paws-r-sdk.com/docs/workmail_describe_inbound_dmarc_settings/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspaces_operations.R
\name{workspaces_get_account_link}
\alias{workspaces_get_account_link}
\title{Retrieves account link information}
\usage{
workspaces_get_account_link(LinkId = NULL, LinkedAccountId = NULL)
}
\arguments{
\item{LinkId}{The identifier of the account to link.}

\item{LinkedAccountId}{The identifier of the account link}
}
\description{
Retrieves account link information.

See \url{https://www.paws-r-sdk.com/docs/workspaces_get_account_link/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspacesweb_operations.R
\name{workspacesweb_create_session_logger}
\alias{workspacesweb_create_session_logger}
\title{Creates a session logger}
\usage{
workspacesweb_create_session_logger(
  eventFilter,
  logConfiguration,
  displayName = NULL,
  customerManagedKey = NULL,
  additionalEncryptionContext = NULL,
  tags = NULL,
  clientToken = NULL
)
}
\arguments{
\item{eventFilter}{[required] The filter that specifies the events to monitor.}

\item{logConfiguration}{[required] The configuration that specifies where logs are delivered.}

\item{displayName}{The human-readable display name for the session logger resource.}

\item{customerManagedKey}{The custom managed key of the session logger.}

\item{additionalEncryptionContext}{The additional encryption context of the session logger.}

\item{tags}{The tags to add to the session logger.}

\item{clientToken}{A unique, case-sensitive identifier that you provide to ensure the idempotency of the request. Idempotency ensures that an API request completes only once. With an idempotent request, if the original request completes successfully, subsequent retries with the same client token returns the result from the original successful request. If you do not specify a client token, one is automatically generated by the AWS SDK.}
}
\description{
Creates a session logger.

See \url{https://www.paws-r-sdk.com/docs/workspacesweb_create_session_logger/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_delete_resource}
\alias{workmail_delete_resource}
\title{Deletes the specified resource}
\usage{
workmail_delete_resource(OrganizationId, ResourceId)
}
\arguments{
\item{OrganizationId}{[required] The identifier associated with the organization from which the resource is deleted.}

\item{ResourceId}{[required] The identifier of the resource to be deleted.

The identifier can accept \emph{ResourceId}, or \emph{Resourcename}. The following identity formats are available:
\itemize{
\item Resource ID: r-0123456789a0123456789b0123456789
\item Resource name: resource
}}
}
\description{
Deletes the specified resource.

See \url{https://www.paws-r-sdk.com/docs/workmail_delete_resource/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_put_access_control_rule}
\alias{workmail_put_access_control_rule}
\title{Adds a new access control rule for the specified organization}
\usage{
workmail_put_access_control_rule(
  Name,
  Effect,
  Description,
  IpRanges = NULL,
  NotIpRanges = NULL,
  Actions = NULL,
  NotActions = NULL,
  UserIds = NULL,
  NotUserIds = NULL,
  OrganizationId,
  ImpersonationRoleIds = NULL,
  NotImpersonationRoleIds = NULL
)
}
\arguments{
\item{Name}{[required] The rule name.}

\item{Effect}{[required] The rule effect.}

\item{Description}{[required] The rule description.}

\item{IpRanges}{IPv4 CIDR ranges to include in the rule.}

\item{NotIpRanges}{IPv4 CIDR ranges to exclude from the rule.}

\item{Actions}{Access protocol actions to include in the rule. Valid values include \code{ActiveSync}, \code{AutoDiscover}, \code{EWS}, \code{IMAP}, \code{SMTP}, \code{WindowsOutlook}, and \code{WebMail}.}

\item{NotActions}{Access protocol actions to exclude from the rule. Valid values include \code{ActiveSync}, \code{AutoDiscover}, \code{EWS}, \code{IMAP}, \code{SMTP}, \code{WindowsOutlook}, and \code{WebMail}.}

\item{UserIds}{User IDs to include in the rule.}

\item{NotUserIds}{User IDs to exclude from the rule.}

\item{OrganizationId}{[required] The identifier of the organization.}

\item{ImpersonationRoleIds}{Impersonation role IDs to include in the rule.}

\item{NotImpersonationRoleIds}{Impersonation role IDs to exclude from the rule.}
}
\description{
Adds a new access control rule for the specified organization. The rule allows or denies access to the organization for the specified IPv4 addresses, access protocol actions, user IDs and impersonation IDs. Adding a new rule with the same name as an existing rule replaces the older rule.

See \url{https://www.paws-r-sdk.com/docs/workmail_put_access_control_rule/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspaces_operations.R
\name{workspaces_copy_workspace_image}
\alias{workspaces_copy_workspace_image}
\title{Copies the specified image from the specified Region to the current
Region}
\usage{
workspaces_copy_workspace_image(
  Name,
  Description = NULL,
  SourceImageId,
  SourceRegion,
  Tags = NULL
)
}
\arguments{
\item{Name}{[required] The name of the image.}

\item{Description}{A description of the image.}

\item{SourceImageId}{[required] The identifier of the source image.}

\item{SourceRegion}{[required] The identifier of the source Region.}

\item{Tags}{The tags for the image.}
}
\description{
Copies the specified image from the specified Region to the current Region. For more information about copying images, see \href{https://docs.aws.amazon.com/workspaces/latest/adminguide/copy-custom-image.html}{Copy a Custom WorkSpaces Image}.

See \url{https://www.paws-r-sdk.com/docs/workspaces_copy_workspace_image/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/appstream_operations.R
\name{appstream_get_export_image_task}
\alias{appstream_get_export_image_task}
\title{Retrieves information about an export image task, including its current
state, progress, and any error details}
\usage{
appstream_get_export_image_task(TaskId = NULL)
}
\arguments{
\item{TaskId}{The unique identifier of the export image task to retrieve information about.}
}
\description{
Retrieves information about an export image task, including its current state, progress, and any error details.

See \url{https://www.paws-r-sdk.com/docs/appstream_get_export_image_task/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workdocs_operations.R
\name{workdocs_update_document_version}
\alias{workdocs_update_document_version}
\title{Changes the status of the document version to ACTIVE}
\usage{
workdocs_update_document_version(
  AuthenticationToken = NULL,
  DocumentId,
  VersionId,
  VersionStatus = NULL
)
}
\arguments{
\item{AuthenticationToken}{Amazon WorkDocs authentication token. Not required when using Amazon Web Services administrator credentials to access the API.}

\item{DocumentId}{[required] The ID of the document.}

\item{VersionId}{[required] The version ID of the document.}

\item{VersionStatus}{The status of the version.}
}
\description{
Changes the status of the document version to ACTIVE.

See \url{https://www.paws-r-sdk.com/docs/workdocs_update_document_version/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/chatbot_operations.R
\name{chatbot_update_custom_action}
\alias{chatbot_update_custom_action}
\title{Updates a custom action}
\usage{
chatbot_update_custom_action(
  CustomActionArn,
  Definition,
  AliasName = NULL,
  Attachments = NULL
)
}
\arguments{
\item{CustomActionArn}{[required] The fully defined Amazon Resource Name (ARN) of the custom action.}

\item{Definition}{[required] The definition of the command to run when invoked as an alias or as an action button.}

\item{AliasName}{The name used to invoke this action in the chat channel. For example, \verb{@aws run my-alias}.}

\item{Attachments}{Defines when this custom action button should be attached to a notification.}
}
\description{
Updates a custom action.

See \url{https://www.paws-r-sdk.com/docs/chatbot_update_custom_action/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/chatbot_operations.R
\name{chatbot_list_microsoft_teams_user_identities}
\alias{chatbot_list_microsoft_teams_user_identities}
\title{A list all Microsoft Teams user identities with a mapped role}
\usage{
chatbot_list_microsoft_teams_user_identities(
  ChatConfigurationArn = NULL,
  NextToken = NULL,
  MaxResults = NULL
)
}
\arguments{
\item{ChatConfigurationArn}{The Amazon Resource Name (ARN) of the MicrosoftTeamsChannelConfiguration associated with the user identities to list.}

\item{NextToken}{An optional token returned from a prior request. Use this token for pagination of results from this action. If this parameter is specified, the response includes only results beyond the token, up to the value specified by MaxResults.}

\item{MaxResults}{The maximum number of results to include in the response. If more results exist than the specified MaxResults value, a token is included in the response so that the remaining results can be retrieved.}
}
\description{
A list all Microsoft Teams user identities with a mapped role.

See \url{https://www.paws-r-sdk.com/docs/chatbot_list_microsoft_teams_user_identities/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspaces_operations.R
\name{workspaces_create_updated_workspace_image}
\alias{workspaces_create_updated_workspace_image}
\title{Creates a new updated WorkSpace image based on the specified source
image}
\usage{
workspaces_create_updated_workspace_image(
  Name,
  Description,
  SourceImageId,
  Tags = NULL
)
}
\arguments{
\item{Name}{[required] The name of the new updated WorkSpace image.}

\item{Description}{[required] A description of whether updates for the WorkSpace image are available.}

\item{SourceImageId}{[required] The identifier of the source WorkSpace image.}

\item{Tags}{The tags that you want to add to the new updated WorkSpace image.

To add tags at the same time when you're creating the updated image, you must create an IAM policy that grants your IAM user permissions to use \code{workspaces:CreateTags}.}
}
\description{
Creates a new updated WorkSpace image based on the specified source image. The new updated WorkSpace image has the latest drivers and other updates required by the Amazon WorkSpaces components.

See \url{https://www.paws-r-sdk.com/docs/workspaces_create_updated_workspace_image/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspaces_operations.R
\name{workspaces_describe_workspaces}
\alias{workspaces_describe_workspaces}
\title{Describes the specified WorkSpaces}
\usage{
workspaces_describe_workspaces(
  WorkspaceIds = NULL,
  DirectoryId = NULL,
  UserName = NULL,
  BundleId = NULL,
  Limit = NULL,
  NextToken = NULL,
  WorkspaceName = NULL
)
}
\arguments{
\item{WorkspaceIds}{The identifiers of the WorkSpaces. You cannot combine this parameter with any other filter.

Because the \code{\link[=workspaces_create_workspaces]{create_workspaces}} operation is asynchronous, the identifier it returns is not immediately available. If you immediately call \code{\link[=workspaces_describe_workspaces]{describe_workspaces}} with this identifier, no information is returned.}

\item{DirectoryId}{The identifier of the directory. In addition, you can optionally specify a specific directory user (see \code{UserName}). You cannot combine this parameter with any other filter.}

\item{UserName}{The name of the directory user. You must specify this parameter with \code{DirectoryId}.}

\item{BundleId}{The identifier of the bundle. All WorkSpaces that are created from this bundle are retrieved. You cannot combine this parameter with any other filter.}

\item{Limit}{The maximum number of items to return.}

\item{NextToken}{If you received a \code{NextToken} from a previous call that was paginated, provide this token to receive the next set of results.}

\item{WorkspaceName}{The name of the user-decoupled WorkSpace.}
}
\description{
Describes the specified WorkSpaces.

See \url{https://www.paws-r-sdk.com/docs/workspaces_describe_workspaces/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspacesweb_operations.R
\name{workspacesweb_create_ip_access_settings}
\alias{workspacesweb_create_ip_access_settings}
\title{Creates an IP access settings resource that can be associated with a web
portal}
\usage{
workspacesweb_create_ip_access_settings(
  displayName = NULL,
  description = NULL,
  tags = NULL,
  customerManagedKey = NULL,
  additionalEncryptionContext = NULL,
  ipRules,
  clientToken = NULL
)
}
\arguments{
\item{displayName}{The display name of the IP access settings.}

\item{description}{The description of the IP access settings.}

\item{tags}{The tags to add to the IP access settings resource. A tag is a key-value pair.}

\item{customerManagedKey}{The custom managed key of the IP access settings.}

\item{additionalEncryptionContext}{Additional encryption context of the IP access settings.}

\item{ipRules}{[required] The IP rules of the IP access settings.}

\item{clientToken}{A unique, case-sensitive identifier that you provide to ensure the idempotency of the request. Idempotency ensures that an API request completes only once. With an idempotent request, if the original request completes successfully, subsequent retries with the same client token returns the result from the original successful request.

If you do not specify a client token, one is automatically generated by the Amazon Web Services SDK.}
}
\description{
Creates an IP access settings resource that can be associated with a web portal.

See \url{https://www.paws-r-sdk.com/docs/workspacesweb_create_ip_access_settings/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/appstream_operations.R
\name{appstream_start_software_deployment_to_image_builder}
\alias{appstream_start_software_deployment_to_image_builder}
\title{Initiates license included applications deployment to an image builder
instance}
\usage{
appstream_start_software_deployment_to_image_builder(
  ImageBuilderName,
  RetryFailedDeployments = NULL
)
}
\arguments{
\item{ImageBuilderName}{[required] The name of the target image builder instance.}

\item{RetryFailedDeployments}{Whether to retry previously failed license included application deployments.}
}
\description{
Initiates license included applications deployment to an image builder instance.

See \url{https://www.paws-r-sdk.com/docs/appstream_start_software_deployment_to_image_builder/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_delete_availability_configuration}
\alias{workmail_delete_availability_configuration}
\title{Deletes the AvailabilityConfiguration for the given WorkMail
organization and domain}
\usage{
workmail_delete_availability_configuration(OrganizationId, DomainName)
}
\arguments{
\item{OrganizationId}{[required] The WorkMail organization for which the \code{AvailabilityConfiguration} will be deleted.}

\item{DomainName}{[required] The domain for which the \code{AvailabilityConfiguration} will be deleted.}
}
\description{
Deletes the \code{AvailabilityConfiguration} for the given WorkMail organization and domain.

See \url{https://www.paws-r-sdk.com/docs/workmail_delete_availability_configuration/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspaces_operations.R
\name{workspaces_import_client_branding}
\alias{workspaces_import_client_branding}
\title{Imports client branding}
\usage{
workspaces_import_client_branding(
  ResourceId,
  DeviceTypeWindows = NULL,
  DeviceTypeOsx = NULL,
  DeviceTypeAndroid = NULL,
  DeviceTypeIos = NULL,
  DeviceTypeLinux = NULL,
  DeviceTypeWeb = NULL
)
}
\arguments{
\item{ResourceId}{[required] The directory identifier of the WorkSpace for which you want to import client branding.}

\item{DeviceTypeWindows}{The branding information to import for Windows devices.}

\item{DeviceTypeOsx}{The branding information to import for macOS devices.}

\item{DeviceTypeAndroid}{The branding information to import for Android devices.}

\item{DeviceTypeIos}{The branding information to import for iOS devices.}

\item{DeviceTypeLinux}{The branding information to import for Linux devices.}

\item{DeviceTypeWeb}{The branding information to import for web access.}
}
\description{
Imports client branding. Client branding allows you to customize your WorkSpace's client login portal. You can tailor your login portal company logo, the support email address, support link, link to reset password, and a custom message for users trying to sign in.

See \url{https://www.paws-r-sdk.com/docs/workspaces_import_client_branding/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/appstream_operations.R
\name{appstream_create_fleet}
\alias{appstream_create_fleet}
\title{Creates a fleet}
\usage{
appstream_create_fleet(
  Name,
  ImageName = NULL,
  ImageArn = NULL,
  InstanceType,
  FleetType = NULL,
  ComputeCapacity = NULL,
  VpcConfig = NULL,
  MaxUserDurationInSeconds = NULL,
  DisconnectTimeoutInSeconds = NULL,
  Description = NULL,
  DisplayName = NULL,
  EnableDefaultInternetAccess = NULL,
  DomainJoinInfo = NULL,
  Tags = NULL,
  IdleDisconnectTimeoutInSeconds = NULL,
  IamRoleArn = NULL,
  StreamView = NULL,
  Platform = NULL,
  MaxConcurrentSessions = NULL,
  UsbDeviceFilterStrings = NULL,
  SessionScriptS3Location = NULL,
  MaxSessionsPerInstance = NULL,
  RootVolumeConfig = NULL,
  DisableIMDSV1 = NULL
)
}
\arguments{
\item{Name}{[required] A unique name for the fleet.}

\item{ImageName}{The name of the image used to create the fleet.}

\item{ImageArn}{The ARN of the public, private, or shared image to use.}

\item{InstanceType}{[required] The instance type to use when launching fleet instances. The following instance types are available:
\itemize{
\item stream.standard.small
\item stream.standard.medium
\item stream.standard.large
\item stream.standard.xlarge
\item stream.standard.2xlarge
\item stream.compute.large
\item stream.compute.xlarge
\item stream.compute.2xlarge
\item stream.compute.4xlarge
\item stream.compute.8xlarge
\item stream.memory.large
\item stream.memory.xlarge
\item stream.memory.2xlarge
\item stream.memory.4xlarge
\item stream.memory.8xlarge
\item stream.memory.z1d.large
\item stream.memory.z1d.xlarge
\item stream.memory.z1d.2xlarge
\item stream.memory.z1d.3xlarge
\item stream.memory.z1d.6xlarge
\item stream.memory.z1d.12xlarge
\item stream.graphics.g4dn.xlarge
\item stream.graphics.g4dn.2xlarge
\item stream.graphics.g4dn.4xlarge
\item stream.graphics.g4dn.8xlarge
\item stream.graphics.g4dn.12xlarge
\item stream.graphics.g4dn.16xlarge
\item stream.graphics.g5.xlarge
\item stream.graphics.g5.2xlarge
\item stream.graphics.g5.4xlarge
\item stream.graphics.g5.8xlarge
\item stream.graphics.g5.12xlarge
\item stream.graphics.g5.16xlarge
\item stream.graphics.g5.24xlarge
\item stream.graphics.g6.xlarge
\item stream.graphics.g6.2xlarge
\item stream.graphics.g6.4xlarge
\item stream.graphics.g6.8xlarge
\item stream.graphics.g6.16xlarge
\item stream.graphics.g6.12xlarge
\item stream.graphics.g6.24xlarge
\item stream.graphics.gr6.4xlarge
\item stream.graphics.gr6.8xlarge
\item stream.graphics.g6f.large
\item stream.graphics.g6f.xlarge
\item stream.graphics.g6f.2xlarge
\item stream.graphics.g6f.4xlarge
\item stream.graphics.gr6f.4xlarge
}

The following instance types are available for Elastic fleets:
\itemize{
\item stream.standard.small
\item stream.standard.medium
\item stream.standard.large
\item stream.standard.xlarge
\item stream.standard.2xlarge
}}

\item{FleetType}{The fleet type.

\strong{ALWAYS_ON}

Provides users with instant-on access to their apps. You are charged for all running instances in your fleet, even if no users are streaming apps.

\strong{ON_DEMAND}

Provide users with access to applications after they connect, which takes one to two minutes. You are charged for instance streaming when users are connected and a small hourly fee for instances that are not streaming apps.}

\item{ComputeCapacity}{The desired capacity for the fleet. This is not allowed for Elastic fleets. For Elastic fleets, specify MaxConcurrentSessions instead.}

\item{VpcConfig}{The VPC configuration for the fleet. This is required for Elastic fleets, but not required for other fleet types. Elastic fleets require that you specify at least two subnets in different availability zones.}

\item{MaxUserDurationInSeconds}{The maximum amount of time that a streaming session can remain active, in seconds. If users are still connected to a streaming instance five minutes before this limit is reached, they are prompted to save any open documents before being disconnected. After this time elapses, the instance is terminated and replaced by a new instance.

Specify a value between 600 and 432000.}

\item{DisconnectTimeoutInSeconds}{The amount of time that a streaming session remains active after users disconnect. If users try to reconnect to the streaming session after a disconnection or network interruption within this time interval, they are connected to their previous session. Otherwise, they are connected to a new session with a new streaming instance.

Specify a value between 60 and 36000.}

\item{Description}{The description to display.}

\item{DisplayName}{The fleet name to display.}

\item{EnableDefaultInternetAccess}{Enables or disables default internet access for the fleet.}

\item{DomainJoinInfo}{The name of the directory and organizational unit (OU) to use to join the fleet to a Microsoft Active Directory domain. This is not allowed for Elastic fleets.}

\item{Tags}{The tags to associate with the fleet. A tag is a key-value pair, and the value is optional. For example, Environment=Test. If you do not specify a value, Environment=.

If you do not specify a value, the value is set to an empty string.

Generally allowed characters are: letters, numbers, and spaces representable in UTF-8, and the following special characters:

_ . : / = + \\ - @

For more information, see \href{https://docs.aws.amazon.com/appstream2/latest/developerguide/tagging-basic.html}{Tagging Your Resources} in the \emph{Amazon WorkSpaces Applications Administration Guide}.}

\item{IdleDisconnectTimeoutInSeconds}{The amount of time that users can be idle (inactive) before they are disconnected from their streaming session and the \code{DisconnectTimeoutInSeconds} time interval begins. Users are notified before they are disconnected due to inactivity. If they try to reconnect to the streaming session before the time interval specified in \code{DisconnectTimeoutInSeconds} elapses, they are connected to their previous session. Users are considered idle when they stop providing keyboard or mouse input during their streaming session. File uploads and downloads, audio in, audio out, and pixels changing do not qualify as user activity. If users continue to be idle after the time interval in \code{IdleDisconnectTimeoutInSeconds} elapses, they are disconnected.

To prevent users from being disconnected due to inactivity, specify a value of 0. Otherwise, specify a value between 60 and 36000. The default value is 0.

If you enable this feature, we recommend that you specify a value that corresponds exactly to a whole number of minutes (for example, 60, 120, and 180). If you don't do this, the value is rounded to the nearest minute. For example, if you specify a value of 70, users are disconnected after 1 minute of inactivity. If you specify a value that is at the midpoint between two different minutes, the value is rounded up. For example, if you specify a value of 90, users are disconnected after 2 minutes of inactivity.}

\item{IamRoleArn}{The Amazon Resource Name (ARN) of the IAM role to apply to the fleet. To assume a role, a fleet instance calls the AWS Security Token Service (STS) \code{AssumeRole} API operation and passes the ARN of the role to use. The operation creates a new session with temporary credentials. WorkSpaces Applications retrieves the temporary credentials and creates the \strong{appstream_machine_role} credential profile on the instance.

For more information, see \href{https://docs.aws.amazon.com/appstream2/latest/developerguide/using-iam-roles-to-grant-permissions-to-applications-scripts-streaming-instances.html}{Using an IAM Role to Grant Permissions to Applications and Scripts Running on WorkSpaces Applications Streaming Instances} in the \emph{Amazon WorkSpaces Applications Administration Guide}.}

\item{StreamView}{The WorkSpaces Applications view that is displayed to your users when they stream from the fleet. When \code{APP} is specified, only the windows of applications opened by users display. When \code{DESKTOP} is specified, the standard desktop that is provided by the operating system displays.

The default value is \code{APP}.}

\item{Platform}{The fleet platform. WINDOWS_SERVER_2019, AMAZON_LINUX2 and UBUNTU_PRO_2404 are supported for Elastic fleets.}

\item{MaxConcurrentSessions}{The maximum concurrent sessions of the Elastic fleet. This is required for Elastic fleets, and not allowed for other fleet types.}

\item{UsbDeviceFilterStrings}{The USB device filter strings that specify which USB devices a user can redirect to the fleet streaming session, when using the Windows native client. This is allowed but not required for Elastic fleets.}

\item{SessionScriptS3Location}{The S3 location of the session scripts configuration zip file. This only applies to Elastic fleets.}

\item{MaxSessionsPerInstance}{The maximum number of user sessions on an instance. This only applies to multi-session fleets.}

\item{RootVolumeConfig}{The configuration for the root volume of fleet instances. Use this to customize storage capacity from 200 GB up to 500 GB based on your application requirements.}

\item{DisableIMDSV1}{Set to true to disable Instance Metadata Service Version 1 (IMDSv1) and enforce IMDSv2. Set to false to enable both IMDSv1 and IMDSv2.

Before disabling IMDSv1, ensure your WorkSpaces Applications images are running the agent version or managed image update released on or after January 16, 2024 to support IMDSv2 enforcement.}
}
\description{
Creates a fleet. A fleet consists of streaming instances that your users access for their applications and desktops.

See \url{https://www.paws-r-sdk.com/docs/appstream_create_fleet/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ivschat_operations.R
\name{ivschat_delete_message}
\alias{ivschat_delete_message}
\title{Sends an event to a specific room which directs clients to delete a
specific message; that is, unrender it from view and delete it from the
client’s chat history}
\usage{
ivschat_delete_message(roomIdentifier, id, reason = NULL)
}
\arguments{
\item{roomIdentifier}{[required] Identifier of the room where the message should be deleted. Currently this must be an ARN.}

\item{id}{[required] ID of the message to be deleted. This is the \code{Id} field in the received message (see \href{https://docs.aws.amazon.com/ivs/latest/chatmsgapireference/actions-message-subscribe.html}{Message (Subscribe)} in the Chat Messaging API).}

\item{reason}{Reason for deleting the message.}
}
\description{
Sends an event to a specific room which directs clients to delete a specific message; that is, unrender it from view and delete it from the client’s chat history. This event’s \code{EventName} is \code{aws:DELETE_MESSAGE}. This replicates the \href{https://docs.aws.amazon.com/ivs/latest/chatmsgapireference/actions-deletemessage-publish.html}{DeleteMessage} WebSocket operation in the Amazon IVS Chat Messaging API.

See \url{https://www.paws-r-sdk.com/docs/ivschat_delete_message/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_put_mailbox_permissions}
\alias{workmail_put_mailbox_permissions}
\title{Sets permissions for a user, group, or resource}
\usage{
workmail_put_mailbox_permissions(
  OrganizationId,
  EntityId,
  GranteeId,
  PermissionValues
)
}
\arguments{
\item{OrganizationId}{[required] The identifier of the organization under which the user, group, or resource exists.}

\item{EntityId}{[required] The identifier of the user or resource for which to update mailbox permissions.

The identifier can be \emph{UserId, ResourceID, or Group Id}, \emph{Username, Resourcename, or Groupname}, or \emph{email}.
\itemize{
\item Entity ID: 12345678-1234-1234-1234-123456789012, r-0123456789a0123456789b0123456789, or S-1-1-12-1234567890-123456789-123456789-1234
\item Email address: entity@domain.tld
\item Entity name: entity
}}

\item{GranteeId}{[required] The identifier of the user, group, or resource to which to grant the permissions.

The identifier can be \emph{UserId, ResourceID, or Group Id}, \emph{Username, Resourcename, or Groupname}, or \emph{email}.
\itemize{
\item Grantee ID: 12345678-1234-1234-1234-123456789012, r-0123456789a0123456789b0123456789, or S-1-1-12-1234567890-123456789-123456789-1234
\item Email address: grantee@domain.tld
\item Grantee name: grantee
}}

\item{PermissionValues}{[required] The permissions granted to the grantee. SEND_AS allows the grantee to send email as the owner of the mailbox (the grantee is not mentioned on these emails). SEND_ON_BEHALF allows the grantee to send email on behalf of the owner of the mailbox (the grantee is not mentioned as the physical sender of these emails). FULL_ACCESS allows the grantee full access to the mailbox, irrespective of other folder-level permissions set on the mailbox.}
}
\description{
Sets permissions for a user, group, or resource. This replaces any pre-existing permissions.

See \url{https://www.paws-r-sdk.com/docs/workmail_put_mailbox_permissions/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_get_mailbox_details}
\alias{workmail_get_mailbox_details}
\title{Requests a user's mailbox details for a specified organization and user}
\usage{
workmail_get_mailbox_details(OrganizationId, UserId)
}
\arguments{
\item{OrganizationId}{[required] The identifier for the organization that contains the user whose mailbox details are being requested.}

\item{UserId}{[required] The identifier for the user whose mailbox details are being requested.

The identifier can be the \emph{UserId}, \emph{Username}, or \emph{email}. The following identity formats are available:
\itemize{
\item User ID: 12345678-1234-1234-1234-123456789012 or S-1-1-12-1234567890-123456789-123456789-1234
\item Email address: user@domain.tld
\item User name: user
}}
}
\description{
Requests a user's mailbox details for a specified organization and user.

See \url{https://www.paws-r-sdk.com/docs/workmail_get_mailbox_details/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_deregister_from_work_mail}
\alias{workmail_deregister_from_work_mail}
\title{Mark a user, group, or resource as no longer used in WorkMail}
\usage{
workmail_deregister_from_work_mail(OrganizationId, EntityId)
}
\arguments{
\item{OrganizationId}{[required] The identifier for the organization under which the WorkMail entity exists.}

\item{EntityId}{[required] The identifier for the member to be updated.

The identifier can be \emph{UserId, ResourceId, or Group Id}, \emph{Username, Resourcename, or Groupname}, or \emph{email}.
\itemize{
\item Entity ID: 12345678-1234-1234-1234-123456789012, r-0123456789a0123456789b0123456789, or S-1-1-12-1234567890-123456789-123456789-1234
\item Email address: entity@domain.tld
\item Entity name: entity
}}
}
\description{
Mark a user, group, or resource as no longer used in WorkMail. This action disassociates the mailbox and schedules it for clean-up. WorkMail keeps mailboxes for 30 days before they are permanently removed. The functionality in the console is \emph{Disable}.

See \url{https://www.paws-r-sdk.com/docs/workmail_deregister_from_work_mail/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspaces_operations.R
\name{workspaces_reboot_workspaces}
\alias{workspaces_reboot_workspaces}
\title{Reboots the specified WorkSpaces}
\usage{
workspaces_reboot_workspaces(RebootWorkspaceRequests)
}
\arguments{
\item{RebootWorkspaceRequests}{[required] The WorkSpaces to reboot. You can specify up to 25 WorkSpaces.}
}
\description{
Reboots the specified WorkSpaces.

See \url{https://www.paws-r-sdk.com/docs/workspaces_reboot_workspaces/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_create_identity_center_application}
\alias{workmail_create_identity_center_application}
\title{Creates the WorkMail application in IAM Identity Center that can be used
later in the WorkMail - IdC integration}
\usage{
workmail_create_identity_center_application(
  Name,
  InstanceArn,
  ClientToken = NULL
)
}
\arguments{
\item{Name}{[required] The name of the IAM Identity Center application.}

\item{InstanceArn}{[required] The Amazon Resource Name (ARN) of the instance.}

\item{ClientToken}{The idempotency token associated with the request.}
}
\description{
Creates the WorkMail application in IAM Identity Center that can be used later in the WorkMail - IdC integration. For more information, see PutIdentityProviderConfiguration. This action does not affect the authentication settings for any WorkMail organizations.

See \url{https://www.paws-r-sdk.com/docs/workmail_create_identity_center_application/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspaces_operations.R
\name{workspaces_create_standby_workspaces}
\alias{workspaces_create_standby_workspaces}
\title{Creates a standby WorkSpace in a secondary Region}
\usage{
workspaces_create_standby_workspaces(PrimaryRegion, StandbyWorkspaces)
}
\arguments{
\item{PrimaryRegion}{[required] The Region of the primary WorkSpace.}

\item{StandbyWorkspaces}{[required] Information about the standby WorkSpace to be created.}
}
\description{
Creates a standby WorkSpace in a secondary Region.

See \url{https://www.paws-r-sdk.com/docs/workspaces_create_standby_workspaces/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/appstream_operations.R
\name{appstream_list_export_image_tasks}
\alias{appstream_list_export_image_tasks}
\title{Lists export image tasks, with optional filtering and pagination}
\usage{
appstream_list_export_image_tasks(
  Filters = NULL,
  MaxResults = NULL,
  NextToken = NULL
)
}
\arguments{
\item{Filters}{Optional filters to apply when listing export image tasks. Filters help you narrow down the results based on specific criteria.}

\item{MaxResults}{The maximum number of export image tasks to return in a single request. The valid range is 1-500, with a default of 50.}

\item{NextToken}{The pagination token from a previous request. Use this to retrieve the next page of results when there are more tasks than the MaxResults limit.}
}
\description{
Lists export image tasks, with optional filtering and pagination. Use this operation to monitor the status of multiple export operations.

See \url{https://www.paws-r-sdk.com/docs/appstream_list_export_image_tasks/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspaces_operations.R
\name{workspaces_describe_account_modifications}
\alias{workspaces_describe_account_modifications}
\title{Retrieves a list that describes modifications to the configuration of
Bring Your Own License (BYOL) for the specified account}
\usage{
workspaces_describe_account_modifications(NextToken = NULL)
}
\arguments{
\item{NextToken}{If you received a \code{NextToken} from a previous call that was paginated, provide this token to receive the next set of results.}
}
\description{
Retrieves a list that describes modifications to the configuration of Bring Your Own License (BYOL) for the specified account.

See \url{https://www.paws-r-sdk.com/docs/workspaces_describe_account_modifications/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspaces_operations.R
\name{workspaces_create_connection_alias}
\alias{workspaces_create_connection_alias}
\title{Creates the specified connection alias for use with cross-Region
redirection}
\usage{
workspaces_create_connection_alias(ConnectionString, Tags = NULL)
}
\arguments{
\item{ConnectionString}{[required] A connection string in the form of a fully qualified domain name (FQDN), such as \code{www.example.com}.

After you create a connection string, it is always associated to your Amazon Web Services account. You cannot recreate the same connection string with a different account, even if you delete all instances of it from the original account. The connection string is globally reserved for your account.}

\item{Tags}{The tags to associate with the connection alias.}
}
\description{
Creates the specified connection alias for use with cross-Region redirection. For more information, see \href{https://docs.aws.amazon.com/workspaces/latest/adminguide/cross-region-redirection.html}{Cross-Region Redirection for Amazon WorkSpaces}.

See \url{https://www.paws-r-sdk.com/docs/workspaces_create_connection_alias/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspacesweb_operations.R
\name{workspacesweb_untag_resource}
\alias{workspacesweb_untag_resource}
\title{Removes one or more tags from the specified resource}
\usage{
workspacesweb_untag_resource(resourceArn, tagKeys)
}
\arguments{
\item{resourceArn}{[required] The ARN of the resource.}

\item{tagKeys}{[required] The list of tag keys to remove from the resource.}
}
\description{
Removes one or more tags from the specified resource.

See \url{https://www.paws-r-sdk.com/docs/workspacesweb_untag_resource/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/appstream_operations.R
\name{appstream_create_image_builder}
\alias{appstream_create_image_builder}
\title{Creates an image builder}
\usage{
appstream_create_image_builder(
  Name,
  ImageName = NULL,
  ImageArn = NULL,
  InstanceType,
  Description = NULL,
  DisplayName = NULL,
  VpcConfig = NULL,
  IamRoleArn = NULL,
  EnableDefaultInternetAccess = NULL,
  DomainJoinInfo = NULL,
  AppstreamAgentVersion = NULL,
  Tags = NULL,
  AccessEndpoints = NULL,
  RootVolumeConfig = NULL,
  SoftwaresToInstall = NULL,
  SoftwaresToUninstall = NULL,
  DisableIMDSV1 = NULL
)
}
\arguments{
\item{Name}{[required] A unique name for the image builder.}

\item{ImageName}{The name of the image used to create the image builder.}

\item{ImageArn}{The ARN of the public, private, or shared image to use.}

\item{InstanceType}{[required] The instance type to use when launching the image builder. The following instance types are available:
\itemize{
\item stream.standard.small
\item stream.standard.medium
\item stream.standard.large
\item stream.compute.large
\item stream.compute.xlarge
\item stream.compute.2xlarge
\item stream.compute.4xlarge
\item stream.compute.8xlarge
\item stream.memory.large
\item stream.memory.xlarge
\item stream.memory.2xlarge
\item stream.memory.4xlarge
\item stream.memory.8xlarge
\item stream.memory.z1d.large
\item stream.memory.z1d.xlarge
\item stream.memory.z1d.2xlarge
\item stream.memory.z1d.3xlarge
\item stream.memory.z1d.6xlarge
\item stream.memory.z1d.12xlarge
\item stream.graphics.g4dn.xlarge
\item stream.graphics.g4dn.2xlarge
\item stream.graphics.g4dn.4xlarge
\item stream.graphics.g4dn.8xlarge
\item stream.graphics.g4dn.12xlarge
\item stream.graphics.g4dn.16xlarge
\item stream.graphics.g5.xlarge
\item stream.graphics.g5.2xlarge
\item stream.graphics.g5.4xlarge
\item stream.graphics.g5.8xlarge
\item stream.graphics.g5.16xlarge
\item stream.graphics.g5.12xlarge
\item stream.graphics.g5.24xlarge
\item stream.graphics.g6.xlarge
\item stream.graphics.g6.2xlarge
\item stream.graphics.g6.4xlarge
\item stream.graphics.g6.8xlarge
\item stream.graphics.g6.16xlarge
\item stream.graphics.g6.12xlarge
\item stream.graphics.g6.24xlarge
\item stream.graphics.gr6.4xlarge
\item stream.graphics.gr6.8xlarge
\item stream.graphics.g6f.large
\item stream.graphics.g6f.xlarge
\item stream.graphics.g6f.2xlarge
\item stream.graphics.g6f.4xlarge
\item stream.graphics.gr6f.4xlarge
}}

\item{Description}{The description to display.}

\item{DisplayName}{The image builder name to display.}

\item{VpcConfig}{The VPC configuration for the image builder. You can specify only one subnet.}

\item{IamRoleArn}{The Amazon Resource Name (ARN) of the IAM role to apply to the image builder. To assume a role, the image builder calls the AWS Security Token Service (STS) \code{AssumeRole} API operation and passes the ARN of the role to use. The operation creates a new session with temporary credentials. WorkSpaces Applications retrieves the temporary credentials and creates the \strong{appstream_machine_role} credential profile on the instance.

For more information, see \href{https://docs.aws.amazon.com/appstream2/latest/developerguide/using-iam-roles-to-grant-permissions-to-applications-scripts-streaming-instances.html}{Using an IAM Role to Grant Permissions to Applications and Scripts Running on WorkSpaces Applications Streaming Instances} in the \emph{Amazon WorkSpaces Applications Administration Guide}.}

\item{EnableDefaultInternetAccess}{Enables or disables default internet access for the image builder.}

\item{DomainJoinInfo}{The name of the directory and organizational unit (OU) to use to join the image builder to a Microsoft Active Directory domain.}

\item{AppstreamAgentVersion}{The version of the WorkSpaces Applications agent to use for this image builder. To use the latest version of the WorkSpaces Applications agent, specify [LATEST].}

\item{Tags}{The tags to associate with the image builder. A tag is a key-value pair, and the value is optional. For example, Environment=Test. If you do not specify a value, Environment=.

Generally allowed characters are: letters, numbers, and spaces representable in UTF-8, and the following special characters:

_ . : / = + \\ - @

If you do not specify a value, the value is set to an empty string.

For more information about tags, see \href{https://docs.aws.amazon.com/appstream2/latest/developerguide/tagging-basic.html}{Tagging Your Resources} in the \emph{Amazon WorkSpaces Applications Administration Guide}.}

\item{AccessEndpoints}{The list of interface VPC endpoint (interface endpoint) objects. Administrators can connect to the image builder only through the specified endpoints.}

\item{RootVolumeConfig}{The configuration for the root volume of the image builder. Use this to customize storage capacity from 200 GB up to 500 GB based on your application installation requirements.}

\item{SoftwaresToInstall}{The list of license included applications to install on the image builder during creation.

Possible values include the following:
\itemize{
\item Microsoft_Office_2021_LTSC_Professional_Plus_32Bit
\item Microsoft_Office_2021_LTSC_Professional_Plus_64Bit
\item Microsoft_Office_2024_LTSC_Professional_Plus_32Bit
\item Microsoft_Office_2024_LTSC_Professional_Plus_64Bit
\item Microsoft_Visio_2021_LTSC_Professional_32Bit
\item Microsoft_Visio_2021_LTSC_Professional_64Bit
\item Microsoft_Visio_2024_LTSC_Professional_32Bit
\item Microsoft_Visio_2024_LTSC_Professional_64Bit
\item Microsoft_Project_2021_Professional_32Bit
\item Microsoft_Project_2021_Professional_64Bit
\item Microsoft_Project_2024_Professional_32Bit
\item Microsoft_Project_2024_Professional_64Bit
\item Microsoft_Office_2021_LTSC_Standard_32Bit
\item Microsoft_Office_2021_LTSC_Standard_64Bit
\item Microsoft_Office_2024_LTSC_Standard_32Bit
\item Microsoft_Office_2024_LTSC_Standard_64Bit
\item Microsoft_Visio_2021_LTSC_Standard_32Bit
\item Microsoft_Visio_2021_LTSC_Standard_64Bit
\item Microsoft_Visio_2024_LTSC_Standard_32Bit
\item Microsoft_Visio_2024_LTSC_Standard_64Bit
\item Microsoft_Project_2021_Standard_32Bit
\item Microsoft_Project_2021_Standard_64Bit
\item Microsoft_Project_2024_Standard_32Bit
\item Microsoft_Project_2024_Standard_64Bit
}}

\item{SoftwaresToUninstall}{The list of license included applications to uninstall from the image builder during creation.

Possible values include the following:
\itemize{
\item Microsoft_Office_2021_LTSC_Professional_Plus_32Bit
\item Microsoft_Office_2021_LTSC_Professional_Plus_64Bit
\item Microsoft_Office_2024_LTSC_Professional_Plus_32Bit
\item Microsoft_Office_2024_LTSC_Professional_Plus_64Bit
\item Microsoft_Visio_2021_LTSC_Professional_32Bit
\item Microsoft_Visio_2021_LTSC_Professional_64Bit
\item Microsoft_Visio_2024_LTSC_Professional_32Bit
\item Microsoft_Visio_2024_LTSC_Professional_64Bit
\item Microsoft_Project_2021_Professional_32Bit
\item Microsoft_Project_2021_Professional_64Bit
\item Microsoft_Project_2024_Professional_32Bit
\item Microsoft_Project_2024_Professional_64Bit
\item Microsoft_Office_2021_LTSC_Standard_32Bit
\item Microsoft_Office_2021_LTSC_Standard_64Bit
\item Microsoft_Office_2024_LTSC_Standard_32Bit
\item Microsoft_Office_2024_LTSC_Standard_64Bit
\item Microsoft_Visio_2021_LTSC_Standard_32Bit
\item Microsoft_Visio_2021_LTSC_Standard_64Bit
\item Microsoft_Visio_2024_LTSC_Standard_32Bit
\item Microsoft_Visio_2024_LTSC_Standard_64Bit
\item Microsoft_Project_2021_Standard_32Bit
\item Microsoft_Project_2021_Standard_64Bit
\item Microsoft_Project_2024_Standard_32Bit
\item Microsoft_Project_2024_Standard_64Bit
}}

\item{DisableIMDSV1}{Set to true to disable Instance Metadata Service Version 1 (IMDSv1) and enforce IMDSv2. Set to false to enable both IMDSv1 and IMDSv2.

Before disabling IMDSv1, ensure your WorkSpaces Applications images are running the agent version or managed image update released on or after January 16, 2024 to support IMDSv2 enforcement.}
}
\description{
Creates an image builder. An image builder is a virtual machine that is used to create an image.

See \url{https://www.paws-r-sdk.com/docs/appstream_create_image_builder/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workdocs_operations.R
\name{workdocs_get_folder}
\alias{workdocs_get_folder}
\title{Retrieves the metadata of the specified folder}
\usage{
workdocs_get_folder(
  AuthenticationToken = NULL,
  FolderId,
  IncludeCustomMetadata = NULL
)
}
\arguments{
\item{AuthenticationToken}{Amazon WorkDocs authentication token. Not required when using Amazon Web Services administrator credentials to access the API.}

\item{FolderId}{[required] The ID of the folder.}

\item{IncludeCustomMetadata}{Set to TRUE to include custom metadata in the response.}
}
\description{
Retrieves the metadata of the specified folder.

See \url{https://www.paws-r-sdk.com/docs/workdocs_get_folder/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspaces_operations.R
\name{workspaces_delete_account_link_invitation}
\alias{workspaces_delete_account_link_invitation}
\title{Deletes the account link invitation}
\usage{
workspaces_delete_account_link_invitation(LinkId, ClientToken = NULL)
}
\arguments{
\item{LinkId}{[required] The identifier of the account link.}

\item{ClientToken}{A string of up to 64 ASCII characters that Amazon WorkSpaces uses to ensure idempotent creation.}
}
\description{
Deletes the account link invitation.

See \url{https://www.paws-r-sdk.com/docs/workspaces_delete_account_link_invitation/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_list_personal_access_tokens}
\alias{workmail_list_personal_access_tokens}
\title{Returns a summary of your Personal Access Tokens}
\usage{
workmail_list_personal_access_tokens(
  OrganizationId,
  UserId = NULL,
  NextToken = NULL,
  MaxResults = NULL
)
}
\arguments{
\item{OrganizationId}{[required] The Organization ID.}

\item{UserId}{The WorkMail User ID.}

\item{NextToken}{The token from the previous response to query the next page.}

\item{MaxResults}{The maximum amount of items that should be returned in a response.}
}
\description{
Returns a summary of your Personal Access Tokens.

See \url{https://www.paws-r-sdk.com/docs/workmail_list_personal_access_tokens/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/appstream_operations.R
\name{appstream_update_entitlement}
\alias{appstream_update_entitlement}
\title{Updates the specified entitlement}
\usage{
appstream_update_entitlement(
  Name,
  StackName,
  Description = NULL,
  AppVisibility = NULL,
  Attributes = NULL
)
}
\arguments{
\item{Name}{[required] The name of the entitlement.}

\item{StackName}{[required] The name of the stack with which the entitlement is associated.}

\item{Description}{The description of the entitlement.}

\item{AppVisibility}{Specifies whether all or only selected apps are entitled.}

\item{Attributes}{The attributes of the entitlement.}
}
\description{
Updates the specified entitlement.

See \url{https://www.paws-r-sdk.com/docs/appstream_update_entitlement/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspaces_operations.R
\name{workspaces_deregister_workspace_directory}
\alias{workspaces_deregister_workspace_directory}
\title{Deregisters the specified directory}
\usage{
workspaces_deregister_workspace_directory(DirectoryId)
}
\arguments{
\item{DirectoryId}{[required] The identifier of the directory. If any WorkSpaces are registered to this directory, you must remove them before you deregister the directory, or you will receive an OperationNotSupportedException error.}
}
\description{
Deregisters the specified directory. This operation is asynchronous and returns before the WorkSpace directory is deregistered. If any WorkSpaces are registered to this directory, you must remove them before you can deregister the directory.

See \url{https://www.paws-r-sdk.com/docs/workspaces_deregister_workspace_directory/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspaces_operations.R
\name{workspaces_describe_workspace_images}
\alias{workspaces_describe_workspace_images}
\title{Retrieves a list that describes one or more specified images, if the
image identifiers are provided}
\usage{
workspaces_describe_workspace_images(
  ImageIds = NULL,
  ImageType = NULL,
  NextToken = NULL,
  MaxResults = NULL
)
}
\arguments{
\item{ImageIds}{The identifier of the image.}

\item{ImageType}{The type (owned or shared) of the image.}

\item{NextToken}{If you received a \code{NextToken} from a previous call that was paginated, provide this token to receive the next set of results.}

\item{MaxResults}{The maximum number of items to return.}
}
\description{
Retrieves a list that describes one or more specified images, if the image identifiers are provided. Otherwise, all images in the account are described.

See \url{https://www.paws-r-sdk.com/docs/workspaces_describe_workspace_images/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmailmessageflow_service.R
\name{workmailmessageflow}
\alias{workmailmessageflow}
\title{Amazon WorkMail Message Flow}
\usage{
workmailmessageflow(
  config = list(),
  credentials = list(),
  endpoint = NULL,
  region = NULL
)
}
\arguments{
\item{config}{Optional configuration of credentials, endpoint, and/or region.
\itemize{
\item{\strong{credentials}: \itemize{
\item{\strong{creds}: \itemize{
\item{\strong{access_key_id}: AWS access key ID}
\item{\strong{secret_access_key}: AWS secret access key}
\item{\strong{session_token}: AWS temporary session token}
}}
\item{\strong{profile}: The name of a profile to use. If not given, then the default profile is used.}
\item{\strong{anonymous}: Set anonymous credentials.}
}}
\item{\strong{endpoint}: The complete URL to use for the constructed client.}
\item{\strong{region}: The AWS Region used in instantiating the client.}
\item{\strong{close_connection}: Immediately close all HTTP connections.}
\item{\strong{timeout}: The time in seconds till a timeout exception is thrown when attempting to make a connection. The default is 60 seconds.}
\item{\strong{s3_force_path_style}: Set this to \code{true} to force the request to use path-style addressing, i.e. \verb{http://s3.amazonaws.com/BUCKET/KEY}.}
\item{\strong{sts_regional_endpoint}: Set sts regional endpoint resolver to regional or legacy \url{https://docs.aws.amazon.com/sdkref/latest/guide/feature-sts-regionalized-endpoints.html}}
}}

\item{credentials}{Optional credentials shorthand for the config parameter
\itemize{
\item{\strong{creds}: \itemize{
\item{\strong{access_key_id}: AWS access key ID}
\item{\strong{secret_access_key}: AWS secret access key}
\item{\strong{session_token}: AWS temporary session token}
}}
\item{\strong{profile}: The name of a profile to use. If not given, then the default profile is used.}
\item{\strong{anonymous}: Set anonymous credentials.}
}}

\item{endpoint}{Optional shorthand for complete URL to use for the constructed client.}

\item{region}{Optional shorthand for AWS Region used in instantiating the client.}
}
\value{
A client for the service. You can call the service's operations using
syntax like \code{svc$operation(...)}, where \code{svc} is the name you've assigned
to the client. The available operations are listed in the
Operations section.
}
\description{
The WorkMail Message Flow API provides access to email messages as they are being sent and received by a WorkMail organization.
}
\section{Service syntax}{


\if{html}{\out{<div class="sourceCode">}}\preformatted{svc <- workmailmessageflow(
  config = list(
    credentials = list(
      creds = list(
        access_key_id = "string",
        secret_access_key = "string",
        session_token = "string"
      ),
      profile = "string",
      anonymous = "logical"
    ),
    endpoint = "string",
    region = "string",
    close_connection = "logical",
    timeout = "numeric",
    s3_force_path_style = "logical",
    sts_regional_endpoint = "string"
  ),
  credentials = list(
    creds = list(
      access_key_id = "string",
      secret_access_key = "string",
      session_token = "string"
    ),
    profile = "string",
    anonymous = "logical"
  ),
  endpoint = "string",
  region = "string"
)
}\if{html}{\out{</div>}}
}

\section{Operations}{

\tabular{ll}{
\link[=workmailmessageflow_get_raw_message_content]{get_raw_message_content} \tab Retrieves the raw content of an in-transit email message, in MIME format\cr
\link[=workmailmessageflow_put_raw_message_content]{put_raw_message_content} \tab Updates the raw content of an in-transit email message, in MIME format
}
}

\examples{
\dontrun{
svc <- workmailmessageflow()
svc$get_raw_message_content(
  Foo = 123
)
}

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/chatbot_operations.R
\name{chatbot_describe_chime_webhook_configurations}
\alias{chatbot_describe_chime_webhook_configurations}
\title{Lists Amazon Chime webhook configurations optionally filtered by
ChatConfigurationArn}
\usage{
chatbot_describe_chime_webhook_configurations(
  MaxResults = NULL,
  NextToken = NULL,
  ChatConfigurationArn = NULL
)
}
\arguments{
\item{MaxResults}{The maximum number of results to include in the response. If more results exist than the specified MaxResults value, a token is included in the response so that the remaining results can be retrieved.}

\item{NextToken}{An optional token returned from a prior request. Use this token for pagination of results from this action. If this parameter is specified, the response includes only results beyond the token, up to the value specified by MaxResults.}

\item{ChatConfigurationArn}{An optional Amazon Resource Name (ARN) of a ChimeWebhookConfiguration to describe.}
}
\description{
Lists Amazon Chime webhook configurations optionally filtered by ChatConfigurationArn

See \url{https://www.paws-r-sdk.com/docs/chatbot_describe_chime_webhook_configurations/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workdocs_operations.R
\name{workdocs_create_folder}
\alias{workdocs_create_folder}
\title{Creates a folder with the specified name and parent folder}
\usage{
workdocs_create_folder(AuthenticationToken = NULL, Name = NULL, ParentFolderId)
}
\arguments{
\item{AuthenticationToken}{Amazon WorkDocs authentication token. Not required when using Amazon Web Services administrator credentials to access the API.}

\item{Name}{The name of the new folder.}

\item{ParentFolderId}{[required] The ID of the parent folder.}
}
\description{
Creates a folder with the specified name and parent folder.

See \url{https://www.paws-r-sdk.com/docs/workdocs_create_folder/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ivschat_operations.R
\name{ivschat_list_rooms}
\alias{ivschat_list_rooms}
\title{Gets summary information about all your rooms in the AWS region where
the API request is processed}
\usage{
ivschat_list_rooms(
  name = NULL,
  nextToken = NULL,
  maxResults = NULL,
  messageReviewHandlerUri = NULL,
  loggingConfigurationIdentifier = NULL
)
}
\arguments{
\item{name}{Filters the list to match the specified room name.}

\item{nextToken}{The first room to retrieve. This is used for pagination; see the \code{nextToken} response field.}

\item{maxResults}{Maximum number of rooms to return. Default: 50.}

\item{messageReviewHandlerUri}{Filters the list to match the specified message review handler URI.}

\item{loggingConfigurationIdentifier}{Logging-configuration identifier.}
}
\description{
Gets summary information about all your rooms in the AWS region where the API request is processed. Results are sorted in descending order of \code{updateTime}.

See \url{https://www.paws-r-sdk.com/docs/ivschat_list_rooms/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_assume_impersonation_role}
\alias{workmail_assume_impersonation_role}
\title{Assumes an impersonation role for the given WorkMail organization}
\usage{
workmail_assume_impersonation_role(OrganizationId, ImpersonationRoleId)
}
\arguments{
\item{OrganizationId}{[required] The WorkMail organization under which the impersonation role will be assumed.}

\item{ImpersonationRoleId}{[required] The impersonation role ID to assume.}
}
\description{
Assumes an impersonation role for the given WorkMail organization. This method returns an authentication token you can use to make impersonated calls.

See \url{https://www.paws-r-sdk.com/docs/workmail_assume_impersonation_role/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/chatbot_service.R
\name{chatbot}
\alias{chatbot}
\title{AWS Chatbot}
\usage{
chatbot(config = list(), credentials = list(), endpoint = NULL, region = NULL)
}
\arguments{
\item{config}{Optional configuration of credentials, endpoint, and/or region.
\itemize{
\item{\strong{credentials}: \itemize{
\item{\strong{creds}: \itemize{
\item{\strong{access_key_id}: AWS access key ID}
\item{\strong{secret_access_key}: AWS secret access key}
\item{\strong{session_token}: AWS temporary session token}
}}
\item{\strong{profile}: The name of a profile to use. If not given, then the default profile is used.}
\item{\strong{anonymous}: Set anonymous credentials.}
}}
\item{\strong{endpoint}: The complete URL to use for the constructed client.}
\item{\strong{region}: The AWS Region used in instantiating the client.}
\item{\strong{close_connection}: Immediately close all HTTP connections.}
\item{\strong{timeout}: The time in seconds till a timeout exception is thrown when attempting to make a connection. The default is 60 seconds.}
\item{\strong{s3_force_path_style}: Set this to \code{true} to force the request to use path-style addressing, i.e. \verb{http://s3.amazonaws.com/BUCKET/KEY}.}
\item{\strong{sts_regional_endpoint}: Set sts regional endpoint resolver to regional or legacy \url{https://docs.aws.amazon.com/sdkref/latest/guide/feature-sts-regionalized-endpoints.html}}
}}

\item{credentials}{Optional credentials shorthand for the config parameter
\itemize{
\item{\strong{creds}: \itemize{
\item{\strong{access_key_id}: AWS access key ID}
\item{\strong{secret_access_key}: AWS secret access key}
\item{\strong{session_token}: AWS temporary session token}
}}
\item{\strong{profile}: The name of a profile to use. If not given, then the default profile is used.}
\item{\strong{anonymous}: Set anonymous credentials.}
}}

\item{endpoint}{Optional shorthand for complete URL to use for the constructed client.}

\item{region}{Optional shorthand for AWS Region used in instantiating the client.}
}
\value{
A client for the service. You can call the service's operations using
syntax like \code{svc$operation(...)}, where \code{svc} is the name you've assigned
to the client. The available operations are listed in the
Operations section.
}
\description{
The \emph{AWS Chatbot API Reference} provides descriptions, API request parameters, and the XML response for each of the AWS Chatbot API actions.

AWS Chatbot APIs are currently available in the following Regions:
\itemize{
\item US East (Ohio) - \code{us-east-2}
\item US West (Oregon) - \code{us-west-2}
\item Asia Pacific (Singapore) - \code{ap-southeast-1}
\item Europe (Ireland) - \code{eu-west-1}
}

The AWS Chatbot console can only be used in US East (Ohio). Your configuration data however, is stored in each of the relevant available Regions.

Your AWS CloudTrail events are logged in whatever Region you call from, not US East (N. Virginia) by default.
}
\section{Service syntax}{


\if{html}{\out{<div class="sourceCode">}}\preformatted{svc <- chatbot(
  config = list(
    credentials = list(
      creds = list(
        access_key_id = "string",
        secret_access_key = "string",
        session_token = "string"
      ),
      profile = "string",
      anonymous = "logical"
    ),
    endpoint = "string",
    region = "string",
    close_connection = "logical",
    timeout = "numeric",
    s3_force_path_style = "logical",
    sts_regional_endpoint = "string"
  ),
  credentials = list(
    creds = list(
      access_key_id = "string",
      secret_access_key = "string",
      session_token = "string"
    ),
    profile = "string",
    anonymous = "logical"
  ),
  endpoint = "string",
  region = "string"
)
}\if{html}{\out{</div>}}
}

\section{Operations}{

\tabular{ll}{
\link[=chatbot_associate_to_configuration]{associate_to_configuration} \tab Links a resource (for example, a custom action) to a channel configuration\cr
\link[=chatbot_create_chime_webhook_configuration]{create_chime_webhook_configuration} \tab Creates an AWS Chatbot configuration for Amazon Chime\cr
\link[=chatbot_create_custom_action]{create_custom_action} \tab Creates a custom action that can be invoked as an alias or as a button on a notification\cr
\link[=chatbot_create_microsoft_teams_channel_configuration]{create_microsoft_teams_channel_configuration} \tab Creates an AWS Chatbot configuration for Microsoft Teams\cr
\link[=chatbot_create_slack_channel_configuration]{create_slack_channel_configuration} \tab Creates an AWS Chatbot confugration for Slack\cr
\link[=chatbot_delete_chime_webhook_configuration]{delete_chime_webhook_configuration} \tab Deletes a Amazon Chime webhook configuration for AWS Chatbot\cr
\link[=chatbot_delete_custom_action]{delete_custom_action} \tab Deletes a custom action\cr
\link[=chatbot_delete_microsoft_teams_channel_configuration]{delete_microsoft_teams_channel_configuration} \tab Deletes a Microsoft Teams channel configuration for AWS Chatbot\cr
\link[=chatbot_delete_microsoft_teams_configured_team]{delete_microsoft_teams_configured_team} \tab Deletes the Microsoft Teams team authorization allowing for channels to be configured in that Microsoft Teams team\cr
\link[=chatbot_delete_microsoft_teams_user_identity]{delete_microsoft_teams_user_identity} \tab Identifes a user level permission for a channel configuration\cr
\link[=chatbot_delete_slack_channel_configuration]{delete_slack_channel_configuration} \tab Deletes a Slack channel configuration for AWS Chatbot\cr
\link[=chatbot_delete_slack_user_identity]{delete_slack_user_identity} \tab Deletes a user level permission for a Slack channel configuration\cr
\link[=chatbot_delete_slack_workspace_authorization]{delete_slack_workspace_authorization} \tab Deletes the Slack workspace authorization that allows channels to be configured in that workspace\cr
\link[=chatbot_describe_chime_webhook_configurations]{describe_chime_webhook_configurations} \tab Lists Amazon Chime webhook configurations optionally filtered by ChatConfigurationArn\cr
\link[=chatbot_describe_slack_channel_configurations]{describe_slack_channel_configurations} \tab Lists Slack channel configurations optionally filtered by ChatConfigurationArn\cr
\link[=chatbot_describe_slack_user_identities]{describe_slack_user_identities} \tab Lists all Slack user identities with a mapped role\cr
\link[=chatbot_describe_slack_workspaces]{describe_slack_workspaces} \tab List all authorized Slack workspaces connected to the AWS Account onboarded with AWS Chatbot\cr
\link[=chatbot_disassociate_from_configuration]{disassociate_from_configuration} \tab Unlink a resource, for example a custom action, from a channel configuration\cr
\link[=chatbot_get_account_preferences]{get_account_preferences} \tab Returns AWS Chatbot account preferences\cr
\link[=chatbot_get_custom_action]{get_custom_action} \tab Returns a custom action\cr
\link[=chatbot_get_microsoft_teams_channel_configuration]{get_microsoft_teams_channel_configuration} \tab Returns a Microsoft Teams channel configuration in an AWS account\cr
\link[=chatbot_list_associations]{list_associations} \tab Lists resources associated with a channel configuration\cr
\link[=chatbot_list_custom_actions]{list_custom_actions} \tab Lists custom actions defined in this account\cr
\link[=chatbot_list_microsoft_teams_channel_configurations]{list_microsoft_teams_channel_configurations} \tab Lists all AWS Chatbot Microsoft Teams channel configurations in an AWS account\cr
\link[=chatbot_list_microsoft_teams_configured_teams]{list_microsoft_teams_configured_teams} \tab Lists all authorized Microsoft Teams for an AWS Account\cr
\link[=chatbot_list_microsoft_teams_user_identities]{list_microsoft_teams_user_identities} \tab A list all Microsoft Teams user identities with a mapped role\cr
\link[=chatbot_list_tags_for_resource]{list_tags_for_resource} \tab Lists all of the tags associated with the Amazon Resource Name (ARN) that you specify\cr
\link[=chatbot_tag_resource]{tag_resource} \tab Attaches a key-value pair to a resource, as identified by its Amazon Resource Name (ARN)\cr
\link[=chatbot_untag_resource]{untag_resource} \tab Detaches a key-value pair from a resource, as identified by its Amazon Resource Name (ARN)\cr
\link[=chatbot_update_account_preferences]{update_account_preferences} \tab Updates AWS Chatbot account preferences\cr
\link[=chatbot_update_chime_webhook_configuration]{update_chime_webhook_configuration} \tab Updates a Amazon Chime webhook configuration\cr
\link[=chatbot_update_custom_action]{update_custom_action} \tab Updates a custom action\cr
\link[=chatbot_update_microsoft_teams_channel_configuration]{update_microsoft_teams_channel_configuration} \tab Updates an Microsoft Teams channel configuration\cr
\link[=chatbot_update_slack_channel_configuration]{update_slack_channel_configuration} \tab Updates a Slack channel configuration
}
}

\examples{
\dontrun{
svc <- chatbot()
svc$associate_to_configuration(
  Foo = 123
)
}

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspaces_operations.R
\name{workspaces_describe_connection_alias_permissions}
\alias{workspaces_describe_connection_alias_permissions}
\title{Describes the permissions that the owner of a connection alias has
granted to another Amazon Web Services account for the specified
connection alias}
\usage{
workspaces_describe_connection_alias_permissions(
  AliasId,
  NextToken = NULL,
  MaxResults = NULL
)
}
\arguments{
\item{AliasId}{[required] The identifier of the connection alias.}

\item{NextToken}{If you received a \code{NextToken} from a previous call that was paginated, provide this token to receive the next set of results.}

\item{MaxResults}{The maximum number of results to return.}
}
\description{
Describes the permissions that the owner of a connection alias has granted to another Amazon Web Services account for the specified connection alias. For more information, see \href{https://docs.aws.amazon.com/workspaces/latest/adminguide/cross-region-redirection.html}{Cross-Region Redirection for Amazon WorkSpaces}.

See \url{https://www.paws-r-sdk.com/docs/workspaces_describe_connection_alias_permissions/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ivschat_operations.R
\name{ivschat_update_room}
\alias{ivschat_update_room}
\title{Updates a room’s configuration}
\usage{
ivschat_update_room(
  identifier,
  name = NULL,
  maximumMessageRatePerSecond = NULL,
  maximumMessageLength = NULL,
  messageReviewHandler = NULL,
  loggingConfigurationIdentifiers = NULL
)
}
\arguments{
\item{identifier}{[required] Identifier of the room to be updated. Currently this must be an ARN.}

\item{name}{Room name. The value does not need to be unique.}

\item{maximumMessageRatePerSecond}{Maximum number of messages per second that can be sent to the room (by all clients). Default: 10.}

\item{maximumMessageLength}{The maximum number of characters in a single message. Messages are expected to be UTF-8 encoded and this limit applies specifically to rune/code-point count, not number of bytes. Default: 500.}

\item{messageReviewHandler}{Configuration information for optional review of messages. Specify an empty \code{uri} string to disassociate a message review handler from the specified room.}

\item{loggingConfigurationIdentifiers}{Array of logging-configuration identifiers attached to the room.}
}
\description{
Updates a room’s configuration.

See \url{https://www.paws-r-sdk.com/docs/ivschat_update_room/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_describe_identity_provider_configuration}
\alias{workmail_describe_identity_provider_configuration}
\title{Returns detailed information on the current IdC setup for the WorkMail
organization}
\usage{
workmail_describe_identity_provider_configuration(OrganizationId)
}
\arguments{
\item{OrganizationId}{[required] The Organization ID.}
}
\description{
Returns detailed information on the current IdC setup for the WorkMail organization.

See \url{https://www.paws-r-sdk.com/docs/workmail_describe_identity_provider_configuration/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/appstream_operations.R
\name{appstream_describe_application_fleet_associations}
\alias{appstream_describe_application_fleet_associations}
\title{Retrieves a list that describes one or more application fleet
associations}
\usage{
appstream_describe_application_fleet_associations(
  FleetName = NULL,
  ApplicationArn = NULL,
  MaxResults = NULL,
  NextToken = NULL
)
}
\arguments{
\item{FleetName}{The name of the fleet.}

\item{ApplicationArn}{The ARN of the application.}

\item{MaxResults}{The maximum size of each page of results.}

\item{NextToken}{The pagination token used to retrieve the next page of results for this operation.}
}
\description{
Retrieves a list that describes one or more application fleet associations. Either ApplicationArn or FleetName must be specified.

See \url{https://www.paws-r-sdk.com/docs/appstream_describe_application_fleet_associations/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ivschat_operations.R
\name{ivschat_create_chat_token}
\alias{ivschat_create_chat_token}
\title{Creates an encrypted token that is used by a chat participant to
establish an individual WebSocket chat connection to a room}
\usage{
ivschat_create_chat_token(
  roomIdentifier,
  userId,
  capabilities = NULL,
  sessionDurationInMinutes = NULL,
  attributes = NULL
)
}
\arguments{
\item{roomIdentifier}{[required] Identifier of the room that the client is trying to access. Currently this must be an ARN.}

\item{userId}{[required] Application-provided ID that uniquely identifies the user associated with this token. This can be any UTF-8 encoded text.}

\item{capabilities}{Set of capabilities that the user is allowed to perform in the room. Default: None (the capability to view messages is implicitly included in all requests).}

\item{sessionDurationInMinutes}{Session duration (in minutes), after which the session expires. Default: 60 (1 hour).}

\item{attributes}{Application-provided attributes to encode into the token and attach to a chat session. Map keys and values can contain UTF-8 encoded text. The maximum length of this field is 1 KB total.}
}
\description{
Creates an encrypted token that is used by a chat participant to establish an individual WebSocket chat connection to a room. When the token is used to connect to chat, the connection is valid for the session duration specified in the request. The token becomes invalid at the token-expiration timestamp included in the response.

See \url{https://www.paws-r-sdk.com/docs/ivschat_create_chat_token/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspaces_operations.R
\name{workspaces_update_rules_of_ip_group}
\alias{workspaces_update_rules_of_ip_group}
\title{Replaces the current rules of the specified IP access control group with
the specified rules}
\usage{
workspaces_update_rules_of_ip_group(GroupId, UserRules)
}
\arguments{
\item{GroupId}{[required] The identifier of the group.}

\item{UserRules}{[required] One or more rules.}
}
\description{
Replaces the current rules of the specified IP access control group with the specified rules.

See \url{https://www.paws-r-sdk.com/docs/workspaces_update_rules_of_ip_group/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspaces_operations.R
\name{workspaces_create_workspace_image}
\alias{workspaces_create_workspace_image}
\title{Creates a new WorkSpace image from an existing WorkSpace}
\usage{
workspaces_create_workspace_image(Name, Description, WorkspaceId, Tags = NULL)
}
\arguments{
\item{Name}{[required] The name of the new WorkSpace image.}

\item{Description}{[required] The description of the new WorkSpace image.}

\item{WorkspaceId}{[required] The identifier of the source WorkSpace}

\item{Tags}{The tags that you want to add to the new WorkSpace image. To add tags when you're creating the image, you must create an IAM policy that grants your IAM user permission to use \code{workspaces:CreateTags}.}
}
\description{
Creates a new WorkSpace image from an existing WorkSpace.

See \url{https://www.paws-r-sdk.com/docs/workspaces_create_workspace_image/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_list_mailbox_export_jobs}
\alias{workmail_list_mailbox_export_jobs}
\title{Lists the mailbox export jobs started for the specified organization
within the last seven days}
\usage{
workmail_list_mailbox_export_jobs(
  OrganizationId,
  NextToken = NULL,
  MaxResults = NULL
)
}
\arguments{
\item{OrganizationId}{[required] The organization ID.}

\item{NextToken}{The token to use to retrieve the next page of results.}

\item{MaxResults}{The maximum number of results to return in a single call.}
}
\description{
Lists the mailbox export jobs started for the specified organization within the last seven days.

See \url{https://www.paws-r-sdk.com/docs/workmail_list_mailbox_export_jobs/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/chatbot_operations.R
\name{chatbot_delete_custom_action}
\alias{chatbot_delete_custom_action}
\title{Deletes a custom action}
\usage{
chatbot_delete_custom_action(CustomActionArn)
}
\arguments{
\item{CustomActionArn}{[required] The fully defined ARN of the custom action.}
}
\description{
Deletes a custom action.

See \url{https://www.paws-r-sdk.com/docs/chatbot_delete_custom_action/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspaces_operations.R
\name{workspaces_describe_custom_workspace_image_import}
\alias{workspaces_describe_custom_workspace_image_import}
\title{Retrieves information about a WorkSpace BYOL image being imported via
ImportCustomWorkspaceImage}
\usage{
workspaces_describe_custom_workspace_image_import(ImageId)
}
\arguments{
\item{ImageId}{[required] The identifier of the WorkSpace image.}
}
\description{
Retrieves information about a WorkSpace BYOL image being imported via ImportCustomWorkspaceImage.

See \url{https://www.paws-r-sdk.com/docs/workspaces_describe_custom_workspace_image_import/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/chatbot_operations.R
\name{chatbot_create_microsoft_teams_channel_configuration}
\alias{chatbot_create_microsoft_teams_channel_configuration}
\title{Creates an AWS Chatbot configuration for Microsoft Teams}
\usage{
chatbot_create_microsoft_teams_channel_configuration(
  ChannelId,
  ChannelName = NULL,
  TeamId,
  TeamName = NULL,
  TenantId,
  SnsTopicArns = NULL,
  IamRoleArn,
  ConfigurationName,
  LoggingLevel = NULL,
  GuardrailPolicyArns = NULL,
  UserAuthorizationRequired = NULL,
  Tags = NULL
)
}
\arguments{
\item{ChannelId}{[required] The ID of the Microsoft Teams channel.}

\item{ChannelName}{The name of the Microsoft Teams channel.}

\item{TeamId}{[required] The ID of the Microsoft Teams authorized with AWS Chatbot.

To get the team ID, you must perform the initial authorization flow with Microsoft Teams in the AWS Chatbot console. Then you can copy and paste the team ID from the console. For more information, see \href{https://docs.aws.amazon.com/chatbot/latest/adminguide/teams-setup.html#teams-client-setup}{Step 1: Configure a Microsoft Teams client} in the \emph{AWS Chatbot Administrator Guide}.}

\item{TeamName}{The name of the Microsoft Teams Team.}

\item{TenantId}{[required] The ID of the Microsoft Teams tenant.}

\item{SnsTopicArns}{The Amazon Resource Names (ARNs) of the SNS topics that deliver notifications to AWS Chatbot.}

\item{IamRoleArn}{[required] A user-defined role that AWS Chatbot assumes. This is not the service-linked role.

For more information, see \href{https://docs.aws.amazon.com/chatbot/latest/adminguide/chatbot-iam-policies.html}{IAM policies for AWS Chatbot} in the \emph{AWS Chatbot Administrator Guide}.}

\item{ConfigurationName}{[required] The name of the configuration.}

\item{LoggingLevel}{Logging levels include \code{ERROR}, \code{INFO}, or \code{NONE}.}

\item{GuardrailPolicyArns}{The list of IAM policy ARNs that are applied as channel guardrails. The AWS managed \code{AdministratorAccess} policy is applied by default if this is not set.}

\item{UserAuthorizationRequired}{Enables use of a user role requirement in your chat configuration.}

\item{Tags}{A map of tags assigned to a resource. A tag is a string-to-string map of key-value pairs.}
}
\description{
Creates an AWS Chatbot configuration for Microsoft Teams.

See \url{https://www.paws-r-sdk.com/docs/chatbot_create_microsoft_teams_channel_configuration/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspaces_operations.R
\name{workspaces_authorize_ip_rules}
\alias{workspaces_authorize_ip_rules}
\title{Adds one or more rules to the specified IP access control group}
\usage{
workspaces_authorize_ip_rules(GroupId, UserRules)
}
\arguments{
\item{GroupId}{[required] The identifier of the group.}

\item{UserRules}{[required] The rules to add to the group.}
}
\description{
Adds one or more rules to the specified IP access control group.

See \url{https://www.paws-r-sdk.com/docs/workspaces_authorize_ip_rules/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspacesweb_operations.R
\name{workspacesweb_get_ip_access_settings}
\alias{workspacesweb_get_ip_access_settings}
\title{Gets the IP access settings}
\usage{
workspacesweb_get_ip_access_settings(ipAccessSettingsArn)
}
\arguments{
\item{ipAccessSettingsArn}{[required] The ARN of the IP access settings.}
}
\description{
Gets the IP access settings.

See \url{https://www.paws-r-sdk.com/docs/workspacesweb_get_ip_access_settings/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_describe_organization}
\alias{workmail_describe_organization}
\title{Provides more information regarding a given organization based on its
identifier}
\usage{
workmail_describe_organization(OrganizationId)
}
\arguments{
\item{OrganizationId}{[required] The identifier for the organization to be described.}
}
\description{
Provides more information regarding a given organization based on its identifier.

See \url{https://www.paws-r-sdk.com/docs/workmail_describe_organization/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workdocs_operations.R
\name{workdocs_initiate_document_version_upload}
\alias{workdocs_initiate_document_version_upload}
\title{Creates a new document object and version object}
\usage{
workdocs_initiate_document_version_upload(
  AuthenticationToken = NULL,
  Id = NULL,
  Name = NULL,
  ContentCreatedTimestamp = NULL,
  ContentModifiedTimestamp = NULL,
  ContentType = NULL,
  DocumentSizeInBytes = NULL,
  ParentFolderId = NULL
)
}
\arguments{
\item{AuthenticationToken}{Amazon WorkDocs authentication token. Not required when using Amazon Web Services administrator credentials to access the API.}

\item{Id}{The ID of the document.}

\item{Name}{The name of the document.}

\item{ContentCreatedTimestamp}{The timestamp when the content of the document was originally created.}

\item{ContentModifiedTimestamp}{The timestamp when the content of the document was modified.}

\item{ContentType}{The content type of the document.}

\item{DocumentSizeInBytes}{The size of the document, in bytes.}

\item{ParentFolderId}{The ID of the parent folder.}
}
\description{
Creates a new document object and version object.

See \url{https://www.paws-r-sdk.com/docs/workdocs_initiate_document_version_upload/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ivschat_operations.R
\name{ivschat_get_room}
\alias{ivschat_get_room}
\title{Gets the specified room}
\usage{
ivschat_get_room(identifier)
}
\arguments{
\item{identifier}{[required] Identifier of the room for which the configuration is to be retrieved. Currently this must be an ARN.}
}
\description{
Gets the specified room.

See \url{https://www.paws-r-sdk.com/docs/ivschat_get_room/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspaces_operations.R
\name{workspaces_describe_tags}
\alias{workspaces_describe_tags}
\title{Describes the specified tags for the specified WorkSpaces resource}
\usage{
workspaces_describe_tags(ResourceId)
}
\arguments{
\item{ResourceId}{[required] The identifier of the WorkSpaces resource. The supported resource types are WorkSpaces, registered directories, images, custom bundles, IP access control groups, and connection aliases.}
}
\description{
Describes the specified tags for the specified WorkSpaces resource.

See \url{https://www.paws-r-sdk.com/docs/workspaces_describe_tags/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/appstream_operations.R
\name{appstream_create_export_image_task}
\alias{appstream_create_export_image_task}
\title{Creates a task to export a WorkSpaces Applications image to an EC2 AMI}
\usage{
appstream_create_export_image_task(
  ImageName,
  AmiName,
  IamRoleArn,
  TagSpecifications = NULL,
  AmiDescription = NULL
)
}
\arguments{
\item{ImageName}{[required] The name of the WorkSpaces Applications image to export. The image must be in an available state and owned by your account.}

\item{AmiName}{[required] The name for the exported EC2 AMI. This is a required field that must be unique within your account and region.}

\item{IamRoleArn}{[required] The ARN of the IAM role that allows WorkSpaces Applications to create the AMI. The role must have permissions to copy images, describe images, and create tags, with a trust relationship allowing appstream.amazonaws.com to assume the role.}

\item{TagSpecifications}{The tags to apply to the exported AMI. These tags help you organize and manage your EC2 AMIs.}

\item{AmiDescription}{An optional description for the exported AMI. This description will be applied to the resulting EC2 AMI.}
}
\description{
Creates a task to export a WorkSpaces Applications image to an EC2 AMI. This allows you to use your customized WorkSpaces Applications images with other AWS services or for backup purposes.

See \url{https://www.paws-r-sdk.com/docs/appstream_create_export_image_task/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_list_resource_delegates}
\alias{workmail_list_resource_delegates}
\title{Lists the delegates associated with a resource}
\usage{
workmail_list_resource_delegates(
  OrganizationId,
  ResourceId,
  NextToken = NULL,
  MaxResults = NULL
)
}
\arguments{
\item{OrganizationId}{[required] The identifier for the organization that contains the resource for which delegates are listed.}

\item{ResourceId}{[required] The identifier for the resource whose delegates are listed.

The identifier can accept \emph{ResourceId}, \emph{Resourcename}, or \emph{email}. The following identity formats are available:
\itemize{
\item Resource ID: r-0123456789a0123456789b0123456789
\item Email address: resource@domain.tld
\item Resource name: resource
}}

\item{NextToken}{The token used to paginate through the delegates associated with a resource.}

\item{MaxResults}{The number of maximum results in a page.}
}
\description{
Lists the delegates associated with a resource. Users and groups can be resource delegates and answer requests on behalf of the resource.

See \url{https://www.paws-r-sdk.com/docs/workmail_list_resource_delegates/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspacesweb_operations.R
\name{workspacesweb_list_tags_for_resource}
\alias{workspacesweb_list_tags_for_resource}
\title{Retrieves a list of tags for a resource}
\usage{
workspacesweb_list_tags_for_resource(resourceArn)
}
\arguments{
\item{resourceArn}{[required] The ARN of the resource.}
}
\description{
Retrieves a list of tags for a resource.

See \url{https://www.paws-r-sdk.com/docs/workspacesweb_list_tags_for_resource/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/chatbot_operations.R
\name{chatbot_untag_resource}
\alias{chatbot_untag_resource}
\title{Detaches a key-value pair from a resource, as identified by its Amazon
Resource Name (ARN)}
\usage{
chatbot_untag_resource(ResourceARN, TagKeys)
}
\arguments{
\item{ResourceARN}{[required] The value of the resource that will have the tag removed. An Amazon Resource Name (ARN) is an identifier for a specific AWS resource, such as a server, user, or role.}

\item{TagKeys}{[required] TagKeys are key-value pairs assigned to ARNs that can be used to group and search for resources by type. This metadata can be attached to resources for any purpose.}
}
\description{
Detaches a key-value pair from a resource, as identified by its Amazon Resource Name (ARN). Resources are users, servers, roles, and other entities.

See \url{https://www.paws-r-sdk.com/docs/chatbot_untag_resource/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_describe_mailbox_export_job}
\alias{workmail_describe_mailbox_export_job}
\title{Describes the current status of a mailbox export job}
\usage{
workmail_describe_mailbox_export_job(JobId, OrganizationId)
}
\arguments{
\item{JobId}{[required] The mailbox export job ID.}

\item{OrganizationId}{[required] The organization ID.}
}
\description{
Describes the current status of a mailbox export job.

See \url{https://www.paws-r-sdk.com/docs/workmail_describe_mailbox_export_job/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workmail_operations.R
\name{workmail_list_mailbox_permissions}
\alias{workmail_list_mailbox_permissions}
\title{Lists the mailbox permissions associated with a user, group, or resource
mailbox}
\usage{
workmail_list_mailbox_permissions(
  OrganizationId,
  EntityId,
  NextToken = NULL,
  MaxResults = NULL
)
}
\arguments{
\item{OrganizationId}{[required] The identifier of the organization under which the user, group, or resource exists.}

\item{EntityId}{[required] The identifier of the user, or resource for which to list mailbox permissions.

The entity ID can accept \emph{UserId or ResourceId}, \emph{Username or Resourcename}, or \emph{email}.
\itemize{
\item Entity ID: 12345678-1234-1234-1234-123456789012, or r-0123456789a0123456789b0123456789
\item Email address: entity@domain.tld
\item Entity name: entity
}}

\item{NextToken}{The token to use to retrieve the next page of results. The first call does not contain any tokens.}

\item{MaxResults}{The maximum number of results to return in a single call.}
}
\description{
Lists the mailbox permissions associated with a user, group, or resource mailbox.

See \url{https://www.paws-r-sdk.com/docs/workmail_list_mailbox_permissions/} for full documentation.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/workspaces_operations.R
\name{workspaces_update_workspace_bundle}
\alias{workspaces_update_workspace_bundle}
\title{Updates a WorkSpace bundle with a new image}
\usage{
workspaces_update_workspace_bundle(BundleId = NULL, ImageId = NULL)
}
\arguments{
\item{BundleId}{The identifier of the bundle.}

\item{ImageId}{The identifier of the image.}
}
\description{
Updates a WorkSpace bundle with a new image. For more information about updating WorkSpace bundles, see \href{https://docs.aws.amazon.com/workspaces/latest/adminguide/update-custom-bundle.html}{Update a Custom WorkSpaces Bundle}.

See \url{https://www.paws-r-sdk.com/docs/workspaces_update_workspace_bundle/} for full documentation.
}
\keyword{internal}
